Attribute VB_Name = "GridFunctions"
' GridFunctions:
' Jenness Enterprises
' http://www.jennessent.com
' jeffj@jennessent.com
'--------------------------------------
' AddFieldToVAT - GIVEN A RASTER, FIELDNAME, FIELD TYPE AND FIELD LENGTH, ADDS THE FIELD TO THE VAT.  IF NOT POSSIBLE
'                 (MAYBE USING FLOATING POINT GRID) THEN RETURNS NOTHING. OTHERWISE RETURNS TABLE.
' CalcGridLine - GIVEN pStartPolygon, pEndPolygon, pCorPolygon (FOR BOUNDARY REGION),
'                  pCorRaster As IRaster (FOR COST-DISTANCE), pEnv (IRasterAnalysisEnvironment),
'                  AND OPTIONAL ShouldClean, RETURNS AN IPolyline REPRESENTING LINE FROM START POLYGON TO END POLYGON
' CellValue - GIVEN A POINT AND RASTER, RETURNS CELL VALUE AS VARIANT.  MIGHT NEED TO MODIFY LATER FOR VERY LARGE GRIDS!
' CellValues - GIVEN A POINT COLLECTION AND RASTER, RETURNS CELL VALUES AS VARIANT ARRAY.  MIGHT NEED TO MODIFY LATER FOR VERY LARGE GRIDS!
' ClipRasterToPolygon - GIVEN pRaster As IRaster, pPolygon As IPolygon, SaveInside As Boolean,
'                  OPTIONAL pClipEnvelope, OPTIONAL CellSize, OPTIONAL pEnv (IRasterAnalysisEnvironment), RETURNS IRaster
' CompareSpatialReferences - GIVEN TWO SPATIAL REFERENCES, RETURNS BOOLEAN
' DistributePointsAlongShape - GIVEN ICurve AND SEPARATION DISTANCE, RETURNS A MULTIPOINT OF POINTS ALONG THAT SHAPE
' EllipticArcToPolygon - GIVEN AN ISegmentCollection AND NumVertices, RETURNS Polygon4 BASED ON CONVEX HULL AROUND VERTICES
' EllipticArcToPolygon2 - GIVEN AN ISegmentCollection AND NumVertices, RETURNS IMultipoint
' OpenRasterWorkspace - GIVEN sPath, RETURNS A RASTER WORKSPACE
' ReturnCellCount - GIVEN A RASTER, RETURNS COUNT OF NON-NULL CELLS
' ReturnCellSize - GIVEN A RASTER, RETURNS CELL SIZE BASED ON Y-DIMENSION
' ReturnPixelHeight - GIVEN A RASTER, RETURNS PIXEL HEIGHT (Y-DIMENSION)
' ReturnPixelWidth - GIVEN A RASTER, RETURNS PIXEL WIDTH (X-DIMENSION)
' ReturnPointsByCellSize - GIVEN A RASTER AND LINE, RETURNS IPointCollection WITH POINTS DISTRIBUTED APPROXIMATELY EQUAL TO
'                  CELL SIZE
' SetSpatialAnalysisSettings - GIVEN TargetEnv AND SourceEnv, ASSIGNS PROPERTIES OF SourceEnv TO TargetEnv
' SaveRasterAs -  GIVEN A RASTER BAND COLLECTION, FOLDER PATH, RASTER FILENAME, AND RASTER TYPE, SAVES RASTER AS PERMANENT FILE

Public Enum enumRasterType
   enum_Grid_Type
   enum_Imagine_Type
   enum_TIFF_Type
   enum_JPEG_Type
   enum_JP2000_Type
   enum_BMP_Type
   enum_PNG_Type
   enum_GIF_Type
   enum_PCI_Raster_Type
   enum_X11_Pixmap_Type
   enum_PCRaster_Type
   enum_Memory_Raster_Type
   enum_HDF4_Type
   enum_BIL_Type
   enum_BIP_Type
   enum_BSQ_Type
   enum_IDRISI_Type
   enum_Geodatabase_Type
End Enum

Option Explicit
Const c_sModuleFileName As String = "D:\arcGIS_stuff\general_tools\Registration\GridFunctions.bas"


Public Function OpenRasterWorkspace(sPath As String) As IRasterWorkspace
  On Error GoTo ErrorHandler

  Dim pWKSF As IWorkspaceFactory
58:   Set pWKSF = New RasterWorkspaceFactory

  Dim pRasterWs As IRasterWorkspace
61:   Set pRasterWs = pWKSF.OpenFromFile(sPath, 0)
62:   Set OpenRasterWorkspace = pRasterWs

  Exit Function
ErrorHandler:
  HandleError True, "OpenRasterWorkspace " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function
Public Sub SaveRasterAs(pRasterBandCol As IRasterBandCollection, strPath As String, strName As String, aRasterType As enumRasterType)
  On Error GoTo ErrorHandler
'  MsgBox "GridFunctions - Before: " & strPath
'  strPath = TopoCorridor.aml_func_mod.BasicTrimAvenue(strPath, "", "/\")
'  MsgBox "GridFunctions - After: " & strPath
  
  Dim pSaveAs As IRasterBandCollection
75:   Set pSaveAs = pRasterBandCol
  Dim pRasterWs As IRasterWorkspace
77:   Set pRasterWs = OpenRasterWorkspace(strPath)
78:   If aRasterType = enum_Grid_Type Then
79:     pSaveAs.SaveAs strName, pRasterWs, "GRID"
80:   ElseIf aRasterType = enum_Imagine_Type Then
81:     pSaveAs.SaveAs strName, pRasterWs, "IMAGINE Image"
82:   ElseIf aRasterType = enum_TIFF_Type Then
83:     pSaveAs.SaveAs strName, pRasterWs, "TIFF"
84:   ElseIf aRasterType = enum_JPEG_Type Then
85:     pSaveAs.SaveAs strName, pRasterWs, "JPG"
86:   ElseIf aRasterType = enum_JP2000_Type Then
87:     pSaveAs.SaveAs strName, pRasterWs, "JP2"
88:   ElseIf aRasterType = enum_BMP_Type Then
89:     pSaveAs.SaveAs strName, pRasterWs, "BMP"
90:   ElseIf aRasterType = enum_PNG_Type Then
91:     pSaveAs.SaveAs strName, pRasterWs, "PNG"
92:   ElseIf aRasterType = enum_GIF_Type Then
93:     pSaveAs.SaveAs strName, pRasterWs, "GIF"
94:   ElseIf aRasterType = enum_PCI_Raster_Type Then
95:     pSaveAs.SaveAs strName, pRasterWs, "PIX"
96:   ElseIf aRasterType = enum_X11_Pixmap_Type Then
97:     pSaveAs.SaveAs strName, pRasterWs, "XPM"
98:   ElseIf aRasterType = enum_PCRaster_Type Then
99:     pSaveAs.SaveAs strName, pRasterWs, "MAP"
100:   ElseIf aRasterType = enum_Memory_Raster_Type Then
101:     pSaveAs.SaveAs strName, pRasterWs, "MEM"
102:   ElseIf aRasterType = enum_HDF4_Type Then
103:     pSaveAs.SaveAs strName, pRasterWs, "HDF4"
104:   ElseIf aRasterType = enum_BIL_Type Then
105:     pSaveAs.SaveAs strName, pRasterWs, "BIL"
106:   ElseIf aRasterType = enum_BIP_Type Then
107:     pSaveAs.SaveAs strName, pRasterWs, "BIP"
108:   ElseIf aRasterType = enum_BSQ_Type Then
109:     pSaveAs.SaveAs strName, pRasterWs, "BSQ"
110:   ElseIf aRasterType = enum_IDRISI_Type Then
111:     pSaveAs.SaveAs strName, pRasterWs, "GDB"
112:   ElseIf aRasterType = enum_Geodatabase_Type Then
113:     pSaveAs.SaveAs strName, pRasterWs, "GDB"
114:   End If
  

  Exit Sub
ErrorHandler:
  HandleError True, "SaveRasterAs " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
Public Function ReturnCellSize(pRaster As IRaster) As Double
  On Error GoTo erh
  Dim pRasLayer As IRasterLayer
124:   Set pRasLayer = New RasterLayer
125:   pRasLayer.CreateFromRaster pRaster
  
  Dim pRasterProps As IRasterProps
128:   Set pRasterProps = pRaster
  
  Dim lngNumRows As Long
131:   lngNumRows = pRasLayer.RowCount
  
  Dim pEnvelope As IEnvelope
134:   Set pEnvelope = pRasterProps.Extent
  
136:   ReturnCellSize = pEnvelope.Height / lngNumRows
   
'  Debug.Print "By Rows = " & ReturnCellSize & ",   By Columns = " & pEnvelope.Width / pRasLayer.ColumnCount
  
  Exit Function
erh:
142:     MsgBox "Failed in ReturnCellSize: " & err.Description

End Function
Public Function ReturnPixelHeight(pRaster As IRaster) As Double
  On Error GoTo erh
  Dim pRasLayer As IRasterLayer
148:   Set pRasLayer = New RasterLayer
149:   pRasLayer.CreateFromRaster pRaster
  
  Dim pRasterProps As IRasterProps
152:   Set pRasterProps = pRaster
  
  Dim lngNumRows As Long
155:   lngNumRows = pRasLayer.RowCount
  
  Dim pEnvelope As IEnvelope
158:   Set pEnvelope = pRasterProps.Extent
  
160:   ReturnPixelHeight = pEnvelope.Height / lngNumRows
   
'  Debug.Print "By Rows = " & ReturnCellSize & ",   By Columns = " & pEnvelope.Width / pRasLayer.ColumnCount
  
  Exit Function
erh:
  HandleError True, "ReturnPixelHeight " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4


End Function

Public Function ReturnCellCount(pRaster As IRaster) As Long
  On Error GoTo ErrorHandler

  




  Exit Function
ErrorHandler:
  HandleError True, "ReturnCellCount " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function CalcContinuousGridStats(pRaster As IRaster, pRasterStats As IRasterStatistics, _
      lngNumBins As Long) As esriSystem.IVariantArray
  On Error GoTo ErrorHandler

  
  Dim pRasterAnalysisProps As IRasterAnalysisProps
  Dim pRasterProps As IRasterProps
191:   Set pRasterAnalysisProps = pRaster
192:   Set pRasterProps = pRaster
  
  Dim dblMaximum As Double
  Dim dblMinimum As Double
  Dim dblMean As Double
  Dim dblMedian As Double
  Dim dblMode As Double
  Dim dblStDev As Double
  
  




  Exit Function
ErrorHandler:
  HandleError True, "CalcContinuousGridStats " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function ReturnPixelWidth(pRaster As IRaster) As Double
  On Error GoTo erh
  Dim pRasLayer As IRasterLayer
214:   Set pRasLayer = New RasterLayer
215:   pRasLayer.CreateFromRaster pRaster
  
  Dim pRasterProps As IRasterProps
218:   Set pRasterProps = pRaster
  
  Dim lngNumCols As Long
221:   lngNumCols = pRasLayer.ColumnCount
  
  Dim pEnvelope As IEnvelope
224:   Set pEnvelope = pRasterProps.Extent
  
226:   ReturnPixelWidth = pEnvelope.Width / lngNumCols
   
'  Debug.Print "By Rows = " & ReturnCellSize & ",   By Columns = " & pEnvelope.Width / pRasLayer.ColumnCount
  
  Exit Function
erh:
  HandleError True, "ReturnPixelWidth " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4

End Function

Public Function ReturnPointsByCellSize(pRaster As IRaster, ByVal pLine As IGeometry) As IPointCollection
  On Error GoTo erh
  
  Dim pCurve As ICurve
  Dim dblLength As Double
  
242:   If TypeOf pLine Is ICurve Then
243:     Set pCurve = pLine
244:     dblLength = pCurve.length
245:   Else
246:     MsgBox "Invalid geometry type!  Must implement 'ICurve'..."
247:     Set ReturnPointsByCellSize = Nothing
    Exit Function
249:   End If
  Dim pPointCollection As IPointCollection
  
  ' CHECK SPATIAL REFERENCES; MIGHT NEED TO PROJECT POLYLINE
  Dim pSrcSpRef As ISpatialReference
  Dim pRasProps As IRasterProps
255:   Set pRasProps = pRaster
256:   Set pSrcSpRef = pRasProps.SpatialReference
  
  Dim pTrgSpRef As ISpatialReference
259:   Set pTrgSpRef = pLine.SpatialReference
  
261:   If Not GridFunctions.CompareSpatialReferences(pSrcSpRef, pTrgSpRef) Then
262:     pLine.Project pSrcSpRef
263:   End If
  
  ' GET GRID CELL SIZE
  Dim dblCellSize As Double
267:   dblCellSize = GridFunctions.ReturnCellSize(pRaster)
  Dim NumPoints As Long
269:   NumPoints = Int(dblLength / dblCellSize) + 1
  
  Dim pMpt As IMultipoint
  Dim pSegCol As ISegmentCollection
273:   Set pSegCol = pLine
274:   Set pMpt = GridFunctions.EllipticArcToPolygon2(pSegCol, NumPoints)
275:   Set pPointCollection = pMpt
  
277:   Set ReturnPointsByCellSize = pPointCollection
    
  Exit Function
erh:
281:   If (Erl <> 0) Then
282:     MsgBox "Failed in ReturnPointsByCellSize: " & err.Description & vbCrLf & "Error at line " & CStr(Erl)
283:   Else
284:     MsgBox "Failed in ReturnPointsByCellSize: " & err.Description & vbCrLf & "No Line Number Available..."
285:   End If

End Function
Public Function CompareSpatialReferences(ByVal pSourceSR As ISpatialReference, ByVal pTargetSR As ISpatialReference) As Boolean
  
  On Error GoTo erh
  
292:   If pSourceSR Is Nothing And pTargetSR Is Nothing Then
293:     CompareSpatialReferences = True
    Exit Function
295:   ElseIf pSourceSR Is Nothing Or pTargetSR Is Nothing Then
296:     CompareSpatialReferences = False
    Exit Function
298:   End If
  
  Dim pSourceClone As IClone
  Dim pTargetClone As IClone
  Dim bSREqual As Boolean
  
304:   Set pSourceClone = pSourceSR
305:   Set pTargetClone = pTargetSR
  
  'Compare the coordinate system component of the spatial reference
308:   bSREqual = pSourceClone.IsEqual(pTargetClone)
  
  'If the comparison failed, return false and exit
311:   If Not bSREqual Then
312:     CompareSpatialReferences = False
    Exit Function
314:   End If
  
  'We can also compare the XY precision to ensure the spatial references are equal
  Dim pSourceSR2 As ISpatialReference2
  Dim bXYIsEqual As Boolean
  
320:   Set pSourceSR2 = pSourceSR
321:   bXYIsEqual = pSourceSR2.IsXYPrecisionEqual(pTargetSR)
  
  'If the comparison failed, return false and exit
324:   If Not bXYIsEqual Then
325:     CompareSpatialReferences = False
    Exit Function
327:   End If
  
329:   CompareSpatialReferences = True
  Exit Function
erh:
332:     MsgBox "Failed in CompareSpatialReferences: " & err.Description
End Function
Sub SetSpatialAnalysisSettings(TargetEnv As IRasterAnalysisEnvironment, _
                               SourceEnv As IRasterAnalysisEnvironment)
    On Error GoTo erh
337:     If Not SourceEnv Is Nothing Then
338:         Set TargetEnv.OutWorkspace = SourceEnv.OutWorkspace
339:         If Not SourceEnv.OutSpatialReference Is Nothing Then
340:             Set TargetEnv.OutSpatialReference = SourceEnv.OutSpatialReference
341:         End If
342:         TargetEnv.DefaultOutputRasterPrefix = SourceEnv.DefaultOutputRasterPrefix
343:         TargetEnv.DefaultOutputVectorPrefix = SourceEnv.DefaultOutputVectorPrefix
344:         If Not SourceEnv.Mask Is Nothing Then
345:             Set TargetEnv.Mask = SourceEnv.Mask
346:         End If
        Dim nCellSize As Double
348:         SourceEnv.GetCellSize 3, nCellSize
349:         If nCellSize <> 0 Then
350:             TargetEnv.SetCellSize 3, nCellSize
351:         End If
        Dim pExtent As IEnvelope
353:         SourceEnv.GetExtent 3, pExtent
354:         If Not pExtent Is Nothing Then
355:             TargetEnv.SetExtent 3, pExtent
356:         End If
357:         TargetEnv.VerifyType = SourceEnv.VerifyType
358:     End If
    Exit Sub
erh:
361:     MsgBox "Failed in SetSpatialAnalysisSettings: " & err.Description
End Sub

Public Function ClipRasterToPolygon(pRaster As IRaster, ByVal pPolygon As IPolygon, SaveInside As Boolean, _
      Optional ByVal pClipEnvelope As IEnvelope, Optional CellSize As Double, _
      Optional ByVal pEnv As IRasterAnalysisEnvironment, Optional booShowProgress As Boolean, _
      Optional pApp As IApplication) As IRaster
      
  On Error GoTo ErrorHandler

  
'  If pPolygon.IsEmpty Then
'    Dim xx As Long
'    xx = 1
'  End If
  
    ' PROGRESS BAR STUFF
378:   If booShowProgress Then
    Dim psbar As IStatusBar
380:     Set psbar = pApp.StatusBar
381:     psbar.ProgressBar.position = 1
    Dim pPro As IStepProgressor
383:     Set pPro = psbar.ProgressBar
384:   End If
  
'  MsgBox "Hello 1"
  
  ' FORCE OBJECT TO BE POLYGON IF THE FIRST SEGMENT IS A CURVE
  Dim booWorkingWithCurves As Boolean
  Dim pSegmentCollectionCurves As ISegmentCollection
'  Dim pSegTopoOp As ITopologicalOperator
'  Set pSegTopoOp = pPolygon
'  Dim pCheckSegLine As IPolyline
'  Set pCheckSegLine = pSegTopoOp.Boundary
395:   Set pSegmentCollectionCurves = pPolygon
  Dim pSegmentCurve As ISegment
397:   Set pSegmentCurve = pSegmentCollectionCurves.Segment(0)
  Dim pGeometryTypeA As esriGeometryType
399:   pGeometryTypeA = pSegmentCurve.GeometryType
  
401:   booWorkingWithCurves = (pGeometryTypeA = esriGeometryBezier3Curve) Or _
    (pGeometryTypeA = esriGeometryCircularArc) Or _
    (pGeometryTypeA = esriGeometryEllipticArc)
  
405:   If booWorkingWithCurves Then
    Dim pNewPoints As IPointCollection
407:     Set pNewPoints = GridFunctions.EllipticArcToPolygon2(pSegmentCollectionCurves, 100)
    Dim pNewPolygon As IPointCollection
409:     Set pNewPolygon = New Polygon
410:     pNewPolygon.SetPointCollection pNewPoints
411:     Set pPolygon = pNewPolygon
412:   End If
    
  
'  MsgBox "Hello 2"
  
'  Dim pMxDoc As IMxDocument
'  Set pMxDoc = ThisDocument
  
  ' MAKE EXTRACTION OPERATOR
  Dim pExtractionOp As IExtractionOp
422:   Set pExtractionOp = New RasterExtractionOp
  
  Dim pRastAnalysisEnv As IRasterAnalysisEnvironment
  Dim pSpatialReference As ISpatialReference
  Dim pPolySpatRef As ISpatialReference
427:   Set pPolySpatRef = pPolygon.SpatialReference
  Dim SpatRefSame As Boolean
  Dim pEnvelope As IEnvelope
  
431:   If Not pEnv Is Nothing Then
432:     Set pRastAnalysisEnv = pEnv
433:     Set pSpatialReference = pRastAnalysisEnv.OutSpatialReference
    
    ' CHECK SPATIAL REFERENCE OF INCOMING POLYGON
436:     SpatRefSame = CompareSpatialReferences(pSpatialReference, pPolySpatRef)
437:     If Not SpatRefSame Then pPolygon.Project pSpatialReference
438:     pEnv.GetExtent esriRasterEnvValue, pEnvelope
    
440:   Else
    
    ' MAKE ANALYSIS ENVIRONMENT
443:     Set pRastAnalysisEnv = pExtractionOp
444:     pRastAnalysisEnv.RestoreToPreviousDefaultEnvironment
    
    ' ASSIGN CURRENT ANALYSIS ENVIRONMENT SETTINGS
    Dim theEnvType As esriRasterEnvSettingEnum
    Dim theExtEnvType As esriRasterEnvSettingEnum
    Dim pTempEnv As IEnvelope
    Dim theCellSize As Double
451:     pRastAnalysisEnv.GetCellSize theEnvType, theCellSize
452:     pRastAnalysisEnv.GetExtent theExtEnvType, pTempEnv
    Dim pRasterAnalysisProps As IRasterAnalysisProps
    Dim pRasterProps As IRasterProps
455:         Set pRasterAnalysisProps = pRaster
456:         Set pRasterProps = pRaster
    
    ' DETERMINE OUTPUT SPATIAL REFERENCE BASED ON INPUT RASTER
    
460:     Set pSpatialReference = pRasterProps.SpatialReference
    
    ' CHECK SPATIAL REFERENCE OF INCOMING POLYGON
463:     SpatRefSame = CompareSpatialReferences(pSpatialReference, pPolySpatRef)
464:     If Not SpatRefSame Then pPolygon.Project pSpatialReference
    
    ' DETERMINE ANALYSIS ENVIRONMENT TYPE AND CELL SIZE
467:     If CellSize <= 0 Then
468:       theCellSize = pRasterAnalysisProps.PixelHeight
469:       theEnvType = pRastAnalysisEnv.VerifyType
470:     Else
471:       theCellSize = CellSize
472:       theEnvType = esriRasterEnvValue
473:     End If
    
    Dim pTopoOp As ITopologicalOperator2
476:     If pClipEnvelope Is Nothing Then
      Dim pPolyEnvelope As IEnvelope
478:           Set pPolyEnvelope = pPolygon.Envelope
      Dim pRastEnvelope As IEnvelope
480:           Set pRastEnvelope = pRasterProps.Extent
481:           Set pTopoOp = pPolyEnvelope
482:           pTopoOp.IsKnownSimple = False
483:           pTopoOp.Simplify
      
485:       Set pEnvelope = pTopoOp.Intersect(pPolyEnvelope, esriGeometry2Dimension)
486:     Else
      ' CHECK SPATIAL REFERENCE OF ENVELOPE
488:       SpatRefSame = CompareSpatialReferences(pSpatialReference, pClipEnvelope.SpatialReference)
489:       If Not SpatRefSame Then
490:         pClipEnvelope.Project pSpatialReference
491:       End If
492:       Set pEnvelope = pClipEnvelope.Envelope
493:     End If
    
    ' SET ANALYSIS ENVIRONMENT PROPERTIES
496:     pRastAnalysisEnv.SetCellSize theEnvType, theCellSize
497:     pRastAnalysisEnv.SetExtent esriRasterEnvValue, pEnvelope
498:     Set pRastAnalysisEnv.OutSpatialReference = pSpatialReference
499:   End If
  
  
'  MsgBox "Hello 3"
503:   DoEvents
  
  ' CLIP INCOMING POLYGON TO ANALYSIS AREA; MIGHT HELP AVOID PROBLEMS WITH MULTIPART POLYGONS, HOLES, ETC.
  Dim pIntPolygon As IPolygon4
507:   Set pTopoOp = pPolygon
508:   pTopoOp.IsKnownSimple = False
509:   pTopoOp.Simplify
510:   Set pIntPolygon = pTopoOp.Intersect(pEnvelope, esriGeometry2Dimension)
511:   Set pIntPolygon = pPolygon
512:   Set pIntPolygon.SpatialReference = pPolygon.SpatialReference
  
'  ThisDocument.Graphic_MakeFromGeometry pMxDoc, pIntPolygon, "TestClipPolyGraphics"
  
  
517:   Set pTopoOp = pIntPolygon
518:   pTopoOp.IsKnownSimple = False
519:   pTopoOp.Simplify
  
  Dim pGeometryCollection As IGeometryCollection
  Dim pExtRing As IGeometryCollection
  Dim pIntRingBag As IGeometryCollection
524:   Set pGeometryCollection = pIntPolygon.ConnectedComponentBag
  Dim pIntGeoCol As IGeometryCollection
  Dim pIntPoly As IPolygon4
  Dim pOutGeoCol As IGeometryCollection
  Dim pOutPoly As IPolygon4
  
  Dim pSubPoly As IPolygon4
  Dim pSubRing As IRing
  Dim anIndex As Long
  Dim anIndex2 As Long
  
  Dim pClipRaster As IRaster
  Dim pOuterRaster As IRaster
  Dim pInnerRaster As IRaster
  
  Dim pNegativeGeometryCollection As IGeometryCollection
  Dim anIndex3 As Long
  Dim pNegPoly As IPolygon4
  
  ' MAKE A BUNCH OF NEW RASTER OPERATORS AND ASSIGN THE CURRENT ANALYSIS ENVIRONMENT
  Dim pRasMakerOp As IRasterMakerOp
545:   Set pRasMakerOp = New RasterMakerOp
546:   SetSpatialAnalysisSettings pRasMakerOp, pRastAnalysisEnv
  Dim pCondOp As IConditionalOp
548:   Set pCondOp = New RasterConditionalOp
549:   SetSpatialAnalysisSettings pCondOp, pRastAnalysisEnv
  Dim pLogicOp As ILogicalOp
551:   Set pLogicOp = New RasterMathOps
552:   SetSpatialAnalysisSettings pLogicOp, pRastAnalysisEnv
  Dim pMathOp As IMathOp
554:   Set pMathOp = New RasterMathOps
555:   SetSpatialAnalysisSettings pMathOp, pRastAnalysisEnv
  
  Dim pRasLayer As IRasterLayer
  Dim pTestGeometry As IGeometry
  Dim pTestGeoColl As IGeometryCollection
  Dim pSegmentCollection1 As ISegmentCollection
  Dim pSegment1 As ISegment
  Dim pGeometryType As esriGeometryType
  Dim pEllArcPolygon As IPolygon4
  
  Dim pFinalGrid As IRaster
566:   Set pFinalGrid = pRasMakerOp.MakeConstant(0, True)
567:   Set pClipRaster = pRasMakerOp.MakeConstant(1, True)
  
569:   If booShowProgress Then
570:     pPro.MaxRange = pGeometryCollection.GeometryCount + 2
571:     pPro.StepValue = 1
572:     pPro.Show
573:   End If
  
575:   DoEvents
'  MsgBox "Hello 4"
  
578:   For anIndex = 0 To pGeometryCollection.GeometryCount - 1

580:     Set pSubPoly = pGeometryCollection.Geometry(anIndex)
581:     Set pExtRing = pSubPoly.ExteriorRingBag
582:     Set pSubRing = pExtRing.Geometry(0)
583:     Set pOutGeoCol = New Polygon
584:     pOutGeoCol.AddGeometry pSubRing
585:     Set pOutPoly = pOutGeoCol
586:     Set pTopoOp = pOutPoly
587:     pTopoOp.IsKnownSimple = False
588:     pTopoOp.Simplify
    
'    Debug.Print anIndex & ":  Outer ring of Polygon is Circle?  " & CStr(TypeOf pOutPoly Is ICircularArc)

592:     Set pSegmentCollection1 = pOutPoly
593:     Set pSegment1 = pSegmentCollection1.Segment(0)
594:     pGeometryType = pSegment1.GeometryType
    
596:     If pGeometryType = esriGeometryCircularArc Then
597:       Set pOuterRaster = pExtractionOp.Circle(pClipRaster, pSegment1, Not SaveInside)
598:     ElseIf pGeometryType = esriGeometryEllipticArc Then
599:       Set pEllArcPolygon = EllipticArcToPolygon(pSegmentCollection1, 75)
600:       Set pOuterRaster = pExtractionOp.Polygon(pClipRaster, pEllArcPolygon, Not SaveInside)
601:     ElseIf pGeometryType = esriGeometryEnvelope Then
602:       Set pOuterRaster = pExtractionOp.Rectangle(pClipRaster, pOutPoly, Not SaveInside)
603:     Else
604:       Set pOuterRaster = pExtractionOp.Polygon(pClipRaster, pOutPoly, Not SaveInside)
605:     End If
606:     Set pOuterRaster = pLogicOp.IsNull(pOuterRaster)

608:     If pSubPoly.InteriorRingCount(pSubRing) > 0 Then
609:       Set pIntRingBag = pSubPoly.InteriorRingBag(pSubRing)
   
611:       For anIndex2 = 0 To pIntRingBag.GeometryCount - 1
612:         Set pIntGeoCol = New Polygon
613:         pIntGeoCol.AddGeometry pIntRingBag.Geometry(anIndex2)
614:         Set pIntPoly = pIntGeoCol
615:         Set pTopoOp = pIntPoly
616:         pTopoOp.IsKnownSimple = False
617:         pTopoOp.Simplify

619:         Set pSegmentCollection1 = pIntPoly
620:         Set pSegment1 = pSegmentCollection1.Segment(0)
621:         pGeometryType = pSegment1.GeometryType
                   
       ' CHECK FOR UNUSUAL SHAPES
624:         If pGeometryType = esriGeometryCircularArc Then
625:           Set pInnerRaster = pExtractionOp.Circle(pClipRaster, pSegment1, SaveInside)
626:           Set pInnerRaster = pLogicOp.IsNull(pInnerRaster)
627:           Set pOuterRaster = pMathOp.Times(pInnerRaster, pOuterRaster)
628:         ElseIf pGeometryType = esriGeometryEllipticArc Then
629:           Set pEllArcPolygon = EllipticArcToPolygon(pSegmentCollection1, 75)
630:           Set pInnerRaster = pExtractionOp.Polygon(pClipRaster, pEllArcPolygon, SaveInside)
631:           Set pInnerRaster = pLogicOp.IsNull(pInnerRaster)
632:           Set pOuterRaster = pMathOp.Times(pInnerRaster, pOuterRaster)
633:         ElseIf pGeometryType = esriGeometryEnvelope Then
634:           Set pInnerRaster = pExtractionOp.Rectangle(pClipRaster, pIntPoly, SaveInside)
635:           Set pInnerRaster = pLogicOp.IsNull(pInnerRaster)
636:           Set pOuterRaster = pMathOp.Times(pInnerRaster, pOuterRaster)
637:         Else
638:           Set pNegativeGeometryCollection = pIntPoly.ConnectedComponentBag
639:           For anIndex3 = 0 To pNegativeGeometryCollection.GeometryCount - 1
640:             Set pNegPoly = pNegativeGeometryCollection.Geometry(anIndex3)
641:             Set pTopoOp = pNegPoly
642:             pTopoOp.IsKnownSimple = False
643:             pTopoOp.Simplify
644:             Set pInnerRaster = pExtractionOp.Polygon(pClipRaster, pNegPoly, SaveInside)
645:             Set pInnerRaster = pLogicOp.IsNull(pInnerRaster)
646:             Set pOuterRaster = pMathOp.Times(pInnerRaster, pOuterRaster)
647:           Next anIndex3
648:         End If
        
'        ' CHECK FOR UNUSUAL SHAPES
'        If pGeometryType = esriGeometryCircularArc Then
'          Set pInnerRaster = pExtractionOp.Circle(pClipRaster, pSegment1, SaveInside)
'        ElseIf pGeometryType = esriGeometryEllipticArc Then
'          Set pEllArcPolygon = EllipticArcToPolygon(pSegmentCollection1, 75)
'          Set pInnerRaster = pExtractionOp.Polygon(pClipRaster, pEllArcPolygon, SaveInside)
'        ElseIf pGeometryType = esriGeometryEnvelope Then
'          Set pInnerRaster = pExtractionOp.Rectangle(pClipRaster, pIntPoly, SaveInside)
'        Else
'          Set pInnerRaster = pExtractionOp.Polygon(pClipRaster, pIntPoly, SaveInside)
'        End If
'        Set pInnerRaster = pLogicOp.IsNull(pInnerRaster)
'        Set pOuterRaster = pMathOp.Times(pInnerRaster, pOuterRaster)
        
        
665:         DoEvents
666:       Next anIndex2
    
668:     End If
    
670:     Set pFinalGrid = pMathOp.Plus(pFinalGrid, pOuterRaster)
671:     If booShowProgress Then
672:       pPro.Step
673:     End If
674:     DoEvents
675:   Next anIndex
  
  ' FOR DEBUGGING
  
'  Dim pMxDoc As IMxDocument
'  Set pMxDoc = ThisDocument
'  Dim pMap As IMap
'  Set pMap = pMxDoc.FocusMap
'  Set pRasLayer = New RasterLayer
'  pRasLayer.CreateFromRaster pFinalGrid
'  pMap.AddLayer pRasLayer
 
687:   Set pFinalGrid = pCondOp.SetNull(pLogicOp.EqualTo(pFinalGrid, pRasMakerOp.MakeConstant(0, True)), pFinalGrid)
688:   If booShowProgress Then
689:     pPro.Step
690:   End If
691:   Set ClipRasterToPolygon = pMathOp.Times(pFinalGrid, pRaster)
692:   If booShowProgress Then
693:     pPro.Step
694:   End If
  
696:   DoEvents
  
  ' RESET ANALYSIS ENVIRONMENT TO PREVIOUS STATE
699:   pRastAnalysisEnv.RestoreToPreviousDefaultEnvironment
  
701:   If booShowProgress Then
702:     pPro.Hide
703:   End If

  Exit Function
ErrorHandler:
  HandleError True, "ClipRasterToPolygon " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function


Public Function EllipticArcToPolygon(SegCollection As ISegmentCollection, NumVertices As Long) As IPolygon4
'  Dim pMxDoc As IMxDocument
'  Set pMxDoc = ThisDocument
  
'  Dim pEllArc As IEllipticArc
      
On Error GoTo erh

  Dim pCurve As ICurve
  Dim pGeometry As IGeometry
  
  Dim anIndex As Long
  Dim lngSegCount As Long
724:   lngSegCount = SegCollection.SegmentCount - 1
  Dim theLength As Double
726:   theLength = 0
  Dim theTestLength As Double
  Dim lngLengths() As Long
  ReDim lngLengths(lngSegCount)
730:   For anIndex = 0 To lngSegCount
731:     theTestLength = SegCollection.Segment(anIndex).length
732:     theLength = theLength + theTestLength
733:     lngLengths(anIndex) = theTestLength
734:   Next anIndex
  
  Dim pProportion As Double
  Dim lngVertices() As Long
  Dim lngNumVertices As Long
  ReDim lngVertices(lngSegCount)
740:   For anIndex = 0 To lngSegCount
741:     lngNumVertices = Int((lngLengths(anIndex) / theLength) * NumVertices)
742:     If lngNumVertices < 8 Then lngNumVertices = 8
743:     lngVertices(anIndex) = lngNumVertices
744:   Next anIndex
  
  Dim pMpt As IPointCollection
747:   Set pMpt = New Multipoint
  Dim pPoint As IPoint
749:   Set pPoint = New Point
  Dim pClone As IClone
  
  Dim pRatio As Double
  Dim anIndex2 As Long
  
755:   For anIndex = 0 To lngSegCount
756:     lngNumVertices = lngVertices(anIndex)
757:     pRatio = 1 / lngNumVertices
758:     Set pCurve = SegCollection.Segment(anIndex)
    
760:     For anIndex2 = 0 To lngNumVertices
'      If pGeometry.GeometryType = esriGeometryEllipticArc Then
762:       pCurve.QueryPoint 0, (pRatio * anIndex2), True, pPoint
763:       Set pClone = pPoint
        
 '   Graphic_MakeFromGeometry pMxDoc, pPoint, "DeleteMe"
    
767:       pMpt.AddPoint pClone.Clone
768:     Next anIndex2
769:   Next anIndex
  
  Dim pPoly4 As IPolygon4
  Dim pTopoOp2 As ITopologicalOperator2
  Dim pTopoOp3 As ITopologicalOperator3
774:   Set pTopoOp2 = pMpt
775:   Set pPoly4 = pTopoOp2.ConvexHull
776:   Set pTopoOp3 = pPoly4
777:   pTopoOp3.IsKnownSimple = False
778:   pTopoOp3.Simplify
  
780:   Set EllipticArcToPolygon = pPoly4
    Exit Function
  
erh:
784:     MsgBox "Failed in EllipticArcToPolygon: " & err.Description
End Function

Public Function EllipticArcToPolygon2(SegCollection As ISegmentCollection, NumVertices As Long) As IMultipoint
'  Dim pMxDoc As IMxDocument
'  Set pMxDoc = ThisDocument
  
'  Dim pEllArc As IEllipticArc
      
On Error GoTo erh

  Dim pCurve As ICurve
  Dim pGeometry As IGeometry
  
  Dim anIndex As Long
  Dim lngSegCount As Long
800:   lngSegCount = SegCollection.SegmentCount - 1
  Dim theLength As Double
802:   theLength = 0
  Dim theTestLength As Double
  Dim lngLengths() As Long
  ReDim lngLengths(lngSegCount)
806:   For anIndex = 0 To lngSegCount
807:     theTestLength = SegCollection.Segment(anIndex).length
808:     theLength = theLength + theTestLength
809:     lngLengths(anIndex) = theTestLength
810:   Next anIndex
  
  Dim pProportion As Double
  Dim lngVertices() As Long
  Dim lngNumVertices As Long
  ReDim lngVertices(lngSegCount)
816:   For anIndex = 0 To lngSegCount
817:     lngNumVertices = Int((lngLengths(anIndex) / theLength) * NumVertices)
818:     If lngNumVertices < 8 Then lngNumVertices = 8
819:     lngVertices(anIndex) = lngNumVertices
820:   Next anIndex
  
  Dim pMpt As IPointCollection
823:   Set pMpt = New Multipoint
  Dim pPoint As IPoint
825:   Set pPoint = New Point
  Dim pClone As IClone
  
  Dim pRatio As Double
  Dim anIndex2 As Long
  
831:   For anIndex = 0 To lngSegCount
832:     lngNumVertices = lngVertices(anIndex)
833:     pRatio = 1 / lngNumVertices
834:     Set pCurve = SegCollection.Segment(anIndex)
    
836:     For anIndex2 = 0 To lngNumVertices
'      If pGeometry.GeometryType = esriGeometryEllipticArc Then
838:       pCurve.QueryPoint 0, (pRatio * anIndex2), True, pPoint
839:       Set pClone = pPoint
        
 '   Graphic_MakeFromGeometry pMxDoc, pPoint, "DeleteMe"
    
843:       pMpt.AddPoint pClone.Clone
844:     Next anIndex2
845:   Next anIndex
  
847:   Set EllipticArcToPolygon2 = pMpt
    Exit Function
  
erh:
851:     MsgBox "Failed in EllipticArcToPolygon2: " & err.Description
End Function

Public Function DistributePointsAlongShape(pCurve As ICurve, SeparationDistance As Double) As IPointCollection
      
On Error GoTo erh
'  Dim pMxDoc As IMxDocument
'  Set pMxDoc = ThisDocument
'  Dim pGeometry As IGeometry
  
  Dim anIndex As Long
  Dim theLength As Double
863:   theLength = pCurve.length
  
  Dim pMpt As IPointCollection
866:   Set pMpt = New Multipoint
  Dim pPoint As IPoint
868:   Set pPoint = New Point
  Dim pClone As IClone
  
  Dim dblRatio As Double
872:   dblRatio = SeparationDistance / theLength
  
  Dim theCurrentDist As Double
875:   theCurrentDist = 0
  
877:   Do While theCurrentDist < 1
878:     pCurve.QueryPoint esriNoExtension, theCurrentDist, True, pPoint
879:     Set pClone = pPoint
880:     pMpt.AddPoint pClone.Clone
'    ThisDocument.Graphic_MakeFromGeometry pMxDoc, pPoint, "TestClipPolyGraphics"
882:     theCurrentDist = theCurrentDist + dblRatio
883:   Loop
884:   pCurve.QueryPoint esriNoExtension, 1, True, pPoint
885:   Set pClone = pPoint
886:   pMpt.AddPoint pClone.Clone
  
  Dim pGeometry As IGeometry
889:   Set pGeometry = pMpt
890:   Set pGeometry.SpatialReference = pCurve.SpatialReference
  
892:   Set DistributePointsAlongShape = pMpt
  
    Exit Function
  
erh:
897:     MsgBox "Failed in DistributePointsAlongShape: " & err.Description
End Function

Public Function CalcGridLine(ByVal pStartPolygon As IPolygon, ByVal pEndPolygon As IPolygon, _
      ByVal pCorPolygon As IPolygon, pCorRaster As IRaster, pEnv As IRasterAnalysisEnvironment, _
      Optional ShouldClean As Boolean) As IPolyline
  On Error GoTo ErrorHandler

  
'  Dim pMxDoc As IMxDocument
'  Set pMxDoc = ThisDocument
  Dim pClone As IClone
  
  Dim pEnvelope As IEnvelope
911:   pEnv.GetExtent esriRasterEnvValue, pEnvelope
'  Set pEnvelope = pEnv.GetExtent

  'Create a RasterMakerOp operator
  Dim pRasMakerOp As IRasterMakerOp
916:   Set pRasMakerOp = New RasterMakerOp
917:   GridFunctions.SetSpatialAnalysisSettings pRasMakerOp, pEnv

  Dim pSpRef As ISpatialReference
920:   Set pSpRef = pEnv.OutSpatialReference
  
  ' SET POLYGON SPATIAL REFERENCES; PROJECT THEM IF NECESSARY
923:   If Not (GridFunctions.CompareSpatialReferences(pStartPolygon.SpatialReference, pSpRef)) Then
924:     pStartPolygon.Project pSpRef
925:   End If
926:   If Not (GridFunctions.CompareSpatialReferences(pEndPolygon.SpatialReference, pSpRef)) Then
927:     pEndPolygon.Project pSpRef
928:   End If
  
  ' GENERATE A SERIES OF POINTS AROUND THE BOUNDARY OF THE END POLYGON
  Dim pPoints As IPointCollection
932:   Set pPoints = GridFunctions.ReturnPointsByCellSize(pCorRaster, pEndPolygon)
  Dim anIndex As Long
'  For anIndex = 0 To pPoints.PointCount - 1
'    ThisDocument.Graphic_MakeFromGeometry pMxDoc, pPoints.Point(anIndex), "DeleteMatrix"
'  Next anIndex
  
  ' Create the RasterDistanceOp object
  Dim pDistanceOp As IDistanceOp
940:   Set pDistanceOp = New RasterDistanceOp
  
  ' SET ANALYSIS ENVIRONMENT
943:   SetSpatialAnalysisSettings pDistanceOp, pEnv
  
  ' Declare the input source raster object
  Dim pBaseRaster As IRaster
947:   Set pBaseRaster = pRasMakerOp.MakeConstant(1, True)
  Dim pSourceDataset As IRaster
949:   Set pSourceDataset = ClipRasterToPolygon(pBaseRaster, pStartPolygon, True, , , pEnv)
  
  ' Declare the input cost raster object
  Dim pCostDataset As IGeoDataset
  
  ' Declare the output raster object
  Dim pOutputRaster As IGeoDataset
  
  ' Calls the method
958:   Set pOutputRaster = pDistanceOp.CostDistanceFull(pSourceDataset, pCorRaster, True, True, False)
  
  ' To access the backlink raster from the output generated from the above code:
  Dim pRasterBandCollection As IRasterBandCollection
962:   Set pRasterBandCollection = pOutputRaster
  Dim pDistBand As IRasterBand        ' DISTANCE BAND
964:   Set pDistBand = pRasterBandCollection.Item(0)
  Dim pDistRaster As IRasterBandCollection
966:   Set pDistRaster = New Raster
967:   pDistRaster.Add pDistBand, 0
  
  Dim pDistAsRaster As IRaster
970:   Set pDistAsRaster = pDistRaster
  
  Dim pBacklinkBand As IRasterBand    ' BACKLINK BAND
973:   Set pBacklinkBand = pRasterBandCollection.Item(1)
  Dim pBacklinkRaster As IRasterBandCollection
975:   Set pBacklinkRaster = New Raster
976:   pBacklinkRaster.Add pBacklinkBand, 0
  
'  Dim pMxDoc As IMxDocument
'  Set pMxDoc = ThisDocument
'  Dim pMap As IMap
'  Set pMap = pMxDoc.FocusMap
  
'  ThisDocument.Graphic_MakeFromGeometry pMxDoc, pCleanLine, "TestClipPolyGraphics"
  
'  Dim pRasLayer As IRasterLayer
'  Set pRasLayer = New RasterLayer
'  pRasLayer.CreateFromRaster pCorRaster
'  pMap.AddLayer pRasLayer
'  Dim pRasLayer2 As IRasterLayer
'  Set pRasLayer2 = New RasterLayer
'  pRasLayer2.CreateFromRaster pDistAsRaster
'  pMap.AddLayer pRasLayer2
'  Dim pRasLayer3 As IRasterLayer
'  Set pRasLayer3 = New RasterLayer
'  pRasLayer3.CreateFromRaster pBacklinkRaster
'  pMap.AddLayer pRasLayer3
  
'  Dim pEnumVertices As IEnumVertex
'  Set pEnumVertices = pPoints.EnumVertices
'  Dim pVertex As IPoint
'  Set pVertex = New Point
'  Dim lngPlaceholder As Long
'  Dim lngPlaceholder2 As Long
  
  ' ArcGIS APPEARS TO OCCASIONALLY SCREW UP THE SINGLE BACK PATH FUNCTION.  THEREFORE WE'LL
  ' CREATE THEM ALL
  
  Dim pPathCollection As IGeometryCollection
1009:   Set pPathCollection = pDistanceOp.CostPathAsPolyline(pPoints, pDistAsRaster, pBacklinkRaster)
  ' IF THIS PATH COLLECTION IS EMPTY, THEN LIKELY THAT ONE OF THE POLYGONS DOES NOT INTERSECT ANY GRID CELLS.
  ' THEREFORE CANNOT FIND PATH.
1012:   If pPathCollection.GeometryCount = 0 Then
    Dim pEmptyLine As IPolyline
1014:     Set pEmptyLine = New Polyline
1015:     pEmptyLine.SetEmpty
1016:     Set CalcGridLine = pEmptyLine
    Exit Function
1018:   End If
  
'  Dim pixelWidth As Double, pixelHeight As Double
'  pixelWidth = GridFunctions.ReturnPixelWidth(pDistAsRaster)
'  pixelHeight = GridFunctions.ReturnPixelHeight(pDistAsRaster)
'
'  Dim lngEnvYMax As Long, lngEnvXMin As Long
'  Dim pDistEnv As IEnvelope, pDistProps As IRasterProps
'  Set pDistProps = pDistAsRaster
'  Set pDistEnv = pDistProps.Extent
'  lngEnvYMax = pDistEnv.YMax
'  lngEnvXMin = pDistEnv.XMin
'
'  pEnumVertices.Reset
'  pEnumVertices.QueryNext pVertex, lngPlaceholder, lngPlaceholder2
  
  ' determine which row & col were clicked on
'  Dim lRow As Long, lCol As Long
'  Dim dblMinDist As Double
'  dblMinDist = pDistEnv.Width * pDistEnv.Height
'  Dim pMinPoint As IPoint
'  Set pClone = pVertex
'  Set pMinPoint = pClone.Clone
  
'  Dim pSizePoint As IPnt
'  Dim pPixBlock As IPixelBlock
'  Set pSizePoint = New Pnt
'  pSizePoint.SetCoords 1, 1
'  Dim pTLCPoint As IPnt
'  Dim pSafeArray As Variant
'  Dim dblPixVal As Double
  
'  Do While Not pVertex.IsEmpty
'    lCol = Round(Abs(pVertex.x - lngEnvXMin - (0.5 * pixelWidth)) / pixelWidth)
'    lRow = Round(Abs(pVertex.Y - lngEnvYMax + (0.5 * pixelHeight)) / pixelHeight)
'    Debug.Print "row: " & lRow & ", col " & lCol
    
    ' create a pixel block (that has only one pixel)
    
'    Set pPixBlock = pDistAsRaster.CreatePixelBlock(pSizePoint)
'    Set pTLCPoint = New Pnt
'    pTLCPoint.SetCoords lCol, lRow
'    pDistAsRaster.Read pTLCPoint, pPixBlock
'    pSafeArray = pPixBlock.SafeArray(0)
'    dblPixVal = pSafeArray(0, 0)
'    If dblPixVal < dblMinDist Then
'      dblMinDist = dblPixVal
'      Set pClone = pVertex
'      Set pMinPoint = pClone.Clone
'    End If
 '   Debug.Print "row: " & lRow & ", col " & lCol & ", val = " & dblPixVal & ".   Current min = " & dblMinDist
'    pEnumVertices.QueryNext pVertex, lngPlaceholder, lngPlaceholder2
'  Loop
  
'  Dim pPathPointCol As IPointCollection
'  Set pPathPointCol = New Multipoint
'  pPathPointCol.AddPoint pMinPoint
  
'  Dim pPathCollection As IGeometryCollection
'  Set pPathCollection = pDistanceOp.CostPathAsPolyline(pPathPointCol, pDistAsRaster, pBacklinkRaster)
   
  Dim pPath As IPolyline
  Dim pMinPath As IPolyline
  Dim dblShortDist As Double
1082:   Set pPath = pPathCollection.Geometry(0)
1083:   Set pMinPath = pPath
1084:   dblShortDist = pPath.length
1085:   If pPathCollection.GeometryCount > 1 Then
1086:     For anIndex = 1 To pPathCollection.GeometryCount - 1
1087:       Set pPath = pPathCollection.Geometry(anIndex)
1088:       If pPath.length < dblShortDist Then
1089:         Set pMinPath = pPath
1090:         dblShortDist = pPath.length
1091:       End If
1092:     Next anIndex
1093:   End If
  
  ' CLEAN POLYLINE
  Dim pBoundary As IPolyline
  Dim pTopoOp As ITopologicalOperator
1098:   Set pTopoOp = pCorPolygon
1099:   Set pBoundary = pTopoOp.Boundary
  
  Dim pCleanLine As IPolyline
1102:   If (ShouldClean) Then
1103:     Set pCleanLine = CleanPolyline(pMinPath, pBoundary)
1104:   Else
1105:     Set pCleanLine = pMinPath
1106:   End If
  
  
'    Dim pixelWidth As Double, pixelHeight As Double
'    pixelWidth = pREnv.Width / pRLayer.ColumnCount
'    pixelHeight = pREnv.Height / pRLayer.RowCount
    
    ' determine which row & col were clicked on
'    Dim lRow As Long, lCol As Long
'    lCol = Round(Abs(pPoint.x - pREnv.XMin - (0.5 * pixelWidth)) / pixelWidth)
'    lRow = Round(Abs(pPoint.Y - pREnv.YMax + (0.5 * pixelHeight)) / pixelHeight)
  
  
  
  
  
  
  
  'pExtractOp.Polygon(pOutRaster, pCorPolygon, True)
  
  'Create a raster layer from the output and add it to ArcMap

'  Dim pMxDoc As IMxDocument
'  Set pMxDoc = ThisDocument
'  Dim pMap As IMap
'  Set pMap = pMxDoc.FocusMap
  
'  ThisDocument.Graphic_MakeFromGeometry pMxDoc, pCleanLine, "TestClipPolyGraphics"
  
'  Dim pRasLayer As IRasterLayer
'  Set pRasLayer = New RasterLayer
'  pRasLayer.CreateFromRaster pCorRaster
'  pMap.AddLayer pRasLayer
'  Dim pRasLayer2 As IRasterLayer
'  Set pRasLayer2 = New RasterLayer
'  pRasLayer2.CreateFromRaster pDistAsRaster
'  pMap.AddLayer pRasLayer2
'  Dim pRasLayer3 As IRasterLayer
'  Set pRasLayer3 = New RasterLayer
'  pRasLayer3.CreateFromRaster pBacklinkRaster
'  pMap.AddLayer pRasLayer3
  
'  Set pCorRaster = Nothing
1149:   Set pDistAsRaster = Nothing
1150:   Set pBacklinkRaster = Nothing
1151:   pCleanLine.ReverseOrientation
1152:   Set pCleanLine.SpatialReference = pEnv.OutSpatialReference
1153:   Set CalcGridLine = pCleanLine


  Exit Function
ErrorHandler:
  HandleError True, "CalcGridLine " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function


Public Function CellValues(pPoints As IPointCollection, pRaster As IRaster) As esriSystem.IVariantArray
  On Error GoTo ErrorHandler

    Dim pRP As IRasterProps
1166:     Set pRP = pRaster
    
    Dim dblCellSize As Double
1169:     dblCellSize = ReturnCellSize(pRaster)
    
    'Get extent
    Dim pExtent As IEnvelope
1173:     Set pExtent = pRP.Extent
    Dim X1 As Double, Y1 As Double, X2 As Double, Y2 As Double
1175:     pExtent.QueryCoords X1, Y1, X2, Y2
    
    'Get a PixelBloc with cellvalues
    Dim pPB As IPixelBlock3
    Dim dWidth As Double, dHeight As Double
1180:     dWidth = pRP.Width
1181:     dHeight = pRP.Height
  
    'Create a Pnt to hold the PixelBlock size
    Dim pPnt As IPnt
1185:     Set pPnt = New Pnt
1186:     pPnt.SetCoords dWidth, dHeight
     
    'Create a point to set origin
    Dim pOrigin As IPnt
1190:     Set pOrigin = New Pnt
1191:     pOrigin.SetCoords 0, 0
     
    'Create and read entire grid into PixelBlock
1194:     Set pPB = pRaster.CreatePixelBlock(pPnt)
1195:     pRaster.Read pOrigin, pPB
    
    Dim lngIndex As Long
    Dim dblCellValue As Double
    Dim pPoint As IPoint
    Dim dx As Double, dy As Double
    Dim nX As Double, nY As Double
    Dim iX As Long, iY As Long
    
    Dim pOutArray As esriSystem.IVariantArray
1205:     Set pOutArray = New esriSystem.VarArray
    
    Dim vCellValue As Variant
    
1209:     For lngIndex = 0 To pPoints.PointCount - 1
1210:       Set pPoint = pPoints.Point(lngIndex)
      ' RETURN NULL IF OUTSIDE EXTENT
1212:       If pPoint.X < X1 Or pPoint.X > X2 Or pPoint.Y < Y1 Or pPoint.Y > Y2 Then
1213:         pOutArray.Add Null
1214:       Else
    
1216:         dx = pPoint.X - X1
1217:         dy = Y2 - pPoint.Y
        
        'Find ncells from left-top
1220:         nX = dx / dblCellSize
1221:         nY = dy / dblCellSize
        
        'Determine cell index by taking the int. It will also take care of the fact that the index is 0 based
1224:         iX = Int(nX)
1225:         iY = Int(nY)
        
1227:         If (iX < 0) Then iX = 0
1228:         If (iY < 0) Then iY = 0
1229:         If (iX > pRP.Width - 1) Then
1230:           iX = pRP.Width - 1
1231:         End If
1232:         If (iY > pRP.Height - 1) Then
1233:           iY = pRP.Height - 1
1234:         End If
        
        'Read cell values
1237:         vCellValue = pPB.GetVal(0, iX, iY)
1238:         Debug.Print "From CellValues function..." & vCellValue
1239:         If IsEmpty(vCellValue) Then
1240:           pOutArray.Add Null
1241:         Else
1242:           pOutArray.Add CDbl(vCellValue)
1243:         End If
1244:       End If
1245:     Next lngIndex
1246:     Set CellValues = pOutArray
    

  Exit Function
ErrorHandler:
  HandleError True, "CellValues " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function CellValue(pPoint As IPoint, pRaster As IRaster) As Variant
  On Error GoTo ErrorHandler

    
'    Dim pRawPixels As IRawPixels
'    Dim pRasterBandCol As IRasterBandCollection
'    Set pRasterBandCol = pRaster
'    Set pRawPixels = pRasterBandCol.Item(0)
'create a point which determines the size for IPixelBlock
'    Dim aoiPNT As IPnt
'    Set aoiPNT = New Pnt
'        aoiPNT.SetCoords 1, 1
'create the IPixelBlock
'    Dim aoiPixelBlock As IPixelBlock
'    Set aoiPixelBlock = pRawPixels.CreatePixelBlock(aoiPNT)
    
    
    
    Dim pRP As IRasterProps
1273:     Set pRP = pRaster
    
    Dim dblCellSize As Double
1276:     dblCellSize = ReturnCellSize(pRaster)
    
    'Get extent
    Dim pExtent As IEnvelope
1280:     Set pExtent = pRP.Extent
    Dim X1 As Double, Y1 As Double, X2 As Double, Y2 As Double
1282:     pExtent.QueryCoords X1, Y1, X2, Y2
    
    ' RETURN NULL IF OUTSIDE EXTENT
1285:     If pPoint.X < X1 Or pPoint.X > X2 Or pPoint.Y < Y1 Or pPoint.Y > Y2 Then
1286:       CellValue = Null
      Exit Function
1288:     End If
    
    ' GET 1-CELL PIXELBLOCK
    'Get cell index from map coordinate
    Dim pCellPoint As IPoint  'Get dx dy from left-top
    Dim dx As Double, dy As Double
1294:     dx = pPoint.X - X1
1295:     dy = Y2 - pPoint.Y
    
    'Find ncells from left-top
    Dim nX As Double, nY As Double
1299:     nX = dx / dblCellSize
1300:     nY = dy / dblCellSize
    
    'Determine cell index by taking the int. It will also take care of the fact that the index is 0 based
    Dim iX As Long, iY As Long
1304:     iX = Int(nX)
1305:     iY = Int(nY)
    
    'If the index is < 0, set it to 0 - do I need this adjustment?
1308:     If (iX < 0) Then iX = 0
1309:     If (iY < 0) Then iY = 0
1310:     If (iX > pRP.Width - 1) Then
1311:       iX = pRP.Width - 1
1312:     End If
1313:     If (iY > pRP.Height - 1) Then
1314:       iY = pRP.Height - 1
1315:     End If
      
    'Create a point from cell index and return
1318:     Set pCellPoint = New Point
1319:     pCellPoint.PutCoords CDbl(iX), CDbl(iY)
    
    'Get a PixelBloc with cellvalues
    Dim pPB As IPixelBlock3
    Dim dWidth As Double, dHeight As Double
1324:     dWidth = pRP.Width
1325:     dHeight = pRP.Height
  
    'Create a Pnt to hold the PixelBlock size
    Dim pPnt As IPnt
1329:     Set pPnt = New Pnt
1330:     pPnt.SetCoords dWidth, dHeight
     
    'Create a point to set origin
    Dim pOrigin As IPnt
1334:     Set pOrigin = New Pnt
1335:     pOrigin.SetCoords 0, 0
     
    'Create and read the PixelBlock
1338:     Set pPB = pRaster.CreatePixelBlock(pPnt)
    
    'Read cell values
1341:     pRaster.Read pOrigin, pPB
    Dim vCellValue As Variant
1343:     vCellValue = pPB.GetVal(0, iX, iY)
1344:     Debug.Print "From function..." & vCellValue
1345:     If IsEmpty(vCellValue) Then
1346:       CellValue = Null
1347:     Else
1348:       CellValue = CDbl(vCellValue)
1349:     End If
    

  Exit Function
ErrorHandler:
  HandleError True, "CellValue " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function CleanPolyline(ByVal pPolyline As IPolyline, pBoundary As IPolyline) As IPolyline
  On Error GoTo ErrorHandler


  Dim pPointCol As IPointCollection
1362:   Set pPointCol = pPolyline
  
  Dim pNewPointCol As IPointCollection
1365:   Set pNewPointCol = New Polyline
  
  Dim pSegment As IPointCollection
  Dim pStartPoint As IPoint
  Dim pEndPoint As IPoint
  Dim pClone As IClone
  
  Dim pCount As Long
1373:   pCount = pPointCol.PointCount
  
1375:   Set pStartPoint = pPointCol.Point(0)
1376:   Set pClone = pStartPoint
1377:   pNewPointCol.AddPoint pClone.Clone
  
  Dim anIndex1 As Long
  Dim anIndex2 As Long
  Dim anIndexStep As Long
  
  Dim pRelOp As IRelationalOperator
  
1385:   anIndex1 = 1
1386:   anIndexStep = 0
  
1388:   Do Until anIndex1 = pPointCol.PointCount - 1
1389:     Set pEndPoint = pPointCol.Point(anIndex1)
1390:     Set pSegment = New Polyline
1391:     pSegment.AddPoint pStartPoint
1392:     pSegment.AddPoint pEndPoint
1393:     Set pRelOp = pSegment
1394:     If pRelOp.Disjoint(pBoundary) Then
1395:       anIndex1 = anIndex1 + 1
1396:     Else
1397:       anIndex2 = anIndex1 - 1
1398:       Do Until anIndex2 <= anIndexStep
1399:         Set pStartPoint = pPointCol.Point(anIndex2)
1400:         Set pSegment = New Polyline
1401:         pSegment.AddPoint pStartPoint
1402:         pSegment.AddPoint pEndPoint
1403:         Set pRelOp = pSegment
1404:         If pRelOp.Disjoint(pBoundary) Then
1405:           anIndex2 = anIndex2 - 1
1406:         Else
1407:           Set pClone = pStartPoint
1408:           pNewPointCol.AddPoint pClone.Clone
1409:           anIndexStep = anIndex2 + 1
1410:           Set pStartPoint = pPointCol.Point(anIndexStep)
1411:           Set pClone = pStartPoint
1412:           pNewPointCol.AddPoint pClone.Clone
1413:           anIndex1 = anIndexStep + 1
1414:           Exit Do
1415:         End If
1416:       Loop
1417:     End If
1418:   Loop
1419:   Set pClone = pPointCol.Point(pPointCol.PointCount - 1)
1420:   pNewPointCol.AddPoint pClone.Clone
1421:   Set CleanPolyline = pNewPointCol
1422:   Set CleanPolyline.SpatialReference = pPolyline.SpatialReference


  Exit Function
ErrorHandler:
  HandleError True, "CleanPolyline " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function


Public Function CellValues4CellInterp_Mahal(pPoints As IPointCollection, pRaster As IRaster, _
    pThisExt As TopoCorridor.clsExtension, _
    lngRunningCount As Long, _
    lngTotalCount As Long, _
    dblCurrentPercent As Double, _
    booShouldStop As Boolean, _
    strReturn As String, _
    psbar As IStatusBar, _
    pPro As IStepProgressor, _
    theTimeBegan As Date, _
    lngTimer As Long, _
    Optional lngBandIndex As Long = 0) As esriSystem.IVariantArray
    
  On Error GoTo ErrorHandler
    
    ' SPECIAL CODE TO UPDATE PROGRESS METER
    Dim booShowProgress As Boolean
    Dim frmProgress As TopoCorridor.frmJenProgressMeter
1449:     Set frmProgress = pThisExt.ProgressMeterForm
1450:     booShowProgress = CBool(Not frmProgress Is Nothing)
    Dim dblCheckPercent As Double
    Dim dateRunningTime As Date
1453:     dateRunningTime = Now
    ' ---------------------------------------------------
    
    ' ASSUMES POINTS ARE IN SAME PROJECTION AS RASTER
    Dim pRP As IRasterProps
1458:     Set pRP = pRaster
    
    Dim dblCellSizeX As Double
    Dim dblCellSizeY As Double
1462:     dblCellSizeX = ReturnPixelWidth(pRaster)
1463:     dblCellSizeY = ReturnPixelHeight(pRaster)
    
    Dim dblHalfCellX As Double
1466:     dblHalfCellX = dblCellSizeX / 2
    Dim dblHalfCellY As Double
1468:     dblHalfCellY = dblCellSizeY / 2
    
    'Get extent
    Dim pExtent As IEnvelope
1472:     Set pExtent = pRP.Extent
    Dim X1 As Double, Y1 As Double, X2 As Double, Y2 As Double
1474:     pExtent.QueryCoords X1, Y1, X2, Y2
    
    'Get a PixelBloc with cellvalues
    Dim pPB As IPixelBlock3
    
    Dim dWidth As Double, dHeight As Double
1480:     dWidth = pRP.Width
1481:     dHeight = pRP.Height
  
    'Create a pnt to hold the 2x2 PixelBlock size
    Dim pPnt As IPnt
1485:     Set pPnt = New Pnt
1486:     pPnt.SetCoords 2, 2
1487:     Set pPB = pRaster.CreatePixelBlock(pPnt)
     
    'Create a point to set origin
    Dim pOrigin As IPnt
    
    Dim lngIndex As Long
    Dim dblCellValue As Double
    Dim pPoint As IPoint
    Dim dx As Double, dy As Double
    Dim nX As Double, nY As Double
    Dim dblXRemainder As Double, dblYRemainder As Double
    Dim iX As Long, iY As Long
    Dim intMaxX As Integer, intMaxY As Integer
    
1501:     intMaxX = pRP.Width - 1
1502:     intMaxY = pRP.Height - 1
    
    Dim bytQuadrant As Byte       ' 1 FOR NE, 2 FOR NW, 3 FOR SW, 4 FOR SE
    Dim varInterpVal As Variant
    
    ' BELOW FOR INTERPOLATION PURPOSES; USED TO CALCULATE THE WEIGHT OF THE PRIMARY CELL VS. THE ADJACENT CELLS.
    Dim dblPropX As Double
    Dim dblPropY As Double
    
    Dim pOutArray As esriSystem.IVariantArray
1512:     Set pOutArray = New esriSystem.VarArray
    
    Dim vCellValueNE As Variant
    Dim vCellValueNW As Variant
    Dim vCellValueSE As Variant
    Dim vCellValueSW As Variant
    
    Dim booIsNull As Boolean
    Dim dblWestProp As Double
    Dim dblEastProp As Double
    
1523:     For lngIndex = 0 To pPoints.PointCount - 1
        
      ' SPECIAL CODE TO UPDATE PROGRESS METER
1526:       If booShowProgress Then
1527:         lngRunningCount = lngRunningCount + 1
1528:         dblCheckPercent = Round(lngRunningCount / lngTotalCount, 3)
1529:         If (dblCheckPercent > dblCurrentPercent) Or DateDiff("s", dateRunningTime, Now) >= 1 Then
1530:           dateRunningTime = Now
1531:           dblCurrentPercent = dblCheckPercent
1532:           frmProgress.Est_Time_Left_Short lngRunningCount, _
              "Extracting Grid Cell Values [Sampling " & CStr(Format(pPoints.PointCount, "#,##0")) & " points]...", lngTotalCount
1534:           frmProgress.Refresh
1535:           frmProgress.icnProgressLineShort.Refresh
1536:           frmProgress.icnProgressLine.Refresh
1537:           If Not frmProgress.ShouldContinue Then
      
           ' ********************************************************************************************
            ' ALTERNATIVE CODE THAT SAVES PARTIAL TABLE, CHECKS IF ERRORS FOUND AND OUTPUTS RTF INSTEAD OF TEXT
      
1542:             strReturn = "-----------------------------------------\par" & vbCrLf & _
              "NOTE:  Exited Function Prematurely at Step " & CStr(lngTimer) & "\par" & vbCrLf & _
              "-----------------------------------------\par" & vbCrLf & _
              "\pard\qc " & TopoCorridor.MyGeneralOperations.ReturnTimeElapsedRTF(theTimeBegan, Now, 7) & vbCrLf & "}"
      
           ' ********************************************************************************************
      
1549:             frmProgress.cmdStop.Caption = "Close"
1550:             pPro.position = 0
1551:             psbar.HideProgressBar
1552:             booShouldStop = True
            Exit Function
1554:           End If
1555:         End If
1556:       End If
      ' ---------------------------------------------------
    
1559:       Set pPoint = pPoints.Point(lngIndex)
      
      ' RETURN NULL IF OUTSIDE EXTENT
1562:       If pPoint.X < X1 Or pPoint.X > X2 Or pPoint.Y < Y1 Or pPoint.Y > Y2 Then
1563:         pOutArray.Add Null
1564:       Else
        
1566:         dx = pPoint.X - X1
1567:         dy = Y2 - pPoint.Y
        
        'Find ncells from left-top
1570:         nX = dx / dblCellSizeX
1571:         nY = dy / dblCellSizeY
        
        'Determine cell index by taking the int. It will also take care of the fact that the index is 0 based
1574:         iX = Int(nX)
1575:         iY = Int(nY)
        
        ' FOLLOWING IN CASE OF ROUNDING ERROR
1578:         If (iX < 0) Then iX = 0
1579:         If (iY < 0) Then iY = 0
1580:         If (iX > intMaxX) Then
1581:           iX = intMaxX
1582:         End If
1583:         If (iY > intMaxY) Then
1584:           iY = intMaxY
1585:         End If
        
        ' DETERMINE QUADRANT AND SPECIAL CASES (I.E. AT EDGE OR CORNER)
1588:         dblXRemainder = (nX - iX) * dblCellSizeX
1589:         dblYRemainder = (nY - iY) * dblCellSizeY
        
1591:         If dblYRemainder < dblHalfCellY Then                  ' ON NORTH SIDE OF CELL, SOUTH HALF OF PIXEL BLOCK
1592:           dblPropY = (dblYRemainder + dblHalfCellY) / dblCellSizeY
1593:           If dblXRemainder > dblHalfCellX Then                ' ON EAST SIDE OF CELL, WEST HALF OF PIXEL BLOCK
1594:             bytQuadrant = 1                                   ' ON NORTHEAST CORNER OF CELL, SOUTHWEST CORNER OF PIXEL BLOCK
1595:             dblPropX = 1 - ((dblXRemainder - dblHalfCellX) / dblCellSizeX)
1596:           Else                                                ' ON WEST SIDE OF CELL, EAST HALF OF PIXEL BLOCK
1597:             bytQuadrant = 2                                   ' ON NORTHWEST CORNER OF CELL, SOUTHEAST CORNER OF PIXEL BLOCK
1598:             dblPropX = (dblHalfCellX + dblXRemainder) / dblCellSizeX
1599:           End If
1600:         Else                                                  ' ON SOUTH SIDE OF CELL, NORTH HALF OF PIXEL BLOCK
1601:           dblPropY = 1 - ((dblYRemainder - dblHalfCellY) / dblCellSizeY)
1602:           If dblXRemainder > dblHalfCellX Then                ' ON EAST SIDE, WEST HALF OF PIXEL BLOCK
1603:             bytQuadrant = 4                                   ' ON SOUTHEAST CORNER OF CELL, NORTHWEST CORNER OF PIXEL BLOCK
1604:             dblPropX = 1 - ((dblXRemainder - dblHalfCellX) / dblCellSizeX)
1605:           Else                                                ' ON WEST SIDE OF CELL, EAST HALF OF PIXEL BLOCK
1606:             bytQuadrant = 3                                   ' ON SOUTHWEST CORNER OF CELL, NORTHEAST CORNER OF PIXEL BLOCK
1607:             dblPropX = (dblHalfCellX + dblXRemainder) / dblCellSizeX
1608:           End If
1609:         End If
        
        ' MAKE PIXEL BLOCK
1612:         Set pOrigin = New Pnt
        
        ' RETURN NULL IF AT EDGE OR CORNER AND NEED TO INTERPOLATE FROM OUTSIDE EXTENT
        ' REMEMBER RASTER INDICES START AT LEFT - TOP
1616:         booIsNull = False
        Select Case bytQuadrant
          Case 1              ' NORTHEAST                =================
                              '                          |   :   |   :   |
                              '                          - - - - - - - - -
                              '                          |   :   |   :   |
                              '                          =================
                              '                          |   : X |   :   |
                              '                          - - - - - - - - -
                              '                          |   :   |   :   |
                              '                          =================
1627:             If iX = intMaxX Or iY = 0 Then
1628:               booIsNull = True
1629:             Else
1630:               pOrigin.SetCoords iX, iY - 1
1631:               pRaster.Read pOrigin, pPB
1632:               vCellValueNW = pPB.GetVal(lngBandIndex, 0, 0)
1633:               vCellValueSW = pPB.GetVal(lngBandIndex, 0, 1)
1634:               vCellValueNE = pPB.GetVal(lngBandIndex, 1, 0)
1635:               vCellValueSE = pPB.GetVal(lngBandIndex, 1, 1)
1636:               If IsCellNaN(vCellValueNW) Or IsCellNaN(vCellValueNE) Or IsCellNaN(vCellValueSW) Or _
                IsCellNaN(vCellValueSE) Or IsEmpty(vCellValueNW) Or IsEmpty(vCellValueNE) Or _
                IsEmpty(vCellValueSW) Or IsEmpty(vCellValueSE) Then
1639:                     booIsNull = True
1640:               Else
1641:                 dblWestProp = (CDbl(vCellValueNW) * (1 - dblPropY)) + (CDbl(vCellValueSW) * dblPropY)
1642:                 dblEastProp = (CDbl(vCellValueNE) * (1 - dblPropY)) + (CDbl(vCellValueSE) * dblPropY)
1643:                 varInterpVal = CVar((dblWestProp * dblPropX) + (dblEastProp * (1 - dblPropX)))
1644:               End If
1645:             End If
          Case 2              ' NORTHWEST                =================
                              '                          |   :   |   :   |
                              '                          - - - - - - - - -
                              '                          |   :   |   :   |
                              '                          =================
                              '                          |   :   | X :   |
                              '                          - - - - - - - - -
                              '                          |   :   |   :   |
                              '                          =================
1655:             If iX = 0 Or iY = 0 Then
1656:               booIsNull = True
1657:             Else
1658:               pOrigin.SetCoords iX - 1, iY - 1
1659:               pRaster.Read pOrigin, pPB
1660:               vCellValueNW = pPB.GetVal(lngBandIndex, 0, 0)
1661:               vCellValueSW = pPB.GetVal(lngBandIndex, 0, 1)
1662:               vCellValueNE = pPB.GetVal(lngBandIndex, 1, 0)
1663:               vCellValueSE = pPB.GetVal(lngBandIndex, 1, 1)
1664:               If IsCellNaN(vCellValueNW) Or IsCellNaN(vCellValueNE) Or IsCellNaN(vCellValueSW) Or _
                IsCellNaN(vCellValueSE) Or IsEmpty(vCellValueNW) Or IsEmpty(vCellValueNE) Or _
                IsEmpty(vCellValueSW) Or IsEmpty(vCellValueSE) Then
1667:                     booIsNull = True
1668:               Else
1669:                 dblWestProp = (CDbl(vCellValueNW) * (1 - dblPropY)) + (CDbl(vCellValueSW) * dblPropY)
1670:                 dblEastProp = (CDbl(vCellValueNE) * (1 - dblPropY)) + (CDbl(vCellValueSE) * dblPropY)
1671:                 varInterpVal = CVar((dblWestProp * (1 - dblPropX)) + (dblEastProp * dblPropX))
1672:               End If
1673:             End If
          Case 3              ' SOUTHWEST                =================
                              '                          |   :   |   :   |
                              '                          - - - - - - - - -
                              '                          |   :   | X :   |
                              '                          =================
                              '                          |   :   |   :   |
                              '                          - - - - - - - - -
                              '                          |   :   |   :   |
                              '                          =================
1683:             If iX = 0 Or iY = intMaxY Then
1684:               booIsNull = True
1685:             Else
1686:               pOrigin.SetCoords iX - 1, iY
1687:               pRaster.Read pOrigin, pPB
1688:               vCellValueNW = pPB.GetVal(lngBandIndex, 0, 0)
1689:               vCellValueSW = pPB.GetVal(lngBandIndex, 0, 1)
1690:               vCellValueNE = pPB.GetVal(lngBandIndex, 1, 0)
1691:               vCellValueSE = pPB.GetVal(lngBandIndex, 1, 1)
1692:               If IsCellNaN(vCellValueNW) Or IsCellNaN(vCellValueNE) Or IsCellNaN(vCellValueSW) Or _
                IsCellNaN(vCellValueSE) Or IsEmpty(vCellValueNW) Or IsEmpty(vCellValueNE) Or _
                IsEmpty(vCellValueSW) Or IsEmpty(vCellValueSE) Then
1695:                     booIsNull = True
1696:               Else
1697:                 dblWestProp = (CDbl(vCellValueNW) * dblPropY) + (CDbl(vCellValueSW) * (1 - dblPropY))
1698:                 dblEastProp = (CDbl(vCellValueNE) * dblPropY) + (CDbl(vCellValueSE) * (1 - dblPropY))
1699:                 varInterpVal = CVar((dblWestProp * (1 - dblPropX)) + (dblEastProp * dblPropX))
1700:               End If
1701:             End If
          Case 4              ' SOUTHEAST                =================
                              '                          |   :   |   :   |
                              '                          - - - - - - - - -
                              '                          |   : X |   :   |
                              '                          =================
                              '                          |   :   |   :   |
                              '                          - - - - - - - - -
                              '                          |   :   |   :   |
                              '                          =================
1711:             If iX = intMaxX Or iY = intMaxY Then
1712:               booIsNull = True
1713:             Else
1714:               pOrigin.SetCoords iX, iY
1715:               pRaster.Read pOrigin, pPB
1716:               vCellValueNW = pPB.GetVal(lngBandIndex, 0, 0)
1717:               vCellValueSW = pPB.GetVal(lngBandIndex, 0, 1)
1718:               vCellValueNE = pPB.GetVal(lngBandIndex, 1, 0)
1719:               vCellValueSE = pPB.GetVal(lngBandIndex, 1, 1)
1720:               If IsCellNaN(vCellValueNW) Or IsCellNaN(vCellValueNE) Or IsCellNaN(vCellValueSW) Or _
                IsCellNaN(vCellValueSE) Or IsEmpty(vCellValueNW) Or IsEmpty(vCellValueNE) Or _
                IsEmpty(vCellValueSW) Or IsEmpty(vCellValueSE) Then
1723:                     booIsNull = True
1724:               Else
1725:                 dblWestProp = (CDbl(vCellValueNW) * dblPropY) + (CDbl(vCellValueSW) * (1 - dblPropY))
1726:                 dblEastProp = (CDbl(vCellValueNE) * dblPropY) + (CDbl(vCellValueSE) * (1 - dblPropY))
1727:                 varInterpVal = CVar((dblWestProp * dblPropX) + (dblEastProp * (1 - dblPropX)))
1728:               End If
              
1730:             End If
1731:         End Select
        
1733:         If booIsNull Then
1734:           pOutArray.Add Null
'          varInterpVal = -9999
1736:         Else
1737:           pOutArray.Add CDbl(varInterpVal)
1738:         End If
        
'        Debug.Print "From CellValues4CellInterp function..." & vbCrLf & _
          "   dblPropX = " & CStr(dblPropX) & vbCrLf & _
          "   dblPropY = " & CStr(dblPropY) & vbCrLf & _
          "   Quadrant = " & CStr(bytQuadrant) & vbCrLf & _
          "   vCellValueNW = " & CStr(vCellValueNW) & vbCrLf & _
          "   vCellValueNE = " & CStr(vCellValueNE) & vbCrLf & _
          "   vCellValueSW = " & CStr(vCellValueSW) & vbCrLf & _
          "   vCellValueSE = " & CStr(vCellValueSE) & vbCrLf & _
          "   dblWestProp = " & CStr(dblWestProp) & vbCrLf & _
          "   dblEastProp = " & CStr(dblEastProp) & vbCrLf & _
          "   Interpolated Value = " & CStr(varInterpVal)
1751:       End If
1752:     Next lngIndex
1753:     Set CellValues4CellInterp_Mahal = pOutArray
    
  Exit Function
ErrorHandler:
  HandleError True, "CellValues4CellInterp_Mahal " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
'  MsgBox "lngBandIndex = " & CStr(lngBandIndex) & vbCrLf & _
         "Point X = " & CStr(pPoint.X) & vbCrLf & _
         "Point Y = " & CStr(pPoint.Y) & vbCrLf & _
         "Point index = " & CStr(lngIndex) & vbCrLf & _
         "Raster Width = " & CStr(dWidth) & vbCrLf & _
         "Raster Height = " & CStr(dHeight)

End Function

Public Function CellValues_Mahal(pPoints As IPointCollection, pRaster As IRaster, _
    pThisExt As TopoCorridor.clsExtension, _
    lngRunningCount As Long, _
    lngTotalCount As Long, _
    dblCurrentPercent As Double, _
    booShouldStop As Boolean, _
    strReturn As String, _
    psbar As IStatusBar, _
    pPro As IStepProgressor, _
    theTimeBegan As Date, _
    lngTimer As Long, _
    Optional lngBandIndex As Long = 0) As esriSystem.IVariantArray
    
  On Error GoTo ErrorHandler

    ' SPECIAL CODE TO UPDATE PROGRESS METER
    Dim booShowProgress As Boolean
    Dim frmProgress As TopoCorridor.frmJenProgressMeter
1785:     Set frmProgress = pThisExt.ProgressMeterForm
1786:     booShowProgress = CBool(Not frmProgress Is Nothing)
    Dim dblCheckPercent As Double
    Dim dateRunningTime As Date
1789:     dateRunningTime = Now
    ' ---------------------------------------------------
    
    Dim pRP As IRasterProps
1793:     Set pRP = pRaster
    
    Dim dblCellSize As Double
1796:     dblCellSize = ReturnCellSize(pRaster)
    
    'Get extent
    Dim pExtent As IEnvelope
1800:     Set pExtent = pRP.Extent
    Dim X1 As Double, Y1 As Double, X2 As Double, Y2 As Double
1802:     pExtent.QueryCoords X1, Y1, X2, Y2
    
    'Get a PixelBloc with cellvalues
    Dim pPB As IPixelBlock3
    Dim dWidth As Double, dHeight As Double
1807:     dWidth = pRP.Width
1808:     dHeight = pRP.Height
  
    'Create a pnt to hold the PixelBlock size
    Dim pPnt As IPnt
1812:     Set pPnt = New Pnt
1813:     pPnt.SetCoords dWidth, dHeight
     
    'Create a point to set origin
    Dim pOrigin As IPnt
1817:     Set pOrigin = New Pnt
1818:     pOrigin.SetCoords 0, 0
     
    'Create and read entire grid into PixelBlock
1821:     Set pPB = pRaster.CreatePixelBlock(pPnt)
1822:     pRaster.Read pOrigin, pPB
    
    Dim lngIndex As Long
    Dim dblCellValue As Double
    Dim pPoint As IPoint
    Dim dx As Double, dy As Double
    Dim nX As Double, nY As Double
    Dim iX As Long, iY As Long
    
    Dim pOutArray As esriSystem.IVariantArray
1832:     Set pOutArray = New esriSystem.VarArray
    
    Dim vCellValue As Variant
    
1836:     For lngIndex = 0 To pPoints.PointCount - 1
    
      ' SPECIAL CODE TO UPDATE PROGRESS METER
1839:       If booShowProgress Then
1840:         lngRunningCount = lngRunningCount + 1
1841:         dblCheckPercent = Round(lngRunningCount / lngTotalCount, 3)
1842:         If (dblCheckPercent > dblCurrentPercent) Or DateDiff("s", dateRunningTime, Now) >= 1 Then
1843:           dateRunningTime = Now
1844:           dblCurrentPercent = dblCheckPercent
1845:           frmProgress.Est_Time_Left_Short lngRunningCount, _
              "Extracting Grid Cell Values [Sampling " & CStr(Format(pPoints.PointCount, "#,##0")) & " points]...", lngTotalCount
1847:           frmProgress.Refresh
1848:           frmProgress.icnProgressLineShort.Refresh
1849:           frmProgress.icnProgressLine.Refresh
1850:           If Not frmProgress.ShouldContinue Then
      
           ' ********************************************************************************************
            ' ALTERNATIVE CODE THAT SAVES PARTIAL TABLE, CHECKS IF ERRORS FOUND AND OUTPUTS RTF INSTEAD OF TEXT
      
1855:             strReturn = "-----------------------------------------\par" & vbCrLf & _
              "NOTE:  Exited Function Prematurely at Step " & CStr(lngTimer) & "\par" & vbCrLf & _
              "-----------------------------------------\par" & vbCrLf & _
              "\pard\qc " & TopoCorridor.MyGeneralOperations.ReturnTimeElapsedRTF(theTimeBegan, Now, 7) & vbCrLf & "}"
      
           ' ********************************************************************************************
      
1862:             frmProgress.cmdStop.Caption = "Close"
1863:             pPro.position = 0
1864:             psbar.HideProgressBar
1865:             booShouldStop = True
            Exit Function
1867:           End If
1868:         End If
1869:       End If
      ' ---------------------------------------------------
      
1872:       Set pPoint = pPoints.Point(lngIndex)
      ' RETURN NULL IF OUTSIDE EXTENT
1874:       If pPoint.X < X1 Or pPoint.X > X2 Or pPoint.Y < Y1 Or pPoint.Y > Y2 Then
1875:         pOutArray.Add Null
1876:       Else
    
1878:         dx = pPoint.X - X1
1879:         dy = Y2 - pPoint.Y
        
        'Find ncells from left-top
1882:         nX = dx / dblCellSize
1883:         nY = dy / dblCellSize
        
        'Determine cell index by taking the int. It will also take care of the fact that the index is 0 based
1886:         iX = Int(nX)
1887:         iY = Int(nY)
        
1889:         If (iX < 0) Then iX = 0
1890:         If (iY < 0) Then iY = 0
1891:         If (iX > pRP.Width - 1) Then
1892:           iX = pRP.Width - 1
1893:         End If
1894:         If (iY > pRP.Height - 1) Then
1895:           iY = pRP.Height - 1
1896:         End If
        
        'Read cell values
1899:         vCellValue = pPB.GetVal(lngBandIndex, iX, iY)
1900:         Debug.Print "From CellValues function..." & vCellValue
1901:         If IsEmpty(vCellValue) Then
1902:           pOutArray.Add Null
1903:         Else
1904:           pOutArray.Add CDbl(vCellValue)
1905:         End If
1906:       End If
1907:     Next lngIndex
1908:     Set CellValues_Mahal = pOutArray
    

  Exit Function
ErrorHandler:
  HandleError True, "CellValues_Mahal " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function CellValues2_Mahal(pPoints As IPointCollection, pRaster As IRaster, _
    pThisExt As TopoCorridor.clsExtension, _
    lngRunningCount As Long, _
    lngTotalCount As Long, _
    dblCurrentPercent As Double, _
    booShouldStop As Boolean, _
    strReturn As String, _
    psbar As IStatusBar, _
    pPro As IStepProgressor, _
    theTimeBegan As Date, _
    lngTimer As Long, _
    Optional lngBandIndex As Long = 0) As esriSystem.IVariantArray
    
   On Error GoTo ErrorHandler

    ' SPECIAL CODE TO UPDATE PROGRESS METER
    Dim booShowProgress As Boolean
    Dim frmProgress As TopoCorridor.frmJenProgressMeter
1934:     Set frmProgress = pThisExt.ProgressMeterForm
1935:     booShowProgress = CBool(Not frmProgress Is Nothing)
    Dim dblCheckPercent As Double
    Dim dateRunningTime As Date
1938:     dateRunningTime = Now
    ' ---------------------------------------------------
    

     ' ASSUMES POINTS ARE IN SAME PROJECTION AS RASTER
    Dim pRP As IRasterProps
1944:     Set pRP = pRaster
    
    Dim dblCellSizeX As Double
    Dim dblCellSizeY As Double
1948:     dblCellSizeX = ReturnPixelWidth(pRaster)
1949:     dblCellSizeY = ReturnPixelHeight(pRaster)
    
    Dim dblHalfCellX As Double
1952:     dblHalfCellX = dblCellSizeX / 2
    Dim dblHalfCellY As Double
1954:     dblHalfCellY = dblCellSizeY / 2
    
    'Get extent
    Dim pExtent As IEnvelope
1958:     Set pExtent = pRP.Extent
    Dim X1 As Double, Y1 As Double, X2 As Double, Y2 As Double
1960:     pExtent.QueryCoords X1, Y1, X2, Y2
    
    'Get a PixelBloc with cellvalues
    Dim pPB As IPixelBlock3
    
    Dim dWidth As Double, dHeight As Double
1966:     dWidth = pRP.Width
1967:     dHeight = pRP.Height
  
    'Create a pnt to hold the 2x2 PixelBlock size
    Dim pPnt As IPnt
1971:     Set pPnt = New Pnt
1972:     pPnt.SetCoords 1, 1
1973:     Set pPB = pRaster.CreatePixelBlock(pPnt)
     
    'Create a point to set origin
    Dim pOrigin As IPnt
    
    Dim lngIndex As Long
    Dim dblCellValue As Double
    Dim pPoint As IPoint
    Dim dx As Double, dy As Double
    Dim nX As Double, nY As Double
    Dim dblXRemainder As Double, dblYRemainder As Double
    Dim iX As Long, iY As Long
    Dim intMaxX As Integer, intMaxY As Integer
    
1987:     intMaxX = pRP.Width - 1
1988:     intMaxY = pRP.Height - 1
        
    ' BELOW FOR INTERPOLATION PURPOSES; USED TO CALCULATE THE WEIGHT OF THE PRIMARY CELL VS. THE ADJACENT CELLS.
    Dim dblPropX As Double
    Dim dblPropY As Double
    
    Dim pOutArray As esriSystem.IVariantArray
1995:     Set pOutArray = New esriSystem.VarArray
    
    ' MAKE PIXEL BLOCK
1998:     Set pOrigin = New Pnt
    
    Dim vCellValue As Variant
    Dim booIsNull As Boolean
    
2003:     For lngIndex = 0 To pPoints.PointCount - 1
    
      ' SPECIAL CODE TO UPDATE PROGRESS METER
2006:       If booShowProgress Then
2007:         lngRunningCount = lngRunningCount + 1
2008:         dblCheckPercent = Round(lngRunningCount / lngTotalCount, 3)
2009:         If (dblCheckPercent > dblCurrentPercent) Or DateDiff("s", dateRunningTime, Now) >= 1 Then
2010:           dateRunningTime = Now
2011:           dblCurrentPercent = dblCheckPercent
2012:           frmProgress.Est_Time_Left_Short lngRunningCount, _
              "Extracting Grid Cell Values [Sampling " & CStr(Format(pPoints.PointCount, "#,##0")) & " points]...", lngTotalCount
2014:           frmProgress.Refresh
2015:           frmProgress.icnProgressLineShort.Refresh
2016:           frmProgress.icnProgressLine.Refresh
2017:           If Not frmProgress.ShouldContinue Then
      
           ' ********************************************************************************************
            ' ALTERNATIVE CODE THAT SAVES PARTIAL TABLE, CHECKS IF ERRORS FOUND AND OUTPUTS RTF INSTEAD OF TEXT
      
2022:             strReturn = "-----------------------------------------\par" & vbCrLf & _
              "NOTE:  Exited Function Prematurely at Step " & CStr(lngTimer) & "\par" & vbCrLf & _
              "-----------------------------------------\par" & vbCrLf & _
              "\pard\qc " & TopoCorridor.MyGeneralOperations.ReturnTimeElapsedRTF(theTimeBegan, Now, 7) & vbCrLf & "}"
      
           ' ********************************************************************************************
      
2029:             frmProgress.cmdStop.Caption = "Close"
2030:             pPro.position = 0
2031:             psbar.HideProgressBar
2032:             booShouldStop = True
            Exit Function
2034:           End If
2035:         End If
2036:       End If
      ' ---------------------------------------------------
      
2039:       Set pPoint = pPoints.Point(lngIndex)
      
      ' RETURN NULL IF OUTSIDE EXTENT
2042:       If pPoint.X < X1 Or pPoint.X > X2 Or pPoint.Y < Y1 Or pPoint.Y > Y2 Then
2043:         pOutArray.Add Null
2044:       Else
        
2046:         dx = pPoint.X - X1
2047:         dy = Y2 - pPoint.Y
        
        'Find ncells from left-top
2050:         nX = dx / dblCellSizeX
2051:         nY = dy / dblCellSizeY
        
        'Determine cell index by taking the int. It will also take care of the fact that the index is 0 based
2054:         iX = Int(nX)
2055:         iY = Int(nY)
        
        ' FOLLOWING IN CASE OF ROUNDING ERROR
2058:         If (iX < 0) Then iX = 0
2059:         If (iY < 0) Then iY = 0
2060:         If (iX > intMaxX) Then
2061:           iX = intMaxX
2062:         End If
2063:         If (iY > intMaxY) Then
2064:           iY = intMaxY
2065:         End If
        
2067:         booIsNull = False

2069:         If iX > intMaxX Or iY < 0 Then
2070:           booIsNull = True
2071:         Else
2072:           pOrigin.SetCoords iX, iY
2073:           pRaster.Read pOrigin, pPB
2074:           vCellValue = pPB.GetVal(lngBandIndex, 0, 0)
2075:           If IsCellNaN(vCellValue) Or IsEmpty(vCellValue) Then
2076:             booIsNull = True
2077:           End If
2078:         End If
        
2080:         If booIsNull Then
2081:           pOutArray.Add Null
'          varInterpVal = -9999
2083:         Else
2084:           pOutArray.Add CDbl(vCellValue)
2085:         End If
        
'        Debug.Print "From CellValues4CellInterp function..." & vbCrLf & _
          "   dblPropX = " & CStr(dblPropX) & vbCrLf & _
          "   dblPropY = " & CStr(dblPropY) & vbCrLf & _
          "   Quadrant = " & CStr(bytQuadrant) & vbCrLf & _
          "   vCellValueNW = " & CStr(vCellValueNW) & vbCrLf & _
          "   vCellValueNE = " & CStr(vCellValueNE) & vbCrLf & _
          "   vCellValueSW = " & CStr(vCellValueSW) & vbCrLf & _
          "   vCellValueSE = " & CStr(vCellValueSE) & vbCrLf & _
          "   dblWestProp = " & CStr(dblWestProp) & vbCrLf & _
          "   dblEastProp = " & CStr(dblEastProp) & vbCrLf & _
          "   Interpolated Value = " & CStr(varInterpVal)
2098:       End If
2099:     Next lngIndex
2100:     Set CellValues2_Mahal = pOutArray
    
  Exit Function
ErrorHandler:
   HandleError True, "CellValues2_Mahal " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function


Private Function IsCellNaN(expression As Variant) As Boolean
  On Error GoTo ErrorHandler

  On Error Resume Next
2112:   If Not IsNumeric(expression) Then
2113:     IsCellNaN = False
    Exit Function
2115:   End If
2116:   If (CStr(expression) = "-1.#QNAN") Or (CStr(expression) = "1,#QNAN") Then ' can vary by locale
2117:     IsCellNaN = True
2118:   Else
2119:     IsCellNaN = False
2120:   End If

  Exit Function
ErrorHandler:
  HandleError False, "IsCellNaN " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function
Public Function CellValues4CellInterp(pPoints As IPointCollection, pRaster As IRaster, _
    Optional lngBandIndex As Long = 0) As esriSystem.IVariantArray
  On Error GoTo ErrorHandler

    
    ' ASSUMES POINTS ARE IN SAME PROJECTION AS RASTER
    Dim pRP As IRasterProps
2133:     Set pRP = pRaster
    
    Dim dblCellSizeX As Double
    Dim dblCellSizeY As Double
2137:     dblCellSizeX = ReturnPixelWidth(pRaster)
2138:     dblCellSizeY = ReturnPixelHeight(pRaster)
    
    Dim dblHalfCellX As Double
2141:     dblHalfCellX = dblCellSizeX / 2
    Dim dblHalfCellY As Double
2143:     dblHalfCellY = dblCellSizeY / 2
    
    'Get extent
    Dim pExtent As IEnvelope
2147:     Set pExtent = pRP.Extent
    Dim X1 As Double, Y1 As Double, X2 As Double, Y2 As Double
2149:     pExtent.QueryCoords X1, Y1, X2, Y2
    
    'Get a PixelBloc with cellvalues
    Dim pPB As IPixelBlock3
    
    Dim dWidth As Double, dHeight As Double
2155:     dWidth = pRP.Width
2156:     dHeight = pRP.Height
  
    'Create a pnt to hold the 2x2 PixelBlock size
    Dim pPnt As IPnt
2160:     Set pPnt = New Pnt
2161:     pPnt.SetCoords 2, 2
2162:     Set pPB = pRaster.CreatePixelBlock(pPnt)
     
    'Create a point to set origin
    Dim pOrigin As IPnt
    
    Dim lngIndex As Long
    Dim dblCellValue As Double
    Dim pPoint As IPoint
    Dim dx As Double, dy As Double
    Dim nX As Double, nY As Double
    Dim dblXRemainder As Double, dblYRemainder As Double
    Dim iX As Long, iY As Long
    Dim intMaxX As Integer, intMaxY As Integer
    
2176:     intMaxX = pRP.Width - 1
2177:     intMaxY = pRP.Height - 1
    
    Dim bytQuadrant As Byte       ' 1 FOR NE, 2 FOR NW, 3 FOR SW, 4 FOR SE
    Dim varInterpVal As Variant
    
    ' BELOW FOR INTERPOLATION PURPOSES; USED TO CALCULATE THE WEIGHT OF THE PRIMARY CELL VS. THE ADJACENT CELLS.
    Dim dblPropX As Double
    Dim dblPropY As Double
    
    Dim pOutArray As esriSystem.IVariantArray
2187:     Set pOutArray = New esriSystem.VarArray
    
    Dim vCellValueNE As Variant
    Dim vCellValueNW As Variant
    Dim vCellValueSE As Variant
    Dim vCellValueSW As Variant
    
    Dim booIsNull As Boolean
    Dim dblWestProp As Double
    Dim dblEastProp As Double
    
2198:     For lngIndex = 0 To pPoints.PointCount - 1
2199:       Set pPoint = pPoints.Point(lngIndex)
      
      ' RETURN NULL IF OUTSIDE EXTENT
2202:       If pPoint.X < X1 Or pPoint.X > X2 Or pPoint.Y < Y1 Or pPoint.Y > Y2 Then
2203:         pOutArray.Add Null
2204:       Else
        
2206:         dx = pPoint.X - X1
2207:         dy = Y2 - pPoint.Y
        
        'Find ncells from left-top
2210:         nX = dx / dblCellSizeX
2211:         nY = dy / dblCellSizeY
        
        'Determine cell index by taking the int. It will also take care of the fact that the index is 0 based
2214:         iX = Int(nX)
2215:         iY = Int(nY)
        
        ' FOLLOWING IN CASE OF ROUNDING ERROR
2218:         If (iX < 0) Then iX = 0
2219:         If (iY < 0) Then iY = 0
2220:         If (iX > intMaxX) Then
2221:           iX = intMaxX
2222:         End If
2223:         If (iY > intMaxY) Then
2224:           iY = intMaxY
2225:         End If
        
        ' DETERMINE QUADRANT AND SPECIAL CASES (I.E. AT EDGE OR CORNER)
2228:         dblXRemainder = (nX - iX) * dblCellSizeX
2229:         dblYRemainder = (nY - iY) * dblCellSizeY
        
2231:         If dblYRemainder < dblHalfCellY Then                  ' ON NORTH SIDE OF CELL, SOUTH HALF OF PIXEL BLOCK
2232:           dblPropY = (dblYRemainder + dblHalfCellY) / dblCellSizeY
2233:           If dblXRemainder > dblHalfCellX Then                ' ON EAST SIDE OF CELL, WEST HALF OF PIXEL BLOCK
2234:             bytQuadrant = 1                                   ' ON NORTHEAST CORNER OF CELL, SOUTHWEST CORNER OF PIXEL BLOCK
2235:             dblPropX = 1 - ((dblXRemainder - dblHalfCellX) / dblCellSizeX)
2236:           Else                                                ' ON WEST SIDE OF CELL, EAST HALF OF PIXEL BLOCK
2237:             bytQuadrant = 2                                   ' ON NORTHWEST CORNER OF CELL, SOUTHEAST CORNER OF PIXEL BLOCK
2238:             dblPropX = (dblHalfCellX + dblXRemainder) / dblCellSizeX
2239:           End If
2240:         Else                                                  ' ON SOUTH SIDE OF CELL, NORTH HALF OF PIXEL BLOCK
2241:           dblPropY = 1 - ((dblYRemainder - dblHalfCellY) / dblCellSizeY)
2242:           If dblXRemainder > dblHalfCellX Then                ' ON EAST SIDE, WEST HALF OF PIXEL BLOCK
2243:             bytQuadrant = 4                                   ' ON SOUTHEAST CORNER OF CELL, NORTHWEST CORNER OF PIXEL BLOCK
2244:             dblPropX = 1 - ((dblXRemainder - dblHalfCellX) / dblCellSizeX)
2245:           Else                                                ' ON WEST SIDE OF CELL, EAST HALF OF PIXEL BLOCK
2246:             bytQuadrant = 3                                   ' ON SOUTHWEST CORNER OF CELL, NORTHEAST CORNER OF PIXEL BLOCK
2247:             dblPropX = (dblHalfCellX + dblXRemainder) / dblCellSizeX
2248:           End If
2249:         End If
        
        ' MAKE PIXEL BLOCK
2252:         Set pOrigin = New Pnt
        
        ' RETURN NULL IF AT EDGE OR CORNER AND NEED TO INTERPOLATE FROM OUTSIDE EXTENT
        ' REMEMBER RASTER INDICES START AT LEFT - TOP
2256:         booIsNull = False
        Select Case bytQuadrant
          Case 1              ' NORTHEAST                =================
                              '                          |   :   |   :   |
                              '                          - - - - - - - - -
                              '                          |   :   |   :   |
                              '                          =================
                              '                          |   : X |   :   |
                              '                          - - - - - - - - -
                              '                          |   :   |   :   |
                              '                          =================
2267:             If iX = intMaxX Or iY = 0 Then
2268:               booIsNull = True
2269:             Else
2270:               pOrigin.SetCoords iX, iY - 1
2271:               pRaster.Read pOrigin, pPB
2272:               vCellValueNW = pPB.GetVal(lngBandIndex, 0, 0)
2273:               vCellValueSW = pPB.GetVal(lngBandIndex, 0, 1)
2274:               vCellValueNE = pPB.GetVal(lngBandIndex, 1, 0)
2275:               vCellValueSE = pPB.GetVal(lngBandIndex, 1, 1)
2276:               If IsCellNaN(vCellValueNW) Or IsCellNaN(vCellValueNE) Or IsCellNaN(vCellValueSW) Or _
                IsCellNaN(vCellValueSE) Or IsEmpty(vCellValueNW) Or IsEmpty(vCellValueNE) Or _
                IsEmpty(vCellValueSW) Or IsEmpty(vCellValueSE) Then
2279:                     booIsNull = True
2280:               Else
2281:                 dblWestProp = (CDbl(vCellValueNW) * (1 - dblPropY)) + (CDbl(vCellValueSW) * dblPropY)
2282:                 dblEastProp = (CDbl(vCellValueNE) * (1 - dblPropY)) + (CDbl(vCellValueSE) * dblPropY)
2283:                 varInterpVal = CVar((dblWestProp * dblPropX) + (dblEastProp * (1 - dblPropX)))
2284:               End If
2285:             End If
          Case 2              ' NORTHWEST                =================
                              '                          |   :   |   :   |
                              '                          - - - - - - - - -
                              '                          |   :   |   :   |
                              '                          =================
                              '                          |   :   | X :   |
                              '                          - - - - - - - - -
                              '                          |   :   |   :   |
                              '                          =================
2295:             If iX = 0 Or iY = 0 Then
2296:               booIsNull = True
2297:             Else
2298:               pOrigin.SetCoords iX - 1, iY - 1
2299:               pRaster.Read pOrigin, pPB
2300:               vCellValueNW = pPB.GetVal(lngBandIndex, 0, 0)
2301:               vCellValueSW = pPB.GetVal(lngBandIndex, 0, 1)
2302:               vCellValueNE = pPB.GetVal(lngBandIndex, 1, 0)
2303:               vCellValueSE = pPB.GetVal(lngBandIndex, 1, 1)
2304:               If IsCellNaN(vCellValueNW) Or IsCellNaN(vCellValueNE) Or IsCellNaN(vCellValueSW) Or _
                IsCellNaN(vCellValueSE) Or IsEmpty(vCellValueNW) Or IsEmpty(vCellValueNE) Or _
                IsEmpty(vCellValueSW) Or IsEmpty(vCellValueSE) Then
2307:                     booIsNull = True
2308:               Else
2309:                 dblWestProp = (CDbl(vCellValueNW) * (1 - dblPropY)) + (CDbl(vCellValueSW) * dblPropY)
2310:                 dblEastProp = (CDbl(vCellValueNE) * (1 - dblPropY)) + (CDbl(vCellValueSE) * dblPropY)
2311:                 varInterpVal = CVar((dblWestProp * (1 - dblPropX)) + (dblEastProp * dblPropX))
2312:               End If
2313:             End If
          Case 3              ' SOUTHWEST                =================
                              '                          |   :   |   :   |
                              '                          - - - - - - - - -
                              '                          |   :   | X :   |
                              '                          =================
                              '                          |   :   |   :   |
                              '                          - - - - - - - - -
                              '                          |   :   |   :   |
                              '                          =================
2323:             If iX = 0 Or iY = intMaxY Then
2324:               booIsNull = True
2325:             Else
2326:               pOrigin.SetCoords iX - 1, iY
2327:               pRaster.Read pOrigin, pPB
2328:               vCellValueNW = pPB.GetVal(lngBandIndex, 0, 0)
2329:               vCellValueSW = pPB.GetVal(lngBandIndex, 0, 1)
2330:               vCellValueNE = pPB.GetVal(lngBandIndex, 1, 0)
2331:               vCellValueSE = pPB.GetVal(lngBandIndex, 1, 1)
2332:               If IsCellNaN(vCellValueNW) Or IsCellNaN(vCellValueNE) Or IsCellNaN(vCellValueSW) Or _
                IsCellNaN(vCellValueSE) Or IsEmpty(vCellValueNW) Or IsEmpty(vCellValueNE) Or _
                IsEmpty(vCellValueSW) Or IsEmpty(vCellValueSE) Then
2335:                     booIsNull = True
2336:               Else
2337:                 dblWestProp = (CDbl(vCellValueNW) * dblPropY) + (CDbl(vCellValueSW) * (1 - dblPropY))
2338:                 dblEastProp = (CDbl(vCellValueNE) * dblPropY) + (CDbl(vCellValueSE) * (1 - dblPropY))
2339:                 varInterpVal = CVar((dblWestProp * (1 - dblPropX)) + (dblEastProp * dblPropX))
2340:               End If
2341:             End If
          Case 4              ' SOUTHEAST                =================
                              '                          |   :   |   :   |
                              '                          - - - - - - - - -
                              '                          |   : X |   :   |
                              '                          =================
                              '                          |   :   |   :   |
                              '                          - - - - - - - - -
                              '                          |   :   |   :   |
                              '                          =================
2351:             If iX = intMaxX Or iY = intMaxY Then
2352:               booIsNull = True
2353:             Else
2354:               pOrigin.SetCoords iX, iY
2355:               pRaster.Read pOrigin, pPB
2356:               vCellValueNW = pPB.GetVal(lngBandIndex, 0, 0)
2357:               vCellValueSW = pPB.GetVal(lngBandIndex, 0, 1)
2358:               vCellValueNE = pPB.GetVal(lngBandIndex, 1, 0)
2359:               vCellValueSE = pPB.GetVal(lngBandIndex, 1, 1)
2360:               If IsCellNaN(vCellValueNW) Or IsCellNaN(vCellValueNE) Or IsCellNaN(vCellValueSW) Or _
                IsCellNaN(vCellValueSE) Or IsEmpty(vCellValueNW) Or IsEmpty(vCellValueNE) Or _
                IsEmpty(vCellValueSW) Or IsEmpty(vCellValueSE) Then
2363:                     booIsNull = True
2364:               Else
2365:                 dblWestProp = (CDbl(vCellValueNW) * dblPropY) + (CDbl(vCellValueSW) * (1 - dblPropY))
2366:                 dblEastProp = (CDbl(vCellValueNE) * dblPropY) + (CDbl(vCellValueSE) * (1 - dblPropY))
2367:                 varInterpVal = CVar((dblWestProp * dblPropX) + (dblEastProp * (1 - dblPropX)))
2368:               End If
              
2370:             End If
2371:         End Select
        
2373:         If booIsNull Then
2374:           pOutArray.Add Null
'          varInterpVal = -9999
2376:         Else
2377:           pOutArray.Add CDbl(varInterpVal)
2378:         End If
        
'        Debug.Print "From CellValues4CellInterp function..." & vbCrLf & _
          "   dblPropX = " & CStr(dblPropX) & vbCrLf & _
          "   dblPropY = " & CStr(dblPropY) & vbCrLf & _
          "   Quadrant = " & CStr(bytQuadrant) & vbCrLf & _
          "   vCellValueNW = " & CStr(vCellValueNW) & vbCrLf & _
          "   vCellValueNE = " & CStr(vCellValueNE) & vbCrLf & _
          "   vCellValueSW = " & CStr(vCellValueSW) & vbCrLf & _
          "   vCellValueSE = " & CStr(vCellValueSE) & vbCrLf & _
          "   dblWestProp = " & CStr(dblWestProp) & vbCrLf & _
          "   dblEastProp = " & CStr(dblEastProp) & vbCrLf & _
          "   Interpolated Value = " & CStr(varInterpVal)
2391:       End If
2392:     Next lngIndex
2393:     Set CellValues4CellInterp = pOutArray
    

  Exit Function
ErrorHandler:
  HandleError True, "CellValues4CellInterp " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function CellValues2(pPoints As IPointCollection, pRaster As IRaster, _
        Optional lngBandIndex As Long = 0) As esriSystem.IVariantArray
  On Error GoTo ErrorHandler


     ' ASSUMES POINTS ARE IN SAME PROJECTION AS RASTER
    Dim pRP As IRasterProps
2408:     Set pRP = pRaster
    
    Dim dblCellSizeX As Double
    Dim dblCellSizeY As Double
2412:     dblCellSizeX = ReturnPixelWidth(pRaster)
2413:     dblCellSizeY = ReturnPixelHeight(pRaster)
    
    Dim dblHalfCellX As Double
2416:     dblHalfCellX = dblCellSizeX / 2
    Dim dblHalfCellY As Double
2418:     dblHalfCellY = dblCellSizeY / 2
    
    'Get extent
    Dim pExtent As IEnvelope
2422:     Set pExtent = pRP.Extent
    Dim X1 As Double, Y1 As Double, X2 As Double, Y2 As Double
2424:     pExtent.QueryCoords X1, Y1, X2, Y2
    
    'Get a PixelBloc with cellvalues
    Dim pPB As IPixelBlock3
    
    Dim dWidth As Double, dHeight As Double
2430:     dWidth = pRP.Width
2431:     dHeight = pRP.Height
  
    'Create a pnt to hold the 2x2 PixelBlock size
    Dim pPnt As IPnt
2435:     Set pPnt = New Pnt
2436:     pPnt.SetCoords 1, 1
2437:     Set pPB = pRaster.CreatePixelBlock(pPnt)
     
    'Create a point to set origin
    Dim pOrigin As IPnt
    
    Dim lngIndex As Long
    Dim dblCellValue As Double
    Dim pPoint As IPoint
    Dim dx As Double, dy As Double
    Dim nX As Double, nY As Double
    Dim dblXRemainder As Double, dblYRemainder As Double
    Dim iX As Long, iY As Long
    Dim intMaxX As Integer, intMaxY As Integer
    
2451:     intMaxX = pRP.Width - 1
2452:     intMaxY = pRP.Height - 1
        
    ' BELOW FOR INTERPOLATION PURPOSES; USED TO CALCULATE THE WEIGHT OF THE PRIMARY CELL VS. THE ADJACENT CELLS.
    Dim dblPropX As Double
    Dim dblPropY As Double
    
    Dim pOutArray As esriSystem.IVariantArray
2459:     Set pOutArray = New esriSystem.VarArray
    
    ' MAKE PIXEL BLOCK
2462:     Set pOrigin = New Pnt
    
    Dim vCellValue As Variant
    Dim booIsNull As Boolean
        
2467:     For lngIndex = 0 To pPoints.PointCount - 1
2468:       Set pPoint = pPoints.Point(lngIndex)
      
  '    MsgBox "Raster Extent:  X = " & CStr(Format(X1, "0.000")) & " to " & CStr(Format(X2, "0.000")) & vbCrLf & _
           "                Y = " & CStr(Format(Y1, "0.000")) & " to " & CStr(Format(Y2, "0.000")) & vbCrLf & _
           "Point Coordinates:  X = " & CStr(Format(pPoint.X, "0.000")) & ", Y = " & CStr(Format(pPoint.Y, "0.000"))
      
      ' RETURN NULL IF OUTSIDE EXTENT
2475:       If pPoint.X < X1 Or pPoint.X > X2 Or pPoint.Y < Y1 Or pPoint.Y > Y2 Then
2476:         pOutArray.Add Null
2477:       Else
        
2479:         dx = pPoint.X - X1
2480:         dy = Y2 - pPoint.Y
        
        'Find ncells from left-top
2483:         nX = dx / dblCellSizeX
2484:         nY = dy / dblCellSizeY
        
        'Determine cell index by taking the int. It will also take care of the fact that the index is 0 based
2487:         iX = Int(nX)
2488:         iY = Int(nY)
        
        ' FOLLOWING IN CASE OF ROUNDING ERROR
2491:         If (iX < 0) Then iX = 0
2492:         If (iY < 0) Then iY = 0
2493:         If (iX > intMaxX) Then
2494:           iX = intMaxX
2495:         End If
2496:         If (iY > intMaxY) Then
2497:           iY = intMaxY
2498:         End If
        
2500:         booIsNull = False

2502:         If iX > intMaxX Or iY < 0 Then
2503:           booIsNull = True
2504:         Else
2505:           pOrigin.SetCoords iX, iY
2506:           pRaster.Read pOrigin, pPB
2507:           vCellValue = pPB.GetVal(lngBandIndex, 0, 0)
2508:           If IsCellNaN(vCellValue) Or IsEmpty(vCellValue) Then
2509:             booIsNull = True
2510:           End If
2511:         End If
        
2513:         If booIsNull Then
2514:           pOutArray.Add Null
'          varInterpVal = -9999
2516:         Else
2517:           pOutArray.Add CDbl(vCellValue)
2518:         End If
        
'        Debug.Print "From CellValues4CellInterp function..." & vbCrLf & _
          "   dblPropX = " & CStr(dblPropX) & vbCrLf & _
          "   dblPropY = " & CStr(dblPropY) & vbCrLf & _
          "   Quadrant = " & CStr(bytQuadrant) & vbCrLf & _
          "   vCellValueNW = " & CStr(vCellValueNW) & vbCrLf & _
          "   vCellValueNE = " & CStr(vCellValueNE) & vbCrLf & _
          "   vCellValueSW = " & CStr(vCellValueSW) & vbCrLf & _
          "   vCellValueSE = " & CStr(vCellValueSE) & vbCrLf & _
          "   dblWestProp = " & CStr(dblWestProp) & vbCrLf & _
          "   dblEastProp = " & CStr(dblEastProp) & vbCrLf & _
          "   Interpolated Value = " & CStr(varInterpVal)
2531:       End If
2532:     Next lngIndex
2533:     Set CellValues2 = pOutArray
    

  Exit Function
ErrorHandler:
  HandleError True, "CellValues2 " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function
