Attribute VB_Name = "LandFacetFunctions"
Option Explicit


Const c_sModuleFileName As String = "D:\arcGIS_stuff\consultation\brost_climate_change\code\LandFacetFunctions.bas"

Public Function CalcLandFacetTermini(pDocParams As esriSystem.IVariantArray, _
    pParams As esriSystem.IVariantArray) As String
  On Error GoTo ErrorHandler

  
  Dim strBaseString As String
12:   strBaseString = strBaseString & "{\rtf1\ansi\ansicpg1252\deff0\deflang1033{\fonttbl{\f0\fswiss\fcharset0 Arial;}{\f1\fnil\fcharset0 MS Sans Serif;}}" & vbNewLine
13:   strBaseString = strBaseString & "\viewkind4\uc1\pard\qc\f0\fs20 Termini Function Failed..." & vbNewLine
14:   strBaseString = strBaseString & "\par \pard\f1\fs17 " & vbNewLine
15:   strBaseString = strBaseString & "\par }" & vbNewLine
16:   strBaseString = strBaseString & " " & vbNewLine
  
18:   CalcLandFacetTermini = strBaseString
   
  Dim pApp As IApplication
  Dim pThisExt As TopoCorridor.clsExtension
  Dim pMxDoc As IMxDocument
  
24:   Set pApp = pDocParams.Element(0)
25:   Set pMxDoc = pDocParams.Element(1)
26:   Set pThisExt = pDocParams.Element(2)
  
  Dim psbar As IStatusBar
29:   Set psbar = pApp.StatusBar
  Dim pProg As IStepProgressor
31:   Set pProg = psbar.ProgressBar
'  Dim pPrgAnim As IAnimationProgressor
'  Set pPrgAnim = psbar.ProgressAnimation
  
  Dim lngIndex As Long
  Dim lngIndex2 As Long
  Dim lngIndex3 As Long
    
  ' RETURN ARRAY IS IVariantArray, CONTAINING:
  ' 0) IRasterBand: SELECTED DENSITY RASTER BAND
  ' 1) STRING: NAME OF SELECTED RASTER
  ' 2) IFeatureLayer: SELECTED HABITAT BLOCK POLYGON LAYER
  ' 3) STRING: NAME OF SELECTED FEATURE LAYER
  ' 4) LONG: SIZE THRESHOLD
  ' 5) STRING: FULL OUTPUT STRING FROM txtOutput
  ' 6) IWORKSPACE: OUTPUT WORKSPACE
  ' 7) PATH TO WORKSPACE
  ' 8) JUST FILENAME
  ' 9) DOUBLE: DATA THRESHOLD

  Dim pRastBand As IRasterBand
  Dim pRastDataset As IRasterDataset
  Dim strRasterName As String
  Dim pPolygonFLayer As IFeatureLayer
  Dim pPolygonFClass As IFeatureClass
  Dim pCursor As IFeatureCursor
  Dim pFeature As IFeature
  Dim strPolygonName As String
  Dim lngThreshold As Long
  Dim strFullOutput As String
  Dim strWS As String
  Dim pWS As IFeatureWorkspace
  Dim strFilename As String
  Dim dblDataThreshold As Double
  
66:   Set pRastBand = pParams.Element(0)
67:   Set pRastDataset = pRastBand.RasterDataset
68:   strRasterName = pParams.Element(1)
69:   Set pPolygonFLayer = pParams.Element(2)
70:   strPolygonName = pParams.Element(3)
71:   Set pPolygonFClass = pPolygonFLayer.FeatureClass
72:   lngThreshold = pParams.Element(4)
73:   strFullOutput = pParams.Element(5)
74:   Set pWS = pParams.Element(6)
75:   strWS = pParams.Element(7)
76:   strFilename = pParams.Element(8)
77:   dblDataThreshold = pParams.Element(9)
  
  Dim datTimeBegan As Date
80:   datTimeBegan = Now
  
  ' MAKE IN-MEMORY FEATURE CLASS OF POLYGONS IN CORRECT PROJECTION FOR MASK
  ' ALSO MAKE LIST OF TWO PROJECTED POLYGONS FOR LATER ANALYSIS
  Dim pMaskFClass As IFeatureClass
  Dim pPolygonArray As esriSystem.IArray
  Dim pPolygon As IPolygon
  Dim pRastSpRef As ISpatialReference
  Dim pPolySpRef As ISpatialReference
  Dim pGeoDataset As IGeoDataset
  Dim pPolygonEnvelope As IEnvelope
  
92:   Set pGeoDataset = pRastBand
93:   Set pRastSpRef = pGeoDataset.SpatialReference
  
95:   Set pGeoDataset = pPolygonFClass
96:   Set pPolySpRef = pGeoDataset.SpatialReference
  
98:   Set pCursor = pPolygonFClass.Search(Nothing, True)
99:   Set pFeature = pCursor.NextFeature
  
101:   Set pPolygonArray = New esriSystem.Array
102:   Do Until pFeature Is Nothing
103:     Set pPolygon = pFeature.ShapeCopy
104:     If Not TopoCorridor.MyGeneralOperations.CompareSpatialReferences(pPolySpRef, pRastSpRef) Then
105:       pPolygon.Project pRastSpRef
106:     End If
107:     pPolygonArray.Add pPolygon
108:     If pPolygonEnvelope Is Nothing Then
109:       Set pPolygonEnvelope = pPolygon.Envelope
110:     Else
111:       pPolygonEnvelope.Union pPolygon.Envelope
112:     End If
113:     Set pFeature = pCursor.NextFeature
114:   Loop
  
  
'  pPrgAnim.Show
'  pPrgAnim.Play
  
120:   psbar.ShowProgressBar "Projecting polygons from " & strPolygonName & "...", 0, 7, 1, True
121:   pProg.position = 0
122:   pProg.Step
123:   DoEvents
124:   Set pMaskFClass = TopoCorridor.MyGeneralOperations.CreateInMemoryFeatureClass(pPolygonArray)
  
  Dim pTempRaster As IRaster2
  
  Dim pLogOp As ILogicalOp
129:   Set pLogOp = New RasterMathOps
  Dim pLogAnEnv As IRasterAnalysisEnvironment
131:   Set pLogAnEnv = pLogOp
132:   pLogAnEnv.SetCellSize esriRasterEnvValue, pRastDataset
133:   pLogAnEnv.SetExtent esriRasterEnvValue, pRastDataset, pRastDataset
134:   Set pLogAnEnv.Mask = pMaskFClass
  
  Dim pConvOp As IConversionOp
137:   Set pConvOp = New RasterConversionOp
  Dim pConvAnEnv As IRasterAnalysisEnvironment
139:   Set pConvAnEnv = pConvOp
140:   pConvAnEnv.SetCellSize esriRasterEnvValue, pRastDataset
141:   pConvAnEnv.SetExtent esriRasterEnvValue, pRastDataset, pRastDataset
142:   Set pConvAnEnv.Mask = pMaskFClass
  
  Dim pMakerOp As IRasterMakerOp
145:   Set pMakerOp = New RasterMakerOp
  Dim pMakerAnEnv As IRasterAnalysisEnvironment
147:   Set pMakerAnEnv = pMakerOp
148:   pMakerAnEnv.SetCellSize esriRasterEnvValue, pRastDataset
149:   pMakerAnEnv.SetExtent esriRasterEnvValue, pRastDataset, pRastDataset
150:   Set pMakerAnEnv.OutSpatialReference = pRastSpRef
151:   Set pMakerAnEnv.Mask = pMaskFClass
  
153:   psbar.Message(0) = "Identifying regions from " & strRasterName & " with values > " & CStr(dblDataThreshold) & "..."
154:   pProg.Step
155:   DoEvents
  
  Dim pZeroDataset As IRasterDataset
158:   Set pTempRaster = pMakerOp.MakeConstant(dblDataThreshold, False)
159:   Set pZeroDataset = pTempRaster.RasterDataset
    
  Dim pDensGTOneDataset As IRasterDataset
162:   Set pTempRaster = pLogOp.GreaterThan(pRastDataset, pZeroDataset)
163:   Set pDensGTOneDataset = pTempRaster.RasterDataset
  
  Dim pPotentialFClass As IFeatureClass
  Dim pTempWS As IWorkspace
167:   Set pTempWS = pWS
  Dim strTempName As String
169:   strTempName = TopoCorridor.MyGeneralOperations.MakeUniqueShapeFilename(strWS & "\temp_polygons.shp")
 '  MsgBox strTempName
171:   strTempName = TopoCorridor.aml_func_mod.ReturnFilename(strTempName)
172:   psbar.Message(0) = "Extracting polygons from " & strRasterName & "..."
173:   pProg.Step
174:   DoEvents
  
176:   Set pPotentialFClass = pConvOp.RasterDataToPolygonFeatureData(pDensGTOneDataset, pTempWS, strTempName, False)
  
  ' EXTRACT POLYGONS FOR EACH HABITAT BLOCK
179:   psbar.Message(0) = "Extracting and Buffering Density Polygons..."
180:   pProg.Step
181:   DoEvents
  
  Dim pHabBlock1 As IPolygon
  Dim pHabBlock2 As IPolygon
  
186:   Set pHabBlock1 = pPolygonArray.Element(0)
187:   Set pHabBlock2 = pPolygonArray.Element(1)
  
  Dim pHab1Array As esriSystem.IArray
190:   Set pHab1Array = New esriSystem.Array
  Dim pHab2Array As esriSystem.IArray
192:   Set pHab2Array = New esriSystem.Array
  
  Dim pRelOp1 As IRelationalOperator
195:   Set pRelOp1 = pHabBlock1
  Dim pTopoOp1 As ITopologicalOperator
197:   Set pTopoOp1 = pHabBlock1
  
  Dim pRelOp2 As IRelationalOperator
200:   Set pRelOp2 = pHabBlock2
  Dim pTopoOp2 As ITopologicalOperator
202:   Set pTopoOp2 = pHabBlock2
  
  Dim pTempCursor As IFeatureCursor
  Dim pTempFeature As IFeature
  Dim pTempPolygon As IPolygon
  Dim lngFieldIndex As Long
208:   lngFieldIndex = pPotentialFClass.FindField("GRIDCODE")
  Dim lngGridCode As Long
  Dim pGeoTempPolygon As IPolygon
  Dim pClone As IClone
  Dim pPrjSpRef As IProjectedCoordinateSystem
  Dim pBufferPolygon As IPolygon
  Dim booNeedToReproject As Boolean
  
  Dim pTempTopoOp As ITopologicalOperator
  
218:   Set pTempCursor = pPotentialFClass.Search(Nothing, True)
219:   Set pTempFeature = pTempCursor.NextFeature
    
221:   Do Until pTempFeature Is Nothing
 '   MsgBox "Working on Feature #" & CStr(pTempFeature.OID + 1) & " of " & CStr(pPotentialFClass.FeatureCount(Nothing)) & "..."
223:     lngGridCode = pTempFeature.Value(lngFieldIndex)
224:     If lngGridCode = 1 Then
225:       Set pTempPolygon = pTempFeature.ShapeCopy
'      If TypeOf pTempPolygon.SpatialReference Is IGeographicCoordinateSystem Then
'        Set pGeoTempPolygon = pTempPolygon
'        booNeedToReproject = False
'      Else
'        Set pClone = pTempPolygon
'        Set pGeoTempPolygon = pClone.Clone
'        Set pPrjSpRef = pTempPolygon.SpatialReference
'        pGeoTempPolygon.Project pPrjSpRef.GeographicCoordinateSystem
'        Set pTempTopoOp = pGeoTempPolygon
'        pTempTopoOp.Simplify
'        booNeedToReproject = True
'      End If
'      Set pBufferPolygon = TopoCorridor.MyGeometricOperations.BufferGeographic(pGeoTempPolygon, 1)
'      If booNeedToReproject Then
'        pBufferPolygon.Project pRastSpRef
'        Set pTempTopoOp = pBufferPolygon
'        pTempTopoOp.Simplify
'      End If
'      If Not pRelOp1.Disjoint(pBufferPolygon) Then
'        pHab1Array.Add pBufferPolygon
'      End If
'
'      If Not pRelOp2.Disjoint(pBufferPolygon) Then
'        pHab2Array.Add pBufferPolygon
'      End If
      
252:       If Not pRelOp1.Disjoint(pTempPolygon) Then
253:         pHab1Array.Add pTempPolygon
254:       End If
      
256:       If Not pRelOp2.Disjoint(pTempPolygon) Then
257:         pHab2Array.Add pTempPolygon
258:       End If
259:     End If
260:     Set pTempFeature = pTempCursor.NextFeature
261:   Loop
  
  ' DELETE FEATURE CLASS
  Dim pDatasetToDelete As IDataset
265:   Set pDatasetToDelete = pPotentialFClass
266:   Set pPotentialFClass = Nothing
267:   Set pTempFeature = Nothing
268:   Set pTempCursor = Nothing
269:   If pDatasetToDelete.CanDelete Then
270:     pDatasetToDelete.DELETE
271:   End If

273:   psbar.Message(0) = "Identifying Density Polygons >= " & CStr(lngThreshold) & "% of largest polygon in Wildland Block #1..."
274:   pProg.Step
275:   DoEvents
  
  Dim pTopoOp As ITopologicalOperator2
  Dim pGeomBag As IGeometryCollection
  Dim pGeom As IGeometry
  
  Dim pHab1Polygon As IPolygon2
  Dim pHab2Polygon As IPolygon2
  
  ' BAIL OUT IF NO POLYGONS IN EITHER HABITAT BLOCK
285:   If pHab1Array.Count = 0 And pHab2Array.Count = 0 Then
  
287:     strBaseString = "{\rtf1\ansi\ansicpg1252\deff0\deflang1033{\fonttbl{\f0\fswiss\fcharset0 Arial;}{\f1\fnil\fcharset0 MS Sans Serif;}}" & vbNewLine
288:     strBaseString = strBaseString & "\viewkind4\uc1\pard\qc\f0\fs20 Termini Function Failed..." & vbNewLine
289:     strBaseString = strBaseString & "\par \pard\qc\fs17 -- No Density Polygons found in either Wildland Block -- " & vbNewLine
290:     strBaseString = strBaseString & "\par }" & vbNewLine
291:     strBaseString = strBaseString & " " & vbNewLine
    
293:     CalcLandFacetTermini = strBaseString
294:     GoTo CleanUp
295:   End If
  
'  MsgBox "Before Combining, Clipping and Selecting..." & vbCrLf & _
         "Habitat Block 1 has " & CStr(pHab1Array.Count) & " polygons above threshold" & vbCrLf & _
         "Habitat Block 2 has " & CStr(pHab2Array.Count) & " polygons above threshold"
'  TopoCorridor.MyGeneralOperations.DeleteGraphicsByName pMxDoc, "delete_me"
  
  Dim lngNumParts As Long
  Dim pPolygonComponents
  Dim pSubPolygon As IPolygon
  Dim dblCurrentArea As Double
  Dim dblMaxArea As Double
  Dim pPolyComponents() As IPolygon 'Declare an array of polygon
  Dim pArea As IArea
  Dim pTempArray As esriSystem.IArray
  
  ' HABITAT BLOCK 1
312:   dblMaxArea = 0
313:   If pHab1Array.Count > 0 Then
  
    ' FIRST COMBINE ALL POLYGONS
316:     Set pGeomBag = New GeometryBag
317:     Set pGeom = pGeomBag
318:     Set pGeom.SpatialReference = pRastSpRef
319:     For lngIndex = 0 To pHab1Array.Count - 1
320:       Set pTempPolygon = pHab1Array.Element(lngIndex)
'      MsgBox "pTempPolygon #" & CStr(lngIndex + 1) & " of " & CStr(pHab1Array.Count) & " is Nothing = " & _
            UCase(CStr(pTempPolygon Is Nothing))
323:       pGeomBag.AddGeometry pTempPolygon
324:     Next lngIndex
325:     Set pHab1Polygon = New Polygon
326:     Set pHab1Polygon.SpatialReference = pRastSpRef
327:     Set pTopoOp = pHab1Polygon
328:     pTopoOp.ConstructUnion pGeomBag
329:     pTopoOp.Simplify
    
    ' CLIP POLYGON TO HABITAT BOUNDARY
332:     Set pHab1Polygon = pTopoOp.Intersect(pHabBlock1, pHabBlock1.Dimension)
333:     pTopoOp.Simplify
    
    ' SPLIT INTO POTENTIALLY MULTIPLE SUB-POLYGONS
336:     Set pTempArray = ReturnBetterConnectedComponents(pHab1Polygon, dblMaxArea)

    ' ONLY RETAIN POLYGONS WITHIN SIZE THRESHOLD
    ' FIRST ADJUST MAX AREA VALUE TO THRESHOLD PERCENTAGE
340:     dblMaxArea = dblMaxArea * CDbl(lngThreshold) / 100
341:     pHab1Array.RemoveAll
342:     For lngIndex = 0 To pTempArray.Count - 1
343:       Set pSubPolygon = pTempArray.Element(lngIndex)
344:       Set pArea = pSubPolygon
345:       If pArea.Area >= dblMaxArea Then
346:         pHab1Array.Add pSubPolygon
'        TopoCorridor.MyGeneralOperations.Graphic_MakeFromGeometry pMxDoc, pSubPolygon, "delete_me"
348:       End If
349:     Next lngIndex
350:   End If

352:   psbar.Message(0) = "Identifying Density Polygons >= " & CStr(lngThreshold) & "% of largest polygon in Wildland Block #1..."
353:   pProg.Step
354:   DoEvents
  
  ' HABITAT BLOCK 2
357:   dblMaxArea = 0
358:   If pHab1Array.Count > 0 Then
  
    ' FIRST COMBINE ALL POLYGONS
361:     Set pGeomBag = New GeometryBag
362:     Set pGeom = pGeomBag
363:     Set pGeom.SpatialReference = pRastSpRef
364:     For lngIndex = 0 To pHab2Array.Count - 1
365:       Set pTempPolygon = pHab2Array.Element(lngIndex)
'      MsgBox "pTempPolygon #" & CStr(lngIndex + 1) & " of " & CStr(pHab1Array.Count) & " is Nothing = " & _
            UCase(CStr(pTempPolygon Is Nothing))
368:       pGeomBag.AddGeometry pTempPolygon
369:     Next lngIndex
370:     Set pHab2Polygon = New Polygon
371:     Set pHab2Polygon.SpatialReference = pRastSpRef
372:     Set pTopoOp = pHab2Polygon
373:     pTopoOp.ConstructUnion pGeomBag
374:     pTopoOp.Simplify
    
    ' CLIP POLYGON TO HABITAT BOUNDARY
377:     Set pHab2Polygon = pTopoOp.Intersect(pHabBlock2, pHabBlock2.Dimension)
378:     pTopoOp.Simplify
    
    ' SPLIT INTO POTENTIALLY MULTIPLE SUB-POLYGONS
381:     Set pTempArray = ReturnBetterConnectedComponents(pHab2Polygon, dblMaxArea)
'    MsgBox "dblMaxArea, back in 'CalcLandFacetTermini'..."
    ' ONLY RETAIN POLYGONS WITHIN SIZE THRESHOLD
    ' FIRST ADJUST MAX AREA VALUE TO THRESHOLD PERCENTAGE
385:     dblMaxArea = dblMaxArea * CDbl(lngThreshold) / 100
386:     pHab2Array.RemoveAll
387:     For lngIndex = 0 To pTempArray.Count - 1
388:       Set pSubPolygon = pTempArray.Element(lngIndex)
389:       Set pArea = pSubPolygon
390:       If pArea.Area >= dblMaxArea Then
391:         pHab2Array.Add pSubPolygon
'        TopoCorridor.MyGeneralOperations.Graphic_MakeFromGeometry pMxDoc, pSubPolygon, "delete_me"
393:       End If
394:     Next lngIndex
395:   End If

  
398:   psbar.Message(0) = "Creating Shapefile of Termini Polygons..."
399:   pProg.Step
400:   DoEvents
  
 ' MsgBox "After Combining, Clipping and Selecting..." & vbCrLf & _
         "Habitat Block 1 has " & CStr(pHab1Array.Count) & " polygons above threshold" & vbCrLf & _
         "Habitat Block 2 has " & CStr(pHab2Array.Count) & " polygons above threshold"
  
  ' MAKE TERMINI POLYGON FEATURE CLASS
  Dim pAddFields As esriSystem.IVariantArray
408:   Set pAddFields = New esriSystem.VarArray
  
  Dim pField As IField
  Dim pFieldEdit As IFieldEdit

413:   Set pField = New Field
414:   Set pFieldEdit = pField
415:   With pFieldEdit
416:     .Name = "Unique_ID"
417:     .Type = esriFieldTypeInteger
418:   End With
419:   pAddFields.Add pField

421:   Set pField = New Field
422:   Set pFieldEdit = pField
423:   With pFieldEdit
424:     .Name = "Hab_Block"
425:     .Type = esriFieldTypeInteger
426:   End With
427:   pAddFields.Add pField
  
  Dim pNewFClass As IFeatureClass
430:   Set pNewFClass = TopoCorridor.MyGeneralOperations.CreateGeneralFeatureClass( _
      esriGeometryPolygon, pRastSpRef, strWS, strFilename, ENUM_Shapefile, pAddFields, , , , True, _
      False, pPolygonEnvelope, pHab1Array.Count + pHab2Array.Count)
  Dim lngIDIndex As Long
  Dim lngHabIndex As Long
435:   lngIDIndex = pNewFClass.FindField("Unique_ID")
436:   lngHabIndex = pNewFClass.FindField("Hab_Block")
  
  Dim pBufCursor As IFeatureCursor
  Dim pBuffer As IFeatureBuffer
  
441:   Set pBuffer = pNewFClass.CreateFeatureBuffer
442:   Set pBufCursor = pNewFClass.Insert(True)
  
  Dim lngID As Long
445:   lngID = 0
446:   For lngIndex = 0 To pHab1Array.Count - 1
447:     lngID = lngID + 1
448:     Set pTempPolygon = pHab1Array.Element(lngIndex)
449:     Set pBuffer.Shape = pTempPolygon
450:     pBuffer.Value(lngIDIndex) = lngID
451:     pBuffer.Value(lngHabIndex) = 1
452:     pBufCursor.InsertFeature pBuffer
453:   Next lngIndex
  
455:   For lngIndex = 0 To pHab2Array.Count - 1
456:     lngID = lngID + 1
457:     Set pTempPolygon = pHab2Array.Element(lngIndex)
458:     Set pBuffer.Shape = pTempPolygon
459:     pBuffer.Value(lngIDIndex) = lngID
460:     pBuffer.Value(lngHabIndex) = 2
461:     pBufCursor.InsertFeature pBuffer
462:   Next lngIndex
463:   pBufCursor.Flush
  
  Dim pDataset As IDataset
466:   Set pDataset = pNewFClass
  
  Dim pNewFLayer As IFeatureLayer
469:   Set pNewFLayer = New FeatureLayer
470:   pNewFLayer.Name = pDataset.BrowseName
471:   Set pNewFLayer.FeatureClass = pNewFClass
  
473:   pMxDoc.FocusMap.AddLayer pNewFLayer
  
475:   pProg.position = 0
476:   psbar.HideProgressBar
  
'  pPrgAnim.Stop
'  pPrgAnim.Hide
'  Set pPrgAnim = Nothing
  
    ' MAKE FINAL REPORT
483:   strBaseString = "{\rtf1\ansi\ansicpg1252\deff0\deflang1033{\fonttbl{\f0\fswiss\fcharset0 Arial;}{\f1\fmodern\fprq1\fcharset0 Courier New;}{\f2\fnil\fcharset0 MS Sans Serif;}}" & vbNewLine
484:   strBaseString = strBaseString & "\viewkind4\uc1\pard\qc\b\f0\fs20 -- Land Facet Termini Analysis Complete --\b0 " & vbNewLine
485:   strBaseString = strBaseString & "\par \pard\qc ---------------------------------- " & vbNewLine
486:   strBaseString = strBaseString & "\par\fs16 \pard\b Analysis Raster = \b0\i " & strRasterName & " \i0 " & vbNewLine
487:   strBaseString = strBaseString & "\par\b Analysis Layer Threshold = \b0 " & CStr(dblDataThreshold) & vbNewLine
488:   strBaseString = strBaseString & "\par\b Wildland Block Polygon Layer = \b0 " & strPolygonName & vbNewLine
489:   strBaseString = strBaseString & "\par\b Size Threshold = \b0 " & CStr(lngThreshold) & "%" & vbNewLine
490:   strBaseString = strBaseString & "\par\b Output Termini Polygon Shapefile: \b0 " & vbNewLine
491:   strBaseString = strBaseString & "\par   --> Filename = " & strFilename & vbNewLine
492:   strBaseString = strBaseString & "\par   --> Workspace = " & Replace(strWS, "\", "\\") & vbNewLine
493:   strBaseString = strBaseString & "\par " & vbNewLine
    
  ' END REPORT
496:   strBaseString = strBaseString & "\par \pard\qc ---------------------------------- " & vbNewLine
497:   strBaseString = strBaseString & "\par " & vbNewLine
498:   strBaseString = strBaseString & TopoCorridor.MyGeneralOperations.ReturnTimeElapsedRTF(datTimeBegan, Now, 7)
499:   strBaseString = strBaseString & "\par }" & vbNewLine
  
501:   CalcLandFacetTermini = strBaseString
  
  ' CLEANUP
504:   GoTo CleanUp



  

  Exit Function
ErrorHandler:
  HandleError True, "CalcLandFacetTermini " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4

CleanUp:
  
'  If Not pPrgAnim Is Nothing Then
'    pPrgAnim.Stop
'    pPrgAnim.Hide
'  End If
  

  ReDim pPolyComponents(0)
523:   Set pDataset = Nothing
524:   Set pApp = Nothing
525:   Set pThisExt = Nothing
526:   Set pMxDoc = Nothing
527:   Set psbar = Nothing
'  Set pPrgAnim = Nothing
529:   Set pRastBand = Nothing
530:   Set pRastDataset = Nothing
531:   Set pPolygonFLayer = Nothing
532:   Set pPolygonFClass = Nothing
533:   Set pCursor = Nothing
534:   Set pFeature = Nothing
535:   Set pWS = Nothing
536:   Set pMaskFClass = Nothing
537:   Set pPolygonArray = Nothing
538:   Set pPolygon = Nothing
539:   Set pRastSpRef = Nothing
540:   Set pPolySpRef = Nothing
541:   Set pGeoDataset = Nothing
542:   Set pPolygonEnvelope = Nothing
543:   Set pTempRaster = Nothing
544:   Set pLogOp = Nothing
545:   Set pLogAnEnv = Nothing
546:   Set pConvOp = Nothing
547:   Set pConvAnEnv = Nothing
548:   Set pMakerOp = Nothing
549:   Set pMakerAnEnv = Nothing
550:   Set pZeroDataset = Nothing
551:   Set pDensGTOneDataset = Nothing
552:   Set pPotentialFClass = Nothing
553:   Set pTempWS = Nothing
554:   Set pHabBlock1 = Nothing
555:   Set pHabBlock2 = Nothing
556:   Set pHab1Array = Nothing
557:   Set pHab2Array = Nothing
558:   Set pRelOp1 = Nothing
559:   Set pTopoOp1 = Nothing
560:   Set pRelOp2 = Nothing
561:   Set pTopoOp2 = Nothing
562:   Set pTempCursor = Nothing
563:   Set pTempFeature = Nothing
564:   Set pTempPolygon = Nothing
565:   Set pGeoTempPolygon = Nothing
566:   Set pClone = Nothing
567:   Set pPrjSpRef = Nothing
568:   Set pBufferPolygon = Nothing
569:   Set pTempTopoOp = Nothing
570:   Set pDatasetToDelete = Nothing
571:   Set pTopoOp = Nothing
572:   Set pGeomBag = Nothing
573:   Set pGeom = Nothing
574:   Set pHab1Polygon = Nothing
575:   Set pHab2Polygon = Nothing
576:   Set pSubPolygon = Nothing
577:   Set pArea = Nothing
578:   Set pTempArray = Nothing
579:   Set pAddFields = Nothing
580:   Set pField = Nothing
581:   Set pFieldEdit = Nothing
582:   Set pNewFClass = Nothing
583:   Set pBufCursor = Nothing
584:   Set pBuffer = Nothing
585:   Set pNewFLayer = Nothing
586:   Set pProg = Nothing




  
End Function

Public Function ReturnBetterConnectedComponents(ByVal pPolygon As IPolygon2, dblMaxArea As Double) As esriSystem.IArray
  On Error GoTo ErrorHandler
  
  Dim pPolyComponents() As IPolygon
  Dim pTempArray As esriSystem.IArray
  Dim lngNumParts As Long
  Dim booFoundTouching As Boolean
  Dim lngIndex As Long
  Dim pArea As IArea
  Dim pSubPolygon As IPolygon
  Dim pTopoOp As ITopologicalOperator
  
  ' SPLIT INTO POTENTIALLY MULTIPLE SUB-POLYGONS
607:   lngNumParts = pPolygon.ExteriorRingCount
  ReDim pPolyComponents(lngNumParts - 1) 'Redimension the array of polygons with number of exterior rings
609:   pPolygon.GetConnectedComponents lngNumParts, pPolyComponents(0)  'Pass the first element of the array
  
611:   Set pTempArray = New esriSystem.Array
  
  ' MAKE ESRI-VERSION OF SEPARATE POLYGONS
614:   For lngIndex = 0 To lngNumParts - 1
615:     Set pSubPolygon = pPolyComponents(lngIndex)
616:     Set pSubPolygon.SpatialReference = pPolygon.SpatialReference
617:     Set pTopoOp = pSubPolygon
618:     pTopoOp.Simplify
        
620:     pTempArray.Add pSubPolygon
621:   Next lngIndex
  
  ' COMBINE ALL POLYGONS THAT TOUCH EACH OTHER
  Dim pFinalArray As esriSystem.IArray
  Dim pInterArray As esriSystem.IArray
626:   Set pInterArray = New esriSystem.Array
627:   Set pFinalArray = New esriSystem.Array
  
  Dim pTempPolygon As IPolygon2
  Dim pTempPolygon2 As IPolygon2
  Dim pRelOp As IRelationalOperator
  
  Dim pTempArray2 As esriSystem.IArray
634:   Set pTempArray2 = New esriSystem.Array
  Dim dblTempArea As Double
  
637:   Do Until pTempArray.Count = 0
    
639:     Set pTempPolygon = pTempArray.Element(0)
640:     pTempArray.Remove (0)
    
642:     pTempArray2.RemoveAll
643:     pInterArray.RemoveAll
644:     pInterArray.Add pTempPolygon
645:     Set pRelOp = pTempPolygon
646:     booFoundTouching = False
    
648:     If pTempArray.Count > 0 Then
649:       For lngIndex = 0 To pTempArray.Count - 1
650:         Set pTempPolygon2 = pTempArray.Element(lngIndex)
651:         If pRelOp.Disjoint(pTempPolygon2) Then
652:           pTempArray2.Add pTempPolygon2
653:         Else
654:           pInterArray.Add pTempPolygon2
655:           booFoundTouching = True
656:         End If
657:       Next lngIndex
658:     End If
    
660:     If booFoundTouching Then
661:       Set pTempPolygon = CombineArrayPolygons(pInterArray)
662:       pTempArray2.Insert 0, pTempPolygon
663:     Else
664:       pFinalArray.Add pTempPolygon
665:       Set pArea = pTempPolygon
666:       dblTempArea = pArea.Area
667:       If dblTempArea > dblMaxArea Then dblMaxArea = dblTempArea
'      MyGeneralOperations.Graphic_MakeFromGeometry pMxDoc, pTempPolygon, "delete_me"
'      Debug.Print "pFinalArray.Count = " & CStr(pFinalArray.Count) & ", pTempArray.Count = " & CStr(pTempArray.Count)
670:     End If
671:     pTempArray.RemoveAll
672:     For lngIndex = 0 To pTempArray2.Count - 1
673:       pTempArray.Add pTempArray2.Element(lngIndex)
674:     Next lngIndex
675:   Loop
  
677:   Set ReturnBetterConnectedComponents = pFinalArray
  
679:   GoTo CleanUp
ErrorHandler:
  HandleError True, "ReturnBetterConnectedComponents " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
CleanUp:

  ReDim pPolyComponents(0)
685:   Set pTempArray = Nothing
686:   Set pArea = Nothing
687:   Set pFinalArray = Nothing
688:   Set pInterArray = Nothing
689:   Set pTempPolygon = Nothing
690:   Set pTempPolygon2 = Nothing
691:   Set pRelOp = Nothing

End Function

Public Function CombineArrayPolygons(pPolygonArray As esriSystem.IArray) As IPolygon
  On Error GoTo ErrorHandler
    
698:     If pPolygonArray.Count = 1 Then
699:       Set CombineArrayPolygons = pPolygonArray.Element(0)
      Exit Function
701:     End If
    
    Dim lngIndex As Long
    Dim pGeomBag As IGeometryCollection
    Dim pGeom As IGeometry
    Dim pTempPolygon As IPolygon
707:     Set pTempPolygon = pPolygonArray.Element(0)
    Dim pTopoOp As ITopologicalOperator
    
    ' FIRST COMBINE ALL POLYGONS
711:     Set pGeomBag = New GeometryBag
712:     Set pGeom = pGeomBag
713:     Set pGeom.SpatialReference = pTempPolygon.SpatialReference
714:     pGeomBag.AddGeometry pTempPolygon
    
716:     For lngIndex = 1 To pPolygonArray.Count - 1
717:       Set pTempPolygon = pPolygonArray.Element(lngIndex)
718:       pGeomBag.AddGeometry pTempPolygon
719:     Next lngIndex
    
721:     Set CombineArrayPolygons = New Polygon
722:     Set CombineArrayPolygons.SpatialReference = pGeom.SpatialReference
723:     Set pTopoOp = CombineArrayPolygons
724:     pTopoOp.ConstructUnion pGeomBag
725:     pTopoOp.Simplify

727:   GoTo CleanUp
ErrorHandler:
  HandleError True, "CombinePolygons " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4


CleanUp:
733:   Set pGeomBag = Nothing
734:   Set pGeom = Nothing
735:   Set pTempPolygon = Nothing
736:   Set pTopoOp = Nothing

End Function

Public Function CalcLandFacetRaster(pParams As esriSystem.IVariantArray) As String
  On Error GoTo ErrorHandler
  
  Dim strBaseString As String
744:   strBaseString = strBaseString & "{\rtf1\ansi\ansicpg1252\deff0\deflang1033{\fonttbl{\f0\fswiss\fcharset0 Arial;}{\f1\fnil\fcharset0 MS Sans Serif;}}" & vbNewLine
745:   strBaseString = strBaseString & "\viewkind4\uc1\pard\qc\f0\fs20 Land Facet Function Failed..." & vbNewLine
746:   strBaseString = strBaseString & "\par \pard\f1\fs17 " & vbNewLine
747:   strBaseString = strBaseString & "\par }" & vbNewLine
748:   strBaseString = strBaseString & " " & vbNewLine
  
750:   CalcLandFacetRaster = strBaseString
   
  Dim pApp As IApplication
  Dim pThisExt As TopoCorridor.clsExtension
  Dim pMxDoc As IMxDocument
  
756:   Set pApp = pParams.Element(0)
757:   Set pMxDoc = pParams.Element(1)
758:   Set pThisExt = pParams.Element(2)
  
  Dim lngIndex As Long
  Dim lngIndex2 As Long
  Dim lngIndex3 As Long
  Dim pClone As IClone
  
  Dim pSubArray As esriSystem.IVariantArray
  Dim datTimeBegan As Date
767:   datTimeBegan = Now
  
  ' FORM 1 PARAMETERS
  ' RETURN ARRAY IS IVariantArray, CONTAINING:
  ' 0) IRasterBand: SELECTED RASTER BAND
  ' 1) STRING: Name of original raster band
  ' 2) STRING: Name of selected attribute field
  ' 3) STRING: Selected Attribute Value
  ' 4) IDoubleArray: Array of cell values that correspond with this selected attribute value
  ' 5) STRING: Save Format
  ' 6) STRING: TEXT VERSION OF SAVE FORMAT
  ' 7) STRING: New Raster Name
  ' 8) BOOLEAN: Whether new workspace is File Geodatabase
  ' 9) IWORKSPACE: Either an IRasterWorkspace2 or an IRasterWorkspaceEx
  '10) STRING: Extension for output
  '11) LONG: INDEX VALUE FOR lbxLayers, in case returning to this dialog
  '12) LONG: INDEX VALUE FOR lbxFields, in case returning to this dialog
  '13) LONG: INDEX VALUE FOR cbxValue, in case returning to this dialog
  '14) LONG: INDEX VALUE FOR cbxFormat, in case returning to this dialog
  '15) STRING: Text for txtOutput, in case returning to this dialog
  '16) BOOLEAN: Whether Saving Optional Table, in case returning to this dialog
  '17) LONG: Optional Table Format Index Value, in case returning to this dialog
  '18) STRING: Optional Table Output Filename, in case returning to this dialog
  '19) STRING: TEXT VERSION OF SAVE FORMAT
  '20) STRING: FILE NAME OF NEW TABLE
  '21) STRING: WORKSPACE PATH FOR NEW TABLE
  
  Dim pForm1Params As esriSystem.IVariantArray
795:   Set pForm1Params = pThisExt.frmImportStep1Return
  
  Dim pSlopeClassBand As IRasterBand
  Dim strSlopeClassName As String
  Dim strSlopeClassFieldName As String
  Dim strSlopeClassAttValue As String
  Dim pSlopeVals As IDoubleArray
  Dim strOutputSaveFormat As String
  Dim strOutputSaveFormatForReport As String
  Dim strOutputRasterName As String
  Dim booOutputIsFGDB As Boolean
  Dim pWS As IWorkspace
  Dim strExtension As String
  
'  Dim pTempBand As IRasterBand
'  Dim pTempDataset As IDataset
'  Dim pTempName As IName
'
'  Set pTempBand = pForm1Params.Element(0)
'  Set pTempDataset = pTempBand
'  Set pTempName = pTempDataset.FullName
  
  
  
819:   Set pSlopeClassBand = pForm1Params.Element(0)
820:   strSlopeClassName = pForm1Params.Element(1)
821:   strSlopeClassFieldName = pForm1Params.Element(2)
822:   strSlopeClassAttValue = pForm1Params.Element(3)
823:   Set pSlopeVals = pForm1Params.Element(4)
824:   strOutputSaveFormat = pForm1Params.Element(5)
825:   strOutputSaveFormatForReport = pForm1Params.Element(6)
826:   strOutputRasterName = pForm1Params.Element(7)
827:   booOutputIsFGDB = pForm1Params.Element(8)
828:   Set pWS = pForm1Params.Element(9)
829:   strExtension = pForm1Params.Element(10)
  
  
  Dim strWSPath As String
833:   strWSPath = pWS.PathName
834:   If Right(strWSPath, 1) = "\" Then
835:     strWSPath = Left(strWSPath, Len(strWSPath) - 1)
836:   End If
  
  Dim pOutputRastWS As IRasterWorkspace2
  Dim pOutputRastWsEx As IRasterWorkspaceEx
840:   If booOutputIsFGDB Then
841:     Set pOutputRastWsEx = pWS
842:   Else
843:     Set pOutputRastWS = pWS
844:   End If
  
  ' CONVERT IDoubleArray to Double() array for faster access
  Dim dblSlopeVals() As Double
  ReDim dblSlopeVals(pSlopeVals.Count - 1)
849:   For lngIndex = 0 To pSlopeVals.Count - 1
850:     dblSlopeVals(lngIndex) = pSlopeVals.Element(lngIndex)
851:   Next lngIndex
  
  
  ' m_pCentroidData:  IVariantArray CONTAINING FIVE OBJECTS:
  ' 0) pNamesSubArray:  IStringArray CONTAINING VARIABLE NAMES
  ' 1) pValsArray:  IVariantArray CONTAINING MULTIPLE IVariantArrays, ONE FOR EACH CENTROID.
  '    --> EACH pValsSubArray CONTAINS A SET OF CENTROID COORDINATE VALUES; ONE VALUE FOR EACH VARIABLE
  '    --> EACH COORDINATE IN pValsSubArray CORRESPONDS WITH VARIABLE NAME IN pNamesSubArray
  ' 2) STRING:  RTF-format description of Centroids data
  ' 3) STRING:  FULL RTF-format description of Centroids data, IN CASE RETURNING TO THIS DIALOG
  ' 4) DOUBLE(): 2-dimensional array; 1st dimension is centroid number, 2nd dimension is variable value
  
  ' m_pBinWidthData:  IVariantArray CONTAINING FIVE OBJECTS:
  ' 0) pNamesSubArray:  IStringArray CONTAINING VARIABLE NAMES
  ' 1) pValsArray:  IVariantArray CONTAINING BIN WIDTH VALUES FOR EACH VARIABLE.
  '    --> EACH BIN WIDTH VALUE IN pValsArray CORRESPONDS WITH VARIABLE NAME IN pNamesSubArray
  ' 2) STRING:  RTF-format description of Bin Width data
  ' 3) STRING:  FULL RTF-format description of Bin Width data, IN CASE RETURNING TO THIS DIALOG
  ' 4) DOUBLE():  Same as pValsArray, but faster to access
  
  ' m_pParamsData:  IVariantArray CONTAINING FIVE OBJECTS:
  ' 0) pNamesSubArray:  IStringArray CONTAINING VARIABLE NAMES
  ' 1) pValsArray:  IVariantArray CONTAINING MULTIPLE IVariantArrays, ONE FOR EACH VARIABLE.
  '    --> EACH pValsSubArray CONTAINS TWO VALUES:  MEAN AND STANDARD DEVIATION FOR THIS VARIABLE
  ' 2) STRING:  RTF-format description of Params data
  ' 3) STRING:  FULL RTF-format description of Params data, IN CASE RETURNING TO THIS DIALOG
  ' 4) DOUBLE(): 2-dimensional array; 1st dimension is Variable number, 2nd dimension is mean and standard deviation
  
  ' m_pEvalData:  IVariantArray CONTAINING FIVE OBJECTS:
  ' 0) pNamesSubArray:  IStringArray CONTAINING VARIABLE NAMES
  ' 1) pValsArray:  IVariantArray CONTAINING MULTIPLE IVariantArrays, ONE FOR EACH BIN CENTROID.
  '    --> EACH pValsSubArray CONTAINS A SET OF CENTROID COORDINATE VALUES; ONE VALUE FOR EACH VARIABLE
  '    --> EACH COORDINATE IN pValsSubArray CORRESPONDS WITH VARIABLE NAME IN pNamesSubArray
  ' 2) STRING:  RTF-format description of Eval Points data
  ' 3) STRING:  FULL RTF-format description of Eval Points data, IN CASE RETURNING TO THIS DIALOG
  ' 4) DOUBLE(): 2-dimensional array; 1st dimension is bin number, 2nd dimension is variable value
  
  Dim pForm2Params As esriSystem.IVariantArray
889:   Set pForm2Params = pThisExt.frmImportStep2Return
  Dim pCentroidData As esriSystem.IVariantArray
891:   Set pCentroidData = pForm2Params.Element(0)
  Dim pBinWidthData As esriSystem.IVariantArray
893:   Set pBinWidthData = pForm2Params.Element(1)
  Dim pParamsData As esriSystem.IVariantArray
895:   Set pParamsData = pForm2Params.Element(2)
  Dim pEvalData As esriSystem.IVariantArray
897:   Set pEvalData = pForm2Params.Element(3)
  
  Dim strCentroidsInput As String
  Dim strBinWidthInput As String
  Dim strParamsInput As String
  Dim strEvalInput As String
  
904:   strCentroidsInput = pCentroidData.Element(2)
905:   strBinWidthInput = pBinWidthData.Element(2)
906:   strParamsInput = pParamsData.Element(2)
907:   strEvalInput = pEvalData.Element(2)
  
  Dim dblCentroidVals() As Double
910:   dblCentroidVals = pCentroidData.Element(4)
  Dim dblBinWidthVals() As Double
912:   dblBinWidthVals = pBinWidthData.Element(4)
  Dim dblParamsVals() As Double
914:   dblParamsVals = pParamsData.Element(4)
  Dim dblEvalVals() As Double
916:   dblEvalVals = pEvalData.Element(4)
  
  Dim lngVariableCount As Long
919:   lngVariableCount = UBound(dblBinWidthVals) + 1
  Dim lngClusterCount As Long
921:   lngClusterCount = UBound(dblCentroidVals, 1)
  
  ' CONVERT BIN CENTROIDS AND BIN WIDTHS DATA TO SINGLE DOUBLE ARRAY WITH MIN/MAX VALUES FOR EACH BIN
  Dim dblBins() As Double
  ReDim dblBins(UBound(dblEvalVals, 1), (UBound(dblEvalVals, 2) * 2) + 1)
  Dim dblHalfBinWidths() As Double
  ReDim dblHalfBinWidths(UBound(dblBinWidthVals))
  Dim dblTempVal As Double
  Dim dblBinHalfWidth As Double
'  For lngIndex = 0 To UBound(dblBinWidthVals)
'    dblHalfBinWidths(lngIndex) = dblBinWidthVals(lngIndex) / 2
'  Next lngIndex
933:   For lngIndex = 0 To UBound(dblEvalVals)
934:     For lngIndex2 = 0 To UBound(dblHalfBinWidths)
935:       dblTempVal = dblEvalVals(lngIndex, lngIndex2)
936:       dblBinHalfWidth = dblBinWidthVals(lngIndex2)
937:       dblBins(lngIndex, lngIndex2 * 2) = dblTempVal - dblBinHalfWidth
938:       dblBins(lngIndex, (lngIndex2 * 2) + 1) = dblTempVal + dblBinHalfWidth
939:     Next lngIndex2
940:   Next lngIndex
  
'
'  ' FOR DEBUGGING
'  Dim strReport As String
'  strReport = strReport & "Bin Widths" & vbCrLf
'  For lngIndex = 0 To UBound(dblBinWidthVals)
'    strReport = strReport & "  " & CStr(dblBinWidthVals(lngIndex)) & vbCrLf
'  Next lngIndex
'  strReport = strReport & "Half Bin Widths" & vbCrLf
'  For lngIndex = 0 To UBound(dblHalfBinWidths)
'    strReport = strReport & "  " & CStr(dblHalfBinWidths(lngIndex)) & vbCrLf
'  Next lngIndex
'
'  strReport = strReport & vbCrLf & "Centroids" & vbCrLf
'  For lngIndex = 0 To UBound(dblCentroidVals, 1)
'    For lngIndex2 = 0 To UBound(dblCentroidVals, 2)
'      strReport = strReport & CStr(dblCentroidVals(lngIndex, lngIndex2)) & "     "
'    Next lngIndex2
'    strReport = strReport & vbCrLf
'  Next lngIndex
'
'  strReport = strReport & vbCrLf & "10 Lines of Eval Bins" & vbCrLf
'  For lngIndex = 0 To 9
'    For lngIndex2 = 0 To UBound(dblEvalVals, 2)
'      strReport = strReport & CStr(dblEvalVals(lngIndex, lngIndex2)) & "     "
'    Next lngIndex2
'    strReport = strReport & vbCrLf
'  Next lngIndex
'  Clipboard.Clear
'
'  strReport = strReport & vbCrLf & "10 Lines of Final Bins" & vbCrLf
'  For lngIndex = 0 To 9
'    For lngIndex2 = 0 To UBound(dblBins, 2)
'      strReport = strReport & CStr(dblBins(lngIndex, lngIndex2)) & "     "
'    Next lngIndex2
'    strReport = strReport & vbCrLf
'  Next lngIndex
'  CalcLandFacetRaster = strReport
'  GoTo CleanUp
  
  ' FORM 3 PARAMETERS
  ' RETURN ARRAY WILL BE IVariantArray, CONTAINING SEPARATE SUB-ARRAY FOR EACH VARIABLE.
  ' VARIABLE SUB-ARRAYS WILL BE IVariantArrays, CONTAINING THE FOLLOWING:
  ' 0) STRING: Variable Name
  ' 1) IRasterBand or IFeatureLayer: Variable Layer
  ' 2) STRING: Layer Name
  ' 3) LONG: List Index of Layer ComboBox, in case dialog needs to be refilled
  ' 4) STRING: Attribute Field Name (only if a Feature Layer; otherwise null string)
  ' 5) LONG: List Index of Field ComboBox, in case dialog needs to be refilled
  ' 6) STRING: Layer Name, formatted to more easily be converted to attribute field
  Dim pLayerVarsArray As esriSystem.IVariantArray
  Dim pRasterLayer As IRasterLayer
  Dim pRasterBand As IRasterBand
  Dim strVariableName As String
  Dim strLayerName As String
  Dim pUnknown As IUnknown
  Dim strFieldName As String
998:   Set pLayerVarsArray = pThisExt.frmImportStep3Return
  
  
  ' FORM 4 PARAMETERS
  Dim dblPhi As Double
  Dim dblThreshold As Double
  
1005:   dblPhi = pThisExt.frmImportStep4FuzzinessParam
1006:   dblThreshold = pThisExt.frmImportStep4FuzzinessThreshold

  ' CLEAR UP MEMORY
1009:   Set pThisExt.frmImportStep1Return = Nothing
1010:   Set pThisExt.frmImportStep2Return = Nothing
1011:   Set pThisExt.frmImportStep3Return = Nothing









  Dim pTemplateBand As IRasterBand
  Dim strTemplateName As String
  Dim pTemplateRaster As IRaster
  Dim pTemplateDataset As IRasterDataset2
  Dim pTemplateProps As IRasterProps
  Dim pTemplateSpRef As ISpatialReference
  Dim pTemplatePnt As IPnt
  
1029:   Set pTemplateBand = pSlopeClassBand
1030:   strTemplateName = strSlopeClassName
1031:   Set pTemplateDataset = pTemplateBand.RasterDataset
1032:   Set pTemplateRaster = pTemplateDataset.CreateFullRaster
1033:   Set pTemplateProps = pTemplateBand
1034:   Set pTemplateSpRef = pTemplateProps.SpatialReference
1035:   Set pTemplatePnt = pTemplateProps.MeanCellSize
  
  Dim strInputName As String
  Dim strInputBand As IRasterBand
  
'  Dim pAdditionalRasters As esriSystem.IVariantArray
'  Dim pAdditionalFeatLayers As esriSystem.IVariantArray
'  Dim booShouldClip As Boolean
'  Dim pClipLayer As IFeatureLayer
  Dim strOutputFormat As String
  Dim strFullFilename As String
'  Dim booAllHaveNoSpRef As Boolean
  Dim strFullFilePath As String
  Dim booAddCombinedToMap As Boolean
  
  ' FOR DEBUGGING
1051:   booAddCombinedToMap = False
  
'  Set pAdditionalRasters = pParams.Element(2)
'  Set pAdditionalFeatLayers = pParams.Element(3)
'  booShouldClip = pParams.Element(4)
'  Set pClipLayer = pParams.Element(5)
'  strOutputFormat = pParams.Element(6)
'  strFullFilename = pParams.Element(7)
'  Set pWS = pParams.Element(8)
'  booAllHaveNoSpRef = pParams.Element(9)
'  strFullFilePath = pParams.Element(10)
'  booAddCombinedToMap = pParams.Element(11)
  
  Dim strWsName As String
1065:   strWsName = pWS.PathName
1066:   If Right(strWsName, 1) = " \" Then
1067:     strWsName = Left(strWsName, Len(strWsName) - 1)
1068:   End If
  
  Dim lngTransformCount As Long
1071:   lngTransformCount = 1
1072:   For lngIndex = 0 To pLayerVarsArray.Count - 1
1073:     Set pSubArray = pLayerVarsArray.Element(lngIndex)
1074:     Set pUnknown = pSubArray.Element(1)
1075:     If TypeOf pUnknown Is IFeatureLayer Then
1076:       lngTransformCount = lngTransformCount + 2
1077:     Else
1078:       lngTransformCount = lngTransformCount + 1
1079:     End If
1080:   Next lngIndex
  
  Dim lngTransformCounter As Long
1083:   lngTransformCounter = 1
  
  ' FOLLOWING CODE SHOULD BE INSERTED INTO A FUNCTION.  NEEDS MINOR EDITS IF GOING INTO A SUBROUTINE
  ' SPECIFICALLY, CHANGE "Exit Function" to "Exit Sub" IN BAILOUT SECTION
  ' PROGRESS BAR STUFF
    ' PROGRESS BAR STUFF
  Dim psbar As IStatusBar
1090:   Set psbar = pApp.StatusBar
  Dim pPro As IStepProgressor
1092:   Set pPro = psbar.ProgressBar
  Dim theTimeBegan As Date
  Dim dateRunningTime As Date
1095:   theTimeBegan = Now
1096:   dateRunningTime = Now
  Dim strHeader As String
1098:   strHeader = "Pass 1 of 2: Aligning Datasets"
  Dim strMessage As String
1100:   strMessage = strHeader
  
  Dim frmProgress As New TopoCorridor.frmJenProgressMeterBasic
  Dim theDetailedDescription As String
  Dim theProgressSpecific As String

1106:   frmProgress.SetExpanded = pThisExt.ProgressDialogSetExpanded
1107:   frmProgress.SetExpanded = True
1108:   frmProgress.SetAutoClose = pThisExt.ProgressDialogAutoClose

1110:   theTimeBegan = Now
1111:   frmProgress.ShouldContinue = True
1112:   frmProgress.ProgBeginTime = Now
1113:   frmProgress.ProgRecCount = lngTransformCount
1114:   frmProgress.lblCurrentTime.Caption = Format(Now, "ttttt")
1115:   frmProgress.lblBeginTime.Caption = "Began Job: " & Format(theTimeBegan, "ttttt,  ddddd")

1117:   theDetailedDescription = "Calculating..." & vbCrLf & _
      "Began Job: " & Format(theTimeBegan, "ttttt,  ddddd") & vbCrLf & _
      "-------------------------------------------" & vbCrLf
1120:   frmProgress.txtDetails.Text = theDetailedDescription

1122:   frmProgress.Frame.Caption = " Current Status:"
1123:   frmProgress.Frame.Visible = True
1124:   frmProgress.cmdDetails.Visible = True
1125:   frmProgress.cmdStop.Visible = True
  
  ' ---- UPDATE PROGRESS METER
1128:   DoEvents
1129:   theProgressSpecific = "Working on Step " & CStr(lngTransformCounter) & " of " & CStr(lngTransformCount) & "..."
1130:   theDetailedDescription = theDetailedDescription & _
    " --> " & theProgressSpecific & vbCrLf & _
    "          [time stamp " & Format(Now, "ttttt,  ddddd") & "]" & vbCrLf & vbCrLf
1133:   frmProgress.txtDetails.Text = theDetailedDescription
1134:   frmProgress.txtDetails.SelStart = Len(theDetailedDescription)

1136:   frmProgress.Est_Time_Left lngTransformCounter, "Pass 1 of 2:  Aligning '" & strTemplateName & "'...", "Calculating Data..."
1137:   frmProgress.lblCurrentTime.Caption = Format(Now, "ttttt")
1138:   frmProgress.Refresh
1139:   frmProgress.icnProgressLine.Refresh
1140:   DoEvents
1141:   If LFR_BailOutOfProgress(frmProgress, pApp) Then

   ' ********************************************************************************************
    ' SIMPLE CODE
1145:     CalcLandFacetRaster = "Exited Function Prematurely..." & vbCrLf

   ' ********************************************************************************************

1149:     frmProgress.cmdStop.Caption = "Close"
1150:     pPro.position = 0
1151:     psbar.HideProgressBar
    Exit Function
1153:   End If
  ' ---- END PROGRESS METER STUFF --------------------------------
  
  
1157:   psbar.ShowProgressBar "Pass 1 of 2:  Aligning projection, extent and cell size for '" & strTemplateName & "'...", 0, lngTransformCount, 1, True
1158:   pPro.MaxRange = lngTransformCount
1159:   pPro.position = lngTransformCounter
1160:   pPro.Show
  
  Dim pAddLayer As IRasterLayer
    
  Dim pAddFeatLayer As IFeatureLayer
  Dim pFeatClassDesc As IFeatureClassDescriptor
  Dim pFeatClass As IFeatureClass
  Dim pField As IField
  
  Dim strAddName As String
  
''  ' DO ANALYSIS
''  lngWorkOrderCounter = lngWorkOrderCounter + 1
''  psbar.ShowProgressBar "Exporting " & pTemplate.Name & " to " & strTemplateName & "...", 1, lngWorkOrderCount, lngWorkOrderCounter, True
''  DoEvents
'
  

  
'  MsgBox "lngTransformCount = " & CStr(lngTransformCount) & vbCrLf & _
         "pAdditionalRasters.Count = " & CStr(pAdditionalRasters.Count) & vbCrLf & _
         "pAdditionalFeatLayers.Count = " & CStr(pAdditionalFeatLayers.Count)
  
  Dim pRastMakerOp As IRasterMakerOp
1184:   Set pRastMakerOp = New RasterMakerOp
  Dim pRastAnEnv As IRasterAnalysisEnvironment
1186:   Set pRastAnEnv = pRastMakerOp

  Dim dblCellSize As Double
1189:   dblCellSize = (pTemplatePnt.X + pTemplatePnt.Y) / 2
  Dim pEnv As IEnvelope
1191:   Set pEnv = pTemplateProps.Extent
1192:   Set pClone = pEnv
1193:   Set pEnv = pClone.Clone
1194:   pEnv.Expand -(pTemplatePnt.X) / 10, -(pTemplatePnt.Y) / 10, False
1195:   Set pRastAnEnv.OutSpatialReference = pTemplateSpRef
'   Set pRastAnEnv.OutWorkspace = pWS
1197:   pRastAnEnv.SetCellSize esriRasterEnvValue, dblCellSize
1198:   pRastAnEnv.SetExtent esriRasterEnvValue, pEnv, pTemplateRaster
  
  Dim pOneDataset As IRasterDataset
  Dim pTempRaster As IRaster2
1202:   Set pTempRaster = pRastMakerOp.MakeConstant(1, False)
1203:   Set pOneDataset = pTempRaster.RasterDataset
  
  Dim pMathOp As IMathOp
1206:   Set pMathOp = New RasterMathOps
  Dim pMathEnv As IRasterAnalysisEnvironment
1208:   Set pMathEnv = pMathOp
1209:   Set pMathEnv.OutSpatialReference = pTemplateSpRef
'   Set pMathEnv.OutWorkspace = pWS
1211:   pMathEnv.SetCellSize esriRasterEnvValue, dblCellSize
1212:   pMathEnv.SetExtent esriRasterEnvValue, pEnv, pTemplateRaster
  
  Dim pInBandColl As IRasterBandCollection
1215:   Set pInBandColl = New Raster
  
  Dim pAddBand As IRasterBand
  Dim pNewBand As IRasterBand
  Dim pNewDataset As IRasterDataset
  Dim pNewBandColl As IRasterBandCollection
    
1222:   Set pTempRaster = pMathOp.Times(pTemplateBand, pOneDataset)
1223:   Set pNewDataset = pTempRaster.RasterDataset
1224:   Set pNewBandColl = pNewDataset
1225:   Set pNewBand = pNewBandColl.Item(0)
1226:   pInBandColl.AppendBand pNewBand
  ' FOR DEBUGGING
 ' MsgBox "Added Template:" & vbCrLf & "pInBandColl.Count = " & CStr(pInBandColl.Count)
    
  Dim pInRaster As IRaster
1231:   Set pInRaster = pInBandColl
1232:   pInRaster.ResampleMethod = RSP_NearestNeighbor
  Dim pInProps As IRasterProps
1234:   Set pInProps = pInBandColl
1235:   pInProps.SpatialReference = pTemplateSpRef
1236:   pInProps.Extent = pTemplateProps.Extent
1237:   pInProps.Height = pTemplateProps.Height
1238:   pInProps.Width = pTemplateProps.Width
  
    ' EXPORT ADDITIONAL FEATURE CLASSES
  Dim pOutputFNames As esriSystem.IStringArray
1242:   Set pOutputFNames = New esriSystem.strArray
  Dim pTempConversionRasterDataset As IRasterDataset
  Dim pConOp As IConversionOp
1245:   Set pConOp = New RasterConversionOp
  Dim pTempAnEnv As IRasterAnalysisEnvironment
1247:   Set pTempAnEnv = pConOp
1248:   Set pTempAnEnv.OutSpatialReference = pTemplateSpRef
'   Set pTempAnEnv.OutWorkspace = pWS
1250:   pTempAnEnv.SetCellSize esriRasterEnvValue, dblCellSize
1251:   pTempAnEnv.SetExtent esriRasterEnvValue, pEnv, pTemplateRaster
  
  Dim pFeatGeoDataset As IGeoDataset
  Dim pTempRastDataset As IDataset
  Dim strTempName As String
  
  Dim pRastWS As IRasterWorkspace
  Dim pWsFact As IWorkspaceFactory
1259:   Set pWsFact = New RasterWorkspaceFactory
1260:   Set pRastWS = pWsFact.OpenFromFile(pWS.PathName, 0)
  
  Dim booAlreadyHasInfoFolder As Boolean
1263:   booAlreadyHasInfoFolder = TopoCorridor.aml_func_mod.ExistFileDir(strWsName & "\info")
  
  ' ALIGN DATASETS
1266:   For lngIndex = 0 To pLayerVarsArray.Count - 1
1267:     Set pSubArray = pLayerVarsArray.Element(lngIndex)
1268:     Set pUnknown = pSubArray.Element(1)
1269:     strAddName = pSubArray.Element(2)
1270:     If TypeOf pUnknown Is IRasterBand Then
    
1272:       Set pAddBand = pUnknown
      
1274:       lngTransformCounter = lngTransformCounter + 1
1275:       pPro.MaxRange = lngTransformCount
1276:       pPro.position = lngTransformCounter
1277:       pPro.Message = "Pass 1 of 2:  Aligning projection, extent and cell size for '" & strAddName & "'..."
1278:       pPro.Show
          
      ' ---- UPDATE PROGRESS METER
1281:       DoEvents
1282:       theProgressSpecific = "Working on Step " & CStr(lngTransformCounter) & " of " & CStr(lngTransformCount) & "..."
1283:       theDetailedDescription = theDetailedDescription & _
        " --> " & theProgressSpecific & vbCrLf & _
        "          [time stamp " & Format(Now, "ttttt,  ddddd") & "]" & vbCrLf & vbCrLf
1286:       frmProgress.txtDetails.Text = theDetailedDescription
1287:       frmProgress.txtDetails.SelStart = Len(theDetailedDescription)
    
1289:       frmProgress.Est_Time_Left lngTransformCounter, "Pass 1 of 2:  Aligning '" & strAddName & "'...", "Calculating Data..."
1290:       frmProgress.lblCurrentTime.Caption = Format(Now, "ttttt")
1291:       frmProgress.Refresh
1292:       frmProgress.icnProgressLine.Refresh
1293:       DoEvents
1294:       If LFR_BailOutOfProgress(frmProgress, pApp) Then
    
       ' ********************************************************************************************
        ' SIMPLE CODE
1298:         CalcLandFacetRaster = "Exited Function Prematurely..." & vbCrLf
    
       ' ********************************************************************************************
    
1302:         frmProgress.cmdStop.Caption = "Close"
1303:         pPro.position = 0
1304:         psbar.HideProgressBar
        Exit Function
1306:       End If
      ' ---- END PROGRESS METER STUFF --------------------------------
      
1309:       DoEvents
      
1311:       Set pTempRaster = pMathOp.Times(pAddBand, pOneDataset)
1312:       Set pNewDataset = pTempRaster.RasterDataset
1313:       Set pNewBandColl = pNewDataset
1314:       Set pNewBand = pNewBandColl.Item(0)
1315:       pInBandColl.AppendBand pNewBand
    ' FOR DEBUGGING
  '    MsgBox "Added Additional Raster #" & CStr(lngIndex) & ":" & vbCrLf & "pInBandColl.Count = " & CStr(pInBandColl.Count)
  '    MsgBox "Position " & CStr(pPro.position) & " of " & CStr(pPro.MaxRange)

1320:     Else
  
1322:       Set pAddFeatLayer = pUnknown
1323:       strFieldName = pSubArray.Element(4)
1324:       Set pFeatClass = pAddFeatLayer.FeatureClass
1325:       Set pFeatGeoDataset = pFeatClass
      
1327:       lngTransformCounter = lngTransformCounter + 1
1328:       pPro.MaxRange = lngTransformCount
1329:       pPro.position = lngTransformCounter
1330:       pPro.Message = "Pass 1 of 2:  Aligning projection, extent and cell size for '" & pAddFeatLayer.Name & "'..."
1331:       pPro.Show
          
      ' ---- UPDATE PROGRESS METER
1334:       DoEvents
1335:       theProgressSpecific = "Working on Step " & CStr(lngTransformCounter) & " of " & CStr(lngTransformCount) & "..."
1336:       theDetailedDescription = theDetailedDescription & _
        " --> " & theProgressSpecific & vbCrLf & _
        "          [time stamp " & Format(Now, "ttttt,  ddddd") & "]" & vbCrLf & vbCrLf
1339:       frmProgress.txtDetails.Text = theDetailedDescription
1340:       frmProgress.txtDetails.SelStart = Len(theDetailedDescription)
    
1342:       frmProgress.Est_Time_Left lngTransformCounter, "Pass 1 of 2:  Aligning '" & pAddFeatLayer.Name & "'...", "Calculating Data..."
1343:       frmProgress.lblCurrentTime.Caption = Format(Now, "ttttt")
1344:       frmProgress.Refresh
1345:       frmProgress.icnProgressLine.Refresh
1346:       DoEvents
1347:       If LFR_BailOutOfProgress(frmProgress, pApp) Then
    
       ' ********************************************************************************************
        ' SIMPLE CODE
1351:         CalcLandFacetRaster = "Exited Function Prematurely..." & vbCrLf
    
       ' ********************************************************************************************
    
1355:         frmProgress.cmdStop.Caption = "Close"
1356:         pPro.position = 0
1357:         psbar.HideProgressBar
        Exit Function
1359:       End If
      ' ---- END PROGRESS METER STUFF --------------------------------
1361:       DoEvents
  
1363:       Set pFeatClassDesc = New FeatureClassDescriptor
1364:       pFeatClassDesc.Create pFeatClass, Nothing, strFieldName
      
1366:       strTempName = TopoCorridor.MyGeneralOperations.MakeUniqueShapeFilename(strWsName & "\" & "CS_Temp")
1367:       strTempName = TopoCorridor.aml_func_mod.ReturnFilename(strTempName)
    '  MsgBox "strTempName = " & strTempName & vbCrLf & _
        "strWsName = " & strWsName
1370:       Set pTempConversionRasterDataset = pConOp.ToRasterDataset(pFeatClassDesc, "GRID", pRastWS, strTempName)
          
1372:       lngTransformCounter = lngTransformCounter + 1
1373:       pPro.MaxRange = lngTransformCount
1374:       pPro.position = lngTransformCounter
1375:       pPro.Message = "Pass 1 of 2:  Aligning projection, extent and cell size for '" & pAddFeatLayer.Name & "'..."
1376:       pPro.Show
          
      ' ---- UPDATE PROGRESS METER
1379:       DoEvents
1380:       theProgressSpecific = "Working on Step " & CStr(lngTransformCounter) & " of " & CStr(lngTransformCount) & "..."
1381:       theDetailedDescription = theDetailedDescription & _
        " --> " & theProgressSpecific & vbCrLf & _
        "          [time stamp " & Format(Now, "ttttt,  ddddd") & "]" & vbCrLf & vbCrLf
1384:       frmProgress.txtDetails.Text = theDetailedDescription
1385:       frmProgress.txtDetails.SelStart = Len(theDetailedDescription)
    
1387:       frmProgress.Est_Time_Left lngTransformCounter, "Pass 1 of 2:  Aligning '" & pAddFeatLayer.Name & "'...", "Calculating Data..."
1388:       frmProgress.lblCurrentTime.Caption = Format(Now, "ttttt")
1389:       frmProgress.Refresh
1390:       frmProgress.icnProgressLine.Refresh
1391:       DoEvents
1392:       If LFR_BailOutOfProgress(frmProgress, pApp) Then
    
       ' ********************************************************************************************
        ' SIMPLE CODE
1396:         CalcLandFacetRaster = "Exited Function Prematurely..." & vbCrLf
    
       ' ********************************************************************************************
    
1400:         frmProgress.cmdStop.Caption = "Close"
1401:         pPro.position = 0
1402:         psbar.HideProgressBar
        Exit Function
1404:       End If
      ' ---- END PROGRESS METER STUFF --------------------------------
1406:       DoEvents
      
1408:       Set pTempRastDataset = pTempConversionRasterDataset
1409:       Set pTempRaster = pMathOp.Float(pTempConversionRasterDataset)
1410:       Set pNewDataset = pTempRaster.RasterDataset
1411:       Set pTempRaster = pMathOp.Times(pNewDataset, pOneDataset)
1412:       Set pNewDataset = pTempRaster.RasterDataset
1413:       Set pNewBandColl = pNewDataset
1414:       Set pNewBand = pNewBandColl.Item(0)
1415:       pInBandColl.AppendBand pNewBand
    ' FOR DEBUGGING
  '    MsgBox "Added Additional Feature #" & CStr(lngIndex) & ":" & vbCrLf & "pInBandColl.Count = " & CStr(pInBandColl.Count)
  
1419:       Set pTempConversionRasterDataset = Nothing
1420:       If pTempRastDataset.CanDelete Then
1421:         pTempRastDataset.DELETE
1422:       End If
1423:       Set pTempRastDataset = Nothing
1424:     End If
1425:   Next lngIndex

1427:   pRastAnEnv.RestoreToPreviousDefaultEnvironment
  
  ' PREPARE OUTPUT DATA TABLE
  Dim pAddFieldNames As esriSystem.IVariantArray
  
  Dim pFieldEdit As IFieldEdit
  
  Dim pAddFields As esriSystem.IVariantArray
  Dim pTable As ITable
  Dim pFieldIndexes As esriSystem.ILongArray
  Dim lngFieldIndex As Long
  
  Dim lngFormatStyle As Long          ' 0 = dBASE, 1 = CSV
  
  Dim lngFileNumber As Long
  Dim strRow As String
  Dim strTestOutput As String
  
  Dim booExportTable As Boolean
  Dim strPathName As String
  
1448:   booExportTable = pForm1Params.Element(16)
  
  Dim pClusterFieldNames As esriSystem.IStringArray
1451:   Set pClusterFieldNames = New esriSystem.strArray
  Dim pClusterIndices As esriSystem.ILongArray
1453:   Set pClusterIndices = New esriSystem.LongArray
  Dim pVariableFieldNames As esriSystem.IStringArray
1455:   Set pVariableFieldNames = New esriSystem.strArray
  Dim pVariableIndices As esriSystem.ILongArray
1457:   Set pVariableIndices = New esriSystem.LongArray
  Dim booInBins As Boolean
  
1460:   If booExportTable Then
1461:     lngFormatStyle = pForm1Params.Element(17)
1462:     strFullFilename = pForm1Params.Element(20)
1463:     strPathName = pForm1Params.Element(21)
'    strFullFilePath = pForm1Params.Element(18)
1465:     Set pAddFieldNames = New esriSystem.VarArray
  
1467:     If Right(strPathName, 1) = "\" Then
1468:       strFullFilePath = strPathName & strFullFilename
1469:     Else
1470:       strFullFilePath = strPathName & "\" & strFullFilename
1471:     End If
    
1473:     strTempName = strTemplateName
1474:     strFieldName = TopoCorridor.MyGeneralOperations.ReturnDBASEFieldName(strTempName, pAddFieldNames)
1475:     pAddFieldNames.Add strFieldName
1476:       pVariableFieldNames.Add strFieldName
    
1478:     For lngIndex = 0 To pLayerVarsArray.Count - 1
1479:       Set pSubArray = pLayerVarsArray.Element(lngIndex)
1480:       strTempName = pSubArray.Element(6)
1481:       strFieldName = TopoCorridor.MyGeneralOperations.ReturnDBASEFieldName(strTempName, pAddFieldNames)
1482:       pAddFieldNames.Add strFieldName
1483:       pVariableFieldNames.Add strFieldName
1484:     Next lngIndex
    
    ' FOR DEBUGGING
'    strOutputFormat = "dBASE (*.dbf)"
'    strFullFilename = TopoCorridor.aml_func_mod.ReturnFilename( _
'        TopoCorridor.MyGeneralOperations.MakeUniquedBASEName(pWS.PathName & "test.dbf"))
  
1491:     If lngFormatStyle = 0 Then          '  strOutputFormat = "dBASE (*.dbf)" Then
1492:       lngFormatStyle = 0
1493:       Set pAddFields = New esriSystem.VarArray
      
      ' ADD COORDINATES
1496:       Set pField = New Field
1497:       Set pFieldEdit = pField
1498:       With pFieldEdit
1499:         .Name = "X_Coord"
1500:         .Type = esriFieldTypeDouble
1501:         .Precision = 16
1502:         .Scale = 8
1503:       End With
1504:       pAddFields.Add pField
      
1506:       Set pField = New Field
1507:       Set pFieldEdit = pField
1508:       With pFieldEdit
1509:         .Name = "Y_Coord"
1510:         .Type = esriFieldTypeDouble
1511:         .Precision = 16
1512:         .Scale = 8
1513:       End With
1514:       pAddFields.Add pField
      
      ' ADD LAYER DATA
1517:       For lngIndex = 0 To pAddFieldNames.Count - 1
1518:         strFieldName = pAddFieldNames.Element(lngIndex)
1519:         Set pField = New Field
1520:         Set pFieldEdit = pField
1521:         With pFieldEdit
1522:           .Name = strFieldName
1523:           .Type = esriFieldTypeDouble
1524:           .Precision = 16
1525:           .Scale = 8
1526:         End With
1527:         pAddFields.Add pField
        
1529:       Next lngIndex
      
      ' ADD CLUSTERS
1532:       For lngIndex = 0 To lngClusterCount
1533:         strFieldName = TopoCorridor.MyGeneralOperations.ReturnDBASEFieldName("Cluster" & CStr(lngIndex + 1), pAddFields)
1534:         Set pField = New Field
1535:         Set pFieldEdit = pField
1536:         With pFieldEdit
1537:           .Name = strFieldName
1538:           .Type = esriFieldTypeDouble
1539:           .Precision = 16
1540:           .Scale = 8
1541:         End With
1542:         pAddFields.Add pField
        
1544:         pClusterFieldNames.Add strFieldName
1545:       Next lngIndex
      
      ' ADD CONFUSION INDEX DATA
      Dim strFirstClusterName As String
1549:       strFirstClusterName = TopoCorridor.MyGeneralOperations.ReturnDBASEFieldName("First_Clst", pAddFields)
1550:       Set pField = New Field
1551:       Set pFieldEdit = pField
1552:       With pFieldEdit
1553:         .Name = strFirstClusterName
1554:         .Type = esriFieldTypeInteger
1555:         .Precision = 6
1556:       End With
1557:       pAddFields.Add pField
      
      Dim strSecondClusterName As String
1560:       strSecondClusterName = TopoCorridor.MyGeneralOperations.ReturnDBASEFieldName("Secnd_Clst", pAddFields)
1561:       Set pField = New Field
1562:       Set pFieldEdit = pField
1563:       With pFieldEdit
1564:         .Name = strSecondClusterName
1565:         .Type = esriFieldTypeInteger
1566:         .Precision = 6
1567:       End With
1568:       pAddFields.Add pField
      
      Dim strConfusionIndexName As String
1571:       strConfusionIndexName = TopoCorridor.MyGeneralOperations.ReturnDBASEFieldName("Conf_Index", pAddFields)
1572:       Set pField = New Field
1573:       Set pFieldEdit = pField
1574:       With pFieldEdit
1575:         .Name = strConfusionIndexName
1576:         .Type = esriFieldTypeDouble
1577:         .Precision = 16
1578:         .Scale = 8
1579:       End With
1580:       pAddFields.Add pField
      
      Dim strOutlierIndexName As String
1583:       strOutlierIndexName = TopoCorridor.MyGeneralOperations.ReturnDBASEFieldName("Outlier", pAddFields)
1584:       Set pField = New Field
1585:       Set pFieldEdit = pField
1586:       With pFieldEdit
1587:         .Name = strOutlierIndexName
1588:         .Type = esriFieldTypeString
1589:         .length = 5
1590:       End With
1591:       pAddFields.Add pField
      
      ' FOR DEBUGGING
'      Dim strTempReport As String
'      strTempReport = "Path = " & strPathName & vbCrLf & "Filename = " & strFullFilename & vbCrLf
'      Set pFieldIndexes = New esriSystem.LongArray
'      For lngIndex = 0 To pAddFields.Count - 1
'        Set pField = pAddFields.Element(lngIndex)
'        strFieldName = pField.Name
'        strTempReport = strTempReport & "Field Index " & CStr(lngIndex) & " = " & strFieldName & vbCrLf
'      Next lngIndex
'      CalcLandFacetRaster = strTempReport
      
1604:       Set pTable = TopoCorridor.MyGeneralOperations.CreatedBASETableInFolder2(strPathName, strFullFilename, _
           pAddFields, False)
      
1607:       For lngIndex = 0 To pVariableFieldNames.Count - 1
1608:         strFieldName = pVariableFieldNames.Element(lngIndex)
1609:         pVariableIndices.Add pTable.FindField(strFieldName)
1610:       Next lngIndex
      
1612:       For lngIndex = 0 To pClusterFieldNames.Count - 1
1613:         strFieldName = pClusterFieldNames.Element(lngIndex)
1614:         pClusterIndices.Add pTable.FindField(strFieldName)
1615:       Next lngIndex
      
'      strTempReport = ""
1618:       Set pFieldIndexes = New esriSystem.LongArray
1619:       For lngIndex = 0 To pAddFields.Count - 1
1620:         Set pField = pAddFields.Element(lngIndex)
1621:         strFieldName = pField.Name
1622:         lngFieldIndex = pTable.FindField(strFieldName)
1623:         pFieldIndexes.Add lngFieldIndex
'        strTempReport = strTempReport & "Field Index for '" & strFieldName & "' = " & CStr(pFieldIndexes.Element(lngIndex)) & vbCrLf
1625:       Next lngIndex
      
      
      Dim pCursor As ICursor
      Dim pBuffer As IRowBuffer
      
1631:       Set pBuffer = pTable.CreateRowBuffer
1632:       Set pCursor = pTable.Insert(True)
      
      Dim lngXIndex As Long
      Dim lngYIndex As Long
      Dim lngHighClusterIndex As Long
      Dim lngSecondClusterIndex As Long
      Dim lngConfusionIndex As Long
      Dim lngOutlierIndex As Long
      
1641:       lngXIndex = pTable.FindField("X_Coord")
1642:       lngYIndex = pTable.FindField("Y_Coord")
1643:       lngHighClusterIndex = pTable.FindField(strFirstClusterName)
1644:       lngSecondClusterIndex = pTable.FindField(strSecondClusterName)
1645:       lngConfusionIndex = pTable.FindField(strConfusionIndexName)
1646:       lngOutlierIndex = pTable.FindField(strOutlierIndexName)
'      strTempReport = strTempReport & "Field Index for 'X_Coord' = " & CStr(lngXIndex) & vbCrLf
'      strTempReport = strTempReport & "Field Index for 'Y_Coord' = " & CStr(lngYIndex)
  '    If MsgBox(strTempReport, vbOKCancel) <> vbOK Then Exit Function
      
1651:     ElseIf lngFormatStyle = 1 Then     ' strOutputFormat = "Comma-Delimited (*.csv)" Then
1652:       lngFormatStyle = 1
1653:       lngFileNumber = FreeFile(0)
1654:       Open strFullFilePath For Output Access Write As #lngFileNumber
1655:       strRow = ""
1656:       For lngIndex = 0 To pAddFieldNames.Count - 1
1657:         strFieldName = pAddFieldNames.Element(lngIndex)
1658:         strRow = strRow & strFieldName & ","
1659:       Next lngIndex
1660:       strRow = strRow & "X_Coord,Y_Coord,"
      
      ' ADD CLUSTERS
1663:       For lngIndex = 0 To lngClusterCount
1664:         strRow = strRow & "Cluster_" & CStr(lngIndex + 1) & ","
1665:       Next lngIndex
      
      ' ADD CONFUSION INDEX DATA
1668:       strRow = strRow & "First_Clst,Secnd_Clst,Conf_Index,Outlier"
1669:       Print #lngFileNumber, strRow
1670:     End If
1671:   End If       ' END IF EXPORT TABLE
  
  
  Dim pTempBand As IRasterBand
  
  '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  '/////////// |                  | \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
  '----------  |   CALCULATIONS   |  ---------------------------------------------------------------------------
  '\\\\\\\\\\\ |                  | ///////////////////////////////////////////////////////////////////////////
  '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  
  Dim pRastProps As IRasterProps
1683:   Set pClone = pInRaster
1684:   Set pRastProps = pClone.Clone
'  Set pRastProps = pInRaster
  
  Dim lngHeight As Long
  Dim lngWidth As Long
  Dim dblNoData As Double
  Dim varNoData As Variant
  Dim dblX As Double
  Dim dblY As Double
  
1694:   lngWidth = pRastProps.Width
1695:   lngHeight = pRastProps.Height
1696:   varNoData = pRastProps.NoDataValue
  
1698:   psbar.ShowProgressBar "Pass 2 of 2:  Extracting Cell Values...", 0, lngHeight, 1, True
1699:   pPro.position = 1
1700:   pPro.Show
1701:   frmProgress.ProgRecCount = lngHeight
  
  Dim pPnt As IPnt
1704:   Set pPnt = New Pnt
1705:   pPnt.SetCoords lngWidth, 1

  Dim pPixBlock As IPixelBlock3

  Dim pTopLeft As IPnt

  Dim varNoDataArray As Variant
  Dim booHasData() As Boolean
  Dim varData As Variant
  Dim varAllData() As Variant
  Dim varEmptyData() As Variant
  ReDim varEmptyData(lngWidth - 1)
  
  ' FOR DEBUGGING
'  Dim strDebugReport As String
'  strDebugReport = ""
'  For lngIndex = 0 To (lngNbrHoodRadius * 2)
'    For lngIndex2 = 0 To (lngNbrHoodRadius * 2)
'      strDebugReport = strDebugReport & Left(UCase(CStr(booMaskArray(lngIndex, lngIndex2))), 1) & "  "
'    Next lngIndex2
'    strDebugReport = strDebugReport & vbCrLf
'  Next lngIndex
 
  ' ADD FIRST LINE OF DATA
  Dim pRastCursor As IRasterCursor
  Dim pInputRaster As IRaster2
1731:   Set pInputRaster = pInRaster
1732:   Set pRastCursor = pInputRaster.CreateCursorEx(pPnt)

1734:   Set pPixBlock = pRastCursor.PixelBlock
1735:   pPixBlock.PixelType(0) = PT_FLOAT
1736:   pRastCursor.Reset
1737:   Set pPixBlock = pRastCursor.PixelBlock
1738:   varData = pPixBlock.PixelData(0)
  
  Dim lngNumBands As Long
1741:   lngNumBands = pInBandColl.Count - 1
  Dim booAllHasData() As Boolean
  ReDim booAllHasData(lngWidth - 1)
  ReDim varAllData(lngWidth - 1, lngNumBands)   ' BAND NUMBER IS FIRST INDEX, VALUE IS SECOND INDEX
  
  Dim varNoDataVals() As Variant
  ReDim varNoDataVals(lngNumBands)
  Dim pTempProps As IRasterProps
1749:   For lngIndex = 0 To lngNumBands
1750:     Set pTempBand = pInBandColl.Item(lngIndex)
1751:     Set pTempProps = pTempBand
1752:     varNoDataVals(lngIndex) = CDbl(pTempProps.NoDataValue)
'    MsgBox "Band #" & CStr(lngIndex) & ":  NoData = " & CStr(pTempProps.NoDataValue), , "Checking NoData Values:"
1754:   Next lngIndex
  
  ' RESET HAS-DATA ARRAY TO ALL TRUE
1757:   For lngIndex = 0 To lngWidth - 1
1758:     booAllHasData(lngIndex) = True
1759:   Next lngIndex
  ' CHECK HAS DATA ARRAYS FOR ALL LEVELS; RESET booAllHasData TO FALSE IF ANY VALUES ARE FALSE
1761:   For lngIndex = 0 To lngNumBands
1762:     booHasData = ConvertNoDataMaskToSomethingUseful(pPixBlock.NoDataMask(0))
1763:     For lngIndex2 = 0 To lngWidth - 1
1764:       If booHasData(lngIndex2) = False Then booAllHasData(lngIndex2) = False
1765:     Next lngIndex2
1766:   Next lngIndex
'
'  ' BELOW IS WORKAROUND FOR PROBLEM IN WHICH PIXEL BLOCK APPEARS TO NOT BE ABLE TO CORRECTLY READ FIRST ROW.
'  ' I THINK THIS HAS SOMETHING TO DO WITH SETTING THE PIXEL TYPE TO PT_FLOAT.  IT READS IT CORRECTLY AFTER
'  ' THAT POINT, BUT I CANNOT SET IT BEFORE READING THE FIRST ROW FROM RASTER CURSOR, EVEN AFTER USING 'RESET'.
'  ' CODE BELOW SIMPLY EXTRACTS varData1 and booHasData1 FROM A DIFFERENT PIXEL BLOCK THAT IS READ CORRECTLY.
  Dim pTempPixBlock As IPixelBlock3
  Dim pTemporaryRaster As IRaster
1774:   Set pTemporaryRaster = pInputRaster
  Dim pTempPoint As IPnt
1776:   Set pTempPoint = New Pnt
1777:   pTempPoint.SetCoords CInt(lngWidth), 1
1778:   Set pTempPixBlock = pTemporaryRaster.CreatePixelBlock(pTempPoint)
1779:   pTempPixBlock.PixelType(0) = PT_FLOAT
  Dim pTempOrigin As IPnt
1781:   Set pTempOrigin = New Pnt

  Dim lngRowCounter As Long
1784:   lngRowCounter = -1
  Dim varVal As Variant
  Dim dblVal As Double

1788:   pTempOrigin.SetCoords 0, 0
1789:   pTemporaryRaster.Read pTempOrigin, pTempPixBlock
  
'  ' FOR DEBUGGING
'  strTestOutput = TopoCorridor.MyGeneralOperations.MakeUniqueShapeFilename(strWsName & "\test.txt")
'  lngFileNumber = FreeFile(0)
'  Open strTestOutput For Output Access Write As #lngFileNumber
'  varData = pTempPixBlock.PixelDataByRef(0)
'  For lngIndex = 0 To UBound(varData, 2)
'    strRow = ""
'    For lngIndex2 = 0 To UBound(varData, 1)
'      strRow = strRow & CStr(varData(lngIndex2, lngIndex)) & ","
'    Next lngIndex2
'    strRow = Left(strRow, Len(strRow) - 1) & "   ...   " & vbCrLf
'    Print #lngFileNumber, strRow
'  Next lngIndex
'  Close #lngFileNumber
'  booHasData = ConvertNoDataMaskToSomethingUseful(pTempPixBlock.NoDataMaskByRef(0))

  ' RESET HAS-DATA ARRAY TO ALL TRUE
  
1809:   For lngIndex = 0 To pTempPixBlock.Planes - 1
1810:     pTempPixBlock.PixelType(lngIndex) = PT_FLOAT
1811:   Next lngIndex
  
1813:   For lngIndex = 0 To lngWidth - 1
'    pTempPixBlock.PixelType(lngIndex) = PT_FLOAT
1815:     booAllHasData(lngIndex) = True
1816:   Next lngIndex
  ' CHECK HAS DATA ARRAYS FOR ALL LEVELS; RESET booAllHasData TO FALSE IF ANY VALUES ARE FALSE
1818:   For lngIndex = 0 To lngNumBands
1819:     varData = pTempPixBlock.PixelDataByRef(lngIndex)
    
'    ' FOR DEBUGGING
'    strTestOutput = TopoCorridor.MyGeneralOperations.MakeUniqueShapeFilename(strWsName & _
'        "\varData_" & CStr(lngIndex) & ".txt")
'    lngFileNumber = FreeFile(0)
'    Open strTestOutput For Output Access Write As #lngFileNumber
'    For lngIndex2 = 0 To UBound(varData, 1)
'      strRow = ""
'      For lngIndex3 = 0 To UBound(varData, 2)
'        strRow = strRow & CStr(varData(lngIndex2, lngIndex3)) & ","
'      Next lngIndex3
'      strRow = Left(strRow, Len(strRow) - 1)
'      Print #lngFileNumber, strRow
'    Next lngIndex2
'    Close #lngFileNumber
    
1836:     booHasData = ConvertNoDataMaskToSomethingUseful(pTempPixBlock.NoDataMask(lngIndex))
1837:     For lngIndex2 = 0 To lngWidth - 1
1838:       varAllData(lngIndex2, lngIndex) = varData(lngIndex2, 0)
1839:       If booHasData(lngIndex2) = False Then booAllHasData(lngIndex2) = False
1840:     Next lngIndex2
    
1842:   Next lngIndex
    
'  ' FOR DEBUGGING
'  strTestOutput = Replace(strWsName & "\varAllData.txt", "\\", "\")
'  strTestOutput = TopoCorridor.MyGeneralOperations.MakeUniqueShapeFilename(strTestOutput)
'  lngFileNumber = FreeFile(0)
'  Open strTestOutput For Output Access Write As #lngFileNumber
'  For lngIndex2 = 0 To UBound(varAllData, 1)
'    strRow = ""
'    For lngIndex3 = 0 To UBound(varAllData, 2)
'      strRow = strRow & CStr(varAllData(lngIndex2, lngIndex3)) & ","
'    Next lngIndex3
'    strRow = strRow & "   IS MASKED = " & UCase(CStr(Not booAllHasData(lngIndex2)))
''    strRow = Left(strRow, Len(strRow) - 1)
'    Print #lngFileNumber, strRow
'  Next lngIndex2
'  Close #lngFileNumber
'  MsgBox "See " & strTestOutput
'  GoTo CleanUp
  
  
  ' FROM HERE ON OUT, RASTER CURSOR SEEMS TO WORK

  ' IF lngFocalRow ACTUALLY IS lngHeight, THEN IT IS ONE ROW TOO FAR.
  Dim lngFocalRow As Long
1867:   lngFocalRow = 0
  Dim lngLastColumn As Long
1869:   lngLastColumn = lngWidth - 1
  Dim lngOut As Long
  Dim booAddThisRow As Boolean
  
  Dim datRunningTime As Date
1874:   datRunningTime = Now
'    ' UPDATE PROGRESS BAR MESSAGE ONCE PER 2 SECONDS
'    If (lngTimer = lngValCount) Or DateDiff("s", dateRunningTime, Now) >= 1 Then
  
  Dim booInSlopeClass As Boolean
  
  ' MAKE ARRAY OF X-COORDINATE VALUES
  Dim pTempRast2 As IRaster2
1882:   Set pTempRast2 = pTemporaryRaster
  Dim dblXCoords() As Double
  Dim dblYCoords() As Double
  ReDim dblXCoords(lngWidth - 1)
  ReDim dblYCoords(lngHeight - 1)
1887:   For lngIndex = 0 To lngLastColumn
1888:     dblXCoords(lngIndex) = pTempRast2.ToMapX(lngIndex)
1889:   Next lngIndex
1890:   For lngIndex = 0 To lngHeight - 1
1891:     dblYCoords(lngIndex) = pTempRast2.ToMapY(lngIndex)
1892:   Next lngIndex
1893:   Set pTempRast2 = Nothing
  
  Dim dblLayerVector() As Double
  ReDim dblLayerVector(lngNumBands - 1)
  Dim pFuzzyOutput As esriSystem.IVariantArray
  
  ' RETURN ARRAY WILL CONTAIN
  ' 0) DoubleArray for membership to each cluster
  ' 1) LONG: Number of nearest cluster
  ' 2) LONG: Number of 2nd Nearest Cluster
  ' 3) DOUBLE: Confusion Index Value
  Dim dblMemberships() As Double
  Dim lngHighestMembership As Long
  Dim lngSecondMembership As Long
  Dim dblConfusionIndex As Double
  
  
    ' CREATE RASTERS TO WRITE TO -----------------------------------------------------------------------------------
  ' Create the dataset
  Dim pOutDS As IRasterDataset2
  Dim pOutRasterEdit As IRasterEdit

  Dim pRasterStorDef As IRasterStorageDef2
  Dim pRasterDef As IRasterDef
  Dim pGeomDef As IGeometryDef
  
  Dim pOriginPoint As IPoint
1920:   Set pOriginPoint = New Point
1921:   pOriginPoint.PutCoords pRastProps.Extent.XMin, pRastProps.Extent.YMin
  
  Dim pOutPnt As IPnt
1924:   Set pOutPnt = New Pnt
  
  Dim pSpRef As ISpatialReference
1927:   Set pSpRef = pRastProps.SpatialReference
      
  ' IRasterStorageDef
1930:   Set pRasterStorDef = New RasterStorageDef
1931:   Set pRasterStorDef.CellSize = pRastProps.MeanCellSize
1932:   pRasterStorDef.CompressionType = esriRasterSdeCompressionTypeRunLength
1933:   pRasterStorDef.PyramidLevel = 2
1934:   pRasterStorDef.PyramidResampleType = RSP_BilinearInterpolation
1935:   pRasterStorDef.TileHeight = 128
1936:   pRasterStorDef.TileWidth = 128

  ' IRasterDef
1939:   Set pRasterDef = New RasterDef
1940:   Set pRasterDef.SpatialReference = pSpRef
1941:   pRasterDef.Description = "rasterdataset"

  ' IGeometryDef
1944:   Set pGeomDef = Nothing
  
  Dim pOutProps As IRasterProps
  Dim pOutBandColl As IRasterBandCollection
  Dim pTempOutBandColl As IRasterBandCollection
  Dim pOutBand As IRasterBand
  Dim pRastDatasetEdit As IRasterDatasetEdit2
  Dim pTempOutRaster As IRaster
  
  Dim strTemp10Name As String
  Dim pTempWS As IWorkspace2
  Dim strBaseName As String
  Dim lngTempCounter As Long
  
1958:   strTemp10Name = "temp"
1959:   strBaseName = "temp"
1960:   lngTempCounter = 1
  
1962:   If TypeOf pOutputRastWS Is IRasterWorkspaceEx Then
1963:   Set pTempWS = pOutputRastWS
1964:     Do Until Not pTempWS.NameExists(esriDTAny, strTemp10Name)
1965:       lngTempCounter = lngTempCounter + 1
1966:       strTemp10Name = strBaseName & "_" & CStr(lngTempCounter)
1967:     Loop
1968:   Else
1969:     Do Until Not TopoCorridor.aml_func_mod.ExistFileDir(strWSPath & "\" & strTemp10Name)
1970:       lngTempCounter = lngTempCounter + 1
1971:       strTemp10Name = strBaseName & "_" & CStr(lngTempCounter)
1972:     Loop
1973:   End If
  
  Dim lngDocVersion As Long
1976:   lngDocVersion = TopoCorridor.aml_func_mod.ReturnArcGISVersionAlt(pMxDoc)
  
1978:   If booOutputIsFGDB Then
    
1980:     If lngDocVersion <= 3 Then
1981:       Set pOutDS = pOutputRastWsEx.CreateRasterDataset(strOutputRasterName, 1, PT_SHORT, pRasterStorDef, _
          "DEFAULTS", pRasterDef, pGeomDef)
1983:     Else
1984:       Set pOutDS = pOutputRastWsEx.CreateRasterDataset(strTemp10Name, 1, PT_FLOAT, pRasterStorDef, _
          "DEFAULTS", pRasterDef, pGeomDef)
1986:     End If
1987:     Set pTempOutBandColl = pOutDS
1988:     Set pTempOutRaster = New Raster
1989:     Set pOutBandColl = pTempOutRaster
1990:     pOutBandColl.AppendBands pTempOutBandColl
1991:     pTempOutRaster.ResampleMethod = RSP_BilinearInterpolation
    
1993:     Set pOutProps = pTempOutRaster
1994:     pOutProps.Extent = pRastProps.Extent
1995:     pOutProps.Height = pRastProps.Height
1996:     pOutProps.Width = pRastProps.Width
1997:     pOutProps.SpatialReference = pSpRef
1998:     pOutProps.PixelType = PT_FLOAT
1999:   Else
  
'    MsgBox "pOutputRastWS is Nothing = " & CStr(pOutputRastWS Is Nothing) & vbCrLf & _
      "pWS is Nothing = " & CStr(pWS Is Nothing) & vbCrLf & _
      "pWS.PathName = " & CStr(pWS.PathName) & vbCrLf & _
      "strOutputRasterName & strExtension = " & strOutputRasterName & strExtension & vbCrLf & _
      "strOutputSaveFormat = " & strOutputSaveFormat & vbCrLf & _
      "pOriginPoint = " & CStr(pOriginPoint.X) & "  x  " & CStr(pOriginPoint.Y) & vbCrLf & _
      "lngWidth = " & CStr(lngWidth) & vbCrLf & _
      "lngHeight = " & CStr(lngHeight) & vbCrLf & _
      "pRastProps.MeanCellSize.X = " & CStr(pRastProps.MeanCellSize.X) & vbCrLf & _
      "pRastProps.MeanCellSize.Y = " & CStr(pRastProps.MeanCellSize.Y) & vbCrLf & _
      "pSpRef = " & pSpRef.Name

'    Set pOutDS = pOutputRastWS.CreateRasterDataset(strOutputRasterName & strExtension, strOutputSaveFormat, pOriginPoint, lngWidth, lngHeight, _
        pRastProps.MeanCellSize.X, pRastProps.MeanCellSize.Y, 1, PT_FLOAT, pSpRef, True)
2015:     If lngDocVersion <= 3 Then
2016:       Set pOutDS = pOutputRastWS.CreateRasterDataset(strOutputRasterName & strExtension, strOutputSaveFormat, pOriginPoint, lngWidth, lngHeight, _
          pRastProps.MeanCellSize.X, pRastProps.MeanCellSize.Y, 1, PT_SHORT, pSpRef, True)
2018:     Else
2019:       Set pOutDS = pOutputRastWS.CreateRasterDataset(strTemp10Name, "GRID", pOriginPoint, lngWidth, lngHeight, _
          pRastProps.MeanCellSize.X, pRastProps.MeanCellSize.Y, 1, PT_FLOAT, pSpRef, True)
2021:     End If
2022:   End If
  
  Dim pOutputPixBlock As IPixelBlock3
  
  ' OUTPUT VARIABLES
  Dim pOutputRaster As IRaster2
  Dim pOutputRaster2 As IRaster
  Dim pPixelData As Variant
  Dim pRawPixel As IRawPixels
  Dim pOutPixelBlock As IPixelBlock3
  Dim pBands As IRasterBandCollection
  Dim pOutputRastProps As IRasterProps
  Dim pCache As Variant

  ' QI for IRawPixels and IRasterProps
2037:   Set pOutputRaster = pOutDS.CreateFullRaster
2038:   Set pOutputRaster2 = pOutputRaster
2039:   Set pOutRasterEdit = pOutputRaster
2040:   Set pBands = pOutDS
2041:   Set pRawPixel = pBands.Item(0)
2042:   Set pOutputRastProps = pRawPixel
2043:   If Not booOutputIsFGDB Then
2044:     pOutputRastProps.NoDataValue = CInt(-9999)
2045:   End If
'  Set pOutPixelBlock = pRawPixel.CreatePixelBlock(pPnt)
2047:   Set pOutputPixBlock = pOutputRaster2.CreatePixelBlock(pPnt)
  
2049:   If lngDocVersion <= 3 Then
2050:     pOutputPixBlock.PixelType(0) = PT_SHORT
2051:   Else
2052:     pOutputPixBlock.PixelType(0) = PT_FLOAT
2053:   End If
  Dim varOutData As Variant
    
2056:   Do Until lngFocalRow = lngHeight
2057:     pPro.Step
2058:     DoEvents
2059:     dblY = dblYCoords(lngFocalRow)
    
    ' WRITE ROW
2062:     pOutPnt.SetCoords 0, lngFocalRow
2063:     pOutputRaster2.Read pOutPnt, pOutputPixBlock
2064:     varOutData = pOutputPixBlock.PixelData(0)
    
2066:     For lngIndex = 0 To lngLastColumn
2067:       dblX = dblXCoords(lngIndex)
2068:       booInSlopeClass = False  ' RESET AT BEGINNING OF EACH VECTOR OF VALUES
2069:       lngOut = -9999
          
'      If MsgBox("lngFocalRow = " & CStr(lngFocalRow) & vbCrLf & _
        "booAllHasData(lngIndex = " & CStr(lngIndex) & ") = " & CStr(booAllHasData(lngIndex)), vbYesNo) = vbYes Then GoTo CleanUp

'      lngOut = -9999
2075:       If booAllHasData(lngIndex) Then

        ' GET DATA FROM ALL BANDS; IF ANY ARE NODATA, THEN DO NOT ADD ROW TO OUTPUT
2078:         booAddThisRow = True
2079:         strRow = ""
2080:         For lngIndex2 = 0 To lngNumBands
          
2082:           varVal = varAllData(lngIndex, lngIndex2)
            
'          If MsgBox("lngFocalRow = " & CStr(lngFocalRow) & vbCrLf & _
            "booAllHasData(lngIndex = " & CStr(lngIndex) & ") = " & CStr(booAllHasData(lngIndex)) & vbCrLf & _
            "Not IsNull(varVal) = " & CStr(Not IsNull(varVal)), vbYesNo) = vbYes Then GoTo CleanUp
            
2088:           If IsNull(varVal) Then
2089:             booAddThisRow = False
2090:             Exit For
2091:           Else
2092:             varNoData = varNoDataVals(lngIndex2)
2093:             If varNoData = varVal Then
2094:               booAddThisRow = False
2095:               Exit For
2096:             Else
    
2098:               dblVal = CDbl(varVal)
  
'              If MsgBox("lngFocalRow = " & CStr(lngFocalRow) & ", Band " & CStr(lngIndex2) & vbCrLf & _
                "booAllHasData(lngIndex = " & CStr(lngIndex) & ") = " & CStr(booAllHasData(lngIndex)) & vbCrLf & _
                "Not IsNull(varVal) = " & CStr(Not IsNull(varVal)) & vbCrLf & _
                "dblVal = " & CStr(dblVal), vbYesNo) = vbYes Then GoTo CleanUp
              
              ' ONLY ACCEPT VALUE IF IN DESIGNATED SLOPE CLASS
2106:               If lngIndex2 = 0 Then
2107:                 booInSlopeClass = False
2108:                 For lngIndex3 = 0 To UBound(dblSlopeVals)
2109:                   If dblVal = dblSlopeVals(lngIndex3) Then
2110:                     booInSlopeClass = True
2111:                     Exit For
2112:                   End If
2113:                 Next lngIndex3
                
'                MsgBox "Checking Slope Class:  Slope Class '" & CStr(dblVal) & "' is a specified value = " & UCase(CStr(booInSlopeClass))
                
2117:               Else
2118:                 dblLayerVector(lngIndex2 - 1) = dblVal
2119:               End If
              
2121:               If booInSlopeClass Then
2122:                 If booExportTable Then
2123:                   If lngFormatStyle = 0 Then              ' dBASE
2124:                     lngFieldIndex = pVariableIndices.Element(lngIndex2)
2125:                     pBuffer.Value(lngFieldIndex) = dblVal
2126:                   ElseIf lngFormatStyle = 1 Then          ' CSV
2127:                     strRow = strRow & CStr(Format(dblVal, "0.00000000")) & ","
2128:                   End If
2129:                 End If
2130:               Else
2131:                 booAddThisRow = False
2132:                 Exit For
2133:               End If
2134:             End If
2135:           End If
2136:         Next lngIndex2
        
        ' READY TO WRITE TABLE ROW OR CELL VALUE
2139:         If booAddThisRow Then
          
          ' CALCULATE CLUSTER AND CONFUSION VALUES
2142:           booInBins = CheckInBins(dblLayerVector, dblBins)
          
2144:           Set pFuzzyOutput = CalcFuzzyValues(dblLayerVector, dblCentroidVals, dblParamsVals, dblPhi)
          ' RETURN ARRAY WILL CONTAIN
          ' 0) DoubleArray for membership to each cluster
          ' 1) LONG: Number of nearest cluster
          ' 2) LONG: Number of 2nd Nearest Cluster
          ' 3) DOUBLE: Confusion Index Value
          
2151:           dblMemberships = pFuzzyOutput.Element(0)
2152:           lngHighestMembership = pFuzzyOutput.Element(1)
2153:           lngSecondMembership = pFuzzyOutput.Element(2)
2154:           dblConfusionIndex = pFuzzyOutput.Element(3)
          
2156:           If booExportTable Then
2157:             If lngFormatStyle = 0 Then             ' dBASE
2158:               pBuffer.Value(lngXIndex) = dblX
2159:               pBuffer.Value(lngYIndex) = dblY
2160:               pBuffer.Value(lngOutlierIndex) = UCase(CStr(Not booInBins))
              
2162:               For lngIndex2 = 0 To pClusterIndices.Count - 1
2163:                 pBuffer.Value(pClusterIndices.Element(lngIndex2)) = dblMemberships(lngIndex2)
2164:               Next lngIndex2
             
2166:               pBuffer.Value(lngHighClusterIndex) = lngHighestMembership
2167:               pBuffer.Value(lngSecondClusterIndex) = lngSecondMembership
2168:               pBuffer.Value(lngConfusionIndex) = dblConfusionIndex
              
2170:               pCursor.InsertRow pBuffer
2171:             ElseIf lngFormatStyle = 1 Then          ' CSV
2172:               strRow = strRow & CStr(Format(dblX, "0.00000000")) & "," & CStr(Format(dblY, "0.00000000")) & ","
2173:               For lngIndex2 = 0 To lngClusterCount
2174:                 strRow = strRow & CStr(Format(dblMemberships(lngIndex2), "0.00000000")) & ","
2175:               Next lngIndex2
2176:               strRow = strRow & CStr(Format(lngHighestMembership, "0")) & "," & CStr(Format(lngSecondMembership, "0")) & _
                  "," & CStr(Format(dblConfusionIndex, "0.00000000")) & "," & UCase(CStr(booInBins))
2178:               Print #lngFileNumber, strRow
2179:             End If
2180:           End If
          
          ' WRITE CELL VALUE
2183:           If booInBins And dblConfusionIndex <= dblThreshold Then
2184:             lngOut = lngHighestMembership
2185:           End If
2186:         End If
2187:       End If
      
      ' ---- UPDATE PROGRESS METER
2190:       If (lngFocalRow = lngHeight) Or DateDiff("s", dateRunningTime, Now) >= 2 Then
2191:         dateRunningTime = Now
2192:         DoEvents
2193:         theProgressSpecific = "Working on Raster Row " & CStr(lngFocalRow) & " of " & CStr(lngHeight) & "..."
2194:         theDetailedDescription = theDetailedDescription & _
          " --> " & theProgressSpecific & vbCrLf & _
          "          [time stamp " & Format(Now, "ttttt,  ddddd") & "]" & vbCrLf & vbCrLf
2197:         frmProgress.txtDetails.Text = theDetailedDescription
2198:         frmProgress.txtDetails.SelStart = Len(theDetailedDescription)
      
2200:         frmProgress.Est_Time_Left lngFocalRow, "Pass 2 of 2:  Extracting Cell Values, writing Land Facet values...", "Extracting Data: Row "
2201:         frmProgress.lblCurrentTime.Caption = Format(Now, "ttttt")
2202:         frmProgress.Refresh
2203:         frmProgress.icnProgressLine.Refresh
2204:         DoEvents
2205:         If LFR_BailOutOfProgress(frmProgress, pApp) Then
      
         ' ********************************************************************************************
          ' SIMPLE CODE
2209:           CalcLandFacetRaster = "Exited Function Prematurely..." & vbCrLf
      
         ' ********************************************************************************************
      
2213:           frmProgress.cmdStop.Caption = "Close"
2214:           pPro.position = 0
2215:           psbar.HideProgressBar
          Exit Function
2217:         End If
        ' ---- END PROGRESS METER STUFF --------------------------------
2219:         DoEvents
2220:       End If
      
2222:       varOutData(lngIndex, 0) = lngOut
      
2224:     Next lngIndex
    
    ' FLUSH CURRENT SET OF DATA TO TABLE
2227:     If booExportTable And lngFormatStyle = 0 Then
2228:       pCursor.Flush
2229:     End If
          
    ' FOR DEBUGGING
'    If lngFocalRow = 3 Then
'      strTestOutput = Replace(strWsName & "\varOutData_Row" & CStr(lngFocalRow) & ".txt", "\\", "\")
'      strTestOutput = TopoCorridor.MyGeneralOperations.MakeUniqueShapeFilename(strTestOutput)
'      lngFileNumber = FreeFile(0)
'      Open strTestOutput For Output Access Write As #lngFileNumber
'      For lngIndex2 = 0 To UBound(varOutData, 1)
'        strRow = "Column " & CStr(lngIndex2) & "] "
'        For lngIndex3 = 0 To UBound(varOutData, 2)
'          strRow = strRow & CStr(varOutData(lngIndex2, lngIndex3)) & ","
'        Next lngIndex3
'        strRow = strRow & "   IS MASKED = " & UCase(CStr(Not booAllHasData(lngIndex2)))
'    '    strRow = Left(strRow, Len(strRow) - 1)
'        Print #lngFileNumber, strRow
'      Next lngIndex2
'      Close #lngFileNumber
'      MsgBox "See " & strTestOutput
'      GoTo CleanUp
'    End If
    
    ' SAVE RASTER DATA TO HARD DRIVE
2252:     pOutputPixBlock.PixelData(0) = varOutData
    
          
    ' FOR DEBUGGING
'    If lngFocalRow = 3 Then
'      strTestOutput = Replace(strWsName & "\pOutputPixBlock_Row" & CStr(lngFocalRow) & ".txt", "\\", "\")
'      strTestOutput = TopoCorridor.MyGeneralOperations.MakeUniqueShapeFilename(strTestOutput)
'      lngFileNumber = FreeFile(0)
'      Open strTestOutput For Output Access Write As #lngFileNumber
'      For lngIndex2 = 0 To pOutputPixBlock.Width - 1
'        strRow = "Column " & CStr(lngIndex2) & "] "
'        strRow = strRow & CStr(pOutputPixBlock.GetVal(0, lngIndex2, 0)) & ","
'
'        strRow = strRow & "   IS MASKED = " & UCase(CStr(Not booAllHasData(lngIndex2)))
'    '    strRow = Left(strRow, Len(strRow) - 1)
'        Print #lngFileNumber, strRow
'      Next lngIndex2
'      Close #lngFileNumber
'      MsgBox "See " & strTestOutput
'      GoTo CleanUp
'    End If
    
    
2275:     pOutRasterEdit.Write pOutPnt, pOutputPixBlock
2276:     If lngFocalRow Mod 20 = 0 Then
2277:       pOutRasterEdit.Refresh
2278:     End If
    
    ' MOVE TO NEXT ROW
2281:     lngFocalRow = lngFocalRow + 1
    
2283:     pRastCursor.Next
2284:     Set pPixBlock = pRastCursor.PixelBlock
        
'    pPixBlock.PixelType(0) = PT_FLOAT
'    varData = pPixBlock.PixelDataByRef(0)
'    booHasData = ConvertNoDataMaskToSomethingUseful(pPixBlock.NoDataMaskByRef(0))

    ' RESET HAS-DATA ARRAY TO ALL TRUE
2291:     For lngIndex = 0 To pPixBlock.Planes - 1
2292:       pPixBlock.PixelType(lngIndex) = PT_FLOAT
2293:     Next lngIndex
    
2295:     For lngIndex = 0 To lngWidth - 1
'      pPixBlock.PixelType(lngIndex) = PT_FLOAT
2297:       booAllHasData(lngIndex) = True
2298:     Next lngIndex
    
    ' CHECK HAS DATA ARRAYS FOR ALL LEVELS; RESET booAllHasData TO FALSE IF ANY VALUES ARE FALSE
2301:     For lngIndex = 0 To lngNumBands
2302:       varData = pPixBlock.PixelDataByRef(lngIndex)
2303:       booHasData = ConvertNoDataMaskToSomethingUseful(pPixBlock.NoDataMaskByRef(lngIndex))
2304:       For lngIndex2 = 0 To lngWidth - 1
2305:         varAllData(lngIndex2, lngIndex) = varData(lngIndex2, 0)
2306:         If booHasData(lngIndex2) = False Then booAllHasData(lngIndex2) = False
2307:       Next lngIndex2
2308:     Next lngIndex
    
2310:   Loop
  
2312:   pOutRasterEdit.Refresh
  

  '  ----------------------------
  
  ' SYMBOLIZE ADD LAND FACET RASTER TO MAP
  Dim pNewLayer As IRasterLayer
  Dim pStretchRen As IRasterStretchColorRampRenderer
  Dim pRasRen As IRasterRenderer
  Dim pRedColor As IColor
  Dim pYellowColor As IColor
  Dim pGreenColor As IColor
  Dim pRamp1 As IAlgorithmicColorRamp
  Dim pRamp2 As IAlgorithmicColorRamp
  Dim pMultiRamp As IMultiPartColorRamp
  
  Dim pNameField As IField
  Dim pNameFieldEdit As IFieldEdit
  Dim lngValue As Long
  Dim lngValueIndex As Long
  Dim lngNameIndex As Long
  Dim pRastTableCursor As ICursor
  Dim pRastRow As IRow
  Dim pLandFacetLayer As IRasterLayer
  Dim NumOfValues As Integer
  Dim pColor1 As IRgbColor
  Dim pColor2 As IRgbColor
  Dim pColor3 As IRgbColor
  Dim pColor4 As IRgbColor
  Dim pColor5 As IRgbColor
  Dim pCatRaster As IRaster
  Dim pFSymbol As ISimpleFillSymbol
  Dim pUVRen As IRasterUniqueValueRenderer
  Dim pColor As IRgbColor
  Dim lngRedStart As Long
  Dim lngRedEnd As Long
  Dim lngGreenStart As Long
  Dim lngGreenEnd As Long
  Dim lngBlueStart As Long
  Dim lngBlueEnd As Long
  Dim lngRedInterval As Long
  Dim lngGreenInterval As Long
  Dim lngBlueInterval As Long
  Dim varLabelValue As Variant
  Dim lngOID As Long
  
2358:   psbar.Message(0) = "  --> Adding Land Facet Layer to map..."

  Dim pStatsBandColl As IRasterBandCollection
  Dim pStatsBand As IRasterBand
2362:   Set pStatsBandColl = pOutDS
2363:   Set pStatsBand = pStatsBandColl.Item(0)
 ' pStatsBand.ComputeStatsAndHist
  Dim pStats As IRasterStatistics
2366:   Set pStats = pStatsBand.Statistics
2367:   pStats.Recalculate
2368:   Set pStatsBand = Nothing
2369:   Set pStatsBandColl = Nothing
2370:   Set pStats = Nothing


2373:   Set pSubArray = Nothing
2374:   Set pSlopeClassBand = Nothing
2375:   Set pSlopeVals = Nothing
2376:   Set pForm2Params = Nothing
2377:   Set pCentroidData = Nothing
2378:   Set pBinWidthData = Nothing
2379:   Set pParamsData = Nothing
2380:   Set pEvalData = Nothing
2381:   Set pRasterLayer = Nothing
2382:   Set pRasterBand = Nothing
2383:   Set pUnknown = Nothing
2384:   Set pTemplateBand = Nothing
2385:   Set pTemplateRaster = Nothing
2386:   Set pTemplateDataset = Nothing
2387:   Set pTemplateProps = Nothing
2388:   Set pTemplateSpRef = Nothing
2389:   Set pTemplatePnt = Nothing
2390:   Set strInputBand = Nothing
2391:   Set pRastMakerOp = Nothing
2392:   Set pRastAnEnv = Nothing
2393:   Set pEnv = Nothing
2394:   Set pOneDataset = Nothing
2395:   Set pTempRaster = Nothing
2396:   Set pMathOp = Nothing
2397:   Set pMathEnv = Nothing
2398:   Set pInBandColl = Nothing
2399:   Set pAddBand = Nothing
2400:   Set pNewBand = Nothing
2401:   Set pNewDataset = Nothing
2402:   Set pNewBandColl = Nothing
2403:   Set pInProps = Nothing
2404:   Set pOutputFNames = Nothing
2405:   Set pTempConversionRasterDataset = Nothing
2406:   Set pConOp = Nothing
2407:   Set pTempAnEnv = Nothing
2408:   Set pFeatGeoDataset = Nothing
2409:   Set pTempRastDataset = Nothing
2410:   Set pTempBand = Nothing
2411:   Set pRastProps = Nothing
2412:   Set pPnt = Nothing
2413:   Set pPixBlock = Nothing
2414:   Set pTopLeft = Nothing
2415:   Set pRastCursor = Nothing
2416:   Set pInputRaster = Nothing
2417:   Set pTempProps = Nothing
2418:   Set pTempPixBlock = Nothing
2419:   Set pTemporaryRaster = Nothing
2420:   Set pTempPoint = Nothing
2421:   Set pTempOrigin = Nothing
2422:   Set pTempRast2 = Nothing
2423:   Set pFuzzyOutput = Nothing
2424:   Set pOutDS = Nothing
2425:   Set pOutRasterEdit = Nothing
2426:   Set pRasterStorDef = Nothing
2427:   Set pRasterDef = Nothing
2428:   Set pGeomDef = Nothing
2429:   Set pOriginPoint = Nothing
2430:   Set pOutPnt = Nothing
2431:   Set pOutProps = Nothing
2432:   Set pOutBandColl = Nothing
2433:   Set pTempOutBandColl = Nothing
2434:   Set pOutBand = Nothing
2435:   Set pRastDatasetEdit = Nothing
2436:   Set pTempOutRaster = Nothing
2437:   Set pOutputPixBlock = Nothing
2438:   Set pOutputRaster = Nothing
2439:   Set pOutputRaster2 = Nothing
2440:   Set pRawPixel = Nothing
2441:   Set pOutPixelBlock = Nothing
2442:   Set pBands = Nothing
2443:   Set pOutputRastProps = Nothing


  
  Dim pTempDS As IRasterDataset
  Dim pMathOp2 As IMathOp
  Dim pDataset As IDataset
  Dim pSaveAs As ISaveAs2
  Dim pNewDS As IRasterDataset
  Dim pRastPyramid As IRasterPyramid
  
2454:   If lngDocVersion <= 3 Then
  
2456:     Set pNewDS = pOutputRastWS.OpenRasterDataset(strOutputRasterName & strExtension)
2457:     Set pStatsBandColl = pNewDS
2458:     Set pStatsBand = pStatsBandColl.Item(0)
2459:     pStatsBand.ComputeStatsAndHist
    
2461:     Set pRastPyramid = pNewDS
2462:     pRastPyramid.Create
    
2464:   Else
  
2466:     Set pTempDS = pOutputRastWS.OpenRasterDataset(strTemp10Name)
2467:     Set pDataset = pTempDS
2468:     Set pMathOp2 = New RasterMathOps
2469:     Set pTempRaster = pMathOp2.Int(pTempDS)
2470:     Set pNewDS = pTempRaster.RasterDataset
    
2472:     Set pTempRaster = Nothing
2473:     Set pTempDS = Nothing
2474:     pDataset.DELETE
    
2476:     Set pSaveAs = pNewDS
2477:     pSaveAs.SaveAs strOutputRasterName & strExtension, pOutputRastWS, strOutputSaveFormat
    
2479:     Set pDataset = pNewDS
2480:     Set pNewDS = Nothing
2481:     pDataset.DELETE
  
2483:     Set pNewDS = pOutputRastWS.OpenRasterDataset(strOutputRasterName & strExtension)
2484:     Set pStatsBandColl = pNewDS
2485:     Set pStatsBand = pStatsBandColl.Item(0)
2486:     pStatsBand.ComputeStatsAndHist
    
2488:     Set pRastPyramid = pNewDS
2489:     pRastPyramid.Create
    
2491:   End If
  
'  psaveas.

  
'    Set pOutDS = pOutputRastWS.CreateRasterDataset(strOutputRasterName & strExtension, strOutputSaveFormat, pOriginPoint, lngWidth, lngHeight, _
'        pRastProps.MeanCellSize.X, pRastProps.MeanCellSize.Y, 1, PT_FLOAT, pSpRef, True)
'
'  Dim strTempName As String
'  Dim pTempWS As IWorkspace2
'  Set pTempWS = pOutputRastWS
'  strTempName = "temp"
'  Dim strBaseName As String
'  strBaseName = "temp"
'  Dim lngTempCounter As Long
'  lngTempCounter = 1
'  Do Until Not pTempWS.NameExists(esriDTAny, strTempName)
'    lngTempCounter = lngTempCounter + 1
'    strTempName = strBaseName & "_" & CStr(lngTempCounter)
'  Loop
'
'
'
'  Set pOutDS = pOutputRastWS.OpenRasterDataset(strOutputRasterName & strExtension)



  ' ADD CORRECT CLASS NAMES TO RASTER ATTRIBUTE TABLE
  ' FIRST ADD NAME FIELD
2520:   psbar.Message(0) = "Updating Land Facet Table..."
  Dim pRastTable As ITable
'  MsgBox TypeOf pStatsBand Is ITable
  
'  Set pRastTable = pStatsBand.AttributeTable
2525:   Set pRastTable = TopoCorridor.TopoCor_Functions.ReturnRasterTable(pStatsBand)
2526:   If Not pRastTable Is Nothing Then
    
2528:     If strOutputSaveFormat = "GRID" Then
2529:       Set pNameField = New Field
2530:       Set pNameFieldEdit = pNameField
2531:       With pNameFieldEdit
2532:         .Name = "Land_Facet"
2533:         .Type = esriFieldTypeString
2534:         .length = 50
2535:       End With
2536:       pRastTable.AddField pNameField          ' <---------------
      ' NEXT ADD CLASS VALUES TO NEW FIELD
    
2539:       lngValueIndex = pRastTable.FindField("VALUE")
2540:       lngNameIndex = pRastTable.FindField("Land_Facet")
    
2542:       Set pRastTableCursor = pRastTable.Update(Nothing, False)
2543:       Set pRastRow = pRastTableCursor.NextRow
2544:       Do Until pRastRow Is Nothing
2545:         lngValue = pRastRow.Value(lngValueIndex)
2546:         pRastRow.Value(lngNameIndex) = "Land Facet " & CStr(lngValue)
2547:         pRastTableCursor.UpdateRow pRastRow
2548:         Set pRastRow = pRastTableCursor.NextRow
2549:       Loop
2550:     End If
  
2552:     Set pLandFacetLayer = New RasterLayer
2553:     pLandFacetLayer.CreateFromDataset pNewDS
2554:     pLandFacetLayer.Name = strOutputRasterName
    
2556:     NumOfValues = pRastTable.RowCount(Nothing)
    
    ' CREATE CLASS COLORS
2559:     Set pColor1 = New RgbColor
2560:     Set pColor2 = New RgbColor
2561:     Set pColor3 = New RgbColor
2562:     Set pColor4 = New RgbColor
2563:     Set pColor5 = New RgbColor
    
    Select Case NumOfValues
      Case 1
2567:         pColor1.RGB = RGB(34, 102, 51)
      Case 2
2569:         pColor1.RGB = RGB(69, 117, 181)
2570:         pColor2.RGB = RGB(214, 47, 39)
      Case 3
2572:         pColor1.RGB = RGB(69, 117, 181)
2573:         pColor2.RGB = RGB(255, 255, 191)
2574:         pColor3.RGB = RGB(214, 47, 39)
      Case 4
2576:         pColor1.RGB = RGB(194, 82, 60)
2577:         pColor2.RGB = RGB(247, 215, 7)
2578:         pColor3.RGB = RGB(14, 196, 65)
2579:         pColor4.RGB = RGB(11, 44, 122)
      Case 5
2581:         pColor1.RGB = RGB(194, 82, 60)
2582:         pColor2.RGB = RGB(240, 180, 17)
2583:         pColor3.RGB = RGB(123, 237, 0)
2584:         pColor4.RGB = RGB(27, 168, 124)
2585:         pColor5.RGB = RGB(11, 44, 122)
      Case Else
2587:         pColor1.RGB = RGB(69, 117, 181)
2588:         pColor2.RGB = RGB(214, 47, 39)
2589:     End Select
    
2591:     Set pCatRaster = pLandFacetLayer.Raster
    ' Create UniqueValue renderer and QI RasterRenderer
2593:     Set pUVRen = New RasterUniqueValueRenderer
2594:     Set pRasRen = pUVRen
  
    ' Connect the renderer and the raster
2597:     Set pRasRen.Raster = pCatRaster
2598:     pRasRen.Update
    
    ' Set UniqueValue renerer
2601:     pUVRen.HeadingCount = 1   ' Use one heading
2602:     pUVRen.Heading(0) = "Land Facets"
2603:     pUVRen.ClassCount(0) = NumOfValues
2604:     If strOutputSaveFormat = "GRID" Then
2605:       pUVRen.Field = "Land_Facet"
2606:     Else
2607:       pUVRen.Field = "Value"
2608:     End If
    
2610:     lngRedStart = 69
2611:     lngRedEnd = 214
2612:     lngGreenStart = 117
2613:     lngGreenEnd = 47
2614:     lngBlueStart = 181
2615:     lngBlueEnd = 39
    
    
2618:     lngRedInterval = (lngRedEnd - lngRedStart) / NumOfValues
2619:     lngGreenInterval = (lngGreenEnd - lngGreenStart) / NumOfValues
2620:     lngBlueInterval = (lngBlueEnd - lngBlueStart) / NumOfValues
    
2622:     Set pRastTableCursor = pRastTable.Update(Nothing, False)
2623:     Set pRastRow = pRastTableCursor.NextRow
2624:     Do Until pRastRow Is Nothing
2625:       lngValue = pRastRow.Value(lngValueIndex)
2626:       lngOID = pRastRow.OID
      
    '  MsgBox "pRastRow.Value(lngValueIndex) = pRastRow.Value(" & CStr(lngValueIndex) & ") = " & _
            CStr(pRastRow.Value(lngValueIndex))
      
      Select Case lngValue
        Case 1
2633:           varLabelValue = "Land Facet 1"
2634:           pUVRen.AddValue 0, lngOID, varLabelValue  'Get a row from the table
2635:           pUVRen.Label(0, lngOID) = CStr(varLabelValue) ' Set label
2636:           Set pFSymbol = New SimpleFillSymbol
          Select Case NumOfValues
            Case 1, 2, 3, 4, 5
2639:               pFSymbol.Color = pColor1
            Case Else
2641:               pFSymbol.Color = pColor1
2642:           End Select
2643:           pUVRen.Symbol(0, lngOID) = pFSymbol  'Set symbol
        Case 2
2645:           varLabelValue = "Land Facet 2"
2646:           pUVRen.AddValue 0, lngOID, varLabelValue  'Get a row from the table
2647:           pUVRen.Label(0, lngOID) = CStr(varLabelValue) ' Set label
2648:           Set pFSymbol = New SimpleFillSymbol
          Select Case NumOfValues
            Case 1, 2, 3, 4, 5
2651:               pFSymbol.Color = pColor2
            Case Else
2653:               Set pColor = New RgbColor
2654:               pColor.RGB = RGB(lngRedStart + ((lngValue - 1) * lngRedInterval), _
                               lngGreenStart + ((lngValue - 1) * lngGreenInterval), _
                               lngBlueStart + ((lngValue - 1) * lngBlueInterval))
2657:               pFSymbol.Color = pColor
2658:           End Select
2659:           pUVRen.Symbol(0, lngOID) = pFSymbol  'Set symbol
        Case 3
2661:           varLabelValue = "Land Facet 3"
2662:           pUVRen.AddValue 0, lngOID, varLabelValue   'Get a row from the table
2663:           pUVRen.Label(0, lngOID) = CStr(varLabelValue) ' Set label
2664:           Set pFSymbol = New SimpleFillSymbol
          Select Case NumOfValues
            Case 1, 2, 3, 4, 5
2667:               pFSymbol.Color = pColor3
            Case Else
2669:               Set pColor = New RgbColor
2670:               pColor.RGB = RGB(lngRedStart + ((lngValue - 1) * lngRedInterval), _
                               lngGreenStart + ((lngValue - 1) * lngGreenInterval), _
                               lngBlueStart + ((lngValue - 1) * lngBlueInterval))
2673:               pFSymbol.Color = pColor
2674:           End Select
2675:           pUVRen.Symbol(0, lngOID) = pFSymbol  'Set symbol
        Case 4
2677:           varLabelValue = "Land Facet 4"
2678:           pUVRen.AddValue 0, lngOID, varLabelValue   'Get a row from the table
2679:           pUVRen.Label(0, lngOID) = CStr(varLabelValue) ' Set label
2680:           Set pFSymbol = New SimpleFillSymbol
          Select Case NumOfValues
            Case 1, 2, 3, 4, 5
2683:               pFSymbol.Color = pColor4
            Case Else
2685:               Set pColor = New RgbColor
2686:               pColor.RGB = RGB(lngRedStart + ((lngValue - 1) * lngRedInterval), _
                               lngGreenStart + ((lngValue - 1) * lngGreenInterval), _
                               lngBlueStart + ((lngValue - 1) * lngBlueInterval))
2689:               pFSymbol.Color = pColor
2690:           End Select
2691:           pUVRen.Symbol(0, lngOID) = pFSymbol  'Set symbol
        Case 5
2693:           varLabelValue = "Land Facet 5"
2694:           pUVRen.AddValue 0, lngOID, varLabelValue   'Get a row from the table
2695:           pUVRen.Label(0, lngOID) = CStr(varLabelValue) ' Set label
2696:           Set pFSymbol = New SimpleFillSymbol
          Select Case NumOfValues
            Case 1, 2, 3, 4, 5
2699:               pFSymbol.Color = pColor5
            Case Else
2701:               Set pColor = New RgbColor
2702:               pColor.RGB = RGB(lngRedStart + ((lngValue - 1) * lngRedInterval), _
                               lngGreenStart + ((lngValue - 1) * lngGreenInterval), _
                               lngBlueStart + ((lngValue - 1) * lngBlueInterval))
2705:               pFSymbol.Color = pColor
2706:           End Select
2707:           pUVRen.Symbol(0, lngOID) = pFSymbol  'Set symbol
        Case Else
2709:           varLabelValue = "Land Facet " & CStr(lngValue)
2710:           pUVRen.AddValue 0, lngOID, varLabelValue 'Get a row from the table
2711:           pUVRen.Label(0, lngOID) = CStr(varLabelValue) ' Set label
2712:           Set pFSymbol = New SimpleFillSymbol
2713:           Set pColor = New RgbColor

'            ERROR BELOW:  MAY 31, 2013
2716:           pColor.RGB = RGB(lngRedStart + ((lngValue - 1) * lngRedInterval), _
                           lngGreenStart + ((lngValue - 1) * lngGreenInterval), _
                           lngBlueStart + ((lngValue - 1) * lngBlueInterval))
2719:           pFSymbol.Color = pColor
2720:           pUVRen.Symbol(0, lngOID) = pFSymbol  'Set symbol
2721:       End Select
2722:       pRastTableCursor.UpdateRow pRastRow
  
2724:       Set pRastRow = pRastTableCursor.NextRow
2725:     Loop
   
  
    'Update render and refresh layer
2729:     pRasRen.Update
2730:     Set pLandFacetLayer.Renderer = pUVRen
  
  
2733:     pMxDoc.FocusMap.AddLayer pLandFacetLayer
2734:   Else
  
    ' ADD RASTER TO MAP DOCUMENT
2737:     Set pNewLayer = New RasterLayer
2738:     pNewLayer.CreateFromDataset pNewDS
2739:     pNewLayer.Name = strOutputRasterName
  
    ' SYMBOLIZE RASTER LAYER
  
    ' Create renderer and QI RasterRenderer
2744:     Set pStretchRen = New RasterStretchColorRampRenderer
2745:     Set pRasRen = pStretchRen
    
    Dim pRasterStretch As IRasterStretch
2748:     Set pRasterStretch = pStretchRen
2749:     pRasterStretch.StretchType = esriRasterStretch_NONE
    
    ' Set raster for the renderer and update
2752:     Set pRasRen.Raster = pNewLayer.Raster
2753:     pRasRen.Update
  
    ' COLORS
  
2757:     Set pRedColor = New RgbColor
2758:     Set pYellowColor = New RgbColor
2759:     Set pGreenColor = New RgbColor
  
2761:     pRedColor.RGB = RGB(190, 0, 0)
2762:     pYellowColor.RGB = RGB(255, 255, 200)
2763:     pGreenColor.RGB = RGB(0, 140, 0)
  
    ' CREATE COLOR RAMPS
2766:     Set pRamp1 = New AlgorithmicColorRamp
2767:     pRamp1.Algorithm = esriLabLChAlgorithm
2768:     pRamp1.Size = 130
2769:     pRamp1.FromColor = pRedColor
2770:     pRamp1.ToColor = pYellowColor
2771:     pRamp1.CreateRamp True
  
2773:     Set pRamp2 = New AlgorithmicColorRamp
2774:     pRamp2.Algorithm = esriLabLChAlgorithm
2775:     pRamp2.Size = 130
2776:     pRamp2.FromColor = pYellowColor
2777:     pRamp2.ToColor = pGreenColor
2778:     pRamp2.CreateRamp True
  
2780:     Set pMultiRamp = New MultiPartColorRamp
2781:     pMultiRamp.Ramp(0) = pRamp1
2782:     pMultiRamp.Ramp(1) = pRamp2
2783:     pMultiRamp.Size = 260
2784:     pMultiRamp.CreateRamp True
  
    ' Plug this colorramp into renderer and select a band
2787:     pStretchRen.BandIndex = 0
2788:     pStretchRen.ColorRamp = pMultiRamp
  
    ' Update the renderer with new settings and plug into layer
2791:     pRasRen.Update
2792:     Set pNewLayer.Renderer = pStretchRen
  
2794:     pMxDoc.AddLayer pNewLayer
2795:   End If
'-----------------------------------
   
  Dim pStandaloneTable As IStandaloneTable
  Dim pStTabColl As IStandaloneTableCollection
  Dim pTableWindow2 As ITableWindow2
2801:   If booExportTable Then
2802:     If lngFormatStyle = 0 Then              ' dBASE
2803:       pCursor.Flush
2804:       Set pStTabColl = pMxDoc.FocusMap
2805:       Set pStandaloneTable = New StandaloneTable
2806:       Set pStandaloneTable.Table = pTable
2807:       pStTabColl.AddStandaloneTable pStandaloneTable
2808:       pMxDoc.UpdateContents
      
2810:       Set pTableWindow2 = New TableWindow
2811:       With pTableWindow2
2812:         Set .StandaloneTable = pStandaloneTable
2813:         Set .Application = pApp
2814:         .TableSelectionAction = esriSelectFeatures
2815:         .ShowAliasNamesInColumnHeadings = True
2816:         .ShowSelected = False
2817:         .Show True
2818:       End With
      
2820:     ElseIf lngFormatStyle = 1 Then          ' CSV
2821:       Close #lngFileNumber
2822:     End If
2823:   End If
  
  ' FOR DEBUGGING
  Dim pCombineLayer As IRasterLayer
2827:   If booAddCombinedToMap Then
2828:     Set pCombineLayer = New RasterLayer
2829:     pCombineLayer.CreateFromRaster pInRaster
2830:     pCombineLayer.Name = "Combined"
2831:     pMxDoc.AddLayer pCombineLayer
2832:   End If
  
2834:   psbar.HideProgressBar
2835:   pPro.position = 0
2836:   If frmProgress.chkClose.Value = 1 Then
2837:     frmProgress.Frame.Visible = False
2838:     Set frmProgress = Nothing
2839:   Else
2840:     theProgressSpecific = "Calculations Complete..."
2841:     theDetailedDescription = theDetailedDescription & _
      " --> " & theProgressSpecific & vbCrLf & _
      "          [time stamp " & Format(Now, "ttttt,  ddddd") & "]" & vbCrLf & vbCrLf & _
      TopoCorridor.MyGeneralOperations.ReturnTimeElapsed(theTimeBegan, Now)
2845:       frmProgress.txtDetails.Text = theDetailedDescription
2846:       frmProgress.txtDetails.SelStart = Len(theDetailedDescription)
2847:       frmProgress.cmdStop.Caption = "Close"
2848:   End If
  
  ' MAKE FINAL REPORT
2851:   strBaseString = "{\rtf1\ansi\ansicpg1252\deff0\deflang1033{\fonttbl{\f0\fswiss\fcharset0 Arial;}{\f1\fmodern\fprq1\fcharset0 Courier New;}{\f2\fnil\fcharset0 MS Sans Serif;}}" & vbNewLine
2852:   strBaseString = strBaseString & "\viewkind4\uc1\pard\qc\b\f0\fs20 -- Land Facet Analysis Complete --\b0 " & vbNewLine
2853:   strBaseString = strBaseString & "\par \pard\qc ---------------------------------- " & vbNewLine
2854:   strBaseString = strBaseString & "\par\fs16 \pard\b Slope Class Raster = \b0\i " & strSlopeClassName & " \i0 " & vbNewLine
2855:   strBaseString = strBaseString & "\par -- Attribute Value = " & strSlopeClassAttValue & " from field [" & _
          strSlopeClassFieldName & "] " & vbNewLine
2857:   strBaseString = strBaseString & "\par " & vbNewLine
  
2859:   strBaseString = strBaseString & "\par \pard\qc\b New Land Facet Raster \b0" & vbNewLine
2860:   strBaseString = strBaseString & "\par \pard  -- Filename: " & strOutputRasterName & strExtension & vbNewLine
2861:   strBaseString = strBaseString & "\par  -- Output Format: " & strOutputSaveFormatForReport & vbNewLine
2862:   strBaseString = strBaseString & "\par  -- Workspace: " & Replace(pWS.PathName, "\", "\\") & vbNewLine
2863:   strBaseString = strBaseString & "\par  -- Option to Create Table of Cluster Statistics per Cell: \b " & UCase(CStr(booExportTable)) & " \b0" & vbNewLine
2864:   If booExportTable Then
2865:     strBaseString = strBaseString & "\par    -- Table Format: " & pForm1Params.Element(19) & vbNewLine
2866:     strBaseString = strBaseString & "\par    -- Table Filename: " & Replace(strFullFilePath, "\", "\\") & vbNewLine
2867:   End If
2868:   strBaseString = strBaseString & "\par " & vbNewLine
      
  ' FORM 2 PARAMETERS
2871:   strBaseString = strBaseString & "\par \pard\qc\b Statistical CSV Files \b0" & vbNewLine
2872:   strBaseString = strBaseString & strCentroidsInput & vbNewLine
2873:   strBaseString = strBaseString & "\par " & vbNewLine
2874:   strBaseString = strBaseString & strBinWidthInput & vbNewLine
2875:   strBaseString = strBaseString & "\par " & vbNewLine
2876:   strBaseString = strBaseString & strParamsInput & vbNewLine
2877:   strBaseString = strBaseString & "\par " & vbNewLine
2878:   strBaseString = strBaseString & strEvalInput & vbNewLine
2879:   strBaseString = strBaseString & "\par " & vbNewLine
  
  ' FORM 3 PARAMETERS
2882:   strBaseString = strBaseString & "\par \pard\qc\b Layer Variables \b0" & vbNewLine
2883:   For lngIndex = 0 To pLayerVarsArray.Count - 1
2884:     Set pSubArray = pLayerVarsArray.Element(lngIndex)
2885:     strVariableName = pSubArray.Element(0)
2886:     If lngIndex = 0 Then
2887:       strBaseString = strBaseString & "\par \pard\b Variable #" & CStr(lngIndex + 1) & "] " & strVariableName & "\b0" & vbNewLine
2888:     Else
2889:       strBaseString = strBaseString & "\par\b Variable #" & CStr(lngIndex + 1) & "] " & strVariableName & "\b0" & vbNewLine
2890:     End If
2891:     Set pUnknown = pSubArray.Element(1)
2892:     strLayerName = pSubArray.Element(2)
2893:     If TypeOf pUnknown Is IFeatureLayer Then
2894:       strFieldName = pSubArray.Element(4)
2895:       strBaseString = strBaseString & "\par -- Feature Layer, '" & strLayerName & "'" & vbNewLine
2896:       strBaseString = strBaseString & "\par          Attribute Field = [" & strFieldName & "]" & vbNewLine
2897:     Else
2898:       strBaseString = strBaseString & "\par -- Raster Band, '" & strLayerName & "'" & vbNewLine
2899:     End If
2900:     strBaseString = strBaseString & "\par " & vbNewLine
2901:   Next lngIndex
    
  ' FORM 4 PARAMETERS
2904:   strBaseString = strBaseString & "\par \pard\qc\b Fuzzy C-Means Clustering Parameters \b0" & vbNewLine
2905:   strBaseString = strBaseString & "\par \pard -- Fuzziness Parameter = " & CStr(dblPhi) & vbNewLine
2906:   strBaseString = strBaseString & "\par -- Confusion Index Threshold = " & CStr(dblThreshold) & vbNewLine
  
  ' END REPORT
2909:   strBaseString = strBaseString & "\par \pard\qc ---------------------------------- " & vbNewLine
2910:   strBaseString = strBaseString & "\par " & vbNewLine
2911:   strBaseString = strBaseString & TopoCorridor.MyGeneralOperations.ReturnTimeElapsedRTF(datTimeBegan, Now, 7)
2912:   strBaseString = strBaseString & "\par }" & vbNewLine
  
2914:   CalcLandFacetRaster = strBaseString
  
  ' CLEANUP
2917:   GoTo CleanUp
  
  Exit Function
ErrorHandler:
  HandleError True, "CalcLandFacetRaster " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4

  Dim strReport As String
  strReport = strReport & "  strBaseString = " & CStr(strBaseString) & vbCrLf     ' Dim strBaseString As String
  strReport = strReport & "  lngIndex = " & CStr(lngIndex) & vbCrLf     ' Dim lngIndex As Long
  strReport = strReport & "  lngIndex2 = " & CStr(lngIndex2) & vbCrLf     ' Dim lngIndex2 As Long
  strReport = strReport & "  lngIndex3 = " & CStr(lngIndex3) & vbCrLf     ' Dim lngIndex3 As Long
  strReport = strReport & "  datTimeBegan = " & CStr(datTimeBegan) & vbCrLf     ' Dim datTimeBegan As Date
  strReport = strReport & "  strSlopeClassName = " & CStr(strSlopeClassName) & vbCrLf     ' Dim strSlopeClassName As String
  strReport = strReport & "  strSlopeClassFieldName = " & CStr(strSlopeClassFieldName) & vbCrLf     ' Dim strSlopeClassFieldName As String
  strReport = strReport & "  strSlopeClassAttValue = " & CStr(strSlopeClassAttValue) & vbCrLf     ' Dim strSlopeClassAttValue As String
  strReport = strReport & "  strOutputSaveFormat = " & CStr(strOutputSaveFormat) & vbCrLf     ' Dim strOutputSaveFormat As String
  strReport = strReport & "  strOutputSaveFormatForReport = " & CStr(strOutputSaveFormatForReport) & vbCrLf     ' Dim strOutputSaveFormatForReport As String
  strReport = strReport & "  strOutputRasterName = " & CStr(strOutputRasterName) & vbCrLf     ' Dim strOutputRasterName As String
  strReport = strReport & "  strExtension = " & CStr(strExtension) & vbCrLf     ' Dim strExtension As String
  strReport = strReport & "  ubound(dblSlopeVals) = " & CStr(UBound(dblSlopeVals)) & vbCrLf     ' Dim dblSlopeVals() As Double
  strReport = strReport & "  strCentroidsInput = " & CStr(strCentroidsInput) & vbCrLf     ' Dim strCentroidsInput As String
  strReport = strReport & "  strBinWidthInput = " & CStr(strBinWidthInput) & vbCrLf     ' Dim strBinWidthInput As String
  strReport = strReport & "  strParamsInput = " & CStr(strParamsInput) & vbCrLf     ' Dim strParamsInput As String
  strReport = strReport & "  strEvalInput = " & CStr(strEvalInput) & vbCrLf     ' Dim strEvalInput As String
  strReport = strReport & "  ubound(dblCentroidVals) = " & CStr(UBound(dblCentroidVals)) & vbCrLf     ' Dim dblCentroidVals() As Double
  strReport = strReport & "  ubound(dblBinWidthVals) = " & CStr(UBound(dblBinWidthVals)) & vbCrLf     ' Dim dblBinWidthVals() As Double
  strReport = strReport & "  ubound(dblParamsVals) = " & CStr(UBound(dblParamsVals)) & vbCrLf     ' Dim dblParamsVals() As Double
  strReport = strReport & "  ubound(dblEvalVals) = " & CStr(UBound(dblEvalVals)) & vbCrLf     ' Dim dblEvalVals() As Double
  strReport = strReport & "  lngVariableCount = " & CStr(lngVariableCount) & vbCrLf     ' Dim lngVariableCount As Long
  strReport = strReport & "  lngClusterCount = " & CStr(lngClusterCount) & vbCrLf     ' Dim lngClusterCount As Long
  strReport = strReport & "  ubound(dblBins) = " & CStr(UBound(dblBins)) & vbCrLf     ' Dim dblBins() As Double
  strReport = strReport & "  ubound(dblHalfBinWidths) = " & CStr(UBound(dblHalfBinWidths)) & vbCrLf     ' Dim dblHalfBinWidths() As Double
  strReport = strReport & "  dblTempVal = " & CStr(dblTempVal) & vbCrLf     ' Dim dblTempVal As Double
  strReport = strReport & "  dblBinHalfWidth = " & CStr(dblBinHalfWidth) & vbCrLf     ' Dim dblBinHalfWidth As Double
  strReport = strReport & "  strVariableName = " & CStr(strVariableName) & vbCrLf     ' Dim strVariableName As String
  strReport = strReport & "  strLayerName = " & CStr(strLayerName) & vbCrLf     ' Dim strLayerName As String
  strReport = strReport & "  strFieldName = " & CStr(strFieldName) & vbCrLf     ' Dim strFieldName As String
  strReport = strReport & "  dblPhi = " & CStr(dblPhi) & vbCrLf     ' Dim dblPhi As Double
  strReport = strReport & "  dblThreshold = " & CStr(dblThreshold) & vbCrLf     ' Dim dblThreshold As Double
  strReport = strReport & "  strTemplateName = " & CStr(strTemplateName) & vbCrLf     ' Dim strTemplateName As String
  strReport = strReport & "  strInputName = " & CStr(strInputName) & vbCrLf     ' Dim strInputName As String
  strReport = strReport & "  strOutputFormat = " & CStr(strOutputFormat) & vbCrLf     ' Dim strOutputFormat As String
  strReport = strReport & "  strFullFilename = " & CStr(strFullFilename) & vbCrLf     ' Dim strFullFilename As String
  strReport = strReport & "  strFullFilePath = " & CStr(strFullFilePath) & vbCrLf     ' Dim strFullFilePath As String
  strReport = strReport & "  strWsName = " & CStr(strWsName) & vbCrLf     ' Dim strWsName As String
  strReport = strReport & "  lngTransformCount = " & CStr(lngTransformCount) & vbCrLf     ' Dim lngTransformCount As Long
  strReport = strReport & "  lngTransformCounter = " & CStr(lngTransformCounter) & vbCrLf     ' Dim lngTransformCounter As Long
  strReport = strReport & "  theTimeBegan = " & CStr(theTimeBegan) & vbCrLf     ' Dim theTimeBegan As Date
  strReport = strReport & "  dateRunningTime = " & CStr(dateRunningTime) & vbCrLf     ' Dim dateRunningTime As Date
  strReport = strReport & "  strHeader = " & CStr(strHeader) & vbCrLf     ' Dim strHeader As String
  strReport = strReport & "  strMessage = " & CStr(strMessage) & vbCrLf     ' Dim strMessage As String
  strReport = strReport & "  theDetailedDescription = " & CStr(theDetailedDescription) & vbCrLf     ' Dim theDetailedDescription As String
  strReport = strReport & "  theProgressSpecific = " & CStr(theProgressSpecific) & vbCrLf     ' Dim theProgressSpecific As String
  strReport = strReport & "  strAddName = " & CStr(strAddName) & vbCrLf     ' Dim strAddName As String
  strReport = strReport & "  dblCellSize = " & CStr(dblCellSize) & vbCrLf     ' Dim dblCellSize As Double
  strReport = strReport & "  strTempName = " & CStr(strTempName) & vbCrLf     ' Dim strTempName As String
  strReport = strReport & "  lngFieldIndex = " & CStr(lngFieldIndex) & vbCrLf     ' Dim lngFieldIndex As Long
  strReport = strReport & "  lngFormatStyle = " & CStr(lngFormatStyle) & vbCrLf     ' Dim lngFormatStyle As Long          ' 0 = dBASE, 1 = CSV
  strReport = strReport & "  lngFileNumber = " & CStr(lngFileNumber) & vbCrLf     ' Dim lngFileNumber As Long
  strReport = strReport & "  strRow = " & CStr(strRow) & vbCrLf     ' Dim strRow As String
  strReport = strReport & "  strTestOutput = " & CStr(strTestOutput) & vbCrLf     ' Dim strTestOutput As String
  strReport = strReport & "  strPathName = " & CStr(strPathName) & vbCrLf     ' Dim strPathName As String
  strReport = strReport & "  strFirstClusterName = " & CStr(strFirstClusterName) & vbCrLf     ' Dim strFirstClusterName As String
  strReport = strReport & "  strSecondClusterName = " & CStr(strSecondClusterName) & vbCrLf     ' Dim strSecondClusterName As String
  strReport = strReport & "  strConfusionIndexName = " & CStr(strConfusionIndexName) & vbCrLf     ' Dim strConfusionIndexName As String
  strReport = strReport & "  strOutlierIndexName = " & CStr(strOutlierIndexName) & vbCrLf     ' Dim strOutlierIndexName As String
  strReport = strReport & "  lngXIndex = " & CStr(lngXIndex) & vbCrLf     ' Dim lngXIndex As Long
  strReport = strReport & "  lngYIndex = " & CStr(lngYIndex) & vbCrLf     ' Dim lngYIndex As Long
  strReport = strReport & "  lngHighClusterIndex = " & CStr(lngHighClusterIndex) & vbCrLf     ' Dim lngHighClusterIndex As Long
  strReport = strReport & "  lngSecondClusterIndex = " & CStr(lngSecondClusterIndex) & vbCrLf     ' Dim lngSecondClusterIndex As Long
  strReport = strReport & "  lngConfusionIndex = " & CStr(lngConfusionIndex) & vbCrLf     ' Dim lngConfusionIndex As Long
  strReport = strReport & "  lngOutlierIndex = " & CStr(lngOutlierIndex) & vbCrLf     ' Dim lngOutlierIndex As Long
  strReport = strReport & "  lngHeight = " & CStr(lngHeight) & vbCrLf     ' Dim lngHeight As Long
  strReport = strReport & "  lngWidth = " & CStr(lngWidth) & vbCrLf     ' Dim lngWidth As Long
  strReport = strReport & "  dblNoData = " & CStr(dblNoData) & vbCrLf     ' Dim dblNoData As Double
  strReport = strReport & "  dblX = " & CStr(dblX) & vbCrLf     ' Dim dblX As Double
  strReport = strReport & "  dblY = " & CStr(dblY) & vbCrLf     ' Dim dblY As Double
  strReport = strReport & "  lngNumBands = " & CStr(lngNumBands) & vbCrLf     ' Dim lngNumBands As Long
  strReport = strReport & "  lngRowCounter = " & CStr(lngRowCounter) & vbCrLf     ' Dim lngRowCounter As Long
  strReport = strReport & "  dblVal = " & CStr(dblVal) & vbCrLf     ' Dim dblVal As Double
  strReport = strReport & "  lngFocalRow = " & CStr(lngFocalRow) & vbCrLf     ' Dim lngFocalRow As Long
  strReport = strReport & "  lngLastColumn = " & CStr(lngLastColumn) & vbCrLf     ' Dim lngLastColumn As Long
  strReport = strReport & "  lngOut = " & CStr(lngOut) & vbCrLf     ' Dim lngOut As Long
  strReport = strReport & "  datRunningTime = " & CStr(datRunningTime) & vbCrLf     ' Dim datRunningTime As Date
  strReport = strReport & "  ubound(dblXCoords) = " & CStr(UBound(dblXCoords)) & vbCrLf     ' Dim dblXCoords() As Double
  strReport = strReport & "  ubound(dblYCoords) = " & CStr(UBound(dblYCoords)) & vbCrLf     ' Dim dblYCoords() As Double
  strReport = strReport & "  ubound(dblLayerVector) = " & CStr(UBound(dblLayerVector)) & vbCrLf     ' Dim dblLayerVector() As Double
  strReport = strReport & "  ubound(dblMemberships) = " & CStr(UBound(dblMemberships)) & vbCrLf     ' Dim dblMemberships() As Double
  strReport = strReport & "  lngHighestMembership = " & CStr(lngHighestMembership) & vbCrLf     ' Dim lngHighestMembership As Long
  strReport = strReport & "  lngSecondMembership = " & CStr(lngSecondMembership) & vbCrLf     ' Dim lngSecondMembership As Long
  strReport = strReport & "  dblConfusionIndex = " & CStr(dblConfusionIndex) & vbCrLf     ' Dim dblConfusionIndex As Double
  strReport = strReport & "  lngValue = " & CStr(lngValue) & vbCrLf     ' Dim lngValue As Long
  strReport = strReport & "  lngValueIndex = " & CStr(lngValueIndex) & vbCrLf     ' Dim lngValueIndex As Long
  strReport = strReport & "  lngNameIndex = " & CStr(lngNameIndex) & vbCrLf     ' Dim lngNameIndex As Long
  strReport = strReport & "  NumOfValues = " & CStr(NumOfValues) & vbCrLf     ' Dim NumOfValues As Integer
  strReport = strReport & "  lngRedStart = " & CStr(lngRedStart) & vbCrLf     ' Dim lngRedStart As Long
  strReport = strReport & "  lngRedEnd = " & CStr(lngRedEnd) & vbCrLf     ' Dim lngRedEnd As Long
  strReport = strReport & "  lngGreenStart = " & CStr(lngGreenStart) & vbCrLf     ' Dim lngGreenStart As Long
  strReport = strReport & "  lngGreenEnd = " & CStr(lngGreenEnd) & vbCrLf     ' Dim lngGreenEnd As Long
  strReport = strReport & "  lngBlueStart = " & CStr(lngBlueStart) & vbCrLf     ' Dim lngBlueStart As Long
  strReport = strReport & "  lngBlueEnd = " & CStr(lngBlueEnd) & vbCrLf     ' Dim lngBlueEnd As Long
  strReport = strReport & "  lngRedInterval = " & CStr(lngRedInterval) & vbCrLf     ' Dim lngRedInterval As Long
  strReport = strReport & "  lngGreenInterval = " & CStr(lngGreenInterval) & vbCrLf     ' Dim lngGreenInterval As Long
  strReport = strReport & "  lngBlueInterval = " & CStr(lngBlueInterval) & vbCrLf     ' Dim lngBlueInterval As Long
  strReport = strReport & "  lngOID = " & CStr(lngOID) & vbCrLf     ' Dim lngOID As Long
3022:   strReport = strReport & "  pThisExt.frmImportStep1Return is Nothing = " & CStr(pThisExt.frmImportStep1Return Is Nothing) & vbCrLf
3023:   strReport = strReport & "  pThisExt.frmImportStep2Return is Nothing = " & CStr(pThisExt.frmImportStep2Return Is Nothing) & vbCrLf
3024:   strReport = strReport & "  pThisExt.frmImportStep3Return is Nothing = " & CStr(pThisExt.frmImportStep3Return Is Nothing) & vbCrLf
3025:   strReport = strReport & "  pTempConversionRasterDataset is Nothing = " & CStr(pTempConversionRasterDataset Is Nothing) & vbCrLf
3026:   strReport = strReport & "  pTempRastDataset is Nothing = " & CStr(pTempRastDataset Is Nothing) & vbCrLf
3027:   strReport = strReport & "  pTempRast2 is Nothing = " & CStr(pTempRast2 Is Nothing) & vbCrLf
3028:   strReport = strReport & "  pGeomDef is Nothing = " & CStr(pGeomDef Is Nothing) & vbCrLf
3029:   strReport = strReport & "  pStatsBand is Nothing = " & CStr(pStatsBand Is Nothing) & vbCrLf
3030:   strReport = strReport & "  pStatsBandColl is Nothing = " & CStr(pStatsBandColl Is Nothing) & vbCrLf
3031:   strReport = strReport & "  pStats is Nothing = " & CStr(pStats Is Nothing) & vbCrLf
3032:   strReport = strReport & "  pSubArray is Nothing = " & CStr(pSubArray Is Nothing) & vbCrLf
3033:   strReport = strReport & "  pSlopeClassBand is Nothing = " & CStr(pSlopeClassBand Is Nothing) & vbCrLf
3034:   strReport = strReport & "  pSlopeVals is Nothing = " & CStr(pSlopeVals Is Nothing) & vbCrLf
3035:   strReport = strReport & "  pForm2Params is Nothing = " & CStr(pForm2Params Is Nothing) & vbCrLf
3036:   strReport = strReport & "  pCentroidData is Nothing = " & CStr(pCentroidData Is Nothing) & vbCrLf
3037:   strReport = strReport & "  pBinWidthData is Nothing = " & CStr(pBinWidthData Is Nothing) & vbCrLf
3038:   strReport = strReport & "  pParamsData is Nothing = " & CStr(pParamsData Is Nothing) & vbCrLf
3039:   strReport = strReport & "  pEvalData is Nothing = " & CStr(pEvalData Is Nothing) & vbCrLf
3040:   strReport = strReport & "  pRasterLayer is Nothing = " & CStr(pRasterLayer Is Nothing) & vbCrLf
3041:   strReport = strReport & "  pRasterBand is Nothing = " & CStr(pRasterBand Is Nothing) & vbCrLf
3042:   strReport = strReport & "  pUnknown is Nothing = " & CStr(pUnknown Is Nothing) & vbCrLf
3043:   strReport = strReport & "  pTemplateBand is Nothing = " & CStr(pTemplateBand Is Nothing) & vbCrLf
3044:   strReport = strReport & "  pTemplateRaster is Nothing = " & CStr(pTemplateRaster Is Nothing) & vbCrLf
3045:   strReport = strReport & "  pTemplateDataset is Nothing = " & CStr(pTemplateDataset Is Nothing) & vbCrLf
3046:   strReport = strReport & "  pTemplateProps is Nothing = " & CStr(pTemplateProps Is Nothing) & vbCrLf
3047:   strReport = strReport & "  pTemplateSpRef is Nothing = " & CStr(pTemplateSpRef Is Nothing) & vbCrLf
3048:   strReport = strReport & "  pTemplatePnt is Nothing = " & CStr(pTemplatePnt Is Nothing) & vbCrLf
3049:   strReport = strReport & "  strInputBand is Nothing = " & CStr(strInputBand Is Nothing) & vbCrLf
3050:   strReport = strReport & "  pRastMakerOp is Nothing = " & CStr(pRastMakerOp Is Nothing) & vbCrLf
3051:   strReport = strReport & "  pRastAnEnv is Nothing = " & CStr(pRastAnEnv Is Nothing) & vbCrLf
3052:   strReport = strReport & "  pEnv is Nothing = " & CStr(pEnv Is Nothing) & vbCrLf
3053:   strReport = strReport & "  pOneDataset is Nothing = " & CStr(pOneDataset Is Nothing) & vbCrLf
3054:   strReport = strReport & "  pTempRaster is Nothing = " & CStr(pTempRaster Is Nothing) & vbCrLf
3055:   strReport = strReport & "  pMathOp is Nothing = " & CStr(pMathOp Is Nothing) & vbCrLf
3056:   strReport = strReport & "  pMathEnv is Nothing = " & CStr(pMathEnv Is Nothing) & vbCrLf
3057:   strReport = strReport & "  pInBandColl is Nothing = " & CStr(pInBandColl Is Nothing) & vbCrLf
3058:   strReport = strReport & "  pAddBand is Nothing = " & CStr(pAddBand Is Nothing) & vbCrLf
3059:   strReport = strReport & "  pNewBand is Nothing = " & CStr(pNewBand Is Nothing) & vbCrLf
3060:   strReport = strReport & "  pNewDataset is Nothing = " & CStr(pNewDataset Is Nothing) & vbCrLf
3061:   strReport = strReport & "  pNewBandColl is Nothing = " & CStr(pNewBandColl Is Nothing) & vbCrLf
3062:   strReport = strReport & "  pInProps is Nothing = " & CStr(pInProps Is Nothing) & vbCrLf
3063:   strReport = strReport & "  pOutputFNames is Nothing = " & CStr(pOutputFNames Is Nothing) & vbCrLf
3064:   strReport = strReport & "  pConOp is Nothing = " & CStr(pConOp Is Nothing) & vbCrLf
3065:   strReport = strReport & "  pTempAnEnv is Nothing = " & CStr(pTempAnEnv Is Nothing) & vbCrLf
3066:   strReport = strReport & "  pFeatGeoDataset is Nothing = " & CStr(pFeatGeoDataset Is Nothing) & vbCrLf
3067:   strReport = strReport & "  pTempBand is Nothing = " & CStr(pTempBand Is Nothing) & vbCrLf
3068:   strReport = strReport & "  pRastProps is Nothing = " & CStr(pRastProps Is Nothing) & vbCrLf
3069:   strReport = strReport & "  pPnt is Nothing = " & CStr(pPnt Is Nothing) & vbCrLf
3070:   strReport = strReport & "  pPixBlock is Nothing = " & CStr(pPixBlock Is Nothing) & vbCrLf
3071:   strReport = strReport & "  pTopLeft is Nothing = " & CStr(pTopLeft Is Nothing) & vbCrLf
3072:   strReport = strReport & "  pRastCursor is Nothing = " & CStr(pRastCursor Is Nothing) & vbCrLf
3073:   strReport = strReport & "  pInputRaster is Nothing = " & CStr(pInputRaster Is Nothing) & vbCrLf
3074:   strReport = strReport & "  pTempProps is Nothing = " & CStr(pTempProps Is Nothing) & vbCrLf
3075:   strReport = strReport & "  pTempPixBlock is Nothing = " & CStr(pTempPixBlock Is Nothing) & vbCrLf
3076:   strReport = strReport & "  pTemporaryRaster is Nothing = " & CStr(pTemporaryRaster Is Nothing) & vbCrLf
3077:   strReport = strReport & "  pTempPoint is Nothing = " & CStr(pTempPoint Is Nothing) & vbCrLf
3078:   strReport = strReport & "  pTempOrigin is Nothing = " & CStr(pTempOrigin Is Nothing) & vbCrLf
3079:   strReport = strReport & "  pFuzzyOutput is Nothing = " & CStr(pFuzzyOutput Is Nothing) & vbCrLf
3080:   strReport = strReport & "  pOutDS is Nothing = " & CStr(pOutDS Is Nothing) & vbCrLf
3081:   strReport = strReport & "  pOutRasterEdit is Nothing = " & CStr(pOutRasterEdit Is Nothing) & vbCrLf
3082:   strReport = strReport & "  pRasterStorDef is Nothing = " & CStr(pRasterStorDef Is Nothing) & vbCrLf
3083:   strReport = strReport & "  pRasterDef is Nothing = " & CStr(pRasterDef Is Nothing) & vbCrLf
3084:   strReport = strReport & "  pOriginPoint is Nothing = " & CStr(pOriginPoint Is Nothing) & vbCrLf
3085:   strReport = strReport & "  pOutPnt is Nothing = " & CStr(pOutPnt Is Nothing) & vbCrLf
3086:   strReport = strReport & "  pOutProps is Nothing = " & CStr(pOutProps Is Nothing) & vbCrLf
3087:   strReport = strReport & "  pOutBandColl is Nothing = " & CStr(pOutBandColl Is Nothing) & vbCrLf
3088:   strReport = strReport & "  pTempOutBandColl is Nothing = " & CStr(pTempOutBandColl Is Nothing) & vbCrLf
3089:   strReport = strReport & "  pOutBand is Nothing = " & CStr(pOutBand Is Nothing) & vbCrLf
3090:   strReport = strReport & "  pRastDatasetEdit is Nothing = " & CStr(pRastDatasetEdit Is Nothing) & vbCrLf
3091:   strReport = strReport & "  pTempOutRaster is Nothing = " & CStr(pTempOutRaster Is Nothing) & vbCrLf
3092:   strReport = strReport & "  pOutputPixBlock is Nothing = " & CStr(pOutputPixBlock Is Nothing) & vbCrLf
3093:   strReport = strReport & "  pOutputRaster is Nothing = " & CStr(pOutputRaster Is Nothing) & vbCrLf
3094:   strReport = strReport & "  pOutputRaster2 is Nothing = " & CStr(pOutputRaster2 Is Nothing) & vbCrLf
3095:   strReport = strReport & "  pRawPixel is Nothing = " & CStr(pRawPixel Is Nothing) & vbCrLf
3096:   strReport = strReport & "  pOutPixelBlock is Nothing = " & CStr(pOutPixelBlock Is Nothing) & vbCrLf
3097:   strReport = strReport & "  pBands is Nothing = " & CStr(pBands Is Nothing) & vbCrLf
3098:   strReport = strReport & "  pOutputRastProps is Nothing = " & CStr(pOutputRastProps Is Nothing) & vbCrLf
3099:   strReport = strReport & "  frmProgress is Nothing = " & CStr(frmProgress Is Nothing) & vbCrLf
3100:   strReport = strReport & "  pApp is Nothing = " & CStr(pApp Is Nothing) & vbCrLf
3101:   strReport = strReport & "  pThisExt is Nothing = " & CStr(pThisExt Is Nothing) & vbCrLf
3102:   strReport = strReport & "  pMxDoc is Nothing = " & CStr(pMxDoc Is Nothing) & vbCrLf
3103:   strReport = strReport & "  pForm1Params is Nothing = " & CStr(pForm1Params Is Nothing) & vbCrLf
3104:   strReport = strReport & "  pWS is Nothing = " & CStr(pWS Is Nothing) & vbCrLf
3105:   strReport = strReport & "  pOutputRastWS is Nothing = " & CStr(pOutputRastWS Is Nothing) & vbCrLf
3106:   strReport = strReport & "  pOutputRastWsEx is Nothing = " & CStr(pOutputRastWsEx Is Nothing) & vbCrLf
3107:   strReport = strReport & "  pLayerVarsArray is Nothing = " & CStr(pLayerVarsArray Is Nothing) & vbCrLf
3108:   strReport = strReport & "  psbar is Nothing = " & CStr(psbar Is Nothing) & vbCrLf
3109:   strReport = strReport & "  pPro is Nothing = " & CStr(pPro Is Nothing) & vbCrLf
3110:   strReport = strReport & "  pAddLayer is Nothing = " & CStr(pAddLayer Is Nothing) & vbCrLf
3111:   strReport = strReport & "  pAddFeatLayer is Nothing = " & CStr(pAddFeatLayer Is Nothing) & vbCrLf
3112:   strReport = strReport & "  pFeatClassDesc is Nothing = " & CStr(pFeatClassDesc Is Nothing) & vbCrLf
3113:   strReport = strReport & "  pFeatClass is Nothing = " & CStr(pFeatClass Is Nothing) & vbCrLf
3114:   strReport = strReport & "  pField is Nothing = " & CStr(pField Is Nothing) & vbCrLf
3115:   strReport = strReport & "  pInRaster is Nothing = " & CStr(pInRaster Is Nothing) & vbCrLf
3116:   strReport = strReport & "  pRastWS is Nothing = " & CStr(pRastWS Is Nothing) & vbCrLf
3117:   strReport = strReport & "  pWsFact is Nothing = " & CStr(pWsFact Is Nothing) & vbCrLf
3118:   strReport = strReport & "  pAddFieldNames is Nothing = " & CStr(pAddFieldNames Is Nothing) & vbCrLf
3119:   strReport = strReport & "  pFieldEdit is Nothing = " & CStr(pFieldEdit Is Nothing) & vbCrLf
3120:   strReport = strReport & "  pAddFields is Nothing = " & CStr(pAddFields Is Nothing) & vbCrLf
3121:   strReport = strReport & "  pTable is Nothing = " & CStr(pTable Is Nothing) & vbCrLf
3122:   strReport = strReport & "  pFieldIndexes is Nothing = " & CStr(pFieldIndexes Is Nothing) & vbCrLf
3123:   strReport = strReport & "  pClusterFieldNames is Nothing = " & CStr(pClusterFieldNames Is Nothing) & vbCrLf
3124:   strReport = strReport & "  pClusterIndices is Nothing = " & CStr(pClusterIndices Is Nothing) & vbCrLf
3125:   strReport = strReport & "  pVariableFieldNames is Nothing = " & CStr(pVariableFieldNames Is Nothing) & vbCrLf
3126:   strReport = strReport & "  pVariableIndices is Nothing = " & CStr(pVariableIndices Is Nothing) & vbCrLf
3127:   strReport = strReport & "  pCursor is Nothing = " & CStr(pCursor Is Nothing) & vbCrLf
3128:   strReport = strReport & "  pBuffer is Nothing = " & CStr(pBuffer Is Nothing) & vbCrLf
3129:   strReport = strReport & "  pClone is Nothing = " & CStr(pClone Is Nothing) & vbCrLf
3130:   strReport = strReport & "  pSpRef is Nothing = " & CStr(pSpRef Is Nothing) & vbCrLf
3131:   strReport = strReport & "  pNewLayer is Nothing = " & CStr(pNewLayer Is Nothing) & vbCrLf
3132:   strReport = strReport & "  pStretchRen is Nothing = " & CStr(pStretchRen Is Nothing) & vbCrLf
3133:   strReport = strReport & "  pRasRen is Nothing = " & CStr(pRasRen Is Nothing) & vbCrLf
3134:   strReport = strReport & "  pRedColor is Nothing = " & CStr(pRedColor Is Nothing) & vbCrLf
3135:   strReport = strReport & "  pYellowColor is Nothing = " & CStr(pYellowColor Is Nothing) & vbCrLf
3136:   strReport = strReport & "  pGreenColor is Nothing = " & CStr(pGreenColor Is Nothing) & vbCrLf
3137:   strReport = strReport & "  pRamp1 is Nothing = " & CStr(pRamp1 Is Nothing) & vbCrLf
3138:   strReport = strReport & "  pRamp2 is Nothing = " & CStr(pRamp2 Is Nothing) & vbCrLf
3139:   strReport = strReport & "  pMultiRamp is Nothing = " & CStr(pMultiRamp Is Nothing) & vbCrLf
3140:   strReport = strReport & "  pNameField is Nothing = " & CStr(pNameField Is Nothing) & vbCrLf
3141:   strReport = strReport & "  pNameFieldEdit is Nothing = " & CStr(pNameFieldEdit Is Nothing) & vbCrLf
3142:   strReport = strReport & "  pRastTableCursor is Nothing = " & CStr(pRastTableCursor Is Nothing) & vbCrLf
3143:   strReport = strReport & "  pRastRow is Nothing = " & CStr(pRastRow Is Nothing) & vbCrLf
3144:   strReport = strReport & "  pLandFacetLayer is Nothing = " & CStr(pLandFacetLayer Is Nothing) & vbCrLf
3145:   strReport = strReport & "  pColor1 is Nothing = " & CStr(pColor1 Is Nothing) & vbCrLf
3146:   strReport = strReport & "  pColor2 is Nothing = " & CStr(pColor2 Is Nothing) & vbCrLf
3147:   strReport = strReport & "  pColor3 is Nothing = " & CStr(pColor3 Is Nothing) & vbCrLf
3148:   strReport = strReport & "  pColor4 is Nothing = " & CStr(pColor4 Is Nothing) & vbCrLf
3149:   strReport = strReport & "  pColor5 is Nothing = " & CStr(pColor5 Is Nothing) & vbCrLf
3150:   strReport = strReport & "  pCatRaster is Nothing = " & CStr(pCatRaster Is Nothing) & vbCrLf
3151:   strReport = strReport & "  pFSymbol is Nothing = " & CStr(pFSymbol Is Nothing) & vbCrLf
3152:   strReport = strReport & "  pUVRen is Nothing = " & CStr(pUVRen Is Nothing) & vbCrLf
3153:   strReport = strReport & "  pColor is Nothing = " & CStr(pColor Is Nothing) & vbCrLf

  Dim strErrorReportPath As String
3156:   strErrorReportPath = TopoCorridor.aml_func_mod.ReturnDir(TopoCorridor.aml_func_mod.GetMxDocPath(pApp))
3157:   If Right(strErrorReportPath, 1) <> "\" Then strErrorReportPath = strErrorReportPath & "\"
3158:   strErrorReportPath = TopoCorridor.MyGeneralOperations.MakeUniqueShapeFilename(strErrorReportPath & "Error_Log.txt")
3159:   TopoCorridor.MyGeneralOperations.WriteTextFile strErrorReportPath, strReport, True

3161:   MsgBox "Error Log saved to " & strErrorReportPath

 

  
CleanUp:


3169:   Set pApp = Nothing
3170:   Set pThisExt = Nothing
3171:   Set pMxDoc = Nothing
3172:   Set pClone = Nothing
3173:   Set pSubArray = Nothing
3174:   Set pForm1Params = Nothing
3175:   Set pSlopeClassBand = Nothing
3176:   Set pSlopeVals = Nothing
3177:   Set pWS = Nothing
3178:   Set pOutputRastWS = Nothing
3179:   Set pOutputRastWsEx = Nothing
3180:   Erase dblSlopeVals
3181:   Set pForm2Params = Nothing
3182:   Set pCentroidData = Nothing
3183:   Set pBinWidthData = Nothing
3184:   Set pParamsData = Nothing
3185:   Set pEvalData = Nothing
3186:   Erase dblCentroidVals
3187:   Erase dblBinWidthVals
3188:   Erase dblParamsVals
3189:   Erase dblEvalVals
3190:   Erase dblBins
3191:   Erase dblHalfBinWidths
3192:   Set pLayerVarsArray = Nothing
3193:   Set pRasterLayer = Nothing
3194:   Set pRasterBand = Nothing
3195:   Set pUnknown = Nothing
3196:   Set pTemplateBand = Nothing
3197:   Set pTemplateRaster = Nothing
3198:   Set pTemplateDataset = Nothing
3199:   Set pTemplateProps = Nothing
3200:   Set pTemplateSpRef = Nothing
3201:   Set pTemplatePnt = Nothing
3202:   Set strInputBand = Nothing
3203:   Set psbar = Nothing
3204:   Set pPro = Nothing
3205:   Set frmProgress = Nothing
3206:   Set pAddLayer = Nothing
3207:   Set pAddFeatLayer = Nothing
3208:   Set pFeatClassDesc = Nothing
3209:   Set pFeatClass = Nothing
3210:   Set pField = Nothing
3211:   Set pRastMakerOp = Nothing
3212:   Set pRastAnEnv = Nothing
3213:   Set pEnv = Nothing
3214:   Set pOneDataset = Nothing
3215:   Set pTempRaster = Nothing
3216:   Set pMathOp = Nothing
3217:   Set pMathEnv = Nothing
3218:   Set pInBandColl = Nothing
3219:   Set pAddBand = Nothing
3220:   Set pNewBand = Nothing
3221:   Set pNewDataset = Nothing
3222:   Set pNewBandColl = Nothing
3223:   Set pInRaster = Nothing
3224:   Set pInProps = Nothing
3225:   Set pOutputFNames = Nothing
3226:   Set pTempConversionRasterDataset = Nothing
3227:   Set pConOp = Nothing
3228:   Set pTempAnEnv = Nothing
3229:   Set pFeatGeoDataset = Nothing
3230:   Set pTempRastDataset = Nothing
3231:   Set pRastWS = Nothing
3232:   Set pWsFact = Nothing
3233:   Set pAddFieldNames = Nothing
3234:   Set pFieldEdit = Nothing
3235:   Set pAddFields = Nothing
3236:   Set pTable = Nothing
3237:   Set pFieldIndexes = Nothing
3238:   Set pClusterFieldNames = Nothing
3239:   Set pClusterIndices = Nothing
3240:   Set pVariableFieldNames = Nothing
3241:   Set pVariableIndices = Nothing
3242:   Set pCursor = Nothing
3243:   Set pBuffer = Nothing
3244:   Set pTempBand = Nothing
3245:   Set pRastProps = Nothing
3246:   Set pPnt = Nothing
3247:   Set pPixBlock = Nothing
3248:   Set pTopLeft = Nothing
3249:   Erase booHasData
3250:   Erase varAllData
3251:   Erase varEmptyData
3252:   Set pRastCursor = Nothing
3253:   Set pInputRaster = Nothing
3254:   Erase booAllHasData
3255:   Erase varNoDataVals
3256:   Set pTempProps = Nothing
3257:   Set pTempPixBlock = Nothing
3258:   Set pTemporaryRaster = Nothing
3259:   Set pTempPoint = Nothing
3260:   Set pTempOrigin = Nothing
3261:   Set pTempRast2 = Nothing
3262:   Erase dblXCoords
3263:   Erase dblYCoords
3264:   Erase dblLayerVector
3265:   Set pFuzzyOutput = Nothing
3266:   Erase dblMemberships
3267:   Set pOutDS = Nothing
3268:   Set pOutRasterEdit = Nothing
3269:   Set pRasterStorDef = Nothing
3270:   Set pRasterDef = Nothing
3271:   Set pGeomDef = Nothing
3272:   Set pOriginPoint = Nothing
3273:   Set pOutPnt = Nothing
3274:   Set pSpRef = Nothing
3275:   Set pOutProps = Nothing
3276:   Set pOutBandColl = Nothing
3277:   Set pTempOutBandColl = Nothing
3278:   Set pOutBand = Nothing
3279:   Set pRastDatasetEdit = Nothing
3280:   Set pTempOutRaster = Nothing
3281:   Set pTempWS = Nothing
3282:   Set pOutputPixBlock = Nothing
3283:   Set pOutputRaster = Nothing
3284:   Set pOutputRaster2 = Nothing
3285:   Set pRawPixel = Nothing
3286:   Set pOutPixelBlock = Nothing
3287:   Set pBands = Nothing
3288:   Set pOutputRastProps = Nothing
3289:   Set pNewLayer = Nothing
3290:   Set pStretchRen = Nothing
3291:   Set pRasRen = Nothing
3292:   Set pRedColor = Nothing
3293:   Set pYellowColor = Nothing
3294:   Set pGreenColor = Nothing
3295:   Set pRamp1 = Nothing
3296:   Set pRamp2 = Nothing
3297:   Set pMultiRamp = Nothing
3298:   Set pNameField = Nothing
3299:   Set pNameFieldEdit = Nothing
3300:   Set pRastTableCursor = Nothing
3301:   Set pRastRow = Nothing
3302:   Set pLandFacetLayer = Nothing
3303:   Set pColor1 = Nothing
3304:   Set pColor2 = Nothing
3305:   Set pColor3 = Nothing
3306:   Set pColor4 = Nothing
3307:   Set pColor5 = Nothing
3308:   Set pCatRaster = Nothing
3309:   Set pFSymbol = Nothing
3310:   Set pUVRen = Nothing
3311:   Set pColor = Nothing
3312:   Set pStatsBandColl = Nothing
3313:   Set pStatsBand = Nothing
3314:   Set pStats = Nothing
3315:   Set pTempDS = Nothing
3316:   Set pMathOp2 = Nothing
3317:   Set pDataset = Nothing
3318:   Set pSaveAs = Nothing
3319:   Set pNewDS = Nothing
3320:   Set pRastTable = Nothing
3321:   Set pRasterStretch = Nothing
3322:   Set pStandaloneTable = Nothing
3323:   Set pStTabColl = Nothing
3324:   Set pTableWindow2 = Nothing
3325:   Set pCombineLayer = Nothing
3326:   Set pRastPyramid = Nothing




End Function


' ------------- IN THIS MODULE, NEEDS LFR_GetExtension FUNCTION
Private Function LFR_GetExtension(pApp As IApplication) As TopoCorridor.clsExtension
  On Error GoTo ErrorHandler

  Dim newUid As New UID
  Dim pExt As IExtension
  Dim pThisExt As TopoCorridor.clsExtension
3341:   newUid.Value = "TopoCorridor.clsExtension"
3342:   Set pExt = pApp.FindExtensionByCLSID(newUid)
3343:   Set LFR_GetExtension = pExt
  
3345:   Set newUid = Nothing
3346:   Set pExt = Nothing
3347:   Set pThisExt = Nothing

  Exit Function
ErrorHandler:
  HandleError False, "LFR_GetExtension " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

' ------------- IN THIS MODULE, NEEDS LFR_CalcTimeLeft FUNCTION
Private Function LFR_CalcTimeLeft(strHeader As String, dateStart As Date, lngCurrent As Long, lngTotal As Long) As String
  On Error GoTo ErrorHandler

' ESTIMATED TIME LEFT CODE

  Dim thePercentDone As Double
3361:   If lngTotal <= 0 Then
3362:     thePercentDone = 0
3363:   Else
3364:     thePercentDone = (lngCurrent / lngTotal)
3365:   End If

  Dim thePercentForCalcs As Double
3368:   thePercentForCalcs = Round(thePercentDone * 100, 2)

'    lblPercentDone.Caption = "(" & thePercentForCalcs & "%)"
'    lblPercentDone.Refresh

  Dim theDuration As Double
3374:   theDuration = DateDiff("s", dateStart, Now)

  Dim PredictedDuration As Double
3377:   PredictedDuration = (theDuration * lngTotal) / (lngCurrent)

  Dim EstTimeLeft As Double
3380:   EstTimeLeft = PredictedDuration - theDuration

  Dim EstHoursLeft As Long
  Dim EstMinutesLeft As Long
  Dim EstSecondsLeft As Long

3386:   EstHoursLeft = Fix(EstTimeLeft / 3600)
3387:   EstMinutesLeft = Fix((EstTimeLeft - (EstHoursLeft * 3600)) / 60)
3388:   EstSecondsLeft = Fix(EstTimeLeft - (EstHoursLeft * 3600) - (EstMinutesLeft * 60))

  Dim EstTimeLeftStr As String
3391:   EstTimeLeftStr = EstHoursLeft & ":" & Format(EstMinutesLeft, "00") & ":" & Format(EstSecondsLeft, "00")

3393:   LFR_CalcTimeLeft = strHeader & ".....[record #" & CStr(lngCurrent) & " of " & CStr(lngTotal) & "  ---  " & thePercentForCalcs & "%]....." & _
      "Est. Time Left = " & EstTimeLeftStr & "..."

  Exit Function
ErrorHandler:
  HandleError False, "LFR_CalcTimeLeft " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function
' ------------- IN THIS MODULE, NEEDS LFR_BailOutOfProgress FUNCTION
Private Function LFR_BailOutOfProgress(frmProgressDialog As Object, pApp As IApplication) As Boolean
  On Error GoTo ErrorHandler

  Dim pThisExt As TopoCorridor.clsExtension
3405:   Set pThisExt = LFR_GetExtension(pApp)

  Dim frmProgress As TopoCorridor.frmJenProgressMeterBasic
3408:   Set frmProgress = frmProgressDialog

3410:   pThisExt.ProgressDialogAutoClose = (frmProgress.chkClose.Value = 1)
3411:   pThisExt.ProgressDialogSetExpanded = (frmProgress.SetExpanded)

'  MsgBox "Checking Autoclose Stuff: " & vbCrLf & _
      "Check-Box checked? " & CStr(frmProgress.chkClose.Value = 1) & vbCrLf & _
      "Extension Property Checked? " & CStr(pThisExt.ProgressDialogAutoClose)

  ' PROGRESS METER STUFF --------------------------------------------------------
3418:   LFR_BailOutOfProgress = Not frmProgress.ShouldContinue
3419:   If LFR_BailOutOfProgress Then
    Dim theDateString As String
    Dim theElapsedTimeString As String

3423:     theDateString = Format(Now, "long date") & ";  " & Format(Now, "long time")
3424:     Screen.MousePointer = vbDefault
    Dim theTimeBegan As Date
    Dim theTimeEnd As Date
3427:     theTimeBegan = frmProgress.ProgBeginTime
3428:     theTimeEnd = Now

3430:     theElapsedTimeString = MyGeneralOperations.ReturnTimeElapsed(theTimeBegan, theTimeEnd)

    Dim theReport As String
3433:     theReport = "Operation cancelled prematurely at " & theDateString & vbCrLf & _
        "---------------------------------------------------------" & vbCrLf & theElapsedTimeString

    Dim strCurrentReport As String
3437:     strCurrentReport = frmProgress.txtDetails.Text
3438:     frmProgress.txtDetails.Text = strCurrentReport & vbCrLf & theReport
3439:     frmProgress.txtDetails.SelStart = Len(frmProgress.txtDetails.Text)

3441:     If frmProgress.chkClose.Value = 1 Then
    '  Unload frmProgress
    '  Set frmProgress = Nothing
3444:       frmProgress.Frame.Visible = False
3445:     End If

    Exit Function
3448:   End If
  
3450:   Set pThisExt = Nothing
3451:   Set frmProgress = Nothing

  Exit Function
ErrorHandler:
  HandleError False, "LFR_BailOutOfProgress " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function
Public Function CheckInBins(dblValueVector() As Double, dblBins() As Double) As Boolean
  On Error GoTo ErrorHandler

  
  Dim lngIndex As Long
  Dim lngIndex2 As Long
  Dim dblTempVal As Double
  
3465:   For lngIndex = 0 To UBound(dblBins, 1)
3466:     CheckInBins = True
3467:     For lngIndex2 = 0 To UBound(dblValueVector)
3468:       dblTempVal = dblValueVector(lngIndex2)
3469:       If dblTempVal < dblBins(lngIndex, lngIndex2 * 2) Or dblTempVal > dblBins(lngIndex, (lngIndex2 * 2) + 1) Then
3470:         CheckInBins = False
3471:         Exit For
3472:       End If
3473:     Next lngIndex2
3474:     If CheckInBins Then Exit For
3475:   Next lngIndex


  Exit Function
ErrorHandler:
  HandleError True, "CheckInBins " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function CalcFuzzyValues(dblValueVector() As Double, dblCentroidData() As Double, _
    dblParamsData() As Double, dblFuzzyParam As Double) As esriSystem.IVariantArray

  On Error GoTo ErrorHandler

  ' RETURN ARRAY WILL CONTAIN
  ' 0) DoubleArray for distances to each cluster
  ' 1) LONG: Number of nearest cluster
  ' 2) LONG: Number of 2nd Nearest Cluster
  ' 3) DOUBLE: Confusion Index Value
  
  ' VALUE VECTOR HAS VALUES FOR EACH VARIABLE
  ' CENTROID DATA VECTOR HAS CENTROID ID AS 1ST INDEX, VARIABLE VALUE AS SECOND INDEX
  ' BIN WIDTH VECTOR HAS BIN WIDTH VALUES FOR EACH VARIABLE
  ' PARAMS VECTOR HAS VARIABLE AS 1ST INDEX, MEAN AND STANDARD DEVIATION AS SECOND INDEX
  
  Dim lngIndex As Long
  Dim lngIndex2 As Long
  Dim lngVariableCount As Long
  Dim booInBin As Boolean
  
3504:   lngVariableCount = UBound(dblValueVector)
  
  Dim lngCentroidCount As Long
3507:   lngCentroidCount = UBound(dblCentroidData, 1)
  
  ' FIRST STANDARDIZE THE VECTOR
  Dim dblStandardized() As Double
  ReDim dblStandardized(lngVariableCount)
3512:   For lngIndex = 0 To lngVariableCount
3513:     dblStandardized(lngIndex) = (dblValueVector(lngIndex) - dblParamsData(lngIndex, 0)) / dblParamsData(lngIndex, 1)
3514:   Next lngIndex
  
  Dim dblExponent As Double
3517:   dblExponent = -1 / (dblFuzzyParam - 1)
  
  ' CALCULATE VECTOR OF DISTANCES
  Dim dblDistances() As Double
  Dim dblDistancesToSort() As Double
  ReDim dblDistances(lngCentroidCount)
  ReDim dblDistancesToSort(lngCentroidCount)
  Dim dblSortCounter() As Double
  ReDim dblSortCounter(lngCentroidCount)
  
  Dim dblCalcDistance As Double
  Dim dblSumDistances As Double
3529:   dblSumDistances = 0
3530:   For lngIndex = 0 To lngCentroidCount     ' LOOP THROUGH ALL CENTROIDS
3531:     dblSortCounter(lngIndex) = lngIndex + 1
3532:     dblCalcDistance = 0
3533:     For lngIndex2 = 0 To lngVariableCount
3534:       dblCalcDistance = dblCalcDistance + (dblCentroidData(lngIndex, lngIndex2) - dblStandardized(lngIndex2)) ^ 2
3535:     Next lngIndex2
3536:     dblCalcDistance = dblCalcDistance ^ dblExponent
3537:     dblSumDistances = dblSumDistances + dblCalcDistance
3538:     dblDistances(lngIndex) = dblCalcDistance
3539:   Next lngIndex
  
  ' ADJUST DISTANCE ARRAY BY DIVIDING ALL VALUES BY SUM OF DISTANCES
  Dim dblVal As Double
3543:   For lngIndex = 0 To lngCentroidCount
3544:     dblVal = dblDistances(lngIndex) / dblSumDistances
3545:     dblDistances(lngIndex) = dblVal
3546:     dblDistancesToSort(lngIndex) = dblVal
3547:   Next lngIndex
  
  ' SORT DISTANCES
3550:   QuickSort.DoubleAscendingWithSizes dblDistancesToSort, dblSortCounter, 0, UBound(dblDistancesToSort)
  
  Dim dblHighVal As Double
  Dim dblSecondVal As Double
3554:   dblHighVal = dblDistancesToSort(UBound(dblDistancesToSort))
3555:   dblSecondVal = dblDistancesToSort(UBound(dblDistancesToSort) - 1)
  
  Dim dblConfusionIndex As Double
3558:   dblConfusionIndex = dblSecondVal / dblHighVal
  
3560:   Set CalcFuzzyValues = New esriSystem.VarArray
3561:   CalcFuzzyValues.Add dblDistances
3562:   CalcFuzzyValues.Add dblSortCounter(UBound(dblSortCounter))
3563:   CalcFuzzyValues.Add dblSortCounter(UBound(dblSortCounter) - 1)
3564:   CalcFuzzyValues.Add dblConfusionIndex
  
  Exit Function
ErrorHandler:
  HandleError True, "CalcFuzzyValues " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

