Attribute VB_Name = "QuickSort"
Option Explicit
Option Compare Binary

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Copyright 1996-2005 VBnet, Randy Birch, All Rights Reserved.
' Some pages may also contain other copyrights by the author.
' see http://vbnet.mvps.org/index.html?code/sort/qsvariations.htm
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Distribution: You can freely use this code in your own
'               applications, but you may not reproduce
'               or publish this code on any web site,
'               online service, or distribute as source
'               on any media without express permission.
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' MODIFIED JAN. 4, 2006 BY JEFF JENNESS, TO SIMPLIFY IMPLEMENTATION IN ARCGIS
'-----------------------------------------------------------------------------
Public Sub AngleSort(pAngleInDegrees As esriSystem.IDoubleArray, Optional booSortClockwise As Boolean = True, _
    Optional dblCentralAngle As Double = -999)
    
  Dim dblAngles() As Double
  Dim lngIndex As Long
  ReDim dblAngles(pAngleInDegrees.Count - 1)
  
24:   For lngIndex = 0 To pAngleInDegrees.Count - 1
25:     dblAngles(lngIndex) = pAngleInDegrees.Element(lngIndex)
26:   Next lngIndex
  
28:   DoubleAscending dblAngles, 0, UBound(dblAngles)
  
  
'  Debug.Print
'  Debug.Print "Sorted ..."
'  Dim dblDebugGap As Double
'  Dim strDebugGap As String
'  For lngIndex = 0 To UBound(dblAngles)
'    If lngIndex = 0 Then
'      dblDebugGap = dblAngles(0) + 360 - dblAngles(UBound(dblAngles))
'    Else
'      dblDebugGap = dblAngles(lngIndex) - dblAngles(lngIndex - 1)
'    End If
'    strDebugGap = CStr(Format(dblDebugGap, "0"))
'    Debug.Print CStr(lngIndex + 1) & "]  " & CStr(Format(dblAngles(lngIndex), "0.00")) & "       Gap = " & strDebugGap
'  Next lngIndex
  
  Dim pTempArray As esriSystem.IDoubleArray
46:   Set pTempArray = New esriSystem.DoubleArray
  
  Dim lngSplitIndex As Long
  
50:   If dblCentralAngle <> -999 Then
    
    Dim dblSplitAngle As Double
53:     dblSplitAngle = dblCentralAngle - 180
54:     If dblSplitAngle < 0 Then
55:       dblSplitAngle = dblSplitAngle + 360
56:     End If
    
58:     lngSplitIndex = 0
59:     Do While lngSplitIndex <= UBound(dblAngles)
60:       If dblAngles(lngSplitIndex) > dblSplitAngle Then
61:         Exit Do
62:       End If
63:       lngSplitIndex = lngSplitIndex + 1
64:     Loop
    
66:     If lngSplitIndex <= UBound(dblAngles) Then
67:       For lngIndex = lngSplitIndex To UBound(dblAngles)
68:         pTempArray.Add dblAngles(lngIndex)
69:       Next lngIndex
70:     End If
    
72:     If lngSplitIndex > 0 Then
73:       For lngIndex = 0 To lngSplitIndex - 1
74:         pTempArray.Add dblAngles(lngIndex)
75:       Next lngIndex
76:     End If
    
78:   Else
  
    Dim dblLargestGap As Double
81:     dblLargestGap = dblAngles(0) + 360 - dblAngles(UBound(dblAngles))
82:     lngSplitIndex = 0
    Dim dblTempGap As Double
    
85:     For lngIndex = 0 To UBound(dblAngles) - 1
86:       dblTempGap = dblAngles(lngIndex + 1) - dblAngles(lngIndex)
87:       If dblTempGap > dblLargestGap Then
88:         dblLargestGap = dblTempGap
89:         lngSplitIndex = lngIndex + 1
90:       End If
91:     Next lngIndex
    
    
94:     If lngSplitIndex <= UBound(dblAngles) Then
95:       For lngIndex = lngSplitIndex To UBound(dblAngles)
96:         pTempArray.Add dblAngles(lngIndex)
97:       Next lngIndex
98:     End If
    
100:     If lngSplitIndex > 0 Then
101:       For lngIndex = 0 To lngSplitIndex - 1
102:         pTempArray.Add dblAngles(lngIndex)
103:       Next lngIndex
104:     End If
  
106:   End If
  
'  Debug.Print
'  Debug.Print "Sorted and Wrapped..."
'  For lngIndex = 0 To UBound(dblAngles)
'    If lngIndex = 0 Then
'      dblDebugGap = pTempArray.Element(0) + 360 - pTempArray.Element(UBound(dblAngles))
'    Else
'      dblDebugGap = pTempArray.Element(lngIndex) - pTempArray.Element(lngIndex - 1)
'    End If
'    If dblDebugGap > 360 Then
'      dblDebugGap = dblDebugGap - 360
'    ElseIf dblDebugGap < 0 Then
'      dblDebugGap = dblDebugGap + 360
'    End If
'    strDebugGap = CStr(Format(dblDebugGap, "0"))
'    Debug.Print CStr(lngIndex + 1) & "]  " & CStr(Format(pTempArray.Element(lngIndex), "0.00")) & "       Gap = " & strDebugGap
'  Next lngIndex
  
125:   pAngleInDegrees.RemoveAll
126:   If booSortClockwise Then
127:     For lngIndex = 0 To pTempArray.Count - 1
128:       pAngleInDegrees.Add pTempArray.Element(lngIndex)
129:     Next lngIndex
130:   Else
131:     For lngIndex = pTempArray.Count - 1 To 0 Step -1
132:       pAngleInDegrees.Add pTempArray.Element(lngIndex)
133:     Next lngIndex
134:   End If

End Sub
Public Sub ByteAscending(narray() As Byte, inLow As Long, inHi As Long)

   Dim pivot As Byte
   Dim tmpSwap As Byte
   Dim tmpLow As Long
   Dim tmpHi  As Long
   
144:    tmpLow = inLow
145:    tmpHi = inHi
   
147:    pivot = narray((inLow + inHi) / 2)

149:    While (tmpLow <= tmpHi)
       
151:       While (narray(tmpLow) < pivot And tmpLow < inHi)
152:          tmpLow = tmpLow + 1
153:       Wend
   
155:       While (pivot < narray(tmpHi) And tmpHi > inLow)
156:          tmpHi = tmpHi - 1
157:       Wend

159:       If (tmpLow <= tmpHi) Then
160:          tmpSwap = narray(tmpLow)
161:          narray(tmpLow) = narray(tmpHi)
162:          narray(tmpHi) = tmpSwap
163:          tmpLow = tmpLow + 1
164:          tmpHi = tmpHi - 1
165:       End If
      
167:    Wend
    
169:    If (inLow < tmpHi) Then ByteAscending narray(), inLow, tmpHi
170:    If (tmpLow < inHi) Then ByteAscending narray(), tmpLow, inHi

End Sub


Public Sub ByteDescending(narray() As Byte, inLow As Long, inHi As Long)

   Dim pivot As Byte
   Dim tmpSwap As Byte
   Dim tmpLow As Long
   Dim tmpHi  As Long
   
182:    tmpLow = inLow
183:    tmpHi = inHi
   
185:    pivot = narray((inLow + inHi) / 2)
   
187:    While (tmpLow <= tmpHi)
        
189:       While (narray(tmpLow) > pivot And tmpLow < inHi)
190:          tmpLow = tmpLow + 1
191:       Wend
      
193:       While (pivot > narray(tmpHi) And tmpHi > inLow)
194:          tmpHi = tmpHi - 1
195:       Wend
      
197:       If (tmpLow <= tmpHi) Then
198:          tmpSwap = narray(tmpLow)
199:          narray(tmpLow) = narray(tmpHi)
200:          narray(tmpHi) = tmpSwap
201:          tmpLow = tmpLow + 1
202:          tmpHi = tmpHi - 1
203:       End If
      
205:    Wend
    
207:    If (inLow < tmpHi) Then ByteDescending narray(), inLow, tmpHi
208:    If (tmpLow < inHi) Then ByteDescending narray(), tmpLow, inHi

End Sub
Public Sub LongAscending(narray() As Long, inLow As Long, inHi As Long)

   Dim pivot As Long
   Dim tmpSwap As Long
   Dim tmpLow As Long
   Dim tmpHi  As Long
   
218:    tmpLow = inLow
219:    tmpHi = inHi
   
221:    pivot = narray((inLow + inHi) / 2)

223:    While (tmpLow <= tmpHi)
       
225:       While (narray(tmpLow) < pivot And tmpLow < inHi)
226:          tmpLow = tmpLow + 1
227:       Wend
   
229:       While (pivot < narray(tmpHi) And tmpHi > inLow)
230:          tmpHi = tmpHi - 1
231:       Wend

233:       If (tmpLow <= tmpHi) Then
234:          tmpSwap = narray(tmpLow)
235:          narray(tmpLow) = narray(tmpHi)
236:          narray(tmpHi) = tmpSwap
237:          tmpLow = tmpLow + 1
238:          tmpHi = tmpHi - 1
239:       End If
      
241:    Wend
    
243:    If (inLow < tmpHi) Then LongAscending narray(), inLow, tmpHi
244:    If (tmpLow < inHi) Then LongAscending narray(), tmpLow, inHi

End Sub


Public Sub LongDescending(narray() As Long, inLow As Long, inHi As Long)

   Dim pivot As Long
   Dim tmpSwap As Long
   Dim tmpLow As Long
   Dim tmpHi  As Long
   
256:    tmpLow = inLow
257:    tmpHi = inHi
   
259:    pivot = narray((inLow + inHi) / 2)
   
261:    While (tmpLow <= tmpHi)
        
263:       While (narray(tmpLow) > pivot And tmpLow < inHi)
264:          tmpLow = tmpLow + 1
265:       Wend
      
267:       While (pivot > narray(tmpHi) And tmpHi > inLow)
268:          tmpHi = tmpHi - 1
269:       Wend
      
271:       If (tmpLow <= tmpHi) Then
272:          tmpSwap = narray(tmpLow)
273:          narray(tmpLow) = narray(tmpHi)
274:          narray(tmpHi) = tmpSwap
275:          tmpLow = tmpLow + 1
276:          tmpHi = tmpHi - 1
277:       End If
      
279:    Wend
    
281:    If (inLow < tmpHi) Then LongDescending narray(), inLow, tmpHi
282:    If (tmpLow < inHi) Then LongDescending narray(), tmpLow, inHi

End Sub




Public Sub SingleAscending(narray() As Single, inLow As Long, inHi As Long)

   Dim pivot As Single
   Dim tmpSwap As Single
   Dim tmpLow As Long
   Dim tmpHi  As Long
   
296:    tmpLow = inLow
297:    tmpHi = inHi
   
299:    pivot = narray((inLow + inHi) / 2)

301:    While (tmpLow <= tmpHi)
       
303:       While (narray(tmpLow) < pivot And tmpLow < inHi)
304:          tmpLow = tmpLow + 1
305:       Wend
   
307:       While (pivot < narray(tmpHi) And tmpHi > inLow)
308:          tmpHi = tmpHi - 1
309:       Wend

311:       If (tmpLow <= tmpHi) Then
312:          tmpSwap = narray(tmpLow)
313:          narray(tmpLow) = narray(tmpHi)
314:          narray(tmpHi) = tmpSwap
315:          tmpLow = tmpLow + 1
316:          tmpHi = tmpHi - 1
317:       End If
      
319:    Wend
    
321:    If (inLow < tmpHi) Then SingleAscending narray(), inLow, tmpHi
322:    If (tmpLow < inHi) Then SingleAscending narray(), tmpLow, inHi

End Sub


Public Sub SingleDescending(narray() As Single, inLow As Long, inHi As Long)

   Dim pivot As Single
   Dim tmpSwap As Single
   Dim tmpLow As Long
   Dim tmpHi  As Long
   
334:    tmpLow = inLow
335:    tmpHi = inHi
   
337:    pivot = narray((inLow + inHi) / 2)
   
339:    While (tmpLow <= tmpHi)
        
341:       While (narray(tmpLow) > pivot And tmpLow < inHi)
342:          tmpLow = tmpLow + 1
343:       Wend
      
345:       While (pivot > narray(tmpHi) And tmpHi > inLow)
346:          tmpHi = tmpHi - 1
347:       Wend
      
349:       If (tmpLow <= tmpHi) Then
350:          tmpSwap = narray(tmpLow)
351:          narray(tmpLow) = narray(tmpHi)
352:          narray(tmpHi) = tmpSwap
353:          tmpLow = tmpLow + 1
354:          tmpHi = tmpHi - 1
355:       End If
      
357:    Wend
    
359:    If (inLow < tmpHi) Then SingleDescending narray(), inLow, tmpHi
360:    If (tmpLow < inHi) Then SingleDescending narray(), tmpLow, inHi

End Sub
Public Sub DoubleAscendingWithObjects(narray() As Double, varObjArray() As Variant, inLow As Long, inHi As Long)

  Dim pivot As Double
  Dim tmpSwap As Double
  Dim tmpSizeSwap As Variant
  Dim tmpLow As Long
  Dim tmpHi  As Long
   
371:   tmpLow = inLow
372:   tmpHi = inHi
   
374:   pivot = narray((inLow + inHi) / 2)
375:   While (tmpLow <= tmpHi)
       
377:     While (narray(tmpLow) < pivot And tmpLow < inHi)
378:        tmpLow = tmpLow + 1
379:     Wend
  
381:     While (pivot < narray(tmpHi) And tmpHi > inLow)
382:        tmpHi = tmpHi - 1
383:     Wend
384:     If (tmpLow <= tmpHi) Then
385:        tmpSwap = narray(tmpLow)
386:        narray(tmpLow) = narray(tmpHi)
387:        narray(tmpHi) = tmpSwap
       
389:        tmpSizeSwap = varObjArray(tmpLow)
390:        varObjArray(tmpLow) = varObjArray(tmpHi)
391:        varObjArray(tmpHi) = tmpSizeSwap
       
393:        tmpLow = tmpLow + 1
394:        tmpHi = tmpHi - 1
395:     End If
     
397:   Wend
    
399:   If (inLow < tmpHi) Then DoubleAscendingWithObjects narray(), varObjArray(), inLow, tmpHi
400:   If (tmpLow < inHi) Then DoubleAscendingWithObjects narray(), varObjArray(), tmpLow, inHi

End Sub

Public Sub StringsAscendingWithObjects(sarray() As String, varObjArray() As Variant, inLow As Long, inHi As Long)

   Dim pivot As String
   Dim tmpSwap As String
   Dim tmpSizeSwap As Variant
   Dim tmpLow As Long
   Dim tmpHi As Long
   
412:    tmpLow = inLow
413:    tmpHi = inHi
   
415:    pivot = sarray((inLow + inHi) / 2)
  
417:    While (tmpLow <= tmpHi)
   
419:       While (sarray(tmpLow) < pivot And tmpLow < inHi)
420:          tmpLow = tmpLow + 1
421:       Wend
      
423:       While (pivot < sarray(tmpHi) And tmpHi > inLow)
424:          tmpHi = tmpHi - 1
425:       Wend
      
427:       If (tmpLow <= tmpHi) Then
428:          tmpSwap = sarray(tmpLow)
429:          sarray(tmpLow) = sarray(tmpHi)
430:          sarray(tmpHi) = tmpSwap
       
432:          tmpSizeSwap = varObjArray(tmpLow)
433:          varObjArray(tmpLow) = varObjArray(tmpHi)
434:          varObjArray(tmpHi) = tmpSizeSwap
        
436:          tmpLow = tmpLow + 1
437:          tmpHi = tmpHi - 1
438:       End If
   
440:    Wend
  
442:    If (inLow < tmpHi) Then StringsAscendingWithObjects sarray(), varObjArray(), inLow, tmpHi
443:    If (tmpLow < inHi) Then StringsAscendingWithObjects sarray(), varObjArray(), tmpLow, inHi

End Sub


Public Sub DoubleAscendingWithSizes(narray() As Double, nSizeArray() As Double, inLow As Long, inHi As Long)

  Dim pivot As Double
  Dim tmpSwap As Double
  Dim tmpSizeSwap As Double
  Dim tmpLow As Long
  Dim tmpHi  As Long
   
456:   tmpLow = inLow
457:   tmpHi = inHi
   
459:   pivot = narray((inLow + inHi) / 2)
460:   While (tmpLow <= tmpHi)
       
462:     While (narray(tmpLow) < pivot And tmpLow < inHi)
463:        tmpLow = tmpLow + 1
464:     Wend
  
466:     While (pivot < narray(tmpHi) And tmpHi > inLow)
467:        tmpHi = tmpHi - 1
468:     Wend
469:     If (tmpLow <= tmpHi) Then
470:        tmpSwap = narray(tmpLow)
471:        narray(tmpLow) = narray(tmpHi)
472:        narray(tmpHi) = tmpSwap
       
474:        tmpSizeSwap = nSizeArray(tmpLow)
475:        nSizeArray(tmpLow) = nSizeArray(tmpHi)
476:        nSizeArray(tmpHi) = tmpSizeSwap
       
478:        tmpLow = tmpLow + 1
479:        tmpHi = tmpHi - 1
480:     End If
     
482:   Wend
    
484:   If (inLow < tmpHi) Then DoubleAscendingWithSizes narray(), nSizeArray(), inLow, tmpHi
485:   If (tmpLow < inHi) Then DoubleAscendingWithSizes narray(), nSizeArray(), tmpLow, inHi

End Sub
Public Sub DoubleAscending(narray() As Double, inLow As Long, inHi As Long)

   Dim pivot As Double
   Dim tmpSwap As Double
   Dim tmpLow As Long
   Dim tmpHi  As Long
   
495:    tmpLow = inLow
496:    tmpHi = inHi
   
498:    pivot = narray((inLow + inHi) / 2)

500:    While (tmpLow <= tmpHi)
       
502:       While (narray(tmpLow) < pivot And tmpLow < inHi)
503:          tmpLow = tmpLow + 1
504:       Wend
   
506:       While (pivot < narray(tmpHi) And tmpHi > inLow)
507:          tmpHi = tmpHi - 1
508:       Wend

510:       If (tmpLow <= tmpHi) Then
511:          tmpSwap = narray(tmpLow)
512:          narray(tmpLow) = narray(tmpHi)
513:          narray(tmpHi) = tmpSwap
514:          tmpLow = tmpLow + 1
515:          tmpHi = tmpHi - 1
516:       End If
      
518:    Wend
    
520:    If (inLow < tmpHi) Then DoubleAscending narray(), inLow, tmpHi
521:    If (tmpLow < inHi) Then DoubleAscending narray(), tmpLow, inHi

End Sub


Public Sub DoubleDescending(narray() As Double, inLow As Long, inHi As Long)

   Dim pivot As Double
   Dim tmpSwap As Double
   Dim tmpLow As Long
   Dim tmpHi  As Long
   
533:    tmpLow = inLow
534:    tmpHi = inHi
   
536:    pivot = narray((inLow + inHi) / 2)
   
538:    While (tmpLow <= tmpHi)
        
540:       While (narray(tmpLow) > pivot And tmpLow < inHi)
541:          tmpLow = tmpLow + 1
542:       Wend
      
544:       While (pivot > narray(tmpHi) And tmpHi > inLow)
545:          tmpHi = tmpHi - 1
546:       Wend
      
548:       If (tmpLow <= tmpHi) Then
549:          tmpSwap = narray(tmpLow)
550:          narray(tmpLow) = narray(tmpHi)
551:          narray(tmpHi) = tmpSwap
552:          tmpLow = tmpLow + 1
553:          tmpHi = tmpHi - 1
554:       End If
      
556:    Wend
    
558:    If (inLow < tmpHi) Then DoubleDescending narray(), inLow, tmpHi
559:    If (tmpLow < inHi) Then DoubleDescending narray(), tmpLow, inHi

End Sub

Public Sub StringsAscending(sarray() As String, inLow As Long, inHi As Long)
  
   Dim pivot As String
   Dim tmpSwap As String
   Dim tmpLow As Long
   Dim tmpHi As Long
   
570:    tmpLow = inLow
571:    tmpHi = inHi
   
573:    pivot = sarray((inLow + inHi) / 2)
  
575:    While (tmpLow <= tmpHi)
   
577:       While (sarray(tmpLow) < pivot And tmpLow < inHi)
578:          tmpLow = tmpLow + 1
579:       Wend
      
581:       While (pivot < sarray(tmpHi) And tmpHi > inLow)
582:          tmpHi = tmpHi - 1
583:       Wend
      
585:       If (tmpLow <= tmpHi) Then
586:          tmpSwap = sarray(tmpLow)
587:          sarray(tmpLow) = sarray(tmpHi)
588:          sarray(tmpHi) = tmpSwap
589:          tmpLow = tmpLow + 1
590:          tmpHi = tmpHi - 1
591:       End If
   
593:    Wend
  
595:    If (inLow < tmpHi) Then StringsAscending sarray(), inLow, tmpHi
596:    If (tmpLow < inHi) Then StringsAscending sarray(), tmpLow, inHi

End Sub


Public Sub StringsDescending(sarray() As String, inLow As Long, inHi As Long)
  
   Dim pivot As String
   Dim tmpSwap As String
   Dim tmpLow As Long
   Dim tmpHi As Long
   
608:    tmpLow = inLow
609:    tmpHi = inHi
   
611:    pivot = sarray((inLow + inHi) / 2)
   
613:    While (tmpLow <= tmpHi)
      
615:       While (sarray(tmpLow) > pivot And tmpLow < inHi)
616:          tmpLow = tmpLow + 1
617:       Wend
    
619:       While (pivot > sarray(tmpHi) And tmpHi > inLow)
620:          tmpHi = tmpHi - 1
621:       Wend

623:       If (tmpLow <= tmpHi) Then
624:          tmpSwap = sarray(tmpLow)
625:          sarray(tmpLow) = sarray(tmpHi)
626:          sarray(tmpHi) = tmpSwap
627:          tmpLow = tmpLow + 1
628:          tmpHi = tmpHi - 1
629:       End If
  
631:    Wend
  
633:    If (inLow < tmpHi) Then StringsDescending sarray(), inLow, tmpHi
634:    If (tmpLow < inHi) Then StringsDescending sarray(), tmpLow, inHi

End Sub


Public Sub VariantAscending(sarray() As Variant, inLow As Long, inHi As Long)
  
   Dim pivot As Variant
   Dim tmpSwap As Variant
   Dim tmpLow As Long
   Dim tmpHi As Long
   
646:    tmpLow = inLow
647:    tmpHi = inHi
   
649:    pivot = sarray((inLow + inHi) / 2)
  
651:    While (tmpLow <= tmpHi)
   
653:       While (sarray(tmpLow) < pivot And tmpLow < inHi)
654:          tmpLow = tmpLow + 1
655:       Wend
      
657:       While (pivot < sarray(tmpHi) And tmpHi > inLow)
658:          tmpHi = tmpHi - 1
659:       Wend
      
661:       If (tmpLow <= tmpHi) Then
662:          tmpSwap = sarray(tmpLow)
663:          sarray(tmpLow) = sarray(tmpHi)
664:          sarray(tmpHi) = tmpSwap
665:          tmpLow = tmpLow + 1
666:          tmpHi = tmpHi - 1
667:       End If
   
669:    Wend
  
671:    If (inLow < tmpHi) Then VariantAscending sarray(), inLow, tmpHi
672:    If (tmpLow < inHi) Then VariantAscending sarray(), tmpLow, inHi

End Sub


Public Sub VariantDescending(sarray() As Variant, inLow As Long, inHi As Long)
  
   Dim pivot As Variant
   Dim tmpSwap As Variant
   Dim tmpLow As Long
   Dim tmpHi As Long
   
684:    tmpLow = inLow
685:    tmpHi = inHi
   
687:    pivot = sarray((inLow + inHi) / 2)
   
689:    While (tmpLow <= tmpHi)
      
691:       While (sarray(tmpLow) > pivot And tmpLow < inHi)
692:          tmpLow = tmpLow + 1
693:       Wend
    
695:       While (pivot > sarray(tmpHi) And tmpHi > inLow)
696:          tmpHi = tmpHi - 1
697:       Wend

699:       If (tmpLow <= tmpHi) Then
700:          tmpSwap = sarray(tmpLow)
701:          sarray(tmpLow) = sarray(tmpHi)
702:          sarray(tmpHi) = tmpSwap
703:          tmpLow = tmpLow + 1
704:          tmpHi = tmpHi - 1
705:       End If
  
707:    Wend
  
709:    If (inLow < tmpHi) Then VariantDescending sarray(), inLow, tmpHi
710:    If (tmpLow < inHi) Then VariantDescending sarray(), tmpLow, inHi

End Sub

Public Sub DatesDescending(narray() As Date, inLow As Long, inHi As Long)

   Dim pivot As Long
   Dim tmpSwap As Long
   Dim tmpLow As Long
   Dim tmpHi  As Long
   
721:    tmpLow = inLow
722:    tmpHi = inHi
   
724:    pivot = DateToJulian(narray((inLow + inHi) / 2))
   
726:    While (tmpLow <= tmpHi)
        
728:       While DateToJulian(narray(tmpLow)) > pivot And (tmpLow < inHi)
729:          tmpLow = tmpLow + 1
730:       Wend
      
732:       While (pivot > DateToJulian(narray(tmpHi))) And (tmpHi > inLow)
733:          tmpHi = tmpHi - 1
734:       Wend
      
736:       If (tmpLow <= tmpHi) Then
737:          tmpSwap = narray(tmpLow)
738:          narray(tmpLow) = narray(tmpHi)
739:          narray(tmpHi) = tmpSwap
740:          tmpLow = tmpLow + 1
741:          tmpHi = tmpHi - 1
742:       End If
      
744:    Wend
    
746:    If (inLow < tmpHi) Then DatesDescending narray(), inLow, tmpHi
747:    If (tmpLow < inHi) Then DatesDescending narray(), tmpLow, inHi

End Sub


Public Sub DatesAscending(narray() As Date, inLow As Long, inHi As Long)

   Dim pivot As Long
   Dim tmpSwap As Long
   Dim tmpLow As Long
   Dim tmpHi  As Long
   
759:    tmpLow = inLow
760:    tmpHi = inHi
   
762:    pivot = DateToJulian(narray((inLow + inHi) / 2))

764:    While (tmpLow <= tmpHi)
       
766:       While (DateToJulian(narray(tmpLow)) < pivot) And (tmpLow < inHi)
767:          tmpLow = tmpLow + 1
768:       Wend
   
770:       While (pivot < DateToJulian(narray(tmpHi))) And (tmpHi > inLow)
771:          tmpHi = tmpHi - 1
772:       Wend

774:       If (tmpLow <= tmpHi) Then
      
776:          tmpSwap = narray(tmpLow)
777:          narray(tmpLow) = narray(tmpHi)
778:          narray(tmpHi) = tmpSwap
779:          tmpLow = tmpLow + 1
780:          tmpHi = tmpHi - 1
         
782:       End If
      
784:    Wend
    
786:    If (inLow < tmpHi) Then DatesAscending narray(), inLow, tmpHi
787:    If (tmpLow < inHi) Then DatesAscending narray(), tmpLow, inHi

End Sub

Private Function DateToJulian(MyDate As Date) As Long

  'Return a numeric value representing
  'the passed date
795:    DateToJulian = DateValue(MyDate)

End Function

