Attribute VB_Name = "StatProcs"
Option Explicit

Const m_dblEuler As Double = 2.71828182845905
Const m_dblPi As Double = 3.14159265358979
Const m_dblGammaPartA As Double = 2.506628274631       ' = sqr(2 * m_dblPi)
Const m_dblEPS As Double = 2.22045 * (10 ^ (-16))
Const m_dblMinPositive As Double = 1.00208 * (10 ^ (-292))
Const m_lngMaxIteration As Long = 1000

Private m_dblNormSimpsonArray(1, 44) As Double
Private m_booArrayLoaded As Boolean
Private m_booGammaArrayLoaded As Boolean
Private m_dblConstants(6) As Double

Public m_booFoundError As Boolean
Const c_sModuleFileName As String = "D:\arcGIS_stuff\consultation\brost_climate_change\code\StatProcs.bas"


Public Function CDF_ChiSquare(dblChiSquareVal As Double, lngDegreesOfFreedom As Long) As Double
  On Error GoTo ErrorHandler

  
23:   CDF_ChiSquare = Jen_ReturnIncompleteGammaP(CDbl(lngDegreesOfFreedom / 2), _
        dblChiSquareVal / 2)
  


  Exit Function
ErrorHandler:
  HandleError True, "CDF_ChiSquare " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function Jen_ReturnIncompleteGammaP(dblHalfDF As Double, dblHalfChiSquareValue As Double) As Double
  On Error GoTo ErrorHandler


'  ' FUNCTIONS ADAPTED FROM "Numerical Recipies in C:  The Art of Scientific Computing (ISBN 0-521-43108-5)
'' 1988-1992 by Cambridge University Press.
'' (http://lib-www.lanl.gov/numerical/bookcpdf.html - See Chapter 6, sections 1-4)
''
'' HANDBOOK OF MATHEMATICAL FORMULAS AND INTEGRALS, 2ND. ED. ALAN JEFFREY
''
'' HANDBOOK OF MATHEMATICAL FUNCTIONS, 1972, MILTON ABRAMOWITZ AND IRENE A. STEGUN
''
'' ORIGINAL C++ CODE TO RETURN INCOMPLETE GAMMA P
''
''DP NR::gammp(const DP a, const DP x)
''{
'' DP gamser,gammcf,gln;
''
'' if (x < 0.0 || a <= 0.0)
''   nrerror("Invalid arguments in routine gammp");
'' if (x < a+1.0) {
''   gser(gamser,a,x,gln);
''   return gamser;
'' } else {
''   gcf(gammcf,a,x,gln);
''   return 1.0-gammcf;
'' }
''}
'
'theAValue = self.Get(0)
'theXValue = self.Get(1)
'
'If ((theXValue < 0) Or (theAValue <= 0)) Then
'  msgBox.Info("Invalid arguments in routine ReturnIncompleteGammaP", "Problem:")
'Else
'  If (theXValue < (theAValue + 1)) Then
'    theReturn = av.Run("Jennessent.ReturnIncompleteGammaSeries", {theAValue, theXValue})
'  Else
'    theReturn = 1 - (av.Run("Jennessent.ReturnIncompleteGammaConFrac", {theAValue, theXValue}))
'  End
'End
  
75:   If dblHalfChiSquareValue < 0 Or dblHalfDF <= 0 Then
76:     MsgBox "Invalid arguments in routine 'Jen_ReturnincompleteGammaP'..."
    Exit Function
78:   Else
79:     If dblHalfChiSquareValue < (dblHalfDF + 1) Then
80:       Jen_ReturnIncompleteGammaP = ReturnIncompleteGammaSeries(dblHalfDF, dblHalfChiSquareValue)
81:     Else
82:       Jen_ReturnIncompleteGammaP = 1 - ReturnIncompleteGammaConFrac(dblHalfDF, dblHalfChiSquareValue)
83:     End If
84:   End If
    
  Exit Function
ErrorHandler:
  HandleError True, "Jen_ReturnIncompleteGammaP " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function ReturnIncompleteGammaConFrac(dblHalfDF As Double, dblHalfChiSquareValue As Double) As Double
  On Error GoTo ErrorHandler

'' Jennessent.ReturnIncompleteGammaConFrac
'
'' FUNCTIONS ADAPTED FROM "Numerical Recipies in C:  The Art of Scientific Computing (ISBN 0-521-43108-5)
'' 1988-1992 by Cambridge University Press.
'' (http://lib-www.lanl.gov/numerical/bookcpdf.html - See Chapter 6, sections 1-4)
''
'' HANDBOOK OF MATHEMATICAL FORMULAS AND INTEGRALS, 2ND. ED. ALAN JEFFREY
''
'' HANDBOOK OF MATHEMATICAL FUNCTIONS, 1972, MILTON ABRAMOWITZ AND IRENE A. STEGUN
''
'' ORIGINAL C++ CODE TO RETURN INCOMPLETE GAMMA CONTINUED FRACTION
'
''void NR::gcf(DP &gammcf, const DP a, const DP x, DP &gln)
''{
'' const int ITMAX=100;
'' const DP EPS=numeric_limits<DP>::epsilon();
'' const DP FPMIN=numeric_limits<DP>::min()/EPS;
'' int i;
'' DP an,b,c,d,del,h;
''
'' gln=gammln(a);
'' b=x+1.0-a;
'' c=1.0/FPMIN;
'' d=1.0/b;
'' h=d;
'' for (i=1;i<=ITMAX;i++) {
''   an = -i*(i-a);
''   b += 2.0;
''   d=an*d+b;
''   if (fabs(d) < FPMIN) d=FPMIN;
''   c=b+an/c;
''   if (fabs(c) < FPMIN) c=FPMIN;
''   d=1.0/d;
''   del=d*c;
''   h *= del;
''   if (fabs(del-1.0) <= EPS) break;
'' }
'' if (i > ITMAX) nrerror("a too large, ITMAX too small in gcf");
'' gammcf=exp(-x+a*log(x)-gln)*h;
''}
'
''msgBox.Info("Running Continuous Fraction method...", "")
'
'theMaxIteration = 1000
'theEPS = 2.22045 * (10 ^ (-16))
'theMinPositive = 1.00208 * (10 ^ (-292))
'
'dblHalfDF = self.Get(0)        ' dblHalfDF
'dblHalfChiSquareValue = self.Get(1)        ' dblHalfChiSquareValue
'
'If (dblHalfChiSquareValue < 0) Then
'  theReturn = Number.MakeNull
'ElseIf (dblHalfChiSquareValue = 0) Then
'  theReturn = 0
'Else
'  theGLN = av.Run("Jennessent.ReturnNatLogGammaEstimation", {dblHalfDF})
'  theBValue = dblHalfChiSquareValue + 1 - dblHalfDF
'  theCValue = 1 / theMinPositive
'  theDValue = 1 / theBValue
'  theHValue = theDValue
'  for each anI in 1..theMaxIteration
'    theTestI = anI
'    theANValue = (anI * -1) * (anI - dblHalfDF)
'    theBValue = theBValue + 2
'    theDValue = (theANValue * theDValue) + theBValue
'    if (theDValue.Abs < theMinPositive) then theDValue = theMinPositive end
'    theCValue = theBValue + (theANValue / theCValue)
'    if (theCValue.Abs < theMinPositive) then theCValue = theMinPositive end
'    theDValue = 1 / theDValue
'    theDEL = theDValue * theCValue
'    theHValue = theHValue * theDEL
'    if ((theDEL - 1).abs <= theEPS) then
'      Break
'    End
'  End
'  If (theTestI > theMaxIteration) Then
'    msgBox.Info("Error:  'a' too large; maximum number of iterations is too small...", "Problem:")
'  End
'  'msgBox.Info(theTestI.AsString++"iterations", "")
'  theReturn = (Number.GetEuler ^ ((dblHalfChiSquareValue * -1) + (dblHalfDF * (dblHalfChiSquareValue.Ln)) - theGLN)) * theHValue
'End
'
'return theReturn

178:   If dblHalfChiSquareValue < 0 Then
179:     MsgBox "Invalid value in 'ReturnIncompleteGammaConFrac':" & vbCrLf & _
           "dblHalfChiSquareValue should be >= 0.  Tested value = " & CStr(dblHalfChiSquareValue) & "...", vbCritical, "Invalid Value:"
    Exit Function
182:   ElseIf dblHalfChiSquareValue = 0 Then
183:     ReturnIncompleteGammaConFrac = 0
184:   Else
    Dim dblGLN As Double
    Dim dblAN As Double
    Dim dblB As Double
    Dim dblC As Double
    Dim dblD As Double
    Dim dblH As Double
    Dim dblTestI As Double
    Dim lngIndex As Long
    Dim dblDEL As Double
    
195:     dblGLN = ReturnNaturalLogGammaEstimation(dblHalfDF)
196:     dblB = dblHalfChiSquareValue + 1 - dblHalfDF
197:     dblC = -1 / m_dblMinPositive
198:     dblD = 1 / dblB
199:     dblH = dblD
    
201:     For lngIndex = 1 To m_lngMaxIteration  ' 1000
202:       dblTestI = lngIndex
203:       dblAN = -lngIndex * (lngIndex - dblHalfDF)
204:       dblB = dblB + 2
205:       dblD = (dblAN * dblD) + dblB
206:       If Abs(dblD) < m_dblMinPositive Then dblD = m_dblMinPositive
207:       dblC = dblB + (dblAN / dblC)
208:       If Abs(dblC) < m_dblMinPositive Then dblC = m_dblMinPositive
209:       dblD = 1 / dblD
210:       dblDEL = dblD * dblC
211:       dblH = dblH * dblDEL
212:       If Abs(dblDEL - 1) <= m_dblEPS Then
213:         Exit For
214:       End If
215:     Next lngIndex
    
217:     Debug.Print CStr(lngIndex) & " iterations in 'ReturnIncompleteGammaConFrac'..."
    
219:     If lngIndex >= m_lngMaxIteration Then
220:       MsgBox "Error:  'A' too large; maximum number of iterations too small...", vbCritical, "Error:"
221:     End If
222:     ReturnIncompleteGammaConFrac = _
      (m_dblEuler ^ (-dblHalfChiSquareValue + (dblHalfDF * Log(dblHalfChiSquareValue)) - dblGLN)) * dblH
    
225:   End If
  


  Exit Function
ErrorHandler:
  HandleError True, "ReturnIncompleteGammaConFrac " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function ReturnIncompleteGammaSeries(dblHalfDF As Double, dblHalfChiSquareVal As Double) As Double
  On Error GoTo ErrorHandler


'' Jennessent.ReturnIncompleteGammaSeries
'
'' FUNCTIONS ADAPTED FROM "Numerical Recipies in C:  The Art of Scientific Computing (ISBN 0-521-43108-5)
'' 1988-1992 by Cambridge University Press.
'' (http://lib-www.lanl.gov/numerical/bookcpdf.html - See Chapter 6, sections 1-4)
''
'' HANDBOOK OF MATHEMATICAL FORMULAS AND INTEGRALS, 2ND. ED. ALAN JEFFREY
''
'' HANDBOOK OF MATHEMATICAL FUNCTIONS, 1972, MILTON ABRAMOWITZ AND IRENE A. STEGUN
''
'' ORIGINAL C++ CODE TO RETURN INCOMPLETE GAMMA SERIES
'
''void NR::gser(DP &gamser, const DP a, const DP x, DP &gln)
''{
'' const int ITMAX=100;
'' const DP EPS=numeric_limits<DP>::epsilon();
'' int n;
'' DP sum,del,ap;
''
'' gln=gammln(a);
'' if (x <= 0.0) {
''   if (x < 0.0) nrerror("x less than 0 in routine gser");
''   gamser=0.0;
''   return;
'' } else {
''   ap=a;
''   del=sum=1.0/a;
''   for (n=0;n<ITMAX;n++) {
''     ++ap;
''     del *= x/ap;
''     sum += del;
''     if (fabs(del) < fabs(sum)*EPS) {
''       gamser=sum*exp(-x+a*log(x)-gln);
''       return;
''     }
''   }
''   nrerror("a too large, ITMAX too small in routine gser");
''   return;
'' }
''}
'
''msgBox.Info("Running Series method...", "")
'
'theMaxIteration = 10000
'theEPS = 2.22045 * (10 ^ (-16))
'' theMinPositive = 1.00208 * (10^(-292))
'
'dblHalfDF = self.Get(0)
'dblHalfChiSquareVal = self.Get(1)
'
'If (dblHalfChiSquareVal < 0) Then
'  theReturn = Number.MakeNull
'ElseIf (dblHalfChiSquareVal = 0) Then
'  theReturn = 0
'Else
'  theGLN = av.Run("Jennessent.ReturnNatLogGammaEstimation", {dblHalfDF})
'  theAPValue = dblHalfDF
'  theDEL = 1 / dblHalfDF
'  theSum = 1 / dblHalfDF
'  IsReturned = False
'  for each aNumber in 0..theMaxIteration
'    theTest = aNumber
'    theAPValue = theAPValue + 1
'    theDEL = theDEL * (dblHalfChiSquareVal / theAPValue)
'    theSum = theSum + theDEL
'    If ((theDEL.Abs) < ((theSum.Abs) * theEPS)) Then
'      theReturn = theSum * ((Number.GetEuler) ^ ((dblHalfChiSquareVal * -1) + (dblHalfDF * (dblHalfChiSquareVal.Ln)) - theGLN))
'      IsReturned = True
'      Break
'    End
'  End
'
'  If (IsReturned.Not) Then
'    msgBox.Info("Maximum Iterations Too Small!", "")
'  End
'  'msgBox.Info(theTest.AsString++"iterations", "")
'End
'
'return theReturn
  
318:   If dblHalfChiSquareVal < 0 Then
319:     MsgBox "Invalid value in 'ReturnIncompleteGammaSeries':" & vbCrLf & _
           "dblHalfChiSquareValue should be >= 0.  Tested value = " & CStr(dblHalfChiSquareVal) & "...", vbCritical, "Invalid Value:"
    Exit Function
322:   ElseIf dblHalfChiSquareVal = 0 Then
323:     ReturnIncompleteGammaSeries = 0
324:   Else
    Dim dblGLN As Double
    Dim dblAP As Double
    Dim dblDEL As Double
    Dim dblSum As Double
    Dim booIsReturned As Boolean
    
    Dim lngIndex As Long
    
333:     dblGLN = ReturnNaturalLogGammaEstimation(dblHalfDF)
334:     dblAP = dblHalfDF
335:     dblDEL = 1 / dblHalfDF
336:     dblSum = dblDEL
337:     booIsReturned = False
    
339:     For lngIndex = 1 To m_lngMaxIteration
340:       dblAP = dblAP + 1
341:       dblDEL = dblDEL * dblHalfChiSquareVal / dblAP
342:       dblSum = dblSum + dblDEL
343:       If Abs(dblDEL) < (Abs(dblSum) * m_dblEPS) Then
344:         ReturnIncompleteGammaSeries = _
          dblSum * (m_dblEuler ^ (-dblHalfChiSquareVal + (dblHalfDF * Log(dblHalfChiSquareVal)) - dblGLN))
346:         booIsReturned = True
347:         Exit For
348:       End If
349:     Next lngIndex
    
351:     If Not booIsReturned Then MsgBox "Maximum Iterations Too Small!"
352:     Debug.Print CStr(lngIndex) & " iterations in 'ReturnIncompleteGammaSeries'..."
353:   End If
  
  Exit Function
ErrorHandler:
  HandleError True, "ReturnIncompleteGammaSeries " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function Jen_ReturnIncompleteBeta(dblA As Double, dblB As Double, dblX As Double) As Double
  On Error GoTo ErrorHandler
  
  If m_booFoundError Then Exit Function

' Jennessent.ReturnIncompleteBeta
' FUNCTIONS ADAPTED FROM "Numerical Recipies in C:  The Art of Scientific Computing (ISBN 0-521-43108-5)
' 1988-1992 by Cambridge University Press.
' (http://lib-www.lanl.gov/numerical/bookcpdf.html - See Chapter 6, sections 1-4)
'
' HANDBOOK OF MATHEMATICAL FORMULAS AND INTEGRALS, 2ND. ED. ALAN JEFFREY
'
' HANDBOOK OF MATHEMATICAL FUNCTIONS, 1972, MILTON ABRAMOWITZ AND IRENE A. STEGUN
'
' ORIGINAL C++ CODE TO RETURN INCOMPLETE BETA
'#include <cmath>
'#include "nr.h"
'using namespace std;
'
'DP NR::betai(const DP a, const DP b, const DP x)
'{
' DP bt;
'
' if (x < 0.0 || x > 1.0) nrerror("Bad x in routine betai");
' if (x == 0.0 || x == 1.0) bt=0.0;
' else
'   bt=exp(gammln(a+b)-gammln(a)-gammln(b)+a*log(x)+b*log(1.0-x));
' if (x < (a+1.0)/(a+b+2.0))
'   return bt*betacf(a,b,x)/a;
' else
'   return 1.0-bt*betacf(b,a,1.0-x)/b;
'}
'
  Dim dblGammaLnAPlusB As Double
  Dim dblGammaLnA As Double
  Dim dblGammaLnB As Double
396:   dblGammaLnAPlusB = ReturnNaturalLogGammaEstimation(dblA + dblB)
397:   dblGammaLnA = ReturnNaturalLogGammaEstimation(dblA)
398:   dblGammaLnB = ReturnNaturalLogGammaEstimation(dblB)
  
  Dim dblBT As Double
  
  Dim lngX As Double
403:   lngX = Round(dblX, 9)
404:   If lngX = 0 Or lngX = 1 Then
405:     dblBT = 0
406:   Else
407:     dblBT = m_dblEuler ^ (dblGammaLnAPlusB - dblGammaLnA - dblGammaLnB + (dblA * Log(dblX)) + (dblB * (Log(1 - dblX))))
408:   End If
  
  Dim dblBetaCF As Double
  
412:   If dblX < ((dblA + 1) / (dblA + dblB + 2)) Then
413:     dblBetaCF = ReturnBetaContFraction(dblA, dblB, dblX)
414:     Jen_ReturnIncompleteBeta = (dblBT * dblBetaCF) / dblA
415:   Else
416:     dblBetaCF = ReturnBetaContFraction(dblB, dblA, 1 - dblX)
417:     Jen_ReturnIncompleteBeta = 1 - ((dblBT * dblBetaCF) / dblB)
418:   End If
'  MsgBox "IncompleteBeta = " & CStr(Format(Jen_ReturnIncompleteBeta, "0.00000000"))
  

  Exit Function
ErrorHandler:
  HandleError True, "Jen_ReturnIncompleteBeta " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function ReturnBetaContFraction(dblA As Double, dblB As Double, dblX As Double) As Double
  On Error GoTo ErrorHandler
  If m_booFoundError Then Exit Function

  ' Jennessent.ReturnBetaContFraction
  '
  ' FUNCTIONS ADAPTED FROM "Numerical Recipies in C:  The Art of Scientific Computing (ISBN 0-521-43108-5)
  ' 1988-1992 by Cambridge University Press.
  ' (http://lib-www.lanl.gov/numerical/bookcpdf.html - See Chapter 6, sections 1-4)
  '
  ' HANDBOOK OF MATHEMATICAL FORMULAS AND INTEGRALS, 2ND. ED. ALAN JEFFREY
  '
  ' HANDBOOK OF MATHEMATICAL FUNCTIONS, 1972, MILTON ABRAMOWITZ AND IRENE A. STEGUN
  '
  ' ORIGINAL C++ CODE TO RETURN CONTINUED FRACTION
  '
  'DP NR::betacf(const DP a, const DP b, const DP x)
  '{
  ' const int MAXIT=100;
  ' const DP EPS=numeric_limits<DP>::epsilon();
  ' const DP FPMIN=numeric_limits<DP>::min()/EPS;
  ' int m,m2;
  ' DP aa,c,d,del,h,qab,qam,qap;
  '
  ' qab=a+b;
  ' qap=a+1.0;
  ' qam=a-1.0;
  ' c=1.0;
  ' d=1.0-qab*x/qap;
  ' if (fabs(d) < FPMIN) d=FPMIN;
  ' d=1.0/d;
  ' h=d;
  ' for (m=1;m<=MAXIT;m++) {
  '   m2=2*m;
  '   aa=m*(b-m)*x/((qam+m2)*(a+m2));
  '   d=1.0+aa*d;
  '   if (fabs(d) < FPMIN) d=FPMIN;
  '   c=1.0+aa/c;
  '   if (fabs(c) < FPMIN) c=FPMIN;
  '   d=1.0/d;
  '   h *= d*c;
  '   aa = -(a+m)*(qab+m)*x/((a+m2)*(qap+m2));
  '   d=1.0+aa*d;
  '   if (fabs(d) < FPMIN) d=FPMIN;
  '   c=1.0+aa/c;
  '   if (fabs(c) < FPMIN) c=FPMIN;
  '   d=1.0/d;
  '   del=d*c;
  '   h *= del;
  '   if (fabs(del-1.0) <= EPS) break;
  ' }
  ' if (m > MAXIT) nrerror("a or b too big, or MAXIT too small in betacf");
  ' return h;
  '}
  '
  'theA = 4
  'theB = 5
  'theX = 6
  
  Dim lngMaxIteration As Long
  Dim dblEPS As Double
  Dim dblMinPositive As Double
  
490:   lngMaxIteration = 100
491:   dblEPS = 2.22045 * (10 ^ (-16))
492:   dblMinPositive = 1.00208 * (10 ^ (-292))
  
  'msgBox.Info((1/theMinPositive).AsString, "")
  
  Dim dblQab As Double
  Dim dblQap As Double
  Dim dblQam As Double
  Dim dblC As Double
  Dim dblD As Double
  Dim dblH As Double
  Dim dblM2 As Double
  Dim dblAA As Double
  Dim dblDEL As Double
  
  Dim lngIndex As Long
  
508:   dblQab = dblA + dblB
509:   dblQap = dblA + 1
510:   dblQam = dblA - 1
511:   dblC = 1                                                       ' FIRST STEP IN LENTZ'S METHOD
512:   dblD = 1 - ((dblQab * dblX) / dblQap)
513:   If Abs(dblD) < dblMinPositive Then dblD = dblMinPositive
  
515:   dblD = 1 / dblD
516:   dblH = dblD
'  for each theM in 1..theMaxIteration
518:   For lngIndex = 1 To lngMaxIteration
519:     dblM2 = 2 * lngIndex
520:     dblAA = (lngIndex * (dblB - lngIndex) * dblX) / ((dblQam + dblM2) * (dblA + dblM2))
521:     dblD = 1 + (dblAA * dblD)                                        ' ONE STEP (THE EVEN ONE) OF THE RECURRENCE
522:     If Abs(dblD) < dblMinPositive Then dblD = dblMinPositive
523:     dblC = 1 + (dblAA / dblC)
524:     If Abs(dblC) < dblMinPositive Then dblC = dblMinPositive
525:     dblD = 1 / dblD
526:     dblH = dblH * dblD * dblC
    
528:     dblAA = (-1 * (dblA + lngIndex) * (dblQab + lngIndex) * dblX) / ((dblA + dblM2) * (dblQap + dblM2))
529:     dblD = 1 + (dblAA * dblD)                                        ' NEXT STEP (THE ODD ONE) OF THE RECURRENCE
530:     If Abs(dblD) < dblMinPositive Then dblD = dblMinPositive
531:     dblC = 1 + (dblAA / dblC)
532:     If Abs(dblC) < dblMinPositive Then dblC = dblMinPositive
533:     dblD = 1 / dblD
534:     dblDEL = dblD * dblC
535:     dblH = dblH * dblDEL
    
537:     If Abs(dblDEL - 1) <= dblEPS Then Exit For
538:   Next lngIndex
  
540:   ReturnBetaContFraction = dblH
    


  Exit Function
ErrorHandler:
  HandleError True, "ReturnBetaContFraction " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function ReturnNaturalLogGammaEstimation(dblZ As Double) As Double
  On Error GoTo ErrorHandler
  If m_booFoundError Then Exit Function

' Jennessent.ReturnNatLogGammaEstimation
'
' FUNCTIONS ADAPTED FROM "Numerical Recipies in C:  The Art of Scientific Computing (ISBN 0-521-43108-5)
' 1988-1992 by Cambridge University Press.
' (http://lib-www.lanl.gov/numerical/bookcpdf.html - See Chapter 6, sections 1-4)
'
' A DESCRIPTION OF THE GAMMA FUNCTION (http://www.rskey.org/gamma.htm) BY
' VICTOR M. TOTH (http://www.vttoth.com/)
'
' HANDBOOK OF MATHEMATICAL FUNCTIONS, 1972, MILTON ABRAMOWITZ AND IRENE A. STEGUN
'
' ORIGINAL C++ CODE TO RETURN NATURAL LOG OF GAMMA FROM Numerical Recipies in C
'
'DP NR::gammln(const DP xx)
'{
' int j;
' DP x,y,tmp,ser;
' static const DP cof[6]={76.18009172947146,-86.50532032941677,
'   24.01409824083091,-1.231739572450155,0.1208650973866179e-2,
'   -0.5395239384953e-5};
'
' y=x=xx;
' tmp=x+5.5;
' tmp -= (x+0.5)*log(tmp);
' ser=1.000000000190015;
' for (j=0;j<6;j++) ser += cof[j]/++y;
' return -tmp+log(2.5066282746310005*ser/x);
'}

582:   SetGammaEstArray
  
  Dim dblTemp As Double
585:   dblTemp = dblZ + 5.5
586:   dblTemp = dblTemp - ((dblZ + 0.5) * (Log(dblTemp)))
  
  Dim dblPartB As Double
  Dim lngIndex As Long
  
591:   dblPartB = m_dblConstants(0)
  
593:   For lngIndex = 1 To 6
594:    dblPartB = dblPartB + (m_dblConstants(lngIndex) / (dblZ + lngIndex))
595:   Next lngIndex
596:   ReturnNaturalLogGammaEstimation = Log((m_dblGammaPartA * dblPartB) / dblZ) - dblTemp


  Exit Function
ErrorHandler:
  HandleError True, "ReturnNaturalLogGammaEstimation " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function
Public Function SetGammaEstArray() As Boolean
  On Error GoTo ErrorHandler
  If m_booFoundError Then Exit Function

  
608:   If Not m_booGammaArrayLoaded Then
609:     m_dblConstants(0) = 1.00000000019001
610:     m_dblConstants(1) = 76.1800917294715
611:     m_dblConstants(2) = -86.5053203294168
612:     m_dblConstants(3) = 24.0140982408309
613:     m_dblConstants(4) = -1.23173957245015
614:     m_dblConstants(5) = 1.20865097386618E-03
615:     m_dblConstants(6) = -5.395239384953E-06
616:     m_booGammaArrayLoaded = True
617:   End If
  

  Exit Function
ErrorHandler:
  HandleError True, "SetGammaEstArray " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function SetSimpsonsArray() As Boolean
  On Error GoTo ErrorHandler
  If m_booFoundError Then Exit Function


630:   If Not m_booArrayLoaded Then

632:     m_dblNormSimpsonArray(0, 0) = -5.5
633:     m_dblNormSimpsonArray(1, 0) = 1.898956247E-08
634:     m_dblNormSimpsonArray(0, 1) = -5.25
635:     m_dblNormSimpsonArray(1, 1) = 7.604960516E-08
636:     m_dblNormSimpsonArray(0, 2) = -5#
637:     m_dblNormSimpsonArray(1, 2) = 2.8665157188E-07
638:     m_dblNormSimpsonArray(0, 3) = -4.75
639:     m_dblNormSimpsonArray(1, 3) = 1.01708324257E-06
640:     m_dblNormSimpsonArray(0, 4) = -4.5
641:     m_dblNormSimpsonArray(1, 4) = 3.39767312473E-06
642:     m_dblNormSimpsonArray(0, 5) = -4.25
643:     m_dblNormSimpsonArray(1, 5) = 1.068852577493E-05
644:     m_dblNormSimpsonArray(0, 6) = -4#
645:     m_dblNormSimpsonArray(1, 6) = 3.167124183312E-05
646:     m_dblNormSimpsonArray(0, 7) = -3.75
647:     m_dblNormSimpsonArray(1, 7) = 8.84172852008E-05
648:     m_dblNormSimpsonArray(0, 8) = -3.5
649:     m_dblNormSimpsonArray(1, 8) = 2.3262907903553E-04
650:     m_dblNormSimpsonArray(0, 9) = -3.25
651:     m_dblNormSimpsonArray(1, 9) = 5.7702504239077E-04
652:     m_dblNormSimpsonArray(0, 10) = -3#
653:     m_dblNormSimpsonArray(1, 10) = 1.3498980316301E-03
654:     m_dblNormSimpsonArray(0, 11) = -2.75
655:     m_dblNormSimpsonArray(1, 11) = 2.97976323505456E-03
656:     m_dblNormSimpsonArray(0, 12) = -2.5
657:     m_dblNormSimpsonArray(1, 12) = 6.20966532577614E-03
658:     m_dblNormSimpsonArray(0, 13) = -2.25
659:     m_dblNormSimpsonArray(1, 13) = 1.22244726550447E-02
660:     m_dblNormSimpsonArray(0, 14) = -2#
661:     m_dblNormSimpsonArray(1, 14) = 2.27501319481792E-02
662:     m_dblNormSimpsonArray(0, 15) = -1.75
663:     m_dblNormSimpsonArray(1, 15) = 4.00591568638171E-02
664:     m_dblNormSimpsonArray(0, 16) = -1.5
665:     m_dblNormSimpsonArray(1, 16) = 6.68072012688581E-02
666:     m_dblNormSimpsonArray(0, 17) = -1.25
667:     m_dblNormSimpsonArray(1, 17) = 0.105649773666855
668:     m_dblNormSimpsonArray(0, 18) = -1#
669:     m_dblNormSimpsonArray(1, 18) = 0.158655253931457
670:     m_dblNormSimpsonArray(0, 19) = -0.75
671:     m_dblNormSimpsonArray(1, 19) = 0.226627352376868
672:     m_dblNormSimpsonArray(0, 20) = -0.5
673:     m_dblNormSimpsonArray(1, 20) = 0.308537538725987
674:     m_dblNormSimpsonArray(0, 21) = -0.25
675:     m_dblNormSimpsonArray(1, 21) = 0.401293674317076
676:     m_dblNormSimpsonArray(0, 22) = 0#
677:     m_dblNormSimpsonArray(1, 22) = 0.5
678:     m_dblNormSimpsonArray(0, 23) = 0.25
679:     m_dblNormSimpsonArray(1, 23) = 0.598706325682924
680:     m_dblNormSimpsonArray(0, 24) = 0.5
681:     m_dblNormSimpsonArray(1, 24) = 0.691462461274013
682:     m_dblNormSimpsonArray(0, 25) = 0.75
683:     m_dblNormSimpsonArray(1, 25) = 0.773372647623132
684:     m_dblNormSimpsonArray(0, 26) = 1#
685:     m_dblNormSimpsonArray(1, 26) = 0.841344746068543
686:     m_dblNormSimpsonArray(0, 27) = 1.25
687:     m_dblNormSimpsonArray(1, 27) = 0.894350226333145
688:     m_dblNormSimpsonArray(0, 28) = 1.5
689:     m_dblNormSimpsonArray(1, 28) = 0.933192798731142
690:     m_dblNormSimpsonArray(0, 29) = 1.75
691:     m_dblNormSimpsonArray(1, 29) = 0.959940843136183
692:     m_dblNormSimpsonArray(0, 30) = 2#
693:     m_dblNormSimpsonArray(1, 30) = 0.977249868051821
694:     m_dblNormSimpsonArray(0, 31) = 2.25
695:     m_dblNormSimpsonArray(1, 31) = 0.987775527344955
696:     m_dblNormSimpsonArray(0, 32) = 2.5
697:     m_dblNormSimpsonArray(1, 32) = 0.993790334674224
698:     m_dblNormSimpsonArray(0, 33) = 2.75
699:     m_dblNormSimpsonArray(1, 33) = 0.997020236764945
700:     m_dblNormSimpsonArray(0, 34) = 3#
701:     m_dblNormSimpsonArray(1, 34) = 0.99865010196837
702:     m_dblNormSimpsonArray(0, 35) = 3.25
703:     m_dblNormSimpsonArray(1, 35) = 0.999422974957609
704:     m_dblNormSimpsonArray(0, 36) = 3.5
705:     m_dblNormSimpsonArray(1, 36) = 0.999767370920964
706:     m_dblNormSimpsonArray(0, 37) = 3.75
707:     m_dblNormSimpsonArray(1, 37) = 0.999911582714799
708:     m_dblNormSimpsonArray(0, 38) = 4#
709:     m_dblNormSimpsonArray(1, 38) = 0.999968328758167
710:     m_dblNormSimpsonArray(0, 39) = 4.25
711:     m_dblNormSimpsonArray(1, 39) = 0.999989311474225
712:     m_dblNormSimpsonArray(0, 40) = 4.5
713:     m_dblNormSimpsonArray(1, 40) = 0.999996602326875
714:     m_dblNormSimpsonArray(0, 41) = 4.75
715:     m_dblNormSimpsonArray(1, 41) = 0.999998982916757
716:     m_dblNormSimpsonArray(0, 42) = 5#
717:     m_dblNormSimpsonArray(1, 42) = 0.999999713348428
718:     m_dblNormSimpsonArray(0, 43) = 5.25
719:     m_dblNormSimpsonArray(1, 43) = 0.999999923950395
720:     m_dblNormSimpsonArray(0, 44) = 5.5
721:     m_dblNormSimpsonArray(1, 44) = 0.999999981010438
    
723:     m_booArrayLoaded = True
724:   End If
725:   SetSimpsonsArray = True


  Exit Function
ErrorHandler:
  HandleError True, "SetSimpsonsArray " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function PDF_Normal_Jen(theValue As Double, theMean As Double, theStanDev As Double) As Double
  On Error GoTo ErrorHandler
  If m_booFoundError Then Exit Function


' GETS Y-VALUES FROM NORMAL CURVE
739:   PDF_Normal_Jen = (1 / (theStanDev * (Sqr(2 * (m_dblPi))))) * (m_dblEuler ^ (-(((theValue - theMean) / theStanDev) ^ 2) / 2))


  Exit Function
ErrorHandler:
  HandleError True, "PDF_Normal_Jen " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function IDF_Normal_Jen(theProbability As Double, theMean As Double, theStanDev As Double) As Double
  On Error GoTo ErrorHandler
  If m_booFoundError Then Exit Function


'' Regression_jen.prob_Stat_IDF_Normal
'
'' TESTS SERIES OF X-VALUES, ITERATIVELY HOMING IN ON THE CORRECT ONE
''
'' Returns the critical value from the Normal distribution, for which the cumulative probability
'' is theProb, based on either a 1-tailed case or a 2-tailed case. For example, the Critical X-value for alpha = 0.05
'' on a Normal distribution with Mean 85 and Standard Deviation = 12.456, using a 1-tailed test, is:
'
'' FOR DEBUGGING
''theMean = 5
''theSD = 12.456
''theProb = 0.05
''Use2Tail = False                                     ' X-Value = -15.4882967773075

Dim theMaxIteration As Integer
767: theMaxIteration = 10000
Dim theEPS As Double
769: theEPS = 10 ^ (-12)

Dim theX As Double
Dim theIncrement As Double
773: theX = 0
774: theIncrement = 500

Dim ReachedMin As Boolean
Dim ReachedMax As Boolean

Dim theTestProb As Double
Dim theDifference As Double
Dim theProportion As Double

Dim aNumber As Integer
784: For aNumber = 1 To theMaxIteration
    
786:   theTestProb = CDF_Normal_Simpsons_Jen(theX, theMean, theStanDev)
787:   theDifference = Abs(theTestProb - theProbability)
  
789:   If (theDifference < theEPS) Then
790:     Exit For
791:   Else
792:     If theTestProb = 0 Then
793:       theProportion = 2
794:     Else
795:       theProportion = theProbability / theTestProb
796:     End If
797:     If (theProportion > 1) Then
798:       ReachedMin = True
799:       If ReachedMax Then
800:         theX = theX + theIncrement
801:         theIncrement = theIncrement * 0.501
802:       Else
803:         theX = theX + theIncrement
804:       End If
805:     Else
806:       ReachedMax = True
807:       If ReachedMin Then
808:         theX = theX - theIncrement
809:         theIncrement = theIncrement * 0.501
810:       Else
811:         theX = theX - theIncrement
812:       End If
813:     End If
814:   End If
815: Next aNumber

817: IDF_Normal_Jen = theX


  Exit Function
ErrorHandler:
  HandleError True, "IDF_Normal_Jen " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function CDF_Normal_Simpsons_Jen(theTestValue As Double, theMean As Double, theStanDev As Double) As Double
  On Error GoTo ErrorHandler
  If m_booFoundError Then Exit Function


'' Regression_jen.prob_Stat_CDF_Normal_Simpsons
'' SET RANGE OF X VALUES TO BE FROM -20 STANDARD DEVIATIONS TO CURRENT X, WITH 20-100 ITERATIONS
'' APPEARS TO BE ACCURATE TO AT LEAST 12 DECIMAL PLACES
''
'' USES SIMPSON'S APPROXIMATION, AS DESCRIBED IN:
'' Stewart, James. (1998). Calculus, Concepts and Contexts (Brooks/Cole Publishing Company), p. 421-424
'
''theMean = 85
''theSD = 12.456
''theTestValue = 4.334                      ' 0.000 000 000 04706939 = splus

Dim anIndex As Integer
842: anIndex = 0

Dim theZ As Double
845: theZ = (theTestValue - theMean) / theStanDev

Dim theMinX As Double
848: theMinX = -100

Dim theStartValue As Double
851: theStartValue = 0

Dim theIntervalCount As Integer
Dim theIntervalOne As Integer

856: If theZ <= -5.5 Then
857:   theMinX = -20
858:   theIntervalCount = 300
859:   theIntervalOne = 301
860: Else

862:   SetSimpsonsArray
  Dim theValue As Double
864:   theValue = -5.5
  
866:   Do While (theValue <= theZ) And (anIndex < 45)
867:     theValue = m_dblNormSimpsonArray(0, anIndex)
868:     If theZ > theValue Then
869:       theMinX = theValue
870:       theStartValue = m_dblNormSimpsonArray(1, anIndex)
871:     Else
872:       Exit Do
873:     End If
874:     anIndex = anIndex + 1
875:   Loop
876:   theIntervalCount = 100
877:   theIntervalOne = 101
878: End If

Dim theDeltaX As Double
881: theDeltaX = (theZ - theMinX) / theIntervalCount

Dim theCumulativeValue As Double
Dim theTestX As Double
885: theCumulativeValue = 0
886: theTestX = theMinX

Dim theY As Double
889: For anIndex = 1 To theIntervalOne
890:   theY = ZdistYatX(theTestX)
  
892:   If anIndex = 1 Or anIndex = theIntervalOne Then                ' FIRST OR LAST ELEMENT; NO COEFFICIENT
893:     theCumulativeValue = theCumulativeValue + theY
894:   ElseIf ((anIndex Mod 2) = 0) Then
895:     theCumulativeValue = theCumulativeValue + (4 * theY)         ' EVEN NUMBERED ELEMENTS; COEFFICIENT = 4
896:   Else
897:     theCumulativeValue = theCumulativeValue + (2 * theY)         ' EVEN NUMBERED ELEMENTS; COEFFICIENT = 2
898:   End If
  
900:   theTestX = theTestX + theDeltaX
901: Next anIndex

'' THE FOLLOWING REFLECTS AREA UNDER CURVE FOR X <= TESTVALUE
Dim thePValue As Double
905: thePValue = ((theCumulativeValue * theDeltaX) / 3) + theStartValue

' SIMPSONS APPROXIMATION MIGHT BE <0 IN CERTAIN CASES
908: If thePValue < 0 Then thePValue = 0
909: If thePValue > 1 Then thePValue = 1

911: CDF_Normal_Simpsons_Jen = thePValue


  Exit Function
ErrorHandler:
  HandleError True, "CDF_Normal_Simpsons_Jen " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function ZdistYatX(theValue As Double) As Double
  On Error GoTo ErrorHandler
  If m_booFoundError Then Exit Function


' Regression_jen.prob_Stat_ZdistYatX
' GETS Y-VALUES FROM NORMAL CURVE

927:   ZdistYatX = (1 / (Sqr(2# * (m_dblPi)))) * (m_dblEuler ^ (-(theValue ^ 2) / 2))


  Exit Function
ErrorHandler:
  HandleError True, "ZdistYatX " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function CDF_Binomial(ByVal dblNumberSuccesses As Double, dblNumberTrials As Double, dblProbabilityOfSuccess As Double) As Double
  On Error GoTo ErrorHandler
  If m_booFoundError Then Exit Function

' Jennessent.CDF_Binomial

' FUNCTIONS ADAPTED FROM "Numerical Recipies in C:  The Art of Scientific Computing (ISBN 0-521-43108-5)
' 1988-1992 by Cambridge University Press.
' (http://lib-www.lanl.gov/numerical/bookcpdf.html - See Chapter 6, sections 1-4)
'
' HANDBOOK OF MATHEMATICAL FORMULAS AND INTEGRALS, 2ND. ED. ALAN JEFFREY
'
' HANDBOOK OF MATHEMATICAL FUNCTIONS, 1972, MILTON ABRAMOWITZ AND IRENE A. STEGUN

' Returns the cumulative probability that the number of successes in "dblNumber" trials,
' with probability "dblProbability" of success in each, will be less than "dblNumberSuccesses".

' FOR DEBUGGING
'aQuantity = 13
'theNumber = 20
'theProb = 0.44532                                    ' 0.946757433702356
  
957:   If dblNumberSuccesses = dblNumberTrials Then
958:     CDF_Binomial = 1
959:   Else
960:     dblNumberSuccesses = dblNumberSuccesses + 1
961:     CDF_Binomial = 1 - (Jen_ReturnIncompleteBeta(dblNumberSuccesses, dblNumberTrials - dblNumberSuccesses + 1, dblProbabilityOfSuccess))
962:   End If


  Exit Function
ErrorHandler:
  HandleError True, "CDF_Binomial " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function PDF_Binomial(dblQuantity As Double, dblNumber As Double, dblProb As Double) As Double
  On Error GoTo ErrorHandler
  If m_booFoundError Then Exit Function

  ' Jennessent.PDF_Binomial
  '
  '  McLaughlin, Michael P. (2001).  Regress+, Appendix A.  A Compendium of Common Probability Distributions
  '      (version 2.3).  Available on-line at: http://www.causaScientia.org/math_stat/Dists/Compendium.pdf
  '
  
  ' FOR DEBUGGING
  'aQuantity = 13
  'theNumber = 20
  'theProb = 0.44532
  
  Dim dblBinCoef As Double
  ' MAKE SURE POSITIVE!
987:   dblBinCoef = ReturnBinomialCoefficient(dblQuantity, dblNumber)
  
989:   If dblBinCoef < 0 Then
990:     MsgBox "Invalid Binomial Coefficient Values" & vbCrLf & vbCrLf & _
        "# Successes = " & CStr(dblQuantity) & vbCrLf & _
        "# Trials = " & CStr(dblNumber) & vbCrLf & vbCrLf & _
        "[#Trials] should be >= [#Successes], and both should be >= 0..."
994:     PDF_Binomial = -9999
995:   Else
996:     PDF_Binomial = dblBinCoef * (dblProb ^ dblQuantity) * ((1 - dblProb) ^ (dblNumber - dblQuantity))
997:   End If
  

  Exit Function
ErrorHandler:
  HandleError True, "PDF_Binomial " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function ReturnBinomialCoefficient(dblK As Double, dblN As Double) As Double
  On Error GoTo ErrorHandler
  If m_booFoundError Then Exit Function

  ' Jennessent.ReturnBinomialCoefficient
  '
  '             n!
  '        -----------   ;   0 <= k <= n
  '        k! (n - k)!
  '
  
1016:   If ((dblK > dblN) Or (dblN < 0) Or (dblK < 0)) Then
1017:     ReturnBinomialCoefficient = -9999
1018:   Else
    Dim dblN1FactN As Double
    Dim dblN1FactK As Double
    Dim dblN1FactNminK As Double
    
1023:     dblN1FactN = ReturnNatLogFactorial(dblN)
1024:     dblN1FactK = ReturnNatLogFactorial(dblK)
1025:     dblN1FactNminK = ReturnNatLogFactorial(dblN - dblK)
    
1027:     ReturnBinomialCoefficient = Int((m_dblEuler ^ (dblN1FactN - dblN1FactK - dblN1FactNminK)) + 0.5)
    
1029:   End If


  Exit Function
ErrorHandler:
  HandleError True, "ReturnBinomialCoefficient " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function ReturnNatLogFactorial(dblStart As Double) As Double
  On Error GoTo ErrorHandler
  If m_booFoundError Then Exit Function

  ' Jennessent.ReturnNatLogFactorial
  
1043:   If (dblStart < 0) Then
1044:     ReturnNatLogFactorial = -9999
1045:   Else
1046:     ReturnNatLogFactorial = ReturnNaturalLogGammaEstimation(dblStart + 1)
1047:   End If


  Exit Function
ErrorHandler:
  HandleError True, "ReturnNatLogFactorial " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function


Public Function IDF_Binomial(dblUserProb As Double, lngNumTrials As Long, dblProbSuccess As Double) As Long
  On Error GoTo ErrorHandler
  If m_booFoundError Then Exit Function


  ' Jennessent.IDF_Binomial
  
  ' Returns the Maximum Value X at which P(X-1), given N trials and P probability of success,
  ' is Less than or equal to UserProb.
  
  ' This script takes an iterative process, repeatedly using CDF_Binomial to test values
  ' of X, until it finds one at which theCDF(X-1) <= theProb.
  
  'UserProb = 0.85
  'NumTrials = 2633523
  'ProbSuccess = 0.75
  
  Dim lngIncrement As Long
1074:   lngIncrement = lngNumTrials
  
  Dim lngIteration As Long
1077:   lngIteration = 0
'  Dim strReport As String
'  strReport = ""
  Dim lngX As Long
1081:   lngX = lngNumTrials
  Dim dblProb As Double
  Dim dblProb2 As Double
  Dim dblNumTrials As Double
1085:   dblNumTrials = CDbl(lngNumTrials)
  
1087:   Do While (lngIteration < 400)
1088:     lngIteration = lngIteration + 1
1089:     lngIncrement = Round(CDbl(lngIncrement) * 0.501)
    
1091:     dblProb = CDF_Binomial(CDbl(lngX), dblNumTrials, dblProbSuccess)
    
'    dblProb2 = CDF_Binomial(CDbl(lngX - 1), CDbl(lngNumTrials), dblProbSuccess)
'    strReport = strReport + "(X1): " & CStr(Round(lngX, 2)) & ", Prob: = " & _
'        CStr(Round(dblProb, 16)) & ";        (X2): " & CStr(Round(lngX - 1)) & ", Prob: = " & _
'        CStr(Round(dblProb2, 16)) & vbCrLf

1098:     If dblProb > dblUserProb Then
1099:       dblProb2 = CDF_Binomial(CDbl(lngX - 1), CDbl(lngNumTrials), dblProbSuccess)
1100:       If (dblProb2 <= dblUserProb) Then
1101:         IDF_Binomial = lngX
1102:         Exit Do
1103:       Else
1104:         lngX = Fix(lngX - lngIncrement)
1105:       End If
1106:     Else
1107:       lngX = Fix(lngX + lngIncrement)
1108:     End If
1109:   Loop
  
'  Debug.Print strReport
'
'  av.ClearWorkingStatus
'  'msgBox.Report(theReport, "")
'
'  theDifference = theProb - UserProb
'
'  'msgBox.Info(theResponse.SetFormatPrecision(14).AsString+", "+theIteration.AsString+" iterations; Difference of "+
'  '    theDifference.SetFormatPrecision(16).AsString, "")
'
'  return theResponse



  Exit Function
ErrorHandler:
  HandleError True, "IDF_Binomial " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function


Public Function CalcProbSuccess_Binomial(dblCumulativeProb As Double, lngNumSuccess As Long, lngNumTrials As Long) As Double
  On Error GoTo ErrorHandler
  If m_booFoundError Then Exit Function

  
  ' Returns the P probability of success of a trial, given N total trials, N successful trials and P cumulative
  ' probability of success.
  
  ' This script takes an iterative process, repeatedly using CDF_Binomial to test values
  ' of P, until it finds one at which theCDF(X-1) is sufficiently close to the specified cumulative probability.
  
  'UserProb = 0.85
  'NumTrials = 2633523
  'ProbSuccess = 0.75
  
  Dim lngIteration As Long
1147:   lngIteration = 0
'  Dim strReport As String
'  strReport = ""
  
  Dim dblProb As Double
  Dim dblProb2 As Double
  Dim dblNumTrials As Double
  Dim dblNumSuccess As Double
1155:   dblNumSuccess = CDbl(lngNumSuccess)
1156:   dblNumTrials = CDbl(lngNumTrials)
  
  Dim dblTestCumulativeProb As Double
  
  Dim dblProbSuccess As Double
1161:   dblProbSuccess = 1
  
  Dim dblThreshold As Double
1164:   dblThreshold = 0.000000001
  
  Dim dblIncrement As Double
1167:   dblIncrement = 1
  
  Dim dblDifference As Double
1170:   dblDifference = 1
  
1172:   Do Until (lngIteration > 400) Or (dblDifference <= dblThreshold)
1173:     lngIteration = lngIteration + 1
1174:     dblIncrement = dblIncrement * 0.501
    
1176:     dblTestCumulativeProb = CDF_Binomial(dblNumSuccess, dblNumTrials, dblProbSuccess)
    
'    dblProb2 = CDF_Binomial(CDbl(lngX - 1), CDbl(lngNumTrials), dblProbSuccess)
'    strReport = strReport + "(X1): " & CStr(Round(lngX, 2)) & ", Prob: = " & _
'        CStr(Round(dblProb, 16)) & ";        (X2): " & CStr(Round(lngX - 1)) & ", Prob: = " & _
'        CStr(Round(dblProb2, 16)) & vbCrLf
    
1183:     dblDifference = Abs(dblTestCumulativeProb - dblCumulativeProb)
'    Debug.Print CStr(lngIteration) & "] Testing " & CStr(Format(dblProbSuccess, "0.0000000000")) & "  ...  " & _
                "dblDifference " & CStr(Format(dblDifference, "0.0000000000")) & "  ...  " & _
                "dblIncrement " & CStr(Format(dblIncrement, "0.0000000000"))
                
    
1189:     If dblDifference > dblThreshold Then
1190:       If dblTestCumulativeProb > dblCumulativeProb Then
        ' TRY LOWER dblProbSuccess VALUE
1192:         dblProbSuccess = dblProbSuccess + dblIncrement
1193:       Else
        ' TRY HIGHER dblProbSuccess VALUE
1195:         dblProbSuccess = dblProbSuccess - dblIncrement
1196:       End If
1197:     Else
1198:       CalcProbSuccess_Binomial = dblProbSuccess
1199:     End If
1200:   Loop
  
'  Debug.Print strReport
'
'  av.ClearWorkingStatus
'  'msgBox.Report(theReport, "")
'
'  theDifference = theProb - UserProb
'
'  'msgBox.Info(theResponse.SetFormatPrecision(14).AsString+", "+theIteration.AsString+" iterations; Difference of "+
'  '    theDifference.SetFormatPrecision(16).AsString, "")
'
'  return theResponse


  


  Exit Function
ErrorHandler:
  HandleError True, "CalcProbSuccess_Binomial " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

'Private Sub HandleError(booError As Boolean, strLocation As String, lngErrNum As Long, strErrSrc As String, strErrDesc As String, lngNum As Long)
'883:   MsgBox "Error:" & vbCrLf & "-----------------------------------------" & vbCrLf & strLocation & vbCrLf & vbCrLf & _
'      "  --> Error Number = " & CStr(lngErrNum) & vbCrLf & _
'      "  --> Error Source = " & strErrSrc & vbCrLf & _
'      "  --> Error Description = " & strErrDesc, , "Problem in Binomial Calculator:"
'887:   m_booFoundError = True
'End Sub


