Attribute VB_Name = "TopoCor_Functions"
Option Explicit
Const c_sModuleFileName As String = "D:\arcGIS_stuff\consultation\brost_climate_change\code\TopoCor_Functions.bas"

Public Function ReturnRasterTable(pRasterBand As IRasterBand) As ITable
  On Error GoTo ErrorHandler
  
7:   Set ReturnRasterTable = pRasterBand.AttributeTable
  
  Exit Function
ErrorHandler:
11:   Set ReturnRasterTable = Nothing
End Function

Public Function CreateDensityRaster(pDocParams As esriSystem.IVariantArray, _
    pParams As esriSystem.IVariantArray) As String
  On Error GoTo ErrorHandler

    
  Dim pApp As IApplication
  Dim pMxDoc As IMxDocument
  Dim pThisExt As TopoCorridor.clsExtension
  
23:   Set pApp = pDocParams.Element(0)
24:   Set pMxDoc = pDocParams.Element(1)
25:   Set pThisExt = pDocParams.Element(2)
  
  Dim lngIndex As Long
  Dim lngIndex2 As Long
  Dim lngIndex3 As Long

 
  Dim datBegan As Date
33:   datBegan = Now

  Dim strReport As String
36:   strReport = "Function failed..."
  
38:   CreateDensityRaster = strReport
  
  Dim pInputBand As IRasterBand
  Dim pRastLayer As IRasterLayer
  Dim pGeoDataset As IGeoDataset
  Dim pInputDataset As IRasterDataset
  Dim pInputRaster As IRaster2
  Dim pEnv As IEnvelope
  Dim strSaveFormat As String
  Dim lngNbrHoodRadius As Long
  Dim strNewRasterName As String
  Dim booIsFGB As Boolean
  Dim pRastWS As IRasterWorkspace2
  Dim pRastWsEx As IRasterWorkspaceEx
  Dim strSaveFormatString As String
  Dim pWS As IWorkspace
  Dim strExtension As String
  Dim strInputName As String
  Dim booExcludeIfAnyNull As Boolean
57:   booExcludeIfAnyNull = False
  
  Dim strFieldName As String
  Dim strSelAttribute As String
  Dim pSearchValues As esriSystem.IDoubleArray
  
  ' RETURN ARRAY IS IVariantArray, CONTAINING:
  ' 0) IRasterBand: SELECTED RASTER BAND
  ' 1) STRING: Name of original raster band
  ' 2) STRING: Name of selected attribute field
  ' 3) STRING: Selected Attribute Value
  ' 4) IDoubleArray: Array of cell values that correspond with this selected attribute value
  ' 5) STRING: Save Format
  ' 6) STRING: TEXT VERSION OF SAVE FORMAT
  ' 7) STRING: New Raster Name
  ' 8) BOOLEAN: Whether new workspace is File Geodatabase
  ' 9) IWORKSPACE: Either an IRasterWorkspace2 or an IRasterWorkspaceEx
  '10) STRING: Extension for output
  '11) LONG: Neighborhood Radius, in Cells
  '12) BOOLEAN: Whether to set to NoData if any NoData cells present
  
'  MsgBox "pParams.Count = " & CStr(pParams.Count)
'  MsgBox "VarType(pParams.Element(0)) = " & CStr(VarType(pParams.Element(0)))
'  MsgBox "TypeOf pParams.Element(0) Is ILayer = " & CStr(TypeOf pParams.Element(0) Is ILayer)
'  MsgBox "TypeOf pParams.Element(0) Is IRasterLayer = " & CStr(TypeOf pParams.Element(0) Is IRasterLayer)
  
83:   Set pInputBand = pParams.Element(0)
84:   Set pGeoDataset = pInputBand
85:   Set pEnv = pGeoDataset.Extent
86:   strInputName = pParams.Element(1)
87:   strFieldName = pParams.Element(2)
88:   strSelAttribute = pParams.Element(3)
89:   Set pSearchValues = pParams.Element(4)
90:   strSaveFormat = pParams.Element(5)
91:   strSaveFormatString = pParams.Element(6)
92:   strNewRasterName = pParams.Element(7)
93:   booIsFGB = pParams.Element(8)
94:   Set pWS = pParams.Element(9)
95:   If booIsFGB Then
96:     Set pRastWsEx = pWS
97:   Else
98:     Set pRastWS = pWS
99:   End If
100:   strExtension = pParams.Element(10)
101:   lngNbrHoodRadius = pParams.Element(11)
102:   booExcludeIfAnyNull = pParams.Element(12)
    
  Dim dblSearchVals() As Double
  ReDim dblSearchVals(pSearchValues.Count - 1)
106:   For lngIndex = 0 To pSearchValues.Count - 1
107:     dblSearchVals(lngIndex) = pSearchValues.Element(lngIndex)
108:   Next lngIndex
  
  ' GET VALUE TO SERVE AS WITHIN-RASTER BOUNDARY NON-VALUE
  Dim dblNonValue As Double
  Dim booValExists As Boolean
113:   booValExists = True
  
115:   dblNonValue = 0
116:   Do Until booValExists = False
117:     booValExists = False
118:     For lngIndex = 0 To UBound(dblSearchVals)
119:       If dblSearchVals(lngIndex) = dblNonValue Then
120:         booValExists = True
121:         dblNonValue = dblNonValue + 1
122:       End If
123:     Next lngIndex
124:   Loop
  
  Dim pRastDataset As IRasterDataset3
  
  Dim pSaveAs As ISaveAs2
  Dim pRasterProp As IRasterProps
  Dim pRasLy As IRasterLayer
'  Dim pRaster As IRaster2
  Dim pRastStDef As IRasterStorageDef2
  Dim pRastProps As IRasterProps
  
  '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  '/////////// |                  | \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
  '----------  |   CALCULATIONS   |  ---------------------------------------------------------------------------
  '\\\\\\\\\\\ |                  | ///////////////////////////////////////////////////////////////////////////
  '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

  Dim pPro As IStepProgressor
  Dim psbar As IStatusBar
  
  Dim pTempBandColl As IRasterBandCollection
145:   Set pTempBandColl = New Raster
146:   pTempBandColl.AppendBand pInputBand
147:   Set pInputRaster = pTempBandColl
148:   Set pRastProps = pInputRaster
'  pRastProps.SpatialReference = pGeoDataset.SpatialReference
  
151:   Set psbar = pApp.StatusBar
152:   Set pPro = psbar.ProgressBar
  
  Dim lngHeight As Long
  Dim lngWidth As Long
'  Dim dblCellSize As Double
  Dim dblNoData As Double
  Dim varNoData As Variant
  
'  dblCellSize = (pRastProps.MeanCellSize.X + pRastProps.MeanCellSize.Y) / 2
161:   lngWidth = pRastProps.Width
162:   lngHeight = pRastProps.Height
163:   varNoData = pRastProps.NoDataValue
 ' dblNoData = CDbl(varNoData)
  
'  If lngWidth < 3 Or lngHeight < 3 Then
'    MsgBox "Invalid Raster:  Size must be greater than 3 x 3 cells..." & vbCrLf & "Exiting Function..."
'    CalcSurfaceArea = "Invalid Raster:  Size must be greater than 3 x 3 cells..." & vbCrLf & "Function cancelled..."
'    Goto cleanup
'  End If
  
  ' PROGRESS STUFF
173:   pPro.position = 0
174:   psbar.ShowProgressBar "Calculating Density of '" & strSelAttribute & "' in Cell Neighborhoods...", 1, lngHeight, 1, True
175:   pPro.Message = "Calculating Density of '" & strSelAttribute & "' in Cell Neighborhoods..."

  Dim pPnt As IPnt
178:   Set pPnt = New Pnt
179:   pPnt.SetCoords lngWidth, 1

  Dim pPixBlock As IPixelBlock3

  Dim pTopLeft As IPnt

  Dim varNoDataArray As Variant
  Dim booAllIsData() As Boolean
  ReDim booAllIsData(lngWidth - 1)
188:   For lngIndex = 0 To UBound(booAllIsData)
189:     booAllIsData(lngIndex) = True
190:   Next lngIndex
  Dim booHasData() As Boolean
  Dim varData As Variant
  Dim varEmptyData() As Variant
  ReDim varEmptyData(lngWidth - 1)

'
'  ' MAKE MASK ARRAY
'  Dim booMaskArray() As Boolean
'  ReDim booMaskArray((lngNbrHoodRadius * 2), (lngNbrHoodRadius * 2))
'  For lngIndex = 0 To (lngNbrHoodRadius * 2)
'    For lngIndex2 = 0 To (lngNbrHoodRadius * 2)
'      booMaskArray(lngIndex, lngIndex2) = _
'          Sqr(((lngNbrHoodRadius - lngIndex) ^ 2) + ((lngNbrHoodRadius - lngIndex2) ^ 2)) <= lngNbrHoodRadius
'    Next lngIndex2
'  Next lngIndex

  ' MAKE MASK ARRAY
  Dim booMaskArray() As Boolean
  Dim booCheck As Boolean
  Dim lngTotalCount As Long
  ReDim booMaskArray((lngNbrHoodRadius * 2), (lngNbrHoodRadius * 2))
212:   For lngIndex = 0 To (lngNbrHoodRadius * 2)
213:     For lngIndex2 = 0 To (lngNbrHoodRadius * 2)
214:        booCheck = Sqr(((lngNbrHoodRadius - lngIndex) ^ 2) + ((lngNbrHoodRadius - lngIndex2) ^ 2)) <= lngNbrHoodRadius
215:        booMaskArray(lngIndex, lngIndex2) = booCheck
216:        If booCheck Then lngTotalCount = lngTotalCount + 1
217:     Next lngIndex2
218:   Next lngIndex
  
  ' FOR DEBUGGING
'  Dim strDebugReport As String
'  strDebugReport = ""
'  For lngIndex = 0 To (lngNbrHoodRadius * 2)
'    For lngIndex2 = 0 To (lngNbrHoodRadius * 2)
'      strDebugReport = strDebugReport & Left(UCase(CStr(booMaskArray(lngIndex, lngIndex2))), 1) & "  "
'    Next lngIndex2
'    strDebugReport = strDebugReport & vbCrLf
'  Next lngIndex

  Dim varCalcDataArray() As Variant
  ReDim varCalcDataArray((lngNbrHoodRadius * 2), (lngNbrHoodRadius * 2))
  Dim booCalcHasDataArray() As Boolean
  ReDim booCalcHasDataArray((lngNbrHoodRadius * 2), (lngNbrHoodRadius * 2))
  Dim lngDataIndexX As Long
  Dim lngDataIndexY As Long
  
  Dim dblDensity As Double
  Dim booDensityIsNull As Boolean
  
  
  

    ' OPTION 5, BACK TO RASTER CURSOR, 3 MINUTES 45 SECONDS FOR TEST
    
  ' CREATE RASTERS TO WRITE TO -----------------------------------------------------------------------------------
  ' Create the dataset
  Dim pOutDS As IRasterDataset2
  Dim pOutRasterEdit As IRasterEdit

  Dim pRasterStorDef As IRasterStorageDef2
  Dim pRasterDef As IRasterDef
  Dim pGeomDef As IGeometryDef
  
  Dim pOriginPoint As IPoint
255:   Set pOriginPoint = New Point
256:   pOriginPoint.PutCoords pRastProps.Extent.XMin, pRastProps.Extent.YMin
  
  Dim pOutPnt As IPnt
259:   Set pOutPnt = New Pnt
  Dim lngFocalRow As Long
  
  Dim pSpRef As ISpatialReference
263:   Set pSpRef = pRastProps.SpatialReference
      
  ' IRasterStorageDef
266:   Set pRasterStorDef = New RasterStorageDef
267:   Set pRasterStorDef.CellSize = pRastProps.MeanCellSize
268:   pRasterStorDef.CompressionType = esriRasterSdeCompressionTypeRunLength
269:   pRasterStorDef.PyramidLevel = 2
270:   pRasterStorDef.PyramidResampleType = RSP_BilinearInterpolation
271:   pRasterStorDef.TileHeight = 128
272:   pRasterStorDef.TileWidth = 128

  ' IRasterDef
275:   Set pRasterDef = New RasterDef
276:   Set pRasterDef.SpatialReference = pSpRef
277:   pRasterDef.Description = "rasterdataset"

  ' IGeometryDef
280:   Set pGeomDef = Nothing
  
  Dim pOutProps As IRasterProps
  Dim pOutBandColl As IRasterBandCollection
  Dim pTempOutBandColl As IRasterBandCollection
  Dim pOutBand As IRasterBand
  Dim pRastDatasetEdit As IRasterDatasetEdit2
  Dim pTempOutRaster As IRaster
  
289:   Set pRasterStorDef.CellSize = pRastProps.MeanCellSize
290:   If booIsFGB Then
291:     Set pOutDS = pRastWsEx.CreateRasterDataset(strNewRasterName, 1, PT_FLOAT, pRasterStorDef, _
        "DEFAULTS", pRasterDef, pGeomDef)
293:     Set pTempOutBandColl = pOutDS
294:     Set pTempOutRaster = New Raster
295:     Set pOutBandColl = pTempOutRaster
296:     pOutBandColl.AppendBands pTempOutBandColl
297:     pTempOutRaster.ResampleMethod = RSP_BilinearInterpolation
    
299:     Set pOutProps = pTempOutRaster
300:     pOutProps.Extent = pRastProps.Extent
301:     pOutProps.Height = pRastProps.Height
302:     pOutProps.Width = pRastProps.Width
303:     pOutProps.SpatialReference = pSpRef
304:     pOutProps.PixelType = PT_FLOAT
305:   Else
306:     Set pOutDS = pRastWS.CreateRasterDataset(strNewRasterName & strExtension, strSaveFormat, pOriginPoint, lngWidth, lngHeight, _
        pRastProps.MeanCellSize.X, pRastProps.MeanCellSize.Y, 1, PT_FLOAT, pSpRef, True)
308:   End If
  
  Dim pOutputPixBlock As IPixelBlock3
  
  ' OUTPUT VARIABLES
  Dim pOutputRaster As IRaster2
  Dim pOutputRaster2 As IRaster
  Dim pPixelData As Variant
  Dim pRawPixel As IRawPixels
  Dim pOutPixelBlock As IPixelBlock3
  Dim pBands As IRasterBandCollection
  Dim pOutputRastProps As IRasterProps
  Dim pCache As Variant

  ' QI for IRawPixels and IRasterProps
323:   Set pOutputRaster = pOutDS.CreateFullRaster
324:   Set pOutputRaster2 = pOutputRaster
325:   Set pOutRasterEdit = pOutputRaster
326:   Set pBands = pOutDS
327:   Set pRawPixel = pBands.Item(0)
328:   Set pOutputRastProps = pRawPixel
329:   If Not booIsFGB Then
330:     pOutputRastProps.NoDataValue = CInt(-9999)
331:   End If
'  Set pOutPixelBlock = pRawPixel.CreatePixelBlock(pPnt)
333:   Set pOutputPixBlock = pOutputRaster2.CreatePixelBlock(pPnt)
334:   pOutputPixBlock.PixelType(0) = PT_FLOAT
  Dim varOutData As Variant

  
  
  
  
  
  
  
  ' ----------------------------
  Dim varNbrHeightArray() As Variant
  ReDim varNbrHeightArray(lngWidth - 1, (lngNbrHoodRadius * 2))
  Dim booNbrHeightHasDataArray() As Boolean
  ReDim booNbrHeightHasDataArray(lngWidth - 1, (lngNbrHoodRadius * 2))

  Dim lngPixBlockWidth As Long
  Dim lngPixBlockHeight As Long
  Dim lngLastColumn As Long
353:   lngPixBlockWidth = lngWidth - 1 - lngNbrHoodRadius
354:   lngPixBlockHeight = (lngNbrHoodRadius * 2)
355:   lngLastColumn = (lngNbrHoodRadius * 2)

  ' ADD FIRST LINE OF DATA
  Dim pRastCursor As IRasterCursor
359:   Set pRastCursor = pInputRaster.CreateCursorEx(pPnt)

361:   Set pPixBlock = pRastCursor.PixelBlock
362:   pPixBlock.PixelType(0) = PT_FLOAT
363:   pRastCursor.Reset
364:   Set pPixBlock = pRastCursor.PixelBlock
365:   varData = pPixBlock.PixelData(0)
'  booHasData = ConvertNoDataMaskToSomethingUseful(pPixBlock.NoDataMask(0))
367:   If booExcludeIfAnyNull Then
368:     booHasData = ConvertNoDataMaskToSomethingUseful(pPixBlock.NoDataMask(0))
369:   Else
370:     booHasData = booAllIsData
371:   End If
'
'  ' BELOW IS WORKAROUND FOR PROBLEM IN WHICH PIXEL BLOCK APPEARS TO NOT BE ABLE TO CORRECTLY READ FIRST ROW.
'  ' I THINK THIS HAS SOMETHING TO DO WITH SETTING THE PIXEL TYPE TO PT_FLOAT.  IT READS IT CORRECTLY AFTER
'  ' THAT POINT, BUT I CANNOT SET IT BEFORE READING THE FIRST ROW FROM RASTER CURSOR, EVEN AFTER USING 'RESET'.
'  ' CODE BELOW SIMPLY EXTRACTS varData1 and booHasData1 FROM A DIFFERENT PIXEL BLOCK THAT IS READ CORRECTLY.
  Dim pTempPixBlock As IPixelBlock3
  Dim pTempRaster As IRaster
379:   Set pTempRaster = pInputRaster
  Dim pTempPoint As IPnt
381:   Set pTempPoint = New Pnt
382:   pTempPoint.SetCoords CInt(lngWidth), 1
383:   Set pTempPixBlock = pTempRaster.CreatePixelBlock(pTempPoint)
384:   pTempPixBlock.PixelType(0) = PT_FLOAT
  Dim pTempOrigin As IPnt
386:   Set pTempOrigin = New Pnt

  Dim lngRowCounter As Long
389:   lngRowCounter = -1
  Dim varVal As Variant
'  Dim dblVal As Double

393:   pTempOrigin.SetCoords 0, 0
394:   pTempRaster.Read pTempOrigin, pTempPixBlock
395:   varData = pTempPixBlock.PixelDataByRef(0)
'  booHasData = ConvertNoDataMaskToSomethingUseful(pTempPixBlock.NoDataMaskByRef(0))
397:   If booExcludeIfAnyNull Then
398:     booHasData = ConvertNoDataMaskToSomethingUseful(pTempPixBlock.NoDataMaskByRef(0))
399:   Else
400:     booHasData = booAllIsData
401:   End If

  ' FROM HERE ON OUT, RASTER CURSOR SEEMS TO WORK
 ' MsgBox "UBound(varNbrHeightArray, 1) = " & CStr(UBound(varNbrHeightArray, 1)) & vbCrLf & _
         "UBound(varNbrHeightArray, 2) = " & CStr(UBound(varNbrHeightArray, 2)) & vbCrLf & _
         "UBound(booNbrHeightHasDataArray, 1) = " & CStr(UBound(booNbrHeightHasDataArray, 1)) & vbCrLf & _
         "UBound(booNbrHeightHasDataArray, 2) = " & CStr(UBound(booNbrHeightHasDataArray, 2)) & vbCrLf & _
         "UBound(varData, 1) = " & CStr(UBound(varData, 1)) & vbCrLf & _
         "UBound(varData, 2) = " & CStr(UBound(varData, 2)) & vbCrLf & _
         "lngWidth = " & CStr(lngWidth) & vbCrLf & _
         "lngNbrHoodRadius = " & CStr(lngNbrHoodRadius)
'
'  MsgBox "IsNull(varData(0)) = " & CStr(IsNull(varData(0)))
'  MsgBox "IsNull(varNbrHeightArray(0,6)) = " & CStr((varNbrHeightArray(0, 6)))

  Dim varCheckVal As Variant
  
  ' ADD LINE OF DATA TO [CENTRAL ROW + 1] OF varNbrHeightArray AND booNbrHeightHasDataArray
419:   For lngIndex = 0 To UBound(varNbrHeightArray, 1)
420:     varCheckVal = varData(lngIndex, 0)
421:     If booExcludeIfAnyNull Then
422:       varNbrHeightArray(lngIndex, lngNbrHoodRadius + 1) = varCheckVal
423:     Else
424:       If IsNull(varCheckVal) Then
425:         varNbrHeightArray(lngIndex, lngNbrHoodRadius + 1) = dblNonValue
426:       Else
427:         varNbrHeightArray(lngIndex, lngNbrHoodRadius + 1) = varCheckVal
428:       End If
429:     End If
'    varNbrHeightArray(lngIndex, lngNbrHoodRadius + 1) = varData(lngIndex, 0)
431:     booNbrHeightHasDataArray(lngIndex, lngNbrHoodRadius + 1) = booHasData(lngIndex)
432:   Next lngIndex

  ' ADD REST OF ROWS TO FILL OUT NEIGHBORHOOD HEIGHT
435:   If lngNbrHoodRadius > 1 Then
436:     For lngIndex = 2 To lngNbrHoodRadius
437:       pRastCursor.Next
438:       pPro.Step
439:       DoEvents
440:       Set pPixBlock = pRastCursor.PixelBlock
441:       pPixBlock.PixelType(0) = PT_FLOAT
442:       varData = pPixBlock.PixelDataByRef(0)
'      booHasData = ConvertNoDataMaskToSomethingUseful(pPixBlock.NoDataMaskByRef(0))
444:       If booExcludeIfAnyNull Then
445:         booHasData = ConvertNoDataMaskToSomethingUseful(pPixBlock.NoDataMaskByRef(0))
446:       Else
447:         booHasData = booAllIsData
448:       End If
449:       For lngIndex2 = 0 To UBound(varNbrHeightArray, 1)
450:         varCheckVal = varData(lngIndex, 0)
451:         If booExcludeIfAnyNull Then
452:           varNbrHeightArray(lngIndex2, lngNbrHoodRadius + lngIndex) = varCheckVal
453:         Else
454:           If IsNull(varCheckVal) Then
455:             varNbrHeightArray(lngIndex2, lngNbrHoodRadius + lngIndex) = dblNonValue
456:           Else
457:             varNbrHeightArray(lngIndex2, lngNbrHoodRadius + lngIndex) = varCheckVal
458:           End If
459:         End If
'        varNbrHeightArray(lngIndex2, lngNbrHoodRadius + lngIndex) = varData(lngIndex, 0)
461:         booNbrHeightHasDataArray(lngIndex2, lngNbrHoodRadius + lngIndex) = booHasData(lngIndex)
462:       Next lngIndex2
463:     Next lngIndex
464:   End If

  ' READY TO START DOING AN ANALYSIS
  ' REMEMBER THAT ALWAYS WORKING lngNbrHoodRadius ROWS BEHIND THE CURRENT RASTER CURSOR POSITION

    ' WORK THROUGH REST OF RASTER
  Dim lngSliceRowIndex As Long
  Dim lngSliceColIndex As Long
  Dim lngColIndex As Long
  Dim lngColumnToTest As Long
  Dim lngLastRowIndex As Long
475:   lngLastRowIndex = lngNbrHoodRadius * 2
  Dim lngLastColIndex As Long
477:   lngLastColIndex = lngNbrHoodRadius * 2

'  MsgBox "pDataLinesArray has " & CStr(pDataLinesArray.Count) & " elements..." & vbCrLf & _
'        "pBooHasDataArray has " & CStr(pBooHasDataArray.Count) & " elements..."

  Dim lngRowOfDataCounter As Long
483:   lngRowOfDataCounter = lngNbrHoodRadius

  ' IF lngRowOfDataCounter ACTUALLY IS lngHeight, THEN IT IS ONE ROW TOO FAR.
486:   lngFocalRow = -1
487:   Do Until lngRowOfDataCounter = lngHeight - 1
    
489:     lngFocalRow = lngFocalRow + 1
    
    ' ADD NEW ROWS TO BOTTOM OF SLICE, AND DELETE TOP ROWS
492:     lngRowOfDataCounter = lngRowOfDataCounter + 1
493:     pRastCursor.Next
494:     pPro.Step
495:     DoEvents
496:     Set pPixBlock = pRastCursor.PixelBlock
497:     pPixBlock.PixelType(0) = PT_FLOAT

    ' SHIFT ALL ROWS UP BY ONE
500:     For lngDataIndexX = 0 To UBound(varNbrHeightArray, 1)
501:       For lngDataIndexY = 1 To lngLastRowIndex
502:         varNbrHeightArray(lngDataIndexX, lngDataIndexY - 1) = varNbrHeightArray(lngDataIndexX, lngDataIndexY)
503:         booNbrHeightHasDataArray(lngDataIndexX, lngDataIndexY - 1) = booNbrHeightHasDataArray(lngDataIndexX, lngDataIndexY)
504:       Next lngDataIndexY
505:     Next lngDataIndexX

    ' RESET LOWEST ROW TO NEW VALUES
508:     varData = pPixBlock.PixelDataByRef(0)
'    booHasData = ConvertNoDataMaskToSomethingUseful(pPixBlock.NoDataMaskByRef(0))
510:     If booExcludeIfAnyNull Then
511:       booHasData = ConvertNoDataMaskToSomethingUseful(pPixBlock.NoDataMaskByRef(0))
512:     Else
513:       booHasData = booAllIsData
514:     End If
515:     For lngIndex2 = 0 To UBound(varNbrHeightArray, 1)
    
517:       varCheckVal = varData(lngIndex2, 0)
518:       If booExcludeIfAnyNull Then
519:         varNbrHeightArray(lngIndex2, lngLastRowIndex) = varCheckVal
520:       Else
521:         If IsNull(varCheckVal) Then
522:           varNbrHeightArray(lngIndex2, lngLastRowIndex) = dblNonValue
523:         Else
524:           varNbrHeightArray(lngIndex2, lngLastRowIndex) = varCheckVal
525:         End If
526:       End If
'      varNbrHeightArray(lngIndex2, lngLastRowIndex) = varData(lngIndex2, 0)
528:       booNbrHeightHasDataArray(lngIndex2, lngLastRowIndex) = booHasData(lngIndex2)
529:     Next lngIndex2

    ' ANALYZE THIS SLICE OF RASTER
    ' START WITH ARRAY FULL OF NULL VALUES
533:     For lngDataIndexX = 0 To UBound(varCalcDataArray, 1)
534:       For lngDataIndexY = 0 To UBound(varCalcDataArray, 2)
535:         varCalcDataArray(lngDataIndexX, lngDataIndexY) = Null
536:         booCalcHasDataArray(lngDataIndexX, lngDataIndexY) = False
537:       Next lngDataIndexY
538:     Next lngDataIndexX
    


    ' WRITE ROW
543:     pOutPnt.SetCoords 0, lngFocalRow
    'pRawPixel.Read pOutPnt, pOutPixelBlock
545:     pOutputRaster2.Read pOutPnt, pOutputPixBlock
546:     varOutData = pOutputPixBlock.PixelData(0)
'    pOutPixelBlock.PixelType(0) = PT_FLOAT
'    pPixelData = pOutPixelBlock.PixelDataByRef(0)
     
    ' START AT NEG RADIUS SO CAN FILL UP HALF OF ARRAY BEFORE CALCULATING
551:     For lngIndex2 = -lngNbrHoodRadius To (lngWidth - 1)

      ' SHIFT VALUES IN DATA ARRAY ONE STEP TO LEFT
554:       For lngDataIndexX = 1 To (lngNbrHoodRadius * 2)
555:         For lngDataIndexY = 0 To (lngNbrHoodRadius * 2)
556:           varCalcDataArray(lngDataIndexX - 1, lngDataIndexY) = varCalcDataArray(lngDataIndexX, lngDataIndexY)
557:           booCalcHasDataArray(lngDataIndexX - 1, lngDataIndexY) = booCalcHasDataArray(lngDataIndexX, lngDataIndexY)
558:         Next lngDataIndexY
559:       Next lngDataIndexX

561:       For lngIndex3 = 0 To lngLastRowIndex
562:         If lngIndex2 <= lngPixBlockWidth Then     ' MEANING IF WE ARE ACTUALLY IN RASTER; NOT FILLING LATER CELLS WITH NULLS
'            varVal = varData(lngIndex2 + lngNbrHoodRadius, lngIndex3)
564:           varCalcDataArray(lngLastColIndex, lngIndex3) = varNbrHeightArray(lngIndex2 + lngNbrHoodRadius, lngIndex3)
565:           booCalcHasDataArray(lngLastColIndex, lngIndex3) = booNbrHeightHasDataArray(lngIndex2 + lngNbrHoodRadius, lngIndex3)
566:         Else
567:           varCalcDataArray(lngLastColIndex, lngIndex3) = Null
568:           booCalcHasDataArray(lngLastColIndex, lngIndex3) = False
569:         End If
570:       Next lngIndex3

572:       If lngIndex2 >= 0 Then                        ' MEANING IF WE ARE ACTUALLY IN RASTER; NOT FILLING EARLIER CELLS WITH NULLS
        ' CALCULATE DENSITY VALUE
574:         dblDensity = CalcDensityFromArray(varCalcDataArray, booMaskArray, booCalcHasDataArray, _
                  booDensityIsNull, booExcludeIfAnyNull, dblSearchVals, lngTotalCount)
576:         If booExcludeIfAnyNull Then
577:           If booDensityIsNull Then
578:             If Not booIsFGB Then
  '            pPixelData(lngIndex2, 0) = CInt(-9999)
580:               varOutData(lngIndex2, 0) = CInt(-9999)
581:             End If
582:           Else
  '          pPixelData(lngIndex2, 0) = dblDensity
584:             varOutData(lngIndex2, 0) = Round(dblDensity, 5)
585:           End If
586:         Else
587:           varOutData(lngIndex2, 0) = Round(dblDensity, 5)
588:         End If
589:       End If
590:     Next lngIndex2
    
    ' SAVE DATA TO HARD DRIVE
593:     pOutputPixBlock.PixelData(0) = varOutData
594:     pOutRasterEdit.Write pOutPnt, pOutputPixBlock
595:     If lngRowOfDataCounter Mod 10 = 0 Then
596:       pOutRasterEdit.Refresh
597:     End If
'    pOutPixelBlock.PixelData(0) = pPixelData
'    Set pCache = pRawPixel.AcquireCache
'    pRawPixel.Write pOutPnt, pOutPixelBlock
'    pRawPixel.ReturnCache pCache
    
603:   Loop
604:   pOutRasterEdit.Refresh

  ' CONTINUE UNTIL FINISHED WITH NEIGHBORHOOD RADIUS
607:   For lngIndex = 0 To lngNbrHoodRadius
608:     lngFocalRow = lngFocalRow + 1
    
    ' SHIFT ALL ROWS UP BY ONE
611:     For lngDataIndexX = 0 To UBound(varNbrHeightArray, 1)
612:       For lngDataIndexY = 1 To lngLastRowIndex
613:         varNbrHeightArray(lngDataIndexX, lngDataIndexY - 1) = varNbrHeightArray(lngDataIndexX, lngDataIndexY)
614:         booNbrHeightHasDataArray(lngDataIndexX, lngDataIndexY - 1) = booNbrHeightHasDataArray(lngDataIndexX, lngDataIndexY)
615:       Next lngDataIndexY
      ' SET LOWEST ROW TO NO DATA
617:       booNbrHeightHasDataArray(lngDataIndexX, lngLastRowIndex) = False
618:     Next lngDataIndexX

    ' ANALYZE THIS SLICE OF RASTER
    ' START WITH ARRAY FULL OF NULL VALUES
622:     For lngDataIndexX = 0 To UBound(varCalcDataArray, 1)
623:       For lngDataIndexY = 0 To UBound(varCalcDataArray, 2)
624:         varCalcDataArray(lngDataIndexX, lngDataIndexY) = Null
625:         booCalcHasDataArray(lngDataIndexX, lngDataIndexY) = False
626:       Next lngDataIndexY
627:     Next lngDataIndexX

'    ' WRITE ROW
'    pOutPnt.SetCoords 0, lngFocalRow
'    pRawPixel.Read pOutPnt, pOutPixelBlock
'
'    pOutPixelBlock.PixelType(0) = PT_FLOAT
'    pPixelData = pOutPixelBlock.PixelDataByRef(0)
    
    ' WRITE ROW
637:     pOutPnt.SetCoords 0, lngFocalRow
638:     pOutputRaster2.Read pOutPnt, pOutputPixBlock
639:     varOutData = pOutputPixBlock.PixelData(0)

    ' START AT NEG RADIUS SO CAN FILL UP HALF OF ARRAY BEFORE CALCULATING
642:     For lngIndex2 = -lngNbrHoodRadius To (lngWidth - 1)

      ' SHIFT VALUES IN DATA ARRAY ONE STEP TO LEFT
645:       For lngDataIndexX = 1 To (lngNbrHoodRadius * 2)
646:         For lngDataIndexY = 0 To (lngNbrHoodRadius * 2)
647:           varCalcDataArray(lngDataIndexX - 1, lngDataIndexY) = varCalcDataArray(lngDataIndexX, lngDataIndexY)
648:           booCalcHasDataArray(lngDataIndexX - 1, lngDataIndexY) = booCalcHasDataArray(lngDataIndexX, lngDataIndexY)
649:         Next lngDataIndexY
650:       Next lngDataIndexX

652:       If lngIndex2 >= 0 Then                        ' MEANING IF WE ARE ACTUALLY IN RASTER; NOT FILLING EARLIER CELLS WITH NULLS
653:         For lngIndex3 = 0 To lngLastRowIndex
654:           If lngIndex2 <= lngPixBlockWidth Then     ' MEANING IF WE ARE ACTUALLY IN RASTER; NOT FILLING LATER CELLS WITH NULLS
'            varVal = varData(lngIndex2 + lngNbrHoodRadius, lngIndex3)
656:             varCalcDataArray(lngLastColIndex, lngIndex3) = varNbrHeightArray(lngIndex2 + lngNbrHoodRadius, lngIndex3)
657:             booCalcHasDataArray(lngLastColIndex, lngIndex3) = booNbrHeightHasDataArray(lngIndex2 + lngNbrHoodRadius, lngIndex3)
658:           Else
659:             varCalcDataArray(lngLastColIndex, lngIndex3) = Null
660:             booCalcHasDataArray(lngLastColIndex, lngIndex3) = False
661:           End If
662:         Next lngIndex3

        ' CALCULATE DENSITY INDEX VALUE
665:         dblDensity = CalcDensityFromArray(varCalcDataArray, booMaskArray, booCalcHasDataArray, _
                  booDensityIsNull, booExcludeIfAnyNull, dblSearchVals, lngTotalCount)
667:         If booExcludeIfAnyNull Then
668:           If booDensityIsNull Then
669:             If Not booIsFGB Then
  '            pPixelData(lngIndex2, 0) = CInt(-9999)
671:               varOutData(lngIndex2, 0) = CInt(-9999)
672:             End If
673:           Else
  '          pPixelData(lngIndex2, 0) = dblDensity
675:             varOutData(lngIndex2, 0) = Round(dblDensity, 5)
676:           End If
677:         Else
678:           varOutData(lngIndex2, 0) = Round(dblDensity, 5)
679:         End If
680:       End If
681:     Next lngIndex2
    
    ' SAVE DATA TO HARD DRIVE
684:     pOutputPixBlock.PixelData(0) = varOutData
685:     pOutRasterEdit.Write pOutPnt, pOutputPixBlock
686:     pOutRasterEdit.Refresh
'    pOutPixelBlock.PixelData(0) = pPixelData
'    Set pCache = pRawPixel.AcquireCache
'    pRawPixel.Write pOutPnt, pOutPixelBlock
'    pRawPixel.ReturnCache pCache

692:   Next lngIndex

   
'  ----------------------------
  Dim pNewLayer As IRasterLayer

  Dim pStatsBandColl As IRasterBandCollection
  Dim pStatsBand As IRasterBand
700:   Set pStatsBandColl = pOutDS
701:   Set pStatsBand = pStatsBandColl.Item(0)
702:   pStatsBand.ComputeStatsAndHist
  Dim pStats As IRasterStatistics
704:   Set pStats = pStatsBand.Statistics
705:   pStats.Recalculate
706:   Set pStats = Nothing
  'pStatsBand.ComputeStatsAndHist
  
709:   Set pInputBand = Nothing
710:   Set pRastLayer = Nothing
711:   Set pGeoDataset = Nothing
712:   Set pInputDataset = Nothing
713:   Set pInputRaster = Nothing
714:   Set pEnv = Nothing
715:   Set pSearchValues = Nothing
716:   Set pRastDataset = Nothing
717:   Set pSaveAs = Nothing
718:   Set pRasterProp = Nothing
719:   Set pRasLy = Nothing
720:   Set pRastStDef = Nothing
721:   Set pRastProps = Nothing
722:   Set pTempBandColl = Nothing
723:   Set pPnt = Nothing
724:   Set pPixBlock = Nothing
725:   Set pTopLeft = Nothing
726:   Set pOutDS = Nothing
727:   Set pOutRasterEdit = Nothing
728:   Set pRasterStorDef = Nothing
729:   Set pRasterDef = Nothing
730:   Set pGeomDef = Nothing
731:   Set pOriginPoint = Nothing
732:   Set pOutPnt = Nothing
733:   Set pSpRef = Nothing
734:   Set pOutProps = Nothing
735:   Set pOutBandColl = Nothing
736:   Set pTempOutBandColl = Nothing
737:   Set pOutBand = Nothing
738:   Set pRastDatasetEdit = Nothing
739:   Set pTempOutRaster = Nothing
740:   Set pOutputPixBlock = Nothing
741:   Set pOutputRaster = Nothing
742:   Set pOutputRaster2 = Nothing
743:   Set pRawPixel = Nothing
744:   Set pOutPixelBlock = Nothing
745:   Set pBands = Nothing
746:   Set pOutputRastProps = Nothing
747:   Set pRastCursor = Nothing
748:   Set pTempPixBlock = Nothing
749:   Set pTempRaster = Nothing
750:   Set pTempPoint = Nothing
751:   Set pTempOrigin = Nothing
752:   Set pNewLayer = Nothing
753:   Set pStatsBandColl = Nothing
754:   Set pStatsBand = Nothing
755:   Set pStats = Nothing
  
  Dim pNewDS As IRasterDataset
758:   Set pNewDS = pRastWS.OpenRasterDataset(strNewRasterName & strExtension)
  
  ' ADD RASTER TO MAP DOCUMENT
761:   Set pNewLayer = New RasterLayer
'  pNewLayer.CreateFromRaster pMultiplyStep2
763:   pNewLayer.CreateFromDataset pNewDS
764:   pNewLayer.Name = strNewRasterName

  ' SYMBOLIZE RASTER LAYER

  ' Create renderer and QI RasterRenderer
  Dim pStretchRen As IRasterStretchColorRampRenderer
770:   Set pStretchRen = New RasterStretchColorRampRenderer
  Dim pRasRen As IRasterRenderer
772:   Set pRasRen = pStretchRen
  
  Dim pRasterStretch As IRasterStretch
775:   Set pRasterStretch = pStretchRen
776:   pRasterStretch.StretchType = esriRasterStretch_NONE
  
  ' Set raster for the renderer and update
779:   Set pRasRen.Raster = pNewLayer.Raster
780:   pRasRen.Update

  ' COLORS - MAKE RANDOM COLOR SHADING TO WHITE
  Dim pStartColor As IColor
  Dim pWhiteColor As IColor

786:   Set pStartColor = New RgbColor
787:   Set pWhiteColor = New RgbColor
  
789:   Randomize
790:   pStartColor.RGB = RGB(CLng(Rnd * 100) + 50, CLng(Rnd * 100) + 50, CLng(Rnd * 100) + 50)
791:   pWhiteColor.RGB = RGB(255, 255, 255)

  ' CREATE COLOR RAMPS
  Dim pRamp1 As IAlgorithmicColorRamp
795:   Set pRamp1 = New AlgorithmicColorRamp
796:   pRamp1.Algorithm = esriLabLChAlgorithm
797:   pRamp1.Size = 130
798:   pRamp1.FromColor = pWhiteColor
799:   pRamp1.ToColor = pStartColor
800:   pRamp1.CreateRamp True

  ' Plug this colorramp into renderer and select a band
803:   pStretchRen.BandIndex = 0
804:   pStretchRen.ColorRamp = pRamp1

  ' Update the renderer with new settings and plug into layer
807:   pRasRen.Update
808:   Set pNewLayer.Renderer = pStretchRen

810:   pMxDoc.AddLayer pNewLayer
'-----------------------------------
  
  
814:   pPro.position = 0
815:   psbar.HideProgressBar
  
  

819:   strReport = "Raster Density Function Complete:" & vbCrLf & _
              "----------------------------------------------------------" & vbCrLf & _
              "Analysis Parameters:" & vbCrLf & _
              " --> Input Raster Layer: " & strInputName & vbCrLf & _
              "     --> Attribute Field = [" & strFieldName & "]" & vbCrLf & _
              "     --> Selected Attribute Value = " & strSelAttribute & vbCrLf & _
              " --> Circular Neighborhood Radius: " & CStr(lngNbrHoodRadius) & " cells..." & vbCrLf & _
              " --> Option to set cell to NoData if any NoData values in neighborhood = " & UCase(CStr(booExcludeIfAnyNull)) & vbCrLf & _
              " --> Output Format: " & strSaveFormatString & vbCrLf & _
              " --> Filename: " & strNewRasterName & strExtension & vbCrLf & _
              " --> Workspace = " & pWS.PathName & vbCrLf & _
              "----------------------------------------------------------" & vbCrLf & _
              TopoCorridor.MyGeneralOperations.ReturnTimeElapsed(datBegan, Now)
  
833:   pMxDoc.UpdateContents
834:   pMxDoc.ActiveView.PartialRefresh esriViewGeography, Nothing, pEnv
  
836:   CreateDensityRaster = strReport
    

839:   GoTo CleanUp
ErrorHandler:
  HandleError True, "CreateDensityRaster " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4

CleanUp:



847:   Set pApp = Nothing
848:   Set pMxDoc = Nothing
849:   Set pThisExt = Nothing
850:   Set pInputBand = Nothing
851:   Set pRastLayer = Nothing
852:   Set pGeoDataset = Nothing
853:   Set pInputDataset = Nothing
854:   Set pInputRaster = Nothing
855:   Set pEnv = Nothing
856:   Set pRastWS = Nothing
857:   Set pRastWsEx = Nothing
858:   Set pWS = Nothing
859:   Set pSearchValues = Nothing
860:   Set pRastDataset = Nothing
861:   Set pSaveAs = Nothing
862:   Set pRasterProp = Nothing
863:   Set pRasLy = Nothing
864:   Set pRastStDef = Nothing
865:   Set pRastProps = Nothing
866:   Set pPro = Nothing
867:   Set psbar = Nothing
868:   Set pTempBandColl = Nothing
869:   Set pPnt = Nothing
870:   Set pPixBlock = Nothing
871:   Set pTopLeft = Nothing
872:   Set pOutDS = Nothing
873:   Set pOutRasterEdit = Nothing
874:   Set pRasterStorDef = Nothing
875:   Set pRasterDef = Nothing
876:   Set pGeomDef = Nothing
877:   Set pOriginPoint = Nothing
878:   Set pOutPnt = Nothing
879:   Set pSpRef = Nothing
880:   Set pOutProps = Nothing
881:   Set pOutBandColl = Nothing
882:   Set pTempOutBandColl = Nothing
883:   Set pOutBand = Nothing
884:   Set pRastDatasetEdit = Nothing
885:   Set pTempOutRaster = Nothing
886:   Set pOutputPixBlock = Nothing
887:   Set pOutputRaster = Nothing
888:   Set pOutputRaster2 = Nothing
889:   Set pRawPixel = Nothing
890:   Set pOutPixelBlock = Nothing
891:   Set pBands = Nothing
892:   Set pOutputRastProps = Nothing
893:   Set pRastCursor = Nothing
894:   Set pTempPixBlock = Nothing
895:   Set pTempRaster = Nothing
896:   Set pTempPoint = Nothing
897:   Set pTempOrigin = Nothing
898:   Set pNewLayer = Nothing
899:   Set pStatsBandColl = Nothing
900:   Set pStatsBand = Nothing
901:   Set pStats = Nothing
902:   Set pNewDS = Nothing
903:   Set pStretchRen = Nothing
904:   Set pRasRen = Nothing
905:   Set pRasterStretch = Nothing
906:   Set pStartColor = Nothing
907:   Set pWhiteColor = Nothing
908:   Set pRamp1 = Nothing

End Function


Public Function InvertRaster(pDocParams As esriSystem.IVariantArray, _
    pParams As esriSystem.IVariantArray) As String
  On Error GoTo ErrorHandler


    
  Dim pApp As IApplication
  Dim pMxDoc As IMxDocument
  Dim pThisExt As TopoCorridor.clsExtension
  
923:   Set pApp = pDocParams.Element(0)
924:   Set pMxDoc = pDocParams.Element(1)
925:   Set pThisExt = pDocParams.Element(2)
  
  ' pParams IS IVariantArray, CONTAINING:
  ' 0) IRasterLayer: SELECTED RASTER CATALOG LAYER
  ' 1) STRING: Save Format
  ' 2) STRING: TEXT VERSION OF SAVE FORMAT
  ' 3) STRING: New Raster Name
  ' 4) BOOLEAN: Whether new workspace is File Geodatabase
  ' 5) IWORKSPACE: Either an IRasterWorkspace2 or an IRasterWorkspaceEx
  ' 6) STRING: Extension for output
  ' 7) STRING: Name of Selected Raster Band
  ' 8) DOUBLE: OPTIONAL ADD VALUE

  Dim datBegan As Date
939:   datBegan = Now
  
  Dim strReport As String
942:   strReport = "Function failed..."
  
944:   InvertRaster = strReport
  
  Dim pInputBand As IRasterBand
  Dim pRastLayer As IRasterLayer
  Dim pGeoDataset As IGeoDataset
  Dim pInputDataset As IRasterDataset
  Dim pInputRaster As IRaster2
  Dim pEnv As IEnvelope
  Dim strSaveFormat As String
  Dim lngNbrHoodRadius As Long
  Dim strNewRasterName As String
  Dim booIsFGB As Boolean
  Dim pRastWS As IRasterWorkspace2
  Dim pRastWsEx As IRasterWorkspaceEx
  Dim strSaveFormatString As String
  Dim pWS As IWorkspace
  Dim strExtension As String
  Dim strInputName As String
  Dim booExcludeIfAnyNull As Boolean
  Dim dblAdd As Double
964:   booExcludeIfAnyNull = False
  
'  MsgBox "pParams.Count = " & CStr(pParams.Count)
'  MsgBox "VarType(pParams.Element(0)) = " & CStr(VarType(pParams.Element(0)))
'  MsgBox "TypeOf pParams.Element(0) Is ILayer = " & CStr(TypeOf pParams.Element(0) Is ILayer)
'  MsgBox "TypeOf pParams.Element(0) Is IRasterLayer = " & CStr(TypeOf pParams.Element(0) Is IRasterLayer)
  
971:   Set pInputBand = pParams.Element(0)
972:   Set pGeoDataset = pInputBand
973:   Set pEnv = pGeoDataset.Extent
  
975:   strSaveFormat = pParams.Element(1)
976:   strSaveFormatString = pParams.Element(2)
977:   strNewRasterName = pParams.Element(3)
978:   booIsFGB = pParams.Element(4)
979:   Set pWS = pParams.Element(5)
980:   If booIsFGB Then
981:     Set pRastWsEx = pWS
982:   Else
983:     Set pRastWS = pWS
984:   End If
985:   strExtension = pParams.Element(6)
986:   strInputName = pParams.Element(7)
987:   dblAdd = pParams.Element(8)
  
  Dim pRastDataset As IRasterDataset3
  
  Dim pSaveAs As ISaveAs2
  Dim pRasterProp As IRasterProps
  Dim pRasLy As IRasterLayer
  Dim pRastStDef As IRasterStorageDef2
  Dim pRastProps As IRasterProps
  
  '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  '/////////// |                  | \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
  '----------  |   CALCULATIONS   |  ---------------------------------------------------------------------------
  '\\\\\\\\\\\ |                  | ///////////////////////////////////////////////////////////////////////////
  '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

  Dim pPro As IStepProgressor
  Dim psbar As IStatusBar
  
  Dim pTempBandColl As IRasterBandCollection
1007:   Set pTempBandColl = New Raster
1008:   pTempBandColl.AppendBand pInputBand
1009:   Set pInputRaster = pTempBandColl
1010:   Set pRastProps = pInputRaster
  
1012:   Set psbar = pApp.StatusBar
1013:   Set pPro = psbar.ProgressBar
  
  Dim lngHeight As Long
  Dim lngWidth As Long
  Dim dblNoData As Double
  Dim varNoData As Variant
  
1020:   lngWidth = pRastProps.Width
1021:   lngHeight = pRastProps.Height
1022:   varNoData = pRastProps.NoDataValue
  
  ' PROGRESS STUFF
1025:   pPro.position = 0
  Dim strMessageName As String
1027:   strMessageName = "Inverting '" & strInputName & "'..."
1028:   psbar.ShowProgressBar strMessageName, 1, lngHeight, 1, True
1029:   pPro.Message = strMessageName

  Dim pPnt As IPnt
1032:   Set pPnt = New Pnt
1033:   pPnt.SetCoords lngWidth, 1

  Dim pPixBlock As IPixelBlock3

  Dim pTopLeft As IPnt

  Dim lngIndex As Long
  Dim lngIndex2 As Long
  Dim lngIndex3 As Long
  Dim varNoDataArray As Variant
  Dim booHasData() As Boolean
  Dim varData As Variant
  Dim varEmptyData() As Variant
  ReDim varEmptyData(lngWidth - 1)
  
  ' FOR DEBUGGING
'  Dim strDebugReport As String
'  strDebugReport = ""
'  For lngIndex = 0 To (lngNbrHoodRadius * 2)
'    For lngIndex2 = 0 To (lngNbrHoodRadius * 2)
'      strDebugReport = strDebugReport & Left(UCase(CStr(booMaskArray(lngIndex, lngIndex2))), 1) & "  "
'    Next lngIndex2
'    strDebugReport = strDebugReport & vbCrLf
'  Next lngIndex

  Dim dblShannon As Double
  Dim booShannonIsNull As Boolean
    
  ' CREATE RASTERS TO WRITE TO -----------------------------------------------------------------------------------
  ' Create the dataset
  Dim pOutDS As IRasterDataset2
  Dim pOutRasterEdit As IRasterEdit

  Dim pRasterStorDef As IRasterStorageDef2
  Dim pRasterDef As IRasterDef
  Dim pGeomDef As IGeometryDef
  
  Dim pOriginPoint As IPoint
1071:   Set pOriginPoint = New Point
1072:   pOriginPoint.PutCoords pRastProps.Extent.XMin, pRastProps.Extent.YMin
  
  Dim pOutPnt As IPnt
1075:   Set pOutPnt = New Pnt
  Dim lngFocalRow As Long
  
  Dim pSpRef As ISpatialReference
1079:   Set pSpRef = pRastProps.SpatialReference
      
  ' IRasterStorageDef
1082:   Set pRasterStorDef = New RasterStorageDef
1083:   Set pRasterStorDef.CellSize = pRastProps.MeanCellSize
1084:   pRasterStorDef.CompressionType = esriRasterSdeCompressionTypeRunLength
1085:   pRasterStorDef.PyramidLevel = 2
1086:   pRasterStorDef.PyramidResampleType = RSP_BilinearInterpolation
1087:   pRasterStorDef.TileHeight = 128
1088:   pRasterStorDef.TileWidth = 128

  ' IRasterDef
1091:   Set pRasterDef = New RasterDef
1092:   Set pRasterDef.SpatialReference = pSpRef
1093:   pRasterDef.Description = "rasterdataset"

  ' IGeometryDef
1096:   Set pGeomDef = Nothing
  
  Dim pOutProps As IRasterProps
  Dim pOutBandColl As IRasterBandCollection
  Dim pTempOutBandColl As IRasterBandCollection
  Dim pOutBand As IRasterBand
  Dim pRastDatasetEdit As IRasterDatasetEdit2
  Dim pTempOutRaster As IRaster
  
1105:   Set pRasterStorDef.CellSize = pRastProps.MeanCellSize
1106:   If booIsFGB Then
1107:     Set pOutDS = pRastWsEx.CreateRasterDataset(strNewRasterName, 1, PT_FLOAT, pRasterStorDef, _
        "DEFAULTS", pRasterDef, pGeomDef)
1109:     Set pTempOutBandColl = pOutDS
1110:     Set pTempOutRaster = New Raster
1111:     Set pOutBandColl = pTempOutRaster
1112:     pOutBandColl.AppendBands pTempOutBandColl
1113:     pTempOutRaster.ResampleMethod = RSP_BilinearInterpolation
    
1115:     Set pOutProps = pTempOutRaster
1116:     pOutProps.Extent = pRastProps.Extent
1117:     pOutProps.Height = pRastProps.Height
1118:     pOutProps.Width = pRastProps.Width
1119:     pOutProps.SpatialReference = pSpRef
1120:     pOutProps.PixelType = PT_FLOAT
1121:   Else
1122:     Set pOutDS = pRastWS.CreateRasterDataset(strNewRasterName & strExtension, strSaveFormat, pOriginPoint, lngWidth, lngHeight, _
        pRastProps.MeanCellSize.X, pRastProps.MeanCellSize.Y, 1, PT_FLOAT, pSpRef, True)
1124:   End If
  
  Dim pOutputPixBlock As IPixelBlock3
  
  ' OUTPUT VARIABLES
  Dim pOutputRaster As IRaster2
  Dim pOutputRaster2 As IRaster
  Dim pPixelData As Variant
  Dim pRawPixel As IRawPixels
  Dim pOutPixelBlock As IPixelBlock3
  Dim pBands As IRasterBandCollection
  Dim pOutputRastProps As IRasterProps
  Dim pCache As Variant

  ' QI for IRawPixels and IRasterProps
1139:   Set pOutputRaster = pOutDS.CreateFullRaster
1140:   Set pOutputRaster2 = pOutputRaster
1141:   Set pOutRasterEdit = pOutputRaster
1142:   Set pBands = pOutDS
1143:   Set pRawPixel = pBands.Item(0)
1144:   Set pOutputRastProps = pRawPixel
1145:   If Not booIsFGB Then
1146:     pOutputRastProps.NoDataValue = CInt(-9999)
1147:   End If
'  Set pOutPixelBlock = pRawPixel.CreatePixelBlock(pPnt)
1149:   Set pOutputPixBlock = pOutputRaster2.CreatePixelBlock(pPnt)
1150:   pOutputPixBlock.PixelType(0) = PT_FLOAT
  Dim varOutData As Variant

  ' ADD FIRST LINE OF DATA
  Dim pRastCursor As IRasterCursor
1155:   Set pRastCursor = pInputRaster.CreateCursorEx(pPnt)

1157:   Set pPixBlock = pRastCursor.PixelBlock
1158:   pPixBlock.PixelType(0) = PT_FLOAT
1159:   pRastCursor.Reset
1160:   Set pPixBlock = pRastCursor.PixelBlock
1161:   varData = pPixBlock.PixelData(0)
1162:   booHasData = ConvertNoDataMaskToSomethingUseful(pPixBlock.NoDataMask(0))
'
'  ' BELOW IS WORKAROUND FOR PROBLEM IN WHICH PIXEL BLOCK APPEARS TO NOT BE ABLE TO CORRECTLY READ FIRST ROW.
'  ' I THINK THIS HAS SOMETHING TO DO WITH SETTING THE PIXEL TYPE TO PT_FLOAT.  IT READS IT CORRECTLY AFTER
'  ' THAT POINT, BUT I CANNOT SET IT BEFORE READING THE FIRST ROW FROM RASTER CURSOR, EVEN AFTER USING 'RESET'.
'  ' CODE BELOW SIMPLY EXTRACTS varData1 and booHasData1 FROM A DIFFERENT PIXEL BLOCK THAT IS READ CORRECTLY.
  Dim pTempPixBlock As IPixelBlock3
  Dim pTempRaster As IRaster
1170:   Set pTempRaster = pInputRaster
  Dim pTempPoint As IPnt
1172:   Set pTempPoint = New Pnt
1173:   pTempPoint.SetCoords CInt(lngWidth), 1
1174:   Set pTempPixBlock = pTempRaster.CreatePixelBlock(pTempPoint)
1175:   pTempPixBlock.PixelType(0) = PT_FLOAT
  Dim pTempOrigin As IPnt
1177:   Set pTempOrigin = New Pnt

  Dim lngRowCounter As Long
1180:   lngRowCounter = -1
  Dim varVal As Variant
  Dim dblVal As Double

1184:   pTempOrigin.SetCoords 0, 0
1185:   pTempRaster.Read pTempOrigin, pTempPixBlock
1186:   varData = pTempPixBlock.PixelDataByRef(0)
1187:   booHasData = ConvertNoDataMaskToSomethingUseful(pTempPixBlock.NoDataMaskByRef(0))

  ' FROM HERE ON OUT, RASTER CURSOR SEEMS TO WORK

  ' IF lngFocalRow ACTUALLY IS lngHeight, THEN IT IS ONE ROW TOO FAR.
  
1193:   lngFocalRow = 0
  Dim lngLastColumn As Long
1195:   lngLastColumn = lngWidth - 1
  Dim dblOut As Double
  
1198:   Do Until lngFocalRow = lngHeight
1199:     pPro.Step
1200:     DoEvents
    
    ' WRITE ROW
1203:     pOutPnt.SetCoords 0, lngFocalRow
1204:     pOutputRaster2.Read pOutPnt, pOutputPixBlock
1205:     varOutData = pOutputPixBlock.PixelData(0)
    
    
1208:     For lngIndex = 0 To lngLastColumn
    
   '   If MsgBox("lngFocalRow = " & CStr(lngFocalRow) & vbCrLf & _
        "booHasData(lngIndex = " & CStr(lngIndex) & ") = " & CStr(booHasData(lngIndex)), vbYesNo) = vbYes Then Goto cleanup
      
1213:       dblOut = -9999
1214:       If booHasData(lngIndex) Then
      
       ' If MsgBox("lngFocalRow = " & CStr(lngFocalRow) & vbCrLf & _
          "booHasData(lngIndex = " & CStr(lngIndex) & ") = " & CStr(booHasData(lngIndex)) & vbCrLf & _
          "Not IsNull(varVal) = " & CStr(Not IsNull(varVal)), vbYesNo) = vbYes Then Goto cleanup
        
1220:         varVal = varData(lngIndex, 0)
1221:         If Not IsNull(varVal) Then
      
     '     If MsgBox("lngFocalRow = " & CStr(lngFocalRow) & vbCrLf & _
            "booHasData(lngIndex = " & CStr(lngIndex) & ") = " & CStr(booHasData(lngIndex)) & vbCrLf & _
            "Not IsNull(varVal) = " & CStr(Not IsNull(varVal)) & vbCrLf & _
            "dblVal = " & CStr(dblVal), vbYesNo) = vbYes Then Goto cleanup
            
1228:           dblVal = CDbl(varVal) + dblAdd
1229:           If dblVal <> 0 Then
1230:              dblOut = 1 / dblVal
              
      '      If MsgBox("lngFocalRow = " & CStr(lngFocalRow) & vbCrLf & _
              "booHasData(lngIndex = " & CStr(lngIndex) & ") = " & CStr(booHasData(lngIndex)) & vbCrLf & _
              "Not IsNull(varVal) = " & CStr(Not IsNull(varVal)) & vbCrLf & _
              "dblVal = " & CStr(dblVal) & vbCrLf & _
              "varOutData(lngIndex, 0) = " & CStr(CDbl(varOutData(lngIndex, 0))), vbYesNo) = vbYes Then Goto cleanup
1237:           End If
1238:         End If
1239:       End If
      
1241:       varOutData(lngIndex, 0) = dblOut
      
1243:     Next lngIndex

    ' SAVE DATA TO HARD DRIVE
1246:     pOutputPixBlock.PixelData(0) = varOutData
1247:     pOutRasterEdit.Write pOutPnt, pOutputPixBlock
1248:     If lngFocalRow Mod 20 = 0 Then
1249:       pOutRasterEdit.Refresh
1250:     End If
    
    ' MOVE TO NEXT ROW
1253:     lngFocalRow = lngFocalRow + 1
    
1255:     pRastCursor.Next
1256:     Set pPixBlock = pRastCursor.PixelBlock
1257:     pPixBlock.PixelType(0) = PT_FLOAT
1258:     varData = pPixBlock.PixelDataByRef(0)
1259:     booHasData = ConvertNoDataMaskToSomethingUseful(pPixBlock.NoDataMaskByRef(0))
    
1261:   Loop
  
1263:   pOutRasterEdit.Refresh

'  ----------------------------
  Dim pNewLayer As IRasterLayer

  Dim pStatsBandColl As IRasterBandCollection
  Dim pStatsBand As IRasterBand
1270:   Set pStatsBandColl = pOutDS
1271:   Set pStatsBand = pStatsBandColl.Item(0)
'  pStatsBand.ComputeStatsAndHist
  Dim pStats As IRasterStatistics
1274:   Set pStats = pStatsBand.Statistics
1275:   pStats.Recalculate
1276:   Set pStats = Nothing
  
  

1280:   Set pInputBand = Nothing
1281:   Set pRastLayer = Nothing
1282:   Set pGeoDataset = Nothing
1283:   Set pInputDataset = Nothing
1284:   Set pInputRaster = Nothing
1285:   Set pEnv = Nothing
1286:   Set pRastDataset = Nothing
1287:   Set pSaveAs = Nothing
1288:   Set pRasterProp = Nothing
1289:   Set pRasLy = Nothing
1290:   Set pRastStDef = Nothing
1291:   Set pRastProps = Nothing
1292:   Set pTempBandColl = Nothing
1293:   Set pPnt = Nothing
1294:   Set pPixBlock = Nothing
1295:   Set pTopLeft = Nothing
1296:   Set pOutDS = Nothing
1297:   Set pOutRasterEdit = Nothing
1298:   Set pRasterStorDef = Nothing
1299:   Set pRasterDef = Nothing
1300:   Set pGeomDef = Nothing
1301:   Set pOriginPoint = Nothing
1302:   Set pOutPnt = Nothing
1303:   Set pSpRef = Nothing
1304:   Set pOutProps = Nothing
1305:   Set pOutBandColl = Nothing
1306:   Set pTempOutBandColl = Nothing
1307:   Set pOutBand = Nothing
1308:   Set pRastDatasetEdit = Nothing
1309:   Set pTempOutRaster = Nothing
1310:   Set pOutputPixBlock = Nothing
1311:   Set pOutputRaster = Nothing
1312:   Set pOutputRaster2 = Nothing
1313:   Set pRawPixel = Nothing
1314:   Set pOutPixelBlock = Nothing
1315:   Set pBands = Nothing
1316:   Set pOutputRastProps = Nothing
1317:   Set pRastCursor = Nothing
1318:   Set pTempPixBlock = Nothing
1319:   Set pTempRaster = Nothing
1320:   Set pTempPoint = Nothing
1321:   Set pTempOrigin = Nothing
1322:   Set pStatsBandColl = Nothing
1323:   Set pStatsBand = Nothing
1324:   Set pStats = Nothing

  Dim pNewDS As IRasterDataset
1327:   Set pNewDS = pRastWS.OpenRasterDataset(strNewRasterName & strExtension)
    
  ' ADD RASTER TO MAP DOCUMENT
1330:   Set pNewLayer = New RasterLayer
1331:   pNewLayer.CreateFromDataset pNewDS
1332:   pNewLayer.Name = strNewRasterName

  ' SYMBOLIZE RASTER LAYER

  ' Create renderer and QI RasterRenderer
  Dim pStretchRen As IRasterStretchColorRampRenderer
1338:   Set pStretchRen = New RasterStretchColorRampRenderer
  Dim pRasRen As IRasterRenderer
1340:   Set pRasRen = pStretchRen
  
  Dim pRasterStretch As IRasterStretch
1343:   Set pRasterStretch = pStretchRen
1344:   pRasterStretch.StretchType = esriRasterStretch_NONE

  ' Set raster for the renderer and update
1347:   Set pRasRen.Raster = pNewLayer.Raster
1348:   pRasRen.Update

  ' COLORS
  Dim pRedColor As IColor
  Dim pYellowColor As IColor
  Dim pGreenColor As IColor

1355:   Set pRedColor = New RgbColor
1356:   Set pYellowColor = New RgbColor
1357:   Set pGreenColor = New RgbColor

1359:   pRedColor.RGB = RGB(190, 0, 0)
1360:   pYellowColor.RGB = RGB(255, 255, 200)
1361:   pGreenColor.RGB = RGB(0, 140, 0)

  ' CREATE COLOR RAMPS
  Dim pRamp1 As IAlgorithmicColorRamp
1365:   Set pRamp1 = New AlgorithmicColorRamp
1366:   pRamp1.Algorithm = esriLabLChAlgorithm
1367:   pRamp1.Size = 130
1368:   pRamp1.FromColor = pGreenColor
1369:   pRamp1.ToColor = pYellowColor
1370:   pRamp1.CreateRamp True

  Dim pRamp2 As IAlgorithmicColorRamp
1373:   Set pRamp2 = New AlgorithmicColorRamp
1374:   pRamp2.Algorithm = esriLabLChAlgorithm
1375:   pRamp2.Size = 130
1376:   pRamp2.FromColor = pYellowColor
1377:   pRamp2.ToColor = pRedColor
1378:   pRamp2.CreateRamp True

  Dim pMultiRamp As IMultiPartColorRamp
1381:   Set pMultiRamp = New MultiPartColorRamp
1382:   pMultiRamp.Ramp(0) = pRamp1
1383:   pMultiRamp.Ramp(1) = pRamp2
1384:   pMultiRamp.Size = 260
1385:   pMultiRamp.CreateRamp True

  ' Plug this colorramp into renderer and select a band
1388:   pStretchRen.BandIndex = 0
1389:   pStretchRen.ColorRamp = pMultiRamp

  ' Update the renderer with new settings and plug into layer
1392:   pRasRen.Update
1393:   Set pNewLayer.Renderer = pStretchRen

1395:   pMxDoc.AddLayer pNewLayer
'-----------------------------------
  
1398:   pPro.position = 0
1399:   psbar.HideProgressBar
  
  
  ' ONLY SHOW OUTPUT REPORT IF IT CRASHED PRIOR TO THIS POINT
'  strReport = ""
1404:   strReport = "Invert Raster Function Complete:" & vbCrLf & _
              "----------------------------------------------------------" & vbCrLf & _
              "Analysis Parameters:" & vbCrLf & _
              " --> Input Raster Layer: " & strInputName & vbCrLf & _
              " --> Output Format: " & strSaveFormatString & vbCrLf & _
              " --> Filename: " & strNewRasterName & strExtension & vbCrLf & _
              " --> Workspace = " & pWS.PathName & vbCrLf
              
1412:   If dblAdd <> 0 Then strReport = strReport & _
              " --> Value added to each cell before inversion = " & CStr(dblAdd) & vbCrLf
              
1415:   strReport = strReport & _
              "----------------------------------------------------------" & vbCrLf & _
              TopoCorridor.MyGeneralOperations.ReturnTimeElapsed(datBegan, Now)
  
1419:   pMxDoc.UpdateContents
1420:   pMxDoc.ActiveView.PartialRefresh esriViewGeography, Nothing, pEnv
  
1422:   InvertRaster = strReport
  
  
  
  
  
  


1431:   GoTo CleanUp
ErrorHandler:
  HandleError True, "InvertRaster " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4

CleanUp:


1438:   Set pApp = Nothing
1439:   Set pMxDoc = Nothing
1440:   Set pThisExt = Nothing
1441:   Set pInputBand = Nothing
1442:   Set pRastLayer = Nothing
1443:   Set pGeoDataset = Nothing
1444:   Set pInputDataset = Nothing
1445:   Set pInputRaster = Nothing
1446:   Set pEnv = Nothing
1447:   Set pRastWS = Nothing
1448:   Set pRastWsEx = Nothing
1449:   Set pWS = Nothing
1450:   Set pRastDataset = Nothing
1451:   Set pSaveAs = Nothing
1452:   Set pRasterProp = Nothing
1453:   Set pRasLy = Nothing
1454:   Set pRastStDef = Nothing
1455:   Set pRastProps = Nothing
1456:   Set pPro = Nothing
1457:   Set psbar = Nothing
1458:   Set pTempBandColl = Nothing
1459:   Set pPnt = Nothing
1460:   Set pPixBlock = Nothing
1461:   Set pTopLeft = Nothing
1462:   Set pOutDS = Nothing
1463:   Set pOutRasterEdit = Nothing
1464:   Set pRasterStorDef = Nothing
1465:   Set pRasterDef = Nothing
1466:   Set pGeomDef = Nothing
1467:   Set pOriginPoint = Nothing
1468:   Set pOutPnt = Nothing
1469:   Set pSpRef = Nothing
1470:   Set pOutProps = Nothing
1471:   Set pOutBandColl = Nothing
1472:   Set pTempOutBandColl = Nothing
1473:   Set pOutBand = Nothing
1474:   Set pRastDatasetEdit = Nothing
1475:   Set pTempOutRaster = Nothing
1476:   Set pOutputPixBlock = Nothing
1477:   Set pOutputRaster = Nothing
1478:   Set pOutputRaster2 = Nothing
1479:   Set pRawPixel = Nothing
1480:   Set pOutPixelBlock = Nothing
1481:   Set pBands = Nothing
1482:   Set pOutputRastProps = Nothing
1483:   Set pRastCursor = Nothing
1484:   Set pTempPixBlock = Nothing
1485:   Set pTempRaster = Nothing
1486:   Set pTempPoint = Nothing
1487:   Set pTempOrigin = Nothing
1488:   Set pNewLayer = Nothing
1489:   Set pStatsBandColl = Nothing
1490:   Set pStatsBand = Nothing
1491:   Set pStats = Nothing
1492:   Set pNewDS = Nothing
1493:   Set pStretchRen = Nothing
1494:   Set pRasRen = Nothing
1495:   Set pRasterStretch = Nothing
1496:   Set pRedColor = Nothing
1497:   Set pYellowColor = Nothing
1498:   Set pGreenColor = Nothing
1499:   Set pRamp1 = Nothing
1500:   Set pRamp2 = Nothing
1501:   Set pMultiRamp = Nothing






End Function
Public Function CreateDiversityRaster(pDocParams As esriSystem.IVariantArray, _
    pParams As esriSystem.IVariantArray) As String
  On Error GoTo ErrorHandler

    
  Dim pApp As IApplication
  Dim pMxDoc As IMxDocument
  Dim pThisExt As TopoCorridor.clsExtension
  
1518:   Set pApp = pDocParams.Element(0)
1519:   Set pMxDoc = pDocParams.Element(1)
1520:   Set pThisExt = pDocParams.Element(2)
  
  ' pParams IS IVariantArray, CONTAINING:
  ' 0) IRasterLayer: SELECTED RASTER CATALOG LAYER
  ' 1) LONG: Circular Neighborhood Radius, in units of Cells
  ' 2) STRING: Save Format
  ' 3) STRING: TEXT VERSION OF SAVE FORMAT
  ' 4) STRING: New Raster Name
  ' 5) BOOLEAN: Whether new workspace is File Geodatabase
  ' 6) IWORKSPACE: Either an IRasterWorkspace2 or an IRasterWorkspaceEx
  ' 7) STRING: Extension for output
  ' 8) STRING: Name of Selected Raster Band
  ' 9) BOOLEAN: Whether to exclude if any Null values
 
  Dim datBegan As Date
1535:   datBegan = Now

  Dim strReport As String
1538:   strReport = "Function failed..."
  
1540:   CreateDiversityRaster = strReport
  
  Dim pInputBand As IRasterBand
  Dim pRastLayer As IRasterLayer
  Dim pGeoDataset As IGeoDataset
  Dim pInputDataset As IRasterDataset
  Dim pInputRaster As IRaster2
  Dim pEnv As IEnvelope
  Dim strSaveFormat As String
  Dim lngNbrHoodRadius As Long
  Dim strNewRasterName As String
  Dim booIsFGB As Boolean
  Dim pRastWS As IRasterWorkspace2
  Dim pRastWsEx As IRasterWorkspaceEx
  Dim strSaveFormatString As String
  Dim pWS As IWorkspace
  Dim strExtension As String
  Dim strInputName As String
  Dim booExcludeIfAnyNull As Boolean
1559:   booExcludeIfAnyNull = False
  
'  MsgBox "pParams.Count = " & CStr(pParams.Count)
'  MsgBox "VarType(pParams.Element(0)) = " & CStr(VarType(pParams.Element(0)))
'  MsgBox "TypeOf pParams.Element(0) Is ILayer = " & CStr(TypeOf pParams.Element(0) Is ILayer)
'  MsgBox "TypeOf pParams.Element(0) Is IRasterLayer = " & CStr(TypeOf pParams.Element(0) Is IRasterLayer)
  
1566:   Set pInputBand = pParams.Element(0)
1567:   Set pGeoDataset = pInputBand
1568:   Set pEnv = pGeoDataset.Extent
  
1570:   lngNbrHoodRadius = pParams.Element(1)
1571:   strSaveFormat = pParams.Element(2)
1572:   strSaveFormatString = pParams.Element(3)
1573:   strNewRasterName = pParams.Element(4)
1574:   booIsFGB = pParams.Element(5)
1575:   Set pWS = pParams.Element(6)
1576:   If booIsFGB Then
1577:     Set pRastWsEx = pWS
1578:   Else
1579:     Set pRastWS = pWS
1580:   End If
1581:   strExtension = pParams.Element(7)
1582:   strInputName = pParams.Element(8)
1583:   booExcludeIfAnyNull = pParams.Element(9)
  
  Dim pRastDataset As IRasterDataset3
  
  Dim pSaveAs As ISaveAs2
  Dim pRasterProp As IRasterProps
  Dim pRasLy As IRasterLayer
'  Dim pRaster As IRaster2
  Dim pRastStDef As IRasterStorageDef2
  Dim pRastProps As IRasterProps
  
  ' GET VALUE TO SERVE AS WITHIN-RASTER BOUNDARY NON-VALUE
'  Dim strNonVal As String
'  strNonVal = "skip"
  
  '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  '/////////// |                  | \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
  '----------  |   CALCULATIONS   |  ---------------------------------------------------------------------------
  '\\\\\\\\\\\ |                  | ///////////////////////////////////////////////////////////////////////////
  '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

  Dim pPro As IStepProgressor
  Dim psbar As IStatusBar
  
  Dim pTempBandColl As IRasterBandCollection
1608:   Set pTempBandColl = New Raster
1609:   pTempBandColl.AppendBand pInputBand
1610:   Set pInputRaster = pTempBandColl
1611:   Set pRastProps = pInputRaster
'  pRastProps.SpatialReference = pGeoDataset.SpatialReference
  
1614:   Set psbar = pApp.StatusBar
1615:   Set pPro = psbar.ProgressBar
  
  Dim lngHeight As Long
  Dim lngWidth As Long
'  Dim dblCellSize As Double
  Dim dblNoData As Double
  Dim varNoData As Variant
  
'  dblCellSize = (pRastProps.MeanCellSize.X + pRastProps.MeanCellSize.Y) / 2
1624:   lngWidth = pRastProps.Width
1625:   lngHeight = pRastProps.Height
1626:   varNoData = pRastProps.NoDataValue
 ' dblNoData = CDbl(varNoData)
  
'  If lngWidth < 3 Or lngHeight < 3 Then
'    MsgBox "Invalid Raster:  Size must be greater than 3 x 3 cells..." & vbCrLf & "Exiting Function..."
'    CalcSurfaceArea = "Invalid Raster:  Size must be greater than 3 x 3 cells..." & vbCrLf & "Function cancelled..."
'    Exit Function
'  End If
  
  ' PROGRESS STUFF
1636:   pPro.position = 0
1637:   psbar.ShowProgressBar "Calculating Shannon's Index...", 1, lngHeight, 1, True
1638:   pPro.Message = "Calculating Shannon's Index..."

  Dim pPnt As IPnt
1641:   Set pPnt = New Pnt
1642:   pPnt.SetCoords lngWidth, 1

  Dim pPixBlock As IPixelBlock3

  Dim pTopLeft As IPnt

  Dim lngIndex As Long
  Dim lngIndex2 As Long
  Dim lngIndex3 As Long
  Dim varNoDataArray As Variant
  Dim booHasData() As Boolean
'  Dim booHasData2() As Boolean
'  Dim booHasData3() As Boolean
  Dim varData As Variant
  Dim varEmptyData() As Variant
  ReDim varEmptyData(lngWidth - 1)
'  Dim varData2 As Variant
'  Dim varData3 As Variant


  ' MAKE MASK ARRAY
  Dim booMaskArray() As Boolean
  Dim booCheck As Boolean
  Dim lngTotalCount As Long
  ReDim booMaskArray((lngNbrHoodRadius * 2), (lngNbrHoodRadius * 2))
1667:   For lngIndex = 0 To (lngNbrHoodRadius * 2)
1668:     For lngIndex2 = 0 To (lngNbrHoodRadius * 2)
1669:        booCheck = Sqr(((lngNbrHoodRadius - lngIndex) ^ 2) + ((lngNbrHoodRadius - lngIndex2) ^ 2)) <= lngNbrHoodRadius
1670:        booMaskArray(lngIndex, lngIndex2) = booCheck
1671:        If booCheck Then lngTotalCount = lngTotalCount + 1
1672:     Next lngIndex2
1673:   Next lngIndex
  
  ' FOR DEBUGGING
'  Dim strDebugReport As String
'  strDebugReport = ""
'  For lngIndex = 0 To (lngNbrHoodRadius * 2)
'    For lngIndex2 = 0 To (lngNbrHoodRadius * 2)
'      strDebugReport = strDebugReport & Left(UCase(CStr(booMaskArray(lngIndex, lngIndex2))), 1) & "  "
'    Next lngIndex2
'    strDebugReport = strDebugReport & vbCrLf
'  Next lngIndex

  Dim varCalcDataArray() As Variant
  ReDim varCalcDataArray((lngNbrHoodRadius * 2), (lngNbrHoodRadius * 2))
  Dim booCalcHasDataArray() As Boolean
  ReDim booCalcHasDataArray((lngNbrHoodRadius * 2), (lngNbrHoodRadius * 2))
  Dim lngDataIndexX As Long
  Dim lngDataIndexY As Long
  
  Dim dblShannon As Double
  Dim booShannonIsNull As Boolean
  
      ' OPTION 5, BACK TO RASTER CURSOR, 3 MINUTES 45 SECONDS FOR TEST
    
  ' CREATE RASTERS TO WRITE TO -----------------------------------------------------------------------------------
  ' Create the dataset
  Dim pOutDS As IRasterDataset2
  Dim pOutRasterEdit As IRasterEdit

  Dim pRasterStorDef As IRasterStorageDef2
  Dim pRasterDef As IRasterDef
  Dim pGeomDef As IGeometryDef
  
  Dim pOriginPoint As IPoint
1707:   Set pOriginPoint = New Point
1708:   pOriginPoint.PutCoords pRastProps.Extent.XMin, pRastProps.Extent.YMin
  
  Dim pOutPnt As IPnt
1711:   Set pOutPnt = New Pnt
  Dim lngFocalRow As Long
  
  Dim pSpRef As ISpatialReference
1715:   Set pSpRef = pRastProps.SpatialReference
      
  ' IRasterStorageDef
1718:   Set pRasterStorDef = New RasterStorageDef
1719:   Set pRasterStorDef.CellSize = pRastProps.MeanCellSize
1720:   pRasterStorDef.CompressionType = esriRasterSdeCompressionTypeRunLength
1721:   pRasterStorDef.PyramidLevel = 2
1722:   pRasterStorDef.PyramidResampleType = RSP_BilinearInterpolation
1723:   pRasterStorDef.TileHeight = 128
1724:   pRasterStorDef.TileWidth = 128

  ' IRasterDef
1727:   Set pRasterDef = New RasterDef
1728:   Set pRasterDef.SpatialReference = pSpRef
1729:   pRasterDef.Description = "rasterdataset"

  ' IGeometryDef
1732:   Set pGeomDef = Nothing
  
  Dim pOutProps As IRasterProps
  Dim pOutBandColl As IRasterBandCollection
  Dim pTempOutBandColl As IRasterBandCollection
  Dim pOutBand As IRasterBand
  Dim pRastDatasetEdit As IRasterDatasetEdit2
  Dim pTempOutRaster As IRaster
  
1741:   Set pRasterStorDef.CellSize = pRastProps.MeanCellSize
1742:   If booIsFGB Then
1743:     Set pOutDS = pRastWsEx.CreateRasterDataset(strNewRasterName, 1, PT_FLOAT, pRasterStorDef, _
        "DEFAULTS", pRasterDef, pGeomDef)
1745:     Set pTempOutBandColl = pOutDS
1746:     Set pTempOutRaster = New Raster
1747:     Set pOutBandColl = pTempOutRaster
1748:     pOutBandColl.AppendBands pTempOutBandColl
1749:     pTempOutRaster.ResampleMethod = RSP_BilinearInterpolation
    
1751:     Set pOutProps = pTempOutRaster
1752:     pOutProps.Extent = pRastProps.Extent
1753:     pOutProps.Height = pRastProps.Height
1754:     pOutProps.Width = pRastProps.Width
1755:     pOutProps.SpatialReference = pSpRef
1756:     pOutProps.PixelType = PT_FLOAT
1757:   Else
1758:     Set pOutDS = pRastWS.CreateRasterDataset(strNewRasterName & strExtension, strSaveFormat, pOriginPoint, lngWidth, lngHeight, _
        pRastProps.MeanCellSize.X, pRastProps.MeanCellSize.Y, 1, PT_FLOAT, pSpRef, True)
1760:   End If
  
  Dim pOutputPixBlock As IPixelBlock3
  
  ' OUTPUT VARIABLES
  Dim pOutputRaster As IRaster2
  Dim pOutputRaster2 As IRaster
  Dim pPixelData As Variant
  Dim pRawPixel As IRawPixels
  Dim pOutPixelBlock As IPixelBlock3
  Dim pBands As IRasterBandCollection
  Dim pOutputRastProps As IRasterProps
  Dim pCache As Variant

  ' QI for IRawPixels and IRasterProps
1775:   Set pOutputRaster = pOutDS.CreateFullRaster
1776:   Set pOutputRaster2 = pOutputRaster
1777:   Set pOutRasterEdit = pOutputRaster
1778:   Set pBands = pOutDS
1779:   Set pRawPixel = pBands.Item(0)
1780:   Set pOutputRastProps = pRawPixel
1781:   If Not booIsFGB Then
1782:     pOutputRastProps.NoDataValue = CInt(-9999)
1783:   End If
'  Set pOutPixelBlock = pRawPixel.CreatePixelBlock(pPnt)
1785:   Set pOutputPixBlock = pOutputRaster2.CreatePixelBlock(pPnt)
1786:   pOutputPixBlock.PixelType(0) = PT_FLOAT
  Dim varOutData As Variant

  
  
  
  
  
  
  
  ' ----------------------------
  Dim varNbrHeightArray() As Variant
  ReDim varNbrHeightArray(lngWidth - 1, (lngNbrHoodRadius * 2))
  Dim booNbrHeightHasDataArray() As Boolean
  ReDim booNbrHeightHasDataArray(lngWidth - 1, (lngNbrHoodRadius * 2))
  
'  ' INITALLY FILL varNbrHeightArray WITH STRING VALUES TO INDICATE OUT-OF-RASTER
'  For lngIndex = 0 To UBound(varNbrHeightArray, 1)
'    For lngIndex2 = 0 To UBound(varNbrHeightArray, 2)
'      varNbrHeightArray(lngIndex, lngIndex2) = ""
'    Next lngIndex
'  Next lngIndex
  
  Dim lngPixBlockWidth As Long
  Dim lngPixBlockHeight As Long
  Dim lngLastColumn As Long
1812:   lngPixBlockWidth = lngWidth - 1 - lngNbrHoodRadius
1813:   lngPixBlockHeight = (lngNbrHoodRadius * 2)
1814:   lngLastColumn = (lngNbrHoodRadius * 2)

  ' ADD FIRST LINE OF DATA
  Dim pRastCursor As IRasterCursor
1818:   Set pRastCursor = pInputRaster.CreateCursorEx(pPnt)

1820:   Set pPixBlock = pRastCursor.PixelBlock
1821:   pPixBlock.PixelType(0) = PT_FLOAT
1822:   pRastCursor.Reset
1823:   Set pPixBlock = pRastCursor.PixelBlock
1824:   varData = pPixBlock.PixelData(0)
1825:   booHasData = ConvertNoDataMaskToSomethingUseful(pPixBlock.NoDataMask(0))
'
'  ' BELOW IS WORKAROUND FOR PROBLEM IN WHICH PIXEL BLOCK APPEARS TO NOT BE ABLE TO CORRECTLY READ FIRST ROW.
'  ' I THINK THIS HAS SOMETHING TO DO WITH SETTING THE PIXEL TYPE TO PT_FLOAT.  IT READS IT CORRECTLY AFTER
'  ' THAT POINT, BUT I CANNOT SET IT BEFORE READING THE FIRST ROW FROM RASTER CURSOR, EVEN AFTER USING 'RESET'.
'  ' CODE BELOW SIMPLY EXTRACTS varData1 and booHasData1 FROM A DIFFERENT PIXEL BLOCK THAT IS READ CORRECTLY.
  Dim pTempPixBlock As IPixelBlock3
  Dim pTempRaster As IRaster
1833:   Set pTempRaster = pInputRaster
  Dim pTempPoint As IPnt
1835:   Set pTempPoint = New Pnt
1836:   pTempPoint.SetCoords CInt(lngWidth), 1
1837:   Set pTempPixBlock = pTempRaster.CreatePixelBlock(pTempPoint)
1838:   pTempPixBlock.PixelType(0) = PT_FLOAT
  Dim pTempOrigin As IPnt
1840:   Set pTempOrigin = New Pnt

  Dim lngRowCounter As Long
1843:   lngRowCounter = -1
  Dim varVal As Variant
'  Dim dblVal As Double

1847:   pTempOrigin.SetCoords 0, 0
1848:   pTempRaster.Read pTempOrigin, pTempPixBlock
1849:   varData = pTempPixBlock.PixelDataByRef(0)
1850:   booHasData = ConvertNoDataMaskToSomethingUseful(pTempPixBlock.NoDataMaskByRef(0))

  ' FROM HERE ON OUT, RASTER CURSOR SEEMS TO WORK
 ' MsgBox "UBound(varNbrHeightArray, 1) = " & CStr(UBound(varNbrHeightArray, 1)) & vbCrLf & _
         "UBound(varNbrHeightArray, 2) = " & CStr(UBound(varNbrHeightArray, 2)) & vbCrLf & _
         "UBound(booNbrHeightHasDataArray, 1) = " & CStr(UBound(booNbrHeightHasDataArray, 1)) & vbCrLf & _
         "UBound(booNbrHeightHasDataArray, 2) = " & CStr(UBound(booNbrHeightHasDataArray, 2)) & vbCrLf & _
         "UBound(varData, 1) = " & CStr(UBound(varData, 1)) & vbCrLf & _
         "UBound(varData, 2) = " & CStr(UBound(varData, 2)) & vbCrLf & _
         "lngWidth = " & CStr(lngWidth) & vbCrLf & _
         "lngNbrHoodRadius = " & CStr(lngNbrHoodRadius)
'
'  MsgBox "IsNull(varData(0)) = " & CStr(IsNull(varData(0)))
'  MsgBox "IsNull(varNbrHeightArray(0,6)) = " & CStr((varNbrHeightArray(0, 6)))

  ' ADD LINE OF DATA TO [CENTRAL ROW + 1] OF varNbrHeightArray AND booNbrHeightHasDataArray
1866:   For lngIndex = 0 To UBound(varNbrHeightArray, 1)
1867:     varNbrHeightArray(lngIndex, lngNbrHoodRadius + 1) = varData(lngIndex, 0)
1868:     booNbrHeightHasDataArray(lngIndex, lngNbrHoodRadius + 1) = booHasData(lngIndex)
1869:   Next lngIndex

  ' ADD REST OF ROWS TO FILL OUT NEIGHBORHOOD HEIGHT
1872:   If lngNbrHoodRadius > 1 Then
1873:     For lngIndex = 2 To lngNbrHoodRadius
1874:       pRastCursor.Next
1875:       pPro.Step
1876:       DoEvents
1877:       Set pPixBlock = pRastCursor.PixelBlock
1878:       pPixBlock.PixelType(0) = PT_FLOAT
1879:       varData = pPixBlock.PixelDataByRef(0)
1880:       booHasData = ConvertNoDataMaskToSomethingUseful(pPixBlock.NoDataMaskByRef(0))
1881:       For lngIndex2 = 0 To UBound(varNbrHeightArray, 1)
1882:         varNbrHeightArray(lngIndex2, lngNbrHoodRadius + lngIndex) = varData(lngIndex, 0)
1883:         booNbrHeightHasDataArray(lngIndex2, lngNbrHoodRadius + lngIndex) = booHasData(lngIndex)
1884:       Next lngIndex2
1885:     Next lngIndex
1886:   End If

  ' READY TO START DOING AN ANALYSIS
  ' REMEMBER THAT ALWAYS WORKING lngNbrHoodRadius ROWS BEHIND THE CURRENT RASTER CURSOR POSITION

    ' WORK THROUGH REST OF RASTER
  Dim lngSliceRowIndex As Long
  Dim lngSliceColIndex As Long
  Dim lngColIndex As Long
  Dim lngColumnToTest As Long
  Dim lngLastRowIndex As Long
1897:   lngLastRowIndex = lngNbrHoodRadius * 2
  Dim lngLastColIndex As Long
1899:   lngLastColIndex = lngNbrHoodRadius * 2

'  MsgBox "pDataLinesArray has " & CStr(pDataLinesArray.Count) & " elements..." & vbCrLf & _
'        "pBooHasDataArray has " & CStr(pBooHasDataArray.Count) & " elements..."

  Dim lngRowOfDataCounter As Long
1905:   lngRowOfDataCounter = lngNbrHoodRadius

  ' IF lngRowOfDataCounter ACTUALLY IS lngHeight, THEN IT IS ONE ROW TOO FAR.
  
  
'  First column of Shannon3 is all 0 values.  Don't see similar behavior on other edges.
  
1912:   lngFocalRow = -1
1913:   Do Until lngRowOfDataCounter = lngHeight - 1
    
1915:     lngFocalRow = lngFocalRow + 1
    
    ' ADD NEW ROWS TO BOTTOM OF SLICE, AND DELETE TOP ROWS
1918:     lngRowOfDataCounter = lngRowOfDataCounter + 1
1919:     pRastCursor.Next
1920:     pPro.Step
1921:     DoEvents
1922:     Set pPixBlock = pRastCursor.PixelBlock
1923:     pPixBlock.PixelType(0) = PT_FLOAT

    ' SHIFT ALL ROWS UP BY ONE
1926:     For lngDataIndexX = 0 To UBound(varNbrHeightArray, 1)
1927:       For lngDataIndexY = 1 To lngLastRowIndex
1928:         varNbrHeightArray(lngDataIndexX, lngDataIndexY - 1) = varNbrHeightArray(lngDataIndexX, lngDataIndexY)
1929:         booNbrHeightHasDataArray(lngDataIndexX, lngDataIndexY - 1) = booNbrHeightHasDataArray(lngDataIndexX, lngDataIndexY)
1930:       Next lngDataIndexY
1931:     Next lngDataIndexX

    ' RESET LOWEST ROW TO NEW VALUES
1934:     varData = pPixBlock.PixelDataByRef(0)
1935:     booHasData = ConvertNoDataMaskToSomethingUseful(pPixBlock.NoDataMaskByRef(0))
1936:     For lngIndex2 = 0 To UBound(varNbrHeightArray, 1)
1937:       varNbrHeightArray(lngIndex2, lngLastRowIndex) = varData(lngIndex2, 0)
1938:       booNbrHeightHasDataArray(lngIndex2, lngLastRowIndex) = booHasData(lngIndex2)
1939:     Next lngIndex2

    ' ANALYZE THIS SLICE OF RASTER
    ' START WITH ARRAY FULL OF STRING VALUES TO INDICATE OUT-OF-RASTER
1943:     For lngDataIndexX = 0 To UBound(varCalcDataArray, 1)
1944:       For lngDataIndexY = 0 To UBound(varCalcDataArray, 2)
1945:         varCalcDataArray(lngDataIndexX, lngDataIndexY) = Null
1946:         booCalcHasDataArray(lngDataIndexX, lngDataIndexY) = False
1947:       Next lngDataIndexY
1948:     Next lngDataIndexX

    ' WRITE ROW
1951:     pOutPnt.SetCoords 0, lngFocalRow
    'pRawPixel.Read pOutPnt, pOutPixelBlock
1953:     pOutputRaster2.Read pOutPnt, pOutputPixBlock
1954:     varOutData = pOutputPixBlock.PixelData(0)
'    pOutPixelBlock.PixelType(0) = PT_FLOAT
'    pPixelData = pOutPixelBlock.PixelDataByRef(0)
     
    ' START AT NEG RADIUS SO CAN FILL UP HALF OF ARRAY BEFORE CALCULATING
1959:     For lngIndex2 = -lngNbrHoodRadius To (lngWidth - 1)

      ' SHIFT VALUES IN DATA ARRAY ONE STEP TO LEFT
1962:       For lngDataIndexX = 1 To (lngNbrHoodRadius * 2)
1963:         For lngDataIndexY = 0 To (lngNbrHoodRadius * 2)
1964:           varCalcDataArray(lngDataIndexX - 1, lngDataIndexY) = varCalcDataArray(lngDataIndexX, lngDataIndexY)
1965:           booCalcHasDataArray(lngDataIndexX - 1, lngDataIndexY) = booCalcHasDataArray(lngDataIndexX, lngDataIndexY)
1966:         Next lngDataIndexY
1967:       Next lngDataIndexX

1969:       For lngIndex3 = 0 To lngLastRowIndex
1970:         If lngIndex2 <= lngPixBlockWidth Then     ' MEANING IF WE ARE ACTUALLY IN RASTER; NOT FILLING LATER CELLS WITH STRINGS
'            varVal = varData(lngIndex2 + lngNbrHoodRadius, lngIndex3)
1972:           varCalcDataArray(lngLastColIndex, lngIndex3) = varNbrHeightArray(lngIndex2 + lngNbrHoodRadius, lngIndex3)
1973:           booCalcHasDataArray(lngLastColIndex, lngIndex3) = booNbrHeightHasDataArray(lngIndex2 + lngNbrHoodRadius, lngIndex3)
1974:         Else
1975:           varCalcDataArray(lngLastColIndex, lngIndex3) = Null
1976:           booCalcHasDataArray(lngLastColIndex, lngIndex3) = False
1977:         End If
1978:       Next lngIndex3

1980:       If lngIndex2 >= 0 Then                        ' MEANING IF WE ARE ACTUALLY IN RASTER; NOT FILLING EARLIER CELLS WITH STRINGS
        ' CALCULATE SHANNON'S DIVERSITY INDEX VALUE
1982:         dblShannon = CalcShannonFromArray2(varCalcDataArray, booMaskArray, booCalcHasDataArray, _
                  booShannonIsNull, booExcludeIfAnyNull)
1984:         If booShannonIsNull Then
1985:           If Not booIsFGB Then
'            pPixelData(lngIndex2, 0) = CInt(-9999)
1987:             varOutData(lngIndex2, 0) = CInt(-9999)
1988:           End If
1989:         Else
'          pPixelData(lngIndex2, 0) = dblShannon
1991:           varOutData(lngIndex2, 0) = dblShannon
1992:         End If
1993:       End If
1994:     Next lngIndex2
    
    ' SAVE DATA TO HARD DRIVE
1997:     pOutputPixBlock.PixelData(0) = varOutData
1998:     pOutRasterEdit.Write pOutPnt, pOutputPixBlock
1999:     If lngRowOfDataCounter Mod 10 = 0 Then
2000:       pOutRasterEdit.Refresh
2001:     End If
'    pOutPixelBlock.PixelData(0) = pPixelData
'    Set pCache = pRawPixel.AcquireCache
'    pRawPixel.Write pOutPnt, pOutPixelBlock
'    pRawPixel.ReturnCache pCache
    
2007:   Loop
2008:   pOutRasterEdit.Refresh

  ' CONTINUE UNTIL FINISHED WITH NEIGHBORHOOD RADIUS
2011:   For lngIndex = 0 To lngNbrHoodRadius
2012:     lngFocalRow = lngFocalRow + 1
    
    ' SHIFT ALL ROWS UP BY ONE
2015:     For lngDataIndexX = 0 To UBound(varNbrHeightArray, 1)
2016:       For lngDataIndexY = 1 To lngLastRowIndex
2017:         varNbrHeightArray(lngDataIndexX, lngDataIndexY - 1) = varNbrHeightArray(lngDataIndexX, lngDataIndexY)
2018:         booNbrHeightHasDataArray(lngDataIndexX, lngDataIndexY - 1) = booNbrHeightHasDataArray(lngDataIndexX, lngDataIndexY)
2019:       Next lngDataIndexY
      ' SET LOWEST ROW TO NO DATA
2021:       booNbrHeightHasDataArray(lngDataIndexX, lngLastRowIndex) = False
2022:     Next lngDataIndexX

    ' ANALYZE THIS SLICE OF RASTER
    ' START WITH ARRAY FULL OF NULL VALUES
2026:     For lngDataIndexX = 0 To UBound(varCalcDataArray, 1)
2027:       For lngDataIndexY = 0 To UBound(varCalcDataArray, 2)
2028:         varCalcDataArray(lngDataIndexX, lngDataIndexY) = Null
2029:         booCalcHasDataArray(lngDataIndexX, lngDataIndexY) = False
2030:       Next lngDataIndexY
2031:     Next lngDataIndexX

'    ' WRITE ROW
'    pOutPnt.SetCoords 0, lngFocalRow
'    pRawPixel.Read pOutPnt, pOutPixelBlock
'
'    pOutPixelBlock.PixelType(0) = PT_FLOAT
'    pPixelData = pOutPixelBlock.PixelDataByRef(0)
    
    ' WRITE ROW
2041:     pOutPnt.SetCoords 0, lngFocalRow
2042:     pOutputRaster2.Read pOutPnt, pOutputPixBlock
2043:     varOutData = pOutputPixBlock.PixelData(0)

    ' START AT NEG RADIUS SO CAN FILL UP HALF OF ARRAY BEFORE CALCULATING
2046:     For lngIndex2 = -lngNbrHoodRadius To (lngWidth - 1)

      ' SHIFT VALUES IN DATA ARRAY ONE STEP TO LEFT
2049:       For lngDataIndexX = 1 To (lngNbrHoodRadius * 2)
2050:         For lngDataIndexY = 0 To (lngNbrHoodRadius * 2)
2051:           varCalcDataArray(lngDataIndexX - 1, lngDataIndexY) = varCalcDataArray(lngDataIndexX, lngDataIndexY)
2052:           booCalcHasDataArray(lngDataIndexX - 1, lngDataIndexY) = booCalcHasDataArray(lngDataIndexX, lngDataIndexY)
2053:         Next lngDataIndexY
2054:       Next lngDataIndexX

2056:       If lngIndex2 >= 0 Then                        ' MEANING IF WE ARE ACTUALLY IN RASTER; NOT FILLING EARLIER CELLS WITH NULLS
2057:         For lngIndex3 = 0 To lngLastRowIndex
2058:           If lngIndex2 <= lngPixBlockWidth Then     ' MEANING IF WE ARE ACTUALLY IN RASTER; NOT FILLING LATER CELLS WITH NULLS
'            varVal = varData(lngIndex2 + lngNbrHoodRadius, lngIndex3)
2060:             varCalcDataArray(lngLastColIndex, lngIndex3) = varNbrHeightArray(lngIndex2 + lngNbrHoodRadius, lngIndex3)
2061:             booCalcHasDataArray(lngLastColIndex, lngIndex3) = booNbrHeightHasDataArray(lngIndex2 + lngNbrHoodRadius, lngIndex3)
2062:           Else
2063:             varCalcDataArray(lngLastColIndex, lngIndex3) = Null
2064:             booCalcHasDataArray(lngLastColIndex, lngIndex3) = False
2065:           End If
2066:         Next lngIndex3

        ' CALCULATE SHANNON'S DIVERSITY INDEX VALUE
2069:         dblShannon = CalcShannonFromArray2(varCalcDataArray, booMaskArray, booCalcHasDataArray, _
                  booShannonIsNull, booExcludeIfAnyNull)
2071:         If booShannonIsNull Then
2072:           If Not booIsFGB Then
'            pPixelData(lngIndex2, 0) = CInt(-9999)
2074:             varOutData(lngIndex2, 0) = CInt(-9999)
2075:           End If
2076:         Else
'          pPixelData(lngIndex2, 0) = dblShannon
2078:           varOutData(lngIndex2, 0) = dblShannon
2079:         End If
2080:       End If
2081:     Next lngIndex2
    
    ' SAVE DATA TO HARD DRIVE
2084:     pOutputPixBlock.PixelData(0) = varOutData
2085:     pOutRasterEdit.Write pOutPnt, pOutputPixBlock
2086:     pOutRasterEdit.Refresh
'    pOutPixelBlock.PixelData(0) = pPixelData
'    Set pCache = pRawPixel.AcquireCache
'    pRawPixel.Write pOutPnt, pOutPixelBlock
'    pRawPixel.ReturnCache pCache

2092:   Next lngIndex

   
'  ----------------------------
  Dim pNewLayer As IRasterLayer

  Dim pStatsBandColl As IRasterBandCollection
  Dim pStatsBand As IRasterBand
2100:   Set pStatsBandColl = pOutDS
2101:   Set pStatsBand = pStatsBandColl.Item(0)
  
'   pStatsBand.ComputeStatsAndHist
2104:   psbar.Message(0) = "Calculating Raster Statistics..."
2105:   DoEvents
  Dim pRasterStats As IRasterStatistics
2107:   Set pRasterStats = pStatsBand.Statistics
2108:   pRasterStats.Recalculate
  
 
2111:   Set pInputBand = Nothing
2112:   Set pRastLayer = Nothing
2113:   Set pGeoDataset = Nothing
2114:   Set pInputDataset = Nothing
2115:   Set pInputRaster = Nothing
2116:   Set pEnv = Nothing
2117:   Set pRastDataset = Nothing
2118:   Set pSaveAs = Nothing
2119:   Set pRasterProp = Nothing
2120:   Set pRasLy = Nothing
2121:   Set pRastStDef = Nothing
2122:   Set pRastProps = Nothing
2123:   Set pTempBandColl = Nothing
2124:   Set pPnt = Nothing
2125:   Set pPixBlock = Nothing
2126:   Set pTopLeft = Nothing
2127:   Set pOutDS = Nothing
2128:   Set pOutRasterEdit = Nothing
2129:   Set pRasterStorDef = Nothing
2130:   Set pRasterDef = Nothing
2131:   Set pGeomDef = Nothing
2132:   Set pOriginPoint = Nothing
2133:   Set pOutPnt = Nothing
2134:   Set pSpRef = Nothing
2135:   Set pOutProps = Nothing
2136:   Set pOutBandColl = Nothing
2137:   Set pTempOutBandColl = Nothing
2138:   Set pOutBand = Nothing
2139:   Set pRastDatasetEdit = Nothing
2140:   Set pTempOutRaster = Nothing
2141:   Set pOutputPixBlock = Nothing
2142:   Set pOutputRaster = Nothing
2143:   Set pOutputRaster2 = Nothing
2144:   Set pRawPixel = Nothing
2145:   Set pOutPixelBlock = Nothing
2146:   Set pBands = Nothing
2147:   Set pOutputRastProps = Nothing
2148:   Set pRastCursor = Nothing
2149:   Set pTempPixBlock = Nothing
2150:   Set pTempRaster = Nothing
2151:   Set pTempPoint = Nothing
2152:   Set pTempOrigin = Nothing
2153:   Set pNewLayer = Nothing
2154:   Set pStatsBandColl = Nothing
2155:   Set pStatsBand = Nothing
2156:   Set pRasterStats = Nothing


 

  Dim pNewDS As IRasterDataset
2162:   Set pNewDS = pRastWS.OpenRasterDataset(strNewRasterName & strExtension)
  
  ' ADD RASTER TO MAP DOCUMENT
2165:   Set pNewLayer = New RasterLayer
'  pNewLayer.CreateFromRaster pMultiplyStep2
2167:   pNewLayer.CreateFromDataset pNewDS
2168:   pNewLayer.Name = strNewRasterName

  ' SYMBOLIZE RASTER LAYER

  ' Create renderer and QI RasterRenderer
  Dim pStretchRen As IRasterStretchColorRampRenderer
2174:   Set pStretchRen = New RasterStretchColorRampRenderer
  Dim pRasRen As IRasterRenderer
2176:   Set pRasRen = pStretchRen
  
  Dim pRasterStretch As IRasterStretch
2179:   Set pRasterStretch = pStretchRen
2180:   pRasterStretch.StretchType = esriRasterStretch_NONE

  ' Set raster for the renderer and update
2183:   Set pRasRen.Raster = pNewLayer.Raster
2184:   pRasRen.Update

  ' COLORS
  Dim pRedColor As IColor
  Dim pYellowColor As IColor
  Dim pGreenColor As IColor

2191:   Set pRedColor = New RgbColor
2192:   Set pYellowColor = New RgbColor
2193:   Set pGreenColor = New RgbColor

2195:   pRedColor.RGB = RGB(190, 0, 0)
2196:   pYellowColor.RGB = RGB(255, 255, 200)
2197:   pGreenColor.RGB = RGB(0, 140, 0)

  ' CREATE COLOR RAMPS
  Dim pRamp1 As IAlgorithmicColorRamp
2201:   Set pRamp1 = New AlgorithmicColorRamp
2202:   pRamp1.Algorithm = esriLabLChAlgorithm
2203:   pRamp1.Size = 130
2204:   pRamp1.FromColor = pGreenColor
2205:   pRamp1.ToColor = pYellowColor
2206:   pRamp1.CreateRamp True

  Dim pRamp2 As IAlgorithmicColorRamp
2209:   Set pRamp2 = New AlgorithmicColorRamp
2210:   pRamp2.Algorithm = esriLabLChAlgorithm
2211:   pRamp2.Size = 130
2212:   pRamp2.FromColor = pYellowColor
2213:   pRamp2.ToColor = pRedColor
2214:   pRamp2.CreateRamp True

  Dim pMultiRamp As IMultiPartColorRamp
2217:   Set pMultiRamp = New MultiPartColorRamp
2218:   pMultiRamp.Ramp(0) = pRamp1
2219:   pMultiRamp.Ramp(1) = pRamp2
2220:   pMultiRamp.Size = 260
2221:   pMultiRamp.CreateRamp True

  ' Plug this colorramp into renderer and select a band
2224:   pStretchRen.BandIndex = 0
2225:   pStretchRen.ColorRamp = pMultiRamp

  ' Update the renderer with new settings and plug into layer
2228:   pRasRen.Update
2229:   Set pNewLayer.Renderer = pStretchRen

2231:   pMxDoc.AddLayer pNewLayer
'-----------------------------------
  
  
2235:   pPro.position = 0
2236:   psbar.HideProgressBar
  
  
  ' ONLY SHOW OUTPUT REPORT IF DIVERSITY RASTER IS CREATED
  
2241:   strReport = ""
'  Dim booHasStats As Boolean
'  Set pBandColl = pOutputDataset
'  For lngIndex = 0 To pBandColl.Count - 1
'    Set pBand = pBandColl.Item(lngIndex)
'    pBand.HasStatistics booHasStats
'    If Not booHasStats Then
'      pBand.ComputeStatsAndHist
'    End If
'  Next lngIndex
'
'  Set pLayer = New RasterLayer
'  pLayer.CreateFromDataset pOutputDataset
'  pLayer.Name = strNewRasterName
'  pLayer.Visible = True
'  pMxDoc.AddLayer pLayer

2258:   strReport = "Shannon's Index Function Complete:" & vbCrLf & _
              "----------------------------------------------------------" & vbCrLf & _
              "Analysis Parameters:" & vbCrLf & _
              " --> Input Raster Layer: " & strInputName & vbCrLf & _
              " --> Output Format: " & strSaveFormatString & vbCrLf & _
              " --> Circular Neighborhood Radius: " & CStr(lngNbrHoodRadius) & " cells..." & vbCrLf & _
              " --> Filename: " & strNewRasterName & strExtension & vbCrLf & _
              " --> Workspace = " & pWS.PathName & vbCrLf & _
              "----------------------------------------------------------" & vbCrLf & _
              TopoCorridor.MyGeneralOperations.ReturnTimeElapsed(datBegan, Now)
  
2269:   pMxDoc.UpdateContents
2270:   pMxDoc.ActiveView.PartialRefresh esriViewGeography, Nothing, pEnv
  
2272:   CreateDiversityRaster = strReport
  
  
  
  
  
  
  
  
    

2283:   GoTo CleanUp
ErrorHandler:
  HandleError True, "CreateDiversityRaster " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4

CleanUp:



2291:   Set pApp = Nothing
2292:   Set pMxDoc = Nothing
2293:   Set pThisExt = Nothing
2294:   Set pInputBand = Nothing
2295:   Set pRastLayer = Nothing
2296:   Set pGeoDataset = Nothing
2297:   Set pInputDataset = Nothing
2298:   Set pInputRaster = Nothing
2299:   Set pEnv = Nothing
2300:   Set pRastWS = Nothing
2301:   Set pRastWsEx = Nothing
2302:   Set pWS = Nothing
2303:   Set pRastDataset = Nothing
2304:   Set pSaveAs = Nothing
2305:   Set pRasterProp = Nothing
2306:   Set pRasLy = Nothing
2307:   Set pRastStDef = Nothing
2308:   Set pRastProps = Nothing
2309:   Set pPro = Nothing
2310:   Set psbar = Nothing
2311:   Set pTempBandColl = Nothing
2312:   Set pPnt = Nothing
2313:   Set pPixBlock = Nothing
2314:   Set pTopLeft = Nothing
2315:   Set pOutDS = Nothing
2316:   Set pOutRasterEdit = Nothing
2317:   Set pRasterStorDef = Nothing
2318:   Set pRasterDef = Nothing
2319:   Set pGeomDef = Nothing
2320:   Set pOriginPoint = Nothing
2321:   Set pOutPnt = Nothing
2322:   Set pSpRef = Nothing
2323:   Set pOutProps = Nothing
2324:   Set pOutBandColl = Nothing
2325:   Set pTempOutBandColl = Nothing
2326:   Set pOutBand = Nothing
2327:   Set pRastDatasetEdit = Nothing
2328:   Set pTempOutRaster = Nothing
2329:   Set pOutputPixBlock = Nothing
2330:   Set pOutputRaster = Nothing
2331:   Set pOutputRaster2 = Nothing
2332:   Set pRawPixel = Nothing
2333:   Set pOutPixelBlock = Nothing
2334:   Set pBands = Nothing
2335:   Set pOutputRastProps = Nothing
2336:   Set pRastCursor = Nothing
2337:   Set pTempPixBlock = Nothing
2338:   Set pTempRaster = Nothing
2339:   Set pTempPoint = Nothing
2340:   Set pTempOrigin = Nothing
2341:   Set pNewLayer = Nothing
2342:   Set pStatsBandColl = Nothing
2343:   Set pStatsBand = Nothing
2344:   Set pRasterStats = Nothing
2345:   Set pNewDS = Nothing
2346:   Set pStretchRen = Nothing
2347:   Set pRasRen = Nothing
2348:   Set pRasterStretch = Nothing
2349:   Set pRedColor = Nothing
2350:   Set pYellowColor = Nothing
2351:   Set pGreenColor = Nothing
2352:   Set pRamp1 = Nothing
2353:   Set pRamp2 = Nothing
2354:   Set pMultiRamp = Nothing
End Function
Public Function ConvertNoDataMaskToSomethingUseful2(varNoData As Variant, _
    Optional boo2Dimensional As Boolean = False, Optional lngUBound_X_Plus_1 As Long = -9999, _
    Optional lngUBound_Y As Long = -9999) As Boolean()
  On Error GoTo ErrorHandler


  Dim lngIndex As Long
  Dim lngIntermediate As Long
  Dim lngX As Long
  
  Dim booReturn() As Boolean
2367:   If boo2Dimensional Then
    ReDim booReturn(lngUBound_X_Plus_1 - 1, lngUBound_Y + 8)
2369:     For lngIndex = 0 To UBound(varNoData)
2370:       lngIntermediate = CLng(varNoData(lngIndex))
2371:       lngX = (lngIndex * 8)
2372:       booReturn(lngX Mod lngUBound_X_Plus_1, Int(lngX / lngUBound_X_Plus_1)) = CBool(lngIntermediate And 128)
2373:       lngX = lngX + 1
2374:       booReturn(lngX Mod lngUBound_X_Plus_1, Int(lngX / lngUBound_X_Plus_1)) = CBool(lngIntermediate And 64)
2375:       lngX = lngX + 1
2376:       booReturn(lngX Mod lngUBound_X_Plus_1, Int(lngX / lngUBound_X_Plus_1)) = CBool(lngIntermediate And 32)
2377:       lngX = lngX + 1
2378:       booReturn(lngX Mod lngUBound_X_Plus_1, Int(lngX / lngUBound_X_Plus_1)) = CBool(lngIntermediate And 16)
2379:       lngX = lngX + 1
2380:       booReturn(lngX Mod lngUBound_X_Plus_1, Int(lngX / lngUBound_X_Plus_1)) = CBool(lngIntermediate And 8)
2381:       lngX = lngX + 1
2382:       booReturn(lngX Mod lngUBound_X_Plus_1, Int(lngX / lngUBound_X_Plus_1)) = CBool(lngIntermediate And 4)
2383:       lngX = lngX + 1
2384:       booReturn(lngX Mod lngUBound_X_Plus_1, Int(lngX / lngUBound_X_Plus_1)) = CBool(lngIntermediate And 2)
2385:       lngX = lngX + 1
2386:       booReturn(lngX Mod lngUBound_X_Plus_1, Int(lngX / lngUBound_X_Plus_1)) = CBool(lngIntermediate And 1)
2387:     Next lngIndex
2388:   Else
    ReDim booReturn(((UBound(varNoData) + 1) * 8) - 1)
2390:     For lngIndex = 0 To UBound(varNoData)
2391:       lngIntermediate = CLng(varNoData(lngIndex))
2392:       booReturn(lngIndex * 8) = CBool(lngIntermediate And 128)
2393:       booReturn((lngIndex * 8) + 1) = CBool(lngIntermediate And 64)
2394:       booReturn((lngIndex * 8) + 2) = CBool(lngIntermediate And 32)
2395:       booReturn((lngIndex * 8) + 3) = CBool(lngIntermediate And 16)
2396:       booReturn((lngIndex * 8) + 4) = CBool(lngIntermediate And 8)
2397:       booReturn((lngIndex * 8) + 5) = CBool(lngIntermediate And 4)
2398:       booReturn((lngIndex * 8) + 6) = CBool(lngIntermediate And 2)
2399:       booReturn((lngIndex * 8) + 7) = CBool(lngIntermediate And 1)
2400:     Next lngIndex
2401:   End If
  
2403:   ConvertNoDataMaskToSomethingUseful2 = booReturn
  
  Exit Function
ErrorHandler:
  HandleError True, "ConvertNoDataMaskToSomethingUseful2 " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4


End Function
Public Function CalcShannonFromArray(varNumArray() As Variant, booMaskArray() As Boolean, varNoData As Variant) As Double
  On Error GoTo ErrorHandler

  Dim pColl As Collection
2415:   Set pColl = New Collection
  
  Dim lngIndex As Long
  Dim lngIndex2 As Long
  Dim pUniqueArray As esriSystem.IStringArray
2420:   Set pUniqueArray = New esriSystem.strArray
  
  Dim dblVal As Long
  Dim strKey As String
  Dim lngCount As Long
  Dim varVal As Variant
  
  Dim lngTotalCount As Long
  
2429:   For lngIndex = 0 To UBound(varNumArray, 1)
2430:     For lngIndex2 = 0 To UBound(varNumArray, 2)
2431:       If booMaskArray(lngIndex, lngIndex2) Then
2432:         varVal = varNumArray(lngIndex, lngIndex2)
2433:         If Not IsNull(varVal) Then ' And (varVal <> varNoData) Then       ' <-- Type Mismatch
2434:           strKey = CStr(varVal)
2435:           lngTotalCount = lngTotalCount + 1
2436:           If MyGeneralOperations.CheckCollectionForKey(pColl, strKey) Then
2437:             lngCount = pColl.Item(strKey) + 1
2438:             pColl.Remove (strKey)
2439:           Else
2440:             lngCount = 1
2441:             pUniqueArray.Add strKey
2442:           End If
2443:           pColl.Add lngCount, strKey
2444:         End If
2445:       End If
2446:     Next lngIndex2
2447:   Next lngIndex
  
'  lngTotalCount = pNumArray.Count
  
  Dim dblPi As Double
  
2453:   CalcShannonFromArray = 0
  
2455:   For lngIndex = 0 To pUniqueArray.Count - 1
2456:     strKey = pUniqueArray.Element(lngIndex)
2457:     dblPi = pColl.Item(strKey) / lngTotalCount
2458:     CalcShannonFromArray = CalcShannonFromArray + (dblPi * Log(dblPi)) ' - dblCorrection
'    dblCalcShannonNoCorr = dblCalcShannonNoCorr + (dblPi * Log(dblPi))
'    Debug.Print "Value [" & strKey & "]:  Count = " & CStr(pColl.Item(strKey)) & ", Pi = " & _
        CStr(Format(dblPi, "0.00")) & ", Pi*log(Pi) = " & CStr(Format((dblPi * Log(dblPi)), "0.000"))
2462:   Next lngIndex
  
2464:   Set pColl = Nothing
2465:   Set pUniqueArray = Nothing
  
  Exit Function
ErrorHandler:
  HandleError True, "CalcShannonFromArray " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Private Function CalcShannonFromArray2(varNumArray() As Variant, booMaskArray() As Boolean, _
    booHasDataArray() As Boolean, booShannonIsNull As Boolean, _
    booReturnNullIfAnyNull As Boolean) As Double
    
  On Error GoTo ErrorHandler

2478:   CalcShannonFromArray2 = 0
  
  Dim varValArray() As Variant
  Dim lngCountArray() As Long
  
  Dim lngIndex As Long
  Dim lngIndex2 As Long

  Dim varVal As Variant
  Dim booIsFirstVal As Boolean
2488:   booIsFirstVal = True
  
  Dim lngTotalCount As Long
2491:   lngTotalCount = 0
  
2493:   booShannonIsNull = True
  
2495:   For lngIndex = 0 To UBound(varNumArray, 1)
2496:     For lngIndex2 = 0 To UBound(varNumArray, 2)
2497:       If booHasDataArray(lngIndex, lngIndex2) Then
2498:         If booMaskArray(lngIndex, lngIndex2) Then
2499:           varVal = varNumArray(lngIndex, lngIndex2)
'          If IsNull(varVal) Then
'          Else
2502:             lngTotalCount = lngTotalCount + 1
2503:             booShannonIsNull = False
2504:             If booIsFirstVal Then
              ReDim varValArray(0)
              ReDim lngCountArray(0)
2507:               varValArray(0) = varVal
2508:               lngCountArray(0) = 1
2509:               booIsFirstVal = False
2510:             Else
2511:               ShannonCounter varValArray, lngCountArray, varVal
2512:             End If
'          End If
2514:         End If
2515:       Else
2516:         If booReturnNullIfAnyNull Then
2517:           booShannonIsNull = True
          Exit Function
2519:         End If
2520:       End If
2521:     Next lngIndex2
2522:   Next lngIndex
    
  Dim dblPi As Double
  
2526:   If booShannonIsNull And Not booReturnNullIfAnyNull Then
2527:     booShannonIsNull = False
2528:     CalcShannonFromArray2 = 0
2529:   Else
    
  '  Debug.Print
2532:     If Not booShannonIsNull Then
2533:       For lngIndex = 0 To UBound(lngCountArray)
2534:         varVal = varValArray(lngIndex)
2535:         dblPi = lngCountArray(lngIndex) / lngTotalCount
2536:         CalcShannonFromArray2 = CalcShannonFromArray2 + (dblPi * Log(dblPi)) ' - dblCorrection
    '    dblCalcShannonNoCorr = dblCalcShannonNoCorr + (dblPi * Log(dblPi))
    '    Debug.Print "Value [" & CStr(varVal) & "]:  Count = " & CStr(lngCountArray(lngIndex)) & ", Pi = " & _
            CStr(Format(dblPi, "0.00")) & ", Pi*log(Pi) = " & CStr(Format((dblPi * Log(dblPi)), "0.000"))
2540:       Next lngIndex
    '  Debug.Print
2542:       CalcShannonFromArray2 = -CalcShannonFromArray2
2543:     End If
2544:   End If
  
  Exit Function
ErrorHandler:
  HandleError False, "CalcShannonFromArray2 " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function
Private Function CalcDensityFromArray(varNumArray() As Variant, booMaskArray() As Boolean, _
    booHasDataArray() As Boolean, booDensityIsNull As Boolean, _
    booReturnNullIfAnyNull As Boolean, dblSearchValues() As Double, lngTotalCount As Long) As Double
    
  On Error GoTo ErrorHandler

2556:   CalcDensityFromArray = 0

  Dim varValArray() As Variant
  Dim lngCountArray() As Long

  Dim lngIndex As Long
  Dim lngIndex2 As Long
  Dim lngIndex3 As Long
  Dim lngUbound As Long
2565:   lngUbound = UBound(dblSearchValues)

  Dim varVal As Variant
  Dim booIsFirstVal As Boolean
2569:   booIsFirstVal = True

  Dim lngSampleTotalCount As Long
  Dim lngValueCount As Long
2573:   lngSampleTotalCount = 0
2574:   lngValueCount = 0
2575:   booDensityIsNull = True

2577:   For lngIndex = 0 To UBound(varNumArray, 1)
2578:     For lngIndex2 = 0 To UBound(varNumArray, 2)
2579:       If booHasDataArray(lngIndex, lngIndex2) Then         ' IF DATA IS NOT NULL BASED ON NODATA MASK
2580:         If booMaskArray(lngIndex, lngIndex2) Then          ' IF DATA IS IN OUR NEIGHBORHOOD RADIUS
2581:           varVal = varNumArray(lngIndex, lngIndex2)

2583:           If Not IsNull(varVal) Then
2584:             lngSampleTotalCount = lngSampleTotalCount + 1
2585:             booDensityIsNull = False

2587:             For lngIndex3 = 0 To lngUbound
2588:               If varVal = dblSearchValues(lngIndex3) Then
2589:                 lngValueCount = lngValueCount + 1
2590:                 Exit For
2591:               End If
2592:             Next lngIndex3
2593:           End If
2594:         End If
2595:       Else
2596:         If booReturnNullIfAnyNull Then
2597:           booDensityIsNull = True
          Exit Function
2599:         End If
2600:       End If
2601:     Next lngIndex2
2602:   Next lngIndex

'  If lngTotalCount = 0 Then
'    booDensityIsNull = True
'    Exit Function
'  Else
2608:   If lngSampleTotalCount > 0 Then
2609:     CalcDensityFromArray = lngValueCount / lngSampleTotalCount
2610:   End If
'  End If



 
    
  Exit Function
ErrorHandler:
  HandleError False, "CalcDensityFromArray " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function



Public Sub ShannonCounter(varValArray() As Variant, lngCountArray() As Long, varTest As Variant)
  On Error GoTo ErrorHandler


  Dim lngIndex As Long
  Dim booFound As Boolean
  Dim lngMaxSize As Long
2631:   lngMaxSize = UBound(varValArray)
2632:   booFound = False
2633:   For lngIndex = 0 To lngMaxSize
2634:     If varValArray(lngIndex) = varTest Then
2635:       booFound = True
2636:       lngCountArray(lngIndex) = lngCountArray(lngIndex) + 1
2637:       Exit For
2638:     End If
2639:   Next lngIndex
2640:   If Not booFound Then
2641:     lngMaxSize = lngMaxSize + 1
    ReDim Preserve varValArray(lngMaxSize)
    ReDim Preserve lngCountArray(lngMaxSize)
2644:     varValArray(lngMaxSize) = varTest
2645:     lngCountArray(lngMaxSize) = 1
2646:   End If


  Exit Sub
ErrorHandler:
  HandleError True, "ShannonCounter " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
Public Function ConvertNoDataMaskToSomethingUseful(varNoData As Variant) As Boolean()
  On Error GoTo ErrorHandler


  Dim lngIndex As Long
  
  Dim booReturn() As Boolean
  ReDim booReturn(((UBound(varNoData) + 1) * 8) - 1)
  Dim lngIntermediate As Long
  
2663:   For lngIndex = 0 To UBound(varNoData)
2664:     lngIntermediate = CLng(varNoData(lngIndex))
2665:     booReturn(lngIndex * 8) = CBool(lngIntermediate And 128)
2666:     booReturn((lngIndex * 8) + 1) = CBool(lngIntermediate And 64)
2667:     booReturn((lngIndex * 8) + 2) = CBool(lngIntermediate And 32)
2668:     booReturn((lngIndex * 8) + 3) = CBool(lngIntermediate And 16)
2669:     booReturn((lngIndex * 8) + 4) = CBool(lngIntermediate And 8)
2670:     booReturn((lngIndex * 8) + 5) = CBool(lngIntermediate And 4)
2671:     booReturn((lngIndex * 8) + 6) = CBool(lngIntermediate And 2)
2672:     booReturn((lngIndex * 8) + 7) = CBool(lngIntermediate And 1)
2673:   Next lngIndex
  
2675:   ConvertNoDataMaskToSomethingUseful = booReturn
  

  Exit Function
ErrorHandler:
  HandleError True, "ConvertNoDataMaskToSomethingUseful " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function
