VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cmdCovFromDatasets"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private m_App As IApplication
Private m_MxDoc As IMxDocument
Private m_bitmap As IPictureDisp
Private m_pThisExt As TopoCorridor.clsExtension

Implements ICommand
Const c_sModuleFileName As String = "D:\arcGIS_stuff\general_tools\Mahalanobis\Code\clsCovFromDatasets.cls"

 
Private Sub Class_Initialize()
  On Error GoTo ErrorHandler

15:   Set m_bitmap = LoadResPicture(112, vbResBitmap)

  Exit Sub
ErrorHandler:
  HandleError True, "Class_Initialize " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub Class_Terminate()
  On Error GoTo ErrorHandler

25:   Set m_bitmap = Nothing
26:   Set m_MxDoc = Nothing
27:   Set m_App = Nothing
28:   Set m_pThisExt = Nothing

  Exit Sub
ErrorHandler:
  HandleError True, "Class_Terminate " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Property Get ICommand_Enabled() As Boolean
  On Error GoTo ErrorHandler
  
38:   ICommand_Enabled = True

  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Enabled " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Checked() As Boolean
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
50:    ICommand_Checked = False


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Checked " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Name() As String
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
63:   ICommand_Name = "Mahalanobis_CalcStatsFromDatasets"


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Name " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Caption() As String
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
76:   ICommand_Caption = "&Statistical Matrices, Vector and Raster Inputs"


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Caption " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Tooltip() As String
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
89:   ICommand_Tooltip = "Statistical Matrices, Vector and Raster Inputs"


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Tooltip " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Message() As String
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
102:   ICommand_Message = "Calculate Statistical Matrices from Multiple Vector and Raster Datasets..."


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Message " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_HelpFile() As String
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
115:   ICommand_HelpFile = ""


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_HelpFile " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_HelpContextID() As Long
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
128:   ICommand_HelpContextID = 0


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_HelpContextID " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Bitmap() As esriSystem.OLE_HANDLE
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
141:   ICommand_Bitmap = m_bitmap.Handle


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Bitmap " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Category() As String
  On Error GoTo ErrorHandler

  ' TODO: Add your implementation here
153:   ICommand_Category = "Land Facet Corridor Tools"

  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Category " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Sub ICommand_OnCreate(ByVal hook As Object)
  On Error GoTo ErrorHandler

163:   Set m_App = hook
164:   Set m_MxDoc = m_App.Document
  

  Dim newUid As New UID
  Dim pExt As IExtension
169:   newUid.Value = "TopoCorridor.clsExtension"
170:   Set pExt = m_App.FindExtensionByCLSID(newUid)
171:   Set m_pThisExt = pExt
  

  Exit Sub
ErrorHandler:
  HandleError True, "ICommand_OnCreate " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub ICommand_OnClick()
  On Error GoTo ErrorHandler
  
  ' CLEAR ANY EXISTING USER PARAMETERS
183:   Set m_pThisExt.frmCovBasicReloadParams = Nothing
184:   Set m_pThisExt.frmCovSourceReturn = Nothing
185:   Set m_pThisExt.frmGridLayersReturn = Nothing
186:   Set m_pThisExt.StatsSaveCorrelationOptions = Nothing
187:   Set m_pThisExt.StatsSaveCovOptions = Nothing
188:   Set m_pThisExt.StatsSaveInvCovOptions = Nothing
189:   Set m_pThisExt.StatsSaveMeansOptions = Nothing
190:   Set m_pThisExt.StatsSaveSpearmanOptions = Nothing
191:   m_pThisExt.StatsSaveCorrelation = False
192:   m_pThisExt.StatsSaveCov = False
193:   m_pThisExt.StatsSaveInvCov = False
194:   m_pThisExt.StatsSaveMeans = False
195:   m_pThisExt.StatsSaveSpearman = False
  
  ' GET USER PARAMETERS
  Dim lngStep As Long
199:   lngStep = 1
  
  Dim pCovForm As TopoCorridor.frmCovSourceBasic
  Dim pGrids As TopoCorridor.frmGridLayersBasic
  Dim pOutput As TopoCorridor.frmSaveTablesGeneral
204:   Set m_pThisExt.frmCovSourceReturn = Nothing
205:   Set m_pThisExt.frmGridLayersReturn = Nothing
206:   Set m_pThisExt.frmCovReloadParams = Nothing
  
  Dim pParams As esriSystem.IVariantArray
209:   Set pParams = New esriSystem.VarArray
210:   pParams.Add m_App
211:   pParams.Add m_MxDoc
212:   pParams.Add m_pThisExt
213:   pParams.Add 1    ' FOR DIALOGS THAT WORK WITH MULTIPLE ANALYSES
  ' 1 = STATISTICS FROM DATASET
  ' 2 = MAHALANOBIS FROM POINTS
  
217:   Set pCovForm = New TopoCorridor.frmCovSourceBasic
218:   Set pCovForm.ArcApplication = pParams
219:   Set pGrids = New TopoCorridor.frmGridLayersBasic
220:   Set pGrids.ArcApplication = pParams
221:   Set pOutput = New TopoCorridor.frmSaveTablesGeneral
222:   Set pOutput.ArcApplication = pParams
        
224:   Do Until lngStep = 4
    Select Case lngStep
      Case 1
227:         pCovForm.Show vbModal
228:         If m_pThisExt.ShouldContinue = False Then
229:           m_pThisExt.InputStep = 4
230:         End If
      
      Case 2
233:         pGrids.Show vbModal
234:         If m_pThisExt.ShouldContinue = False Then
235:           m_pThisExt.InputStep = 4
236:         End If
      
      Case 3
239:         pOutput.Show vbModal
240:         If m_pThisExt.ShouldContinue = False Then
241:           m_pThisExt.InputStep = 4
242:         End If
243:     End Select
244:     lngStep = m_pThisExt.InputStep
245:   Loop
  
247:   Set pCovForm = Nothing
248:   Set pGrids = Nothing
249:   Set pOutput = Nothing
  
251:   If m_pThisExt.ShouldContinue = False Then
252:  '   MsgBox "Operation Canceled..."
    Exit Sub
254:   Else
    Dim strOutputReport As String
    
    Dim pProgressMeter As TopoCorridor.frmJenProgressMeter
258:     Set pProgressMeter = New TopoCorridor.frmJenProgressMeter
259:     Set m_pThisExt.ProgressMeterForm = pProgressMeter
    
261:     strOutputReport = TopoCorridor.Mahal_Functions.StatMatricesFromGeoDatasets(m_pThisExt, m_App, m_MxDoc)
    
263:     Set m_pThisExt.ProgressMeterForm = Nothing
    
    Dim frmReportForm As TopoCorridor.frmReportDialog
266:     Set frmReportForm = New TopoCorridor.frmReportDialog
    
    ' SHOW NORMAL TEXT REPORT
269:     frmReportForm.txtReport.Text = strOutputReport
270:     frmReportForm.txtReport.Locked = False
271:     frmReportForm.Caption = "Analysis Report:"
272:     frmReportForm.Show vbModal
273:     Set frmReportForm = Nothing
  
275:   End If
     
  ' CLEAR MEMORY
278:   Set m_pThisExt.frmCovReloadParams = Nothing
279:   Set m_pThisExt.frmCovBasicReloadParams = Nothing
280:   Set m_pThisExt.frmCovSourceReturn = Nothing
281:   Set m_pThisExt.frmGridLayersReturn = Nothing
282:   Set m_pThisExt.frmLayerIDReturn = Nothing

  Dim pDirty As IDocumentDirty
285:   Set pDirty = m_MxDoc
286:   pDirty.SetDirty
287:   m_App.Visible = True
  
  Exit Sub
ErrorHandler:
  HandleError True, "ICommand_OnClick " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub















