VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cmdMahalAtPoints"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private m_App As IApplication
Private m_MxDoc As IMxDocument
Private m_bitmap As IPictureDisp
Private m_pThisExt As TopoCorridor.clsExtension

Implements ICommand
Const c_sModuleFileName As String = "D:\arcGIS_stuff\general_tools\Mahalanobis\Code\clsMahalAtPoints.cls"

 
Private Sub Class_Initialize()
  On Error GoTo ErrorHandler

15:   Set m_bitmap = LoadResPicture(111, vbResBitmap)

  Exit Sub
ErrorHandler:
  HandleError True, "Class_Initialize " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub Class_Terminate()
  On Error GoTo ErrorHandler

25:   Set m_bitmap = Nothing
26:   Set m_MxDoc = Nothing
27:   Set m_App = Nothing
28:   Set m_pThisExt = Nothing

  Exit Sub
ErrorHandler:
  HandleError True, "Class_Terminate " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Property Get ICommand_Enabled() As Boolean
  On Error GoTo ErrorHandler
  
38:   ICommand_Enabled = True

  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Enabled " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Checked() As Boolean
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
50:    ICommand_Checked = False


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Checked " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Name() As String
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
63:   ICommand_Name = "Mahalanobis_AtPoints"


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Name " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Caption() As String
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
76:   ICommand_Caption = "Mahalanobis Distances - At &Points"


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Caption " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Tooltip() As String
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
89:   ICommand_Tooltip = "Mahalanobis - Points"


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Tooltip " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Message() As String
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
102:   ICommand_Message = "Calculate Mahalanobis Distance Values at Sample Points..."


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Message " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_HelpFile() As String
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
115:   ICommand_HelpFile = ""


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_HelpFile " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_HelpContextID() As Long
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
128:   ICommand_HelpContextID = 0


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_HelpContextID " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Bitmap() As esriSystem.OLE_HANDLE
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
141:   ICommand_Bitmap = m_bitmap.Handle


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Bitmap " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Category() As String
  On Error GoTo ErrorHandler

  ' TODO: Add your implementation here
153:   ICommand_Category = "Land Facet Corridor Tools"

  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Category " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Sub ICommand_OnCreate(ByVal hook As Object)
  On Error GoTo ErrorHandler

163:   Set m_App = hook
164:   Set m_MxDoc = m_App.Document
  

  Dim newUid As New UID
  Dim pExt As IExtension
169:   newUid.Value = "TopoCorridor.clsExtension"
170:   Set pExt = m_App.FindExtensionByCLSID(newUid)
171:   Set m_pThisExt = pExt
  

  Exit Sub
ErrorHandler:
  HandleError True, "ICommand_OnCreate " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub ICommand_OnClick()
  On Error GoTo ErrorHandler
  
  ' CLEAR ANY EXISTING USER PARAMETERS
183:   Set m_pThisExt.frmCovReloadParams = Nothing
184:   Set m_pThisExt.frmCovSourceReturn = Nothing
185:   Set m_pThisExt.frmGridLayersReturn = Nothing
186:   Set m_pThisExt.StatsSaveCorrelationOptions = Nothing
187:   Set m_pThisExt.StatsSaveCovOptions = Nothing
188:   Set m_pThisExt.StatsSaveInvCovOptions = Nothing
189:   Set m_pThisExt.StatsSaveMeansOptions = Nothing
190:   Set m_pThisExt.StatsSavePearsonOptions = Nothing
191:   m_pThisExt.StatsSaveCorrelation = False
192:   m_pThisExt.StatsSaveCov = False
193:   m_pThisExt.StatsSaveInvCov = False
194:   m_pThisExt.StatsSaveMeans = False
195:   m_pThisExt.StatsSavePearson = False
  
'   GET USER PARAMETERS
  Dim lngStep As Long
199:   lngStep = 1

  Dim pCovForm As TopoCorridor.frmCovSourceVector
  Dim pGrids As TopoCorridor.frmGridLayersBasic
  Dim pOutputOptions As TopoCorridor.frmPointOutputOptions
204:   Set m_pThisExt.frmMahalVectorSource = Nothing
205:   Set m_pThisExt.frmGridLayersReturn = Nothing
206:   Set m_pThisExt.frmMahalOutputOptions = Nothing
  
  
  Dim pParams As esriSystem.IVariantArray
210:   Set pParams = New esriSystem.VarArray
211:   pParams.Add m_App
212:   pParams.Add m_MxDoc
213:   pParams.Add m_pThisExt
214:   pParams.Add 2    ' FOR DIALOGS THAT WORK WITH MULTIPLE ANALYSES
  ' 1 = STATISTICS FROM DATASET
  ' 2 = MAHALANOBIS FROM POINTS

'  MsgBox "About to define Covariance Source form..."
219:   Set pCovForm = New TopoCorridor.frmCovSourceVector
220:   Set pCovForm.ArcApplication = pParams

'  MsgBox "About to define Grid Layers form..."
223:   Set pGrids = New TopoCorridor.frmGridLayersBasic
224:   Set pGrids.ArcApplication = pParams
  
226:   Set pOutputOptions = New TopoCorridor.frmPointOutputOptions
227:   Set pOutputOptions.ArcApplication = pParams
228:   Set pOutputOptions.PointFeatureLayer = Nothing
  
  Dim pPointFeatureLayer As IFeatureLayer
  Dim pPointParams As esriSystem.IVariantArray
  
'  MsgBox "About to start loop..."
'
235:   Do Until lngStep = 4
    Select Case lngStep
      Case 1
238:         pCovForm.Show vbModal
239:         If m_pThisExt.ShouldContinue = False Then
240:           m_pThisExt.InputStep = 4
241:         Else
242:           Set pPointParams = m_pThisExt.frmMahalVectorSource.Element(0)
243:           Set pPointFeatureLayer = pPointParams.Element(0)
244:           Set pOutputOptions.PointFeatureLayer = pPointFeatureLayer
245:         End If
        
      Case 2
248:         pGrids.Show vbModal
249:         If m_pThisExt.ShouldContinue = False Then
250:           m_pThisExt.InputStep = 4
251:         End If
        
      Case 3
254:         pOutputOptions.Show vbModal
255:         If m_pThisExt.ShouldContinue = False Then
256:           m_pThisExt.InputStep = 4
257:         End If
258:     End Select
259:     lngStep = m_pThisExt.InputStep
260:   Loop
  
262:   Unload pCovForm
263:   Unload pGrids
264:   Unload pOutputOptions
  
'  MsgBox "Forms Deleted"
'  Exit Sub

269:   If m_pThisExt.ShouldContinue = False Then
'    MsgBox "Operation Canceled..."
271:     GoTo CleanUp
272:   Else
    Dim strOutputReport As String

    Dim pProgressMeter As TopoCorridor.frmJenProgressMeter
276:     Set pProgressMeter = New TopoCorridor.frmJenProgressMeter
277:     Set m_pThisExt.ProgressMeterForm = pProgressMeter

279:     strOutputReport = TopoCorridor.Mahal_Functions.MahalanobisAtPoints(m_pThisExt, m_App, m_MxDoc)

281:     Set m_pThisExt.ProgressMeterForm = Nothing

    Dim frmReportForm As TopoCorridor.frmReportDialog
284:     Set frmReportForm = New TopoCorridor.frmReportDialog

    ' SHOW NORMAL TEXT REPORT
287:     frmReportForm.txtReport.TextRTF = strOutputReport
288:     frmReportForm.txtReport.Locked = False
289:     frmReportForm.Caption = "Analysis Report:"
290:     frmReportForm.Show vbModal
291:     Set frmReportForm = Nothing

293:   End If
    
  ' CLEAR MEMORY

  Dim pDirty As IDocumentDirty
298:   Set pDirty = m_MxDoc
299:   pDirty.SetDirty
300:   m_App.Visible = True
  
302:   GoTo CleanUp
ErrorHandler:
  HandleError True, "ICommand_OnClick " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4

CleanUp:
307:   Set pCovForm = Nothing
308:   Set pGrids = Nothing
309:   Set pOutputOptions = Nothing
310:   Set pPointFeatureLayer = Nothing
311:   Set pPointParams = Nothing
312:   Set pProgressMeter = Nothing
313:   Set m_pThisExt.ProgressMeterForm = Nothing
314:   Set m_pThisExt.frmMahalOutputOptions = Nothing
315:   Set m_pThisExt.frmMahalVectorSource = Nothing
316:   Set m_pThisExt.frmGridLayersReturn = Nothing
317:   Set pParams = Nothing
318:   Set pDirty = Nothing

End Sub















