Attribute VB_Name = "Mahal_Functions"
Option Explicit
Const c_sModuleFileName As String = "D:\arcGIS_stuff\general_tools\Mahalanobis\Code\Mahal_Functions.bas"

Public Function RasterChiSquareTransform(pDocParams As esriSystem.IVariantArray, _
    pParams As esriSystem.IVariantArray) As String
  On Error GoTo ErrorHandler


    
  Dim pApp As IApplication
  Dim pMxDoc As IMxDocument
  Dim pThisExt As TopoCorridor.clsExtension
  
14:   Set pApp = pDocParams.Element(0)
15:   Set pMxDoc = pDocParams.Element(1)
16:   Set pThisExt = pDocParams.Element(2)
  
  ' pParams IS IVariantArray, CONTAINING:
  ' 0) IRasterLayer: SELECTED RASTER CATALOG LAYER
  ' 1) STRING: Save Format
  ' 2) STRING: TEXT VERSION OF SAVE FORMAT
  ' 3) STRING: New Raster Name
  ' 4) BOOLEAN: Whether new workspace is File Geodatabase
  ' 5) IWORKSPACE: Either an IRasterWorkspace2 or an IRasterWorkspaceEx
  ' 6) STRING: Extension for output
  ' 7) STRING: Name of Selected Raster Band
  ' 8) DOUBLE: OPTIONAL ADD VALUE

  Dim datBegan As Date
30:   datBegan = Now
  
  Dim strReport As String
33:   strReport = "Function failed..."
  
35:   RasterChiSquareTransform = strReport
  
  Dim pInputBand As IRasterBand
  Dim pRastLayer As IRasterLayer
  Dim pGeoDataset As IGeoDataset
  Dim pInputDataset As IRasterDataset
  Dim pInputRaster As IRaster2
  Dim pEnv As IEnvelope
  Dim strSaveFormat As String
  Dim lngNbrHoodRadius As Long
  Dim strNewRasterName As String
  Dim booIsFGB As Boolean
  Dim pRastWS As IRasterWorkspace2
  Dim pRastWsEx As IRasterWorkspaceEx
  Dim strSaveFormatString As String
  Dim pWS As IWorkspace
  Dim strExtension As String
  Dim strInputName As String
  Dim booExcludeIfAnyNull As Boolean
  Dim lngDF As Long
55:   booExcludeIfAnyNull = False
  
'  MsgBox "pParams.Count = " & CStr(pParams.Count)
'  MsgBox "VarType(pParams.Element(0)) = " & CStr(VarType(pParams.Element(0)))
'  MsgBox "TypeOf pParams.Element(0) Is ILayer = " & CStr(TypeOf pParams.Element(0) Is ILayer)
'  MsgBox "TypeOf pParams.Element(0) Is IRasterLayer = " & CStr(TypeOf pParams.Element(0) Is IRasterLayer)
  
62:   Set pInputBand = pParams.Element(0)
63:   Set pGeoDataset = pInputBand
64:   Set pEnv = pGeoDataset.Extent
  
66:   strSaveFormat = pParams.Element(1)
67:   strSaveFormatString = pParams.Element(2)
68:   strNewRasterName = pParams.Element(3)
69:   booIsFGB = pParams.Element(4)
70:   Set pWS = pParams.Element(5)
71:   If booIsFGB Then
72:     Set pRastWsEx = pWS
73:   Else
74:     Set pRastWS = pWS
75:   End If
76:   strExtension = pParams.Element(6)
77:   strInputName = pParams.Element(7)
78:   lngDF = pParams.Element(8)
  
  Dim pRastDataset As IRasterDataset3
  
  Dim pSaveAs As ISaveAs2
  Dim pRasterProp As IRasterProps
  Dim pRasLy As IRasterLayer
  Dim pRastStDef As IRasterStorageDef2
  Dim pRastProps As IRasterProps
  
  '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  '/////////// |                  | \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
  '----------  |   CALCULATIONS   |  ---------------------------------------------------------------------------
  '\\\\\\\\\\\ |                  | ///////////////////////////////////////////////////////////////////////////
  '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

  Dim pPro As IStepProgressor
  Dim psbar As IStatusBar
  
  Dim pTempBandColl As IRasterBandCollection
98:   Set pTempBandColl = New Raster
99:   pTempBandColl.AppendBand pInputBand
100:   Set pInputRaster = pTempBandColl
101:   Set pRastProps = pInputRaster
  
103:   Set psbar = pApp.StatusBar
104:   Set pPro = psbar.ProgressBar
  
  Dim lngHeight As Long
  Dim lngWidth As Long
  Dim dblNoData As Double
  Dim varNoData As Variant
  
111:   lngWidth = pRastProps.Width
112:   lngHeight = pRastProps.Height
113:   varNoData = pRastProps.NoDataValue
  
  ' PROGRESS STUFF
116:   pPro.position = 0
  Dim strMessageName As String
118:   strMessageName = "Applying Chi-Square Transform '" & strInputName & "'..."
119:   psbar.ShowProgressBar strMessageName, 1, lngHeight, 1, True
120:   pPro.Message = strMessageName

  Dim pPnt As IPnt
123:   Set pPnt = New Pnt
124:   pPnt.SetCoords lngWidth, 1

  Dim pPixBlock As IPixelBlock3

  Dim pTopLeft As IPnt

  Dim lngIndex As Long
  Dim lngIndex2 As Long
  Dim lngIndex3 As Long
  Dim varNoDataArray As Variant
  Dim booHasData() As Boolean
  Dim varData As Variant
  Dim varEmptyData() As Variant
  ReDim varEmptyData(lngWidth - 1)
  
  ' FOR DEBUGGING
'  Dim strDebugReport As String
'  strDebugReport = ""
'  For lngIndex = 0 To (lngNbrHoodRadius * 2)
'    For lngIndex2 = 0 To (lngNbrHoodRadius * 2)
'      strDebugReport = strDebugReport & Left(UCase(CStr(booMaskArray(lngIndex, lngIndex2))), 1) & "  "
'    Next lngIndex2
'    strDebugReport = strDebugReport & vbCrLf
'  Next lngIndex

  Dim dblShannon As Double
  Dim booShannonIsNull As Boolean
    
  ' CREATE RASTERS TO WRITE TO -----------------------------------------------------------------------------------
  ' Create the dataset
  Dim pOutDS As IRasterDataset2
  Dim pOutRasterEdit As IRasterEdit

  Dim pRasterStorDef As IRasterStorageDef2
  Dim pRasterDef As IRasterDef
  Dim pGeomDef As IGeometryDef
  
  Dim pOriginPoint As IPoint
162:   Set pOriginPoint = New Point
163:   pOriginPoint.PutCoords pRastProps.Extent.XMin, pRastProps.Extent.YMin
  
  Dim pOutPnt As IPnt
166:   Set pOutPnt = New Pnt
  Dim lngFocalRow As Long
  
  Dim pSpRef As ISpatialReference
170:   Set pSpRef = pRastProps.SpatialReference
      
  ' IRasterStorageDef
173:   Set pRasterStorDef = New RasterStorageDef
174:   Set pRasterStorDef.CellSize = pRastProps.MeanCellSize
175:   pRasterStorDef.CompressionType = esriRasterSdeCompressionTypeRunLength
176:   pRasterStorDef.PyramidLevel = 2
177:   pRasterStorDef.PyramidResampleType = RSP_BilinearInterpolation
178:   pRasterStorDef.TileHeight = 128
179:   pRasterStorDef.TileWidth = 128

  ' IRasterDef
182:   Set pRasterDef = New RasterDef
183:   Set pRasterDef.SpatialReference = pSpRef
184:   pRasterDef.Description = "rasterdataset"

  ' IGeometryDef
187:   Set pGeomDef = Nothing
  
  Dim pOutProps As IRasterProps
  Dim pOutBandColl As IRasterBandCollection
  Dim pTempOutBandColl As IRasterBandCollection
  Dim pOutBand As IRasterBand
  Dim pRastDatasetEdit As IRasterDatasetEdit2
  Dim pTempOutRaster As IRaster
  
196:   Set pRasterStorDef.CellSize = pRastProps.MeanCellSize
197:   If booIsFGB Then
198:     Set pOutDS = pRastWsEx.CreateRasterDataset(strNewRasterName, 1, PT_FLOAT, pRasterStorDef, _
        "DEFAULTS", pRasterDef, pGeomDef)
200:     Set pTempOutBandColl = pOutDS
201:     Set pTempOutRaster = New Raster
202:     Set pOutBandColl = pTempOutRaster
203:     pOutBandColl.AppendBands pTempOutBandColl
204:     pTempOutRaster.ResampleMethod = RSP_BilinearInterpolation
    
206:     Set pOutProps = pTempOutRaster
207:     pOutProps.Extent = pRastProps.Extent
208:     pOutProps.Height = pRastProps.Height
209:     pOutProps.Width = pRastProps.Width
210:     pOutProps.SpatialReference = pSpRef
211:     pOutProps.PixelType = PT_FLOAT
212:   Else
213:     Set pOutDS = pRastWS.CreateRasterDataset(strNewRasterName & strExtension, strSaveFormat, pOriginPoint, lngWidth, lngHeight, _
        pRastProps.MeanCellSize.X, pRastProps.MeanCellSize.Y, 1, PT_FLOAT, pSpRef, True)
215:   End If
  
  Dim pOutputPixBlock As IPixelBlock3
  
  ' OUTPUT VARIABLES
  Dim pOutputRaster As IRaster2
  Dim pOutputRaster2 As IRaster
  Dim pPixelData As Variant
  Dim pRawPixel As IRawPixels
  Dim pOutPixelBlock As IPixelBlock3
  Dim pBands As IRasterBandCollection
  Dim pOutputRastProps As IRasterProps
  Dim pCache As Variant

  ' QI for IRawPixels and IRasterProps
230:   Set pOutputRaster = pOutDS.CreateFullRaster
231:   Set pOutputRaster2 = pOutputRaster
232:   Set pOutRasterEdit = pOutputRaster
233:   Set pBands = pOutDS
234:   Set pRawPixel = pBands.Item(0)
235:   Set pOutputRastProps = pRawPixel
236:   If Not booIsFGB Then
237:     pOutputRastProps.NoDataValue = CInt(-9999)
238:   End If
'  Set pOutPixelBlock = pRawPixel.CreatePixelBlock(pPnt)
240:   Set pOutputPixBlock = pOutputRaster2.CreatePixelBlock(pPnt)
241:   pOutputPixBlock.PixelType(0) = PT_FLOAT
  Dim varOutData As Variant

  ' ADD FIRST LINE OF DATA
  Dim pRastCursor As IRasterCursor
246:   Set pRastCursor = pInputRaster.CreateCursorEx(pPnt)

248:   Set pPixBlock = pRastCursor.PixelBlock
249:   pPixBlock.PixelType(0) = PT_FLOAT
250:   pRastCursor.Reset
251:   Set pPixBlock = pRastCursor.PixelBlock
252:   varData = pPixBlock.PixelData(0)
253:   booHasData = ConvertNoDataMaskToSomethingUseful(pPixBlock.NoDataMask(0))
'
'  ' BELOW IS WORKAROUND FOR PROBLEM IN WHICH PIXEL BLOCK APPEARS TO NOT BE ABLE TO CORRECTLY READ FIRST ROW.
'  ' I THINK THIS HAS SOMETHING TO DO WITH SETTING THE PIXEL TYPE TO PT_FLOAT.  IT READS IT CORRECTLY AFTER
'  ' THAT POINT, BUT I CANNOT SET IT BEFORE READING THE FIRST ROW FROM RASTER CURSOR, EVEN AFTER USING 'RESET'.
'  ' CODE BELOW SIMPLY EXTRACTS varData1 and booHasData1 FROM A DIFFERENT PIXEL BLOCK THAT IS READ CORRECTLY.
  Dim pTempPixBlock As IPixelBlock3
  Dim pTempRaster As IRaster
261:   Set pTempRaster = pInputRaster
  Dim pTempPoint As IPnt
263:   Set pTempPoint = New Pnt
264:   pTempPoint.SetCoords CInt(lngWidth), 1
265:   Set pTempPixBlock = pTempRaster.CreatePixelBlock(pTempPoint)
266:   pTempPixBlock.PixelType(0) = PT_FLOAT
  Dim pTempOrigin As IPnt
268:   Set pTempOrigin = New Pnt

  Dim lngRowCounter As Long
271:   lngRowCounter = -1
  Dim varVal As Variant
  Dim dblVal As Double

275:   pTempOrigin.SetCoords 0, 0
276:   pTempRaster.Read pTempOrigin, pTempPixBlock
277:   varData = pTempPixBlock.PixelDataByRef(0)
278:   booHasData = ConvertNoDataMaskToSomethingUseful(pTempPixBlock.NoDataMaskByRef(0))

  ' FROM HERE ON OUT, RASTER CURSOR SEEMS TO WORK

  ' IF lngFocalRow ACTUALLY IS lngHeight, THEN IT IS ONE ROW TOO FAR.
  
284:   lngFocalRow = 0
  Dim lngLastColumn As Long
286:   lngLastColumn = lngWidth - 1
  Dim dblOut As Double
  
289:   Do Until lngFocalRow = lngHeight
290:     pPro.Step
291:     DoEvents
    
    ' WRITE ROW
294:     pOutPnt.SetCoords 0, lngFocalRow
295:     pOutputRaster2.Read pOutPnt, pOutputPixBlock
296:     varOutData = pOutputPixBlock.PixelData(0)
    
    
299:     For lngIndex = 0 To lngLastColumn
    
   '   If MsgBox("lngFocalRow = " & CStr(lngFocalRow) & vbCrLf & _
        "booHasData(lngIndex = " & CStr(lngIndex) & ") = " & CStr(booHasData(lngIndex)), vbYesNo) = vbYes Then goto cleanup
      
304:       dblOut = -9999
305:       If booHasData(lngIndex) Then
      
       ' If MsgBox("lngFocalRow = " & CStr(lngFocalRow) & vbCrLf & _
          "booHasData(lngIndex = " & CStr(lngIndex) & ") = " & CStr(booHasData(lngIndex)) & vbCrLf & _
          "Not IsNull(varVal) = " & CStr(Not IsNull(varVal)), vbYesNo) = vbYes Then goto cleanup
        
311:         varVal = varData(lngIndex, 0)
312:         If Not IsNull(varVal) Then
      
     '     If MsgBox("lngFocalRow = " & CStr(lngFocalRow) & vbCrLf & _
            "booHasData(lngIndex = " & CStr(lngIndex) & ") = " & CStr(booHasData(lngIndex)) & vbCrLf & _
            "Not IsNull(varVal) = " & CStr(Not IsNull(varVal)) & vbCrLf & _
            "dblVal = " & CStr(dblVal), vbYesNo) = vbYes Then goto cleanup
            
319:           dblVal = CDbl(varVal)
320:           If dblVal >= 0 Then
321:              dblOut = 1 - TopoCorridor.StatProcs.CDF_ChiSquare(dblVal, lngDF)
              
      '      If MsgBox("lngFocalRow = " & CStr(lngFocalRow) & vbCrLf & _
              "booHasData(lngIndex = " & CStr(lngIndex) & ") = " & CStr(booHasData(lngIndex)) & vbCrLf & _
              "Not IsNull(varVal) = " & CStr(Not IsNull(varVal)) & vbCrLf & _
              "dblVal = " & CStr(dblVal) & vbCrLf & _
              "varOutData(lngIndex, 0) = " & CStr(CDbl(varOutData(lngIndex, 0))), vbYesNo) = vbYes Then goto cleanup
328:           End If
329:         End If
330:       End If
      
332:       varOutData(lngIndex, 0) = dblOut
      
334:     Next lngIndex

    ' SAVE DATA TO HARD DRIVE
337:     pOutputPixBlock.PixelData(0) = varOutData
338:     pOutRasterEdit.Write pOutPnt, pOutputPixBlock
339:     If lngFocalRow Mod 20 = 0 Then
340:       pOutRasterEdit.Refresh
341:     End If
    
    ' MOVE TO NEXT ROW
344:     lngFocalRow = lngFocalRow + 1
    
346:     pRastCursor.Next
347:     Set pPixBlock = pRastCursor.PixelBlock
348:     pPixBlock.PixelType(0) = PT_FLOAT
349:     varData = pPixBlock.PixelDataByRef(0)
350:     booHasData = ConvertNoDataMaskToSomethingUseful(pPixBlock.NoDataMaskByRef(0))
    
352:   Loop
  
354:   pOutRasterEdit.Refresh

'  ----------------------------
  Dim pNewLayer As IRasterLayer

  Dim pStatsBandColl As IRasterBandCollection
  Dim pStatsBand As IRasterBand
361:   Set pStatsBandColl = pOutDS
362:   Set pStatsBand = pStatsBandColl.Item(0)
363:   pStatsBand.ComputeStatsAndHist
  
365:   Set pInputBand = Nothing
366:   Set pRastLayer = Nothing
367:   Set pGeoDataset = Nothing
368:   Set pInputDataset = Nothing
369:   Set pInputRaster = Nothing
370:   Set pEnv = Nothing
371:   Set pRastDataset = Nothing
372:   Set pSaveAs = Nothing
373:   Set pRasterProp = Nothing
374:   Set pRasLy = Nothing
375:   Set pRastStDef = Nothing
376:   Set pRastProps = Nothing
377:   Set pTempBandColl = Nothing
378:   Set pPnt = Nothing
379:   Set pPixBlock = Nothing
380:   Set pTopLeft = Nothing
381:   Set pOutDS = Nothing
382:   Set pOutRasterEdit = Nothing
383:   Set pRasterStorDef = Nothing
384:   Set pRasterDef = Nothing
385:   Set pGeomDef = Nothing
386:   Set pOriginPoint = Nothing
387:   Set pOutPnt = Nothing
388:   Set pOutProps = Nothing
389:   Set pOutBandColl = Nothing
390:   Set pTempOutBandColl = Nothing
391:   Set pOutBand = Nothing
392:   Set pRastDatasetEdit = Nothing
393:   Set pTempOutRaster = Nothing
394:   Set pOutputPixBlock = Nothing
395:   Set pOutputRaster = Nothing
396:   Set pOutputRaster2 = Nothing
397:   Set pRawPixel = Nothing
398:   Set pOutPixelBlock = Nothing
399:   Set pBands = Nothing
400:   Set pOutputRastProps = Nothing
401:   Set pRastCursor = Nothing
402:   Set pTempPixBlock = Nothing
403:   Set pTempRaster = Nothing
404:   Set pTempPoint = Nothing
405:   Set pTempOrigin = Nothing
406:   Set pNewLayer = Nothing
407:   Set pStatsBandColl = Nothing
408:   Set pStatsBand = Nothing
  
  
  Dim pNewDS As IRasterDataset
412:   Set pNewDS = pRastWS.OpenRasterDataset(strNewRasterName & strExtension)
  
  ' ADD RASTER TO MAP DOCUMENT
415:   Set pNewLayer = New RasterLayer
416:   pNewLayer.CreateFromDataset pNewDS
417:   pNewLayer.Name = strNewRasterName

  ' SYMBOLIZE RASTER LAYER

  ' Create renderer and QI RasterRenderer
  Dim pStretchRen As IRasterStretchColorRampRenderer
423:   Set pStretchRen = New RasterStretchColorRampRenderer
  Dim pRasRen As IRasterRenderer
425:   Set pRasRen = pStretchRen
  
  Dim pRasterStretch As IRasterStretch
428:   Set pRasterStretch = pStretchRen
429:   pRasterStretch.StretchType = esriRasterStretch_NONE

  ' Set raster for the renderer and update
432:   Set pRasRen.Raster = pNewLayer.Raster
433:   pRasRen.Update

  ' COLORS
  Dim pRedColor As IColor
  Dim pYellowColor As IColor
  Dim pGreenColor As IColor

440:   Set pRedColor = New RgbColor
441:   Set pYellowColor = New RgbColor
442:   Set pGreenColor = New RgbColor

444:   pRedColor.RGB = RGB(190, 0, 0)
445:   pYellowColor.RGB = RGB(255, 255, 200)
446:   pGreenColor.RGB = RGB(0, 140, 0)

  ' CREATE COLOR RAMPS
  Dim pRamp1 As IAlgorithmicColorRamp
450:   Set pRamp1 = New AlgorithmicColorRamp
451:   pRamp1.Algorithm = esriLabLChAlgorithm
452:   pRamp1.Size = 130
453:   pRamp1.FromColor = pRedColor
454:   pRamp1.ToColor = pYellowColor
455:   pRamp1.CreateRamp True

  Dim pRamp2 As IAlgorithmicColorRamp
458:   Set pRamp2 = New AlgorithmicColorRamp
459:   pRamp2.Algorithm = esriLabLChAlgorithm
460:   pRamp2.Size = 130
461:   pRamp2.FromColor = pYellowColor
462:   pRamp2.ToColor = pGreenColor
463:   pRamp2.CreateRamp True

  Dim pMultiRamp As IMultiPartColorRamp
466:   Set pMultiRamp = New MultiPartColorRamp
467:   pMultiRamp.Ramp(0) = pRamp1
468:   pMultiRamp.Ramp(1) = pRamp2
469:   pMultiRamp.Size = 260
470:   pMultiRamp.CreateRamp True

  ' Plug this colorramp into renderer and select a band
473:   pStretchRen.BandIndex = 0
474:   pStretchRen.ColorRamp = pMultiRamp

  ' Update the renderer with new settings and plug into layer
477:   pRasRen.Update
478:   Set pNewLayer.Renderer = pStretchRen

480:   pMxDoc.AddLayer pNewLayer
'-----------------------------------
  
483:   pPro.position = 0
484:   psbar.HideProgressBar
  
  
  ' ONLY SHOW OUTPUT REPORT IF IT CRASHED PRIOR TO THIS POINT
'  strReport = ""
489:   strReport = "Invert Raster Function Complete:" & vbCrLf & _
              "----------------------------------------------------------" & vbCrLf & _
              "Analysis Parameters:" & vbCrLf & _
              " --> Input Raster Layer: " & strInputName & vbCrLf & _
              " --> Output Format: " & strSaveFormatString & vbCrLf & _
              " --> Filename: " & strNewRasterName & strExtension & vbCrLf & _
              " --> Workspace = " & pWS.PathName & vbCrLf & _
              " --> Degrees of Freedom = " & CStr(lngDF) & vbCrLf & _
              "----------------------------------------------------------" & vbCrLf & _
              TopoCorridor.MyGeneralOperations.ReturnTimeElapsed(datBegan, Now)
  
500:   pMxDoc.UpdateContents
501:   pMxDoc.ActiveView.PartialRefresh esriViewGeography, Nothing, pEnv
  
503:   RasterChiSquareTransform = strReport
  
  
506:   GoTo CleanUp
ErrorHandler:
  HandleError True, "RasterChiSquareTransform " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4

CleanUp:

512:   Set pApp = Nothing
513:   Set pMxDoc = Nothing
514:   Set pThisExt = Nothing
515:   Set pInputBand = Nothing
516:   Set pRastLayer = Nothing
517:   Set pGeoDataset = Nothing
518:   Set pInputDataset = Nothing
519:   Set pInputRaster = Nothing
520:   Set pEnv = Nothing
521:   Set pRastWS = Nothing
522:   Set pRastWsEx = Nothing
523:   Set pWS = Nothing
524:   Set pRastDataset = Nothing
525:   Set pSaveAs = Nothing
526:   Set pRasterProp = Nothing
527:   Set pRasLy = Nothing
528:   Set pRastStDef = Nothing
529:   Set pRastProps = Nothing
530:   Set pPro = Nothing
531:   Set psbar = Nothing
532:   Set pTempBandColl = Nothing
533:   Set pPnt = Nothing
534:   Set pPixBlock = Nothing
535:   Set pTopLeft = Nothing
536:   Set pOutDS = Nothing
537:   Set pOutRasterEdit = Nothing
538:   Set pRasterStorDef = Nothing
539:   Set pRasterDef = Nothing
540:   Set pGeomDef = Nothing
541:   Set pOriginPoint = Nothing
542:   Set pOutPnt = Nothing
543:   Set pSpRef = Nothing
544:   Set pOutProps = Nothing
545:   Set pOutBandColl = Nothing
546:   Set pTempOutBandColl = Nothing
547:   Set pOutBand = Nothing
548:   Set pRastDatasetEdit = Nothing
549:   Set pTempOutRaster = Nothing
550:   Set pOutputPixBlock = Nothing
551:   Set pOutputRaster = Nothing
552:   Set pOutputRaster2 = Nothing
553:   Set pRawPixel = Nothing
554:   Set pOutPixelBlock = Nothing
555:   Set pBands = Nothing
556:   Set pOutputRastProps = Nothing
557:   Set pRastCursor = Nothing
558:   Set pTempPixBlock = Nothing
559:   Set pTempRaster = Nothing
560:   Set pTempPoint = Nothing
561:   Set pTempOrigin = Nothing
562:   Set pNewLayer = Nothing
563:   Set pStatsBandColl = Nothing
564:   Set pStatsBand = Nothing
565:   Set pNewDS = Nothing
566:   Set pStretchRen = Nothing
567:   Set pRasRen = Nothing
568:   Set pRasterStretch = Nothing
569:   Set pRedColor = Nothing
570:   Set pYellowColor = Nothing
571:   Set pGreenColor = Nothing
572:   Set pRamp1 = Nothing
573:   Set pRamp2 = Nothing
574:   Set pMultiRamp = Nothing

End Function

Public Function MahalanobisAtPoints(pThisExt As TopoCorridor.clsExtension, pApp As IApplication, _
  pMxDoc As IMxDocument) As String
  On Error GoTo ErrorHandler

582:   pApp.RefreshWindow
  
  Dim datBegan As Date
585:   datBegan = Now

  ' FOR DEBUGGING - MAHALANOBIS INPUT VARIABLES
  Dim lngCheckIndex As Long
  Dim pSelectedArray As esriSystem.IVariantArray
  Dim pSubArray As esriSystem.IVariantArray
  Dim pUnknown As IUnknown
  Dim pOptions As esriSystem.IVariantArray
  Dim strMahal As String
  Dim strWS As String
  Dim lngWSType As JenDatasetTypes
  Dim booExact As Boolean
  
598:   Set pOptions = pThisExt.frmGridLayersReturn
599:   Set pSelectedArray = pOptions.Element(0)
600:   booExact = pOptions.Element(1)
  
  ' PARAMETERS BELOW NOT USED IN THIS FUNCTION
'  strWS = pOptions.Element(2)
'  lngWSType = pOptions.Element(3)
'  strMahal = pOptions.Element(4)
  
  ' ==================================================================
  
  ' RETURN ARRAY pSourceParams WILL BE AN IVariantArray CONTAINING THE FOLLOWING ITEMS:
  ' 0) pPointParams; IVariantArray CONTAINING:
  '    0) IFeatureLayer: SELECTED POINT LAYER
  '    1) BOOLEAN: Whether to use all points
  '    2) LONG: Total number of points to be used
  '    3) LONG: Selected Number of Points in this layer
  ' 1) pStatsParams; IVariantArray CONTAINING:
  '    0) IStandaloneTable: MEAN VECTOR
  '    1) IStandaloneTable: COVARIANCE MATRIX
  
  Dim pSourceArray As esriSystem.IVariantArray
620:   Set pSourceArray = pThisExt.frmMahalVectorSource
  
  Dim pPointParams As esriSystem.IVariantArray
  Dim pPointLayer As IFeatureLayer
  Dim pPointFClass As IFeatureClass
  Dim booUseAll As Boolean
  Dim lngPointCount As Long
  Dim lngSelPointCount As Long
  
629:   Set pPointParams = pSourceArray.Element(0)
630:   Set pPointLayer = pPointParams.Element(0)
631:   Set pPointFClass = pPointLayer.FeatureClass
632:   booUseAll = pPointParams.Element(1)
633:   lngPointCount = pPointParams.Element(2)
634:   lngSelPointCount = pPointParams.Element(3)
  
  Dim lngIndex As Long
  Dim booHasASelection As Boolean
638:   booHasASelection = False
  Dim pEnumOIDs As IEnumIDs
  Dim lngOIDs() As Long
  Dim pCurrentSelSet As ISelectionSet
  Dim pFSel As IFeatureSelection
643:   Set pFSel = pPointLayer
644:   Set pCurrentSelSet = pFSel.SelectionSet
645:   If pCurrentSelSet.Count > 0 Then
646:     booHasASelection = True
647:     Set pEnumOIDs = pCurrentSelSet.IDs
648:     pEnumOIDs.Reset
    ReDim lngOIDs(pCurrentSelSet.Count - 1)
650:     For lngIndex = 0 To pCurrentSelSet.Count - 1
651:       lngOIDs(lngIndex) = pEnumOIDs.Next
652:     Next lngIndex
653:   End If
  
  
  Dim lngOIDIndex As Long
657:   lngOIDIndex = pPointFClass.Fields.FindField(pPointFClass.OIDFieldName)
  
  Dim pStatsParams As esriSystem.IVariantArray
660:   Set pStatsParams = pSourceArray.Element(1)
  Dim pMeanST As IStandaloneTable
  Dim pCovST As IStandaloneTable
663:   Set pMeanST = pStatsParams.Element(0)
664:   Set pCovST = pStatsParams.Element(1)
  ' ==================================================================
    
  ' FOR PROGRESS METER --------------------------------------------------------------
  Dim booShowProgress As Boolean
  Dim frmProgress As TopoCorridor.frmJenProgressMeter
670:   Set frmProgress = pThisExt.ProgressMeterForm
671:   booShowProgress = CBool(Not frmProgress Is Nothing)
  
  ' ESTIMATE TOTAL NUMBER OF STEPS REQUIRED
  ' 1 FOR READING DATA
  ' 1 FOR INVERTING MATRIX
  ' N FOR EXTRACTING DATA FROM VARIABLE LAYERS
  ' 1 FOR CALCULATING M-VALUES
  '     THIS LAST ONE WILL BE RESET WHEN IT IS TIME TO CALCULATE DATA
  
  Dim lngValCount As Long
681:   lngValCount = pSelectedArray.Count + 4
    
  Dim psbar As IStatusBar
  Dim pPro As IStepProgressor
  Dim booFoundProblems As Boolean
  Dim strProblemReport As String
  Dim strRunningProblems As String
  Dim strTimeElapsed As String
  Dim lngTimer As Long
  Dim theTimeBegan As Date
  Dim dateRunningTime As Date
  Dim strHeader As String
  Dim strMessage As String
  Dim ext As TopoCorridor.clsExtension
  Dim theDetailedDescription As String
  Dim theProgressSpecific As String
  
698:   If booShowProgress Then
    ' FOLLOWING CODE SHOULD BE INSERTED INTO A FUNCTION.  NEEDS MINOR EDITS IF GOING INTO A SUBROUTINE
    ' SPECIFICALLY, CHANGE "goto cleanup" to "goto cleanup" IN BAILOUT SECTION
    ' PROGRESS BAR STUFF'
    
    ' FOLLOWING VARIABLES USED IF CHECKING FOR ERRORS DURING CODE OPERATION
704:     strProblemReport = "-----------------------------------------\par" & vbCrLf & _
                       "NOTE:  The following problems were found in the dataset:\par" & vbCrLf & _
                       "zzzRunningProblemszzz"
                       
708:     theTimeBegan = Now
709:     dateRunningTime = Now
710:     Set psbar = pApp.StatusBar
711:     Set pPro = psbar.ProgressBar
712:     strHeader = "Calculating General Progress"
713:     strMessage = strHeader
    
    ' INSERT FOLLOWING WHERE YOU WANT TO CREATE THE PROGRESS FORM
716:     If booShowProgress Then
        ' PROGRESS METER STUFF ------------------------------------------------------------------
    
    '  frmProgress.SetExpanded = ext.ProgressDialogSetExpanded
720:       frmProgress.SetExpanded = True
721:       Set ext = GetExtension(pApp)
722:       frmProgress.SetAutoClose = ext.ProgressDialogAutoClose
    
724:       theTimeBegan = Now
725:       frmProgress.ShouldContinue = True
726:       frmProgress.ProgBeginTime = Now
727:       frmProgress.ProgRecCount = lngValCount
728:       frmProgress.lblCurrentTime.Caption = Format(Now, "ttttt")
729:       frmProgress.lblBeginTime.Caption = "Began Job: " & Format(theTimeBegan, "ttttt,  ddddd")
    
731:       theDetailedDescription = "Calculating..." & vbCrLf & _
          "Began Job: " & Format(theTimeBegan, "ttttt,  ddddd") & vbCrLf & _
          "-------------------------------------------" & vbCrLf
734:       frmProgress.txtDetails.Text = theDetailedDescription
735:       frmProgress.txtDetails.SelStart = Len(theDetailedDescription)
    
737:       frmProgress.Frame.Caption = " Current Status:"
738:       frmProgress.Frame.Visible = True
739:       frmProgress.cmdDetails.Visible = True
740:       frmProgress.cmdStop.Visible = True
741:     End If
742:   End If
  
  Dim pCovMatrix As Matrix_jen
  Dim pMeanVector As Matrix_jen
  Dim pTransposeMean As Matrix_jen
  Dim pCorrMatrix As Matrix_jen
  
  Dim pArrayForProjections As esriSystem.IArray
750:   Set pArrayForProjections = New esriSystem.Array
  
  Dim pParamsArray As esriSystem.IVariantArray
  
  Dim strSrcReport As String
  Dim pMeanVectorTable As IStandaloneTable
  Dim pCovMatrixTable As IStandaloneTable
  Dim strError As String
  Dim booExtractSucceeded As Boolean
  
  ' ORGANIZE DATA ==============================================================================================================
  Dim strInputParamsReport As String
762:   If pThisExt.ShouldContinue = False Then
 '   MsgBox "Operation Canceled..."
764:     MahalanobisAtPoints = "Operation Canceled..."
765:     GoTo CleanUp
    
767:   Else
    
769:     Set pParamsArray = pSourceArray.Element(1)
        
771:     Set pMeanVectorTable = pParamsArray.Element(0)
772:     Set pCovMatrixTable = pParamsArray.Element(1)
    
774:     Set pMeanVector = New TopoCorridor.Matrix_jen
775:     pMeanVector.ExtractMatrixFromTable pMeanVectorTable.Table, False, Nothing, booExtractSucceeded, strError
776:     If Not booExtractSucceeded Then
777:       MahalanobisAtPoints = "Operation Failed:" & vbCrLf & "--------------------------------" & vbCrLf & _
        "Failed to Convert Mean Vector Table to Matrix..." & vbCrLf & _
        "Error Message = " & strError
780:       GoTo CleanUp
781:     End If
    
783:     Set pTransposeMean = pMeanVector.Transpose(booExtractSucceeded)
    
785:     Set pCovMatrix = New TopoCorridor.Matrix_jen
786:     pCovMatrix.ExtractMatrixFromTable pCovMatrixTable.Table, False, Nothing, booExtractSucceeded, strError
787:     If Not booExtractSucceeded Then
788:       MahalanobisAtPoints = "Operation Failed:" & vbCrLf & "--------------------------------" & vbCrLf & _
        "Failed to Convert Covariance Table to Matrix..." & vbCrLf & _
        "Error Message = " & strError
791:       GoTo CleanUp
792:     End If
    
794:     strSrcReport = "--> Statistical Tables:" & vbCrLf & _
        "  Mean Vector = " & pMeanVectorTable.Name & vbCrLf & _
        "  Covariance Matrix = " & pCovMatrixTable.Name
        
    ' UPDATE PROGRESS METER ==================================================================
799:     strMessage = "Extracting data from tables..."
800:     psbar.Message(0) = strMessage
801:     pPro.position = 0
802:     lngTimer = 2

804:     If booShowProgress Then
      ' ---- PROGRESS METER STUFF
806:       DoEvents
'          theProgressSpecific = "Working on Step " & CStr(lngTimer) & " of " & CStr(lngValCount) & "..."
808:       theProgressSpecific = strMessage
809:       theDetailedDescription = theDetailedDescription & _
        " --> " & theProgressSpecific & vbCrLf & _
        "          [time stamp " & Format(Now, "ttttt,  ddddd") & "]" & vbCrLf & vbCrLf
812:       frmProgress.ResetShortTimer
813:       frmProgress.txtDetails.Text = theDetailedDescription
814:       frmProgress.txtDetails.SelStart = Len(theDetailedDescription)

816:       frmProgress.Est_Time_Left lngTimer, "Reading Statistical Tables...", "Calculating Data...", False
      ' frmProgress.lblCurrentTime.Caption = Format(Now, "ttttt")
818:       frmProgress.Refresh
819:       frmProgress.icnProgressLine.Refresh
820:       DoEvents
821:       If BailOutOfProgress(frmProgress, pApp) Then

       ' ********************************************************************************************
        ' ALTERNATIVE CODE THAT SAVES PARTIAL TABLE, CHECKS IF ERRORS FOUND AND OUTPUTS RTF INSTEAD OF TEXT
825:         strTimeElapsed = TopoCorridor.MyGeneralOperations.ReturnTimeElapsedRTF(theTimeBegan, Now, 7)

827:         If booFoundProblems Then
828:           MahalanobisAtPoints = strInputParamsReport & "-----------------------------------------\par" & vbCrLf & _
            "NOTE:  Exited Function Prematurely at Step " & CStr(lngTimer) & "\par" & vbCrLf & _
              Replace(strProblemReport, "zzzRunningProblemszzz", strRunningProblems) & vbCrLf & _
            "-----------------------------------------\par" & vbCrLf & _
            "\pard\qc " & strTimeElapsed & vbCrLf & "}"
833:         Else
834:           MahalanobisAtPoints = strInputParamsReport & "-----------------------------------------\par" & vbCrLf & _
            "NOTE:  Exited Function Prematurely at Step " & CStr(lngTimer) & "\par" & vbCrLf & _
            "-----------------------------------------\par" & vbCrLf & _
            "\pard\qc " & strTimeElapsed & vbCrLf & "}"
838:         End If

       ' ********************************************************************************************

842:         frmProgress.cmdStop.Caption = "Close"
843:         pPro.position = 0
844:         psbar.HideProgressBar
845:         GoTo CleanUp
846:       End If
      ' ---- END PROGRESS METER STUFF --------------------------------
848:     End If
    
850:     pArrayForProjections.Add pPointParams

852:   End If
 
854:   strInputParamsReport = strInputParamsReport & "Mean and Covariance Source Options:" & vbCrLf & _
      strSrcReport & vbCrLf & "-----------------------------------------" & vbCrLf

  
  ' MAHALANOBIS OUTPUT OPTIONS
  Dim strReport As String
860:   strReport = "Selected Mahalanobis Output Options:" & vbCrLf
  
  Dim pOutputOptions As esriSystem.IVariantArray
863:   Set pOutputOptions = pThisExt.frmMahalOutputOptions
  Dim lngOutputOption As Long
  Dim pLinkField As IField
  Dim strNewFieldName As String
  
  
  Dim pStringArray As esriSystem.IStringArray
  Dim pMahalField As IField
  Dim pMahalFieldEdit As IFieldEdit
      
  Dim pNewOutputTable As ITable
  Dim lngOutputValueIndex As Long
  Dim lngOutputLinkIndex As Long
  Dim pNewTableFields As esriSystem.IVariantArray
  Dim pClone As IClone
  Dim pNewLinkField As IField
  Dim pNewLinkFieldEdit As IFieldEdit
  
  Dim pNewBuffer As IRowBuffer
  Dim pNewCursor As ICursor
  
  Dim pFCursor As IFeatureCursor
  Dim pFeature As IFeature
  
  ' OPEN EDIT SESSION TO MAKE IT GO FASTER
  Dim pEditor As IEditor
  Dim pID As New UID
890:   pID = "esriEditor.Editor"
891:   Set pEditor = pApp.FindExtensionByCLSID(pID)
  Dim pDataset As IDataset
893:   Set pDataset = pPointFClass
  
  Dim strOutputOptionReport As String
  
897:   lngOutputOption = pOutputOptions.Element(0)
  Select Case lngOutputOption
    Case 0    ' MAKE NEW TABLE
900:       Set pLinkField = pOutputOptions.Element(1)
901:       strReport = strReport & "  --> Option:  SAVE TO NEW TABLE" & vbCrLf & _
                              "    --> Table Workspace = " & CStr(pOutputOptions.Element(2)) & vbCrLf & _
                              "    --> Table Name = " & CStr(pOutputOptions.Element(3)) & vbCrLf & _
                              "    --> Link ID Field = [" & pLinkField.Name & "]" & vbCrLf
      
906:       strOutputOptionReport = "\par  -- Option: \b SAVE TO NEW TABLE\b0" & vbCrLf & _
                              "\par    -- Table Workspace = \b " & Replace(CStr(pOutputOptions.Element(2)), "\", "\\") & "\b0" & vbCrLf & _
                              "\par    -- Table Name = \b " & CStr(pOutputOptions.Element(3)) & "\b0" & vbCrLf & _
                              "\par    -- Link ID Field = \b [" & pLinkField.Name & "]\b0" & vbCrLf
      
      ' CREATE TABLE
912:       Set pNewTableFields = New esriSystem.VarArray
913:       Set pClone = pLinkField
      
      ' MAKE SURE NEW LINK FIELD IS VALID DBASE FIELD, AND IS NOT NAMED "MAHAL"
916:       Set pNewLinkField = pClone.Clone
917:       Set pNewLinkFieldEdit = pNewLinkField
918:       Set pStringArray = New esriSystem.strArray
919:       pStringArray.Add "Mahal"
920:       pNewLinkFieldEdit.Name = TopoCorridor.MyGeneralOperations.ReturnDBASEFieldName(pLinkField.Name, pStringArray)
921:       pNewTableFields.Add pNewLinkField
      
      ' CREATE NEW MAHALANOBIS FIELD
924:       Set pMahalField = New Field
925:       Set pMahalFieldEdit = pMahalField
926:       With pMahalFieldEdit
927:         .Name = "Mahal"
928:         .Type = esriFieldTypeDouble
929:         .Scale = 8
930:         .Precision = 12
931:       End With
932:       pNewTableFields.Add pMahalField
      
934:       Set pNewOutputTable = TopoCorridor.MyGeneralOperations.CreateGeneralTableMahal( _
          pOutputOptions.Element(2), pOutputOptions.Element(3), pOutputOptions.Element(5), _
          pNewTableFields, , False)
      
      ' GET RELEVANT FIELD INDICES
939:       lngOutputValueIndex = pNewOutputTable.FindField("Mahal")
940:       lngOutputLinkIndex = pNewOutputTable.FindField(pNewLinkField.Name)
      
942:       Set pNewBuffer = pNewOutputTable.CreateRowBuffer
943:       Set pNewCursor = pNewOutputTable.Insert(True)
      
    Case 1    ' ADD TO EXISTING FIELD
946:       Set pLinkField = pOutputOptions.Element(1)
947:       strReport = strReport & "  --> Option:  SAVE TO EXISTING FIELD" & vbCrLf & _
                              "    --> Mahalanobis Value Field = [" & pLinkField.Name & "]" & vbCrLf
      
      
951:       strOutputOptionReport = "\par  -- Option: \b SAVE TO EXISTING FIELD\b0" & vbCrLf & _
                              "\par    --\b Mahalanobis Value Field\b0  = [" & pLinkField.Name & "]" & vbCrLf
                              
954:       lngOutputValueIndex = pPointFClass.FindField(pLinkField.Name)
  
956:       If pEditor.EditState <> esriStateNotEditing Then
957:         pEditor.StopEditing True
958:       End If
959:       pEditor.StartEditing pDataset.Workspace
'      Set pFCursor = pPointFClass.Update(Nothing, False)
      
    Case 2    ' CREATE NEW FIELD
963:       strNewFieldName = pOutputOptions.Element(1)
964:       strReport = strReport & "  --> Option:  SAVE TO NEW FIELD" & vbCrLf & _
                              "    --> Mahalanobis Value Field = [" & strNewFieldName & "]" & vbCrLf
      
967:       strOutputOptionReport = "\par  -- Option: \b SAVE TO NEW FIELD\b0 " & vbCrLf & _
                              "\par    --\b Mahalanobis Value Field\b0  = [" & strNewFieldName & "]" & vbCrLf
                              
      ' CREATE NEW MAHALANOBIS FIELD
971:       Set pMahalField = New Field
972:       Set pMahalFieldEdit = pMahalField
973:       With pMahalFieldEdit
974:         .Name = TopoCorridor.MyGeneralOperations.ReturnDBASEFieldName(strNewFieldName, pPointFClass.Fields)
975:         .Type = esriFieldTypeDouble
976:         .Scale = 8
977:         .Precision = 12
978:       End With
979:       pPointFClass.AddField pMahalField
'      Set pFCursor = pPointFClass.Update(Nothing, False)
      
982:       lngOutputValueIndex = pPointFClass.FindField(pMahalField.Name)
  
984:       If pEditor.EditState <> esriStateNotEditing Then
985:         pEditor.StopEditing True
986:       End If
987:       pEditor.StartEditing pDataset.Workspace
      
989:   End Select
  
  
  
  ' MAHALANOBIS VARIABLE OPTIONS
  ' NOTE:  EACH OF THESE SELECTED ITEMS IS AN esriSystem.IVariantArray CONTAINING THE FOLLOWING ITEMS:
  ' 1) IF A RASTER LAYER (i.e. if theArray.Element(1) = "Raster"):
  '    0) Index value of original Raster list item; not useful any more
  '    1) String "Raster", indicating the data type of this item
  '    2) Actual Raster object, original saved as IRasterBandCollection but available as an IRaster
  '    3) Name of Raster Object, as it appeared in original list
  '    4) Band Index; added by this function
  ' 2) IF A POLYGON LAYER (i.e. if theArray.Element(1) = "Polygon"):
  '    0) Index value of original Polygon list item; not useful any more
  '    1) String "Polygon", indicating the data type of this item
  '    2) Actual Polygon Layer
  '    3) Polygon Layer Name
  '    4) Field Index value for selected attribute field
  '    5) Actual selected attribute field
  '    6) Band Index; added by this function

  Dim pVariableNames As esriSystem.IStringArray
1011:   Set pVariableNames = New esriSystem.strArray

  Dim pUnknownBandColl As IRasterBandCollection
  Dim pUnknownBand As IRasterBand
  Dim pField As IField
  Dim strOutputReportList As String
  
1018:   For lngCheckIndex = 0 To pSelectedArray.Count - 1
1019:     Set pSubArray = pSelectedArray.Element(lngCheckIndex)
1020:     Set pUnknown = pSubArray.Element(2)
1021:     pVariableNames.Add pSubArray.Element(3)

1023:     If pSubArray.Element(1) = "Raster" Then
1024:       strOutputReportList = strOutputReportList & "\par    " & CStr(lngCheckIndex + 1) & "] RASTER:\b  " & pSubArray.Element(3) & "\b0" & vbCrLf
1025:       strReport = strReport & "   " & CStr(lngCheckIndex + 1) & "] RASTER: " & pSubArray.Element(3) & vbCrLf ' & _
                              ' "       Dataset is IRaster = " & CStr(TypeOf pUnknown Is IRaster) & vbCrLf

      ' MODIFIED SEPTEMBER 17, 2008 BY JENNESS
      ' OBJECT MIGHT BE A RASTER BAND; IF SO, THEN SWITCH TO RASTER HERE.
1030:       If TypeOf pUnknown Is IRasterBand Then
1031:         Set pUnknownBand = pUnknown
1032:         Set pUnknownBandColl = New Raster
1033:         pUnknownBandColl.AppendBand pUnknownBand
1034:         pSubArray.Remove 2
1035:         pSubArray.Insert 2, pUnknownBandColl
1036:       End If

1038:     Else
1039:       Set pField = pSubArray.Element(5)
 
1041:       strOutputReportList = strOutputReportList & "\par    " & CStr(lngCheckIndex + 1) & "] POLYGON FEATURE LAYER:\b  " & pSubArray.Element(3) & "\b0" & vbCrLf & _
                              "\par        Attribute Field:  Name = " & pField.Name & vbCrLf
1043:       strReport = strReport & "   " & CStr(lngCheckIndex + 1) & "] POLYGON FEATURE LAYER: " & pSubArray.Element(3) & vbCrLf & _
                              "       Attribute Field:  Name = " & pField.Name & vbCrLf ' & ",   Index = " & pSubArray.Element(4) & vbCrLf & _
                              '"       Dataset is IFeatureLayer = " & CStr(TypeOf pUnknown Is IFeatureLayer) & vbCrLf
1046:     End If
1047:   Next lngCheckIndex

1049:   strInputParamsReport = strInputParamsReport & "Mahalanobis Input Variable Options:" & vbCrLf & _
      strReport & vbCrLf & "-----------------------------------------" & vbCrLf


  ' ADD MAHALANOBIS VARIABLE ARRAYS
1054:   pArrayForProjections.Add pSelectedArray

  ' =========================================================================================================================
  ' UNIFY PROJECTIONS =======================================================================================================
  ' =========================================================================================================================
  
  ' ACTUALLY, DON'T UNIFY DATASET PROJECTIONS IN THIS CASE!  ONLY REPROJECT POINTS IF NEEDED
  
  Dim strReturnMessage As String
  Dim booShouldStop As Boolean

  Dim pCommonProjectionArray As esriSystem.IArray
1066:   Set pCommonProjectionArray = UnifyProjectionsPointsToLayers(pArrayForProjections, pApp, pThisExt, strMessage, _
      psbar, pPro, lngTimer, theProgressSpecific, theDetailedDescription, strTimeElapsed, booFoundProblems, _
      strReturnMessage, booShouldStop, theTimeBegan, booExact)
  
1070:   lngTimer = lngTimer + pSelectedArray.Count
1071:   If booShouldStop Then
1072:     MahalanobisAtPoints = MahalanobisAtPoints & vbCrLf & strReturnMessage
1073:     GoTo CleanUp
1074:   End If

'  Dim pCommonSpRef As ISpatialReference
'  Set pCommonSpRef = pCommonProjectionArray.Element(2)

1079:   If pCommonProjectionArray Is Nothing Then
1080:     MahalanobisAtPoints = MahalanobisAtPoints & vbCrLf & "Operation Failed:" & vbCrLf & "--------------------------------" & vbCrLf & _
      "Failed to Convert all data sources into a common projection..." & vbCrLf
1082:     GoTo CleanUp
1083:   End If

  ' CONTENTS OF pCommonProjectionArray ARE:
  ' 1) pPointData AS esriSystem.VarArray
  '    a) pOIDArray AS esriSystem.ILongArray
  '    b) pPointSet AS Multipoint (IPointCollection)
  ' 2) pMahalData AS esriSystem.VarArray CONTAINING MULTIPLE esriSystem.IVariantArrays, EACH CONTAINING THE FOLLOWING ITEMS:
  '    a) IF A RASTER LAYER (i.e. if theArray.Element(1) = "Raster"):
  '       0) pPointSet AS Multipoint (IPointCollection), PROJECTED INTO THIS DATASET SPATIAL REFERENCE
  '       1) String "Raster", indicating the data type of this item
  '       2) Raster Dataset Version of Actual Raster object
  '       3) Name of Raster Object, as it appeared in original list
  '       4) Band Index; added by this function
  '       5) varValues; IVariantArray of values at each point
  '    b) IF A POLYGON LAYER (i.e. if theArray.Element(1) = "Polygon"):
  '       0) pPointSet AS Multipoint (IPointCollection), PROJECTED INTO THIS DATASET SPATIAL REFERENCE
  '       1) String "Polygon", indicating the data type of this item
  '       2) Actual Polygon Layer
  '       3) Polygon Layer Name
  '       4) Field Index value for selected attribute field
  '       5) Actual selected attribute field
  '       6) Band Index; added by this function
  '       7) varValues; IVariantArray of values at each point
  ' 3) pCommonSpRef = SPATIAL REFERENCE OF ORIGINAL POINT DATA


  ' =========================================================================================================================
  ' STATISTICAL MATRICES ====================================================================================================
  ' =========================================================================================================================
  
  Dim strDebugReport As String
1114:   strDebugReport = "Means:" & vbCrLf & pMeanVector.MakeText & vbCrLf & vbCrLf
  
  Dim booStringError As Boolean
  Dim strMeanVector As String
1118:   strMeanVector = pMeanVector.MakeTextWithHeaders(pVariableNames, False, True, booStringError, 6, _
      "Mahanalobis Mean Vector [Source = " & pMeanVectorTable.Name & "]")

  Dim strCovMatrix As String
1122:   strCovMatrix = pCovMatrix.MakeTextWithHeaders(pVariableNames, True, True, booStringError, 6, _
      "Mahanalobis Covariance Matrix [Source = " & pCovMatrixTable.Name & "]")

1125:   strDebugReport = strDebugReport & "Covariance:" & vbCrLf & pCovMatrix.MakeText & vbCrLf & vbCrLf

  ' INVERT COVARIANCE MATRIX
  Dim pInvCovMatrix As Matrix_jen
  Dim bytInvertSucceeded As Byte

1131:   If booShowProgress Then
    ' UPDATE PROGRESS METER ==================================================================
1133:     strMessage = "Inverting Covariance Matrix..."
1134:     psbar.Message(0) = strMessage
1135:     pPro.position = 0
1136:     lngTimer = lngTimer + 1

    ' ---- PROGRESS METER STUFF
1139:     DoEvents
1140:     theProgressSpecific = strMessage
1141:     theDetailedDescription = theDetailedDescription & _
      " --> Inverting Covariance Matrix..." & vbCrLf & _
      "          [time stamp " & Format(Now, "ttttt,  ddddd") & "]" & vbCrLf & vbCrLf
1144:     frmProgress.ResetShortTimer
1145:     frmProgress.txtDetails.Text = theDetailedDescription
1146:     frmProgress.txtDetails.SelStart = Len(theDetailedDescription)

1148:     frmProgress.Est_Time_Left lngTimer, "Inverting Covariance Matrix...", "Calculating Data...", False
    ' frmProgress.lblCurrentTime.Caption = Format(Now, "ttttt")
1150:     frmProgress.Refresh
1151:     frmProgress.icnProgressLine.Refresh
1152:     DoEvents
1153:     If BailOutOfProgress(frmProgress, pApp) Then

     ' ********************************************************************************************
      ' ALTERNATIVE CODE THAT SAVES PARTIAL TABLE, CHECKS IF ERRORS FOUND AND OUTPUTS RTF INSTEAD OF TEXT
1157:       strTimeElapsed = TopoCorridor.MyGeneralOperations.ReturnTimeElapsedRTF(theTimeBegan, Now, 7)

1159:       If booFoundProblems Then
1160:         MahalanobisAtPoints = strInputParamsReport & "-----------------------------------------\par" & vbCrLf & _
          "NOTE:  Exited Function Prematurely at Step " & CStr(lngTimer) & "\par" & vbCrLf & _
            Replace(strProblemReport, "zzzRunningProblemszzz", strRunningProblems) & vbCrLf & _
          "-----------------------------------------\par" & vbCrLf & _
          "\pard\qc " & strTimeElapsed & vbCrLf & "}"
1165:       Else
1166:         MahalanobisAtPoints = strInputParamsReport & "-----------------------------------------\par" & vbCrLf & _
          "NOTE:  Exited Function Prematurely at Step " & CStr(lngTimer) & "\par" & vbCrLf & _
          "-----------------------------------------\par" & vbCrLf & _
          "\pard\qc " & strTimeElapsed & vbCrLf & "}"
1170:       End If

     ' ********************************************************************************************

1174:       frmProgress.cmdStop.Caption = "Close"
1175:       pPro.position = 0
1176:       psbar.HideProgressBar
1177:       GoTo CleanUp
1178:     End If
    ' ---- END PROGRESS METER STUFF --------------------------------
1180:   End If

1182:   Set pInvCovMatrix = pCovMatrix.Invert(bytInvertSucceeded)
  ' MODIFIES BYTE VALUE
  '   0) IF OPERATION SUCCESSFUL
  '   1) FAILED AT MatrixLUDecomp_jen BECAUSE OF NON-SQUARE MATRIX
  '   2) FAILED AT MatrixLUDecomp_jen BECAUSE OF SINGULAR MATRIX
  '   3) FAILED AT MatrixFBSub_jen BECAUSE OF UNKNOWN REASONS

  Dim strInvCovMatrix As String
  
  
1192:   strDebugReport = strDebugReport & "Inverse Covariance:" & vbCrLf & pInvCovMatrix.MakeText & vbCrLf & vbCrLf
  
  Select Case bytInvertSucceeded
    Case 1
1196:       MahalanobisAtPoints = "Operation Failed:" & vbCrLf & "--------------------------------" & vbCrLf & _
        "  --> Failed to invert covariance matrix:" & vbCrLf & _
        "  --> FAILED AT MatrixLUDecomp_jen because of Non-Square Matrix..." & vbCrLf & _
        strMeanVector & vbCrLf & strCovMatrix
1200:       GoTo CleanUp
    Case 2
1202:       MahalanobisAtPoints = "Operation Failed:" & vbCrLf & "--------------------------------" & vbCrLf & _
        "  --> Failed to invert covariance matrix:" & vbCrLf & _
        "  --> FAILED AT MatrixLUDecomp_jen because of Singular Matrix..." & vbCrLf & _
        "     This is generally due to one variable having NO variance at all (i.e. all sample " & _
        "point values are the same)." & vbCrLf & vbCrLf & _
        strMeanVector & vbCrLf & strCovMatrix
1208:       GoTo CleanUp
    Case 3
1210:       MahalanobisAtPoints = "Operation Failed:" & vbCrLf & "--------------------------------" & vbCrLf & _
        "  --> Failed to invert covariance matrix:" & vbCrLf & _
        "  --> FAILED AT MatrixFBSub_jen (Back-Substitution Step) because of unknown reasons..." & vbCrLf & _
        strMeanVector & vbCrLf & strCovMatrix
1214:       GoTo CleanUp
    Case Else         ' SUCCEEDED
1216:       strInvCovMatrix = pInvCovMatrix.MakeTextWithHeaders(pVariableNames, True, True, booStringError, 6, _
          "Mahanalobis Inverse Covariance Matrix") & vbCrLf & vbCrLf
1218:   End Select

  ' TEST INVERSION
  Dim pMultMatrix As Matrix_jen
1222:   Set pMultMatrix = pCovMatrix.Multiply(pInvCovMatrix, True)
  Dim strMultMatrix As String
1224:   strMultMatrix = pMultMatrix.MakeTextWithHeaders(pVariableNames, True, True, booStringError, 3, _
      "Check Multiplication") & vbCrLf & vbCrLf

1227:   strDebugReport = strDebugReport & "Multiply:" & vbCrLf & pMultMatrix.MakeText & vbCrLf & vbCrLf
  
  ' CORRELATION
  Dim strCorrMatrix As String
1231:   If pThisExt.StatsSaveCorrelation Then
1232:     strCorrMatrix = pCorrMatrix.MakeTextWithHeaders(pVariableNames, True, True, booStringError, 3, _
        "Correlation Matrix") & vbCrLf & vbCrLf
1234:   Else
1235:     strCorrMatrix = ""
1236:   End If

1238:   MahalanobisAtPoints = MahalanobisAtPoints & _
    strMeanVector & _
    strCovMatrix & _
    strInvCovMatrix & _
    strMultMatrix & _
    strCorrMatrix & vbCrLf & strDebugReport


'  ' =========================================================================================================================
'  ' GENERATE MAHALANOBIS VALUES =============================================================================================
'  ' =========================================================================================================================
  Dim booSucceed As Boolean
  Dim pMeanTranspose As Matrix_jen
1251:   Set pMeanTranspose = pMeanVector.Transpose(booSucceed)
1252:   MahalanobisAtPoints = MahalanobisAtPoints & "Means Transposed: " & vbCrLf & pMeanTranspose.MakeText & vbCrLf
  
  Dim lngIndex2 As Long
  Dim pPointData As esriSystem.IVariantArray
  Dim pOIDArray As esriSystem.ILongArray
  Dim pPointSet As IPointCollection
  
  Dim pMahalData As esriSystem.IVariantArray
1260:   Set pMahalData = pCommonProjectionArray.Element(1)
  Dim pMahalSubArray As esriSystem.IVariantArray
  Dim pMahalPts As IPointCollection
  Dim strMahalType As String
  Dim pRasterDataset As IRasterDataset
  Dim pRasterBandColl As IRasterBandCollection
  Dim varValues As esriSystem.IVariantArray
  
  Dim dblValue As Double
  Dim varVal As Variant
  
  Dim lngPointOID As Long
  
1273:   Set pPointData = pCommonProjectionArray.Element(0)
1274:   Set pOIDArray = pPointData.Element(0)
1275:   Set pPointSet = pPointData.Element(1)
  
  Dim booAbleToCalcVal As Boolean
  Dim strCalcValErrors As String
  
1280:   strCalcValErrors = "\par -------------------------------" & vbNewLine & _
                     "\par\b WARNING:\b0  Missing data for the following Point OID values:" & vbCrLf
  
  Dim pNumMatrix As Matrix_jen
  Dim pCheckPoint As IPoint
  Dim strLayerName As String
  
  Dim dblVals() As Double
  ReDim dblVals(0, pInvCovMatrix.Columns - 1)
  
  Dim pDevFromMean As Matrix_jen
  Dim pMult1 As Matrix_jen
  Dim pMult2 As Matrix_jen
  Dim dblMahal As Double
  Dim lngFail As Long
  
  Dim strPrefix As String
  Dim strSuffix As String
1298:   booSucceed = TopoCorridor.MyGeneralOperations.ReturnQueryStringPrefixSuffix(pPointFClass, strPrefix, strSuffix)
  
  Dim lngShortTimer As Long
  Dim lngPointFullCount As Long
1302:   lngPointFullCount = pPointSet.PointCount
  
1304:   If booShowProgress Then
   ' UPDATE PROGRESS METER ==================================================================
1306:    strMessage = "Calculating Mahalanobis Distance Values..."
1307:    psbar.ShowProgressBar strMessage, 0, lngPointFullCount, 1, True
1308:    pPro.position = 0
   
1310:    lngShortTimer = 0
   
       ' UPDATE PROGRESS METER ==================================================================
1313:     lngTimer = lngTimer + 1
    
    ' ---- PROGRESS METER STUFF
1316:     DoEvents
1317:     theProgressSpecific = strMessage
1318:     theDetailedDescription = theDetailedDescription & _
      " --> Calculating Mahalanobis Values..." & vbCrLf & _
      "          [time stamp " & Format(Now, "ttttt,  ddddd") & "]" & vbCrLf & vbCrLf
1321:     frmProgress.ResetShortTimer
1322:     frmProgress.txtDetails.Text = theDetailedDescription
1323:     frmProgress.txtDetails.SelStart = Len(theDetailedDescription)
    
1325:     frmProgress.Est_Time_Left lngTimer, "Inverting Covariance Matrix...", "Calculating Data...", False
    ' frmProgress.lblCurrentTime.Caption = Format(Now, "ttttt")
1327:     frmProgress.Refresh
1328:     frmProgress.icnProgressLine.Refresh
1329:     DoEvents
1330:     If BailOutOfProgress(frmProgress, pApp) Then
  
     ' ********************************************************************************************
      ' ALTERNATIVE CODE THAT SAVES PARTIAL TABLE, CHECKS IF ERRORS FOUND AND OUTPUTS RTF INSTEAD OF TEXT
1334:       strTimeElapsed = TopoCorridor.MyGeneralOperations.ReturnTimeElapsedRTF(theTimeBegan, Now, 7)
  
1336:       If booFoundProblems Then
1337:         MahalanobisAtPoints = strInputParamsReport & "-----------------------------------------\par" & vbCrLf & _
          "NOTE:  Exited Function Prematurely at Step " & CStr(lngTimer) & "\par" & vbCrLf & _
            Replace(strProblemReport, "zzzRunningProblemszzz", strRunningProblems) & vbCrLf & _
          "-----------------------------------------\par" & vbCrLf & _
          "\pard\qc " & strTimeElapsed & vbCrLf & "}"
1342:       Else
1343:         MahalanobisAtPoints = strInputParamsReport & "-----------------------------------------\par" & vbCrLf & _
          "NOTE:  Exited Function Prematurely at Step " & CStr(lngTimer) & "\par" & vbCrLf & _
          "-----------------------------------------\par" & vbCrLf & _
          "\pard\qc " & strTimeElapsed & vbCrLf & "}"
1347:       End If
  
     ' ********************************************************************************************
  
1351:       frmProgress.cmdStop.Caption = "Close"
1352:       pPro.position = 0
1353:       psbar.HideProgressBar
1354:       GoTo CleanUp
1355:     End If
    ' ---- END PROGRESS METER STUFF --------------------------------
1357:   End If
  
  Dim booMissingDataProblems As Boolean
1360:   booMissingDataProblems = False
1361:   For lngIndex = 0 To lngPointFullCount - 1
    
1363:     pPro.Step
    
1365:     booAbleToCalcVal = True
1366:     lngPointOID = pOIDArray.Element(lngIndex)
    
1368:     MahalanobisAtPoints = MahalanobisAtPoints & " --> Point ID " & CStr(lngPointOID) & "] "
    
1370:     Set pNumMatrix = New Matrix_jen
  '  pNumMatrix..Rows = 1
  '  pNumMatrix.Columns = pInvCovMatrix.Columns
    
1374:     For lngIndex2 = 0 To pMahalData.Count - 1
1375:       Set pMahalSubArray = pMahalData.Element(lngIndex2)
1376:       Set pMahalPts = pMahalSubArray.Element(0)
1377:       strMahalType = pMahalSubArray.Element(1)
1378:       strLayerName = pMahalSubArray.Element(3)
      
1380:       If strMahalType = "Raster" Then
1381:         Set pRasterDataset = pMahalSubArray.Element(2)
1382:         Set varValues = pMahalSubArray.Element(5)
1383:       Else
1384:         Set varValues = pMahalSubArray.Element(7)
1385:       End If
      
1387:       varVal = varValues.Element(lngIndex)
1388:       If IsNull(varVal) Then
1389:         booAbleToCalcVal = False
1390:         booMissingDataProblems = True
1391:         strCalcValErrors = strCalcValErrors & _
              "\par    -- POINT OID = " & CStr(lngPointOID) & "] Missing " & strLayerName & vbCrLf
1393:         dblValue = -9999
1394:       Else
1395:         dblValue = CDbl(varVal)
1396:         dblVals(0, lngIndex2) = dblValue
1397:       End If
      
1399:       MahalanobisAtPoints = MahalanobisAtPoints & "[" & CStr(Format(dblValue, "0.000")) & "], "
1400:     Next lngIndex2
          
1402:     MahalanobisAtPoints = Left(MahalanobisAtPoints, Len(MahalanobisAtPoints) - 2) & vbCrLf
    
    ' ONLY CALCULATE MAHALANOBIS VALUE IF ALL VARIABLES HAVE DATA
1405:     If booAbleToCalcVal Then
1406:       pNumMatrix.MatrixArray = dblVals
1407:       MahalanobisAtPoints = MahalanobisAtPoints & pNumMatrix.MakeText & vbCrLf
1408:       Set pDevFromMean = pNumMatrix.Subtract(pMeanTranspose, booSucceed)
1409:       If booSucceed Then
1410:         MahalanobisAtPoints = MahalanobisAtPoints & pDevFromMean.MakeText & vbCrLf
1411:         Set pMult1 = pDevFromMean.Multiply(pInvCovMatrix, booSucceed)
1412:         If booSucceed Then
1413:           Set pMult2 = pMult1.Multiply(pDevFromMean.Transpose(booSucceed), booSucceed)
1414:         End If
1415:       End If
1416:       If booSucceed Then
1417:         dblMahal = pMult2.ReturnCellValue(1, 1, lngFail)
1418:         MahalanobisAtPoints = MahalanobisAtPoints & "Mahalanobis Value = " & CStr(dblMahal) & vbCrLf & vbCrLf
        
        Select Case lngOutputOption
          Case 0
1422:             pNewBuffer.Value(lngOutputLinkIndex) = lngPointOID            ' <-----
1423:             pNewBuffer.Value(lngOutputValueIndex) = dblMahal
1424:             pNewCursor.InsertRow pNewBuffer
          Case 1, 2
            Dim pQueryFilter As IQueryFilter
1427:             Set pQueryFilter = New QueryFilter
1428:             pQueryFilter.WhereClause = strPrefix & pPointFClass.OIDFieldName & strSuffix & " = " & CStr(lngPointOID)
1429:             Set pFCursor = pPointFClass.Update(pQueryFilter, False)
1430:             Set pFeature = pFCursor.NextFeature
1431:             pFeature.Value(lngOutputValueIndex) = dblMahal
1432:             pFCursor.UpdateFeature pFeature                               ' <-----
1433:         End Select
1434:       End If
1435:     End If
1436:   Next lngIndex

' MAKE TABLE AND ADD TO MAP DOCUMENT
  Dim pNewStandaloneTable As IStandaloneTable
  Dim pTableWindow2 As ITableWindow2
  Dim pStandaloneTableCollection As IStandaloneTableCollection
  Select Case lngOutputOption
    Case 0
1444:       pNewCursor.Flush
    
1446:       Set pNewStandaloneTable = New StandaloneTable
1447:       Set pNewStandaloneTable.Table = pNewOutputTable
    
1449:       Set pTableWindow2 = New TableWindow
    
1451:       With pTableWindow2
1452:         Set .StandaloneTable = pNewStandaloneTable
1453:         Set .Application = pApp
1454:         .TableSelectionAction = esriSelectFeatures
1455:         .ShowAliasNamesInColumnHeadings = True
1456:         .ShowSelected = False
1457:         .Show True
1458:       End With
1459:       Set pStandaloneTableCollection = pMxDoc.FocusMap
1460:       pStandaloneTableCollection.AddStandaloneTable pNewStandaloneTable
      
    Case 1, 2
1463:       pFCursor.Flush
1464:       pEditor.StopEditing True
      
1466:   End Select
  
  
  ' RESET ORIGINAL SELECTION
'  MsgBox "booHasASelection = " & booHasASelection
1471:   MahalanobisAtPoints = MahalanobisAtPoints & vbCrLf & "Selection Set:" & vbCrLf
1472:   If booHasASelection Then
1473:     Set pCurrentSelSet = pFSel.SelectionSet
'    pCurrentSelSet.AddList UBound(lngOIDs) + 1, lngOIDs
1475:     For lngIndex = 0 To UBound(lngOIDs)
1476:       pCurrentSelSet.Add lngOIDs(lngIndex)
1477:       MahalanobisAtPoints = MahalanobisAtPoints & CStr(lngIndex) & "]  OID = " & CStr(lngOIDs(lngIndex)) & vbCrLf
1478:     Next lngIndex
1479:     pCurrentSelSet.Refresh
1480:   End If
  
  ' REFRESH TABLE WINDOW IF OPEN
1483:   Set pTableWindow2 = New TableWindow
  Dim pTableWindow As ITableWindow
1485:   pTableWindow2.FindViaLayer pPointLayer
1486:   If Not pTableWindow2 Is Nothing Then
1487:     pTableWindow2.Refresh
1488:     pTableWindow2.UpdateSelection pCurrentSelSet
1489:     pTableWindow2.Refresh
1490:     pTableWindow2.Show False
1491:     pMxDoc.UpdateContents
    
1493:     Set pTableWindow = New TableWindow
1494:     With pTableWindow
1495:       Set .FeatureLayer = pPointLayer
1496:       Set .Application = pApp
1497:       .TableSelectionAction = esriSelectFeatures
1498:       .ShowAliasNamesInColumnHeadings = True
1499:       .Show True
1500:     End With
1501:   End If
  
  ' INSERT FOLLOWING WHERE YOU WANT PROGRESS FORM TO BE CLOSED
  ' NOTE THAT THIS FUNCTION CALLS ON MyGeneralOperations.ReturnTimeElapsed!
1505:   pPro.position = 0
1506:   psbar.HideProgressBar
1507:   If booShowProgress Then
    
1509:     If frmProgress.chkClose.Value = 1 Then
1510:       frmProgress.Frame.Visible = False
1511:       Set frmProgress = Nothing
1512:       Set pThisExt.ProgressMeterForm = Nothing
1513:     Else
1514:       frmProgress.Est_Time_Left lngValCount, "Calculations Complete...", "Calculating Data...", False
1515:       theProgressSpecific = "Calculations Complete..."
1516:       theDetailedDescription = theDetailedDescription & _
        " --> " & theProgressSpecific & vbCrLf & _
        "          [time stamp " & Format(Now, "ttttt,  ddddd") & "]" & vbCrLf & vbCrLf & _
      TopoCorridor.MyGeneralOperations.ReturnTimeElapsed(theTimeBegan, Now)
1520:       frmProgress.txtDetails.Text = theDetailedDescription
1521:       frmProgress.txtDetails.SelStart = Len(theDetailedDescription)
1522:       frmProgress.cmdStop.Caption = "Close"
1523:       frmProgress.Refresh
1524:     End If
1525:   End If
  
  
  ' IF WE'VE MADE IT THIS FAR, ASSUME THAT OPERATION IS SUCCESSFULL AND WRITE CORRECT RETURN REPORT
  Dim strBaseString As String
1530:   strBaseString = strBaseString & "{\rtf1\ansi\ansicpg1252\deff0\deflang1033{\fonttbl{\f0\fswiss\fcharset0 Arial;}{\f1\fmodern\fprq1\fcharset0 Courier New;}{\f2\fnil\fcharset0 MS Sans Serif;}}" & vbNewLine
1531:   strBaseString = strBaseString & "\viewkind4\uc1\pard\qc\b\f0\fs16 -- Mahalanobis at Points Complete --" & vbNewLine
1532:   strBaseString = strBaseString & "\par ----------------------\b0 " & vbNewLine
1533:   strBaseString = strBaseString & "\par \pard\b Points Layer:\b0  zzzPointsLayerzzz" & vbNewLine
1534:   strBaseString = strBaseString & "\par\b Only Analyze Selected:\b0   zzzUseSelectedzzz" & vbNewLine
1535:   strBaseString = strBaseString & "\par\b Analysis Point Count:\b0   zzzPointCountzzz" & vbNewLine
1536:   strBaseString = strBaseString & "\par\b Statistical Matrices:\b0 " & vbNewLine
1537:   strBaseString = strBaseString & "\par \f1 zzzStatMatrices\f0 " & vbNewLine
1538:   strBaseString = strBaseString & "\par -------------------------------" & vbNewLine
1539:   strBaseString = strBaseString & "\par\b Input Layers (In Order):\b0 " & vbNewLine
1540:   strBaseString = strBaseString & "zzzInputLayerszzz" & vbNewLine
1541:   strBaseString = strBaseString & "\par " & vbNewLine
1542:   strBaseString = strBaseString & "\par\b Raster Cell Value Option:\b0  zzzExtractOption" & vbNewLine
1543:   strBaseString = strBaseString & "\par -------------------------------" & vbNewLine
1544:   strBaseString = strBaseString & "\par\b Output Option:\b0  zzzOutputOption" & vbNewLine
1545:   strBaseString = strBaseString & "\par zzzProblemReport " & vbNewLine
1546:   strBaseString = strBaseString & "\par \pard\qc -------------------------------" & vbNewLine
1547:   strBaseString = strBaseString & "\par zzzTimeSpentzzz\fs20 " & vbNewLine
1548:   strBaseString = strBaseString & "\par \pard\f2\fs17 " & vbNewLine
1549:   strBaseString = strBaseString & "\par }" & vbNewLine
1550:   strBaseString = strBaseString & " " & vbNewLine


1553:   strBaseString = Replace(strBaseString, "zzzPointsLayerzzz", pPointLayer.Name)
1554:   strBaseString = Replace(strBaseString, "zzzUseSelectedzzz", UCase(CStr(Not booUseAll)))
1555:   strBaseString = Replace(strBaseString, "zzzPointCountzzz", CStr(lngPointFullCount))
  
  Dim strMatricesReport As String
1558:   strMatricesReport = strMeanVector & Chr(13) & " ---- " & Chr(13) & strCovMatrix
  Dim strText() As String
1560:   strText = Split(strMatricesReport, Chr(13))
1561:   strMatricesReport = ""
  Dim strLine As String
1563:   For lngIndex = 0 To UBound(strText)
1564:     strLine = strText(lngIndex)
1565:     strLine = Trim(strLine)
1566:     If strLine <> "" Then
1567:       strMatricesReport = strMatricesReport & "\par     " & strText(lngIndex) & vbCrLf
1568:     End If
1569:   Next lngIndex
1570:   strBaseString = Replace(strBaseString, "zzzStatMatrices", strMatricesReport)
1571:   strBaseString = Replace(strBaseString, "zzzInputLayerszzz", strOutputReportList)
1572:   If booExact Then
1573:     strBaseString = Replace(strBaseString, "zzzExtractOption", "Use Exact Cell Value")
1574:   Else
1575:     strBaseString = Replace(strBaseString, "zzzExtractOption", "Interpolate from Four Points")
1576:   End If
1577:   strBaseString = Replace(strBaseString, "zzzOutputOption", strOutputOptionReport)
  
1579:   If booMissingDataProblems Then
1580:     strBaseString = Replace(strBaseString, "zzzProblemReport", strCalcValErrors)
1581:   Else
1582:     strBaseString = Replace(strBaseString, "zzzProblemReport", "")
1583:   End If
  
1585:   strBaseString = Replace(strBaseString, "zzzTimeSpentzzz", TopoCorridor.MyGeneralOperations.ReturnTimeElapsedRTF(datBegan, Now, 7))
  
1587:   MahalanobisAtPoints = strBaseString
  
1589:   pMxDoc.ActivatedView.PartialRefresh esriViewGeoSelection, Nothing, Nothing
1590:   pMxDoc.UpdateContents
  
1592:   GoTo CleanUp
ErrorHandler:
  HandleError True, "MahalanobisAtPoints " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4

CleanUp:

1598:   Set pSelectedArray = Nothing
1599:   Set pSubArray = Nothing
1600:   Set pUnknown = Nothing
1601:   Set pOptions = Nothing
1602:   Set pSourceArray = Nothing
1603:   Set pPointParams = Nothing
1604:   Set pPointLayer = Nothing
1605:   Set pPointFClass = Nothing
1606:   Set pEnumOIDs = Nothing
1607:   Set pCurrentSelSet = Nothing
1608:   Set pFSel = Nothing
1609:   Set pStatsParams = Nothing
1610:   Set pMeanST = Nothing
1611:   Set pCovST = Nothing
1612:   Set frmProgress = Nothing
1613:   Set psbar = Nothing
1614:   Set pPro = Nothing
1615:   Set ext = Nothing
1616:   Set pCovMatrix = Nothing
1617:   Set pMeanVector = Nothing
1618:   Set pTransposeMean = Nothing
1619:   Set pCorrMatrix = Nothing
1620:   Set pArrayForProjections = Nothing
1621:   Set pParamsArray = Nothing
1622:   Set pMeanVectorTable = Nothing
1623:   Set pCovMatrixTable = Nothing
1624:   Set pOutputOptions = Nothing
1625:   Set pLinkField = Nothing
1626:   Set pStringArray = Nothing
1627:   Set pMahalField = Nothing
1628:   Set pMahalFieldEdit = Nothing
1629:   Set pNewOutputTable = Nothing
1630:   Set pNewTableFields = Nothing
1631:   Set pClone = Nothing
1632:   Set pNewLinkField = Nothing
1633:   Set pNewLinkFieldEdit = Nothing
1634:   Set pNewBuffer = Nothing
1635:   Set pNewCursor = Nothing
1636:   Set pFCursor = Nothing
1637:   Set pFeature = Nothing
1638:   Set pEditor = Nothing
1639:   Set pID = Nothing
1640:   Set pDataset = Nothing
1641:   Set pVariableNames = Nothing
1642:   Set pUnknownBandColl = Nothing
1643:   Set pUnknownBand = Nothing
1644:   Set pField = Nothing
1645:   Set pCommonProjectionArray = Nothing
1646:   Set pInvCovMatrix = Nothing
1647:   Set pMultMatrix = Nothing
1648:   Set pMeanTranspose = Nothing
1649:   Set pPointData = Nothing
1650:   Set pOIDArray = Nothing
1651:   Set pPointSet = Nothing
1652:   Set pMahalData = Nothing
1653:   Set pMahalSubArray = Nothing
1654:   Set pMahalPts = Nothing
1655:   Set pRasterDataset = Nothing
1656:   Set pRasterBandColl = Nothing
1657:   Set varValues = Nothing
1658:   Set pNumMatrix = Nothing
1659:   Set pCheckPoint = Nothing
1660:   Set pDevFromMean = Nothing
1661:   Set pMult1 = Nothing
1662:   Set pMult2 = Nothing
1663:   Set pQueryFilter = Nothing
1664:   Set pNewStandaloneTable = Nothing
1665:   Set pTableWindow2 = Nothing
1666:   Set pStandaloneTableCollection = Nothing
1667:   Set pTableWindow = Nothing


End Function

Public Function MahalanobisRaster(pThisExt As TopoCorridor.clsExtension, pApp As IApplication, _
  pMxDoc As IMxDocument) As String
  On Error GoTo ErrorHandler

1676:   pApp.RefreshWindow
    
  Dim datBegan As Date
1679:   datBegan = Now
    
  ' FOR DEBUGGING - MAHALANOBIS INPUT VARIABLES
  Dim lngCheckIndex As Long
  Dim pSelectedArray As esriSystem.IVariantArray
  Dim pSubArray As esriSystem.IVariantArray
  Dim pUnknown As IUnknown
  Dim pOptions As esriSystem.IVariantArray
  Dim strMahal As String
  Dim strWS As String
  Dim lngWSType As JenDatasetTypes
  Dim booExact As Boolean
  
  Dim strUseExactText As String
  
1694:   Set pOptions = pThisExt.frmGridLayersReturn
1695:   Set pSelectedArray = pOptions.Element(0)
1696:   booExact = pOptions.Element(1)
1697:   strWS = pOptions.Element(2)
1698:   lngWSType = pOptions.Element(3)
1699:   strMahal = pOptions.Element(4)
  
  Dim pSourceArray As esriSystem.IVariantArray
  Dim lngType As Long
1703:   Set pSourceArray = pThisExt.frmCovSourceReturn
1704:   lngType = pSourceArray.Element(0)
    
  ' FOR PROGRESS METER --------------------------------------------------------------
  Dim booShowProgress As Boolean
  Dim frmProgress As TopoCorridor.frmJenProgressMeter
1709:   Set frmProgress = pThisExt.ProgressMeterForm
1710:   booShowProgress = CBool(Not frmProgress Is Nothing)
  
  ' ESTIMATE TOTAL NUMBER OF STEPS REQUIRED
  ' 2 FOR UNIFYING PROJECTIONS; 1 FOR SOURCE AND 1 FOR VARIABLES
  ' 1 FOR EXTRACTING DATA, ADD 1 FOR EXTRACTING FROM RASTER
  ' 1 FOR CALCULATING STATISTICAL MATRICES
  ' 1 FOR INVERTING COVARIANCE MATRIX
  ' 1 FOR X-MINUS-MEANS MATRIX
  ' N FOR MULTIPLYING X-MINUS-MEANS BY MATRIX
  ' 1 FOR LAST ROUND OF MULTIPLICATION
  
  Dim lngValCount As Long
1722:   lngValCount = pSelectedArray.Count + 7
1723:   If lngType = 2 Then lngValCount = lngValCount + 1
  Dim booFoundProblems As Boolean
  Dim strProblemReport As String
  Dim strRunningProblems As String
  Dim strTimeElapsed As String
  Dim lngTimer As Long
  Dim theTimeBegan As Date
  Dim dateRunningTime As Date
  Dim psbar As IStatusBar
  Dim pPro As IStepProgressor
  Dim strHeader As String
  Dim strMessage As String
  Dim theDetailedDescription As String
  Dim theProgressSpecific As String
  Dim ext As TopoCorridor.clsExtension
  
1739:   If booShowProgress Then
    ' FOLLOWING CODE SHOULD BE INSERTED INTO A FUNCTION.  NEEDS MINOR EDITS IF GOING INTO A SUBROUTINE
    ' SPECIFICALLY, CHANGE "goto cleanup" to "goto cleanup" IN BAILOUT SECTION
    ' PROGRESS BAR STUFF'
    
    ' FOLLOWING VARIABLES USED IF CHECKING FOR ERRORS DURING CODE OPERATION
1745:     strProblemReport = "-----------------------------------------\par" & vbCrLf & _
                       "NOTE:  The following problems were found in the dataset:\par" & vbCrLf & _
                       "zzzRunningProblemszzz"
                       
1749:     theTimeBegan = Now
1750:     dateRunningTime = Now
1751:     Set psbar = pApp.StatusBar
1752:     Set pPro = psbar.ProgressBar
1753:     strHeader = "Calculating General Progress"
1754:     strMessage = strHeader
    
    ' INSERT FOLLOWING WHERE YOU WANT TO CREATE THE PROGRESS FORM
1757:     If booShowProgress Then
        ' PROGRESS METER STUFF ------------------------------------------------------------------
    
    '  frmProgress.SetExpanded = ext.ProgressDialogSetExpanded
1761:       frmProgress.SetExpanded = True
1762:       Set ext = GetExtension(pApp)
1763:       frmProgress.SetAutoClose = ext.ProgressDialogAutoClose
    
1765:       theTimeBegan = Now
1766:       frmProgress.ShouldContinue = True
1767:       frmProgress.ProgBeginTime = Now
1768:       frmProgress.ProgRecCount = lngValCount
1769:       frmProgress.lblCurrentTime.Caption = Format(Now, "ttttt")
1770:       frmProgress.lblBeginTime.Caption = "Began Job: " & Format(theTimeBegan, "ttttt,  ddddd")
    
1772:       theDetailedDescription = "Calculating..." & vbCrLf & _
          "Began Job: " & Format(theTimeBegan, "ttttt,  ddddd") & vbCrLf & _
          "-------------------------------------------" & vbCrLf
1775:       frmProgress.txtDetails.Text = theDetailedDescription
1776:       frmProgress.txtDetails.SelStart = Len(theDetailedDescription)
    
1778:       frmProgress.Frame.Caption = " Current Status:"
1779:       frmProgress.Frame.Visible = True
1780:       frmProgress.cmdDetails.Visible = True
1781:       frmProgress.cmdStop.Visible = True
1782:     End If
1783:   End If
  
  Dim pCovMatrix As Matrix_jen
  Dim pMeanVector As Matrix_jen
  Dim pTransposeMean As Matrix_jen
  Dim pCorrMatrix As Matrix_jen
  
  Dim pArrayForProjections As esriSystem.IArray
1791:   Set pArrayForProjections = New esriSystem.Array
  
  Dim pParamsArray As esriSystem.IVariantArray
  Dim strSrcReport As String
  Dim pPointLayer As IFeatureLayer
  Dim booUseAll As Boolean
  
  Dim pRasterBand As IRasterBand
  Dim strRasterName As String
  Dim lngFieldIndex As Long
  Dim pTable As ITable
  Dim varValue As Variant
  Dim booIsString As Boolean
  Dim strFieldName As String
  Dim pField As IField
  Dim pMeanVectorTable As IStandaloneTable
  Dim pCovMatrixTable As IStandaloneTable
  Dim strError As String
  Dim booExtractSucceeded As Boolean
  
1811:   strSrcReport = "\par\b Source for Mean Vector and Covariance Matrix\b0 " & vbCrLf
  
  ' ORGANIZE DATA ==============================================================================================================
  Dim strInputParamsReport As String
1815:   If pThisExt.ShouldContinue = False Then
 '   MsgBox "Operation Canceled..."
1817:     MahalanobisRaster = "Operation Canceled..."
1818:     GoTo CleanUp
    
1820:   Else
    
1822:     Set pParamsArray = pSourceArray.Element(1)
    
    Select Case lngType
      Case 1                   ' POINT THEME
'        pSourceParams.Add pPointLayer
'        pSourceParams.Add optUseAll.Value              ' TRUE IF USING ALL POINTS, FALSE IF ONLY USING SELECTED POINTS
'        pSourceParams.Add m_lngPointCount              ' TOTAL POINT COUNT FOR THIS LAYER
'        pSourceParams.Add m_lngSelPointCount           ' SELECTED POINT COUNT FOR THIS LAYER
      
1831:         Set pPointLayer = pParamsArray.Element(0)
1832:         booUseAll = pParamsArray.Element(1)
1833:         If booUseAll Then
1834:           strSrcReport = strSrcReport & "\par -- Source = Point Layer [" & pPointLayer.Name & "]" & vbCrLf & _
                         "\par     Option to use All Points (n = " & CStr(Format(pParamsArray.Element(2), "#,##0")) & ")" & vbCrLf & _
                         "\par     Raster Cell Value Option: zzzExtractOption" & vbCrLf
1837:         Else
1838:           strSrcReport = strSrcReport & "\par -- Source = Point Layer [" & pPointLayer.Name & "]" & vbCrLf & _
                         "\par     Option to use Selected Points (n = " & CStr(Format(pParamsArray.Element(3), "#,##0")) & _
                         " of " & CStr(Format(pParamsArray.Element(2), "#,##0")) & ")" & vbCrLf & _
                         "\par     Raster Cell Value Option: zzzExtractOption" & vbCrLf
1842:         End If
        
1844:         Set pSourceArray = New esriSystem.VarArray
1845:         pSourceArray.Add pPointLayer
1846:         pSourceArray.Add "Vector"
1847:         pSourceArray.Add booUseAll
1848:         pArrayForProjections.Add pSourceArray
        
        
      Case 2                  ' RASTER BAND
'          pSourceParams.Add pRasterBand
'          pSourceParams.Add strRasterName
'          pSourceParams.Add lngFieldIndex
'          pSourceParams.Add booIsString
'          pSourceParams.Add varValue
'
        
1859:         Set pRasterBand = pParamsArray.Element(0)
1860:         strRasterName = pParamsArray.Element(1)
'        Set pTable = pRasterBand.AttributeTable
1862:         Set pTable = TopoCorridor.TopoCor_Functions.ReturnRasterTable(pRasterBand)
1863:         lngFieldIndex = pParamsArray.Element(2)
1864:         Set pField = pTable.Fields.Field(lngFieldIndex)
1865:         strFieldName = pField.Name
        
1867:         booIsString = pParamsArray.Element(3)
1868:         varValue = pParamsArray.Element(4)
        
1870:         strSrcReport = strSrcReport & "\par -- Source = Raster Layer [" & strRasterName & "]" & vbCrLf & _
                       "\par  Field Name = " & strFieldName & " at Index #" & CStr(lngFieldIndex) & vbCrLf & _
                       "\par  Search Value = " & CStr(varValue) & "  [Is String = " & CStr(booIsString) & "]"
        
1874:         Set pSourceArray = New esriSystem.VarArray
1875:         pSourceArray.Add pParamsArray
1876:         pSourceArray.Add "Raster"
        
1878:         pArrayForProjections.Add pSourceArray
                       
      Case 3          ' EXISTING STANDALONE TABLES
'        pSourceParams.Add pMeanST
'        pSourceParams.Add pCovST
        
1884:         Set pMeanVectorTable = pParamsArray.Element(0)
1885:         Set pCovMatrixTable = pParamsArray.Element(1)
        
1887:         Set pMeanVector = New TopoCorridor.Matrix_jen
1888:         pMeanVector.ExtractMatrixFromTable pMeanVectorTable.Table, False, Nothing, booExtractSucceeded, strError
1889:         If Not booExtractSucceeded Then
1890:           MahalanobisRaster = "Operation Failed:" & vbCrLf & "--------------------------------" & vbCrLf & _
            "Failed to Convert Mean Vector Table to Matrix..." & vbCrLf & _
            "Error Message = " & strError
1893:           GoTo CleanUp
1894:         End If
        
1896:         Set pTransposeMean = pMeanVector.Transpose(booExtractSucceeded)
        
1898:         Set pCovMatrix = New TopoCorridor.Matrix_jen
1899:         pCovMatrix.ExtractMatrixFromTable pCovMatrixTable.Table, False, Nothing, booExtractSucceeded, strError
1900:         If Not booExtractSucceeded Then
1901:           MahalanobisRaster = "Operation Failed:" & vbCrLf & "--------------------------------" & vbCrLf & _
            "Failed to Convert Covariance Table to Matrix..." & vbCrLf & _
            "Error Message = " & strError
1904:           GoTo CleanUp
1905:         End If
        
1907:         strSrcReport = strSrcReport & "\par -- Existing Tables:" & vbCrLf & _
            "\par  Mean Vector = " & pMeanVectorTable.Name & vbCrLf & _
            "\par  Covariance Matrix = " & pCovMatrixTable.Name
            
        ' UPDATE PROGRESS METER ==================================================================
1912:         strMessage = "Extracting data from tables..."
1913:         psbar.Message(0) = strMessage
1914:         pPro.position = 0
1915:         lngTimer = 2
    
1917:         If booShowProgress Then
          ' ---- PROGRESS METER STUFF
1919:           DoEvents
'          theProgressSpecific = "Working on Step " & CStr(lngTimer) & " of " & CStr(lngValCount) & "..."
1921:           theProgressSpecific = strMessage
1922:           theDetailedDescription = theDetailedDescription & _
            " --> " & theProgressSpecific & vbCrLf & _
            "          [time stamp " & Format(Now, "ttttt,  ddddd") & "]" & vbCrLf & vbCrLf
1925:           frmProgress.ResetShortTimer
1926:           frmProgress.txtDetails.Text = theDetailedDescription
1927:           frmProgress.txtDetails.SelStart = Len(theDetailedDescription)
    
1929:           frmProgress.Est_Time_Left lngTimer, "Reading Statistical Tables...", "Calculating Data...", False
          ' frmProgress.lblCurrentTime.Caption = Format(Now, "ttttt")
1931:           frmProgress.Refresh
1932:           frmProgress.icnProgressLine.Refresh
1933:           DoEvents
1934:           If BailOutOfProgress(frmProgress, pApp) Then
    
           ' ********************************************************************************************
            ' ALTERNATIVE CODE THAT SAVES PARTIAL TABLE, CHECKS IF ERRORS FOUND AND OUTPUTS RTF INSTEAD OF TEXT
1938:             strTimeElapsed = TopoCorridor.MyGeneralOperations.ReturnTimeElapsedRTF(theTimeBegan, Now, 7)
    
1940:             If booFoundProblems Then
1941:               MahalanobisRaster = strInputParamsReport & "-----------------------------------------\par" & vbCrLf & _
                "NOTE:  Exited Function Prematurely at Step " & CStr(lngTimer) & "\par" & vbCrLf & _
                  Replace(strProblemReport, "zzzRunningProblemszzz", strRunningProblems) & vbCrLf & _
                "-----------------------------------------\par" & vbCrLf & _
                "\pard\qc " & strTimeElapsed & vbCrLf & "}"
1946:             Else
1947:               MahalanobisRaster = strInputParamsReport & "-----------------------------------------\par" & vbCrLf & _
                "NOTE:  Exited Function Prematurely at Step " & CStr(lngTimer) & "\par" & vbCrLf & _
                "-----------------------------------------\par" & vbCrLf & _
                "\pard\qc " & strTimeElapsed & vbCrLf & "}"
1951:             End If
    
           ' ********************************************************************************************
    
1955:             frmProgress.cmdStop.Caption = "Close"
1956:             pPro.position = 0
1957:             psbar.HideProgressBar
1958:             GoTo CleanUp
1959:           End If
          ' ---- END PROGRESS METER STUFF --------------------------------
1961:         End If
        
1963:         pArrayForProjections.Add Nothing
    
1965:     End Select

1967:   End If
  
  'strInputParamsReport = strInputParamsReport & "Mean and Covariance Source Options:" & vbCrLf & _
      strSrcReport & vbCrLf & "-----------------------------------------" & vbCrLf
  
1972:   strSrcReport = strSrcReport & "\par -----------------------------------"
  
  ' FOR DEBUGGING - SAVE ANCILLARY STATS TABLES OPTIONS
  Dim strSaveTablesReport As String
  Dim pMeansParams As esriSystem.IVariantArray
1977:   Set pMeansParams = pThisExt.StatsSaveMeansOptions
  Dim pCovParams As esriSystem.IVariantArray
1979:   Set pCovParams = pThisExt.StatsSaveCovOptions
  Dim pInvCovParams As esriSystem.IVariantArray
1981:   Set pInvCovParams = pThisExt.StatsSaveInvCovOptions
  Dim pCorrParams As esriSystem.IVariantArray
1983:   Set pCorrParams = pThisExt.StatsSaveCorrelationOptions
  
1985:   If pMeansParams Is Nothing And pCovParams Is Nothing And pInvCovParams Is Nothing _
      And pCorrParams Is Nothing Then
      
1988:     strSaveTablesReport = "\par No ancillary tables saved..." & vbCrLf
      
1990:   Else
  
1992:     If Not pMeansParams Is Nothing Then
1993:       strSaveTablesReport = strSaveTablesReport & _
      "\par   Mean Vector Saved:" & vbCrLf & _
      "\par     Table Name = " & pMeansParams.Element(0) & vbCrLf & _
      "\par     WS Path = " & pMeansParams.Element(1) & vbCrLf & _
      "\par     Full Path = " & pMeansParams.Element(2) & vbCrLf '& _
     ' "  Workspace Type = " & CStr(pMeansParams.Element(3))
        
2000:     End If
    
2002:     If Not pCovParams Is Nothing Then
2003:       strSaveTablesReport = strSaveTablesReport & _
      "\par   Covariance Matrix Saved:" & vbCrLf & _
      "\par     Table Name = " & pCovParams.Element(0) & vbCrLf & _
      "\par     WS Path = " & pCovParams.Element(1) & vbCrLf & _
      "\par     Full Path = " & pCovParams.Element(2) & vbCrLf '& _
      '"  Workspace Type = " & CStr(pCovParams.Element(3))
2009:     End If
    
2011:     If Not pInvCovParams Is Nothing Then
2012:       strSaveTablesReport = strSaveTablesReport & _
      "\par   Inverse Covariance Matrix Saved:" & vbCrLf & _
      "\par     Table Name = " & pInvCovParams.Element(0) & vbCrLf & _
      "\par     WS Path = " & pInvCovParams.Element(1) & vbCrLf & _
      "\par     Full Path = " & pInvCovParams.Element(2) & vbCrLf '& _
      '"  Workspace Type = " & CStr(pInvCovParams.Element(3))
2018:     End If
    
2020:     If Not pCorrParams Is Nothing Then
2021:       strSaveTablesReport = strSaveTablesReport & _
      "\par   Correlation Matrix Saved:" & vbCrLf & _
      "\par     Table Name = " & pCorrParams.Element(0) & vbCrLf & _
      "\par     WS Path = " & pCorrParams.Element(1) & vbCrLf & _
      "\par     Full Path = " & pCorrParams.Element(2) & vbCrLf '& _
      '"  Workspace Type = " & CStr(pCorrParams.Element(3))
2027:     End If
    
 '   strSaveTablesReport = _
      "Save Means = " & CStr(pThisExt.StatsSaveMeans) & vbCrLf & strMeansReport & vbCrLf & _
      "Save Covariances = " & CStr(pThisExt.StatsSaveCov) & vbCrLf & strCovReport & vbCrLf & _
      "Save Inverse Covariances = " & CStr(pThisExt.StatsSaveInvCov) & vbCrLf & strInvCovReport & vbCrLf & _
      "Save Correlation = " & CStr(pThisExt.StatsSaveCorrelation) & vbCrLf & strCorrReport
2034:   End If

  
  'strInputParamsReport = strInputParamsReport & "Save Ancillary Tables Options:" & vbCrLf & _
      strSaveTablesReport & vbCrLf & "-----------------------------------------" & vbCrLf

2040:   strSrcReport = strSrcReport & "\par Save Ancillary Tables Options:" & vbCrLf & _
      strSaveTablesReport & vbCrLf & "\par -----------------------------------------" & vbCrLf

  Dim strOutputReportList As String
  
2045:   strOutputReportList = _
              "\par \pard\b New Mahalanobis Data Layer Options:\b0" & vbCrLf & _
              "\par\b  -- Workspace =\b0 " & Replace(strWS, "\", "\\") & vbCrLf & _
              "\par\b  -- Name =\b0 " & strMahal & vbCrLf & _
              "\par\b  -- " & CStr(pSelectedArray.Count) & " selected data layers:\b0" & vbCrLf
  
  ' NOTE:  EACH OF THESE SELECTED ITEMS IS AN esriSystem.IVariantArray CONTAINING THE FOLLOWING ITEMS:
  ' 1) IF A RASTER LAYER (i.e. if theArray.Element(1) = "Raster"):
  '    0) Index value of original Raster list item; not useful any more
  '    1) String "Raster", indicating the data type of this item
  '    2) Actual Raster object, original saved as IRasterBandCollection but available as an IRaster
  '    3) Name of Raster Object, as it appeared in original list
  '    4) Band Index; added by this function
  ' 2) IF A POLYGON LAYER (i.e. if theArray.Element(1) = "Polygon"):
  '    0) Index value of original Polygon list item; not useful any more
  '    1) String "Polygon", indicating the data type of this item
  '    2) Actual Polygon Layer
  '    3) Polygon Layer Name
  '    4) Field Index value for selected attribute field
  '    5) Actual selected attribute field
  '    6) Band Index; added by this function
  
  Dim pVariableNames As esriSystem.IStringArray
2068:   Set pVariableNames = New esriSystem.strArray
  
  Dim pUnknownBandColl As IRasterBandCollection
  Dim pUnknownBand As IRasterBand
  
2073:   For lngCheckIndex = 0 To pSelectedArray.Count - 1
2074:     Set pSubArray = pSelectedArray.Element(lngCheckIndex)
2075:     Set pUnknown = pSubArray.Element(2)
2076:     pVariableNames.Add pSubArray.Element(3)
    
2078:     If pSubArray.Element(1) = "Raster" Then
2079:       strOutputReportList = strOutputReportList & "\par    " & CStr(lngCheckIndex + 1) & "] RASTER:\b  " & pSubArray.Element(3) & "\b0" & vbCrLf
  '    strReport = strReport & "   " & CStr(lngCheckIndex + 1) & "] RASTER: " & pSubArray.Element(3) & vbCrLf ' & _
                              ' "       Dataset is IRaster = " & CStr(TypeOf pUnknown Is IRaster) & vbCrLf
      
      ' MODIFIED SEPTEMBER 17, 2008 BY JENNESS
      ' OBJECT MIGHT BE A RASTER BAND; IF SO, THEN SWITCH TO RASTER HERE.
2085:       If TypeOf pUnknown Is IRasterBand Then
2086:         Set pUnknownBand = pUnknown
2087:         Set pUnknownBandColl = New Raster
2088:         pUnknownBandColl.AppendBand pUnknownBand
2089:         pSubArray.Remove 2
2090:         pSubArray.Insert 2, pUnknownBandColl
2091:       End If
      
2093:     Else
2094:       Set pField = pSubArray.Element(5)
2095:       strOutputReportList = strOutputReportList & "\par    " & CStr(lngCheckIndex + 1) & "] POLYGON FEATURE LAYER:\b  " & pSubArray.Element(3) & "\b0" & vbCrLf & _
                              "\par        Attribute Field:  Name = " & pField.Name & vbCrLf
   '   strReport = strReport & "   " & CStr(lngCheckIndex + 1) & "] POLYGON FEATURE LAYER: " & pSubArray.Element(3) & vbCrLf & _
                              "       Attribute Field:  Name = " & pField.Name & vbCrLf ' & ",   Index = " & pSubArray.Element(4) & vbCrLf & _
                              '"       Dataset is IFeatureLayer = " & CStr(TypeOf pUnknown Is IFeatureLayer) & vbCrLf
2100:     End If
2101:   Next lngCheckIndex
  
 ' strInputParamsReport = strInputParamsReport & "Mahalanobis Input Variable Options:" & vbCrLf & _
      strReport & vbCrLf & "-----------------------------------------" & vbCrLf
      
  
  ' ADD MAHALANOBIS VARIABLE ARRAYS
2108:   pArrayForProjections.Add pSelectedArray
  
  
  
  
  
  ' =========================================================================================================================
  ' UNIFY PROJECTIONS =======================================================================================================
  ' =========================================================================================================================
  
  
  Dim strReturnMessage As String
  Dim booShouldStop As Boolean
  
  Dim pCommonProjectionArray As esriSystem.IArray
2123:   Set pCommonProjectionArray = UnifyProjections(pArrayForProjections, pApp, pThisExt, strMessage, _
      psbar, pPro, lngTimer, theProgressSpecific, theDetailedDescription, strTimeElapsed, booFoundProblems, _
      strReturnMessage, booShouldStop, theTimeBegan)
  
2127:   If booShouldStop Then
2128:     MahalanobisRaster = MahalanobisRaster & vbCrLf & strReturnMessage
2129:     GoTo CleanUp
2130:   End If
  
  Dim pCommonSpRef As ISpatialReference
2133:   Set pCommonSpRef = pCommonProjectionArray.Element(2)
  
2135:   If pCommonProjectionArray Is Nothing Then
2136:     MahalanobisRaster = MahalanobisRaster & vbCrLf & "Operation Failed:" & vbCrLf & "--------------------------------" & vbCrLf & _
      "Failed to Convert all data sources into a common projection..." & vbCrLf
2138:     GoTo CleanUp
2139:   End If
    
  ' FOR DEBUGGING; LOAD ALL RASTERS INTO VIEW -----------------------------------------------------------------------------
'  Dim lngDebugIndex As Long
'  Dim pDebugRasterDataset As IRasterDataset
'  Dim pDebugArray As esriSystem.IVariantArray
'  Dim pDebugVariablesArray As esriSystem.IVariantArray
'  Dim pDebugLayer As IRasterLayer
'  If lngType = 2 Then                  ' MEANS SOURCE DATA WAS RASTER.  ALSO MEANS RASTER IS TEMPORARY AND MUST BE DELETED
'    Set pDebugRasterDataset = pCommonProjectionArray.Element(0)
'    Set pDebugLayer = New RasterLayer
'    pDebugLayer.CreateFromDataset pDebugRasterDataset
'    pDebugLayer.Name = "Source for Stats"
'    pMxDoc.FocusMap.AddLayer pDebugLayer
'  End If
'
'  Dim booDebugDelete As Boolean
'  Set pDebugVariablesArray = pCommonProjectionArray.Element(1)
'  For lngDebugIndex = 0 To pDebugVariablesArray.Count - 1
'    Set pDebugArray = pDebugVariablesArray.Element(lngDebugIndex)
'    booDebugDelete = pDebugArray.Element(0)
'    Set pDebugRasterDataset = pDebugArray.Element(1)
'    Set pDebugLayer = New RasterLayer
'    pDebugLayer.CreateFromDataset pDebugRasterDataset
'    pDebugLayer.Name = "Raster #" & str(lngDebugIndex + 1) & " Delete = " & CStr(booDebugDelete)
'    pMxDoc.FocusMap.AddLayer pDebugLayer
'  Next lngDebugIndex
  '-------------------------------------------------------------------------------------------------------------------------
  
  
  
  ' =========================================================================================================================
  ' EXTRACT SOURCE DATA =====================================================================================================
  ' =========================================================================================================================
  
  
  
  ' CURRENTLY HAVE ALL DATASETS IN CORRECT PROJECTION
  ' NEXT CREATE VARIANCE AND COVARIANCE MATRICES IF NECESSARY
  Dim pVariablesArray As esriSystem.IVariantArray
2179:   Set pVariablesArray = pCommonProjectionArray.Element(1)
  Dim pDataVariableArray As esriSystem.IVariantArray
  Dim lngRowCount As Long       ' ONLY USED IF INPUT SOURCE IS A POINT LAYER
  Dim strFailureReason As String
  
  ' FOR DEBUGGING
'  Dim lngDebug As Long
'  Dim strDebug As String
'  Dim pDebugArray As esriSystem.IVariantArray
'  strDebug = "Before Extract Source Data" & vbCrLf & vbCrLf
'  For lngDebug = 0 To pVariablesArray.Count - 1
'    Set pDebugArray = pVariablesArray.Element(lngDebug)
'    strDebug = strDebug & "Dataset Name = " & pDebugArray.Element(3) & ",    " & _
'                          "lngBandIndex = " & CStr(pDebugArray.Element(4)) & ",    " & _
'                          "Data Array Count = " & CStr(pDebugArray.Count) & vbCrLf
'  Next lngDebug
'  MsgBox strDebug
  
  Dim pPointCollection As IPointCollection
  Dim pSourceRasDataset As IRasterDataset
  
  Select Case lngType
    Case 1                   ' POINT THEME
2202:       Set pMeanVector = New Matrix_jen
2203:       Set pCovMatrix = New Matrix_jen
2204:       Set pCorrMatrix = New Matrix_jen
2205:       Set pPointCollection = pCommonProjectionArray.Element(0)
  
 '     MsgBox "pPointCollection is Nothing = " & CStr(pPointCollection Is Nothing) & vbCrLf & _
             "pVariablesArray is Nothing = " & CStr(pVariablesArray Is Nothing) & vbCrLf & _
             "pMeanVector is Nothing = " & CStr(pMeanVector Is Nothing) & vbCrLf & _
             "pCovMatrix is Nothing = " & CStr(pCovMatrix Is Nothing) & vbCrLf & _
             "Use Interp = " & CStr(pThisExt.UseInterpCellValue) & vbCrLf & _
             "lngRowCount = " & CStr(lngRowCount) & vbCrLf & _
             "strFailureReason = " & strFailureReason
         
2215:       Call ExtractStatMatricesFromPointCollection(pPointCollection, pVariablesArray, pTransposeMean, _
            pCovMatrix, pThisExt.UseInterpCellValue, lngRowCount, strFailureReason, pCorrMatrix, pThisExt, pApp, _
            strMessage, psbar, pPro, lngTimer, theProgressSpecific, theDetailedDescription, strTimeElapsed, booFoundProblems, _
            strReturnMessage, booShouldStop, theTimeBegan)
            
2220:       If booShouldStop Then
2221:         MahalanobisRaster = MahalanobisRaster & vbCrLf & strReturnMessage
2222:         GoTo CleanUp
2223:       End If
            
2225:       If lngRowCount <> pPointCollection.PointCount Then
2226:         MahalanobisRaster = MahalanobisRaster & "Note:  Only " & CStr(lngRowCount) & " of " & _
          CStr(pPointCollection.PointCount) & " sample points had non-null values for all " & _
          "Mahalanobis input variables..." & vbCrLf & vbCrLf
2229:       End If
      
2231:       If pTransposeMean.IsNull Or pCovMatrix.IsNull Then
2232:         If lngRowCount = 0 Then
2233:           MahalanobisRaster = "Operation Failed:" & vbCrLf & "--------------------------------" & vbCrLf & _
            "Failed to generate Mean Vector and Covariance Matrices from sample points..." & vbCrLf & _
            "No sample points intersected all Mahalanobis Variable sources, so all samples had missing data and were excluded..." & _
            vbCrLf & strFailureReason
2237:           GoTo CleanUp
2238:         Else
2239:           MahalanobisRaster = "Operation Failed:" & vbCrLf & "--------------------------------" & vbCrLf & _
            "Failed to generate Mean Vector and Covariance Matrices from sample points..." & vbCrLf & strFailureReason
2241:           GoTo CleanUp
2242:         End If
2243:       End If
2244:       Set pMeanVector = pTransposeMean.Transpose(True)
      
    Case 2                  ' RASTER BAND
2247:       Set pMeanVector = New Matrix_jen
2248:       Set pCovMatrix = New Matrix_jen
2249:       Set pCorrMatrix = New Matrix_jen
2250:       Set pSourceRasDataset = pCommonProjectionArray.Element(0)
2251:       Call ExtractStatMatricesFromRaster(pSourceRasDataset, pVariablesArray, pTransposeMean, pCovMatrix, pCommonSpRef, _
          pCorrMatrix, pThisExt, pApp, _
          strMessage, psbar, pPro, lngTimer, theProgressSpecific, theDetailedDescription, strTimeElapsed, booFoundProblems, _
          strReturnMessage, booShouldStop, theTimeBegan)
          
2256:       If booShouldStop Then
2257:         MahalanobisRaster = MahalanobisRaster & vbCrLf & strReturnMessage
2258:         GoTo CleanUp
2259:       End If
      
2261:       If pTransposeMean.IsNull Or pCovMatrix.IsNull Then
2262:         MahalanobisRaster = "Operation Failed:" & vbCrLf & "--------------------------------" & vbCrLf & _
          "Failed to generate Mean Vector and Covariance Matrices from " & pParamsArray.Element(1) & "..." & vbCrLf
2264:         GoTo CleanUp
2265:       End If
2266:       Set pMeanVector = pTransposeMean.Transpose(True)
      
2268:   End Select
  
  
    
  ' =========================================================================================================================
  ' STATISTICAL MATRICES ====================================================================================================
  ' =========================================================================================================================
  
  
  Dim booStringError As Boolean
  Dim strMeanVector As String
2279:   strMeanVector = pMeanVector.MakeTextWithHeaders(pVariableNames, False, True, booStringError, 6, _
      "Mahanalobis Mean Vector")
  
  Dim strCovMatrix As String
2283:   strCovMatrix = pCovMatrix.MakeTextWithHeaders(pVariableNames, True, True, booStringError, 6, _
      "Mahanalobis Covariance Matrix")
  
  ' INVERT COVARIANCE MATRIX
  Dim pInvCovMatrix As Matrix_jen
  Dim bytInvertSucceeded As Byte
  
2290:   If booShowProgress Then
    ' UPDATE PROGRESS METER ==================================================================
2292:     strMessage = "Inverting Covariance Matrix..."
2293:     psbar.Message(0) = strMessage
2294:     pPro.position = 0
2295:     lngTimer = lngTimer + 1
        
    ' ---- PROGRESS METER STUFF
2298:     DoEvents
2299:     theProgressSpecific = strMessage
2300:     theDetailedDescription = theDetailedDescription & _
      " --> Inverting Covariance Matrix..." & vbCrLf & _
      "          [time stamp " & Format(Now, "ttttt,  ddddd") & "]" & vbCrLf & vbCrLf
2303:     frmProgress.ResetShortTimer
2304:     frmProgress.txtDetails.Text = theDetailedDescription
2305:     frmProgress.txtDetails.SelStart = Len(theDetailedDescription)

2307:     frmProgress.Est_Time_Left lngTimer, "Inverting Covariance Matrix...", "Calculating Data...", False
    ' frmProgress.lblCurrentTime.Caption = Format(Now, "ttttt")
2309:     frmProgress.Refresh
2310:     frmProgress.icnProgressLine.Refresh
2311:     DoEvents
2312:     If BailOutOfProgress(frmProgress, pApp) Then

     ' ********************************************************************************************
      ' ALTERNATIVE CODE THAT SAVES PARTIAL TABLE, CHECKS IF ERRORS FOUND AND OUTPUTS RTF INSTEAD OF TEXT
2316:       strTimeElapsed = TopoCorridor.MyGeneralOperations.ReturnTimeElapsedRTF(theTimeBegan, Now, 7)

2318:       If booFoundProblems Then
2319:         MahalanobisRaster = strInputParamsReport & "-----------------------------------------\par" & vbCrLf & _
          "NOTE:  Exited Function Prematurely at Step " & CStr(lngTimer) & "\par" & vbCrLf & _
            Replace(strProblemReport, "zzzRunningProblemszzz", strRunningProblems) & vbCrLf & _
          "-----------------------------------------\par" & vbCrLf & _
          "\pard\qc " & strTimeElapsed & vbCrLf & "}"
2324:       Else
2325:         MahalanobisRaster = strInputParamsReport & "-----------------------------------------\par" & vbCrLf & _
          "NOTE:  Exited Function Prematurely at Step " & CStr(lngTimer) & "\par" & vbCrLf & _
          "-----------------------------------------\par" & vbCrLf & _
          "\pard\qc " & strTimeElapsed & vbCrLf & "}"
2329:       End If

     ' ********************************************************************************************

2333:       frmProgress.cmdStop.Caption = "Close"
2334:       pPro.position = 0
2335:       psbar.HideProgressBar
2336:       GoTo CleanUp
2337:     End If
    ' ---- END PROGRESS METER STUFF --------------------------------
2339:   End If
    
2341:   Set pInvCovMatrix = pCovMatrix.Invert(bytInvertSucceeded)
  ' MODIFIES BYTE VALUE
  '   0) IF OPERATION SUCCESSFUL
  '   1) FAILED AT MatrixLUDecomp_jen BECAUSE OF NON-SQUARE MATRIX
  '   2) FAILED AT MatrixLUDecomp_jen BECAUSE OF SINGULAR MATRIX
  '   3) FAILED AT MatrixFBSub_jen BECAUSE OF UNKNOWN REASONS

  Select Case bytInvertSucceeded
    Case 1
2350:       MahalanobisRaster = "Operation Failed:" & vbCrLf & "--------------------------------" & vbCrLf & _
        "  --> Failed to invert covariance matrix:" & vbCrLf & _
        "  --> FAILED AT MatrixLUDecomp_jen because of Non-Square Matrix..." & vbCrLf & _
        strMeanVector & vbCrLf & strCovMatrix
2354:       GoTo CleanUp
    Case 2
2356:       MahalanobisRaster = "Operation Failed:" & vbCrLf & "--------------------------------" & vbCrLf & _
        "  --> Failed to invert covariance matrix:" & vbCrLf & _
        "  --> FAILED AT MatrixLUDecomp_jen because of Singular Matrix..." & vbCrLf & _
        "     This is generally due to one variable having NO variance at all (i.e. all sample " & _
        "point values are the same)." & vbCrLf & vbCrLf & _
        strMeanVector & vbCrLf & strCovMatrix
2362:       GoTo CleanUp
    Case 3
2364:       MahalanobisRaster = "Operation Failed:" & vbCrLf & "--------------------------------" & vbCrLf & _
        "  --> Failed to invert covariance matrix:" & vbCrLf & _
        "  --> FAILED AT MatrixFBSub_jen (Back-Substitution Step) because of unknown reasons..." & vbCrLf & _
        strMeanVector & vbCrLf & strCovMatrix
2368:       GoTo CleanUp
    Case Else         ' SUCCEEDED
      Dim strInvCovMatrix As String
2371:       strInvCovMatrix = pInvCovMatrix.MakeTextWithHeaders(pVariableNames, True, True, booStringError, 6, _
          "Mahanalobis Inverse Covariance Matrix") & vbCrLf & vbCrLf
2373:   End Select
  
  ' TEST INVERSION
  Dim pMultMatrix As Matrix_jen
2377:   Set pMultMatrix = pCovMatrix.Multiply(pInvCovMatrix, True)
  Dim strMultMatrix As String
2379:   strMultMatrix = pMultMatrix.MakeTextWithHeaders(pVariableNames, True, True, booStringError, 3, _
      "Check Multiplication") & vbCrLf & vbCrLf
  
  ' CORRELATION
  Dim strCorrMatrix As String
2384:   If pThisExt.StatsSaveCorrelation Then
2385:     strCorrMatrix = pCorrMatrix.MakeTextWithHeaders(pVariableNames, True, True, booStringError, 3, _
        "Correlation Matrix") & vbCrLf & vbCrLf
2387:   Else
2388:     strCorrMatrix = ""
2389:   End If
  
2391:   MahalanobisRaster = MahalanobisRaster & _
    strMeanVector & _
    strCovMatrix & _
    strInvCovMatrix & _
    strMultMatrix & _
    strCorrMatrix
   
   
  ' =========================================================================================================================
  ' SAVE TABLES IF REQUESTED ================================================================================================
  ' =========================================================================================================================
  
  
  Dim strTableWS As String
  Dim strTableName As String
  Dim strFullName As String
  Dim lngTableCategory As JenDatasetTypes
  Dim pTableOptions As esriSystem.IVariantArray
  Dim strSaveString As String
2410:   strSaveString = "-------------------------------------------------" & vbCrLf & _
      "Intermediate Statistical Tables Saved:" & vbCrLf
  Dim booAddSaveString As Boolean
2413:   booAddSaveString = False
  Dim strFieldNameReport As String
  
  ' MEAN VECTOR
2417:   If pThisExt.StatsSaveMeans Then
2418:     Set pTableOptions = pThisExt.StatsSaveMeansOptions
2419:     strTableName = pTableOptions.Element(0)
2420:     strTableWS = pTableOptions.Element(1)
2421:     strFullName = pTableOptions.Element(2)
2422:     lngTableCategory = pTableOptions.Element(3)
2423:     Call CreateTables(pMeanVector, True, strTableWS, strTableName, lngTableCategory, "Mean Vector", pMxDoc, pApp, pThisExt, _
        strFieldNameReport, pVariableNames)
2425:     strSaveString = strSaveString & "  -- Mean Vector:" & vbCrLf & _
                                    "      Saved to " & strFullName & vbCrLf & _
                                    strFieldNameReport & vbCrLf
2428:     booAddSaveString = True
2429:     If booShowProgress Then
2430:       theDetailedDescription = theDetailedDescription & _
        " --> Saving Mean Vector Table..." & vbCrLf & _
        "          [time stamp " & Format(Now, "ttttt,  ddddd") & "]" & vbCrLf & vbCrLf
2433:       frmProgress.txtDetails.Text = theDetailedDescription
2434:       frmProgress.txtDetails.SelStart = Len(theDetailedDescription)
2435:     End If
2436:   End If
  
  ' COVARIANCE MATRIX
2439:   If pThisExt.StatsSaveCov Then
2440:     Set pTableOptions = pThisExt.StatsSaveCovOptions
2441:     strTableName = pTableOptions.Element(0)
2442:     strTableWS = pTableOptions.Element(1)
2443:     strFullName = pTableOptions.Element(2)
2444:     lngTableCategory = pTableOptions.Element(3)
2445:     Call CreateTables(pCovMatrix, False, strTableWS, strTableName, lngTableCategory, "Covariance Matrix", pMxDoc, pApp, _
        pThisExt, strFieldNameReport, pVariableNames)
2447:     strSaveString = strSaveString & "  -- Covariance Matrix:" & vbCrLf & _
                                    "      Saved to " & strFullName & vbCrLf & _
                                    strFieldNameReport & vbCrLf
2450:     booAddSaveString = True
2451:     If booShowProgress Then
2452:       theDetailedDescription = theDetailedDescription & _
        " --> Saving Covariance Matrix Table..." & vbCrLf & _
        "          [time stamp " & Format(Now, "ttttt,  ddddd") & "]" & vbCrLf & vbCrLf
2455:       frmProgress.txtDetails.Text = theDetailedDescription
2456:       frmProgress.txtDetails.SelStart = Len(theDetailedDescription)
2457:     End If
2458:   End If
  
  ' INVERSE COVARIANCE MATRIX
2461:   If pThisExt.StatsSaveInvCov Then
2462:     Set pTableOptions = pThisExt.StatsSaveInvCovOptions
2463:     strTableName = pTableOptions.Element(0)
2464:     strTableWS = pTableOptions.Element(1)
2465:     strFullName = pTableOptions.Element(2)
2466:     lngTableCategory = pTableOptions.Element(3)
2467:     Call CreateTables(pInvCovMatrix, False, strTableWS, strTableName, lngTableCategory, "Inverse Covariance Matrix", pMxDoc, _
          pApp, pThisExt, strFieldNameReport, pVariableNames)
2469:     strSaveString = strSaveString & "  --> Inverse Covariance Matrix:" & vbCrLf & _
                                    "      Saved to " & strFullName & vbCrLf & _
                                    strFieldNameReport & vbCrLf
2472:     booAddSaveString = True

2474:     If booShowProgress Then
2475:       theDetailedDescription = theDetailedDescription & _
        " --> Saving Inverse Covariance Matrix Table..." & vbCrLf & _
        "          [time stamp " & Format(Now, "ttttt,  ddddd") & "]" & vbCrLf & vbCrLf
2478:       frmProgress.txtDetails.Text = theDetailedDescription
2479:       frmProgress.txtDetails.SelStart = Len(theDetailedDescription)
2480:     End If
2481:   End If
  
  ' CORRELATION
2484:   If pThisExt.StatsSaveCorrelation Then
2485:     Set pTableOptions = pThisExt.StatsSaveCorrelationOptions
2486:     strTableName = pTableOptions.Element(0)
2487:     strTableWS = pTableOptions.Element(1)
2488:     strFullName = pTableOptions.Element(2)
2489:     lngTableCategory = pTableOptions.Element(3)
2490:     Call CreateTables(pCorrMatrix, False, strTableWS, strTableName, lngTableCategory, "Correlation Matrix", pMxDoc, pApp, _
        pThisExt, strFieldNameReport, pVariableNames)
2492:     strSaveString = strSaveString & "  --> Correlation Matrix:" & vbCrLf & _
                                    "      Saved to " & strFullName & vbCrLf & _
                                    strFieldNameReport & vbCrLf
2495:     booAddSaveString = True

2497:     If booShowProgress Then
2498:       theDetailedDescription = theDetailedDescription & _
        " --> Saving Correlation Matrix Table..." & vbCrLf & _
        "          [time stamp " & Format(Now, "ttttt,  ddddd") & "]" & vbCrLf & vbCrLf
2501:       frmProgress.txtDetails.Text = theDetailedDescription
2502:       frmProgress.txtDetails.SelStart = Len(theDetailedDescription)
2503:     End If
2504:   End If
  
2506:   If booAddSaveString Then
2507:     MahalanobisRaster = MahalanobisRaster & strSaveString & vbCrLf & "-------------------------------------------------"
2508:   End If
2509:   frmProgress.ZOrder 0
  
'   Crashes when incorporating polygon layer
  
  
  
  ' =========================================================================================================================
  ' GENERATE MAHALANOBIS RASTER =============================================================================================
  ' =========================================================================================================================
  
  
  
  
  ' 1] MAKE VARIANT-ARRAY MATRIX OF RASTER BANDS
  Dim pBandsMatrix As esriSystem.IVariantArray
2524:   Set pBandsMatrix = MakeRasterMatrix(pVariablesArray, pThisExt, pApp)     ' RETURNS COLUMN OF RASTER BANDS
  
  ' 2] GET A COLUMN OF (X MINUS MEANS) RASTERS
  Dim pXMinusMeansMatrix As IVariantArray
  Dim strXMinusReason As String
  Dim booXMinus As Boolean
2530:   Set pXMinusMeansMatrix = ReturnXMinusMeans(pBandsMatrix, pMeanVector, booXMinus, strXMinusReason, pThisExt, pApp, strMessage, _
      psbar, pPro, lngTimer, theProgressSpecific, theDetailedDescription, strTimeElapsed, booFoundProblems, _
      strReturnMessage, booShouldStop, theTimeBegan)
  
2534:   If booShouldStop Then
2535:     MahalanobisRaster = MahalanobisRaster & vbCrLf & strReturnMessage
2536:     GoTo CleanUp
2537:   End If
  
2539:   If booXMinus Then       ' I.E. IF OPERATION FAILED
2540:     MahalanobisRaster = "Operation Failed:" & vbCrLf & "--------------------------------" & vbCrLf & _
      "  --> Failed to subtract raster band mean values from raster bands..." & vbCrLf & _
      strMeanVector & vbCrLf & strCovMatrix
2543:     GoTo CleanUp
2544:   End If
  
  ' 3] TRANSPOSE (X MINUS MEANS) MATRIX
  Dim pXMinusMeansTransposeMatrix As IVariantArray
2548:   Set pXMinusMeansTransposeMatrix = TransposeRasterMatrix(pXMinusMeansMatrix, pThisExt, pApp)
  
  ' 4] MULTIPLY (X MINUS MEANS TRANSPOSED) BY COVARIANCE MATRIX
  Dim pMultiplyStep1 As esriSystem.IVariantArray
2552:   Set pMultiplyStep1 = MahalStep1(pXMinusMeansTransposeMatrix, pInvCovMatrix, pMxDoc, pThisExt, pApp, strMessage, _
      psbar, pPro, lngTimer, theProgressSpecific, theDetailedDescription, strTimeElapsed, booFoundProblems, _
      strReturnMessage, booShouldStop, theTimeBegan)
  
2556:   If booShouldStop Then
2557:     MahalanobisRaster = MahalanobisRaster & vbCrLf & strReturnMessage
2558:     GoTo CleanUp
2559:   End If
  
  ' 5] MULTIPLY pMultiplyStep1 BY (X MINUS MEANS) MATRIX
  Dim pMultiplyStep2 As IRaster
2563:   Set pMultiplyStep2 = MahalStep2(pMultiplyStep1, pXMinusMeansMatrix, pThisExt, pApp, strMessage, _
      psbar, pPro, lngTimer, theProgressSpecific, theDetailedDescription, strTimeElapsed, booFoundProblems, _
      strReturnMessage, booShouldStop, theTimeBegan)
  
2567:   If booShouldStop Then
2568:     MahalanobisRaster = MahalanobisRaster & vbCrLf & strReturnMessage
2569:     GoTo CleanUp
2570:   End If
  
  ' NOW HAVE MAHALANOBIS RASTER
  ' SAVE DATASET
'  Set pOptions = pThisExt.frmGridLayersReturn
'  Set pSelectedArray = pOptions.Element(0)
'  booExact = pOptions.Element(1)
'  strWS = pOptions.Element(2)
'  lngWSType = pOptions.Element(3)
'  strMahal = pOptions.Element(4)

  Dim pSaveAs As ISaveAs2
2582:   Set pSaveAs = pMultiplyStep2
  Dim strFormat As String
2584:   If lngWSType = ENUM_File_Raster Then
2585:     strFormat = "GRID"
2586:   Else
2587:     strFormat = "GDB"
2588:   End If
    
2590:   If booShowProgress Then
2591:     theDetailedDescription = theDetailedDescription & _
      " --> Saving Mahalanobis Grid..." & vbCrLf & _
      "          [time stamp " & Format(Now, "ttttt,  ddddd") & "]" & vbCrLf & vbCrLf
2594:     frmProgress.txtDetails.Text = theDetailedDescription
2595:     frmProgress.txtDetails.SelStart = Len(theDetailedDescription)
2596:   End If
  
  Dim pRast2 As IRaster2
2599:   Set pRast2 = pMultiplyStep2
  Dim pTempDataset As IRasterDataset2
2601:   Set pTempDataset = pRast2.RasterDataset
  Dim pTempRastBandColl As IRasterBandCollection
2603:   Set pTempRastBandColl = pTempDataset
  Dim pTempRastband As IRasterBand
2605:   Set pTempRastband = pTempRastBandColl.Item(0)
  Dim pRastStats As IRasterStatistics
2607:   Set pRastStats = pTempRastband.Statistics
2608:   pRastStats.Recalculate
    
2610:   Set pSaveAs = pRast2
  
  Dim pRastStorDef As IRasterStorageDef2
2613:   Set pRastStorDef = New RasterStorageDef
  
'  MsgBox TypeOf pOptions.Element(5) Is IWorkspace
'  MsgBox "strMahal = " & strMahal & vbCrLf & _
         "strFormat = " & strFormat
         
  Dim pSavedDataset As IRasterDataset
2620:   Set pSavedDataset = pSaveAs.SaveAsRasterDataset(strMahal, pOptions.Element(5), strFormat, pRastStorDef)           ' <-----------
  
2622:   Set pRast2 = Nothing
2623:   Set pTempDataset = Nothing
2624:   Set pTempRastBandColl = Nothing
2625:   Set pTempRastband = Nothing
2626:   Set pRastStats = Nothing
2627:   Set pMultiplyStep2 = Nothing
2628:   Set pMultiplyStep1 = Nothing
2629:   Set pSaveAs = Nothing
    
  Dim pInterimRaster As IRaster
  Dim pInterimDataset As IRasterDataset2
2633:   Set pInterimDataset = pSavedDataset
2634:   Set pInterimRaster = pInterimDataset.CreateFullRaster
  
2636:   If booShowProgress Then
2637:     theDetailedDescription = theDetailedDescription & _
      " --> Adding Mahalanobis Layer to Map..." & vbCrLf & _
      "          [time stamp " & Format(Now, "ttttt,  ddddd") & "]" & vbCrLf & vbCrLf
2640:     frmProgress.txtDetails.Text = theDetailedDescription
2641:     frmProgress.txtDetails.SelStart = Len(theDetailedDescription)
2642:   End If
  
  ' ADD RASTER TO MAP DOCUMENT
  Dim pNewLayer As IRasterLayer
2646:   Set pNewLayer = New RasterLayer
'  pNewLayer.CreateFromRaster pMultiplyStep2
2648:   pNewLayer.CreateFromDataset pSavedDataset
2649:   pNewLayer.Name = strMahal
  
  ' SYMBOLIZE RASTER LAYER
      
  ' Create renderer and QI RasterRenderer
  Dim pStretchRen As IRasterStretchColorRampRenderer
2655:   Set pStretchRen = New RasterStretchColorRampRenderer
  Dim pRasRen As IRasterRenderer
2657:   Set pRasRen = pStretchRen
  
  Dim pRasterStretch As IRasterStretch
2660:   Set pRasterStretch = pStretchRen
2661:   pRasterStretch.StretchType = esriRasterStretch_NONE
  
  ' Set raster for the renderer and update
2664:   Set pRasRen.Raster = pInterimRaster
2665:   pRasRen.Update
  
  ' COLORS
  Dim pRedColor As IColor
  Dim pYellowColor As IColor
  Dim pGreenColor As IColor
  
2672:   Set pRedColor = New RgbColor
2673:   Set pYellowColor = New RgbColor
2674:   Set pGreenColor = New RgbColor
  
2676:   pRedColor.RGB = RGB(190, 0, 0)
2677:   pYellowColor.RGB = RGB(255, 255, 200)
2678:   pGreenColor.RGB = RGB(0, 140, 0)
  
  ' CREATE COLOR RAMPS
  Dim pRamp1 As IAlgorithmicColorRamp
2682:   Set pRamp1 = New AlgorithmicColorRamp
2683:   pRamp1.Algorithm = esriLabLChAlgorithm
2684:   pRamp1.Size = 130
2685:   pRamp1.FromColor = pGreenColor
2686:   pRamp1.ToColor = pYellowColor
2687:   pRamp1.CreateRamp True
  
  Dim pRamp2 As IAlgorithmicColorRamp
2690:   Set pRamp2 = New AlgorithmicColorRamp
2691:   pRamp2.Algorithm = esriLabLChAlgorithm
2692:   pRamp2.Size = 130
2693:   pRamp2.FromColor = pYellowColor
2694:   pRamp2.ToColor = pRedColor
2695:   pRamp2.CreateRamp True
  
  Dim pMultiRamp As IMultiPartColorRamp
2698:   Set pMultiRamp = New MultiPartColorRamp
2699:   pMultiRamp.Ramp(0) = pRamp1
2700:   pMultiRamp.Ramp(1) = pRamp2
2701:   pMultiRamp.Size = 260
2702:   pMultiRamp.CreateRamp True
  
  ' Plug this colorramp into renderer and select a band
2705:   pStretchRen.BandIndex = 0
2706:   pStretchRen.ColorRamp = pMultiRamp
  
  ' Update the renderer with new settings and plug into layer
2709:   pRasRen.Update
2710:   Set pNewLayer.Renderer = pStretchRen
  
2712:   pMxDoc.AddLayer pNewLayer
  
  
  ' INSERT FOLLOWING WHERE YOU WANT PROGRESS FORM TO BE CLOSED
  ' NOTE THAT THIS FUNCTION CALLS ON MyGeneralOperations.ReturnTimeElapsed!
2717:   pPro.position = 0
2718:   psbar.HideProgressBar
2719:   If booShowProgress Then
2720:     If frmProgress.chkClose.Value = 1 Then
2721:       frmProgress.Frame.Visible = False
2722:       Set frmProgress = Nothing
2723:       Set pThisExt.ProgressMeterForm = Nothing
2724:     Else
2725:       theProgressSpecific = "Calculations Complete..."
2726:       theDetailedDescription = theDetailedDescription & _
        " --> " & theProgressSpecific & vbCrLf & _
        "          [time stamp " & Format(Now, "ttttt,  ddddd") & "]" & vbCrLf & vbCrLf & _
        TopoCorridor.MyGeneralOperations.ReturnTimeElapsed(theTimeBegan, Now)
2730:         frmProgress.txtDetails.Text = theDetailedDescription
2731:         frmProgress.txtDetails.SelStart = Len(theDetailedDescription)
2732:         frmProgress.cmdStop.Caption = "Close"
2733:     End If
2734:   End If
  
  ' REMEMBER TO DELETE TEMPORARY RASTER DATASETS ===================================================================================
2737:   If lngType = 1 Then
    ' DELETE RASTER SOURCE DATASET
    
2740:   End If
  
  Dim lngDeleteIndex As Long
  Dim booDeleteDataset As Boolean
2744:   For lngDeleteIndex = 0 To pVariablesArray.Count - 1
2745:     Set pDataVariableArray = pVariablesArray.Element(lngDeleteIndex)
2746:     booDeleteDataset = pDataVariableArray.Element(0)
2747:     If booDeleteDataset Then
      ' DELETE RASTER SOURCE DATASET
      
2750:     End If
2751:   Next lngDeleteIndex
  
   
  ' IF WE'VE MADE IT THIS FAR, ASSUME THAT OPERATION IS SUCCESSFULL AND WRITE CORRECT RETURN REPORT
  Dim strBaseString As String
2756:   strBaseString = strBaseString & "{\rtf1\ansi\ansicpg1252\deff0\deflang1033{\fonttbl{\f0\fswiss\fcharset0 Arial;}{\f1\fmodern\fprq1\fcharset0 Courier New;}{\f2\fnil\fcharset0 MS Sans Serif;}}" & vbNewLine
2757:   strBaseString = strBaseString & "\viewkind4\uc1\pard\qc\b\f0\fs16 -- Mahalanobis Raster Complete --" & vbNewLine
2758:   strBaseString = strBaseString & "\par ----------------------\b0 " & vbNewLine
2759:   strBaseString = strBaseString & strOutputReportList
2760:   strBaseString = strBaseString & "\par -------------------------------" & vbNewLine
2761:   strBaseString = strBaseString & "\par\b Statistical Matrices:\b0 " & vbNewLine
2762:   strBaseString = strBaseString & "\par \f1 zzzStatMatrices\f0 " & vbNewLine
2763:   strBaseString = strBaseString & "\par " & vbNewLine
2764:   strBaseString = strBaseString & "\par " & strSrcReport
2765:   strBaseString = strBaseString & "\par " & vbNewLine
2766:   strBaseString = strBaseString & "\par \pard\qc -------------------------------" & vbNewLine
2767:   strBaseString = strBaseString & "\par zzzTimeSpentzzz\fs20 " & vbNewLine
2768:   strBaseString = strBaseString & "\par \pard\f2\fs17 " & vbNewLine
2769:   strBaseString = strBaseString & "\par }" & vbNewLine
2770:   strBaseString = strBaseString & " " & vbNewLine

  Dim strMatricesReport As String
2773:   strMatricesReport = strMeanVector & Chr(13) & " ---- " & Chr(13) & strCovMatrix
  Dim strText() As String
2775:   strText = Split(strMatricesReport, Chr(13))
2776:   strMatricesReport = ""
  Dim lngIndex As Long
  Dim strLine As String
2779:   For lngIndex = 0 To UBound(strText)
2780:     strLine = strText(lngIndex)
2781:     strLine = Trim(strLine)
2782:     If strLine <> "" Then
2783:       strMatricesReport = strMatricesReport & "\par     " & strText(lngIndex) & vbCrLf
2784:     End If
2785:   Next lngIndex
2786:   strBaseString = Replace(strBaseString, "zzzStatMatrices", strMatricesReport)
2787:   strBaseString = Replace(strBaseString, "zzzInputLayerszzz", strOutputReportList)
2788:   If booExact Then
2789:     strBaseString = Replace(strBaseString, "zzzExtractOption", "Use Exact Cell Value")
2790:   Else
2791:     strBaseString = Replace(strBaseString, "zzzExtractOption", "Interpolate from Four Points")
2792:   End If
  
2794:   strBaseString = Replace(strBaseString, "zzzTimeSpentzzz", TopoCorridor.MyGeneralOperations.ReturnTimeElapsedRTF(datBegan, Now, 7))
  
2796:   MahalanobisRaster = strBaseString
  
2798:   pMxDoc.ActiveView.Refresh
2799:   pMxDoc.UpdateContents
'  Dim frmReportForm As TopoCorridor.frmReportDialog
'  Set frmReportForm = New TopoCorridor.frmReportDialog
'
'  ' SHOW NORMAL TEXT REPORT
'  frmReportForm.txtReport.Text = strInputParamsReport
'  frmReportForm.txtReport.Locked = False
'  frmReportForm.Caption = "Analysis Options:"
'  frmReportForm.Show vbModal
'  Set frmReportForm = Nothing

2810:   GoTo CleanUp
ErrorHandler:
  HandleError True, "MahalanobisRaster " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4

CleanUp:

2816:   Set pSelectedArray = Nothing
2817:   Set pSubArray = Nothing
2818:   Set pUnknown = Nothing
2819:   Set pOptions = Nothing
2820:   Set pSourceArray = Nothing
2821:   Set frmProgress = Nothing
2822:   Set psbar = Nothing
2823:   Set pPro = Nothing
2824:   Set ext = Nothing
2825:   Set pCovMatrix = Nothing
2826:   Set pMeanVector = Nothing
2827:   Set pTransposeMean = Nothing
2828:   Set pCorrMatrix = Nothing
2829:   Set pArrayForProjections = Nothing
2830:   Set pParamsArray = Nothing
2831:   Set pPointLayer = Nothing
2832:   Set pRasterBand = Nothing
2833:   Set pTable = Nothing
2834:   Set pField = Nothing
2835:   Set pMeanVectorTable = Nothing
2836:   Set pCovMatrixTable = Nothing
2837:   Set pMeansParams = Nothing
2838:   Set pCovParams = Nothing
2839:   Set pInvCovParams = Nothing
2840:   Set pCorrParams = Nothing
2841:   Set pVariableNames = Nothing
2842:   Set pUnknownBandColl = Nothing
2843:   Set pUnknownBand = Nothing
2844:   Set pCommonProjectionArray = Nothing
2845:   Set pCommonSpRef = Nothing
2846:   Set pVariablesArray = Nothing
2847:   Set pDataVariableArray = Nothing
2848:   Set pPointCollection = Nothing
2849:   Set pSourceRasDataset = Nothing
2850:   Set pInvCovMatrix = Nothing
2851:   Set pMultMatrix = Nothing
2852:   Set pTableOptions = Nothing
2853:   Set pBandsMatrix = Nothing
2854:   Set pXMinusMeansMatrix = Nothing
2855:   Set pXMinusMeansTransposeMatrix = Nothing
2856:   Set pMultiplyStep1 = Nothing
2857:   Set pMultiplyStep2 = Nothing
2858:   Set pSaveAs = Nothing
2859:   Set pRast2 = Nothing
2860:   Set pTempDataset = Nothing
2861:   Set pTempRastBandColl = Nothing
2862:   Set pTempRastband = Nothing
2863:   Set pRastStats = Nothing
2864:   Set pRastStorDef = Nothing
2865:   Set pSavedDataset = Nothing
2866:   Set pInterimRaster = Nothing
2867:   Set pInterimDataset = Nothing
2868:   Set pNewLayer = Nothing
2869:   Set pStretchRen = Nothing
2870:   Set pRasRen = Nothing
2871:   Set pRasterStretch = Nothing
2872:   Set pRedColor = Nothing
2873:   Set pYellowColor = Nothing
2874:   Set pGreenColor = Nothing
2875:   Set pRamp1 = Nothing
2876:   Set pRamp2 = Nothing
2877:   Set pMultiRamp = Nothing



End Function


Public Function StatMatricesFromGeoDatasets(pThisExt As TopoCorridor.clsExtension, pApp As IApplication, _
  pMxDoc As IMxDocument) As String
  On Error GoTo ErrorHandler

2888:   pApp.RefreshWindow
  
  ' FOR DEBUGGING - MAHALANOBIS INPUT VARIABLES
  Dim lngCheckIndex As Long
  Dim pSelectedArray As esriSystem.IVariantArray
  Dim pSubArray As esriSystem.IVariantArray
  Dim pUnknown As IUnknown
  Dim pOptions As esriSystem.IVariantArray
  Dim strMahal As String
  Dim strWS As String
  Dim lngWSType As JenDatasetTypes
  Dim booExact As Boolean
  
2901:   Set pOptions = pThisExt.frmGridLayersReturn
2902:   Set pSelectedArray = pOptions.Element(0)
2903:   booExact = pOptions.Element(1)
'  strWS = pOptions.Element(2)
'  lngWSType = pOptions.Element(3)
'  strMahal = pOptions.Element(4)
  
  Dim pSourceArray As esriSystem.IVariantArray
  Dim lngType As Long
2910:   Set pSourceArray = pThisExt.frmCovSourceReturn
2911:   lngType = pSourceArray.Element(0)
    
  ' FOR PROGRESS METER --------------------------------------------------------------
  Dim booShowProgress As Boolean
  Dim frmProgress As TopoCorridor.frmJenProgressMeter
2916:   Set frmProgress = pThisExt.ProgressMeterForm
2917:   booShowProgress = CBool(Not frmProgress Is Nothing)
  
  ' ESTIMATE TOTAL NUMBER OF STEPS REQUIRED
  ' 2 FOR UNIFYING PROJECTIONS; 1 FOR SOURCE AND 1 FOR VARIABLES
  ' 1 FOR EXTRACTING DATA, ADD 1 FOR EXTRACTING FROM RASTER
  ' 1 FOR CALCULATING STATISTICAL MATRICES
  ' 1 FOR INVERTING COVARIANCE MATRIX, OPTIONAL
  
  Dim lngValCount As Long
2926:   If pThisExt.StatsSaveInvCov Then
2927:     lngValCount = 4
2928:   Else
2929:     lngValCount = 5
2930:   End If
2931:   If lngType = 2 Then lngValCount = lngValCount + 1
  
  Dim booFoundProblems As Boolean
  Dim strProblemReport As String
  Dim strRunningProblems As String
  Dim strTimeElapsed As String
  Dim lngTimer As Long
  Dim theTimeBegan As Date
  Dim dateRunningTime As Date
  Dim psbar As IStatusBar
  Dim pPro As IStepProgressor
  Dim strHeader As String
  Dim strMessage As String
  
  Dim theDetailedDescription As String
  Dim theProgressSpecific As String
  Dim ext As TopoCorridor.clsExtension
      
2949:   If booShowProgress Then
    ' FOLLOWING CODE SHOULD BE INSERTED INTO A FUNCTION.  NEEDS MINOR EDITS IF GOING INTO A SUBROUTINE
    ' SPECIFICALLY, CHANGE "goto cleanup" to "goto cleanup" IN BAILOUT SECTION
    ' PROGRESS BAR STUFF'
    
    ' FOLLOWING VARIABLES USED IF CHECKING FOR ERRORS DURING CODE OPERATION
2955:     strProblemReport = "-----------------------------------------\par" & vbCrLf & _
                       "NOTE:  The following problems were found in the dataset:\par" & vbCrLf & _
                       "zzzRunningProblemszzz"
                       
2959:     theTimeBegan = Now
2960:     dateRunningTime = Now
2961:     Set psbar = pApp.StatusBar
2962:     Set pPro = psbar.ProgressBar
2963:     strHeader = "Calculating General Progress"
2964:     strMessage = strHeader
    
    ' INSERT FOLLOWING WHERE YOU WANT TO CREATE THE PROGRESS FORM
2967:     If booShowProgress Then
        ' PROGRESS METER STUFF ------------------------------------------------------------------
    
    '  frmProgress.SetExpanded = ext.ProgressDialogSetExpanded
2971:       frmProgress.SetExpanded = True
2972:       Set ext = GetExtension(pApp)
2973:       frmProgress.SetAutoClose = ext.ProgressDialogAutoClose
    
2975:       theTimeBegan = Now
2976:       frmProgress.ShouldContinue = True
2977:       frmProgress.ProgBeginTime = Now
2978:       frmProgress.ProgRecCount = lngValCount
2979:       frmProgress.lblCurrentTime.Caption = Format(Now, "ttttt")
2980:       frmProgress.lblBeginTime.Caption = "Began Job: " & Format(theTimeBegan, "ttttt,  ddddd")
    
2982:       theDetailedDescription = "Calculating..." & vbCrLf & _
          "Began Job: " & Format(theTimeBegan, "ttttt,  ddddd") & vbCrLf & _
          "-------------------------------------------" & vbCrLf
2985:       frmProgress.txtDetails.Text = theDetailedDescription
2986:       frmProgress.txtDetails.SelStart = Len(theDetailedDescription)
    
2988:       frmProgress.Frame.Caption = " Current Status:"
2989:       frmProgress.Frame.Visible = True
2990:       frmProgress.cmdDetails.Visible = True
2991:       frmProgress.cmdStop.Visible = True
2992:     End If
2993:   End If
  
  Dim pCovMatrix As Matrix_jen
  Dim pMeanVector As Matrix_jen
  Dim pTransposeMean As Matrix_jen
  Dim pCorrMatrix As Matrix_jen
  Dim pSpearman As Matrix_jen
  
  Dim pArrayForProjections As esriSystem.IArray
3002:   Set pArrayForProjections = New esriSystem.Array
  
  Dim pParamsArray As esriSystem.IVariantArray
  
  Dim strSrcReport As String
  Dim pPointLayer As IFeatureLayer
  Dim pRasterBand As IRasterBand
  Dim booUseAll As Boolean
  Dim strRasterName As String
  Dim lngFieldIndex As Long
  Dim pTable As ITable
  Dim varValue As Variant
  Dim booIsString As Boolean
  Dim strFieldName As String
  Dim pField As IField
  
  ' ORGANIZE DATA ==============================================================================================================
  Dim strInputParamsReport As String
3020:   If pThisExt.ShouldContinue = False Then
 '   MsgBox "Operation Canceled..."
3022:     StatMatricesFromGeoDatasets = "Operation Canceled..."
3023:     GoTo CleanUp
    
3025:   Else
    
3027:     Set pParamsArray = pSourceArray.Element(1)
    
    Select Case lngType
      Case 1                   ' POINT THEME
'        pSourceParams.Add pPointLayer
'        pSourceParams.Add optUseAll.Value              ' TRUE IF USING ALL POINTS, FALSE IF ONLY USING SELECTED POINTS
'        pSourceParams.Add m_lngPointCount              ' TOTAL POINT COUNT FOR THIS LAYER
'        pSourceParams.Add m_lngSelPointCount           ' SELECTED POINT COUNT FOR THIS LAYER
      
3036:         Set pPointLayer = pParamsArray.Element(0)
3037:         booUseAll = pParamsArray.Element(1)
3038:         If booUseAll Then
3039:           strSrcReport = "--> Source = Point Layer [" & pPointLayer.Name & "]" & vbCrLf & _
                         "    Option to use All Points (n = " & CStr(Format(pParamsArray.Element(2), "#,##0")) & ")"
3041:         Else
3042:           strSrcReport = "--> Source = Point Layer [" & pPointLayer.Name & "]" & vbCrLf & _
                         "    Option to use Selected Points (n = " & CStr(Format(pParamsArray.Element(3), "#,##0")) & _
                         " of " & CStr(Format(pParamsArray.Element(2), "#,##0")) & ")"
3045:         End If
        
3047:         Set pSourceArray = New esriSystem.VarArray
3048:         pSourceArray.Add pPointLayer
3049:         pSourceArray.Add "Vector"
3050:         pSourceArray.Add booUseAll
3051:         pArrayForProjections.Add pSourceArray
        
        
      Case 2                  ' RASTER BAND
'          pSourceParams.Add pRasterBand
'          pSourceParams.Add strRasterName
'          pSourceParams.Add lngFieldIndex
'          pSourceParams.Add booIsString
'          pSourceParams.Add varValue
'
        
3062:         Set pRasterBand = pParamsArray.Element(0)
3063:         strRasterName = pParamsArray.Element(1)
'        Set pTable = pRasterBand.AttributeTable
3065:         Set pTable = TopoCorridor.TopoCor_Functions.ReturnRasterTable(pRasterBand)
3066:         lngFieldIndex = pParamsArray.Element(2)
3067:         Set pField = pTable.Fields.Field(lngFieldIndex)
3068:         strFieldName = pField.Name
        
3070:         booIsString = pParamsArray.Element(3)
3071:         varValue = pParamsArray.Element(4)
        
3073:         strSrcReport = "--> Source = Raster Layer [" & strRasterName & "]" & vbCrLf & _
                       "  Field Name = " & strFieldName & " at Index #" & CStr(lngFieldIndex) & vbCrLf & _
                       "  Search Value = " & CStr(varValue) & "  [Is String = " & CStr(booIsString) & "]"
        
3077:         Set pSourceArray = New esriSystem.VarArray
3078:         pSourceArray.Add pParamsArray
3079:         pSourceArray.Add "Raster"
        
3081:         pArrayForProjections.Add pSourceArray
        
3083:     End Select
3084:   End If
  
3086:   strInputParamsReport = strInputParamsReport & "Sample Point Source Options:" & vbCrLf & _
      strSrcReport & vbCrLf & "-----------------------------------------" & vbCrLf
  
  ' FOR DEBUGGING - SAVE ANCILLARY STATS TABLES OPTIONS
  Dim strSaveTablesReport As String
  Dim pMeansParams As esriSystem.IVariantArray
3092:   Set pMeansParams = pThisExt.StatsSaveMeansOptions
  Dim pCovParams As esriSystem.IVariantArray
3094:   Set pCovParams = pThisExt.StatsSaveCovOptions
  Dim pInvCovParams As esriSystem.IVariantArray
3096:   Set pInvCovParams = pThisExt.StatsSaveInvCovOptions
  Dim pCorrParams As esriSystem.IVariantArray
3098:   Set pCorrParams = pThisExt.StatsSaveCorrelationOptions
  Dim pSpearmanParams As esriSystem.IVariantArray
3100:   Set pSpearmanParams = pThisExt.StatsSaveSpearmanOptions
  
3102:   If pMeansParams Is Nothing And pCovParams Is Nothing And pInvCovParams Is Nothing _
      And pCorrParams Is Nothing And pSpearmanParams Is Nothing Then
      
3105:     strSaveTablesReport = "No ancillary tables saved..." & vbCrLf
      
3107:   Else
  
3109:     If Not pMeansParams Is Nothing Then
3110:       strSaveTablesReport = strSaveTablesReport & _
      "  Mean Vector Saved:" & vbCrLf & _
      "    Table Name = " & pMeansParams.Element(0) & vbCrLf & _
      "    WS Path = " & pMeansParams.Element(1) & vbCrLf & _
      "    Full Path = " & pMeansParams.Element(2) & vbCrLf '& _
     ' "  Workspace Type = " & CStr(pMeansParams.Element(3))
        
3117:     End If
    
3119:     If Not pCovParams Is Nothing Then
3120:       strSaveTablesReport = strSaveTablesReport & _
      "  Covariance Matrix Saved:" & vbCrLf & _
      "    Table Name = " & pCovParams.Element(0) & vbCrLf & _
      "    WS Path = " & pCovParams.Element(1) & vbCrLf & _
      "    Full Path = " & pCovParams.Element(2) & vbCrLf '& _
      '"  Workspace Type = " & CStr(pCovParams.Element(3))
3126:     End If
    
3128:     If Not pInvCovParams Is Nothing Then
3129:       strSaveTablesReport = strSaveTablesReport & _
      "  Inverse Covariance Matrix Saved:" & vbCrLf & _
      "    Table Name = " & pInvCovParams.Element(0) & vbCrLf & _
      "    WS Path = " & pInvCovParams.Element(1) & vbCrLf & _
      "    Full Path = " & pInvCovParams.Element(2) & vbCrLf '& _
      '"  Workspace Type = " & CStr(pInvCovParams.Element(3))
3135:     End If
    
3137:     If Not pCorrParams Is Nothing Then
3138:       strSaveTablesReport = strSaveTablesReport & _
      "  Correlation Matrix Saved:" & vbCrLf & _
      "    Table Name = " & pCorrParams.Element(0) & vbCrLf & _
      "    WS Path = " & pCorrParams.Element(1) & vbCrLf & _
      "    Full Path = " & pCorrParams.Element(2) & vbCrLf '& _
      '"  Workspace Type = " & CStr(pCorrParams.Element(3))
3144:     End If
    
3146:     If Not pSpearmanParams Is Nothing Then
3147:       strSaveTablesReport = strSaveTablesReport & _
      "  Spearman's Rank Correlation (Rho) Matrix Saved:" & vbCrLf & _
      "    Table Name = " & pSpearmanParams.Element(0) & vbCrLf & _
      "    WS Path = " & pSpearmanParams.Element(1) & vbCrLf & _
      "    Full Path = " & pSpearmanParams.Element(2) & vbCrLf '& _
      '"  Workspace Type = " & CStr(pspearmanParams.Element(3))
3153:     End If
    
 '   strSaveTablesReport = _
      "Save Means = " & CStr(pThisExt.StatsSaveMeans) & vbCrLf & strMeansReport & vbCrLf & _
      "Save Covariances = " & CStr(pThisExt.StatsSaveCov) & vbCrLf & strCovReport & vbCrLf & _
      "Save Inverse Covariances = " & CStr(pThisExt.StatsSaveInvCov) & vbCrLf & strInvCovReport & vbCrLf & _
      "Save Correlation = " & CStr(pThisExt.StatsSaveCorrelation) & vbCrLf & strCorrReport
3160:   End If

3162:   strInputParamsReport = strInputParamsReport & "Save Statistical Tables Options:" & vbCrLf & _
      strSaveTablesReport & vbCrLf & "-----------------------------------------" & vbCrLf

  Dim strReport As String
    
  ' NOTE:  EACH OF THESE SELECTED ITEMS IS AN esriSystem.IVariantArray CONTAINING THE FOLLOWING ITEMS:
  ' 1) IF A RASTER LAYER (i.e. if theArray.Element(1) = "Raster"):
  '    0) Index value of original Raster list item; not useful any more
  '    1) String "Raster", indicating the data type of this item
  '    2) Actual Raster object, original saved as IRasterBandCollection but available as an IRaster
  '    3) Name of Raster Object, as it appeared in original list
  '    4) Band Index; added by this function
  ' 2) IF A POLYGON LAYER (i.e. if theArray.Element(1) = "Polygon"):
  '    0) Index value of original Polygon list item; not useful any more
  '    1) String "Polygon", indicating the data type of this item
  '    2) Actual Polygon Layer
  '    3) Polygon Layer Name
  '    4) Field Index value for selected attribute field
  '    5) Actual selected attribute field
  '    6) Band Index; added by this function
  
  Dim pVariableNames As esriSystem.IStringArray
3184:   Set pVariableNames = New esriSystem.strArray
  
  Dim pUnknownBandColl As IRasterBandCollection
  Dim pUnknownBand As IRasterBand
  
3189:   For lngCheckIndex = 0 To pSelectedArray.Count - 1
3190:     Set pSubArray = pSelectedArray.Element(lngCheckIndex)
3191:     Set pUnknown = pSubArray.Element(2)
3192:     pVariableNames.Add pSubArray.Element(3)
    
3194:     If pSubArray.Element(1) = "Raster" Then
3195:       strReport = strReport & "   " & CStr(lngCheckIndex + 1) & "] RASTER: " & pSubArray.Element(3) & vbCrLf ' & _
                              ' "       Dataset is IRaster = " & CStr(TypeOf pUnknown Is IRaster) & vbCrLf
      
      ' MODIFIED SEPTEMBER 17, 2008 BY JENNESS
      ' OBJECT MIGHT BE A RASTER BAND; IF SO, THEN SWITCH TO RASTER HERE.
3200:       If TypeOf pUnknown Is IRasterBand Then
3201:         Set pUnknownBand = pUnknown
3202:         Set pUnknownBandColl = New Raster
3203:         pUnknownBandColl.AppendBand pUnknownBand
3204:         pSubArray.Remove 2
3205:         pSubArray.Insert 2, pUnknownBandColl
3206:       End If
      
3208:     Else
3209:       Set pField = pSubArray.Element(5)
3210:       strReport = strReport & "   " & CStr(lngCheckIndex + 1) & "] POLYGON FEATURE LAYER: " & pSubArray.Element(3) & vbCrLf & _
                              "       Attribute Field:  Name = " & pField.Name & vbCrLf ' & ",   Index = " & pSubArray.Element(4) & vbCrLf & _
                              '"       Dataset is IFeatureLayer = " & CStr(TypeOf pUnknown Is IFeatureLayer) & vbCrLf
3213:     End If
3214:   Next lngCheckIndex
  
3216:   strInputParamsReport = strInputParamsReport & "Mahalanobis Input Variable Options:" & vbCrLf & _
      strReport & vbCrLf & "-----------------------------------------" & vbCrLf
      
  
  ' ADD MAHALANOBIS VARIABLE ARRAYS
3221:   pArrayForProjections.Add pSelectedArray
  
  ' =========================================================================================================================
  ' UNIFY PROJECTIONS =======================================================================================================
  ' =========================================================================================================================
  
  Dim strReturnMessage As String
  Dim booShouldStop As Boolean
  
  Dim pCommonProjectionArray As esriSystem.IArray
3231:   Set pCommonProjectionArray = UnifyProjections(pArrayForProjections, pApp, pThisExt, strMessage, _
      psbar, pPro, lngTimer, theProgressSpecific, theDetailedDescription, strTimeElapsed, booFoundProblems, _
      strReturnMessage, booShouldStop, theTimeBegan)
  
3235:   If booShouldStop Then
3236:     StatMatricesFromGeoDatasets = StatMatricesFromGeoDatasets & vbCrLf & strReturnMessage
3237:     GoTo CleanUp
3238:   End If
  
  Dim pCommonSpRef As ISpatialReference
3241:   Set pCommonSpRef = pCommonProjectionArray.Element(2)
  
3243:   If pCommonProjectionArray Is Nothing Then
3244:     StatMatricesFromGeoDatasets = StatMatricesFromGeoDatasets & vbCrLf & "Operation Failed:" & vbCrLf & "--------------------------------" & vbCrLf & _
      "Failed to Convert all data sources into a common projection..." & vbCrLf
3246:     GoTo CleanUp
3247:   End If
    
  ' FOR DEBUGGING; LOAD ALL RASTERS INTO VIEW -----------------------------------------------------------------------------
'  Dim lngDebugIndex As Long
'  Dim pDebugRasterDataset As IRasterDataset
'  Dim pDebugArray As esriSystem.IVariantArray
'  Dim pDebugVariablesArray As esriSystem.IVariantArray
'  Dim pDebugLayer As IRasterLayer
'  If lngType = 2 Then                  ' MEANS SOURCE DATA WAS RASTER.  ALSO MEANS RASTER IS TEMPORARY AND MUST BE DELETED
'    Set pDebugRasterDataset = pCommonProjectionArray.Element(0)
'    Set pDebugLayer = New RasterLayer
'    pDebugLayer.CreateFromDataset pDebugRasterDataset
'    pDebugLayer.Name = "Source for Stats"
'    pMxDoc.FocusMap.AddLayer pDebugLayer
'  End If
'
'  Dim booDebugDelete As Boolean
'  Set pDebugVariablesArray = pCommonProjectionArray.Element(1)
'  For lngDebugIndex = 0 To pDebugVariablesArray.Count - 1
'    Set pDebugArray = pDebugVariablesArray.Element(lngDebugIndex)
'    booDebugDelete = pDebugArray.Element(0)
'    Set pDebugRasterDataset = pDebugArray.Element(1)
'    Set pDebugLayer = New RasterLayer
'    pDebugLayer.CreateFromDataset pDebugRasterDataset
'    pDebugLayer.Name = "Raster #" & str(lngDebugIndex + 1) & " Delete = " & CStr(booDebugDelete)
'    pMxDoc.FocusMap.AddLayer pDebugLayer
'  Next lngDebugIndex
  '-------------------------------------------------------------------------------------------------------------------------
  
  
  
  ' =========================================================================================================================
  ' EXTRACT SOURCE DATA =====================================================================================================
  ' =========================================================================================================================
  
  
  
  ' CURRENTLY HAVE ALL DATASETS IN CORRECT PROJECTION
  ' NEXT CREATE VARIANCE AND COVARIANCE MATRICES IF NECESSARY
  Dim pVariablesArray As esriSystem.IVariantArray
3287:   Set pVariablesArray = pCommonProjectionArray.Element(1)
  Dim pDataVariableArray As esriSystem.IVariantArray
  Dim lngRowCount As Long       ' ONLY USED IF INPUT SOURCE IS A POINT LAYER
  Dim strFailureReason As String
  
  ' FOR DEBUGGING
'  Dim lngDebug As Long
'  Dim strDebug As String
'  Dim pDebugArray As esriSystem.IVariantArray
'  strDebug = "Before Extract Source Data" & vbCrLf & vbCrLf
'  For lngDebug = 0 To pVariablesArray.Count - 1
'    Set pDebugArray = pVariablesArray.Element(lngDebug)
'    strDebug = strDebug & "Dataset Name = " & pDebugArray.Element(3) & ",    " & _
'                          "lngBandIndex = " & CStr(pDebugArray.Element(4)) & ",    " & _
'                          "Data Array Count = " & CStr(pDebugArray.Count) & vbCrLf
'  Next lngDebug
'  MsgBox strDebug
  Dim pPointCollection As IPointCollection
  Dim pSourceRasDataset As IRasterDataset
  
  Select Case lngType
    Case 1                   ' POINT THEME
3309:       Set pMeanVector = New Matrix_jen
3310:       Set pCovMatrix = New Matrix_jen
3311:       Set pCorrMatrix = New Matrix_jen
3312:       If pThisExt.StatsSaveSpearman Then
3313:         Set pSpearman = New Matrix_jen
3314:       Else
3315:         Set pSpearman = Nothing
3316:       End If
      
3318:       Set pPointCollection = pCommonProjectionArray.Element(0)
  
 '     MsgBox "pPointCollection is Nothing = " & CStr(pPointCollection Is Nothing) & vbCrLf & _
             "pVariablesArray is Nothing = " & CStr(pVariablesArray Is Nothing) & vbCrLf & _
             "pMeanVector is Nothing = " & CStr(pMeanVector Is Nothing) & vbCrLf & _
             "pCovMatrix is Nothing = " & CStr(pCovMatrix Is Nothing) & vbCrLf & _
             "Use Interp = " & CStr(pThisExt.UseInterpCellValue) & vbCrLf & _
             "lngRowCount = " & CStr(lngRowCount) & vbCrLf & _
             "strFailureReason = " & strFailureReason
         
3328:       Call ExtractStatMatricesFromPointCollection(pPointCollection, pVariablesArray, pTransposeMean, _
            pCovMatrix, pThisExt.UseInterpCellValue, lngRowCount, strFailureReason, pCorrMatrix, pThisExt, pApp, _
            strMessage, psbar, pPro, lngTimer, theProgressSpecific, theDetailedDescription, strTimeElapsed, booFoundProblems, _
            strReturnMessage, booShouldStop, theTimeBegan, pSpearman)
            
3333:       If booShouldStop Then
3334:         StatMatricesFromGeoDatasets = StatMatricesFromGeoDatasets & vbCrLf & strReturnMessage
3335:         GoTo CleanUp
3336:       End If
            
3338:       If lngRowCount <> pPointCollection.PointCount Then
3339:         StatMatricesFromGeoDatasets = StatMatricesFromGeoDatasets & "Note:  Only " & CStr(lngRowCount) & " of " & _
          CStr(pPointCollection.PointCount) & " sample points had non-null values for all " & _
          "input variables..." & vbCrLf & vbCrLf
3342:       End If
      
3344:       If pTransposeMean.IsNull Or pCovMatrix.IsNull Then
3345:         If lngRowCount = 0 Then
3346:           StatMatricesFromGeoDatasets = "Operation Failed:" & vbCrLf & "--------------------------------" & vbCrLf & _
            "Failed to generate Mean Vector and Covariance Matrices from sample points..." & vbCrLf & _
            "No sample points intersected all Variable sources, so all samples had missing data and were excluded..." & _
            vbCrLf & strFailureReason
3350:           GoTo CleanUp
3351:         Else
3352:           StatMatricesFromGeoDatasets = "Operation Failed:" & vbCrLf & "--------------------------------" & vbCrLf & _
            "Failed to generate Mean Vector and Covariance Matrices from sample points..." & vbCrLf & strFailureReason
3354:           GoTo CleanUp
3355:         End If
3356:       End If
3357:       Set pMeanVector = pTransposeMean.Transpose(True)
      
    Case 2                  ' RASTER BAND
3360:       Set pMeanVector = New Matrix_jen
3361:       Set pCovMatrix = New Matrix_jen
3362:       Set pCorrMatrix = New Matrix_jen
3363:       If pThisExt.StatsSaveSpearman Then
3364:         Set pSpearman = New Matrix_jen
3365:       Else
3366:         Set pSpearman = Nothing
3367:       End If
3368:       Set pSourceRasDataset = pCommonProjectionArray.Element(0)
3369:       Call ExtractStatMatricesFromRaster(pSourceRasDataset, pVariablesArray, pTransposeMean, pCovMatrix, pCommonSpRef, _
          pCorrMatrix, pThisExt, pApp, strMessage, psbar, pPro, lngTimer, theProgressSpecific, theDetailedDescription, _
          strTimeElapsed, booFoundProblems, strReturnMessage, booShouldStop, theTimeBegan, pSpearman)
          
3373:       If booShouldStop Then
3374:         StatMatricesFromGeoDatasets = StatMatricesFromGeoDatasets & vbCrLf & strReturnMessage
3375:         GoTo CleanUp
3376:       End If
      
3378:       If pTransposeMean.IsNull Or pCovMatrix.IsNull Then
3379:         StatMatricesFromGeoDatasets = "Operation Failed:" & vbCrLf & "--------------------------------" & vbCrLf & _
          "Failed to generate Mean Vector and Covariance Matrices from " & pParamsArray.Element(1) & "..." & vbCrLf
3381:         GoTo CleanUp
3382:       End If
3383:       Set pMeanVector = pTransposeMean.Transpose(True)
      
3385:   End Select
    
  ' =========================================================================================================================
  ' STATISTICAL MATRICES ====================================================================================================
  ' =========================================================================================================================
  
  Dim booStringError As Boolean
  Dim strMeanVector As String
3393:   If pThisExt.StatsSaveMeans Then
3394:     strMeanVector = pMeanVector.MakeTextWithHeaders(pVariableNames, False, True, booStringError, 6, _
        "Mean Vector") & vbCrLf & vbCrLf
3396:   Else
3397:     strMeanVector = ""
3398:   End If
  
  Dim strCovMatrix As String
3401:   If pThisExt.StatsSaveCov Then
3402:     strCovMatrix = pCovMatrix.MakeTextWithHeaders(pVariableNames, True, True, booStringError, 6, _
        "Covariance Matrix") & vbCrLf & vbCrLf
3404:   Else
3405:     strCovMatrix = ""
3406:   End If
  
  ' INVERT COVARIANCE MATRIX
  Dim pInvCovMatrix As Matrix_jen
  Dim bytInvertSucceeded As Byte
  
3412:   If pThisExt.StatsSaveInvCov Then
3413:     If booShowProgress Then
      ' UPDATE PROGRESS METER ==================================================================
3415:       strMessage = "Inverting Covariance Matrix..."
3416:       psbar.Message(0) = strMessage
3417:       pPro.position = 0
3418:       lngTimer = lngTimer + 1
          
      ' ---- PROGRESS METER STUFF
3421:       DoEvents
3422:       theProgressSpecific = strMessage
3423:       theDetailedDescription = theDetailedDescription & _
        " --> Inverting Covariance Matrix..." & vbCrLf & _
        "          [time stamp " & Format(Now, "ttttt,  ddddd") & "]" & vbCrLf & vbCrLf
3426:       frmProgress.ResetShortTimer
3427:       frmProgress.txtDetails.Text = theDetailedDescription
3428:       frmProgress.txtDetails.SelStart = Len(theDetailedDescription)
  
3430:       frmProgress.Est_Time_Left lngTimer, "Inverting Covariance Matrix...", "Calculating Data...", False
      ' frmProgress.lblCurrentTime.Caption = Format(Now, "ttttt")
3432:       frmProgress.Refresh
3433:       frmProgress.icnProgressLine.Refresh
3434:       DoEvents
3435:       If BailOutOfProgress(frmProgress, pApp) Then
  
       ' ********************************************************************************************
        ' ALTERNATIVE CODE THAT SAVES PARTIAL TABLE, CHECKS IF ERRORS FOUND AND OUTPUTS RTF INSTEAD OF TEXT
3439:         strTimeElapsed = TopoCorridor.MyGeneralOperations.ReturnTimeElapsedRTF(theTimeBegan, Now, 7)
  
3441:         If booFoundProblems Then
3442:           StatMatricesFromGeoDatasets = strInputParamsReport & "-----------------------------------------\par" & vbCrLf & _
            "NOTE:  Exited Function Prematurely at Step " & CStr(lngTimer) & "\par" & vbCrLf & _
              Replace(strProblemReport, "zzzRunningProblemszzz", strRunningProblems) & vbCrLf & _
            "-----------------------------------------\par" & vbCrLf & _
            "\pard\qc " & strTimeElapsed & vbCrLf & "}"
3447:         Else
3448:           StatMatricesFromGeoDatasets = strInputParamsReport & "-----------------------------------------\par" & vbCrLf & _
            "NOTE:  Exited Function Prematurely at Step " & CStr(lngTimer) & "\par" & vbCrLf & _
            "-----------------------------------------\par" & vbCrLf & _
            "\pard\qc " & strTimeElapsed & vbCrLf & "}"
3452:         End If
  
       ' ********************************************************************************************
  
3456:         frmProgress.cmdStop.Caption = "Close"
3457:         pPro.position = 0
3458:         psbar.HideProgressBar
3459:         GoTo CleanUp
3460:       End If
      ' ---- END PROGRESS METER STUFF --------------------------------
3462:     End If
3463:   End If
  
  ' ONLY INVERT IF REQUESTED
3466:   If pThisExt.StatsSaveInvCov Then
3467:     Set pInvCovMatrix = pCovMatrix.Invert(bytInvertSucceeded)
3468:   Else
3469:     Set pInvCovMatrix = Nothing
3470:     bytInvertSucceeded = 4
3471:   End If
  
  Dim strInvCovMatrix As String
      
  ' MODIFIES BYTE VALUE
  '   0) IF OPERATION SUCCESSFUL
  '   1) FAILED AT MatrixLUDecomp_jen BECAUSE OF NON-SQUARE MATRIX
  '   2) FAILED AT MatrixLUDecomp_jen BECAUSE OF SINGULAR MATRIX
  '   3) FAILED AT MatrixFBSub_jen BECAUSE OF UNKNOWN REASONS

  Select Case bytInvertSucceeded
    Case 1
3483:       StatMatricesFromGeoDatasets = "Operation Failed:" & vbCrLf & "--------------------------------" & vbCrLf & _
        "  --> Failed to invert covariance matrix:" & vbCrLf & _
        "  --> FAILED AT MatrixLUDecomp_jen because of Non-Square Matrix..." & vbCrLf & _
        strMeanVector & vbCrLf & strCovMatrix
3487:       GoTo CleanUp
    Case 2
3489:       StatMatricesFromGeoDatasets = "Operation Failed:" & vbCrLf & "--------------------------------" & vbCrLf & _
        "  --> Failed to invert covariance matrix:" & vbCrLf & _
        "  --> FAILED AT MatrixLUDecomp_jen because of Singular Matrix..." & vbCrLf & _
        "     This is generally due to one variable having NO variance at all (i.e. all sample " & _
        "point values are the same)." & vbCrLf & vbCrLf & _
        strMeanVector & vbCrLf & strCovMatrix
3495:       GoTo CleanUp
    Case 3
3497:       StatMatricesFromGeoDatasets = "Operation Failed:" & vbCrLf & "--------------------------------" & vbCrLf & _
        "  --> Failed to invert covariance matrix:" & vbCrLf & _
        "  --> FAILED AT MatrixFBSub_jen (Back-Substitution Step) because of unknown reasons..." & vbCrLf & _
        strMeanVector & vbCrLf & strCovMatrix
3501:       GoTo CleanUp
    Case 4            ' DID NOT ATTEMPT
3503:       strInvCovMatrix = ""
      
    Case Else         ' SUCCEEDED
3506:       strInvCovMatrix = pInvCovMatrix.MakeTextWithHeaders(pVariableNames, True, True, booStringError, 6, _
          "Inverse Covariance Matrix") & vbCrLf & vbCrLf
3508:   End Select
  
  ' TEST INVERSION
  Dim strMultMatrix As String
  Dim pMultMatrix As Matrix_jen
3513:   If bytInvertSucceeded = 0 Then
3514:     Set pMultMatrix = pCovMatrix.Multiply(pInvCovMatrix, True)
3515:     strMultMatrix = pMultMatrix.MakeTextWithHeaders(pVariableNames, True, True, booStringError, 3, _
        "Check Multiplication") & vbCrLf & vbCrLf
3517:   Else
3518:     strMultMatrix = ""
3519:   End If
  
  ' CORRELATION
  Dim strCorrMatrix As String
3523:   If pThisExt.StatsSaveCorrelation Then
3524:     strCorrMatrix = pCorrMatrix.MakeTextWithHeaders(pVariableNames, True, True, booStringError, 3, _
        "Correlation Matrix") & vbCrLf & vbCrLf
3526:   Else
3527:     strCorrMatrix = ""
3528:   End If
  
  ' SPEARMAN CORRELATION
  Dim strSpearmanMatrix As String
3532:   If pThisExt.StatsSaveSpearman Then
3533:     strSpearmanMatrix = pSpearman.MakeTextWithHeaders(pVariableNames, True, True, booStringError, 3, _
        "Spearman's Rank Correlation (Rho) Matrix") & vbCrLf & vbCrLf
3535:   Else
3536:     strSpearmanMatrix = ""
3537:   End If
    
3539:   StatMatricesFromGeoDatasets = StatMatricesFromGeoDatasets & _
      strMeanVector & _
      strCovMatrix & _
      strInvCovMatrix & _
      strMultMatrix & _
      strCorrMatrix & _
      strSpearmanMatrix
  
  
  ' =========================================================================================================================
  ' SAVE TABLES =============================================================================================================
  ' =========================================================================================================================
  
  
  Dim strTableWS As String
  Dim strTableName As String
  Dim strFullName As String
  Dim lngTableCategory As JenDatasetTypes
  Dim pTableOptions As esriSystem.IVariantArray
  Dim strSaveString As String
3559:   strSaveString = "-------------------------------------------------" & vbCrLf & _
      "Statistical Tables Saved:" & vbCrLf
  Dim booAddSaveString As Boolean
3562:   booAddSaveString = False
  Dim strFieldNameReport As String
  
  ' MEAN VECTOR
3566:   If pThisExt.StatsSaveMeans Then
3567:     Set pTableOptions = pThisExt.StatsSaveMeansOptions
3568:     strTableName = pTableOptions.Element(0)
3569:     strTableWS = pTableOptions.Element(1)
3570:     strFullName = pTableOptions.Element(2)
3571:     lngTableCategory = pTableOptions.Element(3)
3572:     Call CreateTables(pMeanVector, True, strTableWS, strTableName, lngTableCategory, "Mean Vector", pMxDoc, pApp, pThisExt, _
        strFieldNameReport, pVariableNames)
3574:     strSaveString = strSaveString & "  --> Mean Vector:" & vbCrLf & _
                                    "      Saved to " & strFullName & vbCrLf & _
                                    strFieldNameReport & vbCrLf
3577:     booAddSaveString = True
3578:     If booShowProgress Then
3579:       theDetailedDescription = theDetailedDescription & _
        " --> Saving Mean Vector Table..." & vbCrLf & _
        "          [time stamp " & Format(Now, "ttttt,  ddddd") & "]" & vbCrLf & vbCrLf
3582:       frmProgress.txtDetails.Text = theDetailedDescription
3583:       frmProgress.txtDetails.SelStart = Len(theDetailedDescription)
3584:     End If
3585:   End If
  
  ' COVARIANCE MATRIX
3588:   If pThisExt.StatsSaveCov Then
3589:     Set pTableOptions = pThisExt.StatsSaveCovOptions
3590:     strTableName = pTableOptions.Element(0)
3591:     strTableWS = pTableOptions.Element(1)
3592:     strFullName = pTableOptions.Element(2)
3593:     lngTableCategory = pTableOptions.Element(3)
3594:     Call CreateTables(pCovMatrix, False, strTableWS, strTableName, lngTableCategory, "Covariance Matrix", pMxDoc, pApp, _
        pThisExt, strFieldNameReport, pVariableNames)
3596:     strSaveString = strSaveString & "  --> Covariance Matrix:" & vbCrLf & _
                                    "      Saved to " & strFullName & vbCrLf & _
                                    strFieldNameReport & vbCrLf
3599:     booAddSaveString = True
3600:     If booShowProgress Then
3601:       theDetailedDescription = theDetailedDescription & _
        " --> Saving Covariance Matrix Table..." & vbCrLf & _
        "          [time stamp " & Format(Now, "ttttt,  ddddd") & "]" & vbCrLf & vbCrLf
3604:       frmProgress.txtDetails.Text = theDetailedDescription
3605:       frmProgress.txtDetails.SelStart = Len(theDetailedDescription)
3606:     End If
3607:   End If
  
  ' INVERSE COVARIANCE MATRIX
3610:   If pThisExt.StatsSaveInvCov Then
3611:     Set pTableOptions = pThisExt.StatsSaveInvCovOptions
3612:     strTableName = pTableOptions.Element(0)
3613:     strTableWS = pTableOptions.Element(1)
3614:     strFullName = pTableOptions.Element(2)
3615:     lngTableCategory = pTableOptions.Element(3)
3616:     Call CreateTables(pInvCovMatrix, False, strTableWS, strTableName, lngTableCategory, "Inverse Covariance Matrix", pMxDoc, _
          pApp, pThisExt, strFieldNameReport, pVariableNames)
3618:     strSaveString = strSaveString & "  --> Inverse Covariance Matrix:" & vbCrLf & _
                                    "      Saved to " & strFullName & vbCrLf & _
                                    strFieldNameReport & vbCrLf
3621:     booAddSaveString = True

3623:     If booShowProgress Then
3624:       theDetailedDescription = theDetailedDescription & _
        " --> Saving Inverse Covariance Matrix Table..." & vbCrLf & _
        "          [time stamp " & Format(Now, "ttttt,  ddddd") & "]" & vbCrLf & vbCrLf
3627:       frmProgress.txtDetails.Text = theDetailedDescription
3628:       frmProgress.txtDetails.SelStart = Len(theDetailedDescription)
3629:     End If
3630:   End If
  
  ' CORRELATION
3633:   If pThisExt.StatsSaveCorrelation Then
3634:     Set pTableOptions = pThisExt.StatsSaveCorrelationOptions
3635:     strTableName = pTableOptions.Element(0)
3636:     strTableWS = pTableOptions.Element(1)
3637:     strFullName = pTableOptions.Element(2)
3638:     lngTableCategory = pTableOptions.Element(3)
3639:     Call CreateTables(pCorrMatrix, False, strTableWS, strTableName, lngTableCategory, "Correlation Matrix", pMxDoc, pApp, _
        pThisExt, strFieldNameReport, pVariableNames)
3641:     strSaveString = strSaveString & "  --> Correlation Matrix:" & vbCrLf & _
                                    "      Saved to " & strFullName & vbCrLf & _
                                    strFieldNameReport & vbCrLf
3644:     booAddSaveString = True

3646:     If booShowProgress Then
3647:       theDetailedDescription = theDetailedDescription & _
        " --> Saving Correlation Matrix Table..." & vbCrLf & _
        "          [time stamp " & Format(Now, "ttttt,  ddddd") & "]" & vbCrLf & vbCrLf
3650:       frmProgress.txtDetails.Text = theDetailedDescription
3651:       frmProgress.txtDetails.SelStart = Len(theDetailedDescription)
3652:     End If
3653:   End If
  
  ' SPEARMAN'S RANK CORRELATION
3656:   If pThisExt.StatsSaveSpearman Then
3657:     Set pTableOptions = pThisExt.StatsSaveSpearmanOptions
3658:     strTableName = pTableOptions.Element(0)
3659:     strTableWS = pTableOptions.Element(1)
3660:     strFullName = pTableOptions.Element(2)
3661:     lngTableCategory = pTableOptions.Element(3)
3662:     Call CreateTables(pSpearman, False, strTableWS, strTableName, lngTableCategory, "Spearman's Rank Correlation Matrix", pMxDoc, pApp, _
        pThisExt, strFieldNameReport, pVariableNames)
3664:     strSaveString = strSaveString & "  --> Spearman's Rank Correlation Matrix:" & vbCrLf & _
                                    "      Saved to " & strFullName & vbCrLf & _
                                    strFieldNameReport & vbCrLf
3667:     booAddSaveString = True

3669:     If booShowProgress Then
3670:       theDetailedDescription = theDetailedDescription & _
        " --> Saving Spearman's Rank Correlation Matrix Table..." & vbCrLf & _
        "          [time stamp " & Format(Now, "ttttt,  ddddd") & "]" & vbCrLf & vbCrLf
3673:       frmProgress.txtDetails.Text = theDetailedDescription
3674:       frmProgress.txtDetails.SelStart = Len(theDetailedDescription)
3675:     End If
3676:   End If
  
3678:   If booAddSaveString Then
3679:     StatMatricesFromGeoDatasets = StatMatricesFromGeoDatasets & strSaveString & vbCrLf & "-------------------------------------------------"
3680:   End If
3681:   frmProgress.ZOrder 0
'
''   Crashes when incorporating polygon layer
'
'
'
'  ' =========================================================================================================================
'  ' GENERATE MAHALANOBIS RASTER =============================================================================================
'  ' =========================================================================================================================
'
'
'
'
'  ' 1] MAKE VARIANT-ARRAY MATRIX OF RASTER BANDS
'  Dim pBandsMatrix As esriSystem.IVariantArray
'  Set pBandsMatrix = MakeRasterMatrix(pVariablesArray, pThisExt, pApp)     ' RETURNS COLUMN OF RASTER BANDS
'
'  ' 2] GET A COLUMN OF (X MINUS MEANS) RASTERS
'  Dim pXMinusMeansMatrix As IVariantArray
'  Dim strXMinusReason As String
'  Dim booXMinus As Boolean
'  Set pXMinusMeansMatrix = ReturnXMinusMeans(pBandsMatrix, pMeanVector, booXMinus, strXMinusReason, pThisExt, pApp, strMessage, _
'      psbar, pPro, lngTimer, theProgressSpecific, theDetailedDescription, strTimeElapsed, booFoundProblems, _
'      strReturnMessage, booShouldStop, theTimeBegan)
'
'  If booShouldStop Then
'    StatMatricesFromGeoDatasets = StatMatricesFromGeoDatasets & vbCrLf & strReturnMessage
'    goto cleanup
'  End If
'
'  If booXMinus Then       ' I.E. IF OPERATION FAILED
'    StatMatricesFromGeoDatasets = "Operation Failed:" & vbCrLf & "--------------------------------" & vbCrLf & _
'      "  --> Failed to subtract raster band mean values from raster bands..." & vbCrLf & _
'      strMeanVector & vbCrLf & strCovMatrix
'    goto cleanup
'  End If
'
'  ' 3] TRANSPOSE (X MINUS MEANS) MATRIX
'  Dim pXMinusMeansTransposeMatrix As IVariantArray
'  Set pXMinusMeansTransposeMatrix = TransposeRasterMatrix(pXMinusMeansMatrix, pThisExt, pApp)
'
'  ' 4] MULTIPLY (X MINUS MEANS TRANSPOSED) BY COVARIANCE MATRIX
'  Dim pMultiplyStep1 As esriSystem.IVariantArray
'  Set pMultiplyStep1 = MahalStep1(pXMinusMeansTransposeMatrix, pInvCovMatrix, pMxDoc, pThisExt, pApp, strMessage, _
'      psbar, pPro, lngTimer, theProgressSpecific, theDetailedDescription, strTimeElapsed, booFoundProblems, _
'      strReturnMessage, booShouldStop, theTimeBegan)
'
'  If booShouldStop Then
'    StatMatricesFromGeoDatasets = StatMatricesFromGeoDatasets & vbCrLf & strReturnMessage
'    goto cleanup
'  End If
'
'  ' 5] MULTIPLY pMultiplyStep1 BY (X MINUS MEANS) MATRIX
'  Dim pMultiplyStep2 As IRaster
'  Set pMultiplyStep2 = MahalStep2(pMultiplyStep1, pXMinusMeansMatrix, pThisExt, pApp, strMessage, _
'      psbar, pPro, lngTimer, theProgressSpecific, theDetailedDescription, strTimeElapsed, booFoundProblems, _
'      strReturnMessage, booShouldStop, theTimeBegan)
'
'  If booShouldStop Then
'    StatMatricesFromGeoDatasets = StatMatricesFromGeoDatasets & vbCrLf & strReturnMessage
'    goto cleanup
'  End If
'
'  ' NOW HAVE MAHALANOBIS RASTER
'  ' SAVE DATASET
''  Set pOptions = pThisExt.frmGridLayersReturn
''  Set pSelectedArray = pOptions.Element(0)
''  booExact = pOptions.Element(1)
''  strWS = pOptions.Element(2)
''  lngWSType = pOptions.Element(3)
''  strMahal = pOptions.Element(4)
'
'  Dim pSaveAs As ISaveAs
'  Set pSaveAs = pMultiplyStep2
'  Dim strFormat As String
'  If lngWSType = ENUM_File_Raster Then
'    strFormat = "GRID"
'  Else
'    strFormat = "GDB"
'  End If
'
'  If booShowProgress Then
'    theDetailedDescription = theDetailedDescription & _
'      " --> Saving Mahalanobis Grid..." & vbCrLf & _
'      "          [time stamp " & Format(Now, "ttttt,  ddddd") & "]" & vbCrLf & vbCrLf
'    frmProgress.txtDetails.Text = theDetailedDescription
'    frmProgress.txtDetails.SelStart = Len(theDetailedDescription)
'  End If
'
'  pSaveAs.SaveAs strMahal, pOptions.Element(5), strFormat
'
'
'  If booShowProgress Then
'    theDetailedDescription = theDetailedDescription & _
'      " --> Adding Mahalanobis Layer to Map..." & vbCrLf & _
'      "          [time stamp " & Format(Now, "ttttt,  ddddd") & "]" & vbCrLf & vbCrLf
'    frmProgress.txtDetails.Text = theDetailedDescription
'    frmProgress.txtDetails.SelStart = Len(theDetailedDescription)
'  End If
'
'  ' ADD RASTER TO MAP DOCUMENT
'  Dim pNewLayer As IRasterLayer
'  Set pNewLayer = New RasterLayer
'  pNewLayer.CreateFromRaster pMultiplyStep2
'  pNewLayer.Name = strMahal
'
'  ' SYMBOLIZE RASTER LAYER
'
'  ' Create renderer and QI RasterRenderer
'  Dim pStretchRen As IRasterStretchColorRampRenderer
'  Set pStretchRen = New RasterStretchColorRampRenderer
'  Dim pRasRen As IRasterRenderer
'  Set pRasRen = pStretchRen
'
'  ' Set raster for the renderer and update
'  Set pRasRen.Raster = pMultiplyStep2
'  pRasRen.Update
'
'  ' COLORS
'  Dim pRedColor As IColor
'  Dim pYellowColor As IColor
'  Dim pGreenColor As IColor
'
'  Set pRedColor = New RgbColor
'  Set pYellowColor = New RgbColor
'  Set pGreenColor = New RgbColor
'
'  pRedColor.RGB = RGB(190, 0, 0)
'  pYellowColor.RGB = RGB(255, 255, 200)
'  pGreenColor.RGB = RGB(0, 140, 0)
'
'  ' CREATE COLOR RAMPS
'  Dim pRamp1 As IAlgorithmicColorRamp
'  Set pRamp1 = New AlgorithmicColorRamp
'  pRamp1.Algorithm = esriLabLChAlgorithm
'  pRamp1.Size = 130
'  pRamp1.FromColor = pGreenColor
'  pRamp1.ToColor = pYellowColor
'  pRamp1.CreateRamp True
'
'  Dim pRamp2 As IAlgorithmicColorRamp
'  Set pRamp2 = New AlgorithmicColorRamp
'  pRamp2.Algorithm = esriLabLChAlgorithm
'  pRamp2.Size = 130
'  pRamp2.FromColor = pYellowColor
'  pRamp2.ToColor = pRedColor
'  pRamp2.CreateRamp True
'
'  Dim pMultiRamp As IMultiPartColorRamp
'  Set pMultiRamp = New MultiPartColorRamp
'  pMultiRamp.Ramp(0) = pRamp1
'  pMultiRamp.Ramp(1) = pRamp2
'  pMultiRamp.Size = 260
'  pMultiRamp.CreateRamp True
'
'  ' Plug this colorramp into renderer and select a band
'  pStretchRen.BandIndex = 0
'  pStretchRen.ColorRamp = pMultiRamp
'
'  ' Update the renderer with new settings and plug into layer
'  pRasRen.Update
'  Set pNewLayer.Renderer = pStretchRen
'
'  pMxDoc.AddLayer pNewLayer
  
  
  ' INSERT FOLLOWING WHERE YOU WANT PROGRESS FORM TO BE CLOSED
  ' NOTE THAT THIS FUNCTION CALLS ON MyGeneralOperations.ReturnTimeElapsed!
3849:   pPro.position = 0
3850:   psbar.HideProgressBar
3851:   If booShowProgress Then
3852:     If frmProgress.chkClose.Value = 1 Then
3853:       frmProgress.Frame.Visible = False
3854:       Set frmProgress = Nothing
3855:       Set pThisExt.ProgressMeterForm = Nothing
3856:     Else
3857:       theProgressSpecific = "Calculations Complete..."
3858:       theDetailedDescription = theDetailedDescription & _
        " --> " & theProgressSpecific & vbCrLf & _
        "          [time stamp " & Format(Now, "ttttt,  ddddd") & "]" & vbCrLf & vbCrLf & _
        TopoCorridor.MyGeneralOperations.ReturnTimeElapsed(theTimeBegan, Now)
3862:         frmProgress.txtDetails.Text = theDetailedDescription
3863:         frmProgress.txtDetails.SelStart = Len(theDetailedDescription)
3864:         frmProgress.cmdStop.Caption = "Close"
3865:     End If
3866:   End If
  
3868:   StatMatricesFromGeoDatasets = strInputParamsReport & StatMatricesFromGeoDatasets
  
3870:   pMxDoc.ActiveView.Refresh
3871:   pMxDoc.UpdateContents
'  Dim frmReportForm As TopoCorridor.frmReportDialog
'  Set frmReportForm = New TopoCorridor.frmReportDialog
'
'  ' SHOW NORMAL TEXT REPORT
'  frmReportForm.txtReport.Text = strInputParamsReport
'  frmReportForm.txtReport.Locked = False
'  frmReportForm.Caption = "Analysis Options:"
'  frmReportForm.Show vbModal
'  Set frmReportForm = Nothing
  
 
3883:   GoTo CleanUp
ErrorHandler:
  HandleError True, "StatMatricesFromGeoDatasets " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4

CleanUp:
3888:   Set pSelectedArray = Nothing
3889:   Set pSubArray = Nothing
3890:   Set pUnknown = Nothing
3891:   Set pOptions = Nothing
3892:   Set pSourceArray = Nothing
3893:   Set frmProgress = Nothing
3894:   Set psbar = Nothing
3895:   Set pPro = Nothing
3896:   Set ext = Nothing
3897:   Set pCovMatrix = Nothing
3898:   Set pMeanVector = Nothing
3899:   Set pTransposeMean = Nothing
3900:   Set pCorrMatrix = Nothing
3901:   Set pSpearman = Nothing
3902:   Set pArrayForProjections = Nothing
3903:   Set pParamsArray = Nothing
3904:   Set pPointLayer = Nothing
3905:   Set pRasterBand = Nothing
3906:   Set pTable = Nothing
3907:   Set pField = Nothing
3908:   Set pMeansParams = Nothing
3909:   Set pCovParams = Nothing
3910:   Set pInvCovParams = Nothing
3911:   Set pCorrParams = Nothing
3912:   Set pSpearmanParams = Nothing
3913:   Set pVariableNames = Nothing
3914:   Set pUnknownBandColl = Nothing
3915:   Set pUnknownBand = Nothing
3916:   Set pCommonProjectionArray = Nothing
3917:   Set pCommonSpRef = Nothing
3918:   Set pVariablesArray = Nothing
3919:   Set pDataVariableArray = Nothing
3920:   Set pPointCollection = Nothing
3921:   Set pSourceRasDataset = Nothing
3922:   Set pInvCovMatrix = Nothing
3923:   Set pMultMatrix = Nothing
3924:   Set pTableOptions = Nothing


End Function


Private Sub ExtractStatMatricesFromPointCollection( _
      pPointCollection As IPointCollection, _
      pDataArray As esriSystem.IVariantArray, _
      pMeanVector As Matrix_jen, _
      pCovMatrix As Matrix_jen, _
      booInterpFrom4Cells As Boolean, _
      lngRowCount As Long, _
      strFailureReason As String, _
      pCorrMatrix As Matrix_jen, _
      pThisExt As TopoCorridor.clsExtension, _
      pApp As IApplication, _
      strMessage As String, _
      psbar As IStatusBar, _
      pPro As IStepProgressor, _
      lngTimer As Long, _
      theProgressSpecific As String, _
      theDetailedDescription As String, _
      strTimeElapsed As String, _
      booFoundProblems As Boolean, _
      strReturn As String, _
      booShouldStop As Boolean, _
      theTimeBegan As Date, _
      Optional pSpearman As Matrix_jen)
    
  On Error GoTo ErrorHandler
  
  Dim booShowProgress As Boolean
  Dim frmProgress As TopoCorridor.frmJenProgressMeter
3958:   Set frmProgress = pThisExt.ProgressMeterForm
3959:   booShowProgress = CBool(Not frmProgress Is Nothing)
  
    ' UPDATE PROGRESS METER ==================================================================
3962:   strMessage = "Extracting Raster Values from Sample Points..."
3963:   psbar.Message(0) = strMessage
3964:   pPro.position = 0
3965:   lngTimer = lngTimer + 1

3967:   If booShowProgress Then
    ' ---- PROGRESS METER STUFF
3969:     DoEvents
'          theProgressSpecific = "Working on Step " & CStr(lngTimer) & " of " & CStr(lngValCount) & "..."
3971:     theProgressSpecific = strMessage
3972:     theDetailedDescription = theDetailedDescription & _
      " --> " & theProgressSpecific & vbCrLf & _
      "          [time stamp " & Format(Now, "ttttt,  ddddd") & "]" & vbCrLf & vbCrLf
3975:     frmProgress.ResetShortTimer
3976:     frmProgress.txtDetails.Text = theDetailedDescription
3977:     frmProgress.txtDetails.SelStart = Len(theDetailedDescription)

3979:     frmProgress.Est_Time_Left lngTimer, "Extracting Raster Values from Sample Points...", "Calculating Data...", False
    ' frmProgress.lblCurrentTime.Caption = Format(Now, "ttttt")
3981:     frmProgress.Refresh
3982:     frmProgress.icnProgressLine.Refresh
3983:     DoEvents
3984:     If BailOutOfProgress(frmProgress, pApp) Then

     ' ********************************************************************************************
      ' ALTERNATIVE CODE THAT SAVES PARTIAL TABLE, CHECKS IF ERRORS FOUND AND OUTPUTS RTF INSTEAD OF TEXT
3988:       strTimeElapsed = TopoCorridor.MyGeneralOperations.ReturnTimeElapsedRTF(theTimeBegan, Now, 7)

3990:       If booFoundProblems Then
3991:         strReturn = "-----------------------------------------\par" & vbCrLf & _
          "NOTE:  Exited Function Prematurely at Step " & CStr(lngTimer) & "\par" & vbCrLf & _
          "-----------------------------------------\par" & vbCrLf & _
          "\pard\qc " & strTimeElapsed & vbCrLf & "}"
3995:       Else
3996:         strReturn = "-----------------------------------------\par" & vbCrLf & _
          "NOTE:  Exited Function Prematurely at Step " & CStr(lngTimer) & "\par" & vbCrLf & _
          "-----------------------------------------\par" & vbCrLf & _
          "\pard\qc " & strTimeElapsed & vbCrLf & "}"
4000:       End If

     ' ********************************************************************************************

4004:       frmProgress.cmdStop.Caption = "Close"
4005:       pPro.position = 0
4006:       psbar.HideProgressBar
4007:       booShouldStop = True
4008:       GoTo CleanUp
4009:     End If
    ' ---- END PROGRESS METER STUFF --------------------------------
4011:   End If
  
4013:   Set pMeanVector = New Matrix_jen
4014:   Set pCovMatrix = New Matrix_jen
  
  Dim pSubArray As esriSystem.IVariantArray
  Dim pRasterDataset As IRasterDataset2
  Dim pRaster As IRaster
  Dim pValArray As esriSystem.IVariantArray
  Dim pVarValuesArray As esriSystem.IVariantArray
4021:   Set pValArray = New esriSystem.VarArray
  
  Dim lngIndex As Long
  Dim lngBandIndex As Long
  
  Dim lngRunningCounter As Long
4027:   lngRunningCounter = 0
  Dim lngTotalCount As Long
4029:   lngTotalCount = pDataArray.Count * pPointCollection.PointCount
  Dim dblCurrentPercent As Double
4031:   dblCurrentPercent = -10
  
  Dim pRasterProps As IRasterProps
  Dim dblCells As Double
  
4036:   For lngIndex = 0 To pDataArray.Count - 1
4037:     Set pSubArray = pDataArray.Element(lngIndex)
4038:     Set pRasterDataset = pSubArray.Element(2)
4039:     If pSubArray.Element(1) = "Polygon" Then
4040:       lngBandIndex = pSubArray.Element(6)
4041:     Else
4042:       lngBandIndex = pSubArray.Element(4)
4043:     End If
4044:     Set pRaster = pRasterDataset.CreateFullRaster
    
    ' FORCE EVALUATION
4047:     Set pRasterProps = pRaster
4048:     dblCells = pRasterProps.Width * pRasterProps.Height
 '   MsgBox pRasterProps.Width & ", " & pRasterProps.Height & vbCrLf & _
        CStr(Format(dblCells, "#,##0")) & vbCrLf & _
        "Name = " & pSubArray.Element(3)
    
4053:     If booInterpFrom4Cells Then
4054:       Set pVarValuesArray = TopoCorridor.GridFunctions.CellValues4CellInterp_Mahal(pPointCollection, pRaster, _
           pThisExt, lngRunningCounter, lngTotalCount, dblCurrentPercent, booShouldStop, strReturn, psbar, _
           pPro, theTimeBegan, lngTimer, lngBandIndex)
4057:     Else
4058:       If pPointCollection.PointCount > 1000 And dblCells < 1000000 Then       ' LOADS ENTIRE GRID IN MEMORY AT ONE TIME
4059:         Set pVarValuesArray = TopoCorridor.GridFunctions.CellValues_Mahal(pPointCollection, pRaster, _
           pThisExt, lngRunningCounter, lngTotalCount, dblCurrentPercent, booShouldStop, strReturn, psbar, _
           pPro, theTimeBegan, lngTimer, lngBandIndex)
4062:       Else                                             ' LOADS SINGLE-CELL PIXEL BLOCKS
4063:         Set pVarValuesArray = TopoCorridor.GridFunctions.CellValues2_Mahal(pPointCollection, pRaster, _
           pThisExt, lngRunningCounter, lngTotalCount, dblCurrentPercent, booShouldStop, strReturn, psbar, _
           pPro, theTimeBegan, lngTimer, lngBandIndex)
4066:       End If
4067:     End If
    
4069:     If booShouldStop Then
4070:       GoTo CleanUp
4071:     End If
    
4073:     pValArray.Add pVarValuesArray
4074:   Next lngIndex
  
  ' PUT POINT VALUES INTO A SINGLE TWO-DIMENSIONAL ARRAY
  ' SKIP ROW IF ANY NULL VALUES FOUND
  Dim pRowsArray As esriSystem.IArray
4079:   Set pRowsArray = New esriSystem.Array
  Dim pSubRow As esriSystem.IDoubleArray
  
  Dim booRowIsNull As Boolean
  Dim varValue As Variant
  Dim lngMaxVariableIndex As Long
4085:   lngMaxVariableIndex = pValArray.Count - 1
  Dim lngIndex2 As Long
  
4088:   For lngIndex = 0 To pPointCollection.PointCount - 1
4089:     booRowIsNull = False
4090:     Set pSubRow = New esriSystem.DoubleArray
    
4092:     For lngIndex2 = 0 To lngMaxVariableIndex
4093:       Set pVarValuesArray = pValArray.Element(lngIndex2)
4094:       varValue = pVarValuesArray.Element(lngIndex)
4095:       If IsNull(varValue) Then
4096:         booRowIsNull = True
4097:         Exit For
4098:       Else
4099:         pSubRow.Add CDbl(varValue)
4100:       End If
4101:     Next lngIndex2
    
4103:     If Not booRowIsNull Then
4104:       pRowsArray.Add pSubRow
4105:     End If
4106:   Next lngIndex
  
  
  
  
    ' UPDATE PROGRESS METER ==================================================================
4112:   strMessage = "Calculating Statistical Matrices..."
4113:   psbar.Message(0) = strMessage
4114:   pPro.position = 0
4115:   lngTimer = lngTimer + 1

4117:   If booShowProgress Then
    ' ---- PROGRESS METER STUFF
4119:     DoEvents
'          theProgressSpecific = "Working on Step " & CStr(lngTimer) & " of " & CStr(lngValCount) & "..."
4121:     theProgressSpecific = strMessage
4122:     theDetailedDescription = theDetailedDescription & _
      " --> " & theProgressSpecific & vbCrLf & _
      "          [time stamp " & Format(Now, "ttttt,  ddddd") & "]" & vbCrLf & vbCrLf
4125:     frmProgress.ResetShortTimer
4126:     frmProgress.txtDetails.Text = theDetailedDescription
4127:     frmProgress.txtDetails.SelStart = Len(theDetailedDescription)

4129:     frmProgress.Est_Time_Left lngTimer, "Calculating Statistical Matrices...", "Calculating Data...", False
    ' frmProgress.lblCurrentTime.Caption = Format(Now, "ttttt")
4131:     frmProgress.Refresh
4132:     frmProgress.icnProgressLine.Refresh
4133:     DoEvents
4134:     If BailOutOfProgress(frmProgress, pApp) Then

     ' ********************************************************************************************
      ' ALTERNATIVE CODE THAT SAVES PARTIAL TABLE, CHECKS IF ERRORS FOUND AND OUTPUTS RTF INSTEAD OF TEXT
4138:       strTimeElapsed = TopoCorridor.MyGeneralOperations.ReturnTimeElapsedRTF(theTimeBegan, Now, 7)

4140:       If booFoundProblems Then
4141:         strReturn = "-----------------------------------------\par" & vbCrLf & _
          "NOTE:  Exited Function Prematurely at Step " & CStr(lngTimer) & "\par" & vbCrLf & _
          "-----------------------------------------\par" & vbCrLf & _
          "\pard\qc " & strTimeElapsed & vbCrLf & "}"
4145:       Else
4146:         strReturn = "-----------------------------------------\par" & vbCrLf & _
          "NOTE:  Exited Function Prematurely at Step " & CStr(lngTimer) & "\par" & vbCrLf & _
          "-----------------------------------------\par" & vbCrLf & _
          "\pard\qc " & strTimeElapsed & vbCrLf & "}"
4150:       End If

     ' ********************************************************************************************

4154:       frmProgress.cmdStop.Caption = "Close"
4155:       pPro.position = 0
4156:       psbar.HideProgressBar
4157:       booShouldStop = True
4158:       GoTo CleanUp
4159:     End If
    ' ---- END PROGRESS METER STUFF --------------------------------
4161:   End If
  
4163:   lngRowCount = pRowsArray.Count
  
  Dim dblArray() As Double
  Dim pValsMatrix As Matrix_jen
  
4168:   If lngRowCount > 0 Then
    ReDim dblArray(lngRowCount - 1, lngMaxVariableIndex)
4170:     For lngIndex = 0 To pRowsArray.Count - 1
4171:       Set pSubRow = pRowsArray.Element(lngIndex)
4172:       For lngIndex2 = 0 To lngMaxVariableIndex
4173:         dblArray(lngIndex, lngIndex2) = pSubRow.Element(lngIndex2)
4174:       Next lngIndex2
4175:     Next lngIndex
  
4177:     Set pValsMatrix = New Matrix_jen
4178:     pValsMatrix.MatrixArray = dblArray
4179:     pValsMatrix.ReturnStatMatrices strFailureReason, , pMeanVector, pCovMatrix, pCorrMatrix
4180:     If Not pSpearman Is Nothing Then
4181:       pValsMatrix.ReturnSpearmansRho pSpearman
4182:     End If
    
4184:   End If
  
4186:   GoTo CleanUp
ErrorHandler:
  HandleError False, "ExtractStatMatricesFromPointCollection " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4

CleanUp:

4192:   Set frmProgress = Nothing
4193:   Set pSubArray = Nothing
4194:   Set pRasterDataset = Nothing
4195:   Set pRaster = Nothing
4196:   Set pValArray = Nothing
4197:   Set pVarValuesArray = Nothing
4198:   Set pRasterProps = Nothing
4199:   Set pRowsArray = Nothing
4200:   Set pSubRow = Nothing
4201:   Set pValsMatrix = Nothing


End Sub

Private Sub ExtractStatMatricesFromRaster( _
      pRasterDataset As IRasterDataset, _
      pDataArray As esriSystem.IVariantArray, _
      pMeanVector As Matrix_jen, _
      pCovMatrix As Matrix_jen, _
      pSpRef As ISpatialReference, _
      pCorrMatrix As Matrix_jen, _
      pThisExt As TopoCorridor.clsExtension, _
      pApp As IApplication, _
      strMessage As String, _
      psbar As IStatusBar, _
      pPro As IStepProgressor, _
      lngTimer As Long, _
      theProgressSpecific As String, _
      theDetailedDescription As String, _
      strTimeElapsed As String, _
      booFoundProblems As Boolean, _
      strReturn As String, _
      booShouldStop As Boolean, _
      theTimeBegan As Date, _
      Optional pSpearman As Matrix_jen)
      
  On Error GoTo ErrorHandler
  
  Dim booShowProgress As Boolean
  Dim frmProgress As TopoCorridor.frmJenProgressMeter
4232:   Set frmProgress = pThisExt.ProgressMeterForm
4233:   booShowProgress = CBool(Not frmProgress Is Nothing)
  
    ' UPDATE PROGRESS METER ==================================================================
4236:   strMessage = "Converting Raster Region to Sample Points..."
4237:   psbar.Message(0) = strMessage
4238:   pPro.position = 0
4239:   lngTimer = lngTimer + 1

4241:   If booShowProgress Then
    ' ---- PROGRESS METER STUFF
4243:     DoEvents
'          theProgressSpecific = "Working on Step " & CStr(lngTimer) & " of " & CStr(lngValCount) & "..."
4245:     theProgressSpecific = strMessage
4246:     theDetailedDescription = theDetailedDescription & _
      " --> " & theProgressSpecific & vbCrLf & _
      "          [time stamp " & Format(Now, "ttttt,  ddddd") & "]" & vbCrLf & vbCrLf
4249:     frmProgress.ResetShortTimer
4250:     frmProgress.txtDetails.Text = theDetailedDescription
4251:     frmProgress.txtDetails.SelStart = Len(theDetailedDescription)

4253:     frmProgress.Est_Time_Left lngTimer, "Converting Raster Region to Sample Points...", "Calculating Data...", False
    ' frmProgress.lblCurrentTime.Caption = Format(Now, "ttttt")
4255:     frmProgress.Refresh
4256:     frmProgress.icnProgressLine.Refresh
4257:     DoEvents
4258:     If BailOutOfProgress(frmProgress, pApp) Then

     ' ********************************************************************************************
      ' ALTERNATIVE CODE THAT SAVES PARTIAL TABLE, CHECKS IF ERRORS FOUND AND OUTPUTS RTF INSTEAD OF TEXT
4262:       strTimeElapsed = TopoCorridor.MyGeneralOperations.ReturnTimeElapsedRTF(theTimeBegan, Now, 7)

4264:       If booFoundProblems Then
4265:         strReturn = "-----------------------------------------\par" & vbCrLf & _
          "NOTE:  Exited Function Prematurely at Step " & CStr(lngTimer) & "\par" & vbCrLf & _
          "-----------------------------------------\par" & vbCrLf & _
          "\pard\qc " & strTimeElapsed & vbCrLf & "}"
4269:       Else
4270:         strReturn = "-----------------------------------------\par" & vbCrLf & _
          "NOTE:  Exited Function Prematurely at Step " & CStr(lngTimer) & "\par" & vbCrLf & _
          "-----------------------------------------\par" & vbCrLf & _
          "\pard\qc " & strTimeElapsed & vbCrLf & "}"
4274:       End If

     ' ********************************************************************************************

4278:       frmProgress.cmdStop.Caption = "Close"
4279:       pPro.position = 0
4280:       psbar.HideProgressBar
4281:       booShouldStop = True
4282:       GoTo CleanUp
4283:     End If
    ' ---- END PROGRESS METER STUFF --------------------------------
4285:   End If
  
  
  
  
  
  
  
  
  
  
    
'  For lngIndex = 0 To pPointCollection.PointCount - 1
'    booRowIsNull = False
'    Set pSubRow = New esriSystem.DoubleArray
'
'    For lngIndex2 = 0 To lngMaxVariableIndex
'      Set pVarValuesArray = pValArray.Element(lngIndex2)
'      varValue = pVarValuesArray.Element(lngIndex)
'      If IsNull(varValue) Then
'        booRowIsNull = True
'        Exit For
'      Else
'        pSubRow.Add CDbl(varValue)
'      End If
'    Next lngIndex2
'
'    If Not booRowIsNull Then
'      pRowsArray.Add pSubRow
'    End If
'  Next lngIndex
'
'  lngRowCount = pRowsArray.Count
'
'  If lngRowCount > 0 Then
'    Dim dblArray() As Double
'    ReDim dblArray(lngRowCount - 1, lngMaxVariableIndex)
'    For lngIndex = 0 To pRowsArray.Count - 1
'      Set pSubRow = pRowsArray.Element(lngIndex)
'      For lngIndex2 = 0 To lngMaxVariableIndex
'        dblArray(lngIndex, lngIndex2) = pSubRow.Element(lngIndex2)
'      Next lngIndex2
'    Next lngIndex
'
'    Dim pValsMatrix As Matrix_jen
'    Set pValsMatrix = New Matrix_jen
'    pValsMatrix.MatrixArray = dblArray
'    pValsMatrix.ReturnStatMatrices strFailureReason, , pMeanVector, pCovMatrix, pCorrMatrix
'    If Not pSpearman Is Nothing Then
'      pValsMatrix.ReturnSpearmansRho pSpearman
'    End If
'
'  End If
'
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  Dim pPointCollection As IPointCollection
4373:   Set pPointCollection = New Multipoint
  
  ' MAKE IN-MEMORY VERSION OF POINT FEATURE CLASS FOR ALL GRID CELLS
    
  Dim pInMemWsFact As IWorkspaceFactory
4378:   Set pInMemWsFact = New InMemoryWorkspaceFactory
  Dim pFeatWS As IFeatureWorkspace
  Dim pName As IName
4381:   Set pName = pInMemWsFact.Create("", "InMemory", Nothing, 0)
4382:   Set pFeatWS = pName.Open
    
  Dim pNewFClass As IGeoDataset
  
  Dim pConvOp As IConversionOp
4387:   Set pConvOp = New RasterConversionOp
4388:   Set pNewFClass = pConvOp.RasterDataToPointFeatureData(pRasterDataset, pFeatWS, "Source")
    
  Dim pFClass As IFeatureClass
4391:   Set pFClass = pNewFClass

  Dim pFeatureCursor As IFeatureCursor
4394:   Set pFeatureCursor = pFClass.Search(Nothing, True)
  Dim pFeature As IFeature
4396:   Set pFeature = pFeatureCursor.NextFeature
  Dim lngCounter As Long
4398:   Do Until pFeature Is Nothing
4399:     pPointCollection.AddPoint pFeature.ShapeCopy
4400:     Set pFeature = pFeatureCursor.NextFeature
4401:     lngCounter = lngCounter + 1
'    If lngCounter Mod 1000 = 0 Then Debug.Print CStr(lngCounter); "..."
    
4404:   Loop
 
  Dim strFailureReason As String
4407:   Call Mahal_Functions.ExtractStatMatricesFromPointCollection(pPointCollection, pDataArray, pMeanVector, _
            pCovMatrix, False, pFClass.FeatureCount(Nothing), strFailureReason, pCorrMatrix, pThisExt, pApp, strMessage, _
            psbar, pPro, lngTimer, theProgressSpecific, theDetailedDescription, strTimeElapsed, booFoundProblems, _
            strReturn, booShouldStop, theTimeBegan, pSpearman)
  
4412:   GoTo CleanUp
ErrorHandler:
  HandleError False, "ExtractStatMatricesFromRaster " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4

CleanUp:

4418:   Set frmProgress = Nothing
4419:   Set pPointCollection = Nothing
4420:   Set pInMemWsFact = Nothing
4421:   Set pFeatWS = Nothing
4422:   Set pName = Nothing
4423:   Set pNewFClass = Nothing
4424:   Set pConvOp = Nothing
4425:   Set pFClass = Nothing
4426:   Set pFeatureCursor = Nothing
4427:   Set pFeature = Nothing


End Sub


Private Function UnifyProjections(pDataArray As esriSystem.IArray, pApp As IApplication, _
      pThisExt As TopoCorridor.clsExtension, strMessage As String, psbar As IStatusBar, _
      pPro As IStepProgressor, lngTimer As Long, _
      theProgressSpecific As String, theDetailedDescription As String, strTimeElapsed As String, _
      booFoundProblems As Boolean, strReturn As String, booShouldStop As Boolean, _
      theTimeBegan As Date) As esriSystem.IArray
      
  On Error GoTo ErrorHandler
  
  ' FOR PROGRESS METER
4443:   booShouldStop = False
  Dim booShowProgress As Boolean
  Dim frmProgress As TopoCorridor.frmJenProgressMeter
4446:   Set frmProgress = pThisExt.ProgressMeterForm
4447:   booShowProgress = CBool(Not frmProgress Is Nothing)
  ' ---------------------------------------------------
  
  
  Dim pSourceData As esriSystem.IVariantArray
4452:   Set pSourceData = pDataArray.Element(0)           ' TWO ITEMS IN ARRAY; FIRST ITEM IS ARRAY CONTAINING SOURCE DATA
  
  Dim pMahalData As esriSystem.IVariantArray
4455:   Set pMahalData = pDataArray.Element(1)            ' TWO ITEMS IN ARRAY; SECOND ITEM IS ARRAY CONTAINING MAHALANOBIS VARIABLE DATA
  
  Dim pDatasetArray As esriSystem.IVariantArray
4458:   Set pDatasetArray = pMahalData.Element(0)
  
  Dim pGeoDataset As IGeoDataset
4461:   Set pGeoDataset = pDatasetArray.Element(2)        ' SEE LIST BELOW FOR ORDER OF ITEMS IN RASTER PARAMETER ARRAYS
  
  Dim pCommonSpRef As ISpatialReference
4464:   Set pCommonSpRef = pGeoDataset.SpatialReference
  
  Dim pReturnArray As esriSystem.IArray
4467:   Set pReturnArray = New esriSystem.Array
  
  Dim pTransformOp As ITransformationOp
  Dim pFLayer As IFeatureLayer
  Dim pFClass As IFeatureClass
  Dim pFeature As IFeature
  Dim pPoint As IPoint
  Dim pPointColl As IPointCollection
  Dim pGeometry As IMultipoint
  Dim pRasterBand As IRasterBand
  Dim strRasterName As String
  Dim lngFieldIndex As Long
  Dim pTable As ITable
  Dim varValue As Variant
  Dim booIsString As Boolean
  Dim strFieldName As String
  Dim pField As IField
  
  Dim lngTotalDatasets As Long
4486:   lngTotalDatasets = pMahalData.Count + 1
  
    ' UPDATE PROGRESS METER ==================================================================
4489:   strMessage = "Setting Source Data Projection..."
4490:   psbar.Message(0) = strMessage
4491:   pPro.position = 0
4492:   lngTimer = lngTimer + 1

4494:   If booShowProgress Then
    ' ---- PROGRESS METER STUFF
4496:     DoEvents
'          theProgressSpecific = "Working on Step " & CStr(lngTimer) & " of " & CStr(lngValCount) & "..."
4498:     theProgressSpecific = strMessage
4499:     theDetailedDescription = theDetailedDescription & _
      " --> " & theProgressSpecific & vbCrLf & _
      "          [time stamp " & Format(Now, "ttttt,  ddddd") & "]" & vbCrLf & vbCrLf
4502:     frmProgress.ResetShortTimer
4503:     frmProgress.txtDetails.Text = theDetailedDescription
4504:     frmProgress.txtDetails.SelStart = Len(theDetailedDescription)

4506:     frmProgress.Est_Time_Left lngTimer, "Setting Source Data Projection...", "Calculating Data...", False
    ' frmProgress.lblCurrentTime.Caption = Format(Now, "ttttt")
4508:     frmProgress.Refresh
4509:     frmProgress.icnProgressLine.Refresh
        
4511:     frmProgress.Est_Time_Left_Short 1, "Forcing Uniform Projection, Source Data...", lngTotalDatasets
4512:     frmProgress.Refresh
4513:     frmProgress.icnProgressLine.Refresh
4514:     frmProgress.icnProgressLineShort.Refresh
    
4516:     DoEvents
4517:     If BailOutOfProgress(frmProgress, pApp) Then

     ' ********************************************************************************************
      ' ALTERNATIVE CODE THAT SAVES PARTIAL TABLE, CHECKS IF ERRORS FOUND AND OUTPUTS RTF INSTEAD OF TEXT
4521:       strTimeElapsed = TopoCorridor.MyGeneralOperations.ReturnTimeElapsedRTF(theTimeBegan, Now, 7)

4523:       If booFoundProblems Then
4524:         strReturn = "-----------------------------------------\par" & vbCrLf & _
          "NOTE:  Exited Function Prematurely at Step " & CStr(lngTimer) & "\par" & vbCrLf & _
          "-----------------------------------------\par" & vbCrLf & _
          "\pard\qc " & strTimeElapsed & vbCrLf & "}"
4528:       Else
4529:         strReturn = "-----------------------------------------\par" & vbCrLf & _
          "NOTE:  Exited Function Prematurely at Step " & CStr(lngTimer) & "\par" & vbCrLf & _
          "-----------------------------------------\par" & vbCrLf & _
          "\pard\qc " & strTimeElapsed & vbCrLf & "}"
4533:       End If

     ' ********************************************************************************************

4537:       frmProgress.cmdStop.Caption = "Close"
4538:       pPro.position = 0
4539:       psbar.HideProgressBar
4540:       booShouldStop = True
4541:       GoTo CleanUp
4542:     End If
    ' ---- END PROGRESS METER STUFF --------------------------------
4544:   End If
  
  
'  MsgBox "Checkpoint 1"
    
  
  Dim strSourceType As String
  Dim booUseAll As Boolean
  Dim pCursor As IFeatureCursor
  Dim pSelection As IFeatureSelection
  Dim pSelSet As ISelectionSet
  
  Dim pParamsArray As esriSystem.IVariantArray
  Dim pDataSpRef As ISpatialReference
  Dim pBandGeoDataset As IGeoDataset
  Dim pQueryFilter As IQueryFilter
  Dim pDataset As IDataset
  Dim pWS As IWorkspace
  Dim pWsFact As IWorkspaceFactory
  Dim lngBracketType As JenFieldBracketTypes
  Dim strStartBracket As String
  Dim strEndBracket As String
  
  Dim pRaster As IRaster
  Dim pRasterBandCol As IRasterBandCollection
  Dim pExtractionOp As IExtractionOp
  Dim pAnEnv As IRasterAnalysisEnvironment
  Dim pRasterDesc As IRasterDescriptor
  Dim pExtractDataset As IGeoDataset
  Dim pConOp As IConditionalOp
  Dim pMakerOp As IRasterMakerOp
  Dim pRasterAnEnv As IRasterAnalysisEnvironment
  Dim pOneDataset As IGeoDataset
4577:   Set pRasterBandCol = New Raster
  Dim pAOIRaster As IGeoDataset
  Dim pFinalRaster As IGeoDataset
  Dim pFinalDataset As IGeoDataset
  Dim pFinalRasterColl As IRasterBandCollection
  Dim pExtractBand As IRasterBand
      
4584:   If pSourceData Is Nothing Then           ' MIGHT BE NOTHING IF USING PRE-EXISTING STATISTICAL MATRICES
4585:     pReturnArray.Add Nothing
4586:   Else
4587:     strSourceType = pSourceData.Element(1)
    'MsgBox strSourceType
4589:     If strSourceType = "Vector" Then
    
'      0) pPointLayer
'      1) optUseAll.Value              ' TRUE IF USING ALL POINTS, FALSE IF ONLY USING SELECTED POINTS
'      2) m_lngPointCount              ' TOTAL POINT COUNT FOR THIS LAYER
'      3) m_lngSelPointCount           ' SELECTED POINT COUNT FOR THIS LAYER
    
      ' THEN RETURN A POINT COLLECTION
      '  -- IN CORRECT PROJECTION
      '  -- ONLY CONTAINING SELECTED POINTS, IF USER CHOSE THAT OPTION
      
4600:       Set pFLayer = pSourceData.Element(0)
4601:       Set pFClass = pFLayer.FeatureClass
      
4603:       booUseAll = pSourceData.Element(2)
      
4605:       If booUseAll Then
4606:         Set pCursor = pFClass.Search(Nothing, True)
4607:       Else
4608:         Set pSelection = pFLayer
4609:         Set pSelSet = pSelection.SelectionSet
4610:         pSelSet.Search Nothing, True, pCursor
4611:       End If
      
4613:       Set pPointColl = New Multipoint
4614:       Set pGeometry = pPointColl
4615:       Set pGeometry.SpatialReference = pCommonSpRef
      
4617:       Set pFeature = pCursor.NextFeature
4618:       Do Until pFeature Is Nothing
4619:         Set pPoint = pFeature.ShapeCopy
        ' MAKE SURE THIS IS NOT AN EMPTY POINT
4621:         If Not pPoint.IsEmpty Then
          ' PROJECT POINT IF NECESSARY
4623:           If Not TopoCorridor.MyGeneralOperations.CompareSpatialReferences(pPoint.SpatialReference, pCommonSpRef) Then
4624:             pPoint.Project pCommonSpRef
4625:           End If
4626:           pPointColl.AddPoint pPoint
4627:         End If
4628:         Set pFeature = pCursor.NextFeature
4629:       Loop
      
4631:       pReturnArray.Add pPointColl
      
4633:     ElseIf strSourceType = "Raster" Then
      
      
4636:       Set pParamsArray = pSourceData.Element(0)
      
4638:       Set pRasterBand = pParamsArray.Element(0)
4639:       strRasterName = pParamsArray.Element(1)
'      Set pTable = pRasterBand.AttributeTable
4641:       Set pTable = TopoCorridor.TopoCor_Functions.ReturnRasterTable(pRasterBand)
4642:       lngFieldIndex = pParamsArray.Element(2)
4643:       Set pField = pTable.Fields.Field(lngFieldIndex)
4644:       strFieldName = pField.Name
      
4646:       booIsString = pParamsArray.Element(3)
4647:       varValue = pParamsArray.Element(4)
4648:       Set pBandGeoDataset = pRasterBand
4649:       Set pDataSpRef = pBandGeoDataset.SpatialReference
      
'      MsgBox pDataSpRef.Name
      
      ' FIRST EXTRACT ONLY THE PARTS OF THE BAND THAT MATCH THE USER'S SPECIFIED VALUE
      ' REMEMBER THAT USER'S SPECIFIED VALUE COULD BE EITHER TEXT OR NUMERIC, AND MIGHT
      ' CORRESPOND TO SEVERAL ROWS OF DATA
4656:       Set pQueryFilter = New QueryFilter
4657:       Set pDataset = pRasterBand
4658:       Set pWS = pDataset.Workspace
      
4660:       Set pWsFact = pWS.WorkspaceFactory
      
4662:       lngBracketType = TopoCorridor.MyGeneralOperations.GetFieldNameBracket(pDataset)
      Select Case lngBracketType
        Case ENUM_EncloseInBrackets
4665:           strStartBracket = "["
4666:           strEndBracket = "]"
        Case ENUM_EncloseInQuotationMarks
4668:           strStartBracket = """"
4669:           strEndBracket = """"
        Case ENUM_DoNotEnclose
4671:           strStartBracket = ""
4672:           strEndBracket = ""
4673:       End Select
      
4675:       If booIsString Then
4676:         pQueryFilter.WhereClause = strStartBracket & pField.Name & strEndBracket & " = '" & CStr(varValue) & "'"
4677:       Else
4678:         pQueryFilter.WhereClause = strStartBracket & pField.Name & strEndBracket & " = " & CStr(varValue)
4679:       End If
      
 '     MsgBox "WhereClause = " & pQueryFilter.WhereClause
      
      
4684:       pRasterBandCol.Add pRasterBand, 0
4685:       Set pRaster = pRasterBandCol
      
 '     MsgBox "Band Name = " & pRasterBand.Bandname
'      MsgBox "About to make raster descriptor..."
      
      ' MAKE A RASTER DESCRIPTOR OBJECT TO IDENTIFY THE PARTS OF THE RASTER TO EXTRACT
4691:       Set pExtractionOp = New RasterExtractionOp
      
4693:       Set pAnEnv = pExtractionOp
4694:       pAnEnv.SetCellSize esriRasterEnvValue, pRaster
4695:       pAnEnv.SetExtent esriRasterEnvValue, pRaster, pRaster
4696:       Set pRasterDesc = New RasterDescriptor
4697:       pRasterDesc.Create pRaster, pQueryFilter, pField.Name
      
'      MsgBox "About to extract..." & vbCrLf & _
        "Query Filter = " & pQueryFilter.WhereClause & vbCrLf & _
        "Field Name = " & pField.Name & vbCrLf & _
        "Raster Descriptor is Nothing" & CStr(pRasterDesc Is Nothing)
      
      ' EXTRACT THOSE PARTS OF THE RASTER THAT MEET USER'S SELECTION CRITERIA
4705:       Set pExtractDataset = pExtractionOp.Attribute(pRasterDesc)
      
'      MsgBox "Extraction complete..."
      
      ' CONVERT THOSE PARTS OF THE RASTER TO "1" VALUES SO THEY SERVE AS A MASK
4710:       Set pConOp = New RasterConditionalOp
      
4712:       Set pMakerOp = New RasterMakerOp
      
4714:       Set pRasterAnEnv = pMakerOp
4715:       pRasterAnEnv.SetCellSize esriRasterEnvValue, pExtractDataset
4716:       pRasterAnEnv.SetExtent esriRasterEnvValue, pExtractDataset, pExtractDataset
      
4718:       Set pOneDataset = pMakerOp.MakeConstant(1, True)
      
'      MsgBox "Make Constant Complete..."
      
4722:       Set pAOIRaster = pConOp.Con(pExtractDataset, pOneDataset, pExtractDataset)
      
 '     MsgBox "Conditional Op Complete..."
      
      ' PROJECT IF NECESSARY
4727:       If TopoCorridor.MyGeneralOperations.CompareSpatialReferences(pDataSpRef, pCommonSpRef) Then
4728:         Set pFinalRaster = pAOIRaster
4729:       Else
        ' PROJECT RASTER INTO NEW PROJECTION
4731:         Set pTransformOp = New RasterTransformationOp
4732:         Set pFinalRaster = pTransformOp.ProjectFast(pAOIRaster, pCommonSpRef, esriGeoAnalysisResampleNearest)
      
4734:       End If
      
      ' CONVERT TO RASTER DATASET IF NECESSARY; HAVING TROUBLE DETERMINING WHETHER OPERATIONS PRODUCE
      ' "Rasters" or "RasterDatasets".
      'MsgBox "Before:  TypeOf pFinalRaster is IRaster = " & CStr(TypeOf pFinalRaster Is IRaster) & vbCrLf & _
             "         TypeOf pFinalRaster is IRasterDataset = " & CStr(TypeOf pFinalRaster Is IRasterDataset)
             
      
'      MsgBox "Checkpoint 3"
      
4744:       If TypeOf pFinalRaster Is IRaster Then
      
4746:         Set pFinalRasterColl = pFinalRaster
4747:         Set pExtractBand = pFinalRasterColl.Item(0)
4748:         Set pFinalDataset = pExtractBand.RasterDataset
      
4750:       Else
4751:         Set pFinalDataset = pFinalRaster
4752:       End If
      
      'MsgBox "After:  TypeOf pFinalDataset is IRaster = " & CStr(TypeOf pFinalDataset Is IRaster) & vbCrLf & _
             "         TypeOf pFinalDataset is IRasterDataset = " & CStr(TypeOf pFinalDataset Is IRasterDataset)
             
4757:       pReturnArray.Add pFinalDataset
4758:     End If
4759:   End If
'  goto cleanup
  
'  MsgBox "Checkpoint 4"
  
  
  ' NOW HAVE THE SOURCE DATASET HANDLED.
  '  -- IF THE SOURCE WAS PRE-EXISTING TABLES, THEN pReturnArray HAS A NOTHING PLACEHOLDER
  '  -- IF THE SOURCE WAS A POINT LAYER, THEN pReturnArray HAS A POINT COLLECTION OF ALL SELECTED POINTS IN THE CORRECT PROJECTION.
  '  -- IF THE SOURCE WAS RASTER BAND, THEN pReturnArray HAS A PROJECTED RASTER OBJECT WITH 1'S AND NO-DATA VALUES
  
  ' MOVING ON TO INPUT MAHALANOBIS VARIABLES, BASED ON frmGridLayers OPTIONS
  
    ' UPDATE PROGRESS METER ==================================================================
4773:   strMessage = "Setting Input Data Projection..."
4774:   psbar.Message(0) = strMessage
4775:   pPro.position = 0
4776:   lngTimer = lngTimer + 1

4778:   If booShowProgress Then
    ' ---- PROGRESS METER STUFF
4780:     DoEvents
'          theProgressSpecific = "Working on Step " & CStr(lngTimer) & " of " & CStr(lngValCount) & "..."
4782:     theProgressSpecific = strMessage
4783:     theDetailedDescription = theDetailedDescription & _
      " --> " & theProgressSpecific & vbCrLf & _
      "          [time stamp " & Format(Now, "ttttt,  ddddd") & "]" & vbCrLf & vbCrLf
4786:     frmProgress.txtDetails.Text = theDetailedDescription
4787:     frmProgress.txtDetails.SelStart = Len(theDetailedDescription)

4789:     frmProgress.Est_Time_Left lngTimer, "Setting Input Data Projection...", "Calculating Data...", False
    ' frmProgress.lblCurrentTime.Caption = Format(Now, "ttttt")
4791:     frmProgress.Refresh
4792:     frmProgress.icnProgressLine.Refresh
4793:     DoEvents
4794:     If BailOutOfProgress(frmProgress, pApp) Then

     ' ********************************************************************************************
      ' ALTERNATIVE CODE THAT SAVES PARTIAL TABLE, CHECKS IF ERRORS FOUND AND OUTPUTS RTF INSTEAD OF TEXT
4798:       strTimeElapsed = TopoCorridor.MyGeneralOperations.ReturnTimeElapsedRTF(theTimeBegan, Now, 7)

4800:       If booFoundProblems Then
4801:         strReturn = "-----------------------------------------\par" & vbCrLf & _
          "NOTE:  Exited Function Prematurely at Step " & CStr(lngTimer) & "\par" & vbCrLf & _
          "-----------------------------------------\par" & vbCrLf & _
          "\pard\qc " & strTimeElapsed & vbCrLf & "}"
4805:       Else
4806:         strReturn = "-----------------------------------------\par" & vbCrLf & _
          "NOTE:  Exited Function Prematurely at Step " & CStr(lngTimer) & "\par" & vbCrLf & _
          "-----------------------------------------\par" & vbCrLf & _
          "\pard\qc " & strTimeElapsed & vbCrLf & "}"
4810:       End If

     ' ********************************************************************************************

4814:       frmProgress.cmdStop.Caption = "Close"
4815:       pPro.position = 0
4816:       psbar.HideProgressBar
4817:       booShouldStop = True
4818:       GoTo CleanUp
4819:     End If
    ' ---- END PROGRESS METER STUFF --------------------------------
4821:   End If
  
  ' NOTE:  EACH OF THESE SELECTED ITEMS IS AN esriSystem.IVariantArray CONTAINING THE FOLLOWING ITEMS:
  ' 1) IF A RASTER LAYER (i.e. if theArray.Element(1) = "Raster"):
  '    0) Index value of original Raster list item; not useful any more
  '    1) String "Raster", indicating the data type of this item
  '    2) Actual Raster object, original saved as IRasterBandCollection but available as an IRaster
  '    3) Name of Raster Object, as it appeared in original list
  '    4) Band Index; added by this function
  ' 2) IF A POLYGON LAYER (i.e. if theArray.Element(1) = "Polygon"):
  '    0) Index value of original Polygon list item; not useful any more
  '    1) String "Polygon", indicating the data type of this item
  '    2) Actual Polygon Layer
  '    3) Polygon Layer Name
  '    4) Field Index value for selected attribute field
  '    5) Actual selected attribute field
  
  Dim lngIndex As Long
  Dim strType As String
  Dim pFeatureLayer As IFeatureLayer
  Dim pRasterBandColl As IRasterBandCollection
  Dim pRasterDataset As IRasterDataset
  Dim pSpRef As ISpatialReference
  
  ' PREPARE ANALYSIS ENVIRONMENT IF CONVERTING POLYGONS
  Dim dblCellSize As Double
  Dim lngAnalysisEnum As esriRasterEnvSettingEnum
4848:   lngAnalysisEnum = esriRasterEnvValue
  ' IF FIRST DATASET IS A RASTER, THEN SET CELL SIZE ACCORDING TO THIS DATASET.  OTHERWISE USE
  ' CURRENT DOCUMENT SETTINGS
4851:   Set pDatasetArray = pMahalData.Element(0)
4852:   strType = pDatasetArray.Element(1)
  Dim pProps As IRasterProps
  Dim pTestSet As IRasterAnalysisEnvironment
  
4856:   If strType = "Raster" Then
4857:     Set pProps = pDatasetArray.Element(2)
4858:     dblCellSize = (pProps.MeanCellSize.X + pProps.MeanCellSize.Y) / 2
4859:   Else
4860:     Set pTestSet = New RasterSettings
4861:     pTestSet.GetCellSize lngAnalysisEnum, dblCellSize
4862:     lngAnalysisEnum = esriRasterEnvValue
4863:   End If
  
  ' RETURNED OBJECTS WILL ALL BE IRasterDatasets IN THE CORRECT PROJECTION
  ' ENTIRE ORIGINAL SUB-ARRAYS WILL BE RETURNED, WITH IRasterDatasets SUBSTITUED FOR ORIGINAL DATASETS
  ' FIRST ITEM (CURRENTLY AN INDEX VALUE, NO LONGER NECESSARY) WILL BE REPLACED WITH BOOLEAN INDICATING
  ' WHETHER DATASET SHOULD BE DELETED
  Dim pReturnRasterDataset As IRasterDataset
  Dim booShouldDelete As Boolean
  
  Dim pNewBandColl As IRasterBandCollection
  Dim lngBandIndex As Long
  
  Dim pClone As IClone
  Dim pNewField As IField
  Dim strShapeFieldName As String
  Dim pShapeField As IField
  Dim pShapeEdit As IFieldEdit
  Dim pGeomDef As IGeometryDef
  Dim pGeomDefEdit As IGeometryDefEdit
        
  Dim pInMemWsFact As IWorkspaceFactory
  Dim pFeatWS As IFeatureWorkspace
  Dim pName As IName
  Dim pNewFClass As IFeatureClass
  Dim pNewFields As IFields
  Dim pNewFieldsEdit As IFieldsEdit
  Dim lngOrigFieldIndex As Long
  Dim lngNewFieldIndex As Long
  Dim pOrigCursor As IFeatureCursor
  Dim pOrigFeature As IFeature
  Dim pNewBuffer As IFeatureBuffer
  Dim pNewCursor As IFeatureCursor
  Dim pPolygon As IPolygon
  Dim pConversionOp As IConversionOp
  Dim pFeatClassDesc As IFeatureClassDescriptor
  Dim pConEnv As IRasterAnalysisEnvironment
  Dim pRasWsFact As IWorkspaceFactory
  Dim pRasWS As IRasterWorkspace
  Dim strSuggestDir As String
  Dim strSuggestName As String
        
4904:   For lngIndex = 0 To pMahalData.Count - 1
    
4906:     If booShowProgress Then
4907:       frmProgress.Est_Time_Left_Short lngIndex + 2, "Forcing Uniform Projection, Input Data " & _
          CStr(lngIndex + 1) & " of " & CStr(pMahalData.Count) & "...", lngTotalDatasets
4909:       frmProgress.Refresh
4910:       frmProgress.icnProgressLine.Refresh
4911:       frmProgress.icnProgressLineShort.Refresh
4912:       If BailOutOfProgress(frmProgress, pApp) Then
  
       ' ********************************************************************************************
        ' ALTERNATIVE CODE THAT SAVES PARTIAL TABLE, CHECKS IF ERRORS FOUND AND OUTPUTS RTF INSTEAD OF TEXT
4916:         strTimeElapsed = TopoCorridor.MyGeneralOperations.ReturnTimeElapsedRTF(theTimeBegan, Now, 7)
  
4918:         If booFoundProblems Then
4919:           strReturn = "-----------------------------------------\par" & vbCrLf & _
            "NOTE:  Exited Function Prematurely at Step " & CStr(lngTimer) & "\par" & vbCrLf & _
            "-----------------------------------------\par" & vbCrLf & _
            "\pard\qc " & strTimeElapsed & vbCrLf & "}"
4923:         Else
4924:           strReturn = "-----------------------------------------\par" & vbCrLf & _
            "NOTE:  Exited Function Prematurely at Step " & CStr(lngTimer) & "\par" & vbCrLf & _
            "-----------------------------------------\par" & vbCrLf & _
            "\pard\qc " & strTimeElapsed & vbCrLf & "}"
4928:         End If
  
       ' ********************************************************************************************
  
4932:         frmProgress.cmdStop.Caption = "Close"
4933:         pPro.position = 0
4934:         psbar.HideProgressBar
4935:         booShouldStop = True
4936:         GoTo CleanUp
4937:       End If
4938:     End If
    
4940:     Set pDatasetArray = pMahalData.Element(lngIndex)
4941:     strType = pDatasetArray.Element(1)
4942:     Set pGeoDataset = pDatasetArray.Element(2)
4943:     Set pSpRef = pGeoDataset.SpatialReference
    
    ' IF VARIABLE IS A RASTER DATASET
4946:     If strType = "Raster" Then
4947:       Set pRasterBandColl = pGeoDataset
4948:       Set pRasterBand = pRasterBandColl.Item(0)
4949:       Set pRasterDataset = pRasterBand.RasterDataset
      
      ' GET BAND INDEX
4952:       Set pNewBandColl = pRasterDataset
4953:       lngBandIndex = pNewBandColl.BandIndex(pRasterBand.Bandname)
      
      ' IF PROJECTION IS CORRECT
4956:       If TopoCorridor.MyGeneralOperations.CompareSpatialReferences(pCommonSpRef, pSpRef) Then
4957:         Set pReturnRasterDataset = pRasterDataset
4958:         booShouldDelete = False
      ' IF RASTER NEEDS TO BE PROJECTED
4960:       Else
        ' PROJECT RASTER INTO NEW PROJECTION
4962:         Set pTransformOp = New RasterTransformationOp
4963:         Set pReturnRasterDataset = pTransformOp.ProjectFast(pRasterDataset, pCommonSpRef, esriGeoAnalysisResampleNearest)
4964:         booShouldDelete = True
4965:       End If
      
      ' WHETHER PROJECTED OR NOT, AN ENTIRE RASTER DATASET IS RETURNED.  THEREFORE ALL BANDS OF A MULTI-BAND DATASET.
      
    ' IF VARIABLE IS A POLYGON DATASET
4970:     Else
4971:       Set pFeatureLayer = pGeoDataset
4972:       Set pFClass = pFeatureLayer.FeatureClass
4973:       lngFieldIndex = pDatasetArray.Element(4)
4974:       Set pField = pDatasetArray.Element(5)
4975:       Set pClone = pField
4976:       booShouldDelete = True
4977:       lngBandIndex = 0
      
      
      ' IF POLYGON FEATURE CLASS DOES NOT NEED TO BE PROJECTED
4981:       If Not TopoCorridor.MyGeneralOperations.CompareSpatialReferences(pCommonSpRef, pSpRef) Then
      
        ' MAKE IN-MEMORY VERSION OF FEATURE CLASS WITH ALL FEATURES PROJECTED
4984:         strShapeFieldName = pFClass.ShapeFieldName
        
        ' CREATE NEW SHAPE FIELD IN CORRECT SPATIAL REFERENCE
4987:         Set pShapeField = New Field
4988:         Set pShapeEdit = pShapeField
4989:         Set pGeomDef = New GeometryDef
4990:         Set pGeomDefEdit = pGeomDef
4991:         With pGeomDefEdit
4992:           .GeometryType = pFClass.ShapeType
4993:           Set .SpatialReference = pCommonSpRef
4994:         End With
4995:         With pShapeEdit
4996:           .Name = strShapeFieldName
4997:           .Type = esriFieldTypeGeometry
4998:         End With
4999:         Set pShapeEdit.GeometryDef = pGeomDef
        
        ' COPY SELECTED FIELD
5002:         Set pNewField = pClone.Clone
5003:         Debug.Print pNewField.Name
        
5005:         Set pInMemWsFact = New InMemoryWorkspaceFactory
        
5007:         Set pName = pInMemWsFact.Create("", "InMemory", Nothing, 0)
5008:         Set pFeatWS = pName.Open
5009:         Set pNewFields = New Fields
5010:         Set pNewFieldsEdit = pNewFields
5011:         pNewFieldsEdit.AddField pShapeField
5012:         pNewFieldsEdit.AddField pNewField
        
5014:         Set pNewFClass = pFeatWS.CreateFeatureClass("InMemory", pNewFields, Nothing, Nothing, esriFTSimple, strShapeFieldName, "")
        
        ' WRITE DATA FROM ORIGINAL TO NEW FEATURE CLASS
5017:         lngOrigFieldIndex = pFClass.FindField(pField.Name)
5018:         lngNewFieldIndex = pNewFClass.FindField(pNewField.Name)
5019:         Debug.Print lngOrigFieldIndex
5020:         Debug.Print lngNewFieldIndex
        
5022:         Set pOrigCursor = pFClass.Search(Nothing, True)
        
5024:         Set pNewBuffer = pNewFClass.CreateFeatureBuffer
5025:         Set pNewCursor = pNewFClass.Insert(True)
        
5027:         Set pOrigFeature = pOrigCursor.NextFeature
        
        
5030:         Do Until pOrigFeature Is Nothing
5031:           Set pPolygon = pOrigFeature.ShapeCopy
          ' PROJECT POLYGON INTO NEW SPATIAL REFERENCE
5033:           pPolygon.Project pCommonSpRef
5034:           Set pNewBuffer.Shape = pPolygon
5035:           pNewBuffer.Value(lngNewFieldIndex) = pOrigFeature.Value(lngOrigFieldIndex)
5036:           Set pOrigFeature = pOrigCursor.NextFeature
5037:           pNewCursor.InsertFeature pNewBuffer
5038:         Loop
5039:         pNewCursor.Flush
        
5041:         Set pFClass = pNewFClass
5042:         lngFieldIndex = lngNewFieldIndex
        
        ' TEST NEW IN-MEMORY FEATURE CLASS
        '  Dim pTestCursor As IFeatureCursor
        '  Set pTestCursor = pNewFClass.Search(Nothing, True)
        '  Dim pTestFeature As IFeature
        '  Set pTestFeature = pTestCursor.NextFeature
        '  Dim lngCounter As Long
        '  lngCounter = 0
        '  Do Until pTestFeature Is Nothing
        '    lngCounter = lngCounter + 1
        '    Debug.Print CStr(lngCounter) & "]  " & CStr(pTestFeature.FeatureType) & ":   " & CStr(pTestFeature.Value(lngNewFieldIndex))
        '    Set pTestFeature = pTestCursor.NextFeature
        '  Loop
5056:       Else
5057:         Set pNewField = pField
5058:       End If
      
      ' CONVERT FEATURE CLASS TO RASTER DATASET
5061:       Set pConversionOp = New RasterConversionOp
      
      
'      Maybe need to do this as a series of extraction ops?  Conversion op does not transfer raster value...
'      Actually might be able to use a FeatureClassDescriptor object instead...
'      http://edndoc.esri.com/arcobjects/9.2/NET/shared/geoprocessing/Spatial_Analyst_Tools/torasterdataset.htm
      
5068:       Set pFeatClassDesc = New FeatureClassDescriptor
      
'      MsgBox "pFClass is Nothing = " & CStr(pFClass Is Nothing) & vbCrLf & _
'          "pNewField is nothing = " & CStr(pNewField Is Nothing) & vbCrLf & _
'          "pFeatClassDesc is nothing = " & CStr(pFeatClassDesc Is Nothing) & vbCrLf & _
'          "Object Name = " & pDatasetArray.Element(3)
'
        
5076:       pFeatClassDesc.Create pFClass, Nothing, pNewField.Name
      
5078:       Set pConEnv = pConversionOp
5079:       pConEnv.SetCellSize lngAnalysisEnum, dblCellSize
      
5081:       Set pRasWsFact = New RasterWorkspaceFactory
5082:       strSuggestDir = "c:\temp"
5083:       If Not pRasWsFact.IsWorkspace("c:\temp") Then
5084:         strSuggestDir = TopoCorridor.aml_func_mod.ReturnDir(TopoCorridor.aml_func_mod.GetMxDocPath(pApp))
5085:       End If
5086:       Set pRasWS = pRasWsFact.OpenFromFile(strSuggestDir, 0)
      
5088:       strSuggestName = TopoCorridor.MyGeneralOperations.MakeUniqueRasterName(ENUM_File_Raster, strSuggestDir, "MahalVar", True)
      
'      MsgBox "About to save " & strSuggestName & " in " & strSuggestDir & "..."
5091:       Set pReturnRasterDataset = pConversionOp.ToRasterDataset(pFeatClassDesc, "GRID", pRasWS, strSuggestName)
      
      ' FOR DEBUGGING
'      Dim pTestLayer As IRasterLayer
'      Set pTestLayer = New RasterLayer
'      pTestLayer.CreateFromDataset pReturnRasterDataset
'      pTestLayer.Name = strSuggestName
'      Dim pTestDoc As IMxDocument
'      Set pTestDoc = pApp.Document
'      pTestDoc.FocusMap.AddLayer pTestLayer
      
'      Dim pRastDataset2 As IRasterDataset2
'      Set pRastDataset2 = pReturnRasterDataset
'      pRastDataset2.CreateFullRaster
      
      
5107:     End If
    
    ' REPLACE ORIGINAL INDEX VALUE AT ELEMENT 0 WITH BOOLEAN STATING WHETHER THIS DATASET SHOULD BE DELETED
5110:     pDatasetArray.Remove 0
5111:     pDatasetArray.Insert 0, booShouldDelete
    
    ' REPLACE ORIGINAL DATASET WITH IRasterDataset
5114:     pDatasetArray.Remove 2
5115:     pDatasetArray.Insert 2, pReturnRasterDataset
    
    ' ADD BAND INDEX VALUE
5118:     pDatasetArray.Add lngBandIndex
    
'    MsgBox "Dataset " & pDatasetArray.Element(3) & vbCrLf & _
           "lngBandIndex = " & CStr(lngBandIndex)
    
5123:   Next lngIndex
  
5125:   If booShowProgress Then
5126:     frmProgress.ResetShortTimer
5127:   End If
  
5129:   pReturnArray.Add pMahalData
5130:   pReturnArray.Add pCommonSpRef
5131:   Set UnifyProjections = pReturnArray

5133:   GoTo CleanUp
ErrorHandler:
  HandleError False, "UnifyProjections " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4

CleanUp:

5139:   Set frmProgress = Nothing
5140:   Set pSourceData = Nothing
5141:   Set pMahalData = Nothing
5142:   Set pDatasetArray = Nothing
5143:   Set pGeoDataset = Nothing
5144:   Set pCommonSpRef = Nothing
5145:   Set pReturnArray = Nothing
5146:   Set pTransformOp = Nothing
5147:   Set pFLayer = Nothing
5148:   Set pFClass = Nothing
5149:   Set pFeature = Nothing
5150:   Set pPoint = Nothing
5151:   Set pPointColl = Nothing
5152:   Set pGeometry = Nothing
5153:   Set pRasterBand = Nothing
5154:   Set pTable = Nothing
5155:   Set pField = Nothing
5156:   Set pCursor = Nothing
5157:   Set pSelection = Nothing
5158:   Set pSelSet = Nothing
5159:   Set pParamsArray = Nothing
5160:   Set pDataSpRef = Nothing
5161:   Set pBandGeoDataset = Nothing
5162:   Set pQueryFilter = Nothing
5163:   Set pDataset = Nothing
5164:   Set pWS = Nothing
5165:   Set pWsFact = Nothing
5166:   Set pRaster = Nothing
5167:   Set pRasterBandCol = Nothing
5168:   Set pExtractionOp = Nothing
5169:   Set pAnEnv = Nothing
5170:   Set pRasterDesc = Nothing
5171:   Set pExtractDataset = Nothing
5172:   Set pConOp = Nothing
5173:   Set pMakerOp = Nothing
5174:   Set pRasterAnEnv = Nothing
5175:   Set pOneDataset = Nothing
5176:   Set pAOIRaster = Nothing
5177:   Set pFinalRaster = Nothing
5178:   Set pFinalDataset = Nothing
5179:   Set pFinalRasterColl = Nothing
5180:   Set pExtractBand = Nothing
5181:   Set pFeatureLayer = Nothing
5182:   Set pRasterBandColl = Nothing
5183:   Set pRasterDataset = Nothing
5184:   Set pSpRef = Nothing
5185:   Set pProps = Nothing
5186:   Set pTestSet = Nothing
5187:   Set pReturnRasterDataset = Nothing
5188:   Set pNewBandColl = Nothing
5189:   Set pClone = Nothing
5190:   Set pNewField = Nothing
5191:   Set pShapeField = Nothing
5192:   Set pShapeEdit = Nothing
5193:   Set pGeomDef = Nothing
5194:   Set pGeomDefEdit = Nothing
5195:   Set pInMemWsFact = Nothing
5196:   Set pFeatWS = Nothing
5197:   Set pName = Nothing
5198:   Set pNewFClass = Nothing
5199:   Set pNewFields = Nothing
5200:   Set pNewFieldsEdit = Nothing
5201:   Set pOrigCursor = Nothing
5202:   Set pOrigFeature = Nothing
5203:   Set pNewBuffer = Nothing
5204:   Set pNewCursor = Nothing
5205:   Set pPolygon = Nothing
5206:   Set pConversionOp = Nothing
5207:   Set pFeatClassDesc = Nothing
5208:   Set pConEnv = Nothing
5209:   Set pRasWsFact = Nothing
5210:   Set pRasWS = Nothing


End Function

Public Function ReturnXMinusMeans(pBandsMatrix As esriSystem.IVariantArray, pMeans As Matrix_jen, booFailed As Boolean, _
      strReason As String, pThisExt As TopoCorridor.clsExtension, pApp As IApplication, _
      strMessage As String, _
      psbar As IStatusBar, _
      pPro As IStepProgressor, _
      lngTimer As Long, _
      theProgressSpecific As String, _
      theDetailedDescription As String, _
      strTimeElapsed As String, _
      booFoundProblems As Boolean, _
      strReturn As String, _
      booShouldStop As Boolean, _
      theTimeBegan As Date) As esriSystem.IVariantArray
      
  On Error GoTo ErrorHandler

  Dim booShowProgress As Boolean
  Dim frmProgress As TopoCorridor.frmJenProgressMeter
5233:   Set frmProgress = pThisExt.ProgressMeterForm
5234:   booShowProgress = CBool(Not frmProgress Is Nothing)
  
    ' UPDATE PROGRESS METER ==================================================================
5237:   strMessage = "Generating Vector of Deviations from Means..."
5238:   psbar.Message(0) = strMessage
5239:   pPro.position = 0
5240:   lngTimer = lngTimer + 1

5242:   If booShowProgress Then
    ' ---- PROGRESS METER STUFF
5244:     DoEvents
'          theProgressSpecific = "Working on Step " & CStr(lngTimer) & " of " & CStr(lngValCount) & "..."
5246:     theProgressSpecific = strMessage
5247:     theDetailedDescription = theDetailedDescription & _
      " --> " & theProgressSpecific & vbCrLf & _
      "          [time stamp " & Format(Now, "ttttt,  ddddd") & "]" & vbCrLf & vbCrLf
5250:     frmProgress.ResetShortTimer
5251:     frmProgress.txtDetails.Text = theDetailedDescription
5252:     frmProgress.txtDetails.SelStart = Len(theDetailedDescription)

5254:     frmProgress.Est_Time_Left lngTimer, "Generating Vector of Deviations from Means...", "Calculating Data...", False
    ' frmProgress.lblCurrentTime.Caption = Format(Now, "ttttt")
5256:     frmProgress.Refresh
5257:     frmProgress.icnProgressLine.Refresh
5258:     DoEvents
5259:     If BailOutOfProgress(frmProgress, pApp) Then

     ' ********************************************************************************************
      ' ALTERNATIVE CODE THAT SAVES PARTIAL TABLE, CHECKS IF ERRORS FOUND AND OUTPUTS RTF INSTEAD OF TEXT
5263:       strTimeElapsed = TopoCorridor.MyGeneralOperations.ReturnTimeElapsedRTF(theTimeBegan, Now, 7)

5265:       If booFoundProblems Then
5266:         strReturn = "-----------------------------------------\par" & vbCrLf & _
          "NOTE:  Exited Function Prematurely at Step " & CStr(lngTimer) & "\par" & vbCrLf & _
          "-----------------------------------------\par" & vbCrLf & _
          "\pard\qc " & strTimeElapsed & vbCrLf & "}"
5270:       Else
5271:         strReturn = "-----------------------------------------\par" & vbCrLf & _
          "NOTE:  Exited Function Prematurely at Step " & CStr(lngTimer) & "\par" & vbCrLf & _
          "-----------------------------------------\par" & vbCrLf & _
          "\pard\qc " & strTimeElapsed & vbCrLf & "}"
5275:       End If

     ' ********************************************************************************************

5279:       frmProgress.cmdStop.Caption = "Close"
5280:       pPro.position = 0
5281:       psbar.HideProgressBar
5282:       booShouldStop = True
5283:       GoTo CleanUp
5284:     End If
    ' ---- END PROGRESS METER STUFF --------------------------------
5286:   End If

  Dim lngRows As Long
  Dim lngCols As Long
  Dim pGeoDataset As IGeoDataset
  
  Dim dblMean As Double
  
  Dim lngReason As Long
5295:   booFailed = False
    
  Dim pReturn As esriSystem.IVariantArray
5298:   Set pReturn = New esriSystem.VarArray
  Dim pSubArray As esriSystem.IVariantArray
  
  Dim pRastMaker As IRasterMakerOp
5302:   Set pRastMaker = New RasterMakerOp
  Dim pAnalysisEnv As IRasterAnalysisEnvironment
5304:   Set pAnalysisEnv = pRastMaker
  
  Dim pExtent As Envelope
  Dim dblCellSize As Double
  
  
  Dim pBaseRaster As IRasterDataset
  Dim pRowArray As esriSystem.IVariantArray
5312:   Set pRowArray = pBandsMatrix.Element(0)
  
5314:   Set pBaseRaster = pRowArray.Element(0)
  
5316:   pAnalysisEnv.SetCellSize esriRasterEnvValue, pBaseRaster
5317:   pAnalysisEnv.SetExtent esriRasterEnvValue, pBaseRaster
  
  Dim pNumRaster As IGeoDataset
  Dim pOutRast As IGeoDataset
  
  Dim pMathOp As IMathOp
5323:   Set pMathOp = New RasterMathOps
  Dim pMathEnv As IRasterAnalysisEnvironment
5325:   Set pMathEnv = pMathOp
5326:   pMathEnv.SetCellSize esriRasterEnvValue, pBaseRaster
5327:   pMathEnv.SetExtent esriRasterEnvValue, pBaseRaster
  
'  Dim pNumBand As IRasterBand
'  Dim pNumBandColl As IRasterBandCollection
  
5332:   For lngRows = 1 To pMeans.Rows
5333:     Set pRowArray = pBandsMatrix.Element(lngRows - 1)
5334:     Set pSubArray = New esriSystem.VarArray
    
5336:     For lngCols = 1 To pMeans.Columns
5337:       dblMean = pMeans.ReturnCellValue(lngRows, lngCols, lngReason)
5338:       If lngReason = 1 Then
5339:         booFailed = True
5340:         strReason = "Out-of bounds Row Index Value"
5341:         GoTo CleanUp
5342:       ElseIf lngReason = 2 Then
5343:         booFailed = True
5344:         strReason = "Out-of bounds Column Index Value"
5345:         GoTo CleanUp
5346:       End If
      
5348:       If booShowProgress Then
5349:         frmProgress.Est_Time_Left_Short lngCols, "Deviations from Means, Step " & _
              CStr(lngCols) & " of " & CStr(pMeans.Columns) & "...", pMeans.Columns
5351:         frmProgress.Refresh
5352:         frmProgress.icnProgressLine.Refresh
5353:         frmProgress.icnProgressLineShort.Refresh
5354:         DoEvents
5355:         If BailOutOfProgress(frmProgress, pApp) Then
    
         ' ********************************************************************************************
          ' ALTERNATIVE CODE THAT SAVES PARTIAL TABLE, CHECKS IF ERRORS FOUND AND OUTPUTS RTF INSTEAD OF TEXT
5359:           strTimeElapsed = TopoCorridor.MyGeneralOperations.ReturnTimeElapsedRTF(theTimeBegan, Now, 7)
    
5361:           If booFoundProblems Then
5362:             strReturn = "-----------------------------------------\par" & vbCrLf & _
              "NOTE:  Exited Function Prematurely at Step " & CStr(lngTimer) & "\par" & vbCrLf & _
              "-----------------------------------------\par" & vbCrLf & _
              "\pard\qc " & strTimeElapsed & vbCrLf & "}"
5366:           Else
5367:             strReturn = "-----------------------------------------\par" & vbCrLf & _
              "NOTE:  Exited Function Prematurely at Step " & CStr(lngTimer) & "\par" & vbCrLf & _
              "-----------------------------------------\par" & vbCrLf & _
              "\pard\qc " & strTimeElapsed & vbCrLf & "}"
5371:           End If
    
         ' ********************************************************************************************
    
5375:           frmProgress.cmdStop.Caption = "Close"
5376:           pPro.position = 0
5377:           psbar.HideProgressBar
5378:           booShouldStop = True
5379:           GoTo CleanUp
5380:         End If
5381:       End If
      
5383:       Set pNumRaster = pRastMaker.MakeConstant(dblMean, False)
'      Set pNumBandColl = pNumRaster
'      Set pNumBand = pNumBandColl.Item(0)
5386:       Set pGeoDataset = pRowArray.Element(lngCols - 1)
5387:       Set pOutRast = pMathOp.Minus(pGeoDataset, pNumRaster)
      
5389:       pSubArray.Add pOutRast
      
5391:     Next lngCols
5392:     pReturn.Add pSubArray
5393:   Next lngRows
  
5395:   frmProgress.ResetShortTimer
5396:   Set ReturnXMinusMeans = pReturn
  
5398:   GoTo CleanUp
ErrorHandler:
  HandleError True, "ReturnXMinusMeans " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4

CleanUp:

5404:   Set frmProgress = Nothing
5405:   Set pGeoDataset = Nothing
5406:   Set pReturn = Nothing
5407:   Set pSubArray = Nothing
5408:   Set pRastMaker = Nothing
5409:   Set pAnalysisEnv = Nothing
5410:   Set pExtent = Nothing
5411:   Set pBaseRaster = Nothing
5412:   Set pRowArray = Nothing
5413:   Set pNumRaster = Nothing
5414:   Set pOutRast = Nothing
5415:   Set pMathOp = Nothing
5416:   Set pMathEnv = Nothing

End Function

Private Function TransposeRasterMatrix(pMatrix As esriSystem.IVariantArray, pThisExt As TopoCorridor.clsExtension, _
    pApp As IApplication) As esriSystem.IVariantArray
  On Error GoTo ErrorHandler

  
  Dim booShowProgress As Boolean
  Dim frmProgress As TopoCorridor.frmJenProgressMeter
5427:   Set frmProgress = pThisExt.ProgressMeterForm
5428:   booShowProgress = CBool(Not frmProgress Is Nothing)
 
  Dim pReturnArray As esriSystem.IVariantArray
5431:   Set pReturnArray = New esriSystem.VarArray
  Dim pRowArray As esriSystem.IVariantArray
  
  Dim pSubArray As esriSystem.IVariantArray
  Dim lngRows As Long
  Dim lngCols As Long
  
5438:   lngRows = pMatrix.Count - 1
  
5440:   Set pSubArray = pMatrix.Element(0)
5441:   lngCols = pSubArray.Count - 1
  
  Dim lngIndex As Long
  Dim lngIndex2 As Long
  
5446:   For lngIndex = 0 To lngCols
5447:     Set pRowArray = New esriSystem.VarArray
5448:     pReturnArray.Add pRowArray
5449:   Next lngIndex
  
  ' TRANSPOSE VALUES
5452:   For lngIndex = 0 To lngCols
5453:     Set pRowArray = pReturnArray.Element(lngIndex)
    
5455:     For lngIndex2 = 0 To lngRows
5456:       Set pSubArray = pMatrix.Element(lngIndex2)
5457:       pRowArray.Add pSubArray.Element(lngIndex)
5458:     Next lngIndex2
5459:   Next lngIndex
  
5461:   Set TransposeRasterMatrix = pReturnArray

5463:   GoTo CleanUp
ErrorHandler:
  HandleError False, "TransposeRasterMatrix " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4

CleanUp:

5469:   Set frmProgress = Nothing
5470:   Set pReturnArray = Nothing
5471:   Set pRowArray = Nothing
5472:   Set pSubArray = Nothing

End Function

Private Function MakeRasterMatrix(pDataArray As esriSystem.IVariantArray, pThisExt As TopoCorridor.clsExtension, _
    pApp As IApplication) As esriSystem.IVariantArray
  On Error GoTo ErrorHandler
  
  Dim booShowProgress As Boolean
  Dim frmProgress As TopoCorridor.frmJenProgressMeter
5482:   Set frmProgress = pThisExt.ProgressMeterForm
5483:   booShowProgress = CBool(Not frmProgress Is Nothing)

  
  Dim pReturnArray As esriSystem.IVariantArray
5487:   Set pReturnArray = New esriSystem.VarArray
  Dim pRowArray As esriSystem.IVariantArray
  
  Dim pSubArray As esriSystem.IVariantArray
  Dim pRasterDataset As IRasterDataset2
  Dim pRaster As IRaster
  Dim pValArray As esriSystem.IVariantArray
  Dim pVarValuesArray As esriSystem.IVariantArray
5495:   Set pValArray = New esriSystem.VarArray
  
  Dim pRasterBandColl As IRasterBandCollection
  Dim pRasterBand As IRasterBand
  
  ' THE MATRIX IS COMPOSED OF RASTER BANDS, NOT THE ENTIRE RASTER DATASETS
  
  Dim lngIndex As Long
  Dim lngBandIndex As Long
5504:   For lngIndex = 0 To pDataArray.Count - 1
5505:     Set pSubArray = pDataArray.Element(lngIndex)
5506:     Set pRasterDataset = pSubArray.Element(2)
5507:     Set pRasterBandColl = pRasterDataset
5508:     If pSubArray.Element(1) = "Polygon" Then
5509:       lngBandIndex = pSubArray.Element(6)
5510:     Else
5511:       lngBandIndex = pSubArray.Element(4)
5512:     End If
5513:     Set pRasterBand = pRasterBandColl.Item(lngBandIndex)
    
5515:     Set pRowArray = New esriSystem.VarArray
5516:     pRowArray.Add pRasterBand
5517:     pReturnArray.Add pRowArray
5518:   Next lngIndex
  
5520:   Set MakeRasterMatrix = pReturnArray

5522:   GoTo CleanUp
ErrorHandler:
  HandleError False, "MakeRasterMatrix " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4

CleanUp:


5529:   Set frmProgress = Nothing
5530:   Set pReturnArray = Nothing
5531:   Set pRowArray = Nothing
5532:   Set pSubArray = Nothing
5533:   Set pRasterDataset = Nothing
5534:   Set pRaster = Nothing
5535:   Set pValArray = Nothing
5536:   Set pVarValuesArray = Nothing
5537:   Set pRasterBandColl = Nothing
5538:   Set pRasterBand = Nothing
End Function

Private Function MahalStep1(pXMinusMeanTranspose As esriSystem.IVariantArray, _
    pInvCovMatrix As Matrix_jen, pMxDoc As IMxDocument, pThisExt As TopoCorridor.clsExtension, _
    pApp As IApplication, _
      strMessage As String, _
      psbar As IStatusBar, _
      pPro As IStepProgressor, _
      lngTimer As Long, _
      theProgressSpecific As String, _
      theDetailedDescription As String, _
      strTimeElapsed As String, _
      booFoundProblems As Boolean, _
      strReturn As String, _
      booShouldStop As Boolean, _
      theTimeBegan As Date) As esriSystem.IVariantArray
      
      
  On Error GoTo ErrorHandler
  
  Dim booShowProgress As Boolean
  Dim frmProgress As TopoCorridor.frmJenProgressMeter
5561:   Set frmProgress = pThisExt.ProgressMeterForm
5562:   booShowProgress = CBool(Not frmProgress Is Nothing)
  
5564:   If booShowProgress Then
5565:     theDetailedDescription = theDetailedDescription & _
      " --> Preparing for Actual Mahalanobis Calculation" & vbCrLf & _
      "          [time stamp " & Format(Now, "ttttt,  ddddd") & "]" & vbCrLf & vbCrLf
5568:     frmProgress.txtDetails.Text = theDetailedDescription
5569:     frmProgress.txtDetails.SelStart = Len(theDetailedDescription)
5570:     DoEvents
5571:   End If
  
  ' FOR DEBUGGING
  Dim frmReportForm As TopoCorridor.frmReportDialog
  Dim pTempRaster As IRaster
  Dim pTempLayer As IRasterLayer
    ' ----------------------------------------------
    
  Dim pRasterBand As IRasterBand
  
  Dim pRowArray As esriSystem.IVariantArray
5582:   Set pRowArray = pXMinusMeanTranspose.Element(0)
  
  Dim pUnknown As IUnknown
5585:   Set pUnknown = pRowArray.Element(0)
  
'  MsgBox "Object is RasterBand = " & CStr(TypeOf pUnknown Is IRasterBand) & vbCrLf & _
         "Object is Raster = " & CStr(TypeOf pUnknown Is IRaster) & vbCrLf & _
         "Object is RasterDataset = " & CStr(TypeOf pUnknown Is IRasterDataset) & vbCrLf & _
         "Object is Raster Band Collection = " & CStr(TypeOf pUnknown Is IRasterBandCollection) & vbCrLf & _
         "Raster Band Count = "
  
'   Set pRasterBand = pRowArray.Element(0)
  
  ' X-MINUS-MEANS MATRIX CONTAINS RASTERS, NOT RASTER BANDS
  Dim pRaster As IRaster
  Dim pRasterBandColl As IRasterBandCollection
5598:   Set pRaster = pRowArray.Element(0)
5599:   Set pRasterBandColl = pRaster
  
  
  ' MAKE RASTER OPERATORS AND SET ANALYSIS ENVIRONMENT
  Dim pMapAlgebraOp As IMapAlgebraOp
5604:   Set pMapAlgebraOp = New RasterMapAlgebraOp
  Dim pRastAnalysisEnv As IRasterAnalysisEnvironment
5606:   Set pRastAnalysisEnv = pMapAlgebraOp
5607:   pRastAnalysisEnv.SetCellSize esriRasterEnvValue, pRaster
5608:   pRastAnalysisEnv.SetExtent esriRasterEnvValue, pRaster
  
  Dim pRasterMakerOp As IRasterMakerOp
5611:   Set pRasterMakerOp = New RasterMakerOp
  Dim pMakerAnEnv As IRasterAnalysisEnvironment
5613:   Set pMakerAnEnv = pRasterMakerOp
5614:   pMakerAnEnv.SetCellSize esriRasterEnvValue, pRaster
5615:   pMakerAnEnv.SetExtent esriRasterEnvValue, pRaster
  
  Dim lngVarCount As Long
5618:   lngVarCount = pRowArray.Count - 1
  
  Dim pVarRaster As IGeoDataset
  Dim strName As String
  
  Dim dblCovVal As Double
  
  ' CONVERT INVERSE COVARIANCE MATRIX TO AN ARRAY OF RASTERS    ' (NOT BANDS)
  Dim pCovRasters As esriSystem.IVariantArray
5627:   Set pCovRasters = New esriSystem.VarArray
  Dim pCovRow As esriSystem.IVariantArray
  Dim lngFailure As Long
  Dim pCovRaster As IRaster
  Dim pCovCollection As IRasterBandCollection
  
5633:   frmProgress.ResetShortTimer
5634:   frmProgress.Refresh
  
  Dim lngIndex As Long
  Dim lngIndex2 As Long
  Dim lngCounter As Long
5639:   lngCounter = 0
  Dim lngCount As Long
5641:   lngCount = pRowArray.Count ^ 2
  
5643:   For lngIndex = 0 To lngVarCount
5644:     Set pCovRow = New esriSystem.VarArray
5645:     For lngIndex2 = 0 To lngVarCount
5646:       dblCovVal = pInvCovMatrix.ReturnCellValue(lngIndex + 1, lngIndex2 + 1, lngFailure)
5647:       Set pCovRaster = pRasterMakerOp.MakeConstant(dblCovVal, False)
        
5649:         lngCounter = lngCounter + 1
5650:         If booShowProgress Then
5651:           frmProgress.Est_Time_Left_Short lngCounter, "Converting Matrix Values to Rasters, Step " & _
                CStr(lngCounter) & " of " & CStr(lngCount) & "...", lngCount
5653:           frmProgress.Refresh
5654:           frmProgress.icnProgressLineShort.Refresh
5655:           frmProgress.icnProgressLine.Refresh
5656:           DoEvents
5657:           If Not frmProgress.ShouldContinue Then
      
           ' ********************************************************************************************
            ' ALTERNATIVE CODE THAT SAVES PARTIAL TABLE, CHECKS IF ERRORS FOUND AND OUTPUTS RTF INSTEAD OF TEXT
      
5662:             strReturn = "-----------------------------------------\par" & vbCrLf & _
              "NOTE:  Exited Function Prematurely at Step " & CStr(lngTimer) & "\par" & vbCrLf & _
              "-----------------------------------------\par" & vbCrLf & _
              "\pard\qc " & TopoCorridor.MyGeneralOperations.ReturnTimeElapsedRTF(theTimeBegan, Now, 7) & vbCrLf & "}"
      
           ' ********************************************************************************************
      
5669:             frmProgress.cmdStop.Caption = "Close"
5670:             pPro.position = 0
5671:             psbar.HideProgressBar
5672:             booShouldStop = True
5673:             GoTo CleanUp
5674:           End If
5675:         End If
        
        ' FOR DEBUGGING; CHECKING TO SEE IF CREATING A RASTER LAYER MAKES THE MAP ALGEBRA OP WORK
5678:         Set pTempLayer = New RasterLayer
5679:         pTempLayer.CreateFromRaster pCovRaster
'        pTempLayer.Name = "Original [Var" & CStr(lngIndex) & CStr(lngIndex2) & "]"
'        pMxDoc.FocusMap.AddLayer pTempLayer
      
'      Set pCovCollection = pCovRaster
'      pCovRow.Add pCovCollection.Item(0)
5685:       pCovRow.Add pCovRaster
5686:     Next lngIndex2
5687:     pCovRasters.Add pCovRow
5688:   Next lngIndex
  
  ' FOR DEBUGGING
  Dim strReport As String
5692:   strReport = ""
  ' ---------------------------------
  
  ' MULTIPLY MATRICES
  ' BIND X-MINUS-MEAN MATRICES
  Dim lngRow As Long
  Dim lngCol As Long
5699:   For lngRow = 0 To pRowArray.Count - 1
'    Set pRasterBand = pRowArray.Element(lngRow)
'    pMapAlgebraOp.BindRaster pRasterBand, "Mean" & CStr(lngRow)
5702:     Set pRaster = pRowArray.Element(lngRow)
5703:     pMapAlgebraOp.BindRaster pRaster, "Mean" & CStr(lngRow)
    
    ' FOR DEBUGGING
5706:     strReport = strReport & "Bound Object [Mean" & CStr(lngRow) & "] is a Raster = " & _
        CStr(TypeOf pRaster Is IRaster) & "..." & vbCrLf
          
5709:     If booShowProgress Then
5710:       frmProgress.Est_Time_Left_Short lngRow + 1, "Deviations from Means, Step " & _
            CStr(lngRow + 1) & " of " & CStr(pRowArray.Count) & _
            "...", pRowArray.Count
5713:       frmProgress.Refresh
5714:       frmProgress.icnProgressLineShort.Refresh
5715:       frmProgress.icnProgressLine.Refresh
5716:       DoEvents
5717:       If BailOutOfProgress(frmProgress, pApp) Then
  
       ' ********************************************************************************************
        ' ALTERNATIVE CODE THAT SAVES PARTIAL TABLE, CHECKS IF ERRORS FOUND AND OUTPUTS RTF INSTEAD OF TEXT
5721:         strTimeElapsed = TopoCorridor.MyGeneralOperations.ReturnTimeElapsedRTF(theTimeBegan, Now, 7)
  
5723:         If booFoundProblems Then
5724:           strReturn = "-----------------------------------------\par" & vbCrLf & _
            "NOTE:  Exited Function Prematurely at Step " & CStr(lngTimer) & "\par" & vbCrLf & _
            "-----------------------------------------\par" & vbCrLf & _
            "\pard\qc " & strTimeElapsed & vbCrLf & "}"
5728:         Else
5729:           strReturn = "-----------------------------------------\par" & vbCrLf & _
            "NOTE:  Exited Function Prematurely at Step " & CStr(lngTimer) & "\par" & vbCrLf & _
            "-----------------------------------------\par" & vbCrLf & _
            "\pard\qc " & strTimeElapsed & vbCrLf & "}"
5733:         End If
  
       ' ********************************************************************************************
  
5737:         frmProgress.cmdStop.Caption = "Close"
5738:         pPro.position = 0
5739:         psbar.HideProgressBar
5740:         booShouldStop = True
5741:         GoTo CleanUp
5742:       End If
5743:     End If
    
    ' FORCE EVALUATION, BECAUSE OTHERWISE MAP ALGEBRA OP WILL CRASH
5746:     Set pTempLayer = New RasterLayer
5747:     pTempLayer.CreateFromRaster pRaster
'    pTempLayer.Name = "Original [Mean" & CStr(lngRow) & "]"
'    pMxDoc.FocusMap.AddLayer pTempLayer
    ' ---------------------------------------
    
5752:   Next lngRow
  
  ' BIND VARIABLE MATRICES AND EXECUTE ANALYSIS
  Dim pOutput As IRaster
  Dim strExecute As String
  
  Dim pReturnArray As esriSystem.IVariantArray
5759:   Set pReturnArray = New esriSystem.VarArray
  
  Dim pReturnRow As esriSystem.IVariantArray
5762:   Set pReturnRow = New esriSystem.VarArray
  
  Dim lngAdjustCount As Long
  Dim lngAdjustCounter As Long
  
5767:   frmProgress.ProgBeginTime = Now
5768:   lngAdjustCount = pCovRasters.Count + 1
5769:   lngAdjustCounter = 0
5770:   For lngCol = 0 To pCovRasters.Count - 1
5771:     strExecute = ""
    
    ' BIND VARIABLE MATRICES; SEPARATE BINDING FOR EACH COLUMN OF VARIABLE INVERSE COVARIANCE RASTERS
5774:     For lngRow = 0 To pCovRasters.Count - 1
5775:       Set pCovRow = pCovRasters.Element(lngRow)
5776:       Set pTempRaster = pCovRow.Element(lngCol)
5777:       pMapAlgebraOp.BindRaster pTempRaster, "Var" & CStr(lngRow)
5778:       strExecute = strExecute & "([Mean" & CStr(lngRow) & "] * [Var" & CStr(lngRow) & "]) + "
            
      ' FOR DEBUGGING
'      strReport = strReport & "Bound Object [Var" & CStr(lngCol) & CStr(lngRow) & "] is a Raster = " & _
'          CStr(TypeOf pCovRow.Element(lngRow) Is IRaster) & "..." & vbCrLf
'
'      Set pTempLayer = New RasterLayer
'      pTempLayer.CreateFromRaster pRowArray.Element(lngRow)
'      pTempLayer.Name = "Original [Mean" & CStr(lngRow) & "]"
'      pMxDoc.FocusMap.AddLayer pTempLayer
'
'      Set pTempLayer = New RasterLayer
'      pTempLayer.CreateFromRaster pCovRow.Element(lngRow)
'      pTempLayer.Name = "Original [Var" & CStr(lngCol) & CStr(lngRow) & "]"
'      pMxDoc.FocusMap.AddLayer pTempLayer
'
'      Set pTempRaster = pMapAlgebraOp.Execute("[Var" & CStr(lngCol) & CStr(lngRow) & "]")
'      Set pTempLayer = New RasterLayer
'      pTempLayer.CreateFromRaster pTempRaster
'      pTempLayer.Name = "[Mean" & CStr(lngRow) & "]"
'      pMxDoc.FocusMap.AddLayer pTempLayer
'
'      Set pTempRaster = pMapAlgebraOp.Execute("([Var" & CStr(lngCol) & CStr(lngRow) & "] * 1)")
'      Set pTempLayer = New RasterLayer
'      pTempLayer.CreateFromRaster pTempRaster
'      pTempLayer.Name = "([Mean" & CStr(lngRow) & "] * 1)"
'      pMxDoc.FocusMap.AddLayer pTempLayer
'
'      Set pTempRaster = pMapAlgebraOp.Execute("[Mean" & CStr(lngRow) & "]")
'      Set pTempLayer = New RasterLayer
'      pTempLayer.CreateFromRaster pTempRaster
'      pTempLayer.Name = "[Mean" & CStr(lngRow) & "]"
'      pMxDoc.FocusMap.AddLayer pTempLayer
'
'      Set pTempRaster = pMapAlgebraOp.Execute("([Mean" & CStr(lngRow) & "] * 1)")
'      Set pTempLayer = New RasterLayer
'      pTempLayer.CreateFromRaster pTempRaster
'      pTempLayer.Name = "([Mean" & CStr(lngRow) & "] * 1)"
'      pMxDoc.FocusMap.AddLayer pTempLayer

'      Set pTempRaster = pMapAlgebraOp.Execute("([Mean" & CStr(lngRow) & "] * [Var" & CStr(lngCol) & CStr(lngRow) & "])")
'      Set pTempLayer = New RasterLayer
'      pTempLayer.CreateFromRaster pTempRaster
'      pTempLayer.Name = "([Mean" & CStr(lngRow) & "] * [Var" & CStr(lngCol) & CStr(lngRow) & "])"
'      pMxDoc.FocusMap.AddLayer pTempLayer
      ' ---------------------------------------
      
5825:     Next lngRow
    
      ' UPDATE PROGRESS METER ==================================================================
5828:     psbar.Message(0) = strMessage
5829:     pPro.position = 0
5830:     lngTimer = lngTimer + 1
5831:     lngAdjustCounter = lngAdjustCounter + 1
5832:     strMessage = "Calculating Mahalanobis Distances [Step " & CStr(lngAdjustCounter) & _
        " of " & CStr(lngAdjustCount) & "]..."
    
5835:     If booShowProgress Then
      ' ---- PROGRESS METER STUFF
5837:       DoEvents
  '          theProgressSpecific = "Working on Step " & CStr(lngTimer) & " of " & CStr(lngValCount) & "..."
5839:       theProgressSpecific = strMessage
5840:       theDetailedDescription = theDetailedDescription & _
        " --> " & theProgressSpecific & vbCrLf & _
        "          [time stamp " & Format(Now, "ttttt,  ddddd") & "]" & vbCrLf & vbCrLf
5843:       frmProgress.txtDetails.Text = theDetailedDescription
5844:       frmProgress.txtDetails.SelStart = Len(theDetailedDescription)
  
5846:       frmProgress.Est_Time_Left lngTimer, "Calculating Mahalanobis Distances...", "Calculating Data...", True, _
          lngAdjustCount, lngAdjustCounter
          
      ' frmProgress.lblCurrentTime.Caption = Format(Now, "ttttt")
      
5851:       frmProgress.Est_Time_Left_Short lngAdjustCounter, strMessage, lngAdjustCount
      
5853:       frmProgress.Refresh
5854:       frmProgress.icnProgressLine.Refresh
5855:       frmProgress.icnProgressLineShort.Refresh
5856:       DoEvents
5857:       If BailOutOfProgress(frmProgress, pApp) Then
  
       ' ********************************************************************************************
        ' ALTERNATIVE CODE THAT SAVES PARTIAL TABLE, CHECKS IF ERRORS FOUND AND OUTPUTS RTF INSTEAD OF TEXT
5861:         strTimeElapsed = TopoCorridor.MyGeneralOperations.ReturnTimeElapsedRTF(theTimeBegan, Now, 7)
  
5863:         If booFoundProblems Then
5864:           strReturn = "-----------------------------------------\par" & vbCrLf & _
            "NOTE:  Exited Function Prematurely at Step " & CStr(lngTimer) & "\par" & vbCrLf & _
            "-----------------------------------------\par" & vbCrLf & _
            "\pard\qc " & strTimeElapsed & vbCrLf & "}"
5868:         Else
5869:           strReturn = "-----------------------------------------\par" & vbCrLf & _
            "NOTE:  Exited Function Prematurely at Step " & CStr(lngTimer) & "\par" & vbCrLf & _
            "-----------------------------------------\par" & vbCrLf & _
            "\pard\qc " & strTimeElapsed & vbCrLf & "}"
5873:         End If
  
       ' ********************************************************************************************
  
5877:         frmProgress.cmdStop.Caption = "Close"
5878:         pPro.position = 0
5879:         psbar.HideProgressBar
5880:         booShouldStop = True
5881:         GoTo CleanUp
5882:       End If
      ' ---- END PROGRESS METER STUFF --------------------------------
5884:     End If
    
5886:     strExecute = Left(strExecute, Len(strExecute) - 3)
    
    ' EXECUTE MAP ALGEBRA OPERATION
    
  
    ' SHOW NORMAL TEXT REPORT FOR DEBUGGING
'    Set frmReportForm = New TopoCorridor.frmReportDialog
'    frmReportForm.txtReport.Text = strReport & vbCrLf & " ------ " & vbCrLf & strExecute
'    frmReportForm.txtReport.Locked = False
'    frmReportForm.Caption = "Analysis Options:"
'    frmReportForm.Show vbModal
'    Set frmReportForm = Nothing
    ' ----------------------------------------------
    
    
    
5902:     Set pOutput = pMapAlgebraOp.Execute(strExecute)
5903:     pReturnRow.Add pOutput
    
    ' UNBIND RASTERS FROM THIS COLUMN
5906:     For lngRow = 0 To pCovRasters.Count - 1
5907:       Set pCovRow = pCovRasters.Element(lngRow)
5908:       pMapAlgebraOp.UnbindRaster "Var" & CStr(lngRow)
5909:     Next lngRow
5910:   Next lngCol
    
5912:   pReturnArray.Add pReturnRow
  
5914:   Set MahalStep1 = pReturnArray
  
5916:   GoTo CleanUp
ErrorHandler:
  HandleError False, "MahalStep1 " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4

CleanUp:

5922:   Set frmProgress = Nothing
5923:   Set frmReportForm = Nothing
5924:   Set pTempRaster = Nothing
5925:   Set pTempLayer = Nothing
5926:   Set pRasterBand = Nothing
5927:   Set pRowArray = Nothing
5928:   Set pUnknown = Nothing
5929:   Set pRaster = Nothing
5930:   Set pRasterBandColl = Nothing
5931:   Set pMapAlgebraOp = Nothing
5932:   Set pRastAnalysisEnv = Nothing
5933:   Set pRasterMakerOp = Nothing
5934:   Set pMakerAnEnv = Nothing
5935:   Set pVarRaster = Nothing
5936:   Set pCovRasters = Nothing
5937:   Set pCovRow = Nothing
5938:   Set pCovRaster = Nothing
5939:   Set pCovCollection = Nothing
5940:   Set pOutput = Nothing
5941:   Set pReturnArray = Nothing
5942:   Set pReturnRow = Nothing

End Function

Private Sub CreateTables(pMatrix As Matrix_jen, booIsMeans As Boolean, _
    strWS As String, strName As String, lngCategory As JenDatasetTypes, _
    strNameForErrorMessage As String, pMxDoc As IMxDocument, pApp As IApplication, _
    pThisExt As TopoCorridor.clsExtension, strFieldNameReport As String, _
    pVariableNames As esriSystem.IStringArray)
    
  On Error GoTo ErrorHandler
  
5954:   strFieldNameReport = ""
  
  Dim pAddFields As esriSystem.IVariantArray
  Dim pField As IField
  Dim pFieldEdit As IFieldEdit
  Dim lngIndex As Long
  
  Dim pNameArray As esriSystem.IStringArray
5962:   Set pAddFields = New esriSystem.VarArray
5963:   Set pNameArray = New esriSystem.strArray
  
  Dim strTestName As String
  Dim booUseGivenNames As Boolean
5967:   booUseGivenNames = Not pVariableNames Is Nothing
  
5969:   If booIsMeans Then
5970:     Set pField = New Field
5971:     Set pFieldEdit = pField
5972:     With pFieldEdit
5973:       .Name = "Means"
5974:       .Type = esriFieldTypeDouble
5975:       .Precision = 16
5976:       .Scale = 8
5977:     End With
5978:     pAddFields.Add pField
5979:     pNameArray.Add pField.Name
5980:   Else
5981:     For lngIndex = 1 To pMatrix.Rows
5982:       Set pField = New Field
5983:       Set pFieldEdit = pField
5984:       If booUseGivenNames Then
5985:         strTestName = pVariableNames.Element(lngIndex - 1) ' STRING ARRAY IS 0-BASED, NOT 1-BASED
5986:         strTestName = TopoCorridor.MyGeneralOperations.ReturnDBASEFieldName(strTestName, pNameArray)
5987:       Else
5988:         strTestName = "Var_" & CStr(lngIndex)
5989:       End If
5990:       With pFieldEdit
5991:         .Name = strTestName
5992:         .Type = esriFieldTypeDouble
5993:         .Precision = 16
5994:         .Scale = 8
5995:       End With
5996:       pAddFields.Add pField
5997:       pNameArray.Add pField.Name
5998:       strFieldNameReport = strFieldNameReport & "  --> Variable '" & pVariableNames.Element(lngIndex - 1) & _
            "': Field Name [" & strTestName & "] and Row " & CStr(lngIndex) & " (OID = " & CStr(lngIndex - 1) & _
            ")..." & vbCrLf
6001:     Next lngIndex
6002:   End If
  
  Dim pTable As ITable
6005:   Set pTable = TopoCorridor.MyGeneralOperations.CreateGeneralTableMahal(strWS, strName, _
         lngCategory, pAddFields, "Specify Name for " & strNameForErrorMessage & " Table:", False)
         
6008:   If pTable Is Nothing Then
6009:     MsgBox "Failed to create " & strNameForErrorMessage & " Table!" & vbCrLf & "Bailing out..."
6010:     GoTo CleanUp
6011:   End If
  
  ' GET INDEX VALUES FOR EACH FIELD
  Dim pIndexArray As esriSystem.ILongArray
6015:   Set pIndexArray = New esriSystem.LongArray
6016:   For lngIndex = 0 To pNameArray.Count - 1
6017:     pIndexArray.Add pTable.FindField(pNameArray.Element(lngIndex))
6018:   Next lngIndex
    
  ' SAMPLE CODE SNIPPET:  ADD RECORDS TO TABLE USING BUFFER
  Dim pBuffer As IRowBuffer
6022:   Set pBuffer = pTable.CreateRowBuffer
  Dim pTableCursor As ICursor
6024:   Set pTableCursor = pTable.Insert(True)
  
  ' LOOP THROUGH WHATEVER STEPS ARE REQUIRED TO GATHER DATA FOR A SINGLE ROW
  Dim lngRow As Long
  Dim lngCol As Long
  Dim dblVal As Double
  Dim lngFailure As Long
  Dim lngFieldIndex As Long
  
6033:   For lngRow = 1 To pMatrix.Rows
6034:     For lngCol = 1 To pMatrix.Columns
6035:       dblVal = CDbl(pMatrix.ReturnCellValue(lngRow, lngCol, lngFailure))
6036:       lngFieldIndex = pIndexArray.Element(lngCol - 1)
6037:       pBuffer.Value(lngFieldIndex) = dblVal
6038:       If booIsMeans Then
6039:         strFieldNameReport = strFieldNameReport & "  --> Variable '" & pVariableNames.Element(lngRow - 1) & _
              "': Stored in Row " & CStr(lngRow) & " (OID = " & CStr(lngRow - 1) & _
              ")..." & vbCrLf
6042:       End If
6043:     Next lngCol
    
6045:     pTableCursor.InsertRow pBuffer
6046:   Next lngRow
  
6048:   pTableCursor.Flush
  
  ' MAKE TABLE AND ADD TO MAP DOCUMENT
  Dim pNewStandaloneTable As IStandaloneTable
  Dim pTableWindow2 As ITableWindow2
  Dim pStandaloneTableCollection As IStandaloneTableCollection
  
6055:   Set pNewStandaloneTable = New StandaloneTable
6056:   Set pNewStandaloneTable.Table = pTable

6058:   Set pTableWindow2 = New TableWindow

6060:   With pTableWindow2
6061:     Set .StandaloneTable = pNewStandaloneTable
6062:     Set .Application = pApp
6063:     .TableSelectionAction = esriSelectFeatures
6064:     .ShowAliasNamesInColumnHeadings = True
6065:     .ShowSelected = False
6066:     .Show True
6067:   End With
6068:   Set pStandaloneTableCollection = pMxDoc.FocusMap
6069:   pStandaloneTableCollection.AddStandaloneTable pNewStandaloneTable
  
6071:   pMxDoc.UpdateContents
  
6073:   GoTo CleanUp
ErrorHandler:
  HandleError False, "CreateTables " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4

CleanUp:


6080:   Set pAddFields = Nothing
6081:   Set pField = Nothing
6082:   Set pFieldEdit = Nothing
6083:   Set pNameArray = Nothing
6084:   Set pTable = Nothing
6085:   Set pIndexArray = Nothing
6086:   Set pBuffer = Nothing
6087:   Set pTableCursor = Nothing
6088:   Set pNewStandaloneTable = Nothing
6089:   Set pTableWindow2 = Nothing
6090:   Set pStandaloneTableCollection = Nothing

End Sub



Private Function MahalStep2(pMahalStep1 As esriSystem.IVariantArray, _
    pXMinusMeans As esriSystem.IVariantArray, pThisExt As TopoCorridor.clsExtension, _
    pApp As IApplication, _
      strMessage As String, _
      psbar As IStatusBar, _
      pPro As IStepProgressor, _
      lngTimer As Long, _
      theProgressSpecific As String, _
      theDetailedDescription As String, _
      strTimeElapsed As String, _
      booFoundProblems As Boolean, _
      strReturn As String, _
      booShouldStop As Boolean, _
      theTimeBegan As Date) As IRaster
      
  On Error GoTo ErrorHandler
  
  Dim booShowProgress As Boolean
  Dim frmProgress As TopoCorridor.frmJenProgressMeter
6115:   Set frmProgress = pThisExt.ProgressMeterForm
6116:   booShowProgress = CBool(Not frmProgress Is Nothing)


    ' UPDATE PROGRESS METER ==================================================================
6120:   psbar.Message(0) = strMessage
6121:   pPro.position = 0
6122:   lngTimer = lngTimer + 1
  
  Dim lngAdjustCount As Long
  Dim lngAdjustCounter As Long
6126:   lngAdjustCount = pXMinusMeans.Count + 1
6127:   lngAdjustCounter = lngAdjustCount
6128:   strMessage = "Calculating Mahalanobis Distances [Step " & CStr(lngAdjustCounter) & _
      " of " & CStr(lngAdjustCount) & "]..."
  
6131:   frmProgress.ProgBeginTime = Now
  
6133:   If booShowProgress Then
    ' ---- PROGRESS METER STUFF
6135:     DoEvents
'          theProgressSpecific = "Working on Step " & CStr(lngTimer) & " of " & CStr(lngValCount) & "..."
6137:     theProgressSpecific = strMessage
6138:     theDetailedDescription = theDetailedDescription & _
      " --> " & theProgressSpecific & vbCrLf & _
      "          [time stamp " & Format(Now, "ttttt,  ddddd") & "]" & vbCrLf & vbCrLf
    
6142:     frmProgress.Est_Time_Left_Short lngAdjustCounter, strMessage, lngAdjustCount
      
6144:     frmProgress.txtDetails.Text = theDetailedDescription
6145:     frmProgress.txtDetails.SelStart = Len(theDetailedDescription)

6147:     frmProgress.Est_Time_Left lngTimer, "Calculating Mahalanobis Distances...", "Calculating Data...", True, _
        lngAdjustCount, lngAdjustCounter
        
    ' frmProgress.lblCurrentTime.Caption = Format(Now, "ttttt")
6151:     frmProgress.Refresh
6152:     frmProgress.icnProgressLine.Refresh
6153:     frmProgress.icnProgressLineShort.Refresh
6154:     DoEvents
6155:     If BailOutOfProgress(frmProgress, pApp) Then

     ' ********************************************************************************************
      ' ALTERNATIVE CODE THAT SAVES PARTIAL TABLE, CHECKS IF ERRORS FOUND AND OUTPUTS RTF INSTEAD OF TEXT
6159:       strTimeElapsed = TopoCorridor.MyGeneralOperations.ReturnTimeElapsedRTF(theTimeBegan, Now, 7)

6161:       If booFoundProblems Then
6162:         strReturn = "-----------------------------------------\par" & vbCrLf & _
          "NOTE:  Exited Function Prematurely at Step " & CStr(lngTimer) & "\par" & vbCrLf & _
          "-----------------------------------------\par" & vbCrLf & _
          "\pard\qc " & strTimeElapsed & vbCrLf & "}"
6166:       Else
6167:         strReturn = "-----------------------------------------\par" & vbCrLf & _
          "NOTE:  Exited Function Prematurely at Step " & CStr(lngTimer) & "\par" & vbCrLf & _
          "-----------------------------------------\par" & vbCrLf & _
          "\pard\qc " & strTimeElapsed & vbCrLf & "}"
6171:       End If

     ' ********************************************************************************************

6175:       frmProgress.cmdStop.Caption = "Close"
6176:       pPro.position = 0
6177:       psbar.HideProgressBar
6178:       booShouldStop = True
6179:       GoTo CleanUp
6180:     End If
    ' ---- END PROGRESS METER STUFF --------------------------------
6182:   End If
    
  ' REMEMBER THAT PXMinusMeans IS FILLED WITH RASTERS, AND pMahalStep1 IS FILLED WITH RASTERS
  ' FIRST CONVERT RASTER BANDS TO 1-DIMENSIONAL ARRAY OF RASTERS
  Dim pRaster As IRaster
  Dim pXMinusMeansRasters As esriSystem.IVariantArray
6188:   Set pXMinusMeansRasters = New esriSystem.VarArray
  Dim pXSubArray As esriSystem.IVariantArray
  Dim lngIndex As Long
  Dim pBandColl As IRasterBandCollection
  
6193:   For lngIndex = 0 To pXMinusMeans.Count - 1
6194:     Set pXSubArray = pXMinusMeans.Element(lngIndex)
6195:     Set pRaster = pXSubArray.Element(0)           ' ONLY ONE RASTER IN EACH ROW; THIS MATRIX IS A COLUMN MATRIX
'    Set pBandColl = New Raster
'    pBandColl.Add pRasterBand, 0
6198:     pXMinusMeansRasters.Add pRaster
6199:   Next lngIndex
  
  ' NEXT EXTRACT 1-DIMENSIONAL ARRAY OF RASTERS FROM STEP 1; SHOULD BE FIRST ITEM IN ORIGINAL ARRAY
  Dim pStep1Rasters As esriSystem.IVariantArray
6203:   Set pStep1Rasters = pMahalStep1.Element(0)
  
  ' MAKE RASTER OPERATORS AND SET ANALYSIS ENVIRONMENT
6206:   Set pXSubArray = pXMinusMeans.Element(0)
6207:   Set pRaster = pXSubArray.Element(0)
  
  Dim pMapAlgebraOp As IMapAlgebraOp
6210:   Set pMapAlgebraOp = New RasterMapAlgebraOp
  Dim pRastAnalysisEnv As IRasterAnalysisEnvironment
6212:   Set pRastAnalysisEnv = pMapAlgebraOp
6213:   pRastAnalysisEnv.SetCellSize esriRasterEnvValue, pRaster
6214:   pRastAnalysisEnv.SetExtent esriRasterEnvValue, pRaster
  
  Dim strName As String
  
  ' BIND RASTERS AND EXECUTE ANALYSIS
  Dim pOutput As IRaster
  Dim strExecute As String
  Dim lngRow As Long
  Dim lngCol As Long
  Dim pMeanRaster As IRaster
  
6225:   strExecute = ""
  
6227:   For lngRow = 0 To pStep1Rasters.Count - 1
6228:     Set pRaster = pStep1Rasters.Element(lngRow)
6229:     Set pMeanRaster = pXMinusMeansRasters.Element(lngRow)
6230:     pMapAlgebraOp.BindRaster pRaster, "Step1_" & CStr(lngRow)
6231:     pMapAlgebraOp.BindRaster pMeanRaster, "Mean_" & CStr(lngRow)
6232:     strExecute = strExecute & "([Step1_" & CStr(lngRow) & "] * [Mean_" & CStr(lngRow) & "]) + "
6233:   Next lngRow
6234:   strExecute = Left(strExecute, Len(strExecute) - 3)
    
  ' EXECUTE MAP ALGEBRA OPERATION
6237:   Set pOutput = pMapAlgebraOp.Execute(strExecute)
  
6239:   Set MahalStep2 = pOutput
  
6241:   GoTo CleanUp
ErrorHandler:
  HandleError False, "MahalStep2 " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4

CleanUp:

6247:   Set frmProgress = Nothing
6248:   Set pRaster = Nothing
6249:   Set pXMinusMeansRasters = Nothing
6250:   Set pXSubArray = Nothing
6251:   Set pBandColl = Nothing
6252:   Set pStep1Rasters = Nothing
6253:   Set pMapAlgebraOp = Nothing
6254:   Set pRastAnalysisEnv = Nothing
6255:   Set pOutput = Nothing
6256:   Set pMeanRaster = Nothing

End Function

Private Function GetExtension(pApp As IApplication) As TopoCorridor.clsExtension
  On Error GoTo ErrorHandler

  Dim newUid As New UID
  Dim pExt As IExtension
  Dim pThisExt As TopoCorridor.clsExtension
6266:   newUid.Value = "TopoCorridor.clsExtension"
6267:   Set pExt = pApp.FindExtensionByCLSID(newUid)
6268:   Set GetExtension = pExt


6271:   Set newUid = Nothing
6272:   Set pExt = Nothing
6273:   Set pThisExt = Nothing
  
6275:   GoTo CleanUp
ErrorHandler:
  HandleError False, "GetExtension " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4

CleanUp:

6281:   Set newUid = Nothing
6282:   Set pExt = Nothing
6283:   Set pThisExt = Nothing
  
End Function

' ------------- IN THIS MODULE, NEEDS CalcTimeLeft FUNCTION
Private Function CalcTimeLeft(strHeader As String, dateStart As Date, lngCurrent As Long, lngTotal As Long) As String
  On Error GoTo ErrorHandler

' ESTIMATED TIME LEFT CODE

  Dim thePercentDone As Double
6294:   If lngTotal <= 0 Then
6295:     thePercentDone = 0
6296:   Else
6297:     thePercentDone = (lngCurrent / lngTotal)
6298:   End If

  Dim thePercentForCalcs As Double
6301:   thePercentForCalcs = Round(thePercentDone * 100, 2)

'    lblPercentDone.Caption = "(" & thePercentForCalcs & "%)"
'    lblPercentDone.Refresh

  Dim theDuration As Double
6307:   theDuration = DateDiff("s", dateStart, Now)

  Dim PredictedDuration As Double
6310:   PredictedDuration = (theDuration * lngTotal) / (lngCurrent)

  Dim EstTimeLeft As Double
6313:   EstTimeLeft = PredictedDuration - theDuration

  Dim EstHoursLeft As Long
  Dim EstMinutesLeft As Long
  Dim EstSecondsLeft As Long

6319:   EstHoursLeft = Fix(EstTimeLeft / 3600)
6320:   EstMinutesLeft = Fix((EstTimeLeft - (EstHoursLeft * 3600)) / 60)
6321:   EstSecondsLeft = Fix(EstTimeLeft - (EstHoursLeft * 3600) - (EstMinutesLeft * 60))

  Dim EstTimeLeftStr As String
6324:   EstTimeLeftStr = EstHoursLeft & ":" & Format(EstMinutesLeft, "00") & ":" & Format(EstSecondsLeft, "00")

6326:   CalcTimeLeft = strHeader & ".....[record #" & CStr(lngCurrent) & " of " & CStr(lngTotal) & "  ---  " & thePercentForCalcs & "%]....." & _
      "Est. Time Left = " & EstTimeLeftStr & "..."

6329:   GoTo CleanUp
ErrorHandler:
  HandleError False, "CalcTimeLeft " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4

CleanUp:

End Function
' ------------- IN THIS MODULE, NEEDS BailOutOfProgress FUNCTION
Private Function BailOutOfProgress(frmProgressDialog As Object, pApp As IApplication) As Boolean
  On Error GoTo ErrorHandler

  Dim pThisExt As TopoCorridor.clsExtension
6341:   Set pThisExt = GetExtension(pApp)

  Dim frmProgress As TopoCorridor.frmJenProgressMeter
6344:   Set frmProgress = frmProgressDialog

6346:   pThisExt.ProgressDialogAutoClose = (frmProgress.chkClose.Value = 1)
6347:   pThisExt.ProgressDialogSetExpanded = (frmProgress.SetExpanded)

'  MsgBox "Checking Autoclose Stuff: " & vbCrLf & _
      "Check-Box checked? " & CStr(frmProgress.chkClose.Value = 1) & vbCrLf & _
      "Extension Property Checked? " & CStr(pThisExt.ProgressDialogAutoClose)

  ' PROGRESS METER STUFF --------------------------------------------------------
6354:   BailOutOfProgress = Not frmProgress.ShouldContinue
6355:   If BailOutOfProgress Then
    Dim theDateString As String
    Dim theElapsedTimeString As String

6359:     theDateString = Format(Now, "long date") & ";  " & Format(Now, "long time")
6360:     Screen.MousePointer = vbDefault
    Dim theTimeBegan As Date
    Dim theTimeEnd As Date
6363:     theTimeBegan = frmProgress.ProgBeginTime
6364:     theTimeEnd = Now

6366:     theElapsedTimeString = MyGeneralOperations.ReturnTimeElapsed(theTimeBegan, theTimeEnd)

    Dim theReport As String
6369:     theReport = "Operation cancelled prematurely at " & theDateString & vbCrLf & _
        "---------------------------------------------------------" & vbCrLf & theElapsedTimeString

    Dim strCurrentReport As String
6373:     strCurrentReport = frmProgress.txtDetails.Text
6374:     frmProgress.txtDetails.Text = strCurrentReport & vbCrLf & theReport
6375:     frmProgress.txtDetails.SelStart = Len(frmProgress.txtDetails.Text)

6377:     If frmProgress.chkClose.Value = 1 Then
    '  Unload frmProgress
    '  Set frmProgress = Nothing
6380:       frmProgress.Frame.Visible = False
6381:     End If

6383:     GoTo CleanUp
6384:   End If

6386:   GoTo CleanUp
ErrorHandler:
  HandleError False, "BailOutOfProgress " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4

CleanUp:

6392:   Set pThisExt = Nothing
6393:   Set frmProgress = Nothing

End Function

Private Function UnifyProjectionsPointsToLayers(pDataArray As esriSystem.IArray, pApp As IApplication, _
      pThisExt As TopoCorridor.clsExtension, strMessage As String, psbar As IStatusBar, _
      pPro As IStepProgressor, lngTimer As Long, _
      theProgressSpecific As String, theDetailedDescription As String, strTimeElapsed As String, _
      booFoundProblems As Boolean, strReturn As String, booShouldStop As Boolean, _
      theTimeBegan As Date, booExact As Boolean) As esriSystem.IArray
      
  On Error GoTo ErrorHandler
  
  ' FOR PROGRESS METER
6407:   booShouldStop = False
  Dim booShowProgress As Boolean
  Dim frmProgress As TopoCorridor.frmJenProgressMeter
6410:   Set frmProgress = pThisExt.ProgressMeterForm
6411:   booShowProgress = CBool(Not frmProgress Is Nothing)
  ' ---------------------------------------------------
  
  
  Dim pPointParams As esriSystem.IVariantArray
  Dim pPointLayer As IFeatureLayer
  Dim pPointFClass As IFeatureClass
  Dim booUseAll As Boolean
  Dim lngPointCount As Long
  Dim lngSelPointCount As Long
  
6422:   Set pPointParams = pDataArray.Element(0)          ' TWO ITEMS IN ARRAY; FIRST ITEM IS ARRAY CONTAINING POINT SOURCE DATA
6423:   Set pPointLayer = pPointParams.Element(0)
6424:   Set pPointFClass = pPointLayer.FeatureClass
6425:   booUseAll = pPointParams.Element(1)
6426:   lngPointCount = pPointParams.Element(2)
6427:   lngSelPointCount = pPointParams.Element(3)
  
  ' MAKE ARRAY OF OID VALUES
  Dim pOIDArray As esriSystem.ILongArray
6431:   Set pOIDArray = New esriSystem.LongArray
  
  ' MAKE BASE MULTIPOINT
  Dim pFeature As IFeature
  Dim pPointSet As IPointCollection
6436:   Set pPointSet = New Multipoint
  
  ' SET SPATIAL REFERENCE OF NEW POINT SET MULTIPOINT
  Dim pGeometry As IGeometry
6440:   Set pGeometry = pPointSet
  Dim pPointGeoDataset As IGeoDataset
6442:   Set pPointGeoDataset = pPointFClass
6443:   Set pGeometry.SpatialReference = pPointGeoDataset.SpatialReference
  
  ' DECIDE WHETHER TO DO ALL POINTS OR ONLY SELECTED SET
  Dim pCursor As IFeatureCursor
  Dim pSelectionSet As ISelectionSet
  Dim pFeatSel As IFeatureSelection
6449:   Set pFeatSel = pPointLayer
6450:   Set pSelectionSet = pFeatSel.SelectionSet
6451:   If Not booUseAll Then
6452:     pSelectionSet.Search Nothing, True, pCursor
6453:   Else
6454:     Set pCursor = pPointFClass.Search(Nothing, True)
6455:   End If
    
  ' POPULATE pOIDArray AND pPointSet
6458:   Set pFeature = pCursor.NextFeature
6459:   Do Until pFeature Is Nothing
    
6461:     pOIDArray.Add pFeature.OID    ' CAN I ASSUME ALL POINT DATASETS WILL HAVE OID VALUES?
6462:     pPointSet.AddPoint pFeature.ShapeCopy
    
6464:     Set pFeature = pCursor.NextFeature
6465:   Loop
  
  ' REFRESH ORIGINAL SELECTION
6468:   If Not booUseAll Then
6469:     Set pFeatSel.SelectionSet = pSelectionSet
6470:     pFeatSel.SelectionChanged
6471:   End If
  
  ' PREPARE TO MAKE COPIES OF MULTIPOINT
  Dim pClone As IClone
6475:   Set pClone = pPointSet
  
  Dim pMahalData As esriSystem.IVariantArray
6478:   Set pMahalData = pDataArray.Element(1)            ' TWO ITEMS IN ARRAY; SECOND ITEM IS ARRAY CONTAINING MAHALANOBIS VARIABLE DATA
  
  Dim pDatasetArray As esriSystem.IVariantArray
6481:   Set pDatasetArray = pMahalData.Element(0)
  
  Dim pGeoDataset As IGeoDataset
'  Set pGeoDataset = pDatasetArray.Element(2)        ' SEE LIST BELOW FOR ORDER OF ITEMS IN RASTER PARAMETER ARRAYS
  
  Dim pCommonSpRef As ISpatialReference
6487:   Set pCommonSpRef = pPointGeoDataset.SpatialReference
  
  Dim pReturnArray As esriSystem.IArray
6490:   Set pReturnArray = New esriSystem.Array
  
  Dim pTransformOp As ITransformationOp
  Dim pFLayer As IFeatureLayer
  Dim pFClass As IFeatureClass
  Dim pPoint As IPoint
  Dim pPointColl As IPointCollection
  Dim pRasterBand As IRasterBand
  Dim strRasterName As String
  Dim lngFieldIndex As Long
  Dim pTable As ITable
  Dim varValue As Variant
  Dim booIsString As Boolean
  Dim strFieldName As String
  Dim pField As IField
  
  Dim lngTotalDatasets As Long
6507:   lngTotalDatasets = pMahalData.Count + 1
  
    ' UPDATE PROGRESS METER ==================================================================
6510:   strMessage = "Identifying Source Data Projection..."
6511:   psbar.Message(0) = strMessage
6512:   pPro.position = 0
6513:   lngTimer = lngTimer + 1

6515:   If booShowProgress Then
    ' ---- PROGRESS METER STUFF
6517:     DoEvents
'          theProgressSpecific = "Working on Step " & CStr(lngTimer) & " of " & CStr(lngValCount) & "..."
6519:     theProgressSpecific = strMessage
6520:     theDetailedDescription = theDetailedDescription & _
      " --> " & theProgressSpecific & vbCrLf & _
      "          [time stamp " & Format(Now, "ttttt,  ddddd") & "]" & vbCrLf & vbCrLf
6523:     frmProgress.ResetShortTimer
6524:     frmProgress.txtDetails.Text = theDetailedDescription
6525:     frmProgress.txtDetails.SelStart = Len(theDetailedDescription)

6527:     frmProgress.Est_Time_Left lngTimer, "Setting Source Data Projection...", "Calculating Data...", False
    ' frmProgress.lblCurrentTime.Caption = Format(Now, "ttttt")
6529:     frmProgress.Refresh
6530:     frmProgress.icnProgressLine.Refresh
        
6532:     frmProgress.Est_Time_Left_Short 1, "Forcing Uniform Projection, Source Data...", lngTotalDatasets
6533:     frmProgress.Refresh
6534:     frmProgress.icnProgressLine.Refresh
6535:     frmProgress.icnProgressLineShort.Refresh
    
6537:     DoEvents
6538:     If BailOutOfProgress(frmProgress, pApp) Then

     ' ********************************************************************************************
      ' ALTERNATIVE CODE THAT SAVES PARTIAL TABLE, CHECKS IF ERRORS FOUND AND OUTPUTS RTF INSTEAD OF TEXT
6542:       strTimeElapsed = TopoCorridor.MyGeneralOperations.ReturnTimeElapsedRTF(theTimeBegan, Now, 7)

6544:       If booFoundProblems Then
6545:         strReturn = "-----------------------------------------\par" & vbCrLf & _
          "NOTE:  Exited Function Prematurely at Step " & CStr(lngTimer) & "\par" & vbCrLf & _
          "-----------------------------------------\par" & vbCrLf & _
          "\pard\qc " & strTimeElapsed & vbCrLf & "}"
6549:       Else
6550:         strReturn = "-----------------------------------------\par" & vbCrLf & _
          "NOTE:  Exited Function Prematurely at Step " & CStr(lngTimer) & "\par" & vbCrLf & _
          "-----------------------------------------\par" & vbCrLf & _
          "\pard\qc " & strTimeElapsed & vbCrLf & "}"
6554:       End If

     ' ********************************************************************************************

6558:       frmProgress.cmdStop.Caption = "Close"
6559:       pPro.position = 0
6560:       psbar.HideProgressBar
6561:       booShouldStop = True
6562:       GoTo CleanUp
6563:     End If
    ' ---- END PROGRESS METER STUFF --------------------------------
6565:   End If
  
  
'  MsgBox "Checkpoint 1"
    
  ' ADD BASE POINT COLLECTION INFO TO RETURN ARRAY
  Dim pPointData As esriSystem.IVariantArray
6572:   Set pPointData = New esriSystem.VarArray
6573:   pPointData.Add pOIDArray
6574:   pPointData.Add pPointSet
  
6576:   pReturnArray.Add pPointData
  
  '  MsgBox "Checkpoint 4"
  
  ' MOVING ON TO INPUT MAHALANOBIS VARIABLES, BASED ON frmGridLayers OPTIONS
  
  ' UPDATE PROGRESS METER ==================================================================
6583:   strMessage = "Setting Input Data Projection..."
6584:   psbar.Message(0) = strMessage
6585:   pPro.position = 0
6586:   lngTimer = lngTimer + 1

6588:   If booShowProgress Then
    ' ---- PROGRESS METER STUFF
6590:     DoEvents
'          theProgressSpecific = "Working on Step " & CStr(lngTimer) & " of " & CStr(lngValCount) & "..."
6592:     theProgressSpecific = strMessage
6593:     theDetailedDescription = theDetailedDescription & _
      " --> " & theProgressSpecific & vbCrLf & _
      "          [time stamp " & Format(Now, "ttttt,  ddddd") & "]" & vbCrLf & vbCrLf
6596:     frmProgress.txtDetails.Text = theDetailedDescription
6597:     frmProgress.txtDetails.SelStart = Len(theDetailedDescription)

6599:     frmProgress.Est_Time_Left lngTimer, "Setting Input Data Projection...", "Calculating Data...", False
    ' frmProgress.lblCurrentTime.Caption = Format(Now, "ttttt")
6601:     frmProgress.Refresh
6602:     frmProgress.icnProgressLine.Refresh
6603:     DoEvents
6604:     If BailOutOfProgress(frmProgress, pApp) Then

     ' ********************************************************************************************
      ' ALTERNATIVE CODE THAT SAVES PARTIAL TABLE, CHECKS IF ERRORS FOUND AND OUTPUTS RTF INSTEAD OF TEXT
6608:       strTimeElapsed = TopoCorridor.MyGeneralOperations.ReturnTimeElapsedRTF(theTimeBegan, Now, 7)

6610:       If booFoundProblems Then
6611:         strReturn = "-----------------------------------------\par" & vbCrLf & _
          "NOTE:  Exited Function Prematurely at Step " & CStr(lngTimer) & "\par" & vbCrLf & _
          "-----------------------------------------\par" & vbCrLf & _
          "\pard\qc " & strTimeElapsed & vbCrLf & "}"
6615:       Else
6616:         strReturn = "-----------------------------------------\par" & vbCrLf & _
          "NOTE:  Exited Function Prematurely at Step " & CStr(lngTimer) & "\par" & vbCrLf & _
          "-----------------------------------------\par" & vbCrLf & _
          "\pard\qc " & strTimeElapsed & vbCrLf & "}"
6620:       End If

     ' ********************************************************************************************

6624:       frmProgress.cmdStop.Caption = "Close"
6625:       pPro.position = 0
6626:       psbar.HideProgressBar
6627:       booShouldStop = True
6628:       GoTo CleanUp
6629:     End If
    ' ---- END PROGRESS METER STUFF --------------------------------
6631:   End If
  
  ' NOTE:  EACH OF THESE SELECTED ITEMS IS AN esriSystem.IVariantArray CONTAINING THE FOLLOWING ITEMS:
  ' 1) IF A RASTER LAYER (i.e. if theArray.Element(1) = "Raster"):
  '    0) Index value of original Raster list item; not useful any more
  '    1) String "Raster", indicating the data type of this item
  '    2) Actual Raster object, original saved as IRasterBandCollection but available as an IRaster
  '    3) Name of Raster Object, as it appeared in original list
  '    4) Band Index; added by this function
  ' 2) IF A POLYGON LAYER (i.e. if theArray.Element(1) = "Polygon"):
  '    0) Index value of original Polygon list item; not useful any more
  '    1) String "Polygon", indicating the data type of this item
  '    2) Actual Polygon Layer
  '    3) Polygon Layer Name
  '    4) Field Index value for selected attribute field
  '    5) Actual selected attribute field
  
  Dim lngIndex As Long
  Dim strType As String
  Dim pFeatureLayer As IFeatureLayer
  Dim pRasterBandColl As IRasterBandCollection
  Dim pRasterDataset As IRasterDataset
  Dim pSpRef As ISpatialReference
  Dim pPrjPointSet As IGeometry
  Dim pRaster As IRaster
  
  Dim pPolygonFLayer As IFeatureLayer
  Dim pPolygonFClass As IFeatureClass
  Dim lngValueIndex As Long
  Dim pPntColl As IPointCollection
  Dim pPolygonFCursor As IFeatureCursor
  Dim pPolygonFeature As IFeature
  Dim pSpFilt As ISpatialFilter
  Dim lngIndex2 As Long
  Dim pCheckPoint As IPoint
        
  ' RETURNED OBJECTS WILL ALL BE IRasterDatasets IF ORIGIONALLY RASTER LAYERS, OR FEATURE CLASSES OTHERWISE
  ' ENTIRE ORIGINAL SUB-ARRAYS WILL BE RETURNED, WITH IRasterDatasets SUBSTITUED FOR ORIGINAL DATASETS
  ' FIRST ITEM (CURRENTLY AN INDEX VALUE, NO LONGER NECESSARY) WILL BE REPLACED WITH BOOLEAN INDICATING
  ' WHETHER DATASET SHOULD BE DELETED
  Dim pReturnRasterDataset As IRasterDataset
  Dim booShouldDelete As Boolean
  
  Dim pNewBandColl As IRasterBandCollection
  Dim lngBandIndex As Long
  
  Dim varValues As esriSystem.IVariantArray
  
6679:   For lngIndex = 0 To pMahalData.Count - 1
  
6681:     If booShowProgress Then
6682:       frmProgress.Est_Time_Left lngTimer + lngIndex, "Setting Source Data Projection...", "Calculating Data...", False
6683:       frmProgress.Est_Time_Left_Short lngIndex + 2, "Forcing Uniform Projection, Input Data " & _
          CStr(lngIndex + 1) & " of " & CStr(pMahalData.Count) & "...", lngTotalDatasets
6685:       frmProgress.Refresh
6686:       frmProgress.icnProgressLine.Refresh
6687:       frmProgress.icnProgressLineShort.Refresh
6688:       If BailOutOfProgress(frmProgress, pApp) Then
  
       ' ********************************************************************************************
        ' ALTERNATIVE CODE THAT SAVES PARTIAL TABLE, CHECKS IF ERRORS FOUND AND OUTPUTS RTF INSTEAD OF TEXT
6692:         strTimeElapsed = TopoCorridor.MyGeneralOperations.ReturnTimeElapsedRTF(theTimeBegan, Now, 7)
  
6694:         If booFoundProblems Then
6695:           strReturn = "-----------------------------------------\par" & vbCrLf & _
            "NOTE:  Exited Function Prematurely at Step " & CStr(lngTimer) & "\par" & vbCrLf & _
            "-----------------------------------------\par" & vbCrLf & _
            "\pard\qc " & strTimeElapsed & vbCrLf & "}"
6699:         Else
6700:           strReturn = "-----------------------------------------\par" & vbCrLf & _
            "NOTE:  Exited Function Prematurely at Step " & CStr(lngTimer) & "\par" & vbCrLf & _
            "-----------------------------------------\par" & vbCrLf & _
            "\pard\qc " & strTimeElapsed & vbCrLf & "}"
6704:         End If
  
       ' ********************************************************************************************
  
6708:         frmProgress.cmdStop.Caption = "Close"
6709:         pPro.position = 0
6710:         psbar.HideProgressBar
6711:         booShouldStop = True
6712:         GoTo CleanUp
6713:       End If
6714:     End If
    
6716:     Set pDatasetArray = pMahalData.Element(lngIndex)
6717:     strType = pDatasetArray.Element(1)
6718:     Set pGeoDataset = pDatasetArray.Element(2)
6719:     Set pSpRef = pGeoDataset.SpatialReference
6720:     booShouldDelete = False
    
6722:     Set pPrjPointSet = pClone.Clone
    
    ' IF PROJECTION IS NOT CORRECT
6725:     If Not TopoCorridor.MyGeneralOperations.CompareSpatialReferences(pCommonSpRef, pSpRef) Then
      ' PROJECT POINTS INTO NEW PROJECTION
6727:       pPrjPointSet.Project pSpRef
6728:     End If
    
    
'    INSERT CODE HERE TO RETURN ACTUAL LISTS OF VARIABLE VALUES RATHER THAN PROJECTED POINTS
    
    
    
    ' IF VARIABLE IS A RASTER DATASET
6736:     If strType = "Raster" Then
      
6738:       Set pRasterBandColl = pGeoDataset
6739:       Set pRaster = pRasterBandColl
      
6741:       Set pRasterBand = pRasterBandColl.Item(0)
6742:       Set pRasterDataset = pRasterBand.RasterDataset
      
      ' GET BAND INDEX
6745:       Set pNewBandColl = pRasterDataset
6746:       lngBandIndex = pNewBandColl.BandIndex(pRasterBand.Bandname)
      
6748:       If booExact Then
6749:         Set varValues = TopoCorridor.GridFunctions.CellValues2(pPrjPointSet, pRaster, lngBandIndex)
6750:       Else
6751:         Set varValues = TopoCorridor.GridFunctions.CellValues4CellInterp(pPrjPointSet, pRaster, lngBandIndex)
6752:       End If
      
6754:       Set pReturnRasterDataset = pRasterDataset
      
      ' WHETHER PROJECTED OR NOT, AN ENTIRE RASTER DATASET IS RETURNED.  THEREFORE ALL BANDS OF A MULTI-BAND DATASET.
6757:     Else
6758:       Set pPolygonFLayer = pDatasetArray.Element(2)
6759:       Set pPolygonFClass = pPolygonFLayer.FeatureClass
6760:       lngValueIndex = pDatasetArray.Element(4)
6761:       Set pPntColl = pPrjPointSet
      
6763:       Set pSpFilt = New SpatialFilter
6764:       pSpFilt.SpatialRel = esriSpatialRelIntersects
      
6766:       Set varValues = New esriSystem.VarArray
      
6768:       For lngIndex2 = 0 To pPntColl.PointCount - 1
6769:         Set pCheckPoint = pPntColl.Point(lngIndex2)
        
6771:         Set pSpFilt.Geometry = pCheckPoint
6772:         Set pPolygonFCursor = pPolygonFClass.Search(pSpFilt, True)
6773:         Set pPolygonFeature = pPolygonFCursor.NextFeature
6774:         If pPolygonFeature Is Nothing Then
6775:           varValue = Null
6776:         Else
6777:           varValue = pPolygonFeature.Value(lngValueIndex)
6778:         End If
6779:         varValues.Add varValue
6780:       Next lngIndex2
6781:     End If
    
    ' REPLACE ORIGINAL INDEX VALUE AT ELEMENT 0 WITH PROPERLY PROJECTED POINT SET
6784:     pDatasetArray.Remove 0
6785:     pDatasetArray.Insert 0, pPrjPointSet
    
    ' REPLACE ORIGINAL DATASET WITH IRasterDataset
6788:     If strType = "Raster" Then
6789:       pDatasetArray.Remove 2
6790:       pDatasetArray.Insert 2, pReturnRasterDataset
6791:     End If
    
    ' ADD BAND INDEX VALUE
6794:     pDatasetArray.Add lngBandIndex
    
    ' ADD VALUES
6797:     pDatasetArray.Add varValues
'    Dim strCheckData As String
'    Dim lngOID As Long
'    strCheckData = "Data for " & pDatasetArray.Element(3) & ":" & vbCrLf
'    For lngIndex2 = 0 To varValues.Count - 1
'      varValue = varValues.Element(lngIndex2)
'      lngOID = pOIDArray.Element(lngIndex2)
'      If IsNull(varValue) Then
'        strCheckData = strCheckData & "  Point OID " & CStr(lngOID) & "] Value = Null" & vbCrLf
'      Else
'        strCheckData = strCheckData & "  Point OID " & CStr(lngOID) & "] Value = " & CDbl(varValue) & vbCrLf
'      End If
'    Next lngIndex2
'    MsgBox strCheckData
    
'    MsgBox "Dataset " & pDatasetArray.Element(3) & vbCrLf & _
           "lngBandIndex = " & CStr(lngBandIndex)
    
6815:   Next lngIndex
  
6817:   If booShowProgress Then
6818:     frmProgress.ResetShortTimer
6819:   End If
  
6821:   pReturnArray.Add pMahalData
6822:   pReturnArray.Add pCommonSpRef
6823:   Set UnifyProjectionsPointsToLayers = pReturnArray

6825:   GoTo CleanUp
ErrorHandler:
  HandleError False, "UnifyProjectionsPointsToLayers " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4

CleanUp:


6832:   Set frmProgress = Nothing
6833:   Set pPointParams = Nothing
6834:   Set pPointLayer = Nothing
6835:   Set pPointFClass = Nothing
6836:   Set pOIDArray = Nothing
6837:   Set pFeature = Nothing
6838:   Set pPointSet = Nothing
6839:   Set pGeometry = Nothing
6840:   Set pPointGeoDataset = Nothing
6841:   Set pCursor = Nothing
6842:   Set pSelectionSet = Nothing
6843:   Set pFeatSel = Nothing
6844:   Set pClone = Nothing
6845:   Set pMahalData = Nothing
6846:   Set pDatasetArray = Nothing
6847:   Set pGeoDataset = Nothing
6848:   Set pCommonSpRef = Nothing
6849:   Set pReturnArray = Nothing
6850:   Set pTransformOp = Nothing
6851:   Set pFLayer = Nothing
6852:   Set pFClass = Nothing
6853:   Set pPoint = Nothing
6854:   Set pPointColl = Nothing
6855:   Set pRasterBand = Nothing
6856:   Set pTable = Nothing
6857:   Set pField = Nothing
6858:   Set pPointData = Nothing
6859:   Set pFeatureLayer = Nothing
6860:   Set pRasterBandColl = Nothing
6861:   Set pRasterDataset = Nothing
6862:   Set pSpRef = Nothing
6863:   Set pPrjPointSet = Nothing
6864:   Set pRaster = Nothing
6865:   Set pPolygonFLayer = Nothing
6866:   Set pPolygonFClass = Nothing
6867:   Set pPntColl = Nothing
6868:   Set pPolygonFCursor = Nothing
6869:   Set pPolygonFeature = Nothing
6870:   Set pSpFilt = Nothing
6871:   Set pCheckPoint = Nothing
6872:   Set pReturnRasterDataset = Nothing
6873:   Set pNewBandColl = Nothing
6874:   Set varValues = Nothing

End Function


