Attribute VB_Name = "MyGeneralOperations"
Option Explicit

' MyGeneralOperations
' Jeff Jenness
' Jenness Enterprises
' http://www.jennessent.com

'  BasicStatsFromArray - GIVEN anArray, Field Name, Table Name, and Application, _
            Returns Sum, Mean, Minimum, Maximum, Range, Count, StDev, Variance, Median, Standard Error of Mean and Mode String
'  BasicStatsFromArraySimple - Simplified version of BasicStatsFromArray, with no progress info and no mode data.
'           GIVEN anArray, optional directive to calculate standard deviation info,
'           Returns Sum, Mean, Minimum, Maximum, Range, Count, StDev, Variance, Median, Standard Error of Mean
'  BasicStatsFromArray_Weighted - GIVEN 2-Dimensional anArray with Values and Weights, Field Name, Table Name, and Application, _
            Returns Weighted Mean, Weighted StDev and Weighted Variance
'  BasicStatsFromVAT - GIVEN 2-Dimensional Arrays (Value and Size, both sorted by Value), Field Name, Table Name, and Application, _
            Returns Sum, Mean, Minimum, Maximum, Range, Count, StDev, Variance, Median, Standard Error of Mean and Mode String
'  CalcStatistics - GIVEN AN ARRAY OF DOUBLES AND AN ARRAY OF BOOLEAN STAT OPTIONS, RETURNS AN ARRAY OF STATISTICS
'  CheckCollectionForKey - GIVEN pCollection and STRING, RETURNS BOOLEAN INDICATING WHETHER COLLECTION HAS THAT KEY OR NOT
'  CheckIfCompressedFGDB - GIVEN pFeatureClass, RETURNS BOOLEAN IF THIS FEATURE CLASS COMES FROM A COMPRESSED FILE GEODATABASE
'  CheckIfFeatureClassExists - GIVEN FEATURE WORKSPACE AND FEATURE CLASS NAME, RETURNS BOOLEAN IF FEATURE CLASS ALREADY EXISTS
'  CheckIfTableExists - GIVEN FEATURE WORKSPACE AND TABLE NAME, RETURNS BOOLEAN IF TABLE WITH THAT NAME ALREADY EXISTS
'  CheckNumericReal - GIVEN KEYASCII AND TEXTBOX, RESTRICTS INPUT TO ANY REAL NUMBER
'  CheckNumericRealPositive - GIVEN KEYASCII AND TEXTBOX, RESTRICTS INPUT TO ANY POSITIVE REAL NUMBER
'  CheckNumericInteger - GIVEN KEYASCII AND TEXTBOX, RESTRICTS INPUT TO ANY INTEGER
'  CheckNumericIntegerPositive - GIVEN KEYASCII AND TEXTBOX, RESTRICTS INPUT TO ANY POSITIVE INTEGER
'  CheckSpRefDomain - GIVEN SPATIAL REFERENCE, RETURNS BOOLEAN STATING WHETHER IT HAS A VALID XY DOMAIN
'  CompareSpatialReferences - RETURNS A BOOLEAN STATING WHETHER PROJECTION / DATUM ARE SAME.
'  ConvertLongBinary - GIVEN A LONG AND OPTIONAL NUMBER OF CHARACTERS, RETURNS BINARY REPRESENTATION.
'  CreateDatasetFeatureClass - GIVEN A FEATURE DATASET, FEATURE CLASS NAME, OPTIONAL GOEMETRY TYPE AND FIELD ARRAY, RETURNS A
'           NEW FEATURE CLASS INSIDE THE SPECIFIED FEATURE DATASET:  MODIFIED FROM ESRI SAMPLE
'  CreateGDBFeatureClass - GIVEN A FILE OR PERSONAL GEODATABASE, FEATURE CLASS NAME, OPTIONAL GOEMETRY TYPE, FIELD ARRAY, ETC, RETURNS A
'           NEW GEODATABASE FEATURE CLASS:  MODIFIED FROM ESRI SAMPLE
'  CreateGDBTable - GIVEN A FILE OR PERSONAL GEODATABASE, TABLE NAME, FIELD ARRAY, ETC, RETURNS A
'           NEW GEODATABASE TABLE:  MODIFIED FROM ESRI SAMPLE FOR CREATING GEODATABASE FEATURE CLASSES
'  CreateGeneralFeatureClass - RETURNS A NEW FEATURE CLASS IN A FOLDER (I.E. SHAPEFILE) OR IN A FILE / PERSONAL GEODATABASE.
'           CAN SEND IT SPECIFIC INSTRUCTIONS REGARDING NAME AND LOCATION, OR CAN HAVE IT ASK THE USER.
'  CreateGeneralTable - RETURNS A NEW TABLE IN A FOLDER (I.E. dBASE TABLE) OR IN A FILE / PERSONAL GEODATABASE.
'           CAN SEND IT SPECIFIC INSTRUCTIONS REGARDING NAME AND LOCATION, OR CAN HAVE IT ASK THE USER.
'  CreateInMemoryFeatureClass - GIVEN AN IARRAY OF GEOMETRIES (ALL OF SAME TYPE), RETURNS AN IN-MEMORY FEATURE CLASS.
'  CreateNestedFoldersByPath - GIVEN A PATH NAME, CREATES ANY MISSING FOLDERS IN THAT PATH
'  CreateShapefileFeatureClass - GIVEN A FOLDER, NAME, SPATIAL REFERENCE, GEOMETRY TYPE, OPTIONAL FIELD ARRAY,
'           RETURNS SHAPEFILE FEATURE CLASS.
'  CreatedBASETableInFolder - GIVEN A FOLDER, NAME, OPTIONAL FIELD ARRAY, CREATEDS dBASE TABLE AND RETURNS ITable OBJECT.
'  CursorToSet_Features - GIVEN A FEATURE CURSOR, RETURNS AN ISET OF FEATURES ALLOWING SET TO BE RUN THROUGH MULTIPLE TIMES
'  CursorToSet_TableRow - GIVEN A CURSOR, RETURNS AN ISET OF ROWS ALLOWING SET TO BE RUN THROUGH MULTIPLE TIMES
'  DeleteGraphicsByName - GIVEN A NAME AND MAP DOCUMENT, DELETES ALL GRAPHICS WITH A PARTICULAR NAME
'  DoSpatialQuery - SELECTS ALL FEATURES FROM FIRST FEATURE LAYER THAT INTERSECT SELECTED FEATURES OF SECONDS FEATURE LAYER
'  EnableSelectTool - GIVEN Application, CLICKS THE "SELECT ELEMENTS" TOOL
'  ForceUppercase - GIVEN KEYASCII AND TEXTBOX, FORCES ENTERED KEYSTROKE TO BE UPPERCASE
'  GetPart - GIVEN A STRING AND DELIMITER, CLIPS OFF PORTION OF STRING IN FRONT OF DELIMITER AND RETURNS IT.  THE ORIGINAL
'           STRING HAS THE PART AND DELIMITER REMOVED FROM THE FRONT.  USED BY CreateNestedFoldersByPath FUNCTION
'  Graphic_MakeFromGeometry - GIVEN A MAP DOCUMENT, GEOMETRY AND OPTIONAL NAME AND SYMBOLOGY, ADDS GRAPHIC TO MAP.
'  Graphic_ReturnElementFromGeometry - GIVEN MAP DOC, GEOMETRY, OPTIONAL NAME AND OPTIONAL ADD-TO-VIEW, RETURNS THE GRAPHIC
'           ELEMENT
'  GraphicsSetNameSelected - GIVEN A MAP DOCUMENT AND NAME, ASSIGNS THAT NAME TO ALL SELECTED GRAPHICS
'  IsNaN - GIVEN A VARIANT, RETURNS A BOOLEAN INDICATING WHETHER A NUMBER IS A "NOT-A-NUMBER" VALUE
'  MakeColorRGB - GIVEN RED, GREEN AND BLUE, RETURN ICOLOR
'  MakeColorHSV - GIVEN HUE, SATURATION AND VALUE, RETURN ICOLOR
'  MakeFieldNameArray - GIVEN ORIGINAL FEATURE CLASS, NEW FEATURE CLASS, AND IVARIANARRAY OF NEW FIELD NAMES,
'                   RETURN ARRAY CONTAINING INDEX VALUES FOR EACH FIELD NAME
'  MakeRandomNormal - GIVEN MEAN, SD, PLACEHOLDER VARIABLE, OPTIONAL SECOND PLACEHOLDER, REPLACES PLACEHOLDERS WITH RANDOM NUMBERS
'                   FROM NORMAL DISTRIBUTION WITH SPECIFIED MEAN AND STANDARD DEVIATION
'                   USES BOX-MULLER TRANSFORMATION
'  MakeRandomNormalPolar - GIVEN MEAN, SD, PLACEHOLDER VARIABLE, OPTIONAL SECOND PLACEHOLDER, REPLACES PLACEHOLDERS WITH RANDOM NUMBERS
'                   FROM NORMAL DISTRIBUTION WITH SPECIFIED MEAN AND STANDARD DEVIATION
'                   Marsaglia's variation of the Box-Muller Transformation (http://en.wikipedia.org/wiki/Box-Muller_transform)
'  MakeUniquedBASEName - GIVEN A FULL FILE NAME, RETURNS A UNIQUE FILENAME IN THAT FOLDER BY APPENDING COUNTER TO ORIGINAL NAME
'  MakeUniqueGDBFeatureClassName - GIVEN IWorkspace AND NAME STRING, RETURNS A NAME STRING THAT REFLECTS A UNIQUE NAME IN THAT GDB
'  MakeUniqueGDBTableName - GIVEN IWorkspace AND NAME STRING, RETURNS A NAME STRING THAT REFLECTS A UNIQUE TABLE NAME IN THAT GDB
'  MakeUniqueRasterName - GIVEN JenDatasetType, WORKSPACE PATH STRING AND RASTER NAME, RETURNS A UNIQUE RASTER NAME FOR THAT WORKSPACE
'                   OPTIONALLY WILL TRIM TO GRID RESTRICTIONS FOR FILE-BASED RASTER
'  MakeUniqueRasterName2 - GIVEN IWorkspace, RASTER NAME AND OPTIONAL BOOLEAN TO TRIM TO 13 CHARACTERS, RETURNS A UNIQUE RASTER NAME FOR THAT WORKSPACE
'  MakeUniqueShapeFilename - GIVEN A FULL FILE NAME, RETURNS A UNIQUE FILENAME IN THAT FOLDER BY APPENDING COUNTER TO ORIGINAL NAME
'  OpenFile - GIVEN A DOCUMENT FILENAME AND PATH, OPENS THAT FILE USING THE REGISTERED WINDOWS PROGRAM
'  RemoveKeyFromCollection - GIVEN A COLLECTION AND KEY, REMOVE THE KEY WITHOUT CRASHING CODE IF COLLECTION DOES NOT HAVE THAT KEY
'  ReplaceBadChars - GIVEN A NAME, REPLACES ALL NON-STANDARD CHARACTERS WITH "_" CHARACTERS
'  ReturnCurrentMapUnits - GIVE IT AN IMAP, IT RETURNS THE NAME OF THE MAP UNITS
'  ReturnDBASEFieldName - GIVEN SAMPLE FIELD NAME AND LIST, RETURNS A NAME THAT IS VALID FOR DBASE AND DOES NOT EXIST IN THE LIST.
'                         LIST CAN BE AN IFields, IStringArray or IVarArray (CONTAINING EITHER STRINGS OR FIELDS)
'  ReturnDistanceUnitsName - GIVEN AN esriUnits, RETURNS THE NAME
'  ReturnFieldsByType - GIVEN pFields AND JenFieldType ENUMERATION, RETURNS AN IVarARRAY OF FIELDS
'  ReturnGraphicsByName - GIVEN A MAP DOCUMENT AND NAME, RETURNS A COLLECTION CONTAINING THE GEOMETRIES OF THOSE GRAPHICS
'  ReturnGraphicsByType - GIVEN A MAP DOCUMENT AND SHAPE TYPE, RETURNS A COLLECTION CONTAINING THE GEOMETRIES OF THOSE GRAPHICS
'  ReturnHistStatsFromDouble - MODIFICATION OF BasicStatsFromArraySimple
'           GIVEN anArray, optional directive to calculate standard deviation info, optional boolean for sample / population,
'                   optional boolean to return sorted array of numbers
'           RETURNS pArray, containing 4 sub-arrays: 1) Double Array of unique values, 2) Long array of counts of values,
'                   Double Array of standard stats (Sum, Mean, Minimum, Maximum, Range, Count, StDev, Variance, Median, Standard Error of Mean)
'                   Optional array of sorted numbers
'  ReturnLayersByType - GIVEN FOCUSMAP AND TYPE, RETURNS IVariantArray OF LAYERS
'  ReturnLayerByName - GIVEN NAME AND MAP, RETURNS pLayer OR NOTHING
'  ReturnQueryStringPrefixSuffix - GIVEN DATASET, FILLS strPrefix AND strSuffix VALUES AND RETURNS BOOLEAN FOR WHETHER IT CRASHED OR NOT
'  ReturnTempRasterWorkspace - RETURNS A RASTER WORKSPACE OBJECT LOCATED IN CURRENT TEMP DIRECTORY
'  ReturnTimeStamp - RETURNS STRING FORMATTED AS "YYYYMMDD_HHMMSS", OR SOMETHING LIKE "20081314_083230"
'  ReturnTimeElapsed - GIVEN A START AND END TIME, RETURNS A STRING DESCRIBING THE TIME ELAPSED.
'           Analysis Began: Wednesday, July 26, 2006;  4:39:01 PM
'           Analysis Complete: Wednesday, July 27, 2006;  5:47:22 PM
'           Time Elapsed: 1 day, 1 hour, 8 minutes, 21 seconds...
'  ReturnTimeElapsedFromMilliseconds - GIVEN A MILLISECOND COUNT (FROM GetTickCount API FUNCTION), RETURNS A STRING DESCRIBING THE TIME ELAPSED.
'           Analysis Began: Wednesday, July 26, 2006;  4:39:01 PM
'           Analysis Complete: Wednesday, July 27, 2006;  5:47:22 PM
'           Time Elapsed: 1 day, 1 hour, 8 minutes, 21 seconds...
'  ReturnTimeElapsedRTF - GIVEN A START AND END TIME, RETURNS AN RTF-FORMATTED STRING DESCRIBING THE TIME ELAPSED.
'           Analysis Began: Wednesday, July 26, 2006;  4:39:01 PM
'           Analysis Complete: Wednesday, July 27, 2006;  5:47:22 PM
'           Time Elapsed: 1 day, 1 hour, 8 minutes, 21 seconds...
'  TrimZerosAndDecimas - GIVEN A NUMERIC VARIANT, RETURNS STRING WILL ALL TRAILING ZEROS AND DECIMALS TRIMMED OFF.  OPTIONAL TO ADD COMMAS
'  TrueLayerCount - GIVEN AN IMAP, RETURNS TRUE LAYER COUNT INCLUDING GROUP LAYERS

Public Declare Function CopyFile Lib "Kernel32" Alias "CopyFileA" _
  (ByVal lpExistingFileName As String, ByVal lpNewFileName As String, _
  ByVal bFailIfExists As Long) As Long
  
Private Declare Function ShellExecute Lib "shell32.dll" Alias _
           "ShellExecuteA" (ByVal hWnd As Long, ByVal lpOperation As String, _
           ByVal lpFile As String, ByVal lpParameters As String, _
           ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long

Public Declare Function SetWindowPos Lib "user32" (ByVal hWnd As Long, ByVal _
  hWndInsertAfter As Long, ByVal X As Long, ByVal Y As _
  Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags _
  As Long) As Long

Public Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" _
  (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long

Public Const GWL_HWNDPARENT = (-8)
Private Const INVALID_HANDLE_VALUE As Long = -1
Private Const MAX_PATH As Long = 260

Declare Function GetDesktopWindow Lib "user32.dll" () As Long
Public Declare Function GetTickCount Lib "Kernel32" () As Long

Private Type SECURITY_ATTRIBUTES
   nLength As Long
   lpSecurityDescriptor As Long
   bInheritHandle As Long
End Type

Private Declare Function CreateDirectory Lib "Kernel32" _
   Alias "CreateDirectoryA" _
  (ByVal lpPathName As String, _
   lpSecurityAttributes As SECURITY_ATTRIBUTES) As Long
   
Public Enum JenFieldTypes
  ENUM_FieldString = 1
  ENUM_FieldNumber = 2
  ENUM_FieldDate = 4
  ENUM_FieldOID = 8
  ENUM_FieldGeometry = 16
  ENUM_FieldBlob = 32
  ENUM_FieldRaster = 64
  ENUM_FieldGUID = 128
  ENUM_FieldGlobalID = 256
  ENUM_FieldXML = 512
End Enum

Public Enum JenLayerTypes
  ENUM_jenFeatureLayers = 1
  ENUM_jenRasterLayers = 2
  ENUM_jenStandaloneTables = 4
  ENUM_jenPointLayers = 8
  ENUM_jenPolylineLayers = 16
  ENUM_jenPolygonLayers = 32
  ENUM_jenMultipointLayers = 64
  ENUM_jenTinLayers = 128
  ENUM_jenRastCatalogLayers = 256
End Enum

Public Enum JenDatasetTypes
  ENUM_Shapefile = 1
  ENUM_FileGDB = 2
  ENUM_PersonalGDB = 4
  ENUM_Coverage = 8
  ENUM_SDC_FeatureClass = 16
  ENUM_File_Raster = 32
End Enum


Public Enum JenFieldBracketTypes
  ENUM_EncloseInQuotationMarks = 1
  ENUM_EncloseInBrackets = 2
  ENUM_DoNotEnclose = 4
End Enum

Const dblPi As Double = 3.14159265358979
Const c_sModuleFileName As String = "...MyGeneralOperations.bas"

Public Function TrimZerosAndDecimals(varNumber As Variant, Optional booAddCommas As Boolean = True) As String
  On Error GoTo ErrorHandler

  Dim dblValue As Double
193:   dblValue = CDbl(varNumber)
  Dim strValue As String
195:   If booAddCommas Then
196:     strValue = CStr(Format(dblValue, "#,##0.000000000000000"))
197:   Else
198:     strValue = CStr(Format(dblValue, "0.000000000000000"))
199:   End If
  
201:   Do Until Right(strValue, 1) <> "0" Or Len(strValue) = 0
202:     strValue = Left(strValue, Len(strValue) - 1)
203:   Loop
  
205:   Do Until Right(strValue, 1) <> "." Or Len(strValue) = 0
206:     strValue = Left(strValue, Len(strValue) - 1)
207:   Loop
  
209:   If strValue = "" Then
210:     strValue = "0"
211:   End If
  
213:   TrimZerosAndDecimals = strValue
  

  Exit Function
ErrorHandler:
  HandleError True, "TrimZerosAndDecimals " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function


Public Function GetFieldNameBracket(pDataset As IDataset) As JenFieldBracketTypes
  On Error GoTo ErrorHandler


  Dim pWS As IWorkspace
  Dim pWsFact As IWorkspaceFactory
  
229:   Set pWS = pDataset.Workspace
230:   Set pWsFact = pWS.WorkspaceFactory
  
  Dim lngBracketType As JenFieldBracketTypes
  ' 1 if enclosing in quotes
  ' 2 if enclosing in brackets
  ' 4 if not enclosing
  
237:   If pWS.Type = esriFileSystemWorkspace Then                   ' THEN IT IS A GRID OR SHAPEFILE
238:     lngBracketType = ENUM_EncloseInQuotationMarks
239:   ElseIf pWS.Type = esriLocalDatabaseWorkspace Then            ' THEN COULD BE FGDB OR PGDB
240:     If Right(pWS.PathName, 4) = ".gdb" Then
241:       lngBracketType = ENUM_EncloseInQuotationMarks            ' FOR FILE GEODATABASE
242:     Else
243:       If TypeOf pDataset Is IRasterDataset Then                ' GRIDS IN PERSONAL GEODATABASES APPARENTLY USE QUOTATION MARKS
244:         lngBracketType = ENUM_EncloseInQuotationMarks
245:       Else
246:         lngBracketType = ENUM_EncloseInBrackets                ' FOR PERSONAL GEODATABASES
247:       End If
248:     End If
249:   ElseIf pWS.Type = esriRemoteDatabaseWorkspace Then
250:     lngBracketType = ENUM_DoNotEnclose                         ' FOR REMOTE SDE-TYPE
251:   End If

253:   GetFieldNameBracket = lngBracketType


  Exit Function
ErrorHandler:
  HandleError True, "GetFieldNameBracket " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function
Public Function MakeFieldNameVarArray(pOrigFClass As IFeatureClass, pNewFClass As IFeatureClass, _
      pFieldArray As esriSystem.IVariantArray, booFieldArrayContainsNamePairs As Boolean) As esriSystem.IVariantArray
  On Error GoTo ErrorHandler

      
  ' MAKE IVariantArray OF FIELD NAME INDICES
  ' STRUCTURE:  ARRAY OF 4-ITEM VARIANT ARRAYS
  '             ITEMS = 0) ORIGINAL FCLASS FIELD NAME
  '                     1) ORIGINAL FCLASS FIELD INDEX
  '                     2) NEW FCLASS FIELD NAME
  '                     3) NEW FCLASS FIELD INDEX
  
  Dim lngIndex As Long
  Dim pField As IField
  Dim strOrigName As String
  Dim strNewName As String
  Dim pNamePair As esriSystem.IStringArray
  Dim pFieldData As esriSystem.IVariantArray
278:   Set MakeFieldNameVarArray = New VarArray
  
280:   For lngIndex = 0 To pFieldArray.Count - 1
281:     If booFieldArrayContainsNamePairs Then
282:       Set pNamePair = pFieldArray.Element(lngIndex)
283:       strOrigName = pNamePair.Element(0)
284:       strNewName = pNamePair.Element(1)
285:     Else
286:       Set pField = pFieldArray.Element(lngIndex)
287:       strOrigName = pField.Name
288:       strNewName = pField.Name
289:     End If
290:     Set pFieldData = New esriSystem.VarArray
291:     pFieldData.Add strOrigName
292:     pFieldData.Add pOrigFClass.FindField(strOrigName)
293:     pFieldData.Add strNewName
294:     pFieldData.Add pNewFClass.FindField(strNewName)
295:     MakeFieldNameVarArray.Add pFieldData
296:   Next lngIndex
      

  Exit Function
ErrorHandler:
  HandleError True, "MakeFieldNameVarArray " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Sub MakeRandomNormal(dblMean As Double, dblSD As Double, ByVal dblRand1 As Double, Optional ByVal dblRand2 As Double = -999)
  On Error GoTo ErrorHandler


308:   Static dblSeed
' Based on the Box-Muller Transformation:.
'          y1 = sqrt( - 2 ln(x1) ) cos( 2 pi x2 )
'          y2 = sqrt( - 2 ln(x1) ) sin( 2 pi x2 )
'        where:
'          x1 = first uniform random number (between 0 and 1)
'          x2 = second uniform random number (between 0 and 1)
'          y1 = first normally distributed random number
'          y2 = second normally distributed random number.
317:   If dblSeed = 0 Then
318:     Randomize            ' USE SYSTEM TIMER
319:   Else
320:     Randomize dblSeed
321:   End If
  Dim dblX1 As Double
  Dim dblX2 As Double
324:   dblX1 = Rnd
325:   dblX2 = Rnd
  
327:   dblRand1 = (Sqr(-2 * Log(dblX1)) * Cos(2 * dblPi * dblX2) * dblSD#) + dblMean#
328:   dblRand2 = (Sqr(-2 * Log(dblX1)) * Sin(2 * dblPi * dblX2) * dblSD#) + dblMean#
  
330:   dblSeed = dblRand2
  

  Exit Sub
ErrorHandler:
  HandleError True, "MakeRandomNormal " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Public Function ReturnHistStatsFromDouble(pDouble As esriSystem.IDoubleArray, _
            Optional pCounts As esriSystem.IDoubleArray, _
            Optional booVariance As Boolean = False, _
            Optional booIsSample As Boolean = False, _
            Optional booReturnSortedArray As Boolean = False, _
            Optional strName As String = "Statistics") As esriSystem.IVariantArray
  On Error GoTo ErrorHandler

    
  Dim dblVals() As Double
  Dim lngIndex As Long
  Dim lngCount As Long
  Dim dblWeight As Double
  
  Dim booHasWeight As Boolean
353:   booHasWeight = Not pCounts Is Nothing
  
355:   lngCount = pDouble.Count - 1
  ReDim dblVals(lngCount)
  
358:   If booHasWeight Then
    Dim dblWeightArray() As Double
    ReDim dblWeightArray(lngCount)
361:     For lngIndex = 0 To lngCount
362:       dblVals(lngIndex) = pDouble.Element(lngIndex)
363:       dblWeightArray(lngIndex) = pCounts.Element(lngIndex)
364:     Next lngIndex
    
    ' SORT VALUES
367:     QuickSort.DoubleAscendingWithSizes dblVals, dblWeightArray, 0, lngCount
368:   Else
369:     dblWeight = 1
370:     For lngIndex = 0 To lngCount
371:       dblVals(lngIndex) = pDouble.Element(lngIndex)
372:     Next lngIndex
    
    ' SORT VALUES
375:     QuickSort.DoubleAscending dblVals, 0, lngCount
376:   End If
    
  ' ASSUMES ARRAY IS SORTED!!!! --------------------------------------
  Dim theSum As Double
  Dim theCount As Double
  Dim theMinimum As Double
  Dim theMaximum As Double
  Dim theMean As Double
  Dim theSumSqDev As Double
  Dim theSqDev As Double
  Dim theMedian As Double
  Dim theVariance As Double
  Dim theStDev As Double
  Dim theStErrMean As Double
  Dim theRange As Double
  Dim dblSumSquaredWeights As Double
  Dim dblCheckVal As Double
  Dim dblHalfCount As Double         ' FOR MEDIAN WHEN USING WEIGHTED VALUES
  Dim booFoundMedian As Boolean      ' FOR MEDIAN WHEN USING WEIGHTED VALUES
  Dim dblRunningCountTotal As Double ' FOR MEDIAN WHEN USING WEIGHTED VALUES
  
397:   booFoundMedian = False
  
  ' MAKE ARRAYS TO RETURN
  Dim pReturnArray As esriSystem.IDoubleArray
  Dim pCountArray As esriSystem.IDoubleArray  ' "Counts" might be <1 nor non-integer if they are feature lengths or areas
  Dim pResponse As esriSystem.IDoubleArray
  
404:   Set pReturnArray = New esriSystem.DoubleArray
405:   Set pCountArray = New esriSystem.DoubleArray
406:   Set pResponse = New esriSystem.DoubleArray
  
  Dim dblCounter As Long
  Dim dblTestVal As Double
  
411:   If lngCount = 0 Then
  
413:     pResponse.Add -999
414:     pResponse.Add -999
415:     pResponse.Add -999
416:     pResponse.Add -999
417:     pResponse.Add -999
418:     pResponse.Add -999
419:     pResponse.Add -999
420:     pResponse.Add -999
421:     pResponse.Add -999
422:     pResponse.Add -999
423:     pResponse.Add -999   ' FOR dblTrueCount
  
425:   Else
  
427:     dblTestVal = dblVals(0)
428:     If booHasWeight Then
429:       dblCounter = dblWeightArray(0)
430:     Else
431:       dblCounter = 1
432:     End If
433:     theMinimum = dblVals(0)
434:     theMaximum = dblVals(UBound(dblVals))
435:     theRange = theMaximum - theMinimum
436:     theSum = dblTestVal
437:     theCount = dblCounter
438:     dblSumSquaredWeights = dblCounter ^ 2
'     theCount = lngCount + 1         ' ARRAY INDEX STARTS AT 0
    
441:     If lngCount > 1 Then
    
      '  PASS 1:  MINIMUM, MAXIMUM HISTOGRAM ARRAYS AND SUM --------------------------------------------------
444:       For lngIndex = 1 To lngCount
445:         dblCheckVal = dblVals(lngIndex)
446:         If booHasWeight Then
447:           dblWeight = dblWeightArray(lngIndex)  ' OTHERWISE WEIGHT DEFAULTS TO 1
448:           dblSumSquaredWeights = dblSumSquaredWeights + (dblWeight ^ 2)
449:         End If
          
        ' BUILD HISTOGRAM ARRAYS
452:         If dblTestVal = dblCheckVal Then
453:           dblCounter = dblCounter + dblWeight
454:         Else
455:           pReturnArray.Add dblTestVal
456:           pCountArray.Add dblCounter
457:           dblTestVal = dblCheckVal
458:           dblCounter = dblWeight
459:         End If
        
        ' GENERAL STATS
462:         theSum = theSum + (dblCheckVal * dblWeight)
463:         theCount = theCount + dblWeight
464:       Next lngIndex
      
      ' FOR HISTOGRAM ARRAYS, ADD LAST VALUE
467:       pReturnArray.Add dblTestVal
468:       pCountArray.Add dblCounter
      
      ' FOR GENERAL STATS
471:       theMean = theSum / theCount
472:       dblHalfCount = theCount / 2
473:       dblRunningCountTotal = 0
      
      '  PASS 2:  STANDARD DEVIATION AND VARIANCE --------------------------------------------------
476:       If booVariance Then
477:         For lngIndex = 0 To lngCount
                    
479:           dblCheckVal = dblVals(lngIndex)
          
481:           If booHasWeight Then
482:             dblWeight = dblWeightArray(lngIndex)
483:             theSqDev = dblWeight * ((dblCheckVal - theMean) ^ 2)
484:             If Not booFoundMedian Then
485:               dblRunningCountTotal = dblRunningCountTotal + dblWeight
486:               If dblRunningCountTotal >= dblHalfCount Then
487:                 booFoundMedian = True
488:                 theMedian = dblCheckVal
489:               End If
490:             End If
491:           Else
492:             theSqDev = (dblCheckVal - theMean) ^ 2
493:           End If
          
495:           theSumSqDev = theSqDev + theSumSqDev
496:         Next lngIndex
497:       Else
498:         theSqDev = 0
499:         theSumSqDev = 0
500:       End If
      
502:       If booHasWeight Then
        ' THEN MEDIAN IS CALCULATED UP IN PASS 2
504:       Else
505:         If theCount Mod 2 = 0 Then      ' EVEN NUMBER
506:           theMedian = (dblVals((theCount / 2) - 1) + dblVals(theCount / 2)) / 2
507:         Else
508:           theMedian = dblVals((theCount - 1) / 2)
509:         End If
510:       End If
      
512:       If booHasWeight Then
513:         If booIsSample Then
          ' FROM http://en.wikipedia.org/wiki/Weighted_standard_deviation#Weighted_sample_variance
          ' FROM http://pygsl.sourceforge.net/reference/pygsl/node36.html
516:           theVariance = (theCount / ((theCount ^ 2) - dblSumSquaredWeights)) * theSumSqDev
517:         Else
          ' FROM http://en.wikipedia.org/wiki/Weighted_standard_deviation#Weighted_sample_variance
519:           theVariance = theSumSqDev / theCount
520:         End If
521:       Else
522:         If booIsSample Then
523:           theVariance = theSumSqDev / (theCount - 1)
524:         Else
525:           theVariance = theSumSqDev / theCount
526:         End If
527:       End If
      
529:       theStDev = Sqr(theVariance)
530:       theStErrMean = theStDev / (Sqr(theCount))
      
532:     Else
533:       pReturnArray.Add dblTestVal
534:       pCountArray.Add 1
      
536:       theMean = dblTestVal
537:       theMedian = dblTestVal
538:       theVariance = 0
539:       theStDev = 0
540:       theStErrMean = 0
      
542:     End If
      
544:     pResponse.Add theSum
545:     pResponse.Add theMean
546:     pResponse.Add theMinimum
547:     pResponse.Add theMaximum
548:     pResponse.Add theRange
549:     pResponse.Add theCount
550:     pResponse.Add theStDev
551:     pResponse.Add theVariance
552:     pResponse.Add theMedian
553:     pResponse.Add theStErrMean
    
555:   End If
  
557:   Set ReturnHistStatsFromDouble = New esriSystem.VarArray
558:   ReturnHistStatsFromDouble.Add pReturnArray
559:   ReturnHistStatsFromDouble.Add pCountArray
560:   ReturnHistStatsFromDouble.Add pResponse
561:   If booReturnSortedArray Then
562:     ReturnHistStatsFromDouble.Add dblVals
563:   Else
564:     ReturnHistStatsFromDouble.Add -999
565:   End If
566:   ReturnHistStatsFromDouble.Add strName
  

  Exit Function
ErrorHandler:
  HandleError True, "ReturnHistStatsFromDouble " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function
Public Function ReplaceBadChars(strName As String, Optional booReplacePeriod As Boolean = False, _
    Optional booReplaceBackSlash As Boolean = False, Optional booReplaceSpace As Boolean = True, _
    Optional booStartWithLetter As Boolean = False) As String
  On Error GoTo ErrorHandler

578:   If strName = "" Then
579:     ReplaceBadChars = "z"
580:   Else
    Dim strAcceptable As String
582:     strAcceptable = "abcdefghijklmnopqrstuvwxyz0123456789_"
583:     If Not booReplacePeriod Then strAcceptable = strAcceptable & "."
584:     If Not booReplaceBackSlash Then strAcceptable = strAcceptable & "\"
585:     If Not booReplaceSpace Then strAcceptable = strAcceptable & " "
    
    Dim strOutput As String
588:     strOutput = strName
    Dim lngIndex As Long
    Dim strChar As String
591:     For lngIndex = 1 To Len(strOutput)
592:       strChar = Mid(strOutput, lngIndex, 1)
593:       If InStr(1, strAcceptable, strChar, vbTextCompare) = 0 Then
594:         strOutput = Replace(strOutput, strChar, "_")
595:       End If
596:     Next lngIndex
597:     If booStartWithLetter Then
      Dim strLetters As String
599:       strLetters = "abcdefghijklmnopqrstuvwxyz"
600:       If InStr(1, strLetters, Left(strOutput, 1), vbTextCompare) = 0 Then
601:         strOutput = "z" & strOutput
602:       End If
603:     End If
604:     ReplaceBadChars = strOutput
605:   End If


  Exit Function
ErrorHandler:
  HandleError True, "ReplaceBadChars " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function CreateGeneralTable(Optional strDir As String = "", Optional strName As String = "", _
    Optional lngCategory As JenDatasetTypes = ENUM_Shapefile, Optional pAddFields As esriSystem.IVariantArray, _
    Optional strGxDialogCaption As String = "Specify New Table Name:") As ITable
  On Error GoTo ErrorHandler

  ' IF booIsFClass = FALSE, THEN THIS FUNCTION WILL CREATE A TABLE INSTEAD
  
  ' THIS FUNCTION ONLY ALLOWS YOU TO WRITE TO A FEATURE DATASET IF IT FORCES USER TO SELECT FEATURE DATASET WITH IGxCatalog.
  ' IF YOU SEND A SPECIFIC PATHNAME AND FILENAME, THIS FUNCTION WILL NOT ALLOW YOU TO SAVE TO A FEATURE DATASET.
  
  Dim pGxDataset As IGxDataset
  Dim pDataset As IDataset
  Dim pWorkspace As IWorkspace
  Dim pFeatureClassName As IFeatureClassName
  Dim pFeatureDatasetName As IName
  Dim pFeatureDataset As IFeatureDataset
  Dim booHasFeatureDataset As Boolean
  Dim strFeatDataset As String
  Dim strPath As String
  Dim strCategory As String
  Dim strParent As String
  Dim strBaseName As String
  Dim pFeatWS As IFeatureWorkspace
  Dim pWsFact As IWorkspaceFactory2
  Dim pTableName As String
  Dim pTable As ITable
  Dim strWsPathname As String
  Dim pGxObj As IGxObject
  Dim pGxDialog As IGxDialog
  Dim pGxFCFilter As IGxObjectFilter
  Dim pFilterCol As IGxObjectFilterCollection

  ' CHECK IF TABLE ALREADY EXISTS
  Dim booAlreadyExists As Boolean
647:   booAlreadyExists = True
  Dim lngResponse As VbMsgBoxResult
  
650:   Do Until booAlreadyExists = False
     
    ' FIRST, CHECK IF DIRECTORY, NAME AND CATEGORY ARE SPECIFIED
653:     If strDir <> "" And strName <> "" Then
      
      Select Case lngCategory
        Case ENUM_Shapefile
657:           strCategory = "Shapefile"
658:           strName = TopoCorridor.aml_func_mod.SetExtension(strName, "dbf")
659:           If Right(strDir, 1) <> "\" Then strDir = strDir & "\"
        Case ENUM_FileGDB
661:           strCategory = "File Geodatabase Feature Class"
        Case ENUM_PersonalGDB
663:           strCategory = "Personal Geodatabase Feature Class"
        Case Else
665:           MsgBox "PROBLEM:  This function can only create dBASE Tables, File GeoDatabase Tables, or " & vbCrLf & _
              "Personal GeoDatabase Tables.  Bailing out...", vbOKOnly, "Invalid Output Type:"
667:           Set CreateGeneralTable = Nothing
          Exit Function
669:       End Select
      
671:       strWsPathname = strDir
672:       booHasFeatureDataset = False
673:       strBaseName = strName
674:       booHasFeatureDataset = False
675:       strFeatDataset = ""
676:     Else
    
 '     If pGxObj Is Nothing Or IsMissing(pGxObj) Then  ' IF NEED TO ASK USER TO SPECIFY GxObject
      
680:       Set pGxDialog = New GxDialog
681:       Set pGxFCFilter = New GxFilterTables
      
683:       Set pFilterCol = pGxDialog
684:       pFilterCol.AddFilter pGxFCFilter, True
685:       pGxDialog.Title = strGxDialogCaption
686:       pGxDialog.AllowMultiSelect = False
687:       pGxDialog.ButtonCaption = "Enter"
        
689:       If Not pGxDialog.DoModalSave(0) Then
690:           Set CreateGeneralTable = Nothing
          Exit Function 'Exit if user press Cancel
692:       End If
      
694:       Set pGxObj = pGxDialog.FinalLocation
695:       strWsPathname = pGxObj.FullName
696:       strBaseName = pGxDialog.Name
    
 '     End If
  
  '    Dim pGxCat As IGxCatalog
  '    Set pGxCat = pGxDialog.InternalCatalog
  
      ' CHECK TO SEE IF WE ARE WRITING TO A FEATURE DATASET
704:       If TypeOf pGxObj Is IGxDataset Then
705:         Set pGxDataset = pGxObj
          
707:         Set pDataset = pGxDataset.Dataset
708:         Set pWorkspace = pDataset.Workspace
709:         strWsPathname = pWorkspace.PathName
      
711:         Set pFeatureDatasetName = pDataset.FullName
        
713:         booHasFeatureDataset = TypeOf pDataset Is IFeatureDataset
714:         If booHasFeatureDataset Then
715:           Set pGxObj = pGxObj.Parent  ' BACK OUT IF FEATURE DATASET IF WE ARE IN ONE
716:         End If
717:       End If
      
719:       strCategory = pGxObj.Category
720:     End If
    
    ' NOW WE KNOW NAME, CATEGORY AND WORKSPACE.  NEXT CREATE WORKSPACE FACTORY
    Select Case strCategory
       Case "Shapefile", "Folder", "dBASE Table"
725:          Set pWsFact = New ShapefileWorkspaceFactory
726:          pTableName = strBaseName
       Case "File Geodatabase Feature Class", "File Geodatabase Raster Catalog", _
           "File Geodatabase", "File Geodatabase Feature Dataset", "File Geodatabase Table"
729:          Set pWsFact = New FileGDBWorkspaceFactory
730:          pTableName = strBaseName
       Case "Personal Geodatabase Feature Class", "Personal Geodatabase Raster Catalog", _
           "Personal Geodatabase", "Personal Geodatabase Feature Dataset", _
           "Personal Geodatabase Table"
734:          Set pWsFact = New AccessWorkspaceFactory
735:          pTableName = strBaseName
'       Case "Polygon Feature Class", "Arc Feature Class", "Point Feature Class", "Route Feature Class", _
'            "Tic Feature Class", "Region Feature Class", "Label Feature Class"
'         Set pWSFact = New ArcInfoWorkspaceFactory
'         If booHasFeatureDataset Then
'           pTableName = strFeatDataset & ":" & strBaseName
'         Else
'           pTableName = strBaseName
'         End If
'       Case "SDC Feature Class"
'         Set pWSFact = New SDCWorkspaceFactory
'         If booHasFeatureDataset Then
'           pTableName = strFeatDataset & ":" & strBaseName
'         Else
'           pTableName = strBaseName
'         End If
       Case Else
752:          MsgBox "Unexpected Workspace Type (" & strCategory & ")!  Need to write new code for this..."
753:          Set CreateGeneralTable = Nothing
         Exit Function
755:     End Select
    
  '  Debug.Print "Full Name = " & strPath & vbCrLf & "Name = " & strName & vbCrLf & _
        "Base Name = " & strBaseName & vbCrLf & "Category = " & strCategory & vbCrLf & "Parent = " & strParent & _
        vbCrLf & "Show String = " & strShowString & vbCrLf & "Save String = " & strSaveString & vbCrLf & _
        "Workspace Pathname = " & pWorkspace.PathName
     
    ' FOR DEBUGGING
  '  Dim frmReportForm As EcoAir_Map.frmReportDialog
  '  Beep
  '  Set frmReportForm = New EcoAir_Map.frmReportDialog
  '  frmReportForm.txtReport.Text = strWsPathName & vbCrLf & strCategory & vbCrLf & pTableName
  '  frmReportForm.Show vbModal
  '  Set frmReportForm = Nothing
  '  MsgBox strWsPathname & vbCrLf & strCategory & vbCrLf & lngCategory
770:     If Right(strWsPathname, 1) = "\" Or Right(strWsPathname, 1) = "/" Then
771:       strWsPathname = Left(strWsPathname, Len(strWsPathname) - 1)
772:     End If
773:     Set pFeatWS = pWsFact.OpenFromFile(strWsPathname, 0)
        
775:     booAlreadyExists = CheckIfTableExists(pFeatWS, strBaseName)
776:     If booAlreadyExists Then
777:       lngResponse = MsgBox("The Table '" & pTableName & "' already exists!  Do you wish to overwrite it?", _
            vbYesNo, "Table Already Exists:")
779:       If lngResponse = vbYes Then
        ' DELETE FEATURE CLASS
        Dim pDelete As ITable
        Dim pDelDataset As IDataset
783:         Set pDelete = pFeatWS.OpenTable(strBaseName)
784:         Set pDelDataset = pDelete
785:         If pDelDataset.CanDelete Then
786:           pDelDataset.DELETE
787:         Else
788:           MsgBox "Unable to delete " & pDataset.Name & "!  Bailing out..."
789:           Set CreateGeneralTable = Nothing
          Exit Function
791:         End If
792:         booAlreadyExists = CheckIfTableExists(pFeatWS, strBaseName)
793:       Else
794:         Set CreateGeneralTable = Nothing
795:         Set pGxObj = Nothing
796:         strName = ""
797:       End If
798:     End If
799:   Loop
  
  ' NOW READY TO CREATE TABLE
802:   If strCategory = "Shapefile" Or strCategory = "Folder" Or strCategory = "dBASE Table" Then      ' IF dBASE TABLE
803:     Set pTable = CreatedBASETableInFolder(strWsPathname, strBaseName, pAddFields)
804:   Else                                                                                            ' IF IN FILE OR PERSONAL GEODATABASE
805:     Set pTable = CreateGDBTable(pFeatWS, strBaseName, pAddFields)
806:   End If
  
808:   Set CreateGeneralTable = pTable
  

  Exit Function
ErrorHandler:
  HandleError True, "CreateGeneralTable " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function CreateGeneralTableMahal(Optional strDir As String = "", Optional strName As String = "", _
    Optional lngCategory As JenDatasetTypes = ENUM_Shapefile, Optional pAddFields As esriSystem.IVariantArray, _
    Optional strGxDialogCaption As String = "Specify New Table Name:", _
    Optional booMakeUniqueIDField As Boolean = True) As ITable
  
  On Error GoTo ErrorHandler

  ' IF booIsFClass = FALSE, THEN THIS FUNCTION WILL CREATE A TABLE INSTEAD
  
  ' THIS FUNCTION ONLY ALLOWS YOU TO WRITE TO A FEATURE DATASET IF IT FORCES USER TO SELECT FEATURE DATASET WITH IGxCatalog.
  ' IF YOU SEND A SPECIFIC PATHNAME AND FILENAME, THIS FUNCTION WILL NOT ALLOW YOU TO SAVE TO A FEATURE DATASET.
  
  Dim pGxDataset As IGxDataset
  Dim pDataset As IDataset
  Dim pWorkspace As IWorkspace
  Dim pFeatureClassName As IFeatureClassName
  Dim pFeatureDatasetName As IName
  Dim pFeatureDataset As IFeatureDataset
  Dim booHasFeatureDataset As Boolean
  Dim strFeatDataset As String
  Dim strPath As String
  Dim strCategory As String
  Dim strParent As String
  Dim strBaseName As String
  Dim pFeatWS As IFeatureWorkspace
  Dim pWsFact As IWorkspaceFactory2
  Dim pTableName As String
  Dim pTable As ITable
  Dim strWsPathname As String
  Dim pGxObj As IGxObject
  Dim pGxDialog As IGxDialog
  Dim pGxFCFilter As IGxObjectFilter
  Dim pFilterCol As IGxObjectFilterCollection

  ' CHECK IF TABLE ALREADY EXISTS
  Dim booAlreadyExists As Boolean
852:   booAlreadyExists = True
  Dim lngResponse As VbMsgBoxResult
  
855:   Do Until booAlreadyExists = False
     
    ' FIRST, CHECK IF DIRECTORY, NAME AND CATEGORY ARE SPECIFIED
858:     If strDir <> "" And strName <> "" Then
      
      Select Case lngCategory
        Case ENUM_Shapefile
862:           strCategory = "Shapefile"
863:           strName = TopoCorridor.aml_func_mod.SetExtension(strName, "dbf")
864:           If Right(strDir, 1) <> "\" Then strDir = strDir & "\"
        Case ENUM_FileGDB
866:           strCategory = "File Geodatabase Feature Class"
        Case ENUM_PersonalGDB
868:           strCategory = "Personal Geodatabase Feature Class"
        Case Else
870:           MsgBox "PROBLEM:  This function can only create dBASE Tables, File GeoDatabase Tables, or " & vbCrLf & _
              "Personal GeoDatabase Tables.  Bailing out...", vbOKOnly, "Invalid Output Type:"
872:           Set CreateGeneralTableMahal = Nothing
          Exit Function
874:       End Select
      
876:       strWsPathname = strDir
877:       booHasFeatureDataset = False
878:       strBaseName = strName
879:       booHasFeatureDataset = False
880:       strFeatDataset = ""
881:     Else
    
 '     If pGxObj Is Nothing Or IsMissing(pGxObj) Then  ' IF NEED TO ASK USER TO SPECIFY GxObject
      
885:       Set pGxDialog = New GxDialog
886:       Set pGxFCFilter = New GxFilterTables
      
888:       Set pFilterCol = pGxDialog
889:       pFilterCol.AddFilter pGxFCFilter, True
890:       pGxDialog.Title = strGxDialogCaption
891:       pGxDialog.AllowMultiSelect = False
892:       pGxDialog.ButtonCaption = "Enter"
        
894:       If Not pGxDialog.DoModalSave(0) Then
895:           Set CreateGeneralTableMahal = Nothing
          Exit Function 'Exit if user press Cancel
897:       End If
      
899:       Set pGxObj = pGxDialog.FinalLocation
900:       strWsPathname = pGxObj.FullName
901:       strBaseName = pGxDialog.Name
    
 '     End If
  
  '    Dim pGxCat As IGxCatalog
  '    Set pGxCat = pGxDialog.InternalCatalog
  
      ' CHECK TO SEE IF WE ARE WRITING TO A FEATURE DATASET
909:       If TypeOf pGxObj Is IGxDataset Then
910:         Set pGxDataset = pGxObj
          
912:         Set pDataset = pGxDataset.Dataset
913:         Set pWorkspace = pDataset.Workspace
914:         strWsPathname = pWorkspace.PathName
      
916:         Set pFeatureDatasetName = pDataset.FullName
        
918:         booHasFeatureDataset = TypeOf pDataset Is IFeatureDataset
919:         If booHasFeatureDataset Then
920:           Set pGxObj = pGxObj.Parent  ' BACK OUT IF FEATURE DATASET IF WE ARE IN ONE
921:         End If
922:       End If
      
924:       strCategory = pGxObj.Category
925:     End If
    
    ' NOW WE KNOW NAME, CATEGORY AND WORKSPACE.  NEXT CREATE WORKSPACE FACTORY
    Select Case strCategory
       Case "Shapefile", "Folder", "dBASE Table"
930:          Set pWsFact = New ShapefileWorkspaceFactory
931:          pTableName = strBaseName
       Case "File Geodatabase Feature Class", "File Geodatabase Raster Catalog", _
           "File Geodatabase", "File Geodatabase Feature Dataset", "File Geodatabase Table"
934:          Set pWsFact = New FileGDBWorkspaceFactory
935:          pTableName = strBaseName
       Case "Personal Geodatabase Feature Class", "Personal Geodatabase Raster Catalog", _
           "Personal Geodatabase", "Personal Geodatabase Feature Dataset", _
           "Personal Geodatabase Table"
939:          Set pWsFact = New AccessWorkspaceFactory
940:          pTableName = strBaseName
'       Case "Polygon Feature Class", "Arc Feature Class", "Point Feature Class", "Route Feature Class", _
'            "Tic Feature Class", "Region Feature Class", "Label Feature Class"
'         Set pWSFact = New ArcInfoWorkspaceFactory
'         If booHasFeatureDataset Then
'           pTableName = strFeatDataset & ":" & strBaseName
'         Else
'           pTableName = strBaseName
'         End If
'       Case "SDC Feature Class"
'         Set pWSFact = New SDCWorkspaceFactory
'         If booHasFeatureDataset Then
'           pTableName = strFeatDataset & ":" & strBaseName
'         Else
'           pTableName = strBaseName
'         End If
       Case Else
957:          MsgBox "Unexpected Workspace Type (" & strCategory & ")!  Need to write new code for this..."
958:          Set CreateGeneralTableMahal = Nothing
         Exit Function
960:     End Select
    
  '  Debug.Print "Full Name = " & strPath & vbCrLf & "Name = " & strName & vbCrLf & _
        "Base Name = " & strBaseName & vbCrLf & "Category = " & strCategory & vbCrLf & "Parent = " & strParent & _
        vbCrLf & "Show String = " & strShowString & vbCrLf & "Save String = " & strSaveString & vbCrLf & _
        "Workspace Pathname = " & pWorkspace.PathName
     
    ' FOR DEBUGGING
  '  Dim frmReportForm As EcoAir_Map.frmReport_modal
  '  Beep
  '  Set frmReportForm = New EcoAir_Map.frmReport_modal
  '  frmReportForm.txtReport.Text = strWsPathName & vbCrLf & strCategory & vbCrLf & pTableName
  '  frmReportForm.Show vbModal
  '  Set frmReportForm = Nothing
  '  MsgBox strWsPathname & vbCrLf & strCategory & vbCrLf & lngCategory
975:     Set pFeatWS = pWsFact.OpenFromFile(strWsPathname, 0)
        
977:     booAlreadyExists = CheckIfTableExists(pFeatWS, strBaseName)
978:     If booAlreadyExists Then
979:       lngResponse = MsgBox("The Table '" & pTableName & "' already exists!  Do you wish to overwrite it?", _
            vbYesNo, "Table Already Exists:")
981:       If lngResponse = vbYes Then
        ' DELETE FEATURE CLASS
        Dim pDelete As ITable
        Dim pDelDataset As IDataset
985:         Set pDelete = pFeatWS.OpenTable(strBaseName)
986:         Set pDelDataset = pDelete
987:         If pDelDataset.CanDelete Then
988:           pDelDataset.DELETE
989:         Else
990:           MsgBox "Unable to delete " & pDataset.Name & "!  Bailing out..."
991:           Set CreateGeneralTableMahal = Nothing
          Exit Function
993:         End If
994:         booAlreadyExists = CheckIfTableExists(pFeatWS, strBaseName)
995:       Else
996:         Set CreateGeneralTableMahal = Nothing
997:         Set pGxObj = Nothing
998:         strName = ""
999:       End If
1000:     End If
1001:   Loop
  
  ' NOW READY TO CREATE TABLE
1004:   If strCategory = "Shapefile" Or strCategory = "Folder" Or strCategory = "dBASE Table" Then      ' IF dBASE TABLE
1005:     Set pTable = CreatedBASETableInFolderMahal(strWsPathname, strBaseName, pAddFields, booMakeUniqueIDField)
1006:   Else                                                                                            ' IF IN FILE OR PERSONAL GEODATABASE
1007:     Set pTable = CreateGDBTableMahal(pFeatWS, strBaseName, pAddFields, , , , booMakeUniqueIDField)
1008:   End If
  
1010:   Set CreateGeneralTableMahal = pTable
  

  Exit Function
ErrorHandler:
  HandleError True, "CreateGeneralTableMahal " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function CreateGDBTableMahal(featWorkspace As IFeatureWorkspace, _
                                            Name As String, _
                                            Optional pAddFields As esriSystem.IVariantArray, _
                                            Optional pCLSID As UID, _
                                            Optional pCLSEXT As UID, _
                                            Optional ConfigWord As String = "", _
                                            Optional booMakeUniqueIDField As Boolean = True _
                                            ) As ITable
  On Error GoTo ErrorHandler
 
'' createWorkspaceFeatureClass: simple helper to create a featureclass in a geodatabase workspace.
'' NOTE: when creating a feature class in a workspace it is important to assign the spatial
''       reference to the geometry field.
'' MODIFIED BY JENNESS APRIL 23 2008 FROM ESRI SAMPLE
  
1033:   Set CreateGDBTableMahal = Nothing
  If featWorkspace Is Nothing Then Exit Function
  If Name = "" Then Exit Function
  
1037:   If (pCLSID Is Nothing) Or IsMissing(pCLSID) Then
1038:     Set pCLSID = Nothing
1039:     Set pCLSID = New UID
1040:     pCLSID.Value = "esriGeoDatabase.Object"
1041:   End If
  
  ' CREATE OBJECT ID FIELD; ADD ANY REQUESTED FIELDS IF NECESSARY
  ' establish a fields collection
  Dim pFields As IFields
  Dim pFieldsEdit As IFieldsEdit
  Dim pGeomDef As IGeometryDef
  Dim pGeomDefEdit As IGeometryDefEdit
  Dim pField As IField
  Dim pFieldEdit As IFieldEdit
  
1052:   Set pFields = New Fields
1053:   Set pFieldsEdit = pFields
  
  '' create the object id field
1056:   Set pField = New Field
1057:   Set pFieldEdit = pField
1058:   pFieldEdit.Name = "Object_ID"
 '   pFieldEdit.AliasName = "object identifier"
1060:   pFieldEdit.Type = esriFieldTypeOID
1061:   pFieldsEdit.AddField pField
 
  ' ADD FIELDS IF REQUESTED
1064:   If Not (pAddFields Is Nothing Or IsMissing(pAddFields)) Then
    Dim lngIndex As Long
1066:     For lngIndex = 0 To pAddFields.Count - 1
1067:       pFieldsEdit.AddField pAddFields.Element(lngIndex)
1068:     Next lngIndex
1069:   End If
  
  ' establish the class extension
1072:   If (pCLSEXT Is Nothing) Or IsMissing(pCLSEXT) Then
1073:     Set pCLSEXT = Nothing
1074:   End If
  
1076:   Set CreateGDBTableMahal = featWorkspace.CreateTable(Name, pFields, pCLSID, pCLSEXT, "")
    
  Exit Function
ErrorHandler:
  HandleError True, "CreateGDBTableMahal " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function CreatedBASETableInFolderMahal(sPath As String, sName As String, Optional pAddFields As esriSystem.IVariantArray, _
    Optional booMakeUniqueIDField As Boolean = True) As ITable
  On Error GoTo ErrorHandler
  
1087:   If Right(sPath, 4) = ".dbf" Then sPath = ReturnDir(sPath)
1088:   If Right(sName, 4) = ".dbf" Then sName = Left(sName, Len(sName) - 4)
  
  ' Open the folder to contain the shapefile as a workspace
  Dim pFWS As IFeatureWorkspace
  Dim pWorkspaceFactory As IWorkspaceFactory
1093:   Set pWorkspaceFactory = New ShapefileWorkspaceFactory
  
1095:   If Not ExistFileDir(sPath) Then
1096:     MsgBox "Unable to create dBASE Table:" & vbCrLf & _
           sPath & " is not a valid workspace...", , "Failed to Create Table:"
1098:     Set CreatedBASETableInFolderMahal = Nothing
    Exit Function
1100:   End If
  
1102:   Set pFWS = pWorkspaceFactory.OpenFromFile(sPath, 0)
  
'   Set up a simple fields collection
  Dim pFields As IFields
  Dim pFieldsEdit As IFieldsEdit
1107:   Set pFields = New Fields
1108:   Set pFieldsEdit = pFields

  Dim pField As IField
  Dim pFieldEdit As IFieldEdit
  
1113:   If booMakeUniqueIDField Then
1114:     Set pField = New Field
1115:     Set pFieldEdit = pField
1116:     With pFieldEdit
1117:         .Precision = 8
1118:         .Name = "Unique_ID"
1119:         .Type = esriFieldTypeInteger
1120:     End With
1121:     pFieldsEdit.AddField pField
1122:   End If
  
  ' ADD FIELDS IF REQUESTED
1125:   If Not (pAddFields Is Nothing Or IsMissing(pAddFields)) Then
    Dim lngIndex As Long
1127:     For lngIndex = 0 To pAddFields.Count - 1
1128:       pFieldsEdit.AddField pAddFields.Element(lngIndex)
1129:     Next lngIndex
1130:   End If
    
  ' Create the dBASE Table
  ' (some parameters apply to geodatabase options and can be defaulted as Nothing)
  Dim booFileExists As Boolean
  Dim strCheckString As String
1136:   If Right(sPath, 1) = "\" Then
1137:     strCheckString = sPath & sName & ".dbf"
'    MsgBox sPath & sName & ".dbf" & vbCrLf & "File Exists? " & CStr(Dir(sPath & sName & ".dbf") <> "")
1139:   Else
1140:     strCheckString = sPath & "\" & sName & ".dbf"
'    MsgBox sPath & "\" & sName & ".dbf" & vbCrLf & "File Exists? " & CStr(Dir(sPath & "\" & sName & ".dbf") <> "")
1142:   End If
  
1144:   booFileExists = (Dir(strCheckString) <> "")
  
1146:   If booFileExists Then
1147:     MsgBox "The following file already exists:" & vbCrLf & vbCrLf & strCheckString & vbCrLf & vbCrLf & _
           "Please select a new filename...", , "Duplicate Filename:"
1149:     Set CreatedBASETableInFolderMahal = Nothing
    Exit Function
1151:   End If
  
  Dim pTable As ITable
1154:   Set pTable = pFWS.CreateTable(sName, pFields, Nothing, Nothing, "")
  
1156:   Set CreatedBASETableInFolderMahal = pTable
  
  Exit Function
ErrorHandler:
  HandleError True, "CreatedBASETableInFolderMahal " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function
Public Function CreateGeneralFeatureClass(pGeomType As esriGeometryType, pSpatialReference As ISpatialReference, _
    Optional strDir As String = "", Optional strName As String = "", Optional lngCategory As JenDatasetTypes = ENUM_Shapefile, _
    Optional pAddFields As esriSystem.IVariantArray, Optional strGxDialogCaption As String = "Specify New Feature Class Name:", _
    Optional booIsInFeatureDataset As Boolean = False, Optional strFeatureDatasetName As String, _
    Optional booIsFClass As Boolean = True, Optional booForceUniqueIDField As Boolean = True, _
    Optional pExtent As IEnvelope, Optional lngOriginalRecCount As Long = -9999) As IFeatureClass
  On Error GoTo ErrorHandler

  ' IF booIsFClass = FALSE, THEN THIS FUNCTION WILL CREATE A TABLE INSTEAD
  
  ' THIS FUNCTION ONLY ALLOWS YOU TO WRITE TO A FEATURE DATASET IF IT FORCES USER TO SELECT FEATURE DATASET WITH IGxCatalog.
  ' IF YOU SEND A SPECIFIC PATHNAME AND FILENAME, THIS FUNCTION WILL NOT ALLOW YOU TO SAVE TO A FEATURE DATASET.
  
  Dim pGxDataset As IGxDataset
  Dim pDataset As IDataset
  Dim pWorkspace As IWorkspace
  Dim pFeatureClassName As IFeatureClassName
  Dim pFeatureDatasetName As IName
  Dim pFeatureDataset As IFeatureDataset
  Dim booHasFeatureDataset As Boolean
  Dim strFeatDataset As String
  Dim strPath As String
  Dim strCategory As String
  Dim strParent As String
  Dim strBaseName As String
  Dim pFeatWS As IFeatureWorkspace
  Dim pWsFact As IWorkspaceFactory2
  Dim pFClassName As String
  Dim pFClass As IFeatureClass
  Dim strWsPathname As String
  Dim pGxObj As IGxObject
  Dim pGxDialog As IGxDialog
  Dim pGxFCFilter As IGxObjectFilter
  Dim pFilterCol As IGxObjectFilterCollection

  ' CHECK IF FEATURECLASS ALREADY EXISTS
  Dim booAlreadyExists As Boolean
1199:   booAlreadyExists = True
  Dim lngResponse As VbMsgBoxResult
  
1202:   Do Until booAlreadyExists = False
     
    ' FIRST, CHECK IF DIRECTORY, NAME AND CATEGORY ARE SPECIFIED
1205:     If strDir <> "" And strName <> "" Then
      
      Select Case lngCategory
        Case ENUM_Shapefile
1209:           strCategory = "Shapefile"
1210:           strName = TopoCorridor.aml_func_mod.SetExtension(strName, "shp")
1211:           If Right(strDir, 1) <> "\" Then strDir = strDir & "\"
        Case ENUM_FileGDB
1213:           strCategory = "File Geodatabase Feature Class"
        Case ENUM_PersonalGDB
1215:           strCategory = "Personal Geodatabase Feature Class"
        Case Else
1217:           MsgBox "PROBLEM:  This function can only create shapefiles, file geodatabase feature classes, or " & vbCrLf & _
              "personal geodatabase feature classes.  Bailing out...", vbOKOnly, "Invalid Output Type:"
1219:           Set CreateGeneralFeatureClass = Nothing
          Exit Function
1221:       End Select
      
1223:       strWsPathname = strDir
1224:       booHasFeatureDataset = False
1225:       strBaseName = strName
1226:       booHasFeatureDataset = booIsInFeatureDataset
1227:       strFeatDataset = strFeatureDatasetName
1228:     Else
    
 '     If pGxObj Is Nothing Or IsMissing(pGxObj) Then  ' IF NEED TO ASK USER TO SPECIFY GxObject
      
1232:       Set pGxDialog = New GxDialog
1233:       Set pGxFCFilter = New GxFilterFeatureClasses
      
1235:       Set pFilterCol = pGxDialog
1236:       pFilterCol.AddFilter pGxFCFilter, True
1237:       pGxDialog.Title = strGxDialogCaption
1238:       pGxDialog.AllowMultiSelect = False
1239:       pGxDialog.ButtonCaption = "Enter"
        
1241:       If Not pGxDialog.DoModalSave(0) Then
1242:           Set CreateGeneralFeatureClass = Nothing
          Exit Function 'Exit if user press Cancel
1244:       End If
      
1246:       Set pGxObj = pGxDialog.FinalLocation
1247:       strWsPathname = pGxObj.FullName
1248:       strBaseName = pGxDialog.Name
    
 '     End If
  
  '    Dim pGxCat As IGxCatalog
  '    Set pGxCat = pGxDialog.InternalCatalog
  
      ' CHECK TO SEE IF WE ARE WRITING TO A FEATURE DATASET
1256:       If TypeOf pGxObj Is IGxDataset Then
1257:         Set pGxDataset = pGxObj
          
1259:         Set pDataset = pGxDataset.Dataset
1260:         Set pWorkspace = pDataset.Workspace
1261:         strWsPathname = pWorkspace.PathName
      
''        Set pFeatureClassName = pDataset.FullName
1264:         Set pFeatureDatasetName = pDataset.FullName
        
1266:         booHasFeatureDataset = TypeOf pDataset Is IFeatureDataset
1267:         If booHasFeatureDataset Then
1268:           Set pFeatureDataset = pDataset
1269:           strFeatDataset = pFeatureDataset.Name
1270:         End If
1271:       End If
          
'      strPath = pGxObj.FullName
1274:       strCategory = pGxObj.Category
'      strName = pGxObj.Name
'      strParent = pGxObj.Parent.FullName
'      strBaseName = pGxObj.BaseName
'      strWsPathName = pWorkspace.PathName
1279:     End If
    
    ' NOW WE KNOW NAME, CATEGORY AND WORKSPACE.  NEXT CREATE WORKSPACE FACTORY
    Select Case strCategory
       Case "Shapefile", "Folder"
1284:          Set pWsFact = New ShapefileWorkspaceFactory
1285:          pFClassName = strBaseName
       Case "File Geodatabase Feature Class", "File Geodatabase Raster Catalog", "File Geodatabase", "File Geodatabase Feature Dataset"
1287:          Set pWsFact = New FileGDBWorkspaceFactory
1288:          If booHasFeatureDataset Then
1289:            pFClassName = strFeatDataset & ":" & strBaseName
1290:          Else
1291:            pFClassName = strBaseName
1292:          End If
       Case "Personal Geodatabase Feature Class", "Personal Geodatabase Raster Catalog", "Personal Geodatabase", "Personal Geodatabase Feature Dataset"
1294:          Set pWsFact = New AccessWorkspaceFactory
1295:          If booHasFeatureDataset Then
1296:            pFClassName = strFeatDataset & ":" & strBaseName
1297:          Else
1298:            pFClassName = strBaseName
1299:          End If
'       Case "Polygon Feature Class", "Arc Feature Class", "Point Feature Class", "Route Feature Class", _
'            "Tic Feature Class", "Region Feature Class", "Label Feature Class"
'         Set pWSFact = New ArcInfoWorkspaceFactory
'         If booHasFeatureDataset Then
'           pFClassName = strFeatDataset & ":" & strBaseName
'         Else
'           pFClassName = strBaseName
'         End If
'       Case "SDC Feature Class"
'         Set pWSFact = New SDCWorkspaceFactory
'         If booHasFeatureDataset Then
'           pFClassName = strFeatDataset & ":" & strBaseName
'         Else
'           pFClassName = strBaseName
'         End If
       Case Else
1316:          MsgBox "Unexpected Feature Class Type (" & strCategory & ")!  Need to write new code for this..."
1317:          Set CreateGeneralFeatureClass = Nothing
         Exit Function
1319:     End Select
    
  '  Debug.Print "Full Name = " & strPath & vbCrLf & "Name = " & strName & vbCrLf & _
        "Base Name = " & strBaseName & vbCrLf & "Category = " & strCategory & vbCrLf & "Parent = " & strParent & _
        vbCrLf & "Show String = " & strShowString & vbCrLf & "Save String = " & strSaveString & vbCrLf & _
        "Workspace Pathname = " & pWorkspace.PathName
     
    ' FOR DEBUGGING
  '  Dim frmReportForm As EcoAir_Map.frmReport_modal
  '  Beep
  '  Set frmReportForm = New EcoAir_Map.frmReport_modal
  '  frmReportForm.txtReport.Text = strWsPathName & vbCrLf & strCategory & vbCrLf & pFClassName
  '  frmReportForm.Show vbModal
  '  Set frmReportForm = Nothing
  '  MsgBox strWsPathname & vbCrLf & strCategory & vbCrLf & lngCategory
1334:     If Right(strWsPathname, 1) = "\" Or Right(strWsPathname, 1) = "/" Then
1335:       strWsPathname = Left(strWsPathname, Len(strWsPathname) - 1)
1336:     End If
1337:     If Right(strWsPathname, 1) = "\" Or Right(strWsPathname, 1) = "/" Then
1338:       strWsPathname = Left(strWsPathname, Len(strWsPathname) - 1)
1339:     End If
1340:     Set pFeatWS = pWsFact.OpenFromFile(strWsPathname, 0)
    
    ' GET FEATURE DATASET IF IT EXISTS
1343:     If booHasFeatureDataset Then Set pFeatureDataset = pFeatWS.OpenFeatureDataset(strFeatDataset)
    
1345:     booAlreadyExists = CheckIfFeatureClassExists(pFeatWS, strBaseName)
1346:     If booAlreadyExists Then
1347:       lngResponse = MsgBox("The Feature Class '" & pFClassName & "' already exists!  Do you wish to overwrite it?", _
            vbYesNo, "Feature Class Already Exists:")
1349:       If lngResponse = vbYes Then
        ' DELETE FEATURE CLASS
        Dim pDelete As IFeatureClass
        Dim pDelDataset As IDataset
1353:         Set pDelete = pFeatWS.OpenFeatureClass(strBaseName)
1354:         Set pDelDataset = pDelete
1355:         pDelDataset.DELETE
1356:         booAlreadyExists = CheckIfFeatureClassExists(pFeatWS, strBaseName)
1357:       Else
1358:         Set CreateGeneralFeatureClass = Nothing
1359:         Set pGxObj = Nothing
1360:         strName = ""
1361:       End If
1362:     End If
1363:   Loop
  
  
  ' NOW READY TO CREATE FEATURE CLASS
1367:   If booHasFeatureDataset Then                                                     ' IF IN FEATURE DATASET
1368:     Set pFClass = CreateDatasetFeatureClass(pFeatureDataset, strBaseName, esriFTSimple, pGeomType, pAddFields)
1369:   ElseIf strCategory = "Shapefile" Or strCategory = "Folder" Then                  ' IF SHAPEFILE
1370:     Set pFClass = CreateShapefileFeatureClass(strWsPathname, strBaseName, pSpatialReference, pGeomType, pAddFields, booForceUniqueIDField)
1371:   Else                                                                             ' IF IN FILE OR PERSONAL GEODATABASE
'    Set pFClass = invoiceCreator.TopoCorridor.aml_func_mod.createWorkspaceFeatureClass(pFeatWS, strBaseName, esriFTSimple, pGeomType)
1373:     Set pFClass = CreateGDBFeatureClass(pFeatWS, strBaseName, esriFTSimple, pSpatialReference, pGeomType, pAddFields, , , , , _
          lngCategory, pExtent, lngOriginalRecCount)
1375:   End If
  
1377:   Set CreateGeneralFeatureClass = pFClass
  

  Exit Function
ErrorHandler:
  HandleError True, "CreateGeneralFeatureClass " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function CheckIfTableExists(pWS As IFeatureWorkspace, strName As String) As Boolean
  On Error GoTo ErrorHandler

    Dim pTable As ITable
    On Error Resume Next
1390:     Set pTable = pWS.OpenTable(strName)
1391:     If pTable Is Nothing Then
1392:         CheckIfTableExists = False
1393:     Else
1394:         CheckIfTableExists = True
1395:     End If
1396:     If CheckIfTableExists = False Then
      Dim pFClass As ITable
1398:       Set pFClass = pWS.OpenFeatureClass(strName)
1399:       If pFClass Is Nothing Then
1400:           CheckIfTableExists = False
1401:       Else
1402:           CheckIfTableExists = True
1403:       End If
1404:     End If

  Exit Function
ErrorHandler:
  HandleError True, "CheckIfTableExists " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function
Public Function CheckIfFeatureClassExists(pWS As IFeatureWorkspace, strName As String) As Boolean
  On Error GoTo ErrorHandler

    Dim pFClass As IFeatureClass
    On Error Resume Next
1415:     Set pFClass = pWS.OpenFeatureClass(strName)
1416:     If pFClass Is Nothing Then
1417:         CheckIfFeatureClassExists = False
1418:     Else
1419:         CheckIfFeatureClassExists = True
1420:     End If
1421:     If CheckIfFeatureClassExists = False Then
      Dim pTable As ITable
1423:       Set pTable = pWS.OpenTable(strName)
1424:       If pTable Is Nothing Then
1425:           CheckIfFeatureClassExists = False
1426:       Else
1427:           CheckIfFeatureClassExists = True
1428:       End If
1429:     End If

  Exit Function
ErrorHandler:
  HandleError True, "CheckIfFeatureClassExists " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function MakeUniqueGDBTableName(pWS As IWorkspace, strName As String) As String
  On Error GoTo ErrorHandler
  
  Dim booTableExists As Boolean
1440:   booTableExists = CheckIfTableExists(pWS, strName)
  Dim theCounter As Long
1442:   theCounter = 1
  Dim strBaseName As String
  Dim strNewName As String
1445:   strBaseName = strName
1446:   strNewName = strName
1447:   Do Until booTableExists = False
1448:     theCounter = theCounter + 1
1449:     strNewName = strBaseName & "_" & CStr(theCounter)
1450:     booTableExists = CheckIfTableExists(pWS, strNewName)
1451:   Loop
  
1453:   MakeUniqueGDBTableName = strNewName
  
  Exit Function
ErrorHandler:
  HandleError True, "MakeUniqueGDBTableName " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function
Public Function MakeUniqueGDBFeatureClassName(pWS As IWorkspace, strName As String) As String
  On Error GoTo ErrorHandler
  
  Dim booFCExists As Boolean
1463:   booFCExists = CheckIfFeatureClassExists(pWS, strName)
  Dim theCounter As Long
1465:   theCounter = 1
  Dim strBaseName As String
  Dim strNewName As String
1468:   strBaseName = strName
1469:   strNewName = strName
1470:   Do Until booFCExists = False
1471:     theCounter = theCounter + 1
1472:     strNewName = strBaseName & "_" & CStr(theCounter)
1473:     booFCExists = CheckIfFeatureClassExists(pWS, strNewName)
1474:   Loop
  
1476:   MakeUniqueGDBFeatureClassName = strNewName
  
  Exit Function
ErrorHandler:
  HandleError True, "MakeUniqueGDBFeatureClassName " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function MakeUniquedBASEName(strFileName As String) As String
  On Error GoTo ErrorHandler

1486:   If Not ExistFileDir(strFileName) Then
1487:     MakeUniquedBASEName = strFileName
    Exit Function
1489:   Else
    
    Dim theCounter As Long
1492:     theCounter = 1
    
    Dim theFilename As String
    Dim theBaseName As String
    Dim thePointPos As Long
    Dim theExtension As String
    
1499:     If InStr(1, Right(strFileName, 5), ".", vbTextCompare) > 0 Then
1500:       thePointPos = InStrRev(strFileName, ".", -1, vbTextCompare)
1501:       theExtension = Right(strFileName, Len(strFileName) - (thePointPos - 1))
1502:       theFilename = Left(strFileName, thePointPos - 1)
1503:     Else
1504:       theExtension = ""
1505:       theFilename = strFileName
1506:     End If
    
1508:     theBaseName = theFilename
    
1510:     Do While ExistFileDir(theFilename & theExtension)
1511:       theCounter = theCounter + 1
1512:       theFilename = theBaseName & "_" & CStr(theCounter)
1513:     Loop
    
1515:     MakeUniquedBASEName = theFilename & theExtension
    
1517:   End If

  Exit Function
ErrorHandler:
  HandleError True, "MakeUniquedBASEName " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function MakeUniqueShapeFilename(strFileName As String) As String
  On Error GoTo ErrorHandler

  Dim theFilename As String
  Dim theBaseName As String
  Dim thePointPos As Long
  Dim theExtension As String
  
1532:   If InStr(1, Right(strFileName, 5), ".", vbTextCompare) > 0 Then
1533:     thePointPos = InStrRev(strFileName, ".", -1, vbTextCompare)
1534:     theExtension = Right(strFileName, Len(strFileName) - (thePointPos - 1))
1535:     theFilename = Left(strFileName, thePointPos - 1)
1536:   Else
1537:     theExtension = ""
1538:     theFilename = strFileName
1539:   End If
  
1541:   If Not TopoCorridor.aml_func_mod.ExistFileDir(strFileName) And Not TopoCorridor.aml_func_mod.ExistFileDir(theFilename) Then
1542:     MakeUniqueShapeFilename = strFileName
    Exit Function
1544:   Else
    
    Dim theCounter As Long
1547:     theCounter = 1
    
    
1550:     theBaseName = theFilename

1552:     Do While TopoCorridor.aml_func_mod.ExistFileDir(theFilename & theExtension) Or TopoCorridor.aml_func_mod.ExistFileDir(theFilename)
1553:       theCounter = theCounter + 1
1554:       theFilename = theBaseName & "_" & CStr(theCounter)
1555:     Loop
    
1557:     MakeUniqueShapeFilename = theFilename & theExtension
    
1559:   End If

  Exit Function
ErrorHandler:
  HandleError True, "MakeUniqueShapeFilename " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function


Public Function CreateGDBTable(featWorkspace As IFeatureWorkspace, _
                                            Name As String, _
                                            Optional pAddFields As esriSystem.IVariantArray, _
                                            Optional pCLSID As UID, _
                                            Optional pCLSEXT As UID, _
                                            Optional ConfigWord As String = "" _
                                            ) As ITable
  On Error GoTo ErrorHandler
 
'' createWorkspaceFeatureClass: simple helper to create a featureclass in a geodatabase workspace.
'' NOTE: when creating a feature class in a workspace it is important to assign the spatial
''       reference to the geometry field.
'' MODIFIED BY JENNESS APRIL 23 2008 FROM ESRI SAMPLE
  
1581:   Set CreateGDBTable = Nothing
  If featWorkspace Is Nothing Then Exit Function
  If Name = "" Then Exit Function
  
1585:   If (pCLSID Is Nothing) Or IsMissing(pCLSID) Then
1586:     Set pCLSID = Nothing
1587:     Set pCLSID = New UID
1588:     pCLSID.Value = "esriGeoDatabase.Object"
1589:   End If
  
  ' CREATE OBJECT ID FIELD; ADD ANY REQUESTED FIELDS IF NECESSARY
  ' establish a fields collection
  Dim pFields As IFields
  Dim pFieldsEdit As IFieldsEdit
  Dim pGeomDef As IGeometryDef
  Dim pGeomDefEdit As IGeometryDefEdit
  Dim pField As IField
  Dim pFieldEdit As IFieldEdit
  
1600:   Set pFields = New Fields
1601:   Set pFieldsEdit = pFields
  
  '' create the object id field
1604:   Set pField = New Field
1605:   Set pFieldEdit = pField
1606:   pFieldEdit.Name = "Object_ID"
 '   pFieldEdit.AliasName = "object identifier"
1608:   pFieldEdit.Type = esriFieldTypeOID
1609:   pFieldsEdit.AddField pField
 
  ' ADD FIELDS IF REQUESTED
1612:   If Not (pAddFields Is Nothing Or IsMissing(pAddFields)) Then
    Dim lngIndex As Long
1614:     For lngIndex = 0 To pAddFields.Count - 1
1615:       pFieldsEdit.AddField pAddFields.Element(lngIndex)
1616:     Next lngIndex
1617:   End If
  
  ' establish the class extension
1620:   If (pCLSEXT Is Nothing) Or IsMissing(pCLSEXT) Then
1621:     Set pCLSEXT = Nothing
1622:   End If
  
1624:   Set CreateGDBTable = featWorkspace.CreateTable(Name, pFields, pCLSID, pCLSEXT, "")
    
  Exit Function
ErrorHandler:
  HandleError True, "CreateGDBTable " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function CreateGDBFeatureClass(featWorkspace As IFeatureWorkspace, _
                                            Name As String, _
                                            featType As esriFeatureType, _
                                            pSpRef As ISpatialReference, _
                                            Optional geomType As esriGeometryType = esriGeometryPoint, _
                                            Optional pAddFields As esriSystem.IVariantArray, _
                                            Optional pCLSID As UID, _
                                            Optional pCLSEXT As UID, _
                                            Optional ConfigWord As String = "", _
                                            Optional booForceUniqueIDField As Boolean = True, _
                                            Optional lngCategory As JenDatasetTypes, _
                                            Optional pExtent As IEnvelope, _
                                            Optional lngOriginalRecCount As Long = -9999) As IFeatureClass
  On Error GoTo ErrorHandler

 
'' createWorkspaceFeatureClass: simple helper to create a featureclass in a geodatabase workspace.
'' NOTE: when creating a feature class in a workspace it is important to assign the spatial
''       reference to the geometry field.
'' MODIFIED BY JENNESS APRIL 23 2008 FROM ESRI SAMPLE
  
1652:   Set CreateGDBFeatureClass = Nothing
  If featWorkspace Is Nothing Then Exit Function
  If Name = "" Then Exit Function
  
1656:   If (pCLSID Is Nothing) Or IsMissing(pCLSID) Then
1657:     Set pCLSID = Nothing
1658:     Set pCLSID = New UID
    
    '' determine the appropriate geometry type corresponding the the feature type
    Select Case featType
      Case esriFTSimple
1663:         pCLSID.Value = "esriGeoDatabase.Feature"
1664:         If geomType = esriGeometryLine Then geomType = esriGeometryPolyline
      Case esriFTSimpleJunction
1666:         geomType = esriGeometryPoint
1667:         pCLSID.Value = "esriGeoDatabase.SimpleJunctionFeature"
      Case esriFTComplexJunction
1669:         pCLSID.Value = "esriGeoDatabase.ComplexJunctionFeature"
      Case esriFTSimpleEdge
1671:         geomType = esriGeometryPolyline
1672:         pCLSID.Value = "esriGeoDatabase.SimpleEdgeFeature"
      Case esriFTComplexEdge
1674:         geomType = esriGeometryPolyline
1675:         pCLSID.Value = "esriGeoDatabase.ComplexEdgeFeature"
      Case esriFTAnnotation
        Exit Function
1678:     End Select
1679:   End If
  
  ' CREATE GEOMETRY AND OBJECT ID FIELD; ADD ANY REQUESTED FIELDS IF NECESSARY
  ' establish a fields collection
  Dim pFields As IFields
  Dim pFieldsEdit As IFieldsEdit
  Dim pGeomDef As IGeometryDef
  Dim pGeomDefEdit As IGeometryDefEdit
  Dim pField As IField
  Dim pFieldEdit As IFieldEdit
  
1690:   Set pFields = New Fields
1691:   Set pFieldsEdit = pFields
  
  '' create the geometry field
1694:   Set pGeomDef = New GeometryDef
1695:   Set pGeomDefEdit = pGeomDef
  
  ' SPATIAL INDEX STUFF
  ' WOULD LIKE THE AVERAGE NUMBER OF FEATURES PER GRID CELL TO BE AROUND 200
  ' GOING TO DEFAULT TO ONE SPATIAL INDEX GRID
  Dim dblIndex0 As Double
  Dim dblIndex1 As Double
  Dim dblIndex2 As Double
1703:   dblIndex0 = 100
1704:   dblIndex1 = 0
1705:   dblIndex2 = 0
  
1707:   If Not pExtent Is Nothing And lngOriginalRecCount > 0 Then
1708:     If Not pExtent.IsEmpty Then
      Dim dblOptimalGridCells As Double
1710:       dblOptimalGridCells = lngOriginalRecCount / 200
      Dim dblX As Double
      Dim dblY As Double
1713:       dblX = pExtent.Width
1714:       dblY = pExtent.Height
1715:       dblIndex0 = Sqr(dblX * dblY / dblOptimalGridCells)
1716:       If dblIndex0 > dblX Then
1717:         dblIndex0 = dblX
1718:       End If
1719:       If dblIndex0 > dblY Then
1720:         dblIndex0 = dblY
1721:       End If
      
1723:       dblIndex1 = 0
1724:       dblIndex2 = 0
1725:     End If
1726:   End If
  
1728:   If Not CheckSpRefDomain(pSpRef) Then
    Dim pSpRefRes As ISpatialReferenceResolution
1730:     Set pSpRefRes = pSpRef
1731:     pSpRefRes.ConstructFromHorizon
1732:   End If
  
  '' assign the geometry definiton properties.
1735:   With pGeomDefEdit
1736:     .GeometryType = geomType
1737:     If lngCategory = ENUM_FileGDB Then       ' FILE GDB
1738:       .GridCount = 1
1739:       .GridSize(0) = dblIndex0
'      .GridSize(1) = dblIndex1
'      .GridSize(2) = dblIndex2
'      .AvgNumPoints = 2
1743:     Else
1744:       .GridCount = 1
1745:       .GridSize(0) = dblIndex0
1746:     End If
1747:     .HasM = False
1748:     .HasZ = False
1749:     Set .SpatialReference = pSpRef
1750:   End With
  
1752:   Set pField = New Field
1753:   Set pFieldEdit = pField
  
1755:   pFieldEdit.Name = "Shape"
1756:   pFieldEdit.AliasName = "geometry"
1757:   pFieldEdit.Type = esriFieldTypeGeometry
1758:   Set pFieldEdit.GeometryDef = pGeomDef
1759:   pFieldsEdit.AddField pField

  '' create the object id field
'  If booForceUniqueIDField Then
    
    
    Dim strUniqueName As String
    Dim strUniqueBase As String
1767:     strUniqueName = "Object_ID"
1768:     strUniqueBase = strUniqueName
    Dim lngUniqueCounter As Long
1770:     lngUniqueCounter = 1
    Dim lngCounterLength As Long
    Dim lngUniqueIndex As Long
    Dim booNameExists As Boolean
    Dim pCheckField As IField
1775:     booNameExists = True
1776:     If (pAddFields Is Nothing Or IsMissing(pAddFields)) Then
1777:       booNameExists = False
1778:     Else
1779:       Do Until booNameExists = False
1780:         booNameExists = False
1781:         For lngUniqueIndex = 0 To pAddFields.Count - 1
1782:           Set pCheckField = pAddFields.Element(lngUniqueIndex)
1783:           If pCheckField.Name = strUniqueName Then
1784:             booNameExists = True
1785:             Exit For
1786:           End If
1787:         Next lngUniqueIndex
1788:         If booNameExists Then
1789:           lngUniqueCounter = lngUniqueCounter + 1
1790:           lngCounterLength = Len(CStr(lngUniqueCounter))
1791:           strUniqueName = Left(strUniqueBase, 11 - lngCounterLength) & CStr(lngUniqueCounter)
1792:         End If
1793:       Loop
1794:     End If
    
1796:     Set pField = New Field
1797:     Set pFieldEdit = pField
1798:     pFieldEdit.Name = strUniqueName
1799:     pFieldEdit.AliasName = "object identifier"
1800:     pFieldEdit.Type = esriFieldTypeOID
1801:     pFieldsEdit.AddField pField
'  End If
  
  ' ADD FIELDS IF REQUESTED
1805:   If Not (pAddFields Is Nothing Or IsMissing(pAddFields)) Then
    Dim lngIndex As Long
1807:     For lngIndex = 0 To pAddFields.Count - 1
1808:       pFieldsEdit.AddField pAddFields.Element(lngIndex)
1809:     Next lngIndex
1810:   End If
  
  
  ' establish the class extension
1814:   If (pCLSEXT Is Nothing) Or IsMissing(pCLSEXT) Then
1815:     Set pCLSEXT = Nothing
1816:   End If
  
  ' locate the shape field
  Dim strShapeFld As String
  Dim J As Integer
1821:   For J = 0 To pFields.FieldCount - 1
1822:     If pFields.Field(J).Type = esriFieldTypeGeometry Then
1823:       strShapeFld = pFields.Field(J).Name
1824:     End If
1825:   Next
  
1827:   Set CreateGDBFeatureClass = featWorkspace.CreateFeatureClass(Name, pFields, pCLSID, _
                             pCLSEXT, featType, strShapeFld, ConfigWord)
  
  Exit Function
ErrorHandler:
  HandleError True, "CreateGDBFeatureClass " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Private Function CheckSpRefDomain(pSpRef As ISpatialReference) As Boolean
  On Error GoTo ErrorHandler
  
  Dim dXmax As Double
  Dim dYmax As Double
  Dim dXmin As Double
  Dim dYmin As Double
  
  'get the xy domain extent of the dataset
  
1845:   pSpRef.GetDomain dXmin, dXmax, dYmin, dYmax
1846:   CheckSpRefDomain = True
  
ErrorHandler:
1849:   CheckSpRefDomain = False

End Function

Public Function CreatedBASETableInFolder(sPath As String, sName As String, Optional pAddFields As esriSystem.IVariantArray) As ITable
  On Error GoTo ErrorHandler
  
1856:   If Right(sPath, 4) = ".dbf" Then sPath = ReturnDir(sPath)
1857:   If Right(sName, 4) = ".dbf" Then sName = Left(sName, Len(sName) - 4)
  
  ' Open the folder to contain the shapefile as a workspace
  Dim pFWS As IFeatureWorkspace
  Dim pWorkspaceFactory As IWorkspaceFactory
1862:   Set pWorkspaceFactory = New ShapefileWorkspaceFactory
  
1864:   If Not ExistFileDir(sPath) Then
1865:     MsgBox "Unable to create dBASE Table:" & vbCrLf & _
           sPath & " is not a valid workspace...", , "Failed to Create Table:"
1867:     Set CreatedBASETableInFolder = Nothing
    Exit Function
1869:   End If
  
1871:   Set pFWS = pWorkspaceFactory.OpenFromFile(sPath, 0)
  
'   Set up a simple fields collection
  Dim pFields As IFields
  Dim pFieldsEdit As IFieldsEdit
1876:   Set pFields = New Fields
1877:   Set pFieldsEdit = pFields

  Dim pField As IField
  Dim pFieldEdit As IFieldEdit
  
1882:   Set pField = New Field
1883:   Set pFieldEdit = pField
1884:   With pFieldEdit
1885:       .Precision = 8
1886:       .Name = "Unique_ID"
1887:       .Type = esriFieldTypeInteger
1888:   End With
1889:   pFieldsEdit.AddField pField
  
  ' ADD FIELDS IF REQUESTED
1892:   If Not (pAddFields Is Nothing Or IsMissing(pAddFields)) Then
    Dim lngIndex As Long
1894:     For lngIndex = 0 To pAddFields.Count - 1
1895:       pFieldsEdit.AddField pAddFields.Element(lngIndex)
1896:     Next lngIndex
1897:   End If
    
  ' Create the dBASE Table
  ' (some parameters apply to geodatabase options and can be defaulted as Nothing)
  Dim booFileExists As Boolean
  Dim strCheckString As String
1903:   If Right(sPath, 1) = "\" Then
1904:     strCheckString = sPath & sName & ".dbf"
'    MsgBox sPath & sName & ".dbf" & vbCrLf & "File Exists? " & CStr(Dir(sPath & sName & ".dbf") <> "")
1906:   Else
1907:     strCheckString = sPath & "\" & sName & ".dbf"
'    MsgBox sPath & "\" & sName & ".dbf" & vbCrLf & "File Exists? " & CStr(Dir(sPath & "\" & sName & ".dbf") <> "")
1909:   End If
  
1911:   booFileExists = (Dir(strCheckString) <> "")
  
1913:   If booFileExists Then
1914:     MsgBox "The following file already exists:" & vbCrLf & vbCrLf & strCheckString & vbCrLf & vbCrLf & _
           "Please select a new filename...", , "Duplicate Filename:"
1916:     Set CreatedBASETableInFolder = Nothing
    Exit Function
1918:   End If
  
  Dim pTable As ITable
1921:   Set pTable = pFWS.CreateTable(sName, pFields, Nothing, Nothing, "")
  
1923:   Set CreatedBASETableInFolder = pTable
  
  Exit Function
ErrorHandler:
  HandleError True, "CreatedBASETableInFolder " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function
    Public Function CreatedBASETableInFolder2(sPath As String, sName As String, pAddFields As esriSystem.IVariantArray, _
          booAddUniqueIDField As Boolean) As ITable
  On Error GoTo ErrorHandler
  
'  MsgBox "Create Table:  Before fixing names..." & vbCrLf & _
         " --> sPath = " & sPath & vbCrLf & _
         " --> sName = " & sName
  
1937:   If Right(sPath, 4) = ".dbf" Then sPath = ReturnDir(sPath)
1938:   If Right(sName, 4) = ".dbf" Then sName = Left(sName, Len(sName) - 4)
  
 ' MsgBox "Create Table:  After fixing names..." & vbCrLf & _
         " --> sPath = " & sPath & vbCrLf & _
         " --> sName = " & sName
         
  ' Open the folder to contain the shapefile as a workspace
  Dim pFWS As IFeatureWorkspace
  Dim pWorkspaceFactory As IWorkspaceFactory
1947:   Set pWorkspaceFactory = New ShapefileWorkspaceFactory
  
1949:   If Not ExistFileDir(sPath) Then
1950:     MsgBox "Unable to create dBASE Table:" & vbCrLf & _
           sPath & " is not a valid workspace...", , "Failed to Create Table:"
1952:     Set CreatedBASETableInFolder2 = Nothing
    Exit Function
1954:   End If
  
1956:   Set pFWS = pWorkspaceFactory.OpenFromFile(sPath, 0)
  
'   Set up a simple fields collection
  Dim pFields As IFields
  Dim pFieldsEdit As IFieldsEdit
1961:   Set pFields = New Fields
1962:   Set pFieldsEdit = pFields

  Dim pField As IField
  Dim pFieldEdit As IFieldEdit
  
1967:   If booAddUniqueIDField Then
1968:     Set pField = New Field
1969:     Set pFieldEdit = pField
1970:     With pFieldEdit
1971:         .Precision = 8
1972:         .Name = "Unique_ID"
1973:         .Type = esriFieldTypeInteger
1974:     End With
1975:     pFieldsEdit.AddField pField
1976:   End If
  
  ' ADD FIELDS IF REQUESTED
  
 ' Dim strDebugReport As String
  'strDebugReport = "pAddFields has " & CStr(pAddFields.Count) & " fields..." & vbCrLf
  
1983:   If Not (pAddFields Is Nothing Or IsMissing(pAddFields)) Then
    Dim lngIndex As Long
1985:     For lngIndex = 0 To pAddFields.Count - 1
1986:       Set pField = pAddFields.Element(lngIndex)
1987:       pFieldsEdit.AddField pAddFields.Element(lngIndex)
      'strDebugReport = strDebugReport & "  " & CStr(lngIndex + 1) & "] " & pField.Name & vbCrLf
1989:     Next lngIndex
1990:   End If
  
 ' MsgBox strDebugReport
  
  ' Create the dBASE Table
  ' (some parameters apply to geodatabase options and can be defaulted as Nothing)
  Dim booFileExists As Boolean
  Dim strCheckString As String
1998:   If Right(sPath, 1) = "\" Then
1999:     strCheckString = sPath & sName & ".dbf"
   ' MsgBox sPath & sName & ".dbf" & vbCrLf & "File Exists? " & CStr(Dir(sPath & sName & ".dbf") <> "")
2001:   Else
2002:     strCheckString = sPath & "\" & sName & ".dbf"
   ' MsgBox sPath & "\" & sName & ".dbf" & vbCrLf & "File Exists? " & CStr(Dir(sPath & "\" & sName & ".dbf") <> "")
2004:   End If
  
2006:   booFileExists = (Dir(strCheckString) <> "")
  
2008:   If booFileExists Then
2009:     MsgBox "The following file already exists:" & vbCrLf & vbCrLf & strCheckString & vbCrLf & vbCrLf & _
           "Please select a new filename...", , "Duplicate Filename:"
2011:     Set CreatedBASETableInFolder2 = Nothing
    Exit Function
2013:   End If
  
  Dim pTable As ITable
2016:   Set pTable = pFWS.CreateTable(sName, pFields, Nothing, Nothing, "")
  
2018:   Set CreatedBASETableInFolder2 = pTable
  
  Exit Function
ErrorHandler:
  HandleError True, "CreatedBASETableInFolder2 " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function CreateShapefileFeatureClass(sPath As String, sName As String, pSpatialReference As ISpatialReference, _
    pGeomType As esriGeometryType, Optional pAddFields As esriSystem.IVariantArray, _
    Optional booForceUniqueIDField As Boolean = True) As IFeatureClass       ' Don't include filename!
  On Error GoTo ErrorHandler

  
2031:   If Right(sPath, 4) = ".shp" Then sPath = ReturnDir(sPath)
2032:   If Right(sName, 4) = ".shp" Then sName = Left(sName, Len(sName) - 4)
  
  ' SET GEOMETRY TYPE, AND EXIT IF NOT ONE OF STANDARD OPTIONS
  Dim pGeomDef As IGeometryDef
  Dim pGeomDefEdit As IGeometryDefEdit
2037:   Set pGeomDef = New GeometryDef
2038:   Set pGeomDefEdit = pGeomDef
2039:   With pGeomDefEdit
2040:     .GeometryType = pGeomType
2041:     Set .SpatialReference = pSpatialReference
2042:   End With
  
  ' Open the folder to contain the shapefile as a workspace
  Dim pFWS As IFeatureWorkspace
  Dim pWorkspaceFactory As IWorkspaceFactory
2047:   Set pWorkspaceFactory = New ShapefileWorkspaceFactory
  
2049:   If Not ExistFileDir(sPath) Then
2050:     MsgBox "Unable to create Feature Class:" & vbCrLf & _
           sPath & " is not a valid workspace...", , "Failed to Create Feature Class:"
2052:     Set CreateShapefileFeatureClass = Nothing
    Exit Function
2054:   End If
  
2056:   Set pFWS = pWorkspaceFactory.OpenFromFile(sPath, 0)
  
'   Set up a simple fields collection
  Dim pFields As IFields
  Dim pFieldsEdit As IFieldsEdit
2061:   Set pFields = New Fields
2062:   Set pFieldsEdit = pFields

  Dim pField As IField
  Dim pFieldEdit As IFieldEdit
  
  ' Make the shape field
  ' it will need a geometry definition, with a spatial reference
2069:   Set pField = New Field
2070:   Set pFieldEdit = pField
2071:   pFieldEdit.Name = "Shape"
2072:   pFieldEdit.Type = esriFieldTypeGeometry

2074:   Set pFieldEdit.GeometryDef = pGeomDef
2075:   pFieldsEdit.AddField pField
  
  ' MAKE SURE UNIQUE ID FIELD IS UNIQUELY NAMED
 
2079:   If booForceUniqueIDField Then
    Dim strUniqueName As String
    Dim strUniqueBase As String
2082:     strUniqueName = "Unique_ID"
2083:     strUniqueBase = strUniqueName
    Dim lngUniqueCounter As Long
2085:     lngUniqueCounter = 1
    Dim lngCounterLength As Long
    Dim lngUniqueIndex As Long
    Dim booNameExists As Boolean
    Dim pCheckField As IField
2090:     booNameExists = True
2091:     If (pAddFields Is Nothing Or IsMissing(pAddFields)) Then
2092:       booNameExists = False
2093:     Else
2094:       Do Until booNameExists = False
2095:         booNameExists = False
2096:         For lngUniqueIndex = 0 To pAddFields.Count - 1
2097:           Set pCheckField = pAddFields.Element(lngUniqueIndex)
2098:           If pCheckField.Name = strUniqueName Then
2099:             booNameExists = True
2100:             Exit For
2101:           End If
2102:         Next lngUniqueIndex
2103:         If booNameExists Then
2104:           lngUniqueCounter = lngUniqueCounter + 1
2105:           lngCounterLength = Len(CStr(lngUniqueCounter))
2106:           strUniqueName = Left(strUniqueBase, 10 - lngCounterLength) & CStr(lngUniqueCounter)
2107:         End If
2108:       Loop
2109:     End If
    
2111:     Set pField = New Field
2112:     Set pFieldEdit = pField
2113:     With pFieldEdit
2114:         .Precision = 8
2115:         .Name = strUniqueName
2116:         .Type = esriFieldTypeInteger
2117:     End With
2118:     pFieldsEdit.AddField pField
2119:   End If
  
  ' ADD FIELDS IF REQUESTED
'  Dim strDebugReport As String
'  Dim pDebugField As IField
2124:   If Not (pAddFields Is Nothing Or IsMissing(pAddFields)) Then
    Dim lngIndex As Long
2126:     For lngIndex = 0 To pAddFields.Count - 1
'      Set pDebugField = pAddFields.Element(lngIndex)
'      strDebugReport = strDebugReport & CStr(lngIndex) & "]  Field Name = " & pDebugField.Name & vbCrLf
2129:       pFieldsEdit.AddField pAddFields.Element(lngIndex)
2130:     Next lngIndex
2131:   End If
'  MsgBox CStr(pGeomDef.GeometryType) & vbCrLf & strDebugReport
  ' Create the shapefile
  ' (some parameters apply to geodatabase options and can be defaulted as Nothing)
  Dim booFileExists As Boolean
  Dim strCheckString As String
2137:   If Right(sPath, 1) = "\" Then
2138:     strCheckString = sPath & sName & ".shp"
'    MsgBox sPath & sName & ".shp" & vbCrLf & "File Exists? " & CStr(Dir(sPath & sName & ".shp") <> "")
2140:   Else
2141:     strCheckString = sPath & "\" & sName & ".shp"
'    MsgBox sPath & "\" & sName & ".shp" & vbCrLf & "File Exists? " & CStr(Dir(sPath & "\" & sName & ".shp") <> "")
2143:   End If
  
'  booFileExists = (Dir(strCheckString) <> "")
'  MsgBox strCheckString & vbCrLf & CStr(booFileExists)
  
2148:   If booFileExists Then
2149:     MsgBox "The following file already exists:" & vbCrLf & vbCrLf & strCheckString & vbCrLf & vbCrLf & _
           "Please select a new filename...", , "Duplicate Filename:"
2151:     Set CreateShapefileFeatureClass = Nothing
    Exit Function
2153:   End If
  
  Dim pFeatClass As IFeatureClass
2156:   Set pFeatClass = pFWS.CreateFeatureClass(sName, pFields, Nothing, _
                                           Nothing, esriFTSimple, "Shape", "")
                                           
2159:   Set CreateShapefileFeatureClass = pFeatClass



  Exit Function
ErrorHandler:
  HandleError True, "CreateShapefileFeatureClass " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

  
Public Function CreateDatasetFeatureClass(pFDS As IFeatureDataset, _
                                  Name As String, featType As esriFeatureType, _
                                  Optional geomType As esriGeometryType = esriGeometryPoint, _
                                  Optional pAddFields As esriSystem.IVariantArray, _
                                  Optional pCLSID As UID, _
                                  Optional pCLSEXT As UID, _
                                  Optional ConfigWord As String = "" _
                                  ) As IFeatureClass
  On Error GoTo ErrorHandler

  
'' createDatasetFeatureClass: simple helper to create a featureclass in a geodatabase Dataset.
'' NOTE: when creating a feature class in a dataset the spatial reference is inherited
'' from the dataset object
'' MODIFIED BY JENNESS APRIL 23 2008 FROM ESRI SAMPLE

  Dim pFields As IFields
  Dim pFieldsEdit As IFieldsEdit
  Dim pGeomDef As IGeometryDef
  Dim pGeomDefEdit As IGeometryDefEdit
  Dim pField As IField
  Dim pFieldEdit As IFieldEdit
  Dim strShapeFld As String
  Dim J As Integer
  
2194:   Set CreateDatasetFeatureClass = Nothing
  If pFDS Is Nothing Then Exit Function
  If Name = "" Then Exit Function
  
2198:   If (pCLSID Is Nothing) Or IsMissing(pCLSID) Then
2199:     Set pCLSID = Nothing
2200:     Set pCLSID = New UID
    
    '' determine the appropriate geometry type corresponding the the feature type
    Select Case featType
      Case esriFTSimple
2205:         pCLSID.Value = "esriGeoDatabase.Feature"
      Case esriFTSimpleJunction
2207:         geomType = esriGeometryPoint
2208:         pCLSID.Value = "esriGeoDatabase.SimpleJunctionFeature"
      Case esriFTComplexJunction
2210:         pCLSID.Value = "esriGeoDatabase.ComplexJunctionFeature"
      Case esriFTSimpleEdge
2212:         geomType = esriGeometryPolyline
2213:         pCLSID.Value = "esriGeoDatabase.SimpleEdgeFeature"
      Case esriFTComplexEdge
2215:         geomType = esriGeometryPolyline
2216:         pCLSID.Value = "esriGeoDatabase.ComplexEdgeFeature"
      Case esriFTAnnotation
        Exit Function
2219:     End Select
2220:   End If
  
  ' CREATE GEOMETRY AND OBJECT ID FIELD; ADD ANY REQUESTED FIELDS IF NECESSARY
  ' establish a fields collection
2224:   Set pFields = New Fields
2225:   Set pFieldsEdit = pFields
  
  '' create the geometry field
2228:   Set pGeomDef = New GeometryDef
2229:   Set pGeomDefEdit = pGeomDef
  
  '' assign the geometry definiton properties.
2232:   With pGeomDefEdit
2233:     .GeometryType = geomType
2234:     .GridCount = 1
2235:     .GridSize(0) = 10
2236:     .AvgNumPoints = 2
2237:     .HasM = False
2238:     .HasZ = False
2239:   End With
  
2241:   Set pField = New Field
2242:   Set pFieldEdit = pField
  
2244:   pFieldEdit.Name = "Shape"
2245:   pFieldEdit.AliasName = "geometry"
2246:   pFieldEdit.Type = esriFieldTypeGeometry
2247:   Set pFieldEdit.GeometryDef = pGeomDef
2248:   pFieldsEdit.AddField pField

  '' create the object id field
2251:   Set pField = New Field
2252:   Set pFieldEdit = pField
2253:   pFieldEdit.Name = "Object_ID"
2254:   pFieldEdit.AliasName = "object identifier"
2255:   pFieldEdit.Type = esriFieldTypeOID
2256:   pFieldsEdit.AddField pField
  
  ' ADD FIELDS IF REQUESTED
2259:   If Not (pAddFields Is Nothing Or IsMissing(pAddFields)) Then
    Dim lngIndex As Long
2261:     For lngIndex = 0 To pAddFields.Count - 1
2262:       pFieldsEdit.AddField pAddFields.Element(lngIndex)
2263:     Next lngIndex
2264:   End If
  
  ' establish the class extension
2267:   If (pCLSEXT Is Nothing) Or IsMissing(pCLSEXT) Then
2268:     Set pCLSEXT = Nothing
2269:   End If
  
  ' locate the shape field
2272:   For J = 0 To pFields.FieldCount - 1
2273:     If pFields.Field(J).Type = esriFieldTypeGeometry Then
2274:       strShapeFld = pFields.Field(J).Name
2275:     End If
2276:   Next
  
2278:   Set CreateDatasetFeatureClass = pFDS.CreateFeatureClass(Name, pFields, pCLSID, pCLSEXT, featType, strShapeFld, ConfigWord)
  

  Exit Function
ErrorHandler:
  HandleError True, "CreateDatasetFeatureClass " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function
           


Public Function ReturnFieldsByType(pFields As IFields, enumJenFieldTypes As JenFieldTypes) As esriSystem.IVariantArray
  On Error GoTo ErrorHandler


  Dim booString As Boolean
  Dim booNumber As Boolean
  Dim booDate As Boolean
  Dim booOID As Boolean
  Dim booGeometry As Boolean
  Dim booBlob As Boolean
  Dim booRaster As Boolean
  Dim booGUID As Boolean
  Dim booGlobalID As Boolean
  Dim booXML As Boolean
  
  Dim strBinary As String
2304:   strBinary = ConvertLongBinary(enumJenFieldTypes, 10)
'  MsgBox "Number = " & enumJenFieldTypes & vbCrLf & "Binary = " & strBinary

2307:   booXML = Mid(strBinary, 1, 1) = "1"
2308:   booGlobalID = Mid(strBinary, 2, 1) = "1"
2309:   booGUID = Mid(strBinary, 3, 1) = "1"
2310:   booRaster = Mid(strBinary, 4, 1) = "1"
2311:   booBlob = Mid(strBinary, 5, 1) = "1"
2312:   booGeometry = Mid(strBinary, 6, 1) = "1"
2313:   booOID = Mid(strBinary, 7, 1) = "1"
2314:   booDate = Mid(strBinary, 8, 1) = "1"
2315:   booNumber = Mid(strBinary, 9, 1) = "1"
2316:   booString = Mid(strBinary, 10, 1) = "1"
  
'  MsgBox "booString = " & booString & vbCrLf & _
      "booNumber = " & booNumber & vbCrLf & _
      "booDate = " & booDate & vbCrLf & _
      "booOID = " & booOID & vbCrLf & _
      "booGeometry = " & booGeometry & vbCrLf & _
      "booBlob = " & booBlob & vbCrLf & _
      "booRaster = " & booRaster & vbCrLf & _
      "booGUID = " & booGUID & vbCrLf & _
      "booGlobalID = " & booGlobalID & vbCrLf & _
      "booXML = " & booXML
  
  Dim pField As IField
  Dim lngIndex As Long
  Dim pType As esriFieldType
  
2333:   Set ReturnFieldsByType = New esriSystem.VarArray
    
2335:   For lngIndex = 0 To pFields.FieldCount - 1
2336:     Set pField = pFields.Field(lngIndex)
2337:     pType = pField.Type
2338:     If booXML And (pType = esriFieldTypeXML) Then
2339:       ReturnFieldsByType.Add pField
2340:     ElseIf booGlobalID And (pType = esriFieldTypeGlobalID) Then
2341:       ReturnFieldsByType.Add pField
2342:     ElseIf booGUID And (pType = esriFieldTypeGUID) Then
2343:       ReturnFieldsByType.Add pField
2344:     ElseIf booRaster And (pType = esriFieldTypeRaster) Then
2345:       ReturnFieldsByType.Add pField
2346:     ElseIf booBlob And (pType = esriFieldTypeBlob) Then
2347:       ReturnFieldsByType.Add pField
2348:     ElseIf booGeometry And (pType = esriFieldTypeGeometry) Then
2349:       ReturnFieldsByType.Add pField
2350:     ElseIf booOID And (pType = esriFieldTypeOID) Then
2351:       ReturnFieldsByType.Add pField
2352:     ElseIf booDate And (pType = esriFieldTypeDate) Then
2353:       ReturnFieldsByType.Add pField
2354:     ElseIf booNumber And ((pType = esriFieldTypeDouble) Or (pType = esriFieldTypeInteger) _
      Or (pType = esriFieldTypeSingle) Or (pType = esriFieldTypeSmallInteger)) Then
2356:       ReturnFieldsByType.Add pField
2357:     ElseIf booString And (pType = esriFieldTypeString) Then
2358:       ReturnFieldsByType.Add pField
2359:     End If
2360:   Next lngIndex


  Exit Function
ErrorHandler:
  HandleError True, "ReturnFieldsByType " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function ReturnDBASEFieldName(ByVal strName As String, pFieldSet As Variant) As String
  On Error GoTo ErrorHandler


  Dim lngIndex As Long
  
  Dim strAcceptable As String
2375:   strAcceptable = "abcdefghijklmnopqrstuvwxyz1234567890_"
  Dim strCharacters As String
2377:   strCharacters = "abcdefghijklmnopqrstuvwxyz"
  
  Dim pField As IField
  
  Dim strNewName As String
  Dim strChar As String
  
  ' MAKE SURE SUGGESTED NAME IS VALID FOR dBASE IN GENERAL
  ' CHECK IF FIELD NAME IS EMPTY STRING
2386:   If strName = "" Then strName = "zField"
  
  ' CHECK IF FIELD NAME IS PROPER LENGTH
2389:   strName = Left(strName, 10)
  
  ' CHECK IF FIELD NAME DOES NOT START WITH A LETTER
2392:   If Not (InStr(1, strCharacters, Left(strName, 1), vbTextCompare) > 0) Then
2393:     strName = Left("z" & strName, 10)
2394:   End If
  
  ' CHECK FOR NON_CONFORMING CHARACTERS
2397:   strNewName = ""
2398:   For lngIndex = 1 To Len(strName)
2399:     strChar = Mid(strName, lngIndex, 1)
2400:     If Not (InStr(1, strAcceptable, strChar, vbTextCompare) > 0) Then
2401:       strNewName = strNewName & "_"
2402:     Else
2403:       strNewName = strNewName & strChar
2404:     End If
2405:   Next lngIndex
2406:   strName = strNewName
  
  Dim strTestName As String
    
  ' MAKE SURE FIELD NAME DOES NOT ALREADY EXIST IN LIST
  ' CONVERT OBJECT INTO LIST OF EXISTING NAMES
  Dim pFieldArray As esriSystem.IStringArray
2413:   Set pFieldArray = New esriSystem.strArray
  
2415:   If TypeOf pFieldSet Is IFields Then
    
    Dim pFields As IFields
2418:     Set pFields = pFieldSet
2419:     If pFields.FieldCount > 0 Then
2420:       For lngIndex = 0 To pFields.FieldCount - 1
2421:         strTestName = pFields.Field(lngIndex).Name
2422:         pFieldArray.Add strTestName
2423:       Next lngIndex
2424:     End If
    
2426:   ElseIf TypeOf pFieldSet Is esriSystem.IVariantArray Then
    
    Dim pVar As Variant
    Dim pVarArray As esriSystem.IVariantArray
2430:     Set pVarArray = pFieldSet
2431:     If pVarArray.Count > 0 Then
2432:       For lngIndex = 0 To pVarArray.Count - 1
2433:         If VarType(pVarArray.Element(lngIndex)) = vbDataObject Then           ' IS AN IField
2434:           Set pField = pVarArray.Element(lngIndex)
2435:           strTestName = pField.Name
2436:         Else
2437:           strTestName = pVarArray.Element(lngIndex)
2438:         End If
2439:         pFieldArray.Add strTestName
2440:       Next lngIndex
2441:     End If
  
2443:   ElseIf TypeOf pFieldSet Is esriSystem.IStringArray Then
    
2445:     Set pFieldArray = pFieldSet
  
2447:   End If
  
  ' CHECK CURRENT NAME AGAINST LIST
2450:   If pFieldArray.Count > 0 Then
    Dim lngCounter As Long
    Dim strBaseName As String
2453:     strBaseName = strName
    Dim booFoundConflict As Boolean
2455:     booFoundConflict = True
2456:     Do Until booFoundConflict = False
2457:       booFoundConflict = False
2458:       For lngIndex = 0 To pFieldArray.Count - 1
2459:         strTestName = pFieldArray.Element(lngIndex)
2460:         If StrComp(strName, strTestName, vbTextCompare) = 0 Then
2461:           booFoundConflict = True
2462:           Exit For
2463:         End If
2464:       Next lngIndex
2465:       If booFoundConflict Then
2466:         lngCounter = lngCounter + 1
2467:         strName = Left(strBaseName, 10 - Len(CStr(lngCounter))) & CStr(lngCounter)
2468:       End If
2469:     Loop
2470:   End If
  
2472:   ReturnDBASEFieldName = strName


  Exit Function
ErrorHandler:
  HandleError True, "ReturnDBASEFieldName " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function ReturnLayerByName(strName As String, pMap As IMap) As ILayer
  On Error GoTo ErrorHandler


2484:   Set ReturnLayerByName = Nothing
  Dim pLayers As IEnumLayer
2486:   Set pLayers = pMap.Layers(Nothing, True)
  Dim pLayer As ILayer
2488:   pLayers.Reset
2489:   Set pLayer = pLayers.Next
2490:   Do Until pLayer Is Nothing
2491:     If pLayer.Name = strName Then
2492:       Set ReturnLayerByName = pLayer
2493:       Exit Do
2494:     End If
2495:     Set pLayer = pLayers.Next
2496:   Loop


  Exit Function
ErrorHandler:
  HandleError True, "ReturnLayerByName " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function CheckIfCompressedFGDB(pFeatureClass As IFeatureClass) As Boolean
  ' NOTE:  WILL ONLY RETURN TRUE IF EVERYTHING WORKS; IF FUNCTION CRASHES, THEN
  ' ASSUME THIS IS NOT A FILE GEODATABASE AND THEREFORE CANNOT BE A COMPRESSED FGDB.
  ' FOR EXAMPLE, APPARENTLY PERSONAL GEODATABASES AND SHAPEFILES DON'T HAVE PROPERTY SETS???
  
  On Error GoTo EH
  
  Dim pDataset As IDataset
2512:   Set pDataset = pFeatureClass
  Dim pGeoDataset As IGeoDataset
2514:   Set pGeoDataset = pFeatureClass
  Dim strCategory As String
2516:   strCategory = pDataset.Category
  Dim booIsFGDB As Boolean
2518:   booIsFGDB = InStr(1, strCategory, "file geodatabase", vbTextCompare)
  
2520:   CheckIfCompressedFGDB = False
  
2522:   If booIsFGDB Then      ' IF FILE GEODATABASE, CHECK IF IT IS COMPRESSED
    Dim pPropSet As IPropertySet
2524:     Set pPropSet = pDataset.PropertySet
    Dim varFormat As Variant
2526:     varFormat = pPropSet.GetProperty("Datafile Format")
2527:     If varFormat = 1 Then
2528:       CheckIfCompressedFGDB = True
2529:     Else
2530:       CheckIfCompressedFGDB = False
2531:     End If
2532:   End If
  
  Exit Function
EH:
2536:   CheckIfCompressedFGDB = False
End Function

Public Function TrueLayerCount(pMap As IMap) As Long
  On Error GoTo ErrorHandler


  Dim lngLayerCount As Long
2544:   lngLayerCount = 0
  
2546:   If pMap.LayerCount > 0 Then
    Dim pEnumLayer As IEnumLayer
2548:     Set pEnumLayer = pMap.Layers
2549:     pEnumLayer.Reset
    Dim pLayer As IUnknown
2551:     Set pLayer = pEnumLayer.Next
2552:     Do Until pLayer Is Nothing
2553:       lngLayerCount = lngLayerCount + 1
2554:       Set pLayer = pEnumLayer.Next
2555:     Loop
2556:   End If
  
2558:   TrueLayerCount = lngLayerCount


  Exit Function
ErrorHandler:
  HandleError True, "TrueLayerCount " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function


Public Function ReturnDistanceUnitsName(lngEsriUnits As esriUnits) As String
  On Error GoTo ErrorHandler


  Select Case lngEsriUnits
    Case 0
2573:       ReturnDistanceUnitsName = "Unknown"
    Case 1
2575:       ReturnDistanceUnitsName = "Inches"
    Case 2
2577:       ReturnDistanceUnitsName = "Points"
    Case 3
2579:       ReturnDistanceUnitsName = "Feet"
    Case 4
2581:       ReturnDistanceUnitsName = "Yards"
    Case 5
2583:       ReturnDistanceUnitsName = "Miles"
    Case 6
2585:       ReturnDistanceUnitsName = "Nautical miles"
    Case 7
2587:       ReturnDistanceUnitsName = "Millimeters"
    Case 8
2589:       ReturnDistanceUnitsName = "Centimeters"
    Case 9
2591:       ReturnDistanceUnitsName = "Meters"
    Case 10
2593:       ReturnDistanceUnitsName = "Kilometers"
    Case 11
2595:       ReturnDistanceUnitsName = "Decimal degrees"
    Case 12
2597:       ReturnDistanceUnitsName = "Decimeters"
2598:   End Select


  Exit Function
ErrorHandler:
  HandleError True, "ReturnDistanceUnitsName " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function ConvertLongBinary(lngNumber As Long, Optional MinimumNumDigits As Long = -1) As String
  On Error GoTo ErrorHandler


  Dim strBinary As String
  Dim lngIntermediate As Long
  Dim lngRemainder As Long
2613:   lngIntermediate = lngNumber
2614:   Do Until lngIntermediate = 1
2615:     lngRemainder = lngIntermediate Mod 2
2616:     lngIntermediate = Int(lngIntermediate / 2)
2617:     strBinary = CStr(lngRemainder) & strBinary
2618:   Loop
2619:   strBinary = "1" & strBinary
  
2621:   If Len(strBinary) < MinimumNumDigits Then
2622:     Do While Len(strBinary) < MinimumNumDigits
2623:       strBinary = "0" & strBinary
2624:     Loop
2625:   End If
  
2627:   ConvertLongBinary = strBinary


  Exit Function
ErrorHandler:
  HandleError True, "ConvertLongBinary " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function


Public Function ReturnLayersByType(pFocusMap As IMap, enumLayerTypes As JenLayerTypes) As esriSystem.IVariantArray
  On Error GoTo ErrorHandler


  Dim booFeatureLayers As Boolean
  Dim booRasterLayers As Boolean
  Dim booStandaloneTables As Boolean
  Dim booPointLayers As Boolean
  Dim booPolylineLayers As Boolean
  Dim booPolygonLayers As Boolean
  Dim booMultipointLayers As Boolean
  Dim booTinLayers As Boolean
  Dim booTerrainLayers As Boolean
  Dim booRasterCatalogLayers As Boolean
  
  Dim strBinary As String
2652:   strBinary = ConvertLongBinary(enumLayerTypes, 9)
'  MsgBox "Number = " & enumLayerTypes & vbCrLf & "Binary = " & strBinary
2654:   booFeatureLayers = Mid(strBinary, 9, 1) = "1"
2655:   booRasterLayers = Mid(strBinary, 8, 1) = "1"
2656:   booStandaloneTables = Mid(strBinary, 7, 1) = "1"
2657:   booPointLayers = Mid(strBinary, 6, 1) = "1"
2658:   booPolylineLayers = Mid(strBinary, 5, 1) = "1"
2659:   booPolygonLayers = Mid(strBinary, 4, 1) = "1"
2660:   booMultipointLayers = Mid(strBinary, 3, 1) = "1"
2661:   booTinLayers = Mid(strBinary, 2, 1) = "1"
2662:   booRasterCatalogLayers = Mid(strBinary, 1, 1) = "1"
  
'  MsgBox "booFeatureLayers = " & booFeatureLayers & vbCrLf & _
'      "booRasterLayers = " & booRasterLayers & vbCrLf & _
'      "booStandaloneTables = " & booStandaloneTables & vbCrLf & _
'      "booPointLayers = " & booPointLayers & vbCrLf & _
'      "booPolylineLayers = " & booPolylineLayers & vbCrLf & _
'      "booPolygonLayers = " & booPolygonLayers & vbCrLf & _
'      "booMultipointLayers = " & booMultipointLayers & vbCrLf & _
'      "booTinLayers = " & booTinLayers

  Dim pEnumLayer As IEnumLayer
  Dim pFeatureLayer As IFeatureLayer
  Dim pLayer As IUnknown
  Dim pFeatureClass As IFeatureClass
  Dim pGeometryType As esriGeometryType
  Dim pFeatureLayerForValid As IFeatureLayer
  Dim booOpenDialog As Boolean
2680:   booOpenDialog = False
  Dim pRasterLayer As IRasterLayer
'  Dim pAsLayer As ILayer
    
2684:   Set ReturnLayersByType = New esriSystem.VarArray
    
2686:   If (pFocusMap.LayerCount > 0) Then
2687:     Set pEnumLayer = pFocusMap.Layers(, True)
2688:     pEnumLayer.Reset
    
2690:     Set pLayer = pEnumLayer.Next
2691:     Do Until pLayer Is Nothing
'      Set pAsLayer = pLayer
'      MsgBox "Layer Name = " & pAsLayer.Name & vbCrLf & _
'             "Feature Layer:  " & CStr(TypeOf pLayer Is IFeatureLayer) & vbCrLf & _
'             "Raster Layer:  " & CStr(TypeOf pLayer Is IRasterLayer) & vbCrLf & _
'             "TIN Layer:  " & CStr(TypeOf pLayer Is ITinLayer)
             
2698:       If TypeOf pLayer Is IGdbRasterCatalogLayer Then
2699:         Set pFeatureLayerForValid = pLayer
2700:         If pFeatureLayerForValid.Valid Then
2701:           If booRasterCatalogLayers Then ReturnLayersByType.Add pLayer
2702:         End If
            
2704:       ElseIf TypeOf pLayer Is IFeatureLayer Then
2705:         Set pFeatureLayerForValid = pLayer
        ' CHECK IF FEATURE LAYER IS VALID
2707:         If pFeatureLayerForValid.Valid Then
          ' CHECK IF POLYGON LAYER
2709:           Set pFeatureClass = pFeatureLayerForValid.FeatureClass          ' CHECK IF FEATURE LAYER
2710:           pGeometryType = pFeatureClass.ShapeType
2711:           If booFeatureLayers Then
2712:             ReturnLayersByType.Add pLayer
2713:           Else
2714:             If (pGeometryType = esriGeometryPolygon) Then                 ' CHECK IF POLYGON LAYER
2715:               If booPolygonLayers Then ReturnLayersByType.Add pLayer
2716:             ElseIf pGeometryType = esriGeometryPolyline Then              ' CHECK IF POLYLINE LAYER
2717:               If booPolylineLayers Then ReturnLayersByType.Add pLayer
2718:             ElseIf pGeometryType = esriGeometryPoint Then                 ' CHECK IF POINT LAYER
2719:               If booPointLayers Then ReturnLayersByType.Add pLayer
2720:             ElseIf pGeometryType = esriGeometryMultipoint Then            ' CHECK IF MULTIPOINT LAYER
2721:               If booMultipointLayers Then ReturnLayersByType.Add pLayer
2722:             End If
2723:           End If
2724:         End If
2725:       ElseIf TypeOf pLayer Is IRasterLayer Then                           ' CHECK IF RASTER LAYER
2726:         Set pRasterLayer = pLayer
2727:         If pRasterLayer.Valid Then
2728:           If booRasterLayers Then ReturnLayersByType.Add pLayer
2729:         End If
2730:       ElseIf TypeOf pLayer Is ITinLayer Then                              ' CHECK IF TIN LAYER
        Dim pTinLayer As ITinLayer
2732:         Set pTinLayer = pLayer
2733:         If pTinLayer.Valid Then
2734:           If booTinLayers Then ReturnLayersByType.Add pLayer
2735:         End If
2736:       End If
2737:       Set pLayer = pEnumLayer.Next
2738:     Loop
2739:   End If
  
2741:   If booStandaloneTables Then
    Dim pSTCollection As IStandaloneTableCollection
2743:     Set pSTCollection = pFocusMap
    Dim pStTble As IStandaloneTable
2745:     If pSTCollection.StandaloneTableCount > 0 Then
      Dim lngIndex As Long
2747:       For lngIndex = 0 To pSTCollection.StandaloneTableCount - 1
2748:         Set pStTble = pSTCollection.StandaloneTable(lngIndex)
2749:         If booStandaloneTables Then ReturnLayersByType.Add pStTble
2750:       Next lngIndex
2751:     End If
2752:   End If
  
'  Dim strReport As String
'  For lngIndex = 0 To ReturnLayersByType.Count - 1
'    Set pAsLayer = ReturnLayersByType.Element(lngIndex)
'    strReport = strReport & CStr(lngIndex) & "] " & pAsLayer.Name & vbCrLf
'  Next lngIndex
'  MsgBox strReport


  Exit Function
ErrorHandler:
  HandleError True, "ReturnLayersByType " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function


Public Function BasicStatsFromVAT(anArray() As Double, dblSizeArray() As Double, _
      theFieldName As String, theTableName As String, _
      m_App As Application, Optional lngNumberHistBins As Long = -9999) As esriSystem.IVariantArray
  On Error GoTo ErrorHandler

  
  
  ' ASSUMES ARRAYS ARE SORTED!!!! --------------------------------------
  
  Dim pResponse As esriSystem.IVariantArray
2778:   Set pResponse = New esriSystem.VarArray
  
    ' PROGRESS BAR STUFF
  Dim psbar As IStatusBar
2782:   Set psbar = m_App.StatusBar
  Dim pPro As IStepProgressor
2784:   Set pPro = psbar.ProgressBar
  
  ' IF MAKING A HISTOGRAM
  Dim booMakeHistogram As Boolean
2788:   booMakeHistogram = (lngNumberHistBins > 0)
  Dim lngHistCountArray() As Long            ' WILL CONTAIN COUNTS OF VALUES LYING IN EACH HISTOGRAM BIN
2790:   If booMakeHistogram Then
    Dim dblHistLow As Double
    Dim dblHistHigh As Double
2793:     dblHistLow = anArray(0)
2794:     dblHistHigh = anArray(UBound(anArray))
    Dim dblInterval As Double
2796:     dblInterval = (dblHistHigh - dblHistLow) / lngNumberHistBins
    
    ReDim lngHistCountArray(lngNumberHistBins)
    Dim lngHistBinIndex As Long
2800:     lngHistBinIndex = 0
    Dim dblCurrentBinThreshold As Double
2802:     dblCurrentBinThreshold = dblHistLow + dblInterval
2803:   End If
  
2805:   Screen.MousePointer = vbHourglass
  
2807:   If booMakeHistogram Then
2808:     psbar.ShowProgressBar "Calculating Statistics on field [" & theFieldName & "] in " & theTableName, 1, _
          4 * (UBound(anArray) - 1), 1, True
2810:   Else
2811:     psbar.ShowProgressBar "Calculating Statistics on field [" & theFieldName & "] in " & theTableName, 1, _
          3 * (UBound(anArray) - 1), 1, True
2813:   End If
  
  Dim FoundMode As Boolean
2816:   FoundMode = False
  
  Dim theModeValList() As Double
  ReDim theModeValList(1, UBound(anArray))
  
  Dim theHighModeCount As Long
2822:   theHighModeCount = 0
  
  Dim anIndex As Long
  Dim theVal As Double
  Dim theSize As Double
  Dim theValTimesSize As Double
  Dim theModeCounter As Long
  Dim theModeIndex As Long
2830:   theModeIndex = -1
  
2832:   anIndex = 0
2833:   psbar.StepProgressBar
  
  ' IF MAKING HISTOGRAM
2836:   If booMakeHistogram Then
2837:     Do While anIndex <= UBound(anArray)
2838:       theVal = anArray(anIndex)
2839:       theSize = dblSizeArray(anIndex)
2840:       theValTimesSize = theVal * theSize
2841:       If theVal <= dblCurrentBinThreshold Then
2842:         lngHistCountArray(lngHistBinIndex) = lngHistCountArray(lngHistBinIndex) + theSize
2843:       Else
2844:         Do While dblCurrentBinThreshold < theVal
2845:           dblCurrentBinThreshold = dblCurrentBinThreshold + dblInterval
2846:           lngHistBinIndex = lngHistBinIndex + 1
2847:         Loop
2848:         lngHistCountArray(lngHistBinIndex) = theSize
2849:       End If
2850:       anIndex = anIndex + 1
2851:       psbar.StepProgressBar
2852:     Loop
2853:   End If
  
  '  PASS 1:  MODE --------------------------------------------------
2856:   anIndex = 0
  
2858:   Do While anIndex < UBound(anArray)
    
2860:     theModeCounter = 0
2861:     theVal = anArray(anIndex)
2862:     theSize = dblSizeArray(anIndex)
    
2864:     Do While (anIndex < UBound(anArray))
      ' IF THE NEXT VALUE UP IS DIFFERENT, THEN START NEW COUNT
2866:       If Not (anArray(anIndex + 1) = theVal) Then
2867:         theModeCounter = theSize
2868:         Exit Do
2869:       End If
            
      ' IF NEXT VALUE UP IS THE SAME, THEN ADD NEW SIZE TO CURRENT TALLY.  THEN CONTINUE LOOKING FOR A NEW VALUE.
2872:       theModeCounter = theModeCounter + theSize
      
2874:       anIndex = anIndex + 1
2875:       theSize = dblSizeArray(anIndex)
      
2877:       psbar.StepProgressBar
2878:     Loop
    
2880:     If theModeCounter > 1 Then
2881:       FoundMode = True
2882:       theModeIndex = theModeIndex + 1
2883:       theModeValList(0, theModeIndex) = theModeCounter
2884:       theModeValList(1, theModeIndex) = theVal
      
'      Debug.Print "Value = " & theModeValList(1, theModeIndex) & "[" & theModeValList(0, theModeIndex) & " cases]"
      
2888:     End If
    
2890:     anIndex = anIndex + 1
2891:     psbar.StepProgressBar
2892:   Loop
  
  Dim theModeString As String
  
  ' IF ANY VALUE OCCURED > 1 TIME
  Dim theFinalModes() As Double
2898:   If FoundMode Then
    ReDim Preserve theModeValList(1, theModeIndex)
    
    Dim theFinalModeCount As Long
2902:     theFinalModeCount = 0
    Dim theTempCount As Long
2904:     theTempCount = 0
        
    Dim theFinalModeIndex As Long
        
2908:     For anIndex = 0 To theModeIndex
2909:       theTempCount = theModeValList(0, anIndex)
2910:       If theTempCount > theFinalModeCount Then
2911:         theFinalModeCount = theTempCount
        ReDim theFinalModes(0)
2913:         theFinalModes(0) = theModeValList(1, anIndex)
2914:       ElseIf theTempCount = theFinalModeCount Then
2915:         theFinalModeIndex = UBound(theFinalModes) + 1
        ReDim Preserve theFinalModes(theFinalModeIndex)
2917:         theFinalModes(theFinalModeIndex) = theModeValList(1, anIndex)
2918:       End If
2919:     Next anIndex
    
2921:     If UBound(theFinalModes) > 0 Then
2922:       theModeString = UBound(theFinalModes) + 1 & " modes found [" & TopoCorridor.aml_func_mod.InsertCommas(theFinalModeCount) & " cases each]: Values = "
2923:       For anIndex = 0 To UBound(theFinalModes)
2924:         theModeString = theModeString & theFinalModes(anIndex) & ", "
2925:       Next anIndex
      
2927:       theModeString = TopoCorridor.aml_func_mod.BasicTrimAvenue(theModeString, "", ", ")
      
2929:     Else
2930:       theModeString = "1 mode found [" & TopoCorridor.aml_func_mod.InsertCommas(theFinalModeCount) & " cases]: Value = " & theFinalModes(0)
2931:     End If
    
2933:   Else
2934:     theModeString = " < No Mode Found >"
2935:   End If
  
  Dim theSum As Double
  Dim theCount As Double
  Dim theMinimum As Double
  Dim theMaximum As Double
  
2942:   theSum = 0
2943:   theCount = 0
2944:   theMinimum = anArray(0)
2945:   theMaximum = anArray(0)
  
  '  PASS 2:  MINIMUM, MAXIMUM AND SUM --------------------------------------------------
2948:   For anIndex = LBound(anArray) To UBound(anArray)
        
2950:     psbar.StepProgressBar
    
2952:     theVal = anArray(anIndex)
2953:     theSize = dblSizeArray(anIndex)
2954:     theCount = theCount + theSize
    
2956:     theValTimesSize = theVal * theSize
    
2958:     If theVal < theMinimum Then
2959:       theMinimum = theVal
2960:     End If
2961:     If theVal > theMaximum Then
2962:       theMaximum = theVal
2963:     End If
2964:     theSum = theSum + theValTimesSize
    
2966:   Next anIndex
  
  Dim theMean As Double
2969:   theMean = theSum / theCount
  
  Dim theSumSqDev As Double
  Dim theSqDev As Double
  Dim theMedian As Double
  Dim lngMiddleIndex As Long     ' DON'T HAVE TO WORRY ABOUT DECIMAL COUNTS BECAUSE WORKING WITH VAT.  ALL COUNTS ARE INTEGER.
  Dim theRunningCount As Double
2976:   theRunningCount = 0
  Dim booFoundMedian As Boolean
2978:   booFoundMedian = False
  
2980:   If theCount = 0 Then
2981:     lngMiddleIndex = 0
2982:   ElseIf theCount Mod 2 = 0 Then      ' EVEN NUMBER
'      theMedian = (anArray((theCount / 2) - 1) + anArray(theCount / 2)) / 2
2984:     lngMiddleIndex = (((theCount / 2) - 1) + (theCount / 2)) / 2
2985:   Else
'      theMedian = anArray((theCount - 1) / 2)
2987:     lngMiddleIndex = (theCount - 1) / 2
2988:   End If
  
  '  PASS 2: MEDIAN, STANDARD DEVIATION AND VARIANCE --------------------------------------------------
2991:   For anIndex = LBound(anArray) To UBound(anArray)
        
2993:     psbar.StepProgressBar
    
2995:     theVal = anArray(anIndex)
2996:     theSize = dblSizeArray(anIndex)
2997:     theRunningCount = theRunningCount + theSize
2998:     If Not booFoundMedian Then
2999:       If theRunningCount >= lngMiddleIndex Then
3000:         theMedian = theVal
3001:         booFoundMedian = True
3002:       End If
3003:     End If
3004:     theSqDev = theSize * ((theVal - theMean) * (theVal - theMean))
3005:     theSumSqDev = theSqDev + theSumSqDev
    
3007:   Next anIndex
  
  Dim theVariance As Double
  Dim theStDev As Double
  Dim theStErrMean As Double
  
3013:   If theCount > 0 Then
    
3015:     theVariance = theSumSqDev / (theCount - 1)
3016:     theStDev = Sqr(theVariance)
3017:     theStErrMean = theStDev / (Sqr(theCount))
    
3019:   Else
3020:     theMedian = -9999
3021:     theVariance = 0
3022:     theStDev = 0
3023:     theStErrMean = 0
3024:   End If

  Dim theRange As Double
3027:   theRange = theMaximum - theMinimum

  ' OUTPUT ARRAY; VARIANT BECAUSE OF MODE STRING
  '(0) = SUM
  '(1) = MEAN
  '(2) = MINIMUM
  '(3) = MAXIMUM
  '(4) = RANGE
  '(5) = COUNT
  '(6) = STANDARD DEVIATION
  '(7) = VARIANCE
  '(8) = MEDIAN
  '(9) = STANDARD ERROR OF MEAN
  '(10) = MODE STRING
  '(11) = DOUBLE ARRAY OF MODE VALUES
  '(12) = BOOLEAN INDICATING WHETHER MODE WAS FOUND
  '(13) = ARRAY OF HISTOGRAM BIN COUNTS
  
3045:   pResponse.Add theSum
3046:   pResponse.Add theMean
3047:   pResponse.Add theMinimum
3048:   pResponse.Add theMaximum
3049:   pResponse.Add theRange
3050:   pResponse.Add theCount
3051:   pResponse.Add theStDev
3052:   pResponse.Add theVariance
3053:   pResponse.Add theMedian
3054:   pResponse.Add theStErrMean
3055:   pResponse.Add theModeString
3056:   pResponse.Add theFinalModes
3057:   pResponse.Add FoundMode
3058:   pResponse.Add lngHistCountArray  ' WILL BE EMPTY ARRAY IF NO HISTOGRAM WAS REQUESTED
  
3060:   psbar.HideProgressBar
3061:   Screen.MousePointer = vbDefault
  
3063:   Set BasicStatsFromVAT = pResponse


  Exit Function
ErrorHandler:
  HandleError True, "BasicStatsFromVAT " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function BasicStatsFromArray_Weighted(anArray() As Double, theFieldName As String, theTableName As String, _
      m_App As Application) As esriSystem.IDoubleArray
  On Error GoTo ErrorHandler

  
  
  ' REQUIRES 2-DIMENSIONAL INPUT ARRAY, WHERE 1ST VALUE = VALUE AND SECOND VALUE = SIZE
  
  Dim pResponse As esriSystem.IDoubleArray
3080:   Set pResponse = New esriSystem.DoubleArray
  
    ' PROGRESS BAR STUFF
  Dim psbar As IStatusBar
3084:   Set psbar = m_App.StatusBar
  Dim pPro As IStepProgressor
3086:   Set pPro = psbar.ProgressBar
    
3088:   Screen.MousePointer = vbHourglass
  
3090:   psbar.ShowProgressBar "Calculating Statistics on field [" & theFieldName & "] in " & theTableName, 1, _
        2 * (UBound(anArray) - 1), 1, True
  
  Dim anIndex As Long
  Dim theVal As Double
  Dim theWeight As Double
  Dim theWeightedVal As Double
  
3098:   anIndex = 0
3099:   psbar.StepProgressBar
    
  Dim theSum As Double
  Dim theCount As Double
  Dim theMinimum As Double
  Dim theMaximum As Double
  
3106:   theCount = 0
  
  '  MINIMUM, MAXIMUM AND SUM --------------------------------------------------
3109:   For anIndex = LBound(anArray) To UBound(anArray)
        
3111:     psbar.StepProgressBar
    
3113:     theVal = anArray(anIndex, 0)
3114:     theWeight = anArray(anIndex, 1)
    
3116:     theCount = theCount + theWeight
3117:     theWeightedVal = theVal * theWeight
3118:     theSum = theSum + theWeightedVal
    
3120:   Next anIndex
  
  Dim theMean As Double
3123:   theMean = theSum / theCount
  
  Dim theSumSqDev As Double
3126:   theSumSqDev = 0
  Dim theSqDev As Double
  
  '  PASS 2:  STANDARD DEVIATION AND VARIANCE --------------------------------------------------
3130:   For anIndex = LBound(anArray) To UBound(anArray)
        
3132:     psbar.StepProgressBar
    
3134:     theVal = anArray(anIndex, 0)
3135:     theWeight = anArray(anIndex, 1)
3136:     theSqDev = theWeight * ((theVal - theMean) * (theVal - theMean))
3137:     theSumSqDev = theSqDev + theSumSqDev
    
3139:   Next anIndex
  
  Dim theVariance As Double
  Dim theStDev As Double
  
3144:   theVariance = theSumSqDev / theCount
3145:   theStDev = Sqr(theVariance)
  
3147:   pResponse.Add theMean
3148:   pResponse.Add theStDev
3149:   pResponse.Add theVariance
  
3151:   psbar.HideProgressBar
    
3153:   Screen.MousePointer = vbDefault
  
3155:   Set BasicStatsFromArray_Weighted = pResponse


  Exit Function
ErrorHandler:
  HandleError True, "BasicStatsFromArray_Weighted " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function BasicStatsFromArraySimple(anArray() As Double, Optional booVariance As Boolean = False) As esriSystem.IDoubleArray
  On Error GoTo ErrorHandler
  
  ' ASSUMES ARRAY IS SORTED!!!! --------------------------------------
  
  Dim pResponse As esriSystem.IDoubleArray
3169:   Set pResponse = New esriSystem.DoubleArray
  
  Dim anIndex As Long
  Dim theVal As Double

  Dim theSum As Double
  Dim theCount As Double
  Dim theMinimum As Double
  Dim theMaximum As Double
  
3179:   theSum = 0
3180:   theCount = UBound(anArray) + 1         ' ARRAY INDEX STARTS AT 0
3181:   theMinimum = anArray(0)
3182:   theMaximum = anArray(0)
  
  '  PASS 1:  MINIMUM, MAXIMUM AND SUM --------------------------------------------------
3185:   For anIndex = LBound(anArray) To UBound(anArray)
    
3187:     theVal = anArray(anIndex)
    
3189:     If theVal < theMinimum Then
3190:       theMinimum = theVal
3191:     End If
3192:     If theVal > theMaximum Then
3193:       theMaximum = theVal
3194:     End If
3195:     theSum = theSum + theVal
    
3197:   Next anIndex
  
  Dim theMean As Double
3200:   theMean = theSum / theCount
  
  Dim theSumSqDev As Double
  Dim theSqDev As Double
  
  '  PASS 2:  STANDARD DEVIATION AND VARIANCE --------------------------------------------------
3206:   If booVariance Then
3207:     For anIndex = LBound(anArray) To UBound(anArray)
                
3209:       theVal = anArray(anIndex)
3210:       theSqDev = (theVal - theMean) * (theVal - theMean)
3211:       theSumSqDev = theSqDev + theSumSqDev
      
3213:     Next anIndex
3214:   Else
3215:     theSqDev = 0
3216:     theSumSqDev = 0
3217:   End If
  
  Dim theMedian As Double
  Dim theVariance As Double
  Dim theStDev As Double
  Dim theStErrMean As Double
  
3224:   If theCount > 1 Then
3225:     If theCount Mod 2 = 0 Then      ' EVEN NUMBER
3226:       theMedian = (anArray((theCount / 2) - 1) + anArray(theCount / 2)) / 2
3227:     Else
3228:       theMedian = anArray((theCount - 1) / 2)
3229:     End If
    
3231:     theVariance = theSumSqDev / (theCount - 1)
3232:     theStDev = Sqr(theVariance)
3233:     theStErrMean = theStDev / (Sqr(theCount))
    
3235:   Else
3236:     theMedian = -9999
3237:     theVariance = 0
3238:     theStDev = 0
3239:     theStErrMean = 0
3240:   End If

  Dim theRange As Double
3243:   theRange = theMaximum - theMinimum

  ' OUTPUT ARRAY; VARIANT BECAUSE OF MODE STRING
  '(0) = SUM
  '(1) = MEAN
  '(2) = MINIMUM
  '(3) = MAXIMUM
  '(4) = RANGE
  '(5) = COUNT
  '(6) = STANDARD DEVIATION
  '(7) = VARIANCE
  '(8) = MEDIAN
  '(9) = STANDARD ERROR OF MEAN
  
3257:   pResponse.Add theSum
3258:   pResponse.Add theMean
3259:   pResponse.Add theMinimum
3260:   pResponse.Add theMaximum
3261:   pResponse.Add theRange
3262:   pResponse.Add theCount
3263:   pResponse.Add theStDev
3264:   pResponse.Add theVariance
3265:   pResponse.Add theMedian
3266:   pResponse.Add theStErrMean
  
3268:   Set BasicStatsFromArraySimple = pResponse

  Exit Function
ErrorHandler:
  HandleError True, "BasicStatsFromArraySimple " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function BasicStatsFromArray(anArray() As Double, theFieldName As String, theTableName As String, _
      m_App As Application, Optional lngNumberHistBins As Long = -9999) As esriSystem.IVariantArray
  On Error GoTo ErrorHandler

  
  
  ' ASSUMES ARRAY IS SORTED!!!! --------------------------------------
  
  Dim pResponse As esriSystem.IVariantArray
3284:   Set pResponse = New esriSystem.VarArray
  
    ' PROGRESS BAR STUFF
  Dim psbar As IStatusBar
3288:   Set psbar = m_App.StatusBar
  Dim pPro As IStepProgressor
3290:   Set pPro = psbar.ProgressBar
  
  ' IF MAKING A HISTOGRAM
  Dim booMakeHistogram As Boolean
3294:   booMakeHistogram = (lngNumberHistBins > 0)
  Dim lngHistCountArray() As Long            ' WILL CONTAIN COUNTS OF VALUES LYING IN EACH HISTOGRAM BIN
3296:   If booMakeHistogram Then
    Dim dblHistLow As Double
    Dim dblHistHigh As Double
3299:     dblHistLow = anArray(0)
3300:     dblHistHigh = anArray(UBound(anArray))
    Dim dblInterval As Double
3302:     dblInterval = (dblHistHigh - dblHistLow) / lngNumberHistBins
    
    ReDim lngHistCountArray(lngNumberHistBins)
    Dim lngHistBinIndex As Long
3306:     lngHistBinIndex = 0
    Dim dblCurrentBinThreshold As Double
3308:     dblCurrentBinThreshold = dblHistLow + dblInterval
3309:   End If
  
3311:   Screen.MousePointer = vbHourglass
  
3313:   If booMakeHistogram Then
3314:     psbar.ShowProgressBar "Calculating Statistics on field [" & theFieldName & "] in " & theTableName, 1, _
          4 * (UBound(anArray) - 1), 1, True
3316:   Else
3317:     psbar.ShowProgressBar "Calculating Statistics on field [" & theFieldName & "] in " & theTableName, 1, _
          3 * (UBound(anArray) - 1), 1, True
3319:   End If
  
  Dim FoundMode As Boolean
3322:   FoundMode = False
  
  Dim theModeValList() As Double
  ReDim theModeValList(1, UBound(anArray))
  
  Dim theHighModeCount As Long
3328:   theHighModeCount = 0
  
  Dim anIndex As Long
  Dim theVal As Double
  Dim theModeCounter As Long
  Dim theModeIndex As Long
3334:   theModeIndex = -1
  
3336:   anIndex = 0
3337:   psbar.StepProgressBar
  
  ' IF MAKING HISTOGRAM
3340:   If booMakeHistogram Then
3341:     Do While anIndex <= UBound(anArray)
3342:       theVal = anArray(anIndex)
3343:       If theVal <= dblCurrentBinThreshold Then
3344:         lngHistCountArray(lngHistBinIndex) = lngHistCountArray(lngHistBinIndex) + 1
3345:       Else
3346:         Do While dblCurrentBinThreshold < theVal
3347:           dblCurrentBinThreshold = dblCurrentBinThreshold + dblInterval
3348:           lngHistBinIndex = lngHistBinIndex + 1
3349:         Loop
3350:         lngHistCountArray(lngHistBinIndex) = 1
3351:       End If
3352:       anIndex = anIndex + 1
3353:       psbar.StepProgressBar
3354:     Loop
3355:   End If
  
  '  PASS 1:  MODE --------------------------------------------------
3358:   anIndex = 0
  
3360:   Do While anIndex < UBound(anArray)
    
3362:     theModeCounter = 1
3363:     theVal = anArray(anIndex)
    
3365:     Do While (anIndex < UBound(anArray))
3366:       If Not (anArray(anIndex + 1) = theVal) Then
3367:         Exit Do
3368:       End If
3369:       anIndex = anIndex + 1
3370:       psbar.StepProgressBar
3371:       theModeCounter = theModeCounter + 1
3372:     Loop
    
3374:     If theModeCounter > 1 Then
3375:       FoundMode = True
3376:       theModeIndex = theModeIndex + 1
3377:       theModeValList(0, theModeIndex) = theModeCounter
3378:       theModeValList(1, theModeIndex) = theVal
      
'      Debug.Print "Value = " & theModeValList(1, theModeIndex) & "[" & theModeValList(0, theModeIndex) & " cases]"
      
3382:     End If
    
3384:     anIndex = anIndex + 1
3385:     psbar.StepProgressBar
3386:   Loop
  
  Dim theModeString As String
  
  ' IF ANY VALUE OCCURED > 1 TIME
  Dim theFinalModes() As Double
3392:   If FoundMode Then
    ReDim Preserve theModeValList(1, theModeIndex)
    
    Dim theFinalModeCount As Long
3396:     theFinalModeCount = 0
    Dim theTempCount As Long
3398:     theTempCount = 0
        
    Dim theFinalModeIndex As Long
        
3402:     For anIndex = 0 To theModeIndex
3403:       theTempCount = theModeValList(0, anIndex)
3404:       If theTempCount > theFinalModeCount Then
3405:         theFinalModeCount = theTempCount
        ReDim theFinalModes(0)
3407:         theFinalModes(0) = theModeValList(1, anIndex)
3408:       ElseIf theTempCount = theFinalModeCount Then
3409:         theFinalModeIndex = UBound(theFinalModes) + 1
        ReDim Preserve theFinalModes(theFinalModeIndex)
3411:         theFinalModes(theFinalModeIndex) = theModeValList(1, anIndex)
3412:       End If
3413:     Next anIndex
    
3415:     If UBound(theFinalModes) > 0 Then
3416:       theModeString = UBound(theFinalModes) + 1 & " modes found [" & TopoCorridor.aml_func_mod.InsertCommas(theFinalModeCount) & " cases each]: Values = "
3417:       For anIndex = 0 To UBound(theFinalModes)
3418:         theModeString = theModeString & theFinalModes(anIndex) & ", "
3419:       Next anIndex
      
3421:       theModeString = TopoCorridor.aml_func_mod.BasicTrimAvenue(theModeString, "", ", ")
      
3423:     Else
3424:       theModeString = "1 mode found [" & TopoCorridor.aml_func_mod.InsertCommas(theFinalModeCount) & " cases]: Value = " & theFinalModes(0)
3425:     End If
    
3427:   Else
3428:     theModeString = " < No Mode Found >"
3429:   End If
  
  Dim theSum As Double
  Dim theCount As Double
  Dim theMinimum As Double
  Dim theMaximum As Double
  
3436:   theSum = 0
3437:   theCount = UBound(anArray) + 1         ' ARRAY INDEX STARTS AT 0
3438:   theMinimum = anArray(0)
3439:   theMaximum = anArray(0)
  
  '  PASS 2:  MINIMUM, MAXIMUM AND SUM --------------------------------------------------
3442:   For anIndex = LBound(anArray) To UBound(anArray)
        
3444:     psbar.StepProgressBar
    
3446:     theVal = anArray(anIndex)
    
3448:     If theVal < theMinimum Then
3449:       theMinimum = theVal
3450:     End If
3451:     If theVal > theMaximum Then
3452:       theMaximum = theVal
3453:     End If
3454:     theSum = theSum + theVal
    
3456:   Next anIndex
  
  Dim theMean As Double
3459:   theMean = theSum / theCount
  
  Dim theSumSqDev As Double
  Dim theSqDev As Double
  
  '  PASS 2:  STANDARD DEVIATION AND VARIANCE --------------------------------------------------
3465:   For anIndex = LBound(anArray) To UBound(anArray)
        
3467:     psbar.StepProgressBar
    
3469:     theVal = anArray(anIndex)
3470:     theSqDev = (theVal - theMean) * (theVal - theMean)
3471:     theSumSqDev = theSqDev + theSumSqDev
    
3473:   Next anIndex
  
  Dim theMedian As Double
  Dim theVariance As Double
  Dim theStDev As Double
  Dim theStErrMean As Double
  
3480:   If theCount > 1 Then
3481:     If theCount Mod 2 = 0 Then      ' EVEN NUMBER
3482:       theMedian = (anArray((theCount / 2) - 1) + anArray(theCount / 2)) / 2
3483:     Else
3484:       theMedian = anArray((theCount - 1) / 2)
3485:     End If
    
3487:     theVariance = theSumSqDev / (theCount - 1)
3488:     theStDev = Sqr(theVariance)
3489:     theStErrMean = theStDev / (Sqr(theCount))
    
3491:   Else
3492:     theMedian = -9999
3493:     theVariance = 0
3494:     theStDev = 0
3495:     theStErrMean = 0
3496:   End If

  Dim theRange As Double
3499:   theRange = theMaximum - theMinimum

  ' OUTPUT ARRAY; VARIANT BECAUSE OF MODE STRING
  '(0) = SUM
  '(1) = MEAN
  '(2) = MINIMUM
  '(3) = MAXIMUM
  '(4) = RANGE
  '(5) = COUNT
  '(6) = STANDARD DEVIATION
  '(7) = VARIANCE
  '(8) = MEDIAN
  '(9) = STANDARD ERROR OF MEAN
  '(10) = MODE STRING
  '(11) = DOUBLE ARRAY OF MODE VALUES
  '(12) = BOOLEAN INDICATING WHETHER MODE WAS FOUND
  '(13) = ARRAY OF HISTOGRAM BIN COUNTS
  
3517:   pResponse.Add theSum
3518:   pResponse.Add theMean
3519:   pResponse.Add theMinimum
3520:   pResponse.Add theMaximum
3521:   pResponse.Add theRange
3522:   pResponse.Add theCount
3523:   pResponse.Add theStDev
3524:   pResponse.Add theVariance
3525:   pResponse.Add theMedian
3526:   pResponse.Add theStErrMean
3527:   pResponse.Add theModeString
3528:   pResponse.Add theFinalModes
3529:   pResponse.Add FoundMode
3530:   pResponse.Add lngHistCountArray  ' WILL BE EMPTY ARRAY IF NO HISTOGRAM WAS REQUESTED
  
3532:   psbar.HideProgressBar
3533:   Screen.MousePointer = vbDefault
  
3535:   Set BasicStatsFromArray = pResponse


  Exit Function
ErrorHandler:
  HandleError True, "BasicStatsFromArray " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function


Public Function CalcStatistics(dblSortedNumbers() As Double, pStatOptions As esriSystem.IVariantArray, _
      Optional booReportProgress As Boolean, Optional pApp As IApplication) As esriSystem.IVariantArray
  On Error GoTo ErrorHandler


  ' FAO_WRD.Stat_CalcFieldStats
'
'Dim chkMean As Boolean
'Set chkMean = pStatOptions.Element(0)
'Dim chkSEMean As Boolean
'Set chkSEMean = pStatOptions.Element(1)
'Dim chkCIMean As Boolean
'Set chkCIMean = pStatOptions.Element(2)
'Dim ConLevel As Double
'Set ConLevel = pStatOptions.Element(3)
'Dim chkMinimum As Boolean
'Set chkMinimum = pStatOptions.Element(4)
'Dim chkQ1 As Boolean
'Set chkQ1 = pStatOptions.Element(5)
'Dim chkMedian As Boolean
'Set chkMedian = pStatOptions.Element(6)
'Dim chkQ3 As Boolean
'Set chkQ3 = pStatOptions.Element.Item(7)
'Dim chkMaximum As Boolean
'Set chkMaximum = pStatOptions.Element(8)
'Dim chkVariance As Boolean
'Set chkVariance = pStatOptions.Element(9)
'Dim chkStDev As Boolean
'Set chkStDev = pStatOptions.Element(10)
'Dim chkAvgDev As Boolean
'Set chkAvgDev = pStatOptions.Element(11)
'Dim chkSkewness As Boolean
'Set chkSkewness = pStatOptions.Element(12)
'Dim chkSkewnessFish As Boolean
'Set chkSkewnessFish = pStatOptions.Element(13)
'Dim chkKurtosis As Boolean
'Set chkKurtosis = pStatOptions.Element(14)
'Dim chkKurtosisFish As Boolean
'Set chkKurtosisFish = pStatOptions.Element(15)
'Dim chkCount As Boolean
'Set chkCount = pStatOptions.Element(16)
'Dim chkNumberNull As Boolean
'Set chkNumberNull = pStatOptions.Element(17)
'Dim chkSum As Boolean
'Set chkSum = pStatOptions.Element(18)
'Dim chkRange As Boolean
'Set chkRange = pStatOptions.Element(19)
'Dim chkMode As Boolean
'Set chkMode = pStatOptions.Element(20)
'
'' MakeHistogram = theResults.Get(21)
'
'Dim pResponse As esriSystem.IVariantArray
'Dim anIndex As Long
'For anIndex = 0 To 20
'  pResponse.Add Nothing
'Next anIndex
'
''' UNFORTUNATELY, THE HISTOGRAM FUNCTION WAS WRITTEN SEPARATELY AND THE STATS ARE IN A DIFFERENT ORDER
''theResponse = {nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil}
''theStatsForHistogramScript = {nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil}
''
''If (MakeHistogram) Then
''  chkMean = True
''  chkStDev = True
''  chkCount = True
''  chkMinimum = True
''  chkMaximum = True
''  theResults.Set(0,True)
''  theResults.Set(4,True)
''  theResults.Set(8,True)
''  theResults.Set(10,True)
''  theResults.Set(16,True)
''End
'
''' HELP IT RUN FASTER IF ONLY A FEW OPTIONS ARE CHECKED
'Dim DoQuantiles As Boolean
'Dim DoSkewKurt As Boolean
'Dim MoreThanBasic As Boolean
'Dim lngMultiplier As Long
'lngMultiplier = 1   ' FOR BASIC STATS
'
'' DIMENSION STATISTIC VARIABLES
'Dim theMean As Double
'Dim theSEMean As Double
'Dim LowerCI As Double
'Dim UpperCI As Double
'Dim theMinimum As Double
'Dim theQ1 As Double
'Dim theMedian As Double
'Dim theQ3 As Double
'Dim theMaximum As Double
'Dim theVar As Double
'Dim theStdDev As Double
'Dim theAvgDev As Double
'Dim theSkew As Double
'Dim theFisherSkew As Double
'Dim theKurt As Double
'Dim theFisherKurt As Double
'Dim theCount As Double
'Dim theNumberNull As Double
'Dim theSum As Double
'Dim theRange As Double
'Dim theModeString As String
'
'' BASIC STATS ARE Count, Minimum, Maximum, Mean, Sum
'DoQuantiles = (chkQ1 Or chkMedian Or chkQ3)
'DoSkewKurt = (chkSkewness Or chkSkewnessFish Or chkKurtosis Or chkKurtosisFish)
''MoreThanBasic = (DoQuantiles Or DoSkewKurt Or chkSEMean Or chkCIMean Or chkVariance Or chkStDev Or chkAvgDev Or MakeHistogram)
'MoreThanBasic = (DoQuantiles Or DoSkewKurt Or chkSEMean Or chkCIMean Or chkVariance Or chkStDev Or chkAvgDev)
'
'If chkVariance Or chkStDev Or chkAvgDev Then lngMultiplier = lngMultiplier + 1
'
'If DoQuantiles Then lngMultiplier = lngMultiplier + 1
'If DoSkewKurt Then lngMultiplier = lngMultiplier + 1
'If MoreThanBasic Then lngMultiplier = lngMultiplier + 1
'If chkMode Then lngMultiplier = lngMultiplier + 1
'
'If booReportProgress Then
'    ' PROGRESS BAR STUFF
'  Dim psbar As IStatusBar
'  Set psbar = pApp.StatusBar
'  Dim pPro As IStepProgressor
'  Set pPro = psbar.ProgressBar
'
'  Screen.MousePointer = vbHourglass
'
'  psbar.ShowProgressBar "Calculating Statistics on field [" & theFieldName & "] in " & theTableName, 1, _
'        lngMultiplier * (UBound(dblSortedNumbers) - 1), 1, True
'End If
'
'Dim theCount As Long
'theCount = UBound(dblSortedNumbers) - 1
'
'If chkMode Then  ' ASSUMES NUMBER ARRAY IS SORTED!
'
'  Dim pFoundMode As Boolean
'  Dim theModeValList() As Double
'  ReDim theModeValList(1, UBound(dblSortedNumbers))
'
'  Dim theHighModeCount As Long
'  theHighModeCount = 0
'
'  Dim theVal As Double
'  Dim theModeCounter As Long
'  Dim theModeIndex As Long
'  theModeIndex = -1
'
'  anIndex = 0
'
'  Do While anIndex < UBound(dblSortedNumbers)
'
'    theModeCounter = 1
'    theVal = dblSortedNumbers(anIndex)
'
'    Do While (anIndex < UBound(dblSortedNumbers))
'      If Not (dblSortedNumbers(anIndex + 1) = theVal) Then
'        Exit Do
'      End If
'      anIndex = anIndex + 1
'      If booReportProgress Then psbar.StepProgressBar
'      theModeCounter = theModeCounter + 1
'    Loop
'
'    If theModeCounter > 1 Then
'      FoundMode = True
'      theModeIndex = theModeIndex + 1
'      theModeValList(0, theModeIndex) = theModeCounter
'      theModeValList(1, theModeIndex) = theVal
'
''      Debug.Print "Value = " & theModeValList(1, theModeIndex) & "[" & theModeValList(0, theModeIndex) & " cases]"
'
'    End If
'
'    anIndex = anIndex + 1
'    If booReportProgress Then psbar.StepProgressBar
'  Loop
'
'  Dim theModeString As String
'
'  ' IF ANY VALUE OCCURED > 1 TIME
'  If FoundMode Then
'    ReDim Preserve theModeValList(1, theModeIndex)
'    Dim theFinalModes() As Double
'    Dim theFinalModeCount As Long
'    theFinalModeCount = 0
'    Dim theTempCount As Long
'    theTempCount = 0
'
'    Dim theFinalModeIndex As Long
'
'    For anIndex = 0 To theModeIndex
'      theTempCount = theModeValList(0, anIndex)
'      If theTempCount > theFinalModeCount Then
'        theFinalModeCount = theTempCount
'        ReDim theFinalModes(0)
'        theFinalModes(0) = theModeValList(1, anIndex)
'      ElseIf theTempCount = theFinalModeCount Then
'        theFinalModeIndex = UBound(theFinalModes) + 1
'        ReDim Preserve theFinalModes(theFinalModeIndex)
'        theFinalModes(theFinalModeIndex) = theModeValList(1, anIndex)
'      End If
'    Next anIndex
'
'    If UBound(theFinalModes) > 0 Then
'      theModeString = UBound(theFinalModes) + 1 & " modes found [" & TopoCorridor.aml_func_mod.InsertCommas(theFinalModeCount) & " cases each]: Values = "
'      For anIndex = 0 To UBound(theFinalModes)
'        theModeString = theModeString & theFinalModes(anIndex) & ", "
'      Next anIndex
'
'      theModeString = TopoCorridor.aml_func_mod.BasicTrimAvenue(theModeString, "", ", ")
'
'    Else
'      theModeString = "1 mode found [" & TopoCorridor.aml_func_mod.InsertCommas(theFinalModeCount) & " cases]: Value = " & theFinalModes(0)
'    End If
'
'  Else
'    theModeString = " < No Mode Found >"
'  End If
'End If
'
'theSum = 0
'theCount = UBound(dblSortedNumbers) + 1         ' ARRAY INDEX STARTS AT 0
'theMinimum = dblSortedNumbers(0)
'theMaximum = dblSortedNumbers(0)
'
''  PASS 2:  MINIMUM, MAXIMUM AND SUM --------------------------------------------------
'For anIndex = LBound(dblSortedNumbers) To UBound(dblSortedNumbers)
'
'  If booReportProgress Then psbar.StepProgressBar
'
'  theVal = dblSortedNumbers(anIndex)
'
'  If theVal < theMinimum Then
'    theMinimum = theVal
'  End If
'  If theVal > theMaximum Then
'    theMaximum = theVal
'  End If
'  theSum = theSum + theVal
'
'Next anIndex
'
'Dim theMean As Double
'theMean = theSum / theCount
'
'Dim theSumSqDev As Double
'Dim theSqDev As Double
'
''  PASS 2:  STANDARD DEVIATION AND VARIANCE --------------------------------------------------
'For anIndex = LBound(dblSortedNumbers) To UBound(dblSortedNumbers)
'
'  If booReportProgress Then psbar.StepProgressBar
'
'  theVal = dblSortedNumbers(anIndex)
'  theSqDev = (theVal - theMean) * (theVal - theMean)
'  theSumSqDev = theSqDev + theSumSqDev
'
'Next anIndex
'
'Dim theMedian As Double
'Dim theVariance As Double
'Dim theStDev As Double
'Dim theStErrMean As Double
'
'If theCount > 1 Then
'  If theCount Mod 2 = 0 Then      ' EVEN NUMBER
'    theMedian = (dblSortedNumbers((theCount / 2) - 1) + dblSortedNumbers(theCount / 2)) / 2
'  Else
'    theMedian = dblSortedNumbers((theCount - 1) / 2)
'  End If
'
'  theVariance = theSumSqDev / (theCount - 1)
'  theStDev = Sqr(theVariance)
'  theStErrMean = theStDev / (Sqr(theCount))
'
'Else
'  theMedian = -9999
'  theVariance = 0
'  theStDev = 0
'  theStErrMean = 0
'End If
'
'Dim theRange As Double
'theRange = theMaximum - theMinimum
'
'' OUTPUT ARRAY; VARIANT BECAUSE OF MODE STRING
''(0) = SUM
''(1) = MEAN
''(2) = MINIMUM
''(3) = MAXIMUM
''(4) = RANGE
''(5) = COUNT
''(6) = STANDARD DEVIATION
''(7) = VARIANCE
''(8) = MEDIAN
''(9) = STANDARD ERROR OF MEAN
''(10) = MODE STRING
'
'theStatsArray(0) = theSum
'theStatsArray(1) = theMean
'theStatsArray(2) = theMinimum
'theStatsArray(3) = theMaximum
'theStatsArray(4) = theRange
'theStatsArray(5) = theCount
'theStatsArray(6) = theStDev
'theStatsArray(7) = theVariance
'theStatsArray(8) = theMedian
'theStatsArray(9) = theStErrMean
'theStatsArray(10) = theModeString
'
''If (chkMode) Then
''  FoundMode = False
''  theModeValList = {}
''  theHighModeCount = 0
''  theDictionaryOfValues = Dictionary.Make(theCount)
''End
''
''theList = {}
''theNumberNull = 0
''theSum = 0
''theCounter = 0
''av.ClearStatus
''
''av.ShowMsg ("Calculating Pass 1")
''For Each aRecord In theSelection
''  theCounter = theCounter + 1
''  av.SetStatus ((theCounter / theCount) * 100)
''  theX = theVTab.ReturnValue(theField, aRecord)
''  If (theX.IsNull) Then
''    theNumberNull = theNumberNull + 1
''  Else
''    theList.Add (theX)
''    theSum = theSum + theX
''
''    ' CALCULATE MODE
''    If (chkMode) Then
''      theModeCount = theDictionaryOfValues.Get(theX)
''      If (theModeCount = nil) Then
''        theModeCount = 1
''      Else
''        theModeCount = theModeCount + 1
''        FoundMode = True
''      End
''      theDictionaryOfValues.Set(theX, theModeCount)
''
''      If (theModeCount > theHighModeCount) Then
''        theModeValList = {theX}
''        theHighModeCount = theModeCount
''      ElseIf (theModeCount = theHighModeCount) Then
''        theModeValList.Add (theX)
''      End
''    End
''  End
''End
''av.ClearStatus
''
''If (theList.Count = 0) Then
''  msgBox.Info("No data available to calculate!  Bailing out...", "")
''  return nil
''End
''
''If (chkMode) Then
''  If (FoundMode) Then
''    theModeValList.RemoveDuplicates
''    theModeValList.Sort (True)
''    theModeString = ""
''    For Each aModeVal In theModeValList
''      theModeString = theModeString + aModeVal.AsString + ", "
''    End
''    theModeString = theModeString.Left(theModeString.Count - 2)
''  Else
''    theModeString = " < No Mode Found >"
''  End
''End
''
''theTotalCount = theCount - theNumberNull
''
''theMean = theSum / theTotalCount
''
''If (MoreThanBasic) Then
''  av.ShowMsg ("Second Pass")
''  theCounter = 0
''
''  theAvgDev = 0
''  theMoment2 = 0
''  theMoment3 = 0
''  theMoment4 = 0
''  For Each anX In theList
''    theCounter = theCounter + 1
''    av.SetStatus ((theCounter / theTotalCount) * 100)
''    theDev = anX - theMean
''    theAvgDev = theAvgDev + (theDev.Abs)
''    theMoment2 = theMoment2 + (theDev ^ 2)
''    If (DoSkewKurt) Then
''      theMoment3 = theMoment3 + (theDev ^ 3)
''      theMoment4 = theMoment4 + (theDev ^ 4)
''    End
''  End
''  av.ClearStatus
''
''  ' MEAN, STANDARD DEVIATION, SKEWNESS, KURTOSIS --------------------------------
''  theVar = theMoment2 / (theTotalCount - 1)
''  theStdDev = theVar.Sqrt
''  theAvgDev = theAvgDev / theTotalCount
''
''  theMoment2 = theMoment2 / theTotalCount
''
''  If (DoSkewKurt) Then
''    theMoment3 = theMoment3 / theTotalCount
''    theMoment4 = theMoment4 / theTotalCount
''
''    theSkew = theMoment3 / (theMoment2 ^ (3 / 2))
''    theFisherSkew  = (theSkew*((theTotalCount*(theTotalCount-1)).sqrt))/(theTotalCount-2)
''
''    theKurt = theMoment4 / (theMoment2 ^ 2)
''    theFisherKurt = ((theTotalCount + 1) * (theTotalCount - 1)) / ((theTotalCount - 2) * (theTotalCount - 3))
''    theFisherKurt = theFisherKurt * (theKurt - (3 * (theTotalCount - 1) / (theTotalCount + 1)))
''
''    If (theVar <> 0) Then
''      theSkew = theMoment3 / (theMoment2 ^ (3 / 2))
''      theFisherSkew  = (theSkew*((theTotalCount*(theTotalCount-1)).sqrt))/(theTotalCount-2)
''
''      theKurt = theMoment4 / (theMoment2 ^ 2)
''      theFisherKurt = ((theTotalCount + 1) * (theTotalCount - 1)) / ((theTotalCount - 2) * (theTotalCount - 3))
''      theFisherKurt = theFisherKurt * (theKurt - (3 * (theTotalCount - 1) / (theTotalCount + 1)))
''    Else
''      theSkew = Number.MakeNull
''      theKurt = Number.MakeNull
''    End
''  End
''
''  ' STANDARD ERROR OF MEAN, CONFIDENCE INTERVALS
''  theSEMean = theStdDev / (theTotalCount.Sqrt)
''  If (chkCIMean) Then
''    theAlphaOver2 = 1 - ((1 - ConLevel) / 2)
''    theT = av.Run("FAO_WRD.Stat_IDF_StudentsT", {theAlphaOver2, (theTotalCount-1)})
''    theFactor = theSEMean * theT
''    LowerCI = theMean - theFactor
''    UpperCI = theMean + theFactor
''  End
''
''  ' QUANTILE DATA -----------------------------------------------------------------
''  If (DoQuantiles) Then
''
''    av.ShowMsg ("Calculating Quantile Data...")
''
''    theList.Sort (True)
''    theMinimum = theList.Get(0)
''    theMaximum = theList.Get(theList.Count - 1)
''    theRange = theMaximum - theMinimum
''
''    theListCount = theList.Count
''    theQ1Index = (theListCount + 1) * 0.25
''    theQ2Index = (theListCount + 1) * 0.5
''    theQ3Index = (theListCount + 1) * 0.75
''
''    If (theQ1Index.Round = theQ1Index) Then
''      theQ1 = theList.Get(theQ1Index - 1)
''    Else
''      theFloor = theList.Get((theQ1Index-1).Floor.Max(0))    ' POSSIBLE THAT IT COULD TRY TO GET INDEX -1, SO MAX IT WITH 0
''      theCeiling = theList.Get((theQ1Index-1).Ceiling)
''      theQ1 = (theFloor + theCeiling) / 2
''    End
''
''    If (theQ2Index.Round = theQ2Index) Then
''      theMedian = theList.Get(theQ2Index - 1)
''    Else
''      theFloor = theList.Get((theQ2Index-1).Floor)
''      theCeiling = theList.Get((theQ2Index-1).Ceiling)
''      theMedian = (theFloor + theCeiling) / 2
''    End
''
''    If (theQ3Index.Round = theQ3Index) Then
''      theQ3 = theList.Get(theQ3Index - 1)
''    Else
''      theFloor = theList.Get((theQ3Index-1).Floor)
''      theCeiling = theList.Get((theQ3Index-1).Ceiling.Min(theListCount-1))  ' POSSIBLE THAT IT COULD TRY TO GET INDEX (COUNT+1), SO MIN IT WITH COUNT
''
''      theQ3 = (theFloor + theCeiling) / 2
''    End
''  End
''End   ' END MORE THAN BASIC
''
'
'
'
'If booReportProgress Then
'  psbar.HideProgressBar
'  Screen.MousePointer = vbDefault
'End If
'
'If chkMean Then pResponse.Element(0) = theMean
'If chkSEMean Then pResponse.Element(1) = theSEMean
'If chkCIMean Then pResponse.Element(2) = LowerCI
'If chkCIMean Then pResponse.Element(3) = UpperCI
'If chkMinimum Then pResponse.Element(4) = theMinimum
'If chkQ1 Then pResponse.Element(5) = theQ1
'If chkMedian Then pResponse.Element(6) = theMedian
'If chkQ3 Then pResponse.Element(7) = theQ3
'If chkMaximum Then pResponse.Element(8) = theMaximum
'If chkVariance Then pResponse.Element(9) = theVar
'If chkStDev Then pResponse.Element(10) = theStdDev
'If chkAvgDev Then pResponse.Element(11) = theAvgDev
'If chkSkewness Then pResponse.Element(12) = theSkew
'If chkSkewnessFish Then pResponse.Element(13) = theFisherSkew
'If chkKurtosis Then pResponse.Element(14) = theKurt
'If chkKurtosisFish Then pResponse.Element(15) = theFisherKurt
'If chkCount Then pResponse.Element(16) = theCount
'If chkNumberNull Then pResponse.Element(17) = theNumberNull
'If chkSum Then pResponse.Element(18) = theSum
'If chkRange Then pResponse.Element(19) = theRange
'If chkMode Then pResponse.Element(20) = theModeString
'
'
'


  Exit Function
ErrorHandler:
  HandleError True, "CalcStatistics " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function Graphic_ReturnElementFromGeometry(ByRef pMxDoc As IMxDocument, ByRef pGeometry As IGeometry, _
    Optional strName As String, Optional AddToView As Boolean) As IElement
  On Error GoTo ErrorHandler

  
  Dim pMxDocument As esriArcMapUI.IMxDocument
  Dim pActiveView As esriCarto.IActiveView
  
  Dim pGContainer As IGraphicsContainer
4076:   Set pGContainer = pMxDoc.FocusMap
  
  Dim pElement As IElement
  Dim pPolygonElement As IPolygonElement
  Dim pSpatialReference As ISpatialReference
  Dim pGraphicElement As IGraphicElement
  Dim pElementProperties As IElementProperties
  
  Dim pClone As IClone
4085:   Set pClone = pGeometry
  Dim pNewGeometry As IGeometry
4087:   Set pNewGeometry = pClone.Clone
  
  Dim pGeometryType As esriGeometryType
4090:   pGeometryType = pNewGeometry.GeometryType
  
  'ADD GEOMETRY, NAME AND SPATIAL REFERENCE TO GRAPHIC ELEMENT
  Select Case pGeometryType
    Case 0:
4095:       MsgBox "Null Geometry!  No graphic added..."
    Case 1, 2:
4097:       Set pElement = New MarkerElement
    Case 3, 6, 13, 14, 15, 16:
4099:       Set pElement = New LineElement
    Case 4, 11:
4101:       Set pElement = New PolygonElement
    Case 5:
4103:       Set pElement = New RectangleElement
    Case Else:
4105:       MsgBox "Unexpected Shape Type:  Unable to add graphic..."
      Exit Function
4107:   End Select
  
  
4110:   If pGeometryType = 2 Then
    Dim pGroupElement As IGroupElement2
4112:     Set pGroupElement = New GroupElement
    Dim pSubElement As IElement
4114:     Set pSubElement = New MarkerElement
    Dim lngIndex As Long
    Dim pPtColl As IPointCollection
4117:     Set pPtColl = pNewGeometry
    Dim pPt As IPoint
4119:     For lngIndex = 0 To pPtColl.PointCount - 1
4120:       Set pPt = pPtColl.Point(lngIndex)
4121:       Set pSubElement = New MarkerElement
4122:       pSubElement.Geometry = pPt
4123:       pGroupElement.AddElement pSubElement
4124:     Next lngIndex
4125:     Set pGraphicElement = pGroupElement
4126:     Set pSpatialReference = pGeometry.SpatialReference
4127:     Set pGraphicElement.SpatialReference = pSpatialReference
4128:     Set pElementProperties = pGroupElement
4129:     pElementProperties.Name = strName
4130:     If AddToView Then
      ' ADD GRAPHIC TO GRAPHICS CONTAINER
4132:       pGContainer.AddElement pGroupElement, 0
      'Draw
4134:       pMxDoc.ActiveView.PartialRefresh esriViewGraphics, Nothing, Nothing
4135:     End If

4137:   Else
4138:     pElement.Geometry = pNewGeometry
4139:     Set pGraphicElement = pElement
4140:     Set pSpatialReference = pGeometry.SpatialReference
4141:     Set pGraphicElement.SpatialReference = pSpatialReference
4142:     Set pElementProperties = pElement
4143:     pElementProperties.Name = strName
  
4145:     If AddToView Then
      ' ADD GRAPHIC TO GRAPHICS CONTAINER
4147:       pGContainer.AddElement pElement, 0
      'Draw
4149:       pMxDoc.ActiveView.PartialRefresh esriViewGraphics, Nothing, Nothing
4150:     End If

4152:   End If
  
  
4155:   Set Graphic_ReturnElementFromGeometry = pElement


  Exit Function
ErrorHandler:
  HandleError True, "Graphic_ReturnElementFromGeometry " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function
Public Sub Graphic_MakeFromGeometry(ByRef pMxDoc As IMxDocument, ByRef pGeometry As IGeometry, Optional strName As String)
  On Error GoTo ErrorHandler

  
  Dim pMxDocument As esriArcMapUI.IMxDocument
  Dim pActiveView As esriCarto.IActiveView
  
  Dim pGContainer As IGraphicsContainer
4170:   Set pGContainer = pMxDoc.FocusMap
  
  Dim pElement As IElement
  Dim pPolygonElement As IPolygonElement
  Dim pSpatialReference As ISpatialReference
  Dim pGraphicElement As IGraphicElement
  Dim pElementProperties As IElementProperties
  
  Dim pClone As IClone
4179:   Set pClone = pGeometry
  Dim pNewGeometry As IGeometry
4181:   Set pNewGeometry = pClone.Clone
  
  Dim pGeometryType As esriGeometryType
4184:   pGeometryType = pNewGeometry.GeometryType
  
  'ADD GEOMETRY, NAME AND SPATIAL REFERENCE TO GRAPHIC ELEMENT
  Select Case pGeometryType
    Case 0:
4189:       MsgBox "Null Geometry!  No graphic added..."
    Case 1:
4191:       Set pElement = New MarkerElement
    Case 2:
4193:       Set pElement = New GroupElement
    Case 3, 6, 13, 14, 15, 16:
4195:       Set pElement = New LineElement
    Case 4, 11:
4197:       Set pElement = New PolygonElement
    Case 5:
4199:       Set pElement = New RectangleElement
    Case Else:
4201:       MsgBox "Unexpected Shape Type:  Unable to add graphic..."
4202:   End Select
  
4204:   If pGeometryType = 2 Then
    Dim pGroupElement As IGroupElement2
4206:     Set pGroupElement = New GroupElement
    Dim pSubElement As IElement
4208:     Set pSubElement = New MarkerElement
    Dim lngIndex As Long
    Dim pPtColl As IPointCollection
4211:     Set pPtColl = pNewGeometry
    Dim pPt As IPoint
4213:     For lngIndex = 0 To pPtColl.PointCount - 1
4214:       Set pPt = pPtColl.Point(lngIndex)
4215:       Set pSubElement = New MarkerElement
4216:       pSubElement.Geometry = pPt
4217:       pGroupElement.AddElement pSubElement
4218:     Next lngIndex
4219:     Set pGraphicElement = pGroupElement
4220:     Set pSpatialReference = pGeometry.SpatialReference
4221:     Set pGraphicElement.SpatialReference = pSpatialReference
4222:     Set pElementProperties = pGroupElement
4223:     pElementProperties.Name = strName
    ' ADD GRAPHIC TO GRAPHICS CONTAINER
4225:     pGContainer.AddElement pGroupElement, 0
4226:   Else
4227:     pElement.Geometry = pNewGeometry
4228:     Set pGraphicElement = pElement
4229:     Set pSpatialReference = pGeometry.SpatialReference
4230:     Set pGraphicElement.SpatialReference = pSpatialReference
4231:     Set pElementProperties = pElement
4232:     pElementProperties.Name = strName
  
    ' ADD GRAPHIC TO GRAPHICS CONTAINER
4235:     pGContainer.AddElement pElement, 0
4236:   End If

  'Draw
4239:   pMxDoc.ActiveView.PartialRefresh esriViewGraphics, Nothing, Nothing


  Exit Sub
ErrorHandler:
  HandleError True, "Graphic_MakeFromGeometry " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
Public Sub OpenDoc(theDocFilename As String, theDocPath As String)
  On Error GoTo ErrorHandler


    ' CHECK IF FILE EXISTS
    Dim booFileExists As Boolean
    Dim theCheckFilename As String
4253:     If Right(theDocPath, 1) = "\" Or Right(theDocPath, 1) = "/" Then
4254:       theCheckFilename = theDocPath & theDocFilename
4255:     Else
4256:       theCheckFilename = theDocPath & "\" & theDocFilename
4257:     End If
    
4259:     booFileExists = Dir(theCheckFilename) <> ""
    
4261:     If booFileExists Then
4262:       Call ShellExecute(0, vbNullString, theDocFilename, vbNullString, theDocPath, 1)
4263:     Else
4264:       MsgBox "Unable to find the following file:" & vbCrLf & vbCrLf & theCheckFilename & vbCrLf & _
            vbCrLf & "Bailing out...", , "Missing File:"
4266:     End If


  Exit Sub
ErrorHandler:
  HandleError True, "OpenDoc " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Public Function MakeColorRGB(pRed As Integer, pGreen As Integer, pBlue As Integer) As IColor
  On Error GoTo ErrorHandler


  Dim pColor As IRgbColor
4279:   Set pColor = New RgbColor
4280:   pColor.Red = pRed
4281:   pColor.Blue = pBlue
4282:   pColor.Green = pGreen
4283:   pColor.UseWindowsDithering = True
  
4285:   Set MakeColorRGB = pColor


  Exit Function
ErrorHandler:
  HandleError True, "MakeColorRGB " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function
Public Function MakeColorHSV(pHue As Integer, pSaturation As Integer, pValue As Integer) As IColor
  On Error GoTo ErrorHandler


  Dim pColor As IHsvColor
4297:   Set pColor = New HsvColor
4298:   pColor.Hue = pHue
4299:   pColor.Saturation = pSaturation
4300:   pColor.Value = pValue
4301:   pColor.UseWindowsDithering = True
  
4303:   Set MakeColorHSV = pColor


  Exit Function
ErrorHandler:
  HandleError True, "MakeColorHSV " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function
Public Sub GraphicsSetNameSelected(ByRef pMxDoc As IMxDocument, strName As String)
  On Error GoTo ErrorHandler


  Dim pGraphicsContainerSelect As IGraphicsContainerSelect
  
4316:   Set pGraphicsContainerSelect = pMxDoc.FocusMap
  Dim pEnumElement As IEnumElement
4318:   Set pEnumElement = pGraphicsContainerSelect.SelectedElements
4319:   pEnumElement.Reset
  
  Dim pElement As IElement
  Dim pElementProperties As IElementProperties
  
4324:   Set pElement = pEnumElement.Next
  
4326:   While Not pElement Is Nothing
4327:     Set pElementProperties = pElement
4328:     pElementProperties.Name = strName
4329:     Set pElement = pEnumElement.Next
4330:   Wend

  Exit Sub


  Exit Sub
ErrorHandler:
  HandleError True, "GraphicsSetNameSelected " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Public Function ReturnGraphicsByName(ByRef pMxDoc As IMxDocument, strName As String, _
      Optional AsElements As Boolean) As IArray
  On Error GoTo ErrorHandler


  Dim pGraphicsContainer As IGraphicsContainer
  
4347:   Set pGraphicsContainer = pMxDoc.FocusMap
  
4349:   pGraphicsContainer.Reset
  
  Dim pElement As IElement
  Dim pElementProperties As IElementProperties
  
4354:   Set pElement = pGraphicsContainer.Next
  
  Dim pArray As IArray
4357:   Set pArray = New esriSystem.Array
  Dim pGeometry As IGeometry
  Dim pClone As IClone
  
4361:   While Not pElement Is Nothing
4362:     Set pElementProperties = pElement
4363:     If pElementProperties.Name = strName Then
4364:       If AsElements Then
4365:         pArray.Add pElement
4366:       Else
4367:         Set pGeometry = pElement.Geometry
4368:         Set pClone = pGeometry
4369:         pArray.Add pClone.Clone     ' ONLY RETURN A COPY OF THE GEOMETRY; DON'T WANT TO MODIFY ACTUAL GRAPHIC HERE
4370:       End If
4371:     End If
4372:     Set pElement = pGraphicsContainer.Next
    
4374:   Wend
4375:   Set ReturnGraphicsByName = pArray


  Exit Function
ErrorHandler:
  HandleError True, "ReturnGraphicsByName " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function ReturnGraphicsByType(ByRef pMxDoc As IMxDocument, intGeometryType As esriGeometryType, _
      Optional AsElements As Boolean) As IArray
  On Error GoTo ErrorHandler


  Dim pGraphicsContainer As IGraphicsContainer
  
4390:   Set pGraphicsContainer = pMxDoc.FocusMap
  
4392:   pGraphicsContainer.Reset
  
  Dim pElement As IElement
  Dim pElementProperties As IElementProperties
  
4397:   Set pElement = pGraphicsContainer.Next
  
  Dim pArray As IArray
4400:   Set pArray = New esriSystem.Array
  Dim pGeometry As IGeometry
  Dim pClone As IClone
  
  Dim pGeometryType As esriGeometryType
  
4406:   While Not pElement Is Nothing
4407:     Set pElementProperties = pElement
4408:     Set pGeometry = pElement.Geometry
4409:     pGeometryType = pGeometry.GeometryType
    
4411:     If pGeometryType = intGeometryType Then
4412:       If AsElements Then            ' IN THIS CASE RETURN THE ACTUAL GRAPHIC ELEMENT
4413:         pArray.Add pElement
4414:       Else
4415:         Set pClone = pGeometry
4416:         pArray.Add pClone.Clone     ' ONLY RETURN A COPY OF THE GEOMETRY; DON'T WANT TO MODIFY ACTUAL GRAPHIC HERE
4417:       End If
4418:     End If
4419:     Set pElement = pGraphicsContainer.Next
    
4421:   Wend
4422:   Set ReturnGraphicsByType = pArray


  Exit Function
ErrorHandler:
  HandleError True, "ReturnGraphicsByType " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Sub DeleteGraphicsByName(ByRef pMxDoc As IMxDocument, strName As String)
  On Error GoTo ErrorHandler


  Dim pGraphicsContainer As IGraphicsContainer
  Dim pActiveView As IActiveView
  
4437:   Set pGraphicsContainer = pMxDoc.FocusMap
4438:   Set pActiveView = pMxDoc.ActiveView
  
4440:   pGraphicsContainer.Reset
  
  Dim pElement As IElement
  Dim pElementProperties As IElementProperties
  
4445:   Set pElement = pGraphicsContainer.Next
  
  Dim pEnvelope As IEnvelope
  
4449:   While Not pElement Is Nothing
4450:     Set pElementProperties = pElement
    
4452:     If pElementProperties.Name = strName Then
4453:       pGraphicsContainer.DeleteElement pElement
4454:       If (pEnvelope Is Nothing) Then
4455:         Set pEnvelope = pElement.Geometry.Envelope
4456:       Else
4457:         pEnvelope.Union pElement.Geometry.Envelope
4458:       End If
4459:     End If
4460:     Set pElement = pGraphicsContainer.Next
    
4462:   Wend
  
4464:   If (Not pEnvelope Is Nothing) Then
4465:     pActiveView.PartialRefresh esriViewGraphics + esriViewGraphicSelection + esriViewGeography, Nothing, pEnvelope
4466:   End If


  Exit Sub
ErrorHandler:
  HandleError True, "DeleteGraphicsByName " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub


Public Sub DoSpatialQuery(pSourceFeatureLayer As IFeatureLayer, pTargetFeatureLayer As IFeatureLayer, DoAll As Boolean, _
    pSelRelationship As esriSpatialRelEnum)
  On Error GoTo ErrorHandler


  Dim pFLayer As IFeatureLayer
  Dim pFc As IFeatureClass
   
  ' Specify the polygon layer with currently selected features
4484:   Set pFLayer = pSourceFeatureLayer

  Dim pFeatSel As IFeatureSelection
4487:   Set pFeatSel = pFLayer
  
  Dim pSelSet As ISelectionSet
  
4491:   If DoAll Then
4492:     pFeatSel.SelectFeatures Nothing, esriSelectionResultNew, False
4493:   End If
  
4495:   Set pSelSet = pFeatSel.SelectionSet

  Dim pEnumGeom As IEnumGeometry
  Dim pEnumGeomBind As IEnumGeometryBind

4500:   Set pEnumGeom = New EnumFeatureGeometry
4501:   Set pEnumGeomBind = pEnumGeom
4502:   pEnumGeomBind.BindGeometrySource Nothing, pSelSet

  Dim pGeomFactory As IGeometryFactory
4505:   Set pGeomFactory = New GeometryEnvironment

  Dim pGeom As IGeometry
4508:   Set pGeom = pGeomFactory.CreateGeometryFromEnumerator(pEnumGeom)

  Dim pSpFilter As ISpatialFilter
4511:   Set pSpFilter = New SpatialFilter
4512:   With pSpFilter
4513:     Set .Geometry = pGeom
4514:     .GeometryField = "SHAPE"
4515:     .SpatialRel = pSelRelationship
4516:   End With
  
4518:   Set pFLayer = pTargetFeatureLayer
4519:   Set pFeatSel = pFLayer
  
4521:   pFeatSel.SelectFeatures pSpFilter, esriSelectionResultNew, False


  Exit Sub
ErrorHandler:
  HandleError True, "DoSpatialQuery " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub


Public Function ReturnCurrentMapUnits(pMap As IMap) As String
  On Error GoTo ErrorHandler


  Dim intEsriUnits As Integer
4535:   intEsriUnits = pMap.MapUnits
  
  Select Case intEsriUnits
    Case 0
4539:       ReturnCurrentMapUnits = "Unknown"
    Case 1
4541:       ReturnCurrentMapUnits = "Inches"
    Case 2
4543:       ReturnCurrentMapUnits = "Points"
    Case 3
4545:       ReturnCurrentMapUnits = "Feet"
    Case 4
4547:       ReturnCurrentMapUnits = "Yards"
    Case 5
4549:       ReturnCurrentMapUnits = "Miles"
    Case 6
4551:       ReturnCurrentMapUnits = "Nautical Miles"
    Case 7
4553:       ReturnCurrentMapUnits = "Millimeters"
    Case 8
4555:       ReturnCurrentMapUnits = "Centimeters"
    Case 9
4557:       ReturnCurrentMapUnits = "Meters"
    Case 10
4559:       ReturnCurrentMapUnits = "Kilometers"
    Case 11
4561:       ReturnCurrentMapUnits = "Decimal Degrees"
    Case 12
4563:       ReturnCurrentMapUnits = "Decimeters"
4564:   End Select


  Exit Function
ErrorHandler:
  HandleError True, "ReturnCurrentMapUnits " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function


Public Sub ForceUppercase(KeyAscii As Integer, txtTextBox As TextBox)
  On Error GoTo ErrorHandler

  
4577:   KeyAscii = Asc(UCase(Chr(KeyAscii)))


  Exit Sub
ErrorHandler:
  HandleError True, "ForceUppercase " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Public Sub CheckNumericReal(KeyAscii As Integer, txtTextBox As TextBox)
  On Error GoTo ErrorHandler


Select Case KeyAscii
  Case Is < 8
4591:     KeyAscii = 0
'  Case 8            ' BACKSPACE
  Case 9 To 43
4594:     KeyAscii = 0
  Case 45            ' "-" CHARACTER; INSERT AT BEGINNING OR REMOVE FROM BEGINNING
                     ' RESET CURSOR POSITION TO ORIGINAL CHARACTER LOCATION
4597:     KeyAscii = 0
    Dim strText As String
    Dim lngpos As Long
4600:     strText = txtTextBox.Text
4601:     lngpos = txtTextBox.SelStart
4602:     If Left(strText, 1) = "-" Then
4603:       txtTextBox.Text = Right(strText, Len(strText) - 1)
4604:       If lngpos > 0 Then
4605:         txtTextBox.SelStart = lngpos - 1
4606:       End If
4607:     Else
4608:       txtTextBox.Text = "-" & strText
4609:       txtTextBox.SelStart = lngpos + 1
4610:     End If
  Case 44 Or 46          ' DECIMAL CHARACTER; ONLY ALLOW ONE PERIOD OR COMMA
    Dim strText2 As String
4613:     strText2 = txtTextBox.Text
    Dim lngPos2 As Long
4615:     lngPos2 = txtTextBox.SelStart
4616:     If Not IsNumeric(Left(strText2, lngPos2) & Chr(KeyAscii) & Right(strText2, Len(strText2) - lngPos2)) Then
4617:       KeyAscii = 0
4618:     End If
  Case 47          ' "/" CHARACTER
4620:     KeyAscii = 0
  Case Is > 57
4622:     KeyAscii = 0
4623: End Select


  Exit Sub
ErrorHandler:
  HandleError True, "CheckNumericReal " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub


Public Sub CheckNumericRealPositive(KeyAscii As Integer, txtTextBox As TextBox)
  On Error GoTo ErrorHandler


Select Case KeyAscii
  Case Is < 8
4638:     KeyAscii = 0
'  Case 8            ' BACKSPACE
  Case 9 To 43
4641:     KeyAscii = 0
  Case 45            ' "-" CHARACTER
4643:     KeyAscii = 0

  Case 44 Or 46          ' DECIMAL CHARACTER; ONLY ALLOW ONE PERIOD OR COMMA
    Dim strText2 As String
4647:     strText2 = txtTextBox.Text
    Dim lngPos2 As Long
4649:     lngPos2 = txtTextBox.SelStart
4650:     If Not IsNumeric(Left(strText2, lngPos2) & Chr(KeyAscii) & Right(strText2, Len(strText2) - lngPos2)) Then
4651:       KeyAscii = 0
4652:     End If
  Case 47          ' "/" CHARACTER
4654:     KeyAscii = 0
  Case Is > 57
4656:     KeyAscii = 0
4657: End Select


  Exit Sub
ErrorHandler:
  HandleError True, "CheckNumericRealPositive " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
Public Sub CheckNumericInteger(KeyAscii As Integer, txtTextBox As TextBox)
  On Error GoTo ErrorHandler


Select Case KeyAscii
  Case Is < 8
4670:     KeyAscii = 0
'  Case 8            ' BACKSPACE
  Case 9 To 43
4673:     KeyAscii = 0
  Case 45            ' "-" CHARACTER; INSERT AT BEGINNING OR REMOVE FROM BEGINNING
                     ' RESET CURSOR POSITION TO ORIGINAL CHARACTER LOCATION
4676:     KeyAscii = 0
    Dim strText As String
    Dim lngpos As Long
4679:     strText = txtTextBox.Text
4680:     lngpos = txtTextBox.SelStart
4681:     If Left(strText, 1) = "-" Then
4682:       txtTextBox.Text = Right(strText, Len(strText) - 1)
4683:       If lngpos > 0 Then
4684:         txtTextBox.SelStart = lngpos - 1
4685:       End If
4686:     Else
4687:       txtTextBox.Text = "-" & strText
4688:       txtTextBox.SelStart = lngpos + 1
4689:     End If
  Case 44, 46, 47         ' PREVENT PERIOD OR COMMA DECIMAL CHARACTER
4691:     KeyAscii = 0
  Case Is > 57
4693:     KeyAscii = 0
4694: End Select


  Exit Sub
ErrorHandler:
  HandleError True, "CheckNumericInteger " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Public Sub CheckNumericIntegerPositive(KeyAscii As Integer, txtTextBox As TextBox)
  On Error GoTo ErrorHandler


' ONLY ALLOW NUMBERS AND BACKSPACE
Select Case KeyAscii
  Case Is < 8
4709:     KeyAscii = 0
'  Case 8            ' BACKSPACE
  Case 9 To 47
4712:     KeyAscii = 0
  Case Is > 57
4714:     KeyAscii = 0
4715: End Select


  Exit Sub
ErrorHandler:
  HandleError True, "CheckNumericIntegerPositive " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
Public Function CompareSpatialReferences(ByVal pSourceSR As ISpatialReference, ByVal pTargetSR As ISpatialReference) As Boolean
  On Error GoTo ErrorHandler

  
  Dim pSourceClone As IClone
  Dim pTargetClone As IClone
  Dim bSREqual As Boolean
  
4730:   Set pSourceClone = pSourceSR
4731:   Set pTargetClone = pTargetSR
  
  'MsgBox "pSourceClone is nothing = " & CStr(pSourceClone Is Nothing) & vbCrLf & _
        "pTargetClone is nothing = " & CStr(pTargetClone Is Nothing)
  
4736:   If pSourceClone Is Nothing And pTargetClone Is Nothing Then
4737:     CompareSpatialReferences = True
4738:   ElseIf pSourceClone Is Nothing Or pTargetClone Is Nothing Then
4739:     CompareSpatialReferences = False
4740:   Else
    
    'Compare the coordinate system component of the spatial reference
4743:     bSREqual = pSourceClone.IsEqual(pTargetClone)
    
    'If the comparison failed, return false and exit
4746:     If Not bSREqual Then
4747:       CompareSpatialReferences = False
      Exit Function
4749:     End If
    
    'We can also compare the XY precision to ensure the spatial references are equal
    Dim pSourceSR2 As ISpatialReference2
    Dim bXYIsEqual As Boolean
    
4755:     Set pSourceSR2 = pSourceSR
4756:     bXYIsEqual = pSourceSR2.IsXYPrecisionEqual(pTargetSR)
    
    'If the comparison failed, return false and exit
4759:     If Not bXYIsEqual Then
4760:       CompareSpatialReferences = False
      Exit Function
4762:     End If
    
4764:     CompareSpatialReferences = True
4765:   End If


  Exit Function
ErrorHandler:
  HandleError True, "CompareSpatialReferences " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function ReturnTimeElapsedFromMilliseconds(lngMilliseconds As Long) As String
  On Error GoTo ErrorHandler

  
  Dim theElapsedTime As Double
  Dim theNumDays As Double
  Dim theNumHours As Double
  Dim theNumMinutes As Double
  Dim theNumSeconds As Double
  
4783:   theElapsedTime = lngMilliseconds / 1000
  
4785:   theNumDays = Int(theElapsedTime / 86400)
4786:   theNumHours = Int((theElapsedTime Mod 86400) / 3600)
4787:   theNumMinutes = Int((theElapsedTime Mod 3600) / 60)
4788:   theNumSeconds = theElapsedTime Mod 60
  
  Dim theDayString As String
  Dim theHourString As String
  Dim theMinString As String
  Dim theSecString As String
  
4795:   If theNumDays = 1 Then
4796:     theDayString = " day"
4797:   Else
4798:     theDayString = " days"
4799:   End If
  
4801:   If theNumHours = 1 Then
4802:     theHourString = " hour"
4803:   Else
4804:     theHourString = " hours"
4805:   End If
  
4807:   If theNumMinutes = 1 Then
4808:     theMinString = " minute"
4809:   Else
4810:     theMinString = " minutes"
4811:   End If
  
4813:   If theNumSeconds = 1 Then
4814:     theSecString = " second..."
4815:   Else
4816:     theSecString = " seconds..."
4817:   End If
  
  Dim theElapsedTimeString As String
4820:   theElapsedTimeString = ""
4821:   If theNumDays > 0 Then
4822:     theElapsedTimeString = theElapsedTimeString & theNumDays & theDayString & ", " & theNumHours & theHourString & ", " & _
    theNumMinutes & theMinString & ", " & theNumSeconds & theSecString
4824:   ElseIf theNumHours > 0 Then
4825:     theElapsedTimeString = theElapsedTimeString & theNumHours & theHourString & ", " & _
    theNumMinutes & theMinString & ", " & theNumSeconds & theSecString
4827:   ElseIf theNumMinutes > 0 Then
4828:     theElapsedTimeString = theElapsedTimeString & _
    theNumMinutes & theMinString & ", " & theNumSeconds & theSecString
4830:   Else
4831:     theElapsedTimeString = theElapsedTimeString & theNumSeconds & theSecString
4832:   End If
  
4834:   ReturnTimeElapsedFromMilliseconds = theElapsedTimeString


  Exit Function
ErrorHandler:
  HandleError True, "ReturnTimeElapsedFromMilliseconds " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function
Public Function ReturnTimeElapsed(theTimeBegan As Date, theTimeEnd As Date) As String
  On Error GoTo ErrorHandler

  
  Dim theElapsedTime As Double
  Dim theNumDays As Double
  Dim theNumHours As Double
  Dim theNumMinutes As Double
  Dim theNumSeconds As Double
  
4851:   theElapsedTime = DateDiff("s", theTimeBegan, theTimeEnd)
  
4853:   theNumDays = Int(theElapsedTime / 86400)
4854:   theNumHours = Int((theElapsedTime Mod 86400) / 3600)
4855:   theNumMinutes = Int((theElapsedTime Mod 3600) / 60)
4856:   theNumSeconds = theElapsedTime Mod 60
  
  Dim theDayString As String
  Dim theHourString As String
  Dim theMinString As String
  Dim theSecString As String
  
4863:   If theNumDays = 1 Then
4864:     theDayString = " day"
4865:   Else
4866:     theDayString = " days"
4867:   End If
  
4869:   If theNumHours = 1 Then
4870:     theHourString = " hour"
4871:   Else
4872:     theHourString = " hours"
4873:   End If
  
4875:   If theNumMinutes = 1 Then
4876:     theMinString = " minute"
4877:   Else
4878:     theMinString = " minutes"
4879:   End If
  
4881:   If theNumSeconds = 1 Then
4882:     theSecString = " second..."
4883:   Else
4884:     theSecString = " seconds..."
4885:   End If
  
  Dim theElapsedTimeString As String
4888:   theElapsedTimeString = "Time Elapsed: "
4889:   If theNumDays > 0 Then
4890:     theElapsedTimeString = theElapsedTimeString & theNumDays & theDayString & ", " & theNumHours & theHourString & ", " & _
    theNumMinutes & theMinString & ", " & theNumSeconds & theSecString
4892:   ElseIf theNumHours > 0 Then
4893:     theElapsedTimeString = theElapsedTimeString & theNumHours & theHourString & ", " & _
    theNumMinutes & theMinString & ", " & theNumSeconds & theSecString
4895:   ElseIf theNumMinutes > 0 Then
4896:     theElapsedTimeString = theElapsedTimeString & _
    theNumMinutes & theMinString & ", " & theNumSeconds & theSecString
4898:   Else
4899:     theElapsedTimeString = theElapsedTimeString & theNumSeconds & theSecString
4900:   End If
  
4902:   ReturnTimeElapsed = "Analysis Began: " & Format(theTimeBegan, "long date") & ";  " & Format(theTimeBegan, "long time") & vbCrLf & _
                      "Analysis Complete: " & Format(theTimeEnd, "long date") & ";  " & Format(theTimeEnd, "long time") & vbCrLf & _
                      theElapsedTimeString & vbCrLf & vbCrLf


  Exit Function
ErrorHandler:
  HandleError True, "ReturnTimeElapsed " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function


Public Function ReturnTimeElapsedRTF(theTimeBegan As Date, theTimeEnd As Date, lngFontSize As Long) As String
  On Error GoTo ErrorHandler


  Dim theElapsedTime As Double
  Dim theNumDays As Double
  Dim theNumHours As Double
  Dim theNumMinutes As Double
  Dim theNumSeconds As Double
  
4923:   theElapsedTime = CDbl(DateDiff("s", theTimeBegan, theTimeEnd))
'  MsgBox "theElapsedTime = " & CStr(theElapsedTime)
4925:   theNumDays = Int(CDbl(theElapsedTime / 86400#))
4926:   theNumHours = Int(CDbl(theElapsedTime Mod 86400#) / 3600#)
4927:   theNumMinutes = Int(CDbl(theElapsedTime Mod 3600#) / 60)
4928:   theNumSeconds = theElapsedTime Mod 60
  
  Dim theDayString As String
  Dim theHourString As String
  Dim theMinString As String
  Dim theSecString As String
  
4935:   If theNumDays = 1 Then
4936:     theDayString = " day"
4937:   Else
4938:     theDayString = " days"
4939:   End If
  
4941:   If theNumHours = 1 Then
4942:     theHourString = " hour"
4943:   Else
4944:     theHourString = " hours"
4945:   End If
  
4947:   If theNumMinutes = 1 Then
4948:     theMinString = " minute"
4949:   Else
4950:     theMinString = " minutes"
4951:   End If
  
4953:   If theNumSeconds = 1 Then
4954:     theSecString = " second..."
4955:   Else
4956:     theSecString = " seconds..."
4957:   End If
  
  Dim theElapsedTimeString As String
4960:   theElapsedTimeString = "Time Elapsed: "
4961:   If theNumDays > 0 Then
4962:     theElapsedTimeString = theElapsedTimeString & theNumDays & theDayString & ", " & theNumHours & theHourString & ", " & _
    theNumMinutes & theMinString & ", " & theNumSeconds & theSecString
4964:   ElseIf theNumHours > 0 Then
4965:     theElapsedTimeString = theElapsedTimeString & theNumHours & theHourString & ", " & _
    theNumMinutes & theMinString & ", " & theNumSeconds & theSecString
4967:   ElseIf theNumMinutes > 0 Then
4968:     theElapsedTimeString = theElapsedTimeString & _
    theNumMinutes & theMinString & ", " & theNumSeconds & theSecString
4970:   Else
4971:     theElapsedTimeString = theElapsedTimeString & theNumSeconds & theSecString
4972:   End If
  
4974:   ReturnTimeElapsedRTF = _
    "\b\fszzzFontSizezzz Analysis Began:\b0\i    zzzTimeBeganzzz\par" & vbCrLf & _
    "\b\i0 Analysis Complete:\b0\i    zzzTimeEndzzz\par" & vbCrLf & _
    "\b\i0 Time Elapsed:\b0\i    zzzTimeElapsedzzz\par" & vbCrLf
  
'  ReturnTimeElapsedRTF = "{\rtf1\ansi\ansicpg1252\deff0\deflang1033{\fonttbl{\f0\fswiss\fcharset0 Arial;}}" & vbCrLf & _
      "{\*\generator Msftedit 5.41.15.1507;}\viewkind4\uc1\pard\b\f0\fszzzFontSizezzz Analysis Began:\b0\i    zzzTimeBeganzzz\par" & vbCrLf & _
      "\b\i0 Analysis Complete:\b0\i    zzzTimeEndzzz\par" & vbCrLf & _
      "\b\i0 Time Elapsed:\b0\i    zzzTimeElapsedzzz\par" & vbCrLf & _
      "}"
  Dim strTimeBegan As String
4985:   strTimeBegan = CStr(Format(theTimeBegan, "long date")) & " at " & CStr(Format(theTimeBegan, "long time"))
  Dim strTimeEnd As String
4987:   strTimeEnd = CStr(Format(theTimeEnd, "long date")) & " at " & CStr(Format(theTimeEnd, "long time"))
  
4989:   ReturnTimeElapsedRTF = Replace(ReturnTimeElapsedRTF, "zzzFontSizezzz", CStr(lngFontSize * 2))
4990:   ReturnTimeElapsedRTF = Replace(ReturnTimeElapsedRTF, "zzzTimeBeganzzz", strTimeBegan)
4991:   ReturnTimeElapsedRTF = Replace(ReturnTimeElapsedRTF, "zzzTimeEndzzz", strTimeEnd)
4992:   ReturnTimeElapsedRTF = Replace(ReturnTimeElapsedRTF, "zzzTimeElapsedzzz", theElapsedTimeString)
  
'  ReturnTimeElapsedRTF = "Analysis Began: " & Format(theTimeBegan, "long date") & ";  " & Format(theTimeBegan, "long time") & vbCrLf & _
                      "Analysis Complete: " & Format(theTimeEnd, "long date") & ";  " & Format(theTimeEnd, "long time") & vbCrLf & _
                      theElapsedTimeString & vbCrLf & vbCrLf


  Exit Function
ErrorHandler:
  HandleError True, "ReturnTimeElapsedRTF " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Sub RemoveKeyFromCollection(colCollection As Collection, strKey As String)
  On Error GoTo ErrorHandler


  On Error Resume Next
  
5010:   colCollection.Remove strKey


  Exit Sub
ErrorHandler:
  HandleError True, "RemoveKeyFromCollection " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Public Function CheckCollectionForKey(colCollection As Collection, strKey As String) As Boolean
  On Error GoTo errHandler
  
5021:   CheckCollectionForKey = True
  Dim lngVarType As Long
5023:   lngVarType = VarType(colCollection.Item(strKey))
  
  Exit Function
errHandler:
5027:   CheckCollectionForKey = False

End Function

Public Sub EnableSelectTool(pApp As IApplication)
  On Error GoTo ErrorHandler


    Dim pUID As New UID
    Dim pCmdItem As ICommandItem
    ' Use the GUID of the Select Elements command
5038:     pUID.Value = "{C22579D1-BC17-11D0-8667-0000F8751720}"
5039:     Set pCmdItem = pApp.Document.CommandBars.Find(pUID)
5040:     pCmdItem.Execute


  Exit Sub
ErrorHandler:
  HandleError True, "EnableSelectTool " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Public Function CreateNestedFoldersByPath(ByVal completeDirectory As String) As Long
  On Error GoTo ErrorHandler


  'ADAPTED FROM http://vbnet.mvps.org/index.html?code/file/nested.htm
  'Visual Basic File Routines
  'CreateDirectory: Creating Nested Folders
  '
  'Posted:     Saturday September 19, 1998
  'Updated:    Wednesday December 05, 2007
  '
  'Applies to:     VB4-32, VB5, VB6
  'Developed with:     VB5, Windows 98
  'OS restrictions:    None
  'Author:     VBnet - Randy Birch

  'creates nested directories on the drive
  'included in the path by parsing the final
  'directory string into a directory array,
  'and looping through each to create the final path.
  
  'The path could be passed to this method as a
  'pre-filled array, reducing the code.
  
   Dim r As Long
   Dim SA As SECURITY_ATTRIBUTES
   Dim drivePart As String
   Dim newDirectory  As String
   Dim Item As String
   Dim sfolders() As String
   Dim pos As Long
   Dim X As Long
      
  'must have a trailing slash for
  'the GetPart routine below
5083:    If Right$(completeDirectory, 1) <> "\" Then
5084:       completeDirectory = completeDirectory & "\"
5085:    End If
  
  'if there is a drive in the string, get it
  'else, just use nothing - assumes current drive
5089:    pos = InStr(completeDirectory, ":")

5091:    If pos Then
5092:       drivePart = GetPart(completeDirectory, "\")
5093:    Else: drivePart = ""
5094:    End If

  'now get the rest of the items that
  'make up the string
5098:    Do Until completeDirectory = ""

    'strip off one item (i.e. "Files\")
5101:      Item = GetPart(completeDirectory, "\")

    'add it to an array for later use, and
    'if this is the first item (x=0),
    'append the drivepart
     ReDim Preserve sfolders(0 To X) As String

5108:      If X = 0 Then Item = drivePart & Item
5109:      sfolders(X) = Item
     
    'increment the array counter
5112:      X = X + 1

5114:    Loop

  'Now create the directories.
  'Because the first directory is
  '0 in the array, reinitialize x to -1
5119:    X = -1
   
5121:    Do
   
5123:       X = X + 1
     'just keep appending the folders in the
     'array to newDirectory.  When x=0 ,
     'newDirectory is "", so the
     'newDirectory gets assigned drive:\firstfolder.
     
     'Subsequent loops adds the next member of the
     'array to the path, forming a fully qualified
     'path to the new directory.
5132:       newDirectory = newDirectory & sfolders(X)
      
     'the only member of the SA type needed (on
     'a win95/98 system at least)
5136:       SA.nLength = LenB(SA)
      
5138:       Call CreateDirectory(newDirectory, SA)
       
5140:    Loop Until X = UBound(sfolders)
   
  'done. Return x, but add 1 for the 0-based array.
5143:    CreateNestedFoldersByPath = X + 1


  Exit Function
ErrorHandler:
  HandleError True, "CreateNestedFoldersByPath " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function GetPart(startStrg As String, delimiter As String) As String
  On Error GoTo ErrorHandler


'takes a string separated by "delimiter",
'splits off 1 item, and shortens the string
'so that the next item is ready for removal.

  Dim C As Integer
  Dim Item As String
  
5162:   C = 1
  
5164:   Do

5166:     If Mid$(startStrg, C, 1) = delimiter Then
      
5168:       Item = Mid$(startStrg, 1, C)
5169:       startStrg = Mid$(startStrg, C + 1, Len(startStrg))
5170:       GetPart = Item
      Exit Function
    
5173:     End If

5175:     C = C + 1

5177:   Loop


  Exit Function
ErrorHandler:
  HandleError True, "GetPart " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function ReturnTimeStamp() As String
  On Error GoTo ErrorHandler


5189:   ReturnTimeStamp = CStr(Format(Now, "yyyymmdd_HhNnSs"))


  Exit Function
ErrorHandler:
  HandleError True, "ReturnTimeStamp " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function


Private Function IsNaN(expression As Variant) As Boolean
  On Error GoTo ErrorHandler

  On Error Resume Next
5202:   If Not IsNumeric(expression) Then
5203:     IsNaN = False
    Exit Function
5205:   End If
5206:   If (CStr(expression) = "-1.#QNAN") Or (CStr(expression) = "1,#QNAN") Then ' can vary by locale
5207:     IsNaN = True
5208:   Else
5209:     IsNaN = False
5210:   End If

  Exit Function
ErrorHandler:
  HandleError False, "IsNaN " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function


Public Function MakeUniqueRasterName(pRasterType As JenDatasetTypes, strWSPath As String, strRasterName As String, _
      Optional booTrimForGRID As Boolean) As String
  On Error GoTo ErrorHandler
  
  ' ONLY RETURNS ACTUAL RASTER NAME
  
  Dim pWsFact As IWorkspaceFactory
  
  Dim pWorkspace As IWorkspace
  Dim pWorkspace2 As IWorkspace2
  Dim pWsEx As IRasterWorkspaceEx
  Dim pWS As IRasterWorkspace
  
  Dim lngIndex As Long
5232:   lngIndex = 1
  
  Dim strNewName As String
  Dim strBaseName As String
5236:   strNewName = strRasterName
5237:   strBaseName = strRasterName
  
  Dim strIndex As String
  
  Select Case pRasterType
    Case ENUM_FileGDB
5243:       Set pWsFact = New FileGDBWorkspaceFactory
5244:       Set pWsEx = pWsFact.OpenFromFile(strWSPath, 0)
5245:       Set pWorkspace2 = pWsEx
5246:       Do Until Not pWorkspace2.NameExists(esriDTRasterDataset, strNewName)
5247:         lngIndex = lngIndex + 1
5248:         strNewName = strBaseName & "_" & CStr(lngIndex)
5249:       Loop
5250:       MakeUniqueRasterName = strNewName
    Case ENUM_PersonalGDB
5252:       Set pWsFact = New AccessWorkspaceFactory
5253:       Set pWsEx = pWsFact.OpenFromFile(strWSPath, 0)
5254:       Set pWorkspace2 = pWsEx
5255:       Do Until Not pWorkspace2.NameExists(esriDTRasterDataset, strNewName)
5256:         lngIndex = lngIndex + 1
5257:         strNewName = strBaseName & "_" & CStr(lngIndex)
5258:       Loop
5259:       MakeUniqueRasterName = strNewName
    Case ENUM_File_Raster
      
5262:       If booTrimForGRID Then
        ' FOLLOW GRID RESTRICTIONS
5264:         strNewName = Left(ReplaceBadChars(strNewName, True, True, True, False), 13)
5265:         strBaseName = strNewName
5266:       End If
      
5268:       Set pWsFact = New RasterWorkspaceFactory
5269:       Set pWS = pWsFact.OpenFromFile(strWSPath, 0)
5270:       Set pWorkspace = pWS
      
      Dim pEnumDatasetName As IEnumDatasetName
5273:       Set pEnumDatasetName = pWorkspace.DatasetNames(esriDTRasterDataset)
      Dim pDatasetName As IDatasetName
      
      Dim booNameExists As Boolean
5277:       booNameExists = True
      
5279:       Do Until booNameExists = False
5280:         booNameExists = False
                    
5282:         pEnumDatasetName.Reset
5283:         Set pDatasetName = pEnumDatasetName.Next
        
5285:         Do Until pDatasetName Is Nothing
5286:           If pDatasetName.Name = strNewName Then
5287:             booNameExists = True
5288:             Set pDatasetName = Nothing
5289:           Else
5290:             Set pDatasetName = pEnumDatasetName.Next
5291:           End If
5292:         Loop
        
5294:         If booNameExists Then
5295:           lngIndex = lngIndex + 1
5296:           strIndex = "_" & CStr(lngIndex)
5297:           If booTrimForGRID Then
5298:             strNewName = Left(strBaseName, 13 - Len(strIndex)) & strIndex
5299:           Else
5300:             strNewName = strBaseName & strIndex
5301:           End If
5302:         End If
5303:       Loop
      
5305:       MakeUniqueRasterName = strNewName
5306:   End Select
      

  Exit Function
ErrorHandler:
  HandleError True, "MakeUniqueRasterName " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function CursorToSet_Features(pFCursor As IFeatureCursor) As esriSystem.ISet
  On Error GoTo ErrorHandler

  'http://forums.esri.com/Thread.asp?c=93&f=992&t=79743&mc=16.
  Dim pFeature As IFeature
5319:   Set CursorToSet_Features = New esriSystem.Set
5320:   Set pFeature = pFCursor.NextFeature
5321:   Do While Not pFeature Is Nothing
5322:     CursorToSet_Features.Add pFeature
5323:     Set pFeature = pFCursor.NextFeature
5324:   Loop
  
5326:   CursorToSet_Features.Reset
  
  Exit Function
ErrorHandler:
  HandleError True, "CursorToSet_Features " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function CursorToSet_TableRow(ByVal pCursor As ICursor) As esriSystem.ISet
  On Error GoTo ErrorHandler

' adapted from VB.NET
' http://forums.esri.com/Thread.asp?c=93&f=992&t=79743&mc=19

  Dim pSSet As esriSystem.ISet
  Dim pRow As IRow

  'populate the set with the cursor
5343:   Set pSSet = New esriSystem.Set
5344:   Set pRow = pCursor.NextRow
5345:   Do Until pRow Is Nothing
5346:     Do Until pRow Is Nothing
5347:       pSSet.Add pRow
5348:       Set pRow = pCursor.NextRow
5349:     Loop
5350:     pSSet.Reset
5351:   Loop

5353:   Set CursorToSet_TableRow = pSSet


  Exit Function
ErrorHandler:
  HandleError True, "CursorToSet_TableRow " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Sub MakeRandomNormalPolar(dblMean As Double, dblSD As Double, ByRef dblRand1 As Double, Optional ByRef dblRand2 As Double = -999)
  On Error GoTo ErrorHandler

'  Static dblSeed
' Based on Marsaglia's variation of the Box-Muller Transformation (http://en.wikipedia.org/wiki/Box-Muller_transform):
'        z1 = u * sqrt((-2 ln(s))/s)
'        z2 = v * sqrt((-2 ln(s))/s)
'      where:
'         s = u^2 + v^2, and is not equal to 0 or > 1
'        x1 = first uniform random number (between -1 and 1)
'        x2 = second uniform random number (between -1 and 1)
'        z1 = first normally distributed random number
'        z2 = second normally distributed random number.

' RANDOMIZE FIRST!
'  If dblSeed = 0 Then
'    Randomize            ' USE SYSTEM TIMER
'  Else
'    Randomize dblSeed
'  End If
  
  Dim dblX1 As Double
  Dim dblX2 As Double
  Dim S As Double
5385:   S = 5
5386:   Do Until S <= 1 And S <> 0
5387:     dblX1 = (Rnd * 2) - 1
5388:     dblX2 = (Rnd * 2) - 1
5389:     S = dblX2 ^ 2 + dblX1 ^ 2
5390:   Loop
  
5392:   dblRand1 = (dblX1 * Sqr(-2 * Log(S) / S) * dblSD#) + dblMean#
5393:   dblRand2 = (dblX2 * Sqr(-2 * Log(S) / S) * dblSD#) + dblMean#
  
'  dblSeed = dblRand2
  

  Exit Sub
ErrorHandler:
  HandleError True, "MakeRandomNormalPolar " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Public Function CreateInMemoryFeatureClass(pGeometryArray As esriSystem.IArray, _
    Optional pValueArray As esriSystem.IVariantArray, Optional pTemplateField As IField) As IFeatureClass
  On Error GoTo ErrorHandler

    ' create an inmemory featureclass
    ' ADAPTED FROM KIRK KUYKENDALL
    ' http://forums.esri.com/Thread.asp?c=93&f=993&t=210767
    
    ' ASSUMES ONE OR MORE GEOMETRIES, ALL OF WHICH ARE IN THE SAME PROJECTION
    Dim pGeom As IGeometry
5413:     Set pGeom = pGeometryArray.Element(0)
    
    Dim pWSF As IWorkspaceFactory
5416:     Set pWSF = New InMemoryWorkspaceFactory
    
    Dim pName As IName
5419:     Set pName = pWSF.Create("", "inmemory", Nothing, 0)
    Dim pFWS As IFeatureWorkspace
5421:     Set pFWS = pName.Open
    
    Dim pFlds As IFields
        
    Dim pFields As IFields
    Dim pFieldsEdit As IFieldsEdit
    Dim pField As IField
    Dim pFieldEdit As IFieldEdit
   
5430:     Set pFields = New Fields
5431:     Set pFieldsEdit = pFields
      
    '' create the geometry field
    
    Dim pGeomDef As IGeometryDef
    Dim pGeomDefEdit As IGeometryDefEdit
5437:     Set pGeomDef = New GeometryDef
5438:     Set pGeomDefEdit = pGeomDef
    
    '' assign the geometry definiton properties.
5441:     With pGeomDefEdit
5442:       .GeometryType = pGeom.GeometryType
5443:       .GridCount = 1
5444:       .GridSize(0) = 10
5445:       .AvgNumPoints = 2
5446:       .HasM = False
5447:       .HasZ = False
5448:       Set .SpatialReference = pGeom.SpatialReference
5449:     End With
    
5451:     Set pField = New Field
5452:     Set pFieldEdit = pField
    
5454:     pFieldEdit.Name = "Shape"
5455:     pFieldEdit.AliasName = "geometry"
5456:     pFieldEdit.Type = esriFieldTypeGeometry
5457:     Set pFieldEdit.GeometryDef = pGeomDef
5458:     pFieldsEdit.AddField pField
    
    Dim pClone As IClone
    Dim booAddAttribute As Boolean
5462:     booAddAttribute = Not pValueArray Is Nothing And Not pTemplateField Is Nothing
    Dim varVal As Variant
    
5465:     If booAddAttribute Then
5466:       Set pClone = pTemplateField
5467:       Set pField = pClone.Clone
5468:       pFieldsEdit.AddField pField
5469:     Else
5470:       Set pField = New Field
5471:       Set pFieldEdit = pField
5472:       With pFieldEdit
5473:         .Name = "Unique_ID"
5474:         .Type = esriFieldTypeInteger
5475:       End With
5476:       pFieldsEdit.AddField pField
5477:     End If
    
    Dim pCLSID As UID
5480:     Set pCLSID = New UID
5481:     pCLSID.Value = "esriGeoDatabase.Feature"
  
    Dim pInMemFC As IFeatureClass
5484:     Set pInMemFC = pFWS.CreateFeatureClass("In_Memory", pFields, _
                             pCLSID, Nothing, esriFTSimple, _
                             "Shape", "")
    
    Dim lngIDIndex As Long
    
    Dim lngAttIndex As Long
5491:     If booAddAttribute Then
5492:       lngAttIndex = pInMemFC.FindField(pTemplateField.Name)
5493:     Else
5494:       lngIDIndex = pInMemFC.FindField("Unique_ID")
5495:     End If
    
    Dim lngIndex As Long
    Dim pOutFeat As IFeature
5499:     For lngIndex = 0 To pGeometryArray.Count - 1
5500:       Set pClone = pGeometryArray.Element(lngIndex)
5501:       Set pGeom = pClone.Clone
5502:       Set pOutFeat = pInMemFC.CreateFeature
5503:       Set pOutFeat.Shape = pGeom
5504:       If booAddAttribute Then
5505:         varVal = pValueArray.Element(lngIndex)
5506:         pOutFeat.Value(lngAttIndex) = varVal
5507:       Else
5508:         pOutFeat.Value(lngIDIndex) = lngIndex + 1
5509:       End If
5510:       pOutFeat.Store
5511:     Next lngIndex
    
5513:     Set CreateInMemoryFeatureClass = pInMemFC
      
5515:     Set pGeom = Nothing
5516:     Set pWSF = Nothing
5517:     Set pName = Nothing
5518:     Set pFWS = Nothing
5519:     Set pFlds = Nothing
5520:     Set pFields = Nothing
5521:     Set pFieldsEdit = Nothing
5522:     Set pField = Nothing
5523:     Set pFieldEdit = Nothing
5524:     Set pGeomDef = Nothing
5525:     Set pGeomDefEdit = Nothing
5526:     Set pCLSID = Nothing
5527:     Set pInMemFC = Nothing
5528:     Set pOutFeat = Nothing
5529:     Set pClone = Nothing
    
  Exit Function
ErrorHandler:
  HandleError True, "CreateInMemoryFeatureClass " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function ReturnTempRasterWorkspace() As IWorkspace
    ' ADAPTED FROM ESRI SAMPLE http://edndoc.esri.com/arcobjects/9.2/CPP_VB6_VBA_VCPP_Doc/COM_Samples_Docs/SpatialAnalyst/ImageUpdate/Visual_Basic/ImageUpdate.frm.htm
    ' Given a pathname, returns the raster workspace object for that path
    On Error GoTo erh
    
    ' Create a Rasterworkspace
    Dim sPath As String
5543:     sPath = Environ("TEMP") ' Get temp directory
    
    Dim pWSF As IWorkspaceFactory
5546:     Set pWSF = New RasterWorkspaceFactory
    Dim pWS As IWorkspace
5548:     Set pWS = pWSF.OpenFromFile(sPath, 0)
5549:     Set ReturnTempRasterWorkspace = pWS
    Exit Function
erh:
5552:     Set ReturnTempRasterWorkspace = Nothing
End Function
Public Function MakeUniqueRasterName2(pWS As IWorkspace, strBaseName As String, booRestrictTo13CharForGrid As Boolean) As String
  On Error GoTo ErrorHandler
  
 ' Dim pWS2 As IWorkspace2
 ' Set pWS2 = pWS

'  MsgBox "Checking " & strBaseName & "..."
  Dim pNames As IEnumDatasetName
5562:   Set pNames = pWS.DatasetNames(esriDTAny)
  Dim pDatasetName As IDatasetName

  Dim booNameExists As Boolean
5566:   booNameExists = True

  Dim lngCounter As Long
5569:   lngCounter = 1
  Dim strCounter As String
  Dim strUniqueName As String
5572:   strUniqueName = strBaseName

5574:   Do Until booNameExists = False
5575:     booNameExists = False
5576:     pNames.Reset
5577:     Set pDatasetName = pNames.Next
5578:     Do Until pDatasetName Is Nothing
'      MsgBox "Comparing " & strBaseName & " with " & pDatasetName.Name
5580:       If StrComp(pDatasetName.Name, strUniqueName, vbTextCompare) = 0 Then
5581:         booNameExists = True
5582:         Exit Do
5583:       End If
5584:       Set pDatasetName = pNames.Next
5585:     Loop
'    MsgBox "booNameExists = " & CStr(booNameExists)
5587:     If booNameExists = True Then 'Or pWS2.NameExists(esriDTRasterDataset, strUniqueName) Then
    '  booNameExists = True
5589:       lngCounter = lngCounter + 1
5590:       strCounter = CStr(lngCounter)
5591:       If booRestrictTo13CharForGrid Then
5592:         strUniqueName = Left(strBaseName, 12 - Len(strCounter)) & "_" & strCounter
5593:       Else
5594:         strUniqueName = strBaseName & "_" & strCounter
5595:       End If
5596:     End If
5597:   Loop
5598:   MakeUniqueRasterName2 = strUniqueName

'  MsgBox "Settled on " & MakeUniqueRasterName2 & "..."

  Exit Function
ErrorHandler:
  HandleError True, "MakeUniqueRasterName2 " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function


Public Sub SetRasterSymbols(pRasterLayer As ILayer, lyrFileName As String)
  On Error GoTo ErrorHandler

  
' ADAPTED FROM Kirk Kuykendall AND Geoffrey Poole
' http://forums.esri.com/Thread.asp?c=93&f=992&t=59083

  Dim pGxFile As IGxFile
5616:   Set pGxFile = New GxLayer
5617:   pGxFile.Path = lyrFileName
  
  Dim pGxLayer As IGxLayer
5620:   Set pGxLayer = pGxFile
  
  Dim pGRLayer As IRasterLayer
5623:   Set pGRLayer = pGxLayer.Layer
  
  ' SET TRANSPARENCY
  Dim pLayerEffects As ILayerEffects
  Dim lngTransp As Double
5628:   Set pLayerEffects = pGRLayer
5629:   lngTransp = pLayerEffects.Transparency
  
  Dim pRenderer As IRasterRenderer
5632:   Set pRenderer = pGRLayer.Renderer
  
5634:   Set pGRLayer = pRasterLayer
5635:   Set pGRLayer.Renderer = pRenderer
  
5637:   Set pLayerEffects = pRasterLayer
5638:   pLayerEffects.Transparency = lngTransp
  
'    Dim pMxDoc As IMxDocument
'    Set pMxDoc = ThisDocument
'    pMxDoc.ActiveView.Refresh
'    pMxDoc.CurrentContentsView.Refresh pGRLayer
'    pMxDoc.UpdateContents


5647:   Set pGxFile = Nothing
5648:   Set pGxLayer = Nothing
5649:   Set pGRLayer = Nothing
5650:   Set pLayerEffects = Nothing
5651:   Set pRenderer = Nothing



  Exit Sub
ErrorHandler:
  HandleError True, "SetRasterSymbols " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
Public Function GeneralExistFileDir(sTest As String) As Boolean
  On Error GoTo ErrorHandler


'Checks for the existance of a File or Directory
  Dim af As Long
5665:   af = -1
  On Error Resume Next
5667:   af = GetAttr(sTest)
5668:   GeneralExistFileDir = (af <> -1)

  Exit Function
ErrorHandler:
  HandleError True, "GeneralExistFileDir " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function
Public Function ReturnQueryStringPrefixSuffix(pDataset As IDataset, strPrefix As String, strSuffix As String) As Boolean
  On Error GoTo ErrorHandler

  
  '  EXAMPLE:
  '  Dim booSucceed As Boolean
  '  booSucceed = ReturnQueryStringPrefixSuffix(pPersonalFClass, strPrefix, strSuffix)
  '  Debug.Print "booSucceed = " & CStr(booSucceed) & vbCrLf & _
  '              "strPrefix = " & strPrefix & vbCrLf & _
  '              "strSuffix = " & strSuffix
  
5685:   ReturnQueryStringPrefixSuffix = False
  Dim pWS As IWorkspace
  Dim pSQLSyntax As ISQLSyntax
  
5689:   Set pWS = pDataset.Workspace
5690:   Set pSQLSyntax = pWS
5691:   strPrefix = pSQLSyntax.GetSpecialCharacter(esriSQL_DelimitedIdentifierPrefix)
5692:   strSuffix = pSQLSyntax.GetSpecialCharacter(esriSQL_DelimitedIdentifierSuffix)
5693:   ReturnQueryStringPrefixSuffix = True
  

  Exit Function
ErrorHandler:
  HandleError True, "ReturnQueryStringPrefixSuffix " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function



Public Function WriteTextFile(strFileName As String, strText As String, Optional booForceOverwrite As Boolean = False) As Boolean
  On Error GoTo ErrorHandler

  
  Dim lngFileNumber As Long
  
5709:   If Dir(strFileName) = "" Or booForceOverwrite Then
5710:     lngFileNumber = FreeFile(0)
    
5712:     Open strFileName For Output As #lngFileNumber

5714:     Print #lngFileNumber, strText
5715:     Close #lngFileNumber
5716:     WriteTextFile = True
5717:   Else
    ' CONFIRM WHETHER TO OVERWRITE FILE
    Dim lngVBResult As VbMsgBoxResult
    
5721:     lngVBResult = MsgBox("File Already Exists!" & vbCrLf & vbCrLf & "  --> " & strFileName & vbCrLf & vbCrLf & _
        "Click 'OK' to overwrite the file, or 'CANCEL' to quit...", vbOKCancel, "File Exists:")
5723:     If lngVBResult = vbOK Then
5724:       Kill strFileName
5725:       If Dir(strFileName) <> "" Then
5726:         MsgBox "Unable to delete " & strFileName & vbCrLf & vbCrLf & _
          "It may be open in another application.  Please delete this file manually or save the text to a new filename.", , "Unable to Delete File:"
5728:         WriteTextFile = False
5729:       Else
      
5731:         lngFileNumber = FreeFile(0)
        
5733:         Open strFileName For Output As #lngFileNumber
    
5735:         Print #lngFileNumber, strText
5736:         Close #lngFileNumber
5737:         WriteTextFile = True
5738:       End If
5739:     Else
5740:       WriteTextFile = False
5741:     End If
5742:   End If


  Exit Function
ErrorHandler:
  HandleError True, "WriteTextFile " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

